/*-------------------------------------------------------------------------
 *
 * execdefs.h
 *
 *
 *
 * Portions Copyright (c) 1996-2006, PostgreSQL Global Development Group
 * Portions Copyright (c) 1994, Regents of the University of California
 *
 * $PostgreSQL: pgsql/src/include/executor/execdefs.h,v 1.19 2006/03/05 15:58:56 momjian Exp $
 *
 *-------------------------------------------------------------------------
 */
#ifndef EXECDEFS_H
#define EXECDEFS_H

/* ----------------
 *		Merge Join states
 * ----------------
 */
#define EXEC_MJ_INITIALIZE_OUTER		1
#define EXEC_MJ_INITIALIZE_INNER		2
#define EXEC_MJ_JOINTUPLES				3
#define EXEC_MJ_NEXTOUTER				4
#define EXEC_MJ_TESTOUTER				5
#define EXEC_MJ_NEXTINNER				6
#define EXEC_MJ_SKIP_TEST				7
#define EXEC_MJ_SKIPOUTER_ADVANCE		8
#define EXEC_MJ_SKIPINNER_ADVANCE		9
#define EXEC_MJ_ENDOUTER				10
#define EXEC_MJ_ENDINNER				11

/* ----------------
 * 		MD-Similarity Join states
 * Added by S Pearson
 * ----------------
 */
//Init states
#define EXEC_DBSIMJOIN_INIT								21
#define EXEC_DBSIMJOIN_NEXT_OUTER						22
#define	 EXEC_DBSIMJOIN_NEXT_INNER						23
//Process externally
#define EXEC_DBSIMJOIN_EXTERN_PROCESS_PARTITIONS			24
#define EXEC_DBSIMJOIN_EXTERN_PROCESS_WINDOWS			25
#define EXEC_DBSIMJOIN_EXTERN_PROCESS_WINDOW_PARTITIONS	26
#define EXEC_DBSIMJOIN_EXTERN_ITERATE_WINDOW_PARTITIONS	27
#define EXEC_DBSIMJOIN_EXTERN_PROCESS_WINDOW_WINDOWS		28
#define EXEC_DBSIMJOIN_EXTERN_ITERATE_WINDOW_WINDOWS		29
#define EXEC_DBSIMJOIN_EXTERN_ITERATE_PARTITIONS			30
//Process internally
#define EXEC_DBSIMJOIN_INTERN_PROCESS_PARTITIONS			31
#define EXEC_DBSIMJOIN_INTERN_PROCESS_WINDOWS			32
#define EXEC_DBSIMJOIN_INTERN_PROCESS_WINDOW_PARTITIONS	33
#define EXEC_DBSIMJOIN_INTERN_ITERATE_WINDOW_PARTITIONS	34
#define EXEC_DBSIMJOIN_INTERN_PROCESS_WINDOW_WINDOWS		35
#define EXEC_DBSIMJOIN_INTERN_ITERATE_WINDOW_WINDOWS		36
#define EXEC_DBSIMJOIN_INTERN_ITERATE_PARTITIONS			37
//Nested join
#define EXEC_DBSIMJOIN_INIT_SMALL_INPUT_NESTLOOP			38
#define EXEC_DBSIMJOIN_INIT_NESTLOOP						39
#define EXEC_DBSIMJOIN_ITER_NESTLOOP						40
#define EXEC_DBSIMJOIN_NESTLOOP							41
#define EXEC_DBSIMJOIN_INIT_WINLOOP						42
#define EXEC_DBSIMJOIN_ITER_WINLOOP						43
#define EXEC_DBSIMJOIN_NESTWINLOOP						44
#define EXEC_DBSIMJOIN_FINISH_SMALL_INPUT				45

#endif   /* EXECDEFS_H */
