
/* A Bison parser, made by GNU Bison 2.4.1.  */

/* Skeleton implementation for Bison's Yacc-like parsers in C
   
      Copyright (C) 1984, 1989, 1990, 2000, 2001, 2002, 2003, 2004, 2005, 2006
   Free Software Foundation, Inc.
   
   This program is free software: you can redistribute it and/or modify
   it under the terms of the GNU General Public License as published by
   the Free Software Foundation, either version 3 of the License, or
   (at your option) any later version.
   
   This program is distributed in the hope that it will be useful,
   but WITHOUT ANY WARRANTY; without even the implied warranty of
   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
   GNU General Public License for more details.
   
   You should have received a copy of the GNU General Public License
   along with this program.  If not, see <http://www.gnu.org/licenses/>.  */

/* As a special exception, you may create a larger work that contains
   part or all of the Bison parser skeleton and distribute that work
   under terms of your choice, so long as that work isn't itself a
   parser generator using the skeleton or a modified version thereof
   as a parser skeleton.  Alternatively, if you modify or redistribute
   the parser skeleton itself, you may (at your option) remove this
   special exception, which will cause the skeleton and the resulting
   Bison output files to be licensed under the GNU General Public
   License without this special exception.
   
   This special exception was added by the Free Software Foundation in
   version 2.2 of Bison.  */

/* C LALR(1) parser skeleton written by Richard Stallman, by
   simplifying the original so-called "semantic" parser.  */

/* All symbols defined below should begin with yy or YY, to avoid
   infringing on user name space.  This should be done even for local
   variables, as they might otherwise be expanded by user macros.
   There are some unavoidable exceptions within include files to
   define necessary library symbols; they are noted "INFRINGES ON
   USER NAME SPACE" below.  */

/* Identify Bison output.  */
#define YYBISON 1

/* Bison version.  */
#define YYBISON_VERSION "2.4.1"

/* Skeleton name.  */
#define YYSKELETON_NAME "yacc.c"

/* Pure parsers.  */
#define YYPURE 0

/* Push parsers.  */
#define YYPUSH 0

/* Pull parsers.  */
#define YYPULL 1

/* Using locations.  */
#define YYLSP_NEEDED 1

/* Substitute the variable and function names.  */
#define yyparse         base_yyparse
#define yylex           base_yylex
#define yyerror         base_yyerror
#define yylval          base_yylval
#define yychar          base_yychar
#define yydebug         base_yydebug
#define yynerrs         base_yynerrs
#define yylloc          base_yylloc

/* Copy the first part of user declarations.  */

/* Line 189 of yacc.c  */
#line 1 "gram.y"


/*#define YYDEBUG 1*/
/*-------------------------------------------------------------------------
 *
 * gram.y
 *	  POSTGRES SQL YACC rules/actions
 *
 * Portions Copyright (c) 1996-2006, PostgreSQL Global Development Group
 * Portions Copyright (c) 1994, Regents of the University of California
 *
 *
 * IDENTIFICATION
 *	  $PostgreSQL: pgsql/src/backend/parser/gram.y,v 2.568 2006/11/05 22:42:09 tgl Exp $
 *
 * HISTORY
 *	  AUTHOR			DATE			MAJOR EVENT
 *	  Andrew Yu			Sept, 1994		POSTQUEL to SQL conversion
 *	  Andrew Yu			Oct, 1994		lispy code conversion
 *
 * NOTES
 *	  CAPITALS are used to represent terminal symbols.
 *	  non-capitals are used to represent non-terminals.
 *	  SQL92-specific syntax is separated from plain SQL/Postgres syntax
 *	  to help isolate the non-extensible portions of the parser.
 *
 *	  In general, nothing in this file should initiate database accesses
 *	  nor depend on changeable state (such as SET variables).  If you do
 *	  database accesses, your code will fail when we have aborted the
 *	  current transaction and are just parsing commands to find the next
 *	  ROLLBACK or COMMIT.  If you make use of SET variables, then you
 *	  will do the wrong thing in multi-query strings like this:
 *			SET SQL_inheritance TO off; SELECT * FROM foo;
 *	  because the entire string is parsed by gram.y before the SET gets
 *	  executed.  Anything that depends on the database or changeable state
 *	  should be handled inside parse_analyze() so that it happens at the
 *	  right time not the wrong time.  The handling of SQL_inheritance is
 *	  a good example.
 *
 * WARNINGS 
 *	  If you use a list, make sure the datum is a node so that the printing
 *	  routines work.
 *
 *	  Sometimes we assign constants to makeStrings. Make sure we don't free
 *	  those.
 *
 *-------------------------------------------------------------------------
 */
#include "postgres.h"

#include <ctype.h>
#include <limits.h>

#include "catalog/index.h"
#include "catalog/namespace.h"
#include "commands/defrem.h"
#include "nodes/makefuncs.h"
#include "parser/gramparse.h"
#include "storage/lmgr.h"
#include "utils/date.h"
#include "utils/datetime.h"
#include "utils/numeric.h"


/* Location tracking support --- simpler than bison's default */
#define YYLLOC_DEFAULT(Current, Rhs, N) \
	do { \
		if (N) \
			(Current) = (Rhs)[1]; \
		else \
			(Current) = (Rhs)[0]; \
	} while (0)

/*
 * The %name-prefix option below will make bison call base_yylex, but we
 * really want it to call filtered_base_yylex (see parser.c).
 */
#define base_yylex filtered_base_yylex

extern List *parsetree;			/* final parse result is delivered here */

static bool QueryIsRule = FALSE;

/*
 * If you need access to certain yacc-generated variables and find that
 * they're static by default, uncomment the next line.  (this is not a
 * problem, yet.)
 */
/*#define __YYSCLASS*/

static Node *makeColumnRef(char *relname, List *indirection, int location);
static Node *makeTypeCast(Node *arg, TypeName *typename);
static Node *makeStringConst(char *str, TypeName *typename);
static Node *makeIntConst(int val);
static Node *makeFloatConst(char *str);
static Node *makeAConst(Value *v);
static A_Const *makeBoolAConst(bool state);
static FuncCall *makeOverlaps(List *largs, List *rargs, int location);
static void check_qualified_name(List *names);
static List *check_func_name(List *names);
static List *extractArgTypes(List *parameters);
static SelectStmt *findLeftmostSelect(SelectStmt *node);
static void insertSelectOptions(SelectStmt *stmt,
								List *sortClause, List *lockingClause,
								Node *limitOffset, Node *limitCount);
static Node *makeSetOp(SetOperation op, bool all, Node *larg, Node *rarg);
static Node *doNegate(Node *n, int location);
static void doNegateFloat(Value *v);



/* Line 189 of yacc.c  */
#line 193 "gram.tab.c"

/* Enabling traces.  */
#ifndef YYDEBUG
# define YYDEBUG 0
#endif

/* Enabling verbose error messages.  */
#ifdef YYERROR_VERBOSE
# undef YYERROR_VERBOSE
# define YYERROR_VERBOSE 1
#else
# define YYERROR_VERBOSE 0
#endif

/* Enabling the token table.  */
#ifndef YYTOKEN_TABLE
# define YYTOKEN_TABLE 0
#endif


/* Tokens.  */
#ifndef YYTOKENTYPE
# define YYTOKENTYPE
   /* Put the tokens into the symbol table, so that GDB and other debuggers
      know about them.  */
   enum yytokentype {
     ABORT_P = 258,
     ABSOLUTE_P = 259,
     ACCESS = 260,
     ACTION = 261,
     ADD_P = 262,
     ADMIN = 263,
     AFTER = 264,
     AGGREGATE = 265,
     ALL = 266,
     ALSO = 267,
     ALTER = 268,
     ANALYSE = 269,
     ANALYZE = 270,
     AND = 271,
     ANY = 272,
     AROUND = 273,
     ARRAY = 274,
     AS = 275,
     ASC = 276,
     ASSERTION = 277,
     ASSIGNMENT = 278,
     ASYMMETRIC = 279,
     AT = 280,
     AUTHORIZATION = 281,
     BACKWARD = 282,
     BEFORE = 283,
     BEGIN_P = 284,
     BETWEEN = 285,
     BIGINT = 286,
     BINARY = 287,
     BIT = 288,
     BOOLEAN_P = 289,
     BOTH = 290,
     BY = 291,
     CACHE = 292,
     CALLED = 293,
     CASCADE = 294,
     CASCADED = 295,
     CASE = 296,
     CAST = 297,
     CHAIN = 298,
     CHAR_P = 299,
     CHARACTER = 300,
     CHARACTERISTICS = 301,
     CHECK = 302,
     CHECKPOINT = 303,
     CLASS = 304,
     CLOSE = 305,
     CLUSTER = 306,
     COALESCE = 307,
     COLLATE = 308,
     COLUMN = 309,
     COMMENT = 310,
     COMMIT = 311,
     COMMITTED = 312,
     CONCURRENTLY = 313,
     CONNECTION = 314,
     CONSTRAINT = 315,
     CONSTRAINTS = 316,
     CONVERSION_P = 317,
     CONVERT = 318,
     COPY = 319,
     CREATE = 320,
     CREATEDB = 321,
     CREATEROLE = 322,
     CREATEUSER = 323,
     CROSS = 324,
     CSV = 325,
     CURRENT_DATE = 326,
     CURRENT_ROLE = 327,
     CURRENT_TIME = 328,
     CURRENT_TIMESTAMP = 329,
     CURRENT_USER = 330,
     CURSOR = 331,
     CYCLE = 332,
     DATABASE = 333,
     DAY_P = 334,
     DEALLOCATE = 335,
     DEC = 336,
     DECIMAL_P = 337,
     DECLARE = 338,
     DEFAULT = 339,
     DEFAULTS = 340,
     DEFERRABLE = 341,
     DEFERRED = 342,
     DEFINER = 343,
     DELETE_P = 344,
     DELIMITER = 345,
     DELIMITERS = 346,
     DESC = 347,
     DISABLE_P = 348,
     DISTINCT = 349,
     DO = 350,
     DOMAIN_P = 351,
     DOUBLE_P = 352,
     DROP = 353,
     EACH = 354,
     ELSE = 355,
     ENABLE_P = 356,
     ENCODING = 357,
     ENCRYPTED = 358,
     END_P = 359,
     ESCAPE = 360,
     EXCEPT = 361,
     EXCLUDING = 362,
     EXCLUSIVE = 363,
     EXECUTE = 364,
     EXISTS = 365,
     EXPLAIN = 366,
     EXTERNAL = 367,
     EXTRACT = 368,
     FALSE_P = 369,
     FETCH = 370,
     FIRST_P = 371,
     FLOAT_P = 372,
     FOR = 373,
     FORCE = 374,
     FOREIGN = 375,
     FORWARD = 376,
     FREEZE = 377,
     FROM = 378,
     FULL = 379,
     FUNCTION = 380,
     GLOBAL = 381,
     GRANT = 382,
     GRANTED = 383,
     GREATEST = 384,
     GROUP_P = 385,
     HANDLER = 386,
     HAVING = 387,
     HEADER_P = 388,
     HOLD = 389,
     HOUR_P = 390,
     IF_P = 391,
     ILIKE = 392,
     IMMEDIATE = 393,
     IMMUTABLE = 394,
     IMPLICIT_P = 395,
     IN_P = 396,
     INCLUDING = 397,
     INCREMENT = 398,
     INDEX = 399,
     INDEXES = 400,
     INHERIT = 401,
     INHERITS = 402,
     INITIALLY = 403,
     INNER_P = 404,
     INOUT = 405,
     INPUT_P = 406,
     INSENSITIVE = 407,
     INSERT = 408,
     INSTEAD = 409,
     INT_P = 410,
     INTEGER = 411,
     INTERSECT = 412,
     INTERVAL = 413,
     INTO = 414,
     INVOKER = 415,
     IS = 416,
     ISNULL = 417,
     ISOLATION = 418,
     JOIN = 419,
     KEY = 420,
     LANCOMPILER = 421,
     LANGUAGE = 422,
     LARGE_P = 423,
     LAST_P = 424,
     LEADING = 425,
     LEAST = 426,
     LEFT = 427,
     LEVEL = 428,
     LIKE = 429,
     LIMIT = 430,
     LISTEN = 431,
     LOAD = 432,
     LOCAL = 433,
     LOCALTIME = 434,
     LOCALTIMESTAMP = 435,
     LOCATION = 436,
     LOCK_P = 437,
     LOGIN_P = 438,
     MATCH = 439,
     MAXVALUE = 440,
     MINUTE_P = 441,
     MINVALUE = 442,
     MODE = 443,
     MONTH_P = 444,
     MOVE = 445,
     MAXELEMSEP = 446,
     MAXGROUPDIAM = 447,
     MAXJOINDIAM = 448,
     NAMES = 449,
     NATIONAL = 450,
     NATURAL = 451,
     NCHAR = 452,
     NEW = 453,
     NEXT = 454,
     NO = 455,
     NOCREATEDB = 456,
     NOCREATEROLE = 457,
     NOCREATEUSER = 458,
     NOINHERIT = 459,
     NOLOGIN_P = 460,
     NONE = 461,
     NOSUPERUSER = 462,
     NOT = 463,
     NOTHING = 464,
     NOTIFY = 465,
     NOTNULL = 466,
     NOWAIT = 467,
     NULL_P = 468,
     NULLIF = 469,
     NUMERIC = 470,
     OBJECT_P = 471,
     OF = 472,
     OFF = 473,
     OFFSET = 474,
     OIDS = 475,
     OLD = 476,
     ON = 477,
     ONLY = 478,
     OPERATOR = 479,
     OPTION = 480,
     OR = 481,
     ORDER = 482,
     OUT_P = 483,
     OUTER_P = 484,
     OVERLAPS = 485,
     OVERLAY = 486,
     OWNED = 487,
     OWNER = 488,
     PARTIAL = 489,
     PASSWORD = 490,
     PLACING = 491,
     POSITION = 492,
     PRECISION = 493,
     PRESERVE = 494,
     PREPARE = 495,
     PREPARED = 496,
     PRIMARY = 497,
     PRIOR = 498,
     PRIVILEGES = 499,
     PROCEDURAL = 500,
     PROCEDURE = 501,
     QUOTE = 502,
     READ = 503,
     REAL = 504,
     REASSIGN = 505,
     RECHECK = 506,
     REFERENCES = 507,
     REINDEX = 508,
     RELATIVE_P = 509,
     RELEASE = 510,
     RENAME = 511,
     REPEATABLE = 512,
     REPLACE = 513,
     RESET = 514,
     RESTART = 515,
     RESTRICT = 516,
     RETURNING = 517,
     RETURNS = 518,
     REVOKE = 519,
     RIGHT = 520,
     ROLE = 521,
     ROLLBACK = 522,
     ROW = 523,
     ROWS = 524,
     RULE = 525,
     SAVEPOINT = 526,
     SCHEMA = 527,
     SCROLL = 528,
     SECOND_P = 529,
     SECURITY = 530,
     SELECT = 531,
     SEQUENCE = 532,
     SERIALIZABLE = 533,
     SESSION = 534,
     SESSION_USER = 535,
     SET = 536,
     SETOF = 537,
     SHARE = 538,
     SHOW = 539,
     SIMILAR = 540,
     SIMPLE = 541,
     SMALLINT = 542,
     SOME = 543,
     STABLE = 544,
     START = 545,
     STATEMENT = 546,
     STATISTICS = 547,
     STDIN = 548,
     STDOUT = 549,
     STORAGE = 550,
     STRICT_P = 551,
     SUBSTRING = 552,
     SUPERUSER_P = 553,
     SYMMETRIC = 554,
     SYSID = 555,
     SYSTEM_P = 556,
     TABLE = 557,
     TABLESPACE = 558,
     TEMP = 559,
     TEMPLATE = 560,
     TEMPORARY = 561,
     THEN = 562,
     TIME = 563,
     TIMESTAMP = 564,
     TO = 565,
     TRAILING = 566,
     TRANSACTION = 567,
     TREAT = 568,
     TRIGGER = 569,
     TRIM = 570,
     TRUE_P = 571,
     TRUNCATE = 572,
     TRUSTED = 573,
     TYPE_P = 574,
     UNCOMMITTED = 575,
     UNENCRYPTED = 576,
     UNION = 577,
     UNIQUE = 578,
     UNKNOWN = 579,
     UNLISTEN = 580,
     UNTIL = 581,
     UPDATE = 582,
     USER = 583,
     USING = 584,
     VACUUM = 585,
     VALID = 586,
     VALIDATOR = 587,
     VALUES = 588,
     VARCHAR = 589,
     VARYING = 590,
     VERBOSE = 591,
     VIEW = 592,
     VOLATILE = 593,
     WHEN = 594,
     WHERE = 595,
     WITH = 596,
     WITHIN = 597,
     WITHOUT = 598,
     WORK = 599,
     WRITE = 600,
     YEAR_P = 601,
     ZONE = 602,
     WITH_CASCADED = 603,
     WITH_LOCAL = 604,
     WITH_CHECK = 605,
     IDENT = 606,
     FCONST = 607,
     SCONST = 608,
     BCONST = 609,
     XCONST = 610,
     Op = 611,
     ICONST = 612,
     PARAM = 613,
     POSTFIXOP = 614,
     UMINUS = 615,
     TYPECAST = 616
   };
#endif



#if ! defined YYSTYPE && ! defined YYSTYPE_IS_DECLARED
typedef union YYSTYPE
{

/* Line 214 of yacc.c  */
#line 116 "gram.y"

	int					ival;
	char				chr;
	char				*str;
	const char			*keyword;
	bool				boolean;
	JoinType			jtype;
	DropBehavior		dbehavior;
	OnCommitAction		oncommit;
	List				*list;
	Node				*node;
	Value				*value;
	ObjectType			objtype;

	TypeName			*typnam;
	FunctionParameter   *fun_param;
	FunctionParameterMode fun_param_mode;
	FuncWithArgs		*funwithargs;
	DefElem				*defelt;
	SortBy				*sortby;
	JoinExpr			*jexpr;
	IndexElem			*ielem;
	Alias				*alias;
	RangeVar			*range;
	A_Indices			*aind;
	ResTarget			*target;
	PrivTarget			*privtarget;

	InsertStmt			*istmt;
	VariableSetStmt		*vsetstmt;



/* Line 214 of yacc.c  */
#line 624 "gram.tab.c"
} YYSTYPE;
# define YYSTYPE_IS_TRIVIAL 1
# define yystype YYSTYPE /* obsolescent; will be withdrawn */
# define YYSTYPE_IS_DECLARED 1
#endif

#if ! defined YYLTYPE && ! defined YYLTYPE_IS_DECLARED
typedef struct YYLTYPE
{
  int first_line;
  int first_column;
  int last_line;
  int last_column;
} YYLTYPE;
# define yyltype YYLTYPE /* obsolescent; will be withdrawn */
# define YYLTYPE_IS_DECLARED 1
# define YYLTYPE_IS_TRIVIAL 1
#endif


/* Copy the second part of user declarations.  */


/* Line 264 of yacc.c  */
#line 649 "gram.tab.c"

#ifdef short
# undef short
#endif

#ifdef YYTYPE_UINT8
typedef YYTYPE_UINT8 yytype_uint8;
#else
typedef unsigned char yytype_uint8;
#endif

#ifdef YYTYPE_INT8
typedef YYTYPE_INT8 yytype_int8;
#elif (defined __STDC__ || defined __C99__FUNC__ \
     || defined __cplusplus || defined _MSC_VER)
typedef signed char yytype_int8;
#else
typedef short int yytype_int8;
#endif

#ifdef YYTYPE_UINT16
typedef YYTYPE_UINT16 yytype_uint16;
#else
typedef unsigned short int yytype_uint16;
#endif

#ifdef YYTYPE_INT16
typedef YYTYPE_INT16 yytype_int16;
#else
typedef short int yytype_int16;
#endif

#ifndef YYSIZE_T
# ifdef __SIZE_TYPE__
#  define YYSIZE_T __SIZE_TYPE__
# elif defined size_t
#  define YYSIZE_T size_t
# elif ! defined YYSIZE_T && (defined __STDC__ || defined __C99__FUNC__ \
     || defined __cplusplus || defined _MSC_VER)
#  include <stddef.h> /* INFRINGES ON USER NAME SPACE */
#  define YYSIZE_T size_t
# else
#  define YYSIZE_T unsigned int
# endif
#endif

#define YYSIZE_MAXIMUM ((YYSIZE_T) -1)

#ifndef YY_
# if YYENABLE_NLS
#  if ENABLE_NLS
#   include <libintl.h> /* INFRINGES ON USER NAME SPACE */
#   define YY_(msgid) dgettext ("bison-runtime", msgid)
#  endif
# endif
# ifndef YY_
#  define YY_(msgid) msgid
# endif
#endif

/* Suppress unused-variable warnings by "using" E.  */
#if ! defined lint || defined __GNUC__
# define YYUSE(e) ((void) (e))
#else
# define YYUSE(e) /* empty */
#endif

/* Identity function, used to suppress warnings about constant conditions.  */
#ifndef lint
# define YYID(n) (n)
#else
#if (defined __STDC__ || defined __C99__FUNC__ \
     || defined __cplusplus || defined _MSC_VER)
static int
YYID (int yyi)
#else
static int
YYID (yyi)
    int yyi;
#endif
{
  return yyi;
}
#endif

#if ! defined yyoverflow || YYERROR_VERBOSE

/* The parser invokes alloca or malloc; define the necessary symbols.  */

# ifdef YYSTACK_USE_ALLOCA
#  if YYSTACK_USE_ALLOCA
#   ifdef __GNUC__
#    define YYSTACK_ALLOC __builtin_alloca
#   elif defined __BUILTIN_VA_ARG_INCR
#    include <alloca.h> /* INFRINGES ON USER NAME SPACE */
#   elif defined _AIX
#    define YYSTACK_ALLOC __alloca
#   elif defined _MSC_VER
#    include <malloc.h> /* INFRINGES ON USER NAME SPACE */
#    define alloca _alloca
#   else
#    define YYSTACK_ALLOC alloca
#    if ! defined _ALLOCA_H && ! defined _STDLIB_H && (defined __STDC__ || defined __C99__FUNC__ \
     || defined __cplusplus || defined _MSC_VER)
#     include <stdlib.h> /* INFRINGES ON USER NAME SPACE */
#     ifndef _STDLIB_H
#      define _STDLIB_H 1
#     endif
#    endif
#   endif
#  endif
# endif

# ifdef YYSTACK_ALLOC
   /* Pacify GCC's `empty if-body' warning.  */
#  define YYSTACK_FREE(Ptr) do { /* empty */; } while (YYID (0))
#  ifndef YYSTACK_ALLOC_MAXIMUM
    /* The OS might guarantee only one guard page at the bottom of the stack,
       and a page size can be as small as 4096 bytes.  So we cannot safely
       invoke alloca (N) if N exceeds 4096.  Use a slightly smaller number
       to allow for a few compiler-allocated temporary stack slots.  */
#   define YYSTACK_ALLOC_MAXIMUM 4032 /* reasonable circa 2006 */
#  endif
# else
#  define YYSTACK_ALLOC YYMALLOC
#  define YYSTACK_FREE YYFREE
#  ifndef YYSTACK_ALLOC_MAXIMUM
#   define YYSTACK_ALLOC_MAXIMUM YYSIZE_MAXIMUM
#  endif
#  if (defined __cplusplus && ! defined _STDLIB_H \
       && ! ((defined YYMALLOC || defined malloc) \
	     && (defined YYFREE || defined free)))
#   include <stdlib.h> /* INFRINGES ON USER NAME SPACE */
#   ifndef _STDLIB_H
#    define _STDLIB_H 1
#   endif
#  endif
#  ifndef YYMALLOC
#   define YYMALLOC malloc
#   if ! defined malloc && ! defined _STDLIB_H && (defined __STDC__ || defined __C99__FUNC__ \
     || defined __cplusplus || defined _MSC_VER)
void *malloc (YYSIZE_T); /* INFRINGES ON USER NAME SPACE */
#   endif
#  endif
#  ifndef YYFREE
#   define YYFREE free
#   if ! defined free && ! defined _STDLIB_H && (defined __STDC__ || defined __C99__FUNC__ \
     || defined __cplusplus || defined _MSC_VER)
void free (void *); /* INFRINGES ON USER NAME SPACE */
#   endif
#  endif
# endif
#endif /* ! defined yyoverflow || YYERROR_VERBOSE */


#if (! defined yyoverflow \
     && (! defined __cplusplus \
	 || (defined YYLTYPE_IS_TRIVIAL && YYLTYPE_IS_TRIVIAL \
	     && defined YYSTYPE_IS_TRIVIAL && YYSTYPE_IS_TRIVIAL)))

/* A type that is properly aligned for any stack member.  */
union yyalloc
{
  yytype_int16 yyss_alloc;
  YYSTYPE yyvs_alloc;
  YYLTYPE yyls_alloc;
};

/* The size of the maximum gap between one aligned stack and the next.  */
# define YYSTACK_GAP_MAXIMUM (sizeof (union yyalloc) - 1)

/* The size of an array large to enough to hold all stacks, each with
   N elements.  */
# define YYSTACK_BYTES(N) \
     ((N) * (sizeof (yytype_int16) + sizeof (YYSTYPE) + sizeof (YYLTYPE)) \
      + 2 * YYSTACK_GAP_MAXIMUM)

/* Copy COUNT objects from FROM to TO.  The source and destination do
   not overlap.  */
# ifndef YYCOPY
#  if defined __GNUC__ && 1 < __GNUC__
#   define YYCOPY(To, From, Count) \
      __builtin_memcpy (To, From, (Count) * sizeof (*(From)))
#  else
#   define YYCOPY(To, From, Count)		\
      do					\
	{					\
	  YYSIZE_T yyi;				\
	  for (yyi = 0; yyi < (Count); yyi++)	\
	    (To)[yyi] = (From)[yyi];		\
	}					\
      while (YYID (0))
#  endif
# endif

/* Relocate STACK from its old location to the new one.  The
   local variables YYSIZE and YYSTACKSIZE give the old and new number of
   elements in the stack, and YYPTR gives the new location of the
   stack.  Advance YYPTR to a properly aligned location for the next
   stack.  */
# define YYSTACK_RELOCATE(Stack_alloc, Stack)				\
    do									\
      {									\
	YYSIZE_T yynewbytes;						\
	YYCOPY (&yyptr->Stack_alloc, Stack, yysize);			\
	Stack = &yyptr->Stack_alloc;					\
	yynewbytes = yystacksize * sizeof (*Stack) + YYSTACK_GAP_MAXIMUM; \
	yyptr += yynewbytes / sizeof (*yyptr);				\
      }									\
    while (YYID (0))

#endif

/* YYFINAL -- State number of the termination state.  */
#define YYFINAL  571
/* YYLAST -- Last index in YYTABLE.  */
#define YYLAST   41706

/* YYNTOKENS -- Number of terminals.  */
#define YYNTOKENS  379
/* YYNNTS -- Number of nonterminals.  */
#define YYNNTS  413
/* YYNRULES -- Number of rules.  */
#define YYNRULES  1691
/* YYNRULES -- Number of states.  */
#define YYNSTATES  2996

/* YYTRANSLATE(YYLEX) -- Bison symbol number corresponding to YYLEX.  */
#define YYUNDEFTOK  2
#define YYMAXUTOK   616

#define YYTRANSLATE(YYX)						\
  ((unsigned int) (YYX) <= YYMAXUTOK ? yytranslate[YYX] : YYUNDEFTOK)

/* YYTRANSLATE[YYLEX] -- Bison symbol number corresponding to YYLEX.  */
static const yytype_uint16 yytranslate[] =
{
       0,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,   367,     2,     2,
     372,   373,   365,   363,   377,   364,   375,   366,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,   378,   376,
     360,   359,   361,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,   370,     2,   371,   368,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     1,     2,     3,     4,
       5,     6,     7,     8,     9,    10,    11,    12,    13,    14,
      15,    16,    17,    18,    19,    20,    21,    22,    23,    24,
      25,    26,    27,    28,    29,    30,    31,    32,    33,    34,
      35,    36,    37,    38,    39,    40,    41,    42,    43,    44,
      45,    46,    47,    48,    49,    50,    51,    52,    53,    54,
      55,    56,    57,    58,    59,    60,    61,    62,    63,    64,
      65,    66,    67,    68,    69,    70,    71,    72,    73,    74,
      75,    76,    77,    78,    79,    80,    81,    82,    83,    84,
      85,    86,    87,    88,    89,    90,    91,    92,    93,    94,
      95,    96,    97,    98,    99,   100,   101,   102,   103,   104,
     105,   106,   107,   108,   109,   110,   111,   112,   113,   114,
     115,   116,   117,   118,   119,   120,   121,   122,   123,   124,
     125,   126,   127,   128,   129,   130,   131,   132,   133,   134,
     135,   136,   137,   138,   139,   140,   141,   142,   143,   144,
     145,   146,   147,   148,   149,   150,   151,   152,   153,   154,
     155,   156,   157,   158,   159,   160,   161,   162,   163,   164,
     165,   166,   167,   168,   169,   170,   171,   172,   173,   174,
     175,   176,   177,   178,   179,   180,   181,   182,   183,   184,
     185,   186,   187,   188,   189,   190,   191,   192,   193,   194,
     195,   196,   197,   198,   199,   200,   201,   202,   203,   204,
     205,   206,   207,   208,   209,   210,   211,   212,   213,   214,
     215,   216,   217,   218,   219,   220,   221,   222,   223,   224,
     225,   226,   227,   228,   229,   230,   231,   232,   233,   234,
     235,   236,   237,   238,   239,   240,   241,   242,   243,   244,
     245,   246,   247,   248,   249,   250,   251,   252,   253,   254,
     255,   256,   257,   258,   259,   260,   261,   262,   263,   264,
     265,   266,   267,   268,   269,   270,   271,   272,   273,   274,
     275,   276,   277,   278,   279,   280,   281,   282,   283,   284,
     285,   286,   287,   288,   289,   290,   291,   292,   293,   294,
     295,   296,   297,   298,   299,   300,   301,   302,   303,   304,
     305,   306,   307,   308,   309,   310,   311,   312,   313,   314,
     315,   316,   317,   318,   319,   320,   321,   322,   323,   324,
     325,   326,   327,   328,   329,   330,   331,   332,   333,   334,
     335,   336,   337,   338,   339,   340,   341,   342,   343,   344,
     345,   346,   347,   348,   349,   350,   351,   352,   353,   354,
     355,   356,   357,   358,   362,   369,   374
};

#if YYDEBUG
/* YYPRHS[YYN] -- Index of the first RHS symbol of rule number YYN in
   YYRHS.  */
static const yytype_uint16 yyprhs[] =
{
       0,     0,     3,     5,     9,    11,    13,    15,    17,    19,
      21,    23,    25,    27,    29,    31,    33,    35,    37,    39,
      41,    43,    45,    47,    49,    51,    53,    55,    57,    59,
      61,    63,    65,    67,    69,    71,    73,    75,    77,    79,
      81,    83,    85,    87,    89,    91,    93,    95,    97,    99,
     101,   103,   105,   107,   109,   111,   113,   115,   117,   119,
     121,   123,   125,   127,   129,   131,   133,   135,   137,   139,
     141,   143,   145,   147,   149,   151,   153,   155,   157,   159,
     161,   163,   165,   167,   169,   171,   173,   175,   177,   179,
     181,   182,   188,   190,   191,   194,   195,   198,   201,   205,
     209,   211,   213,   215,   217,   219,   221,   223,   225,   227,
     229,   231,   233,   237,   241,   244,   247,   250,   253,   257,
     261,   267,   273,   279,   284,   290,   296,   301,   305,   311,
     315,   321,   327,   334,   336,   338,   342,   348,   355,   360,
     362,   363,   366,   367,   369,   371,   373,   375,   377,   379,
     382,   386,   390,   394,   398,   402,   405,   411,   414,   417,
     421,   425,   427,   431,   433,   435,   437,   441,   443,   445,
     447,   450,   453,   456,   458,   460,   462,   464,   466,   468,
     470,   474,   481,   483,   485,   487,   489,   491,   492,   494,
     496,   499,   503,   508,   512,   515,   518,   522,   527,   531,
     534,   539,   541,   543,   545,   547,   549,   554,   559,   561,
     565,   569,   574,   581,   588,   595,   602,   607,   614,   617,
     622,   626,   630,   634,   638,   642,   646,   650,   654,   658,
     661,   665,   667,   669,   673,   677,   681,   684,   687,   691,
     694,   696,   698,   699,   702,   703,   706,   717,   724,   726,
     728,   730,   732,   734,   737,   738,   740,   742,   746,   750,
     752,   754,   758,   762,   766,   771,   773,   774,   777,   778,
     782,   783,   785,   786,   798,   811,   813,   815,   818,   821,
     824,   827,   828,   830,   831,   833,   837,   839,   841,   843,
     847,   850,   851,   855,   857,   859,   862,   864,   868,   873,
     878,   881,   887,   889,   892,   895,   898,   902,   905,   906,
     909,   912,   915,   918,   921,   924,   928,   930,   935,   942,
     950,   962,   966,   967,   969,   973,   975,   978,   981,   984,
     985,   987,   989,   992,   995,   996,  1000,  1004,  1007,  1009,
    1011,  1014,  1017,  1022,  1023,  1026,  1029,  1032,  1033,  1037,
    1042,  1047,  1048,  1051,  1052,  1057,  1058,  1069,  1073,  1074,
    1076,  1080,  1082,  1088,  1093,  1096,  1097,  1100,  1102,  1105,
    1109,  1112,  1115,  1118,  1121,  1125,  1129,  1133,  1135,  1136,
    1138,  1140,  1142,  1145,  1147,  1153,  1163,  1165,  1166,  1168,
    1171,  1174,  1175,  1178,  1179,  1185,  1193,  1195,  1196,  1203,
    1206,  1207,  1211,  1217,  1232,  1252,  1254,  1256,  1258,  1262,
    1268,  1270,  1272,  1274,  1278,  1279,  1281,  1282,  1284,  1286,
    1288,  1292,  1293,  1295,  1297,  1299,  1301,  1303,  1305,  1308,
    1309,  1311,  1314,  1316,  1319,  1320,  1323,  1325,  1328,  1331,
    1338,  1347,  1356,  1361,  1367,  1372,  1377,  1382,  1386,  1394,
    1398,  1400,  1404,  1408,  1410,  1412,  1414,  1416,  1418,  1420,
    1422,  1426,  1430,  1432,  1436,  1440,  1442,  1446,  1450,  1463,
    1465,  1469,  1474,  1482,  1487,  1490,  1492,  1493,  1495,  1496,
    1504,  1514,  1520,  1527,  1534,  1539,  1541,  1543,  1545,  1547,
    1549,  1551,  1553,  1555,  1557,  1561,  1563,  1566,  1569,  1573,
    1578,  1585,  1593,  1601,  1611,  1620,  1629,  1636,  1645,  1655,
    1663,  1674,  1682,  1684,  1686,  1688,  1690,  1692,  1694,  1696,
    1698,  1700,  1702,  1704,  1706,  1708,  1710,  1715,  1718,  1723,
    1726,  1727,  1729,  1731,  1733,  1735,  1738,  1741,  1743,  1745,
    1747,  1750,  1753,  1755,  1758,  1761,  1763,  1765,  1773,  1781,
    1792,  1794,  1796,  1799,  1801,  1805,  1807,  1809,  1811,  1813,
    1815,  1818,  1821,  1824,  1827,  1830,  1833,  1836,  1838,  1842,
    1844,  1847,  1851,  1852,  1854,  1858,  1861,  1868,  1875,  1885,
    1889,  1890,  1894,  1895,  1909,  1924,  1926,  1927,  1930,  1931,
    1933,  1937,  1940,  1943,  1948,  1950,  1953,  1954,  1964,  1972,
    1975,  1976,  1980,  1983,  1985,  1989,  1993,  1997,  2000,  2003,
    2005,  2007,  2009,  2011,  2014,  2016,  2018,  2020,  2025,  2031,
    2033,  2036,  2041,  2047,  2049,  2051,  2053,  2055,  2059,  2063,
    2066,  2069,  2072,  2075,  2077,  2079,  2083,  2086,  2087,  2093,
    2095,  2098,  2100,  2101,  2107,  2115,  2121,  2129,  2137,  2147,
    2149,  2153,  2157,  2161,  2163,  2167,  2179,  2190,  2193,  2196,
    2197,  2207,  2210,  2211,  2216,  2221,  2226,  2228,  2230,  2232,
    2233,  2241,  2248,  2255,  2263,  2270,  2277,  2287,  2294,  2301,
    2308,  2317,  2326,  2333,  2340,  2347,  2349,  2350,  2358,  2365,
    2373,  2380,  2387,  2394,  2402,  2409,  2416,  2423,  2431,  2441,
    2451,  2458,  2465,  2472,  2473,  2488,  2490,  2492,  2496,  2500,
    2502,  2504,  2506,  2508,  2510,  2512,  2514,  2515,  2517,  2519,
    2521,  2523,  2525,  2527,  2528,  2535,  2544,  2547,  2550,  2553,
    2556,  2559,  2563,  2567,  2570,  2573,  2576,  2579,  2583,  2586,
    2592,  2597,  2601,  2605,  2609,  2611,  2613,  2614,  2618,  2621,
    2624,  2626,  2630,  2633,  2635,  2636,  2645,  2656,  2659,  2663,
    2667,  2668,  2671,  2677,  2680,  2681,  2685,  2689,  2693,  2697,
    2701,  2705,  2709,  2713,  2717,  2722,  2726,  2730,  2732,  2733,
    2739,  2745,  2750,  2753,  2754,  2759,  2763,  2769,  2776,  2781,
    2788,  2795,  2801,  2809,  2811,  2812,  2823,  2828,  2831,  2833,
    2838,  2844,  2850,  2853,  2858,  2860,  2862,  2864,  2865,  2867,
    2868,  2870,  2871,  2875,  2876,  2881,  2883,  2885,  2887,  2889,
    2891,  2893,  2895,  2896,  2902,  2906,  2907,  2909,  2913,  2915,
    2917,  2919,  2921,  2925,  2938,  2942,  2943,  2946,  2950,  2956,
    2958,  2963,  2966,  2968,  2972,  2975,  2978,  2979,  2986,  2989,
    2990,  2996,  3000,  3001,  3004,  3007,  3010,  3014,  3016,  3020,
    3022,  3025,  3027,  3028,  3036,  3038,  3042,  3044,  3046,  3050,
    3056,  3059,  3061,  3065,  3073,  3074,  3078,  3081,  3084,  3087,
    3088,  3091,  3094,  3096,  3098,  3102,  3106,  3108,  3111,  3116,
    3121,  3123,  3125,  3137,  3139,  3144,  3149,  3154,  3157,  3158,
    3162,  3166,  3171,  3176,  3181,  3186,  3189,  3191,  3193,  3194,
    3196,  3198,  3199,  3201,  3207,  3209,  3210,  3212,  3213,  3217,
    3219,  3223,  3227,  3230,  3233,  3235,  3240,  3245,  3248,  3251,
    3256,  3258,  3259,  3261,  3263,  3265,  3269,  3270,  3273,  3274,
    3277,  3278,  3281,  3282,  3285,  3286,  3288,  3292,  3294,  3295,
    3297,  3300,  3305,  3310,  3313,  3314,  3317,  3321,  3324,  3325,
    3327,  3331,  3333,  3336,  3338,  3341,  3347,  3354,  3360,  3362,
    3365,  3367,  3372,  3376,  3381,  3387,  3392,  3398,  3403,  3409,
    3412,  3417,  3419,  3422,  3425,  3428,  3430,  3432,  3433,  3438,
    3441,  3443,  3446,  3449,  3454,  3456,  3459,  3463,  3465,  3468,
    3471,  3472,  3474,  3478,  3481,  3484,  3488,  3494,  3501,  3505,
    3510,  3511,  3513,  3515,  3517,  3519,  3521,  3524,  3530,  3533,
    3535,  3537,  3539,  3541,  3543,  3545,  3547,  3549,  3551,  3553,
    3555,  3558,  3561,  3564,  3567,  3570,  3572,  3576,  3577,  3583,
    3587,  3588,  3594,  3598,  3599,  3601,  3603,  3605,  3607,  3613,
    3616,  3618,  3620,  3622,  3624,  3630,  3633,  3636,  3639,  3641,
    3645,  3649,  3652,  3654,  3655,  3659,  3660,  3666,  3669,  3675,
    3678,  3680,  3684,  3688,  3689,  3691,  3693,  3695,  3697,  3699,
    3701,  3705,  3709,  3713,  3717,  3721,  3725,  3729,  3730,  3732,
    3736,  3742,  3745,  3748,  3752,  3756,  3760,  3764,  3768,  3772,
    3776,  3780,  3784,  3788,  3791,  3794,  3798,  3802,  3805,  3809,
    3815,  3820,  3827,  3831,  3837,  3842,  3849,  3854,  3861,  3867,
    3875,  3879,  3882,  3887,  3890,  3894,  3898,  3903,  3907,  3912,
    3916,  3921,  3927,  3934,  3941,  3949,  3956,  3964,  3971,  3979,
    3983,  3988,  3993,  4000,  4003,  4005,  4009,  4012,  4015,  4019,
    4023,  4027,  4031,  4035,  4039,  4043,  4047,  4051,  4055,  4058,
    4061,  4067,  4074,  4081,  4089,  4091,  4093,  4096,  4101,  4103,
    4105,  4107,  4110,  4113,  4116,  4118,  4122,  4127,  4133,  4139,
    4144,  4146,  4148,  4153,  4155,  4160,  4162,  4167,  4169,  4174,
    4176,  4178,  4180,  4182,  4189,  4194,  4199,  4204,  4209,  4216,
    4222,  4228,  4234,  4239,  4246,  4251,  4258,  4263,  4268,  4273,
    4279,  4285,  4289,  4294,  4298,  4304,  4306,  4308,  4310,  4312,
    4314,  4316,  4318,  4320,  4322,  4324,  4326,  4328,  4330,  4332,
    4334,  4339,  4341,  4346,  4348,  4353,  4355,  4358,  4360,  4363,
    4365,  4369,  4373,  4374,  4378,  4380,  4382,  4386,  4390,  4394,
    4396,  4398,  4400,  4402,  4404,  4406,  4408,  4410,  4415,  4419,
    4422,  4426,  4427,  4431,  4435,  4438,  4441,  4443,  4444,  4447,
    4450,  4454,  4457,  4459,  4461,  4465,  4471,  4473,  4476,  4481,
    4484,  4485,  4487,  4488,  4490,  4493,  4496,  4499,  4503,  4509,
    4511,  4514,  4515,  4518,  4520,  4521,  4523,  4525,  4527,  4531,
    4535,  4537,  4541,  4545,  4547,  4549,  4551,  4553,  4555,  4559,
    4561,  4564,  4566,  4570,  4572,  4574,  4576,  4578,  4580,  4582,
    4584,  4587,  4589,  4591,  4593,  4595,  4597,  4600,  4604,  4611,
    4613,  4615,  4617,  4619,  4621,  4623,  4625,  4628,  4630,  4632,
    4634,  4636,  4638,  4640,  4642,  4644,  4646,  4648,  4650,  4652,
    4654,  4656,  4658,  4660,  4662,  4664,  4666,  4668,  4670,  4672,
    4674,  4676,  4678,  4680,  4682,  4684,  4686,  4688,  4690,  4692,
    4694,  4696,  4698,  4700,  4702,  4704,  4706,  4708,  4710,  4712,
    4714,  4716,  4718,  4720,  4722,  4724,  4726,  4728,  4730,  4732,
    4734,  4736,  4738,  4740,  4742,  4744,  4746,  4748,  4750,  4752,
    4754,  4756,  4758,  4760,  4762,  4764,  4766,  4768,  4770,  4772,
    4774,  4776,  4778,  4780,  4782,  4784,  4786,  4788,  4790,  4792,
    4794,  4796,  4798,  4800,  4802,  4804,  4806,  4808,  4810,  4812,
    4814,  4816,  4818,  4820,  4822,  4824,  4826,  4828,  4830,  4832,
    4834,  4836,  4838,  4840,  4842,  4844,  4846,  4848,  4850,  4852,
    4854,  4856,  4858,  4860,  4862,  4864,  4866,  4868,  4870,  4872,
    4874,  4876,  4878,  4880,  4882,  4884,  4886,  4888,  4890,  4892,
    4894,  4896,  4898,  4900,  4902,  4904,  4906,  4908,  4910,  4912,
    4914,  4916,  4918,  4920,  4922,  4924,  4926,  4928,  4930,  4932,
    4934,  4936,  4938,  4940,  4942,  4944,  4946,  4948,  4950,  4952,
    4954,  4956,  4958,  4960,  4962,  4964,  4966,  4968,  4970,  4972,
    4974,  4976,  4978,  4980,  4982,  4984,  4986,  4988,  4990,  4992,
    4994,  4996,  4998,  5000,  5002,  5004,  5006,  5008,  5010,  5012,
    5014,  5016,  5018,  5020,  5022,  5024,  5026,  5028,  5030,  5032,
    5034,  5036,  5038,  5040,  5042,  5044,  5046,  5048,  5050,  5052,
    5054,  5056,  5058,  5060,  5062,  5064,  5066,  5068,  5070,  5072,
    5074,  5076,  5078,  5080,  5082,  5084,  5086,  5088,  5090,  5092,
    5094,  5096,  5098,  5100,  5102,  5104,  5106,  5108,  5110,  5112,
    5114,  5116,  5118,  5120,  5122,  5124,  5126,  5128,  5130,  5132,
    5134,  5136,  5138,  5140,  5142,  5144,  5146,  5148,  5150,  5152,
    5154,  5156,  5158,  5160,  5162,  5164,  5166,  5168,  5170,  5172,
    5174,  5176,  5178,  5180,  5182,  5184,  5186,  5188,  5190,  5192,
    5194,  5196,  5198,  5200,  5202,  5204,  5206,  5208,  5210,  5212,
    5214,  5216,  5218,  5220,  5222,  5224,  5226,  5228,  5230,  5232,
    5234,  5236,  5238,  5240,  5242,  5244,  5246,  5248,  5250,  5252,
    5254,  5256,  5258,  5260,  5262,  5264,  5266,  5268,  5270,  5272,
    5274,  5276,  5278,  5280,  5282,  5284,  5286,  5288,  5290,  5292,
    5294,  5296,  5298,  5300,  5302,  5304,  5306,  5308,  5310,  5312,
    5314,  5316,  5318,  5320,  5322,  5324,  5326,  5328,  5330,  5332,
    5334,  5336
};

/* YYRHS -- A `-1'-separated list of the rules' RHS.  */
static const yytype_int16 yyrhs[] =
{
     380,     0,    -1,   381,    -1,   381,   376,   382,    -1,   382,
      -1,   611,    -1,   612,    -1,   617,    -1,   568,    -1,   395,
      -1,   585,    -1,   586,    -1,   470,    -1,   419,    -1,   389,
      -1,   388,    -1,   391,    -1,   390,    -1,   622,    -1,   418,
      -1,   427,    -1,   620,    -1,   527,    -1,   415,    -1,   428,
      -1,   465,    -1,   501,    -1,   576,    -1,   619,    -1,   616,
      -1,   554,    -1,   394,    -1,   513,    -1,   477,    -1,   398,
      -1,   469,    -1,   437,    -1,   484,    -1,   487,    -1,   383,
      -1,   387,    -1,   607,    -1,   637,    -1,   656,    -1,   503,
      -1,   643,    -1,   502,    -1,   578,    -1,   397,    -1,   518,
      -1,   519,    -1,   482,    -1,   595,    -1,   521,    -1,   486,
      -1,   500,    -1,   392,    -1,   393,    -1,   615,    -1,   635,
      -1,   628,    -1,   530,    -1,   533,    -1,   544,    -1,   548,
      -1,   638,    -1,   597,    -1,   606,    -1,   645,    -1,   596,
      -1,   631,    -1,   520,    -1,   580,    -1,   572,    -1,   571,
      -1,   573,    -1,   583,    -1,   534,    -1,   545,    -1,   587,
      -1,   659,    -1,   599,    -1,   526,    -1,   598,    -1,   649,
      -1,   621,    -1,   414,    -1,   402,    -1,   413,    -1,   604,
      -1,    -1,    65,   266,   781,   384,   385,    -1,   341,    -1,
      -1,   385,   386,    -1,    -1,   235,   780,    -1,   235,   213,
      -1,   103,   235,   780,    -1,   321,   235,   780,    -1,   298,
      -1,   207,    -1,   146,    -1,   204,    -1,    66,    -1,   201,
      -1,    67,    -1,   202,    -1,    68,    -1,   203,    -1,   183,
      -1,   205,    -1,    59,   175,   782,    -1,   331,   326,   780,
      -1,   328,   770,    -1,   300,   779,    -1,     8,   770,    -1,
     266,   770,    -1,   141,   266,   770,    -1,   141,   130,   770,
      -1,    65,   328,   781,   384,   385,    -1,    13,   266,   781,
     384,   385,    -1,    13,   266,   781,   281,   403,    -1,    13,
     266,   781,   414,    -1,    13,   328,   781,   384,   385,    -1,
      13,   328,   781,   281,   403,    -1,    13,   328,   781,   414,
      -1,    98,   266,   770,    -1,    98,   266,   136,   110,   770,
      -1,    98,   328,   770,    -1,    98,   328,   136,   110,   770,
      -1,    65,   130,   781,   384,   385,    -1,    13,   130,   781,
     396,   328,   770,    -1,     7,    -1,    98,    -1,    98,   130,
     770,    -1,    98,   130,   136,   110,   770,    -1,    65,   272,
     399,    26,   781,   400,    -1,    65,   272,   783,   400,    -1,
     783,    -1,    -1,   400,   401,    -1,    -1,   437,    -1,   548,
      -1,   469,    -1,   487,    -1,   533,    -1,   604,    -1,   281,
     403,    -1,   281,   178,   403,    -1,   281,   279,   403,    -1,
     404,   310,   405,    -1,   404,   359,   405,    -1,   308,   347,
     410,    -1,   312,   602,    -1,   279,    46,    20,   312,   602,
      -1,   194,   411,    -1,   266,   412,    -1,   279,    26,   412,
      -1,   279,    26,    84,    -1,   783,    -1,   404,   375,   783,
      -1,   406,    -1,    84,    -1,   407,    -1,   406,   377,   407,
      -1,   409,    -1,   412,    -1,   474,    -1,   248,   320,    -1,
     248,    57,    -1,   257,   248,    -1,   278,    -1,   316,    -1,
     114,    -1,   222,    -1,   218,    -1,   780,    -1,   351,    -1,
     723,   780,   725,    -1,   723,   372,   779,   373,   780,   725,
      -1,   474,    -1,    84,    -1,   178,    -1,   780,    -1,    84,
      -1,    -1,   783,    -1,   353,    -1,   284,   404,    -1,   284,
     308,   347,    -1,   284,   312,   163,   173,    -1,   284,   279,
      26,    -1,   284,    11,    -1,   259,   404,    -1,   259,   308,
     347,    -1,   259,   312,   163,   173,    -1,   259,   279,    26,
      -1,   259,    11,    -1,   281,    61,   416,   417,    -1,    11,
      -1,   768,    -1,    87,    -1,   138,    -1,    48,    -1,    13,
     302,   696,   420,    -1,    13,   144,   696,   422,    -1,   421,
      -1,   420,   377,   421,    -1,     7,   584,   442,    -1,    13,
     584,   783,   424,    -1,    13,   584,   783,    98,   208,   213,
      -1,    13,   584,   783,   281,   208,   213,    -1,    13,   584,
     783,   281,   292,   476,    -1,    13,   584,   783,   281,   295,
     783,    -1,    98,   584,   783,   425,    -1,    13,   584,   783,
     319,   702,   426,    -1,     7,   450,    -1,    98,    60,   771,
     425,    -1,   281,   343,   220,    -1,    51,   222,   771,    -1,
     281,   343,    51,    -1,   101,   314,   771,    -1,   101,   314,
      11,    -1,   101,   314,   328,    -1,    93,   314,   771,    -1,
      93,   314,    11,    -1,    93,   314,   328,    -1,   146,   769,
      -1,   200,   146,   769,    -1,   423,    -1,   423,    -1,   422,
     377,   423,    -1,   233,   310,   781,    -1,   281,   303,   771,
      -1,   281,   504,    -1,   259,   504,    -1,   281,    84,   726,
      -1,    98,    84,    -1,    39,    -1,   261,    -1,    -1,   329,
     726,    -1,    -1,    50,   771,    -1,    64,   433,   769,   452,
     434,   429,   430,   435,   384,   431,    -1,    64,   660,   310,
     430,   384,   431,    -1,   123,    -1,   310,    -1,   780,    -1,
     293,    -1,   294,    -1,   431,   432,    -1,    -1,    32,    -1,
     220,    -1,    90,   618,   780,    -1,   213,   618,   780,    -1,
      70,    -1,   133,    -1,   247,   618,   780,    -1,   105,   618,
     780,    -1,   119,   247,   453,    -1,   119,   208,   213,   453,
      -1,    32,    -1,    -1,   341,   220,    -1,    -1,   436,    91,
     780,    -1,    -1,   329,    -1,    -1,    65,   438,   302,   769,
     372,   439,   373,   460,   461,   462,   463,    -1,    65,   438,
     302,   769,   217,   769,   372,   439,   373,   461,   462,   463,
      -1,   306,    -1,   304,    -1,   178,   306,    -1,   178,   304,
      -1,   126,   306,    -1,   126,   304,    -1,    -1,   440,    -1,
      -1,   441,    -1,   440,   377,   441,    -1,   442,    -1,   447,
      -1,   450,    -1,   783,   702,   443,    -1,   443,   444,    -1,
      -1,    60,   771,   445,    -1,   445,    -1,   446,    -1,   208,
     213,    -1,   213,    -1,   323,   567,   464,    -1,   242,   165,
     567,   464,    -1,    47,   372,   726,   373,    -1,    84,   727,
      -1,   252,   769,   452,   455,   456,    -1,    86,    -1,   208,
      86,    -1,   148,    87,    -1,   148,   138,    -1,   174,   769,
     448,    -1,   448,   449,    -1,    -1,   142,    85,    -1,   107,
      85,    -1,   142,    61,    -1,   107,    61,    -1,   142,   145,
      -1,   107,   145,    -1,    60,   771,   451,    -1,   451,    -1,
      47,   372,   726,   373,    -1,   323,   372,   453,   373,   567,
     464,    -1,   242,   165,   372,   453,   373,   567,   464,    -1,
     120,   165,   372,   453,   373,   252,   769,   452,   455,   456,
     497,    -1,   372,   453,   373,    -1,    -1,   454,    -1,   453,
     377,   454,    -1,   783,    -1,   184,   124,    -1,   184,   234,
      -1,   184,   286,    -1,    -1,   457,    -1,   458,    -1,   457,
     458,    -1,   458,   457,    -1,    -1,   222,   327,   459,    -1,
     222,    89,   459,    -1,   200,     6,    -1,   261,    -1,    39,
      -1,   281,   213,    -1,   281,    84,    -1,   147,   372,   768,
     373,    -1,    -1,   341,   504,    -1,   341,   220,    -1,   343,
     220,    -1,    -1,   222,    56,    98,    -1,   222,    56,    89,
     269,    -1,   222,    56,   239,   269,    -1,    -1,   303,   771,
      -1,    -1,   329,   144,   303,   771,    -1,    -1,    65,   438,
     302,   769,   466,   461,   462,   463,    20,   659,    -1,   372,
     467,   373,    -1,    -1,   468,    -1,   467,   377,   468,    -1,
     783,    -1,    65,   438,   277,   769,   471,    -1,    13,   277,
     769,   471,    -1,   471,   472,    -1,    -1,    37,   474,    -1,
      77,    -1,   200,    77,    -1,   143,   473,   474,    -1,   185,
     474,    -1,   187,   474,    -1,   200,   185,    -1,   200,   187,
      -1,   232,    36,   524,    -1,   290,   384,   474,    -1,   260,
     384,   474,    -1,    36,    -1,    -1,   475,    -1,   476,    -1,
     352,    -1,   364,   352,    -1,   782,    -1,    65,   478,   483,
     167,   412,    -1,    65,   478,   483,   167,   412,   131,   479,
     480,   481,    -1,   318,    -1,    -1,   771,    -1,   771,   525,
      -1,   332,   479,    -1,    -1,   166,   780,    -1,    -1,    98,
     483,   167,   412,   425,    -1,    98,   483,   167,   136,   110,
     412,   425,    -1,   245,    -1,    -1,    65,   303,   771,   485,
     181,   780,    -1,   233,   771,    -1,    -1,    98,   303,   771,
      -1,    98,   303,   136,   110,   771,    -1,    65,   314,   771,
     488,   489,   222,   769,   491,   109,   246,   777,   372,   494,
     373,    -1,    65,    60,   314,   771,     9,   489,   222,   769,
     496,   497,   118,    99,   268,   109,   246,   777,   372,   494,
     373,    -1,    28,    -1,     9,    -1,   490,    -1,   490,   226,
     490,    -1,   490,   226,   490,   226,   490,    -1,   153,    -1,
      89,    -1,   327,    -1,   118,   492,   493,    -1,    -1,    99,
      -1,    -1,   268,    -1,   291,    -1,   495,    -1,   494,   377,
     495,    -1,    -1,   357,    -1,   352,    -1,   780,    -1,   354,
      -1,   355,    -1,   783,    -1,   123,   769,    -1,    -1,   498,
      -1,   498,   499,    -1,   499,    -1,   499,   498,    -1,    -1,
     208,    86,    -1,    86,    -1,   148,   138,    -1,   148,    87,
      -1,    98,   314,   771,   222,   769,   425,    -1,    98,   314,
     136,   110,   771,   222,   769,   425,    -1,    65,    22,   771,
      47,   372,   726,   373,   497,    -1,    98,    22,   771,   425,
      -1,    65,    10,   777,   508,   504,    -1,    65,    10,   777,
     510,    -1,    65,   224,   575,   504,    -1,    65,   319,   524,
     504,    -1,    65,   319,   524,    -1,    65,   319,   524,    20,
     372,   700,   373,    -1,   372,   505,   373,    -1,   506,    -1,
     505,   377,   506,    -1,   786,   359,   507,    -1,   786,    -1,
     562,    -1,   789,    -1,   790,    -1,   736,    -1,   474,    -1,
     780,    -1,   372,   509,   373,    -1,   372,   365,   373,    -1,
     702,    -1,   509,   377,   702,    -1,   372,   511,   373,    -1,
     512,    -1,   511,   377,   512,    -1,   351,   359,   507,    -1,
      65,   224,    49,   524,   516,   118,   319,   702,   329,   773,
      20,   514,    -1,   515,    -1,   514,   377,   515,    -1,   224,
     779,   575,   517,    -1,   224,   779,   575,   372,   574,   373,
     517,    -1,   125,   779,   777,   556,    -1,   295,   702,    -1,
      84,    -1,    -1,   251,    -1,    -1,    98,   224,    49,   524,
     329,   773,   425,    -1,    98,   224,    49,   136,   110,   524,
     329,   773,   425,    -1,    98,   232,    36,   770,   425,    -1,
     250,   232,    36,   770,   310,   771,    -1,    98,   522,   136,
     110,   523,   425,    -1,    98,   522,   523,   425,    -1,   302,
      -1,   277,    -1,   337,    -1,   144,    -1,   319,    -1,    96,
      -1,    62,    -1,   272,    -1,   524,    -1,   523,   377,   524,
      -1,   783,    -1,   783,   525,    -1,   375,   774,    -1,   525,
     375,   774,    -1,   317,   666,   768,   425,    -1,    55,   222,
     528,   524,   161,   529,    -1,    55,   222,    10,   777,   508,
     161,   529,    -1,    55,   222,   125,   777,   556,   161,   529,
      -1,    55,   222,   224,   575,   372,   574,   373,   161,   529,
      -1,    55,   222,    60,   771,   222,   524,   161,   529,    -1,
      55,   222,   270,   771,   222,   524,   161,   529,    -1,    55,
     222,   270,   771,   161,   529,    -1,    55,   222,   314,   771,
     222,   524,   161,   529,    -1,    55,   222,   224,    49,   524,
     329,   773,   161,   529,    -1,    55,   222,   168,   216,   474,
     161,   529,    -1,    55,   222,    42,   372,   702,    20,   702,
     373,   161,   529,    -1,    55,   222,   483,   167,   524,   161,
     529,    -1,    54,    -1,    78,    -1,   272,    -1,   144,    -1,
     277,    -1,   302,    -1,    96,    -1,   319,    -1,   337,    -1,
      62,    -1,   303,    -1,   266,    -1,   780,    -1,   213,    -1,
     115,   531,   532,   771,    -1,   115,   771,    -1,   190,   531,
     532,   771,    -1,   190,   771,    -1,    -1,   199,    -1,   243,
      -1,   116,    -1,   169,    -1,     4,   782,    -1,   254,   782,
      -1,   782,    -1,    11,    -1,   121,    -1,   121,   782,    -1,
     121,    11,    -1,    27,    -1,    27,   782,    -1,    27,    11,
      -1,   123,    -1,   141,    -1,   127,   535,   222,   538,   310,
     539,   541,    -1,   264,   535,   222,   538,   123,   539,   425,
      -1,   264,   127,   225,   118,   535,   222,   538,   123,   539,
     425,    -1,   536,    -1,    11,    -1,    11,   244,    -1,   537,
      -1,   536,   377,   537,    -1,   276,    -1,   252,    -1,    65,
      -1,   783,    -1,   768,    -1,   302,   768,    -1,   277,   768,
      -1,   125,   542,    -1,    78,   770,    -1,   167,   770,    -1,
     272,   770,    -1,   303,   770,    -1,   540,    -1,   539,   377,
     540,    -1,   781,    -1,   130,   781,    -1,   341,   127,   225,
      -1,    -1,   543,    -1,   542,   377,   543,    -1,   777,   556,
      -1,   127,   536,   310,   770,   546,   547,    -1,   264,   536,
     123,   770,   547,   425,    -1,   264,     8,   225,   118,   536,
     123,   770,   547,   425,    -1,   341,     8,   225,    -1,    -1,
     128,    36,   781,    -1,    -1,    65,   549,   144,   775,   222,
     769,   550,   372,   551,   373,   567,   463,   699,    -1,    65,
     549,   144,    58,   775,   222,   769,   550,   372,   551,   373,
     567,   463,   699,    -1,   323,    -1,    -1,   329,   773,    -1,
      -1,   552,    -1,   551,   377,   552,    -1,   783,   553,    -1,
     729,   553,    -1,   372,   726,   373,   553,    -1,   524,    -1,
     329,   524,    -1,    -1,    65,   555,   125,   777,   556,   263,
     561,   563,   567,    -1,    65,   555,   125,   777,   556,   563,
     567,    -1,   226,   258,    -1,    -1,   372,   557,   373,    -1,
     372,   373,    -1,   558,    -1,   557,   377,   558,    -1,   559,
     560,   562,    -1,   560,   559,   562,    -1,   560,   562,    -1,
     559,   562,    -1,   562,    -1,   141,    -1,   228,    -1,   150,
      -1,   141,   228,    -1,   785,    -1,   562,    -1,   702,    -1,
     784,   525,   367,   319,    -1,   282,   784,   525,   367,   319,
      -1,   565,    -1,   563,   565,    -1,    38,   222,   213,   151,
      -1,   263,   213,   222,   213,   151,    -1,   296,    -1,   139,
      -1,   289,    -1,   338,    -1,   112,   275,    88,    -1,   112,
     275,   160,    -1,   275,    88,    -1,   275,   160,    -1,    20,
     566,    -1,   167,   412,    -1,   564,    -1,   780,    -1,   780,
     377,   780,    -1,   341,   504,    -1,    -1,    13,   125,   543,
     569,   570,    -1,   564,    -1,   569,   564,    -1,   261,    -1,
      -1,    98,   125,   777,   556,   425,    -1,    98,   125,   136,
     110,   777,   556,   425,    -1,    98,    10,   777,   508,   425,
      -1,    98,    10,   136,   110,   777,   508,   425,    -1,    98,
     224,   575,   372,   574,   373,   425,    -1,    98,   224,   136,
     110,   575,   372,   574,   373,   425,    -1,   702,    -1,   702,
     377,   702,    -1,   206,   377,   702,    -1,   702,   377,   206,
      -1,   733,    -1,   783,   375,   575,    -1,    65,    42,   372,
     702,    20,   702,   373,   341,   125,   543,   577,    -1,    65,
      42,   372,   702,    20,   702,   373,   343,   125,   577,    -1,
      20,   140,    -1,    20,    23,    -1,    -1,    98,    42,   579,
     372,   702,    20,   702,   373,   425,    -1,   136,   110,    -1,
      -1,   253,   581,   769,   582,    -1,   253,   301,   771,   582,
      -1,   253,    78,   771,   582,    -1,   144,    -1,   302,    -1,
     119,    -1,    -1,    13,    10,   777,   508,   256,   310,   771,
      -1,    13,    62,   524,   256,   310,   771,    -1,    13,    78,
     772,   256,   310,   772,    -1,    13,   125,   777,   556,   256,
     310,   771,    -1,    13,   130,   781,   256,   310,   781,    -1,
      13,   167,   771,   256,   310,   771,    -1,    13,   224,    49,
     524,   329,   773,   256,   310,   771,    -1,    13,   272,   771,
     256,   310,   771,    -1,    13,   302,   696,   256,   310,   771,
      -1,    13,   144,   696,   256,   310,   771,    -1,    13,   302,
     696,   256,   584,   771,   310,   771,    -1,    13,   314,   771,
     222,   696,   256,   310,   771,    -1,    13,   266,   781,   256,
     310,   781,    -1,    13,   328,   781,   256,   310,   781,    -1,
      13,   303,   771,   256,   310,   771,    -1,    54,    -1,    -1,
      13,    10,   777,   508,   281,   272,   771,    -1,    13,    96,
     524,   281,   272,   771,    -1,    13,   125,   777,   556,   281,
     272,   771,    -1,    13,   277,   696,   281,   272,   771,    -1,
      13,   302,   696,   281,   272,   771,    -1,    13,   319,   524,
     281,   272,   771,    -1,    13,    10,   777,   508,   233,   310,
     781,    -1,    13,    62,   524,   233,   310,   781,    -1,    13,
      78,   772,   233,   310,   781,    -1,    13,    96,   524,   233,
     310,   781,    -1,    13,   125,   777,   556,   233,   310,   781,
      -1,    13,   224,   575,   372,   574,   373,   233,   310,   781,
      -1,    13,   224,    49,   524,   329,   773,   233,   310,   781,
      -1,    13,   272,   771,   233,   310,   781,    -1,    13,   319,
     524,   233,   310,   781,    -1,    13,   303,   771,   233,   310,
     781,    -1,    -1,    65,   555,   270,   771,    20,   588,   222,
     593,   310,   769,   699,    95,   594,   589,    -1,   209,    -1,
     591,    -1,   372,   590,   373,    -1,   590,   376,   592,    -1,
     592,    -1,   659,    -1,   638,    -1,   649,    -1,   643,    -1,
     596,    -1,   591,    -1,    -1,   276,    -1,   327,    -1,    89,
      -1,   153,    -1,   154,    -1,    12,    -1,    -1,    98,   270,
     771,   222,   769,   425,    -1,    98,   270,   136,   110,   771,
     222,   769,   425,    -1,   210,   769,    -1,   176,   769,    -1,
     325,   769,    -1,   325,   365,    -1,     3,   600,    -1,    29,
     600,   603,    -1,   290,   312,   603,    -1,    56,   600,    -1,
     104,   600,    -1,   267,   600,    -1,   271,   783,    -1,   255,
     271,   783,    -1,   255,   783,    -1,   267,   600,   310,   271,
     783,    -1,   267,   600,   310,   783,    -1,   240,   312,   780,
      -1,    56,   241,   780,    -1,   267,   241,   780,    -1,   344,
      -1,   312,    -1,    -1,   163,   173,   408,    -1,   248,   223,
      -1,   248,   345,    -1,   601,    -1,   602,   377,   601,    -1,
     602,   601,    -1,   602,    -1,    -1,    65,   438,   337,   769,
     452,    20,   659,   605,    -1,    65,   226,   258,   438,   337,
     769,   452,    20,   659,   605,    -1,   350,   225,    -1,   348,
      47,   225,    -1,   349,    47,   225,    -1,    -1,   177,   776,
      -1,    65,    78,   772,   384,   608,    -1,   608,   609,    -1,
      -1,   303,   610,   771,    -1,   303,   610,    84,    -1,   181,
     610,   780,    -1,   181,   610,    84,    -1,   305,   610,   771,
      -1,   305,   610,    84,    -1,   102,   610,   780,    -1,   102,
     610,   779,    -1,   102,   610,    84,    -1,    59,   175,   610,
     782,    -1,   233,   610,   771,    -1,   233,   610,    84,    -1,
     359,    -1,    -1,    13,    78,   772,   384,   613,    -1,    13,
      78,   772,   281,   403,    -1,    13,    78,   772,   414,    -1,
     613,   614,    -1,    -1,    59,   175,   610,   782,    -1,    98,
      78,   772,    -1,    98,    78,   136,   110,   772,    -1,    65,
      96,   524,   618,   702,   443,    -1,    13,    96,   524,   424,
      -1,    13,    96,   524,    98,   208,   213,    -1,    13,    96,
     524,   281,   208,   213,    -1,    13,    96,   524,     7,   450,
      -1,    13,    96,   524,    98,    60,   771,   425,    -1,    20,
      -1,    -1,    65,   516,    62,   524,   118,   780,   310,   780,
     123,   524,    -1,    51,   775,   222,   769,    -1,    51,   769,
      -1,    51,    -1,   330,   625,   626,   624,    -1,   330,   625,
     626,   624,   769,    -1,   330,   625,   626,   624,   622,    -1,
     623,   624,    -1,   623,   624,   769,   627,    -1,    15,    -1,
      14,    -1,   336,    -1,    -1,   124,    -1,    -1,   122,    -1,
      -1,   372,   770,   373,    -1,    -1,   111,   630,   624,   629,
      -1,   659,    -1,   638,    -1,   649,    -1,   643,    -1,   656,
      -1,   635,    -1,   623,    -1,    -1,   240,   771,   632,    20,
     634,    -1,   372,   633,   373,    -1,    -1,   702,    -1,   633,
     377,   702,    -1,   659,    -1,   638,    -1,   649,    -1,   643,
      -1,   109,   771,   636,    -1,    65,   438,   302,   769,   466,
     461,   462,   463,    20,   109,   771,   636,    -1,   372,   738,
     373,    -1,    -1,    80,   771,    -1,    80,   240,   771,    -1,
     153,   159,   769,   639,   642,    -1,   659,    -1,   372,   640,
     373,   659,    -1,    84,   333,    -1,   641,    -1,   640,   377,
     641,    -1,   783,   760,    -1,   262,   765,    -1,    -1,    89,
     123,   697,   644,   699,   642,    -1,   329,   689,    -1,    -1,
     182,   666,   768,   646,   648,    -1,   141,   647,   188,    -1,
      -1,     5,   283,    -1,   268,   283,    -1,   268,   108,    -1,
     283,   327,   108,    -1,   283,    -1,   283,   268,   108,    -1,
     108,    -1,     5,   108,    -1,   212,    -1,    -1,   327,   697,
     281,   650,   688,   699,   642,    -1,   651,    -1,   650,   377,
     651,    -1,   652,    -1,   653,    -1,   654,   359,   762,    -1,
     372,   655,   373,   359,   764,    -1,   783,   760,    -1,   654,
      -1,   655,   377,   654,    -1,    83,   771,   657,    76,   658,
     118,   659,    -1,    -1,   657,   200,   273,    -1,   657,   273,
      -1,   657,    32,    -1,   657,   152,    -1,    -1,   341,   134,
      -1,   343,   134,    -1,   661,    -1,   660,    -1,   372,   661,
     373,    -1,   372,   660,   373,    -1,   663,    -1,   662,   670,
      -1,   662,   669,   682,   674,    -1,   662,   669,   673,   683,
      -1,   663,    -1,   660,    -1,   276,   668,   765,   664,   688,
     699,   677,   678,   679,   680,   681,    -1,   687,    -1,   662,
     322,   667,   662,    -1,   662,   157,   667,   662,    -1,   662,
     106,   667,   662,    -1,   159,   665,    -1,    -1,   306,   666,
     769,    -1,   304,   666,   769,    -1,   178,   306,   666,   769,
      -1,   178,   304,   666,   769,    -1,   126,   306,   666,   769,
      -1,   126,   304,   666,   769,    -1,   302,   769,    -1,   769,
      -1,   302,    -1,    -1,    11,    -1,    94,    -1,    -1,    94,
      -1,    94,   222,   372,   738,   373,    -1,    11,    -1,    -1,
     670,    -1,    -1,   227,    36,   671,    -1,   672,    -1,   671,
     377,   672,    -1,   726,   329,   736,    -1,   726,    21,    -1,
     726,    92,    -1,   726,    -1,   175,   675,   219,   676,    -1,
     219,   676,   175,   675,    -1,   175,   675,    -1,   219,   676,
      -1,   175,   675,   377,   676,    -1,   673,    -1,    -1,   726,
      -1,    11,    -1,   726,    -1,   130,    36,   738,    -1,    -1,
      18,   660,    -1,    -1,   192,   779,    -1,    -1,   191,   779,
      -1,    -1,   132,   726,    -1,    -1,   684,    -1,   118,   248,
     223,    -1,   682,    -1,    -1,   685,    -1,   684,   685,    -1,
     118,   327,   686,   648,    -1,   118,   283,   686,   648,    -1,
     217,   770,    -1,    -1,   333,   764,    -1,   687,   377,   764,
      -1,   123,   689,    -1,    -1,   690,    -1,   689,   377,   690,
      -1,   696,    -1,   696,   692,    -1,   698,    -1,   698,   692,
      -1,   698,    20,   372,   700,   373,    -1,   698,    20,   783,
     372,   700,   373,    -1,   698,   783,   372,   700,   373,    -1,
     660,    -1,   660,   692,    -1,   691,    -1,   372,   691,   373,
     692,    -1,   372,   691,   373,    -1,   690,    69,   164,   690,
      -1,   690,   693,   164,   690,   695,    -1,   690,   164,   690,
     695,    -1,   690,   196,   693,   164,   690,    -1,   690,   196,
     164,   690,    -1,    20,   783,   372,   770,   373,    -1,    20,
     783,    -1,   783,   372,   770,   373,    -1,   783,    -1,   124,
     694,    -1,   172,   694,    -1,   265,   694,    -1,   149,    -1,
     229,    -1,    -1,   329,   372,   770,   373,    -1,   222,   726,
      -1,   769,    -1,   769,   365,    -1,   223,   769,    -1,   223,
     372,   769,   373,    -1,   696,    -1,   696,   783,    -1,   696,
      20,   783,    -1,   729,    -1,   340,   726,    -1,   340,   730,
      -1,    -1,   701,    -1,   700,   377,   701,    -1,   783,   702,
      -1,   704,   703,    -1,   282,   704,   703,    -1,   704,    19,
     370,   779,   371,    -1,   282,   704,    19,   370,   779,   371,
      -1,   703,   370,   371,    -1,   703,   370,   779,   371,    -1,
      -1,   706,    -1,   707,    -1,   711,    -1,   715,    -1,   722,
      -1,   723,   725,    -1,   723,   372,   779,   373,   725,    -1,
     784,   525,    -1,   706,    -1,   707,    -1,   712,    -1,   716,
      -1,   722,    -1,   784,    -1,   155,    -1,   156,    -1,   287,
      -1,    31,    -1,   249,    -1,   117,   708,    -1,    97,   238,
      -1,    82,   710,    -1,    81,   710,    -1,   215,   709,    -1,
      34,    -1,   372,   779,   373,    -1,    -1,   372,   779,   377,
     779,   373,    -1,   372,   779,   373,    -1,    -1,   372,   779,
     377,   779,   373,    -1,   372,   779,   373,    -1,    -1,   713,
      -1,   714,    -1,   713,    -1,   714,    -1,    33,   720,   372,
     779,   373,    -1,    33,   720,    -1,   717,    -1,   718,    -1,
     717,    -1,   718,    -1,   719,   372,   779,   373,   721,    -1,
     719,   721,    -1,    45,   720,    -1,    44,   720,    -1,   334,
      -1,   195,    45,   720,    -1,   195,    44,   720,    -1,   197,
     720,    -1,   335,    -1,    -1,    45,   281,   783,    -1,    -1,
     309,   372,   779,   373,   724,    -1,   309,   724,    -1,   308,
     372,   779,   373,   724,    -1,   308,   724,    -1,   158,    -1,
     341,   308,   347,    -1,   343,   308,   347,    -1,    -1,   346,
      -1,   189,    -1,    79,    -1,   135,    -1,   186,    -1,   274,
      -1,   346,   310,   189,    -1,    79,   310,   135,    -1,    79,
     310,   186,    -1,    79,   310,   274,    -1,   135,   310,   186,
      -1,   135,   310,   274,    -1,   186,   310,   274,    -1,    -1,
     728,    -1,   726,   374,   702,    -1,   726,    25,   308,   347,
     726,    -1,   363,   726,    -1,   364,   726,    -1,   726,   363,
     726,    -1,   726,   364,   726,    -1,   726,   365,   726,    -1,
     726,   366,   726,    -1,   726,   367,   726,    -1,   726,   368,
     726,    -1,   726,   360,   726,    -1,   726,   361,   726,    -1,
     726,   359,   726,    -1,   726,   735,   726,    -1,   735,   726,
      -1,   726,   735,    -1,   726,    16,   726,    -1,   726,   226,
     726,    -1,   208,   726,    -1,   726,   174,   726,    -1,   726,
     174,   726,   105,   726,    -1,   726,   208,   174,   726,    -1,
     726,   208,   174,   726,   105,   726,    -1,   726,   137,   726,
      -1,   726,   137,   726,   105,   726,    -1,   726,   208,   137,
     726,    -1,   726,   208,   137,   726,   105,   726,    -1,   726,
     285,   310,   726,    -1,   726,   285,   310,   726,   105,   726,
      -1,   726,   208,   285,   310,   726,    -1,   726,   208,   285,
     310,   726,   105,   726,    -1,   726,   161,   213,    -1,   726,
     162,    -1,   726,   161,   208,   213,    -1,   726,   211,    -1,
     731,   230,   731,    -1,   726,   161,   316,    -1,   726,   161,
     208,   316,    -1,   726,   161,   114,    -1,   726,   161,   208,
     114,    -1,   726,   161,   324,    -1,   726,   161,   208,   324,
      -1,   726,   161,    94,   123,   726,    -1,   726,   161,   208,
      94,   123,   726,    -1,   726,   161,   217,   372,   740,   373,
      -1,   726,   161,   208,   217,   372,   740,   373,    -1,   726,
      30,   761,   727,    16,   727,    -1,   726,   208,    30,   761,
     727,    16,   727,    -1,   726,    30,   299,   727,    16,   727,
      -1,   726,   208,    30,   299,   727,    16,   727,    -1,   726,
     141,   751,    -1,   726,   208,   141,   751,    -1,   726,   737,
     732,   660,    -1,   726,   737,   732,   372,   726,   373,    -1,
     323,   660,    -1,   728,    -1,   727,   374,   702,    -1,   363,
     727,    -1,   364,   727,    -1,   727,   363,   727,    -1,   727,
     364,   727,    -1,   727,   365,   727,    -1,   727,   366,   727,
      -1,   727,   367,   727,    -1,   727,   368,   727,    -1,   727,
     360,   727,    -1,   727,   361,   727,    -1,   727,   359,   727,
      -1,   727,   735,   727,    -1,   735,   727,    -1,   727,   735,
      -1,   727,   161,    94,   123,   727,    -1,   727,   161,   208,
      94,   123,   727,    -1,   727,   161,   217,   372,   740,   373,
      -1,   727,   161,   208,   217,   372,   740,   373,    -1,   757,
      -1,   778,    -1,   358,   760,    -1,   372,   726,   373,   760,
      -1,   752,    -1,   729,    -1,   660,    -1,   110,   660,    -1,
      19,   660,    -1,    19,   742,    -1,   731,    -1,   777,   372,
     373,    -1,   777,   372,   738,   373,    -1,   777,   372,    11,
     738,   373,    -1,   777,   372,    94,   738,   373,    -1,   777,
     372,   365,   373,    -1,    71,    -1,    73,    -1,    73,   372,
     779,   373,    -1,    74,    -1,    74,   372,   779,   373,    -1,
     179,    -1,   179,   372,   779,   373,    -1,   180,    -1,   180,
     372,   779,   373,    -1,    72,    -1,    75,    -1,   280,    -1,
     328,    -1,    42,   372,   726,    20,   702,   373,    -1,   113,
     372,   739,   373,    -1,   231,   372,   744,   373,    -1,   237,
     372,   746,   373,    -1,   297,   372,   747,   373,    -1,   313,
     372,   726,    20,   702,   373,    -1,   315,   372,    35,   750,
     373,    -1,   315,   372,   170,   750,   373,    -1,   315,   372,
     311,   750,   373,    -1,   315,   372,   750,   373,    -1,    63,
     372,   726,   329,   524,   373,    -1,    63,   372,   738,   373,
      -1,   214,   372,   726,   377,   726,   373,    -1,    52,   372,
     738,   373,    -1,   129,   372,   738,   373,    -1,   171,   372,
     738,   373,    -1,   726,   342,   352,   217,   726,    -1,   726,
      18,   726,   193,   779,    -1,   726,    18,   726,    -1,   268,
     372,   738,   373,    -1,   268,   372,   373,    -1,   372,   738,
     377,   726,   373,    -1,    17,    -1,   288,    -1,    11,    -1,
     356,    -1,   734,    -1,   363,    -1,   364,    -1,   365,    -1,
     366,    -1,   367,    -1,   368,    -1,   360,    -1,   361,    -1,
     359,    -1,   356,    -1,   224,   372,   575,   373,    -1,   733,
      -1,   224,   372,   575,   373,    -1,   733,    -1,   224,   372,
     575,   373,    -1,   174,    -1,   208,   174,    -1,   137,    -1,
     208,   137,    -1,   726,    -1,   738,   377,   726,    -1,   743,
     123,   726,    -1,    -1,   740,   377,   702,    -1,   702,    -1,
     742,    -1,   741,   377,   742,    -1,   370,   738,   371,    -1,
     370,   741,   371,    -1,   351,    -1,   346,    -1,   189,    -1,
      79,    -1,   135,    -1,   186,    -1,   274,    -1,   353,    -1,
     726,   745,   748,   749,    -1,   726,   745,   748,    -1,   236,
     726,    -1,   727,   141,   727,    -1,    -1,   726,   748,   749,
      -1,   726,   749,   748,    -1,   726,   748,    -1,   726,   749,
      -1,   738,    -1,    -1,   123,   726,    -1,   118,   726,    -1,
     726,   123,   738,    -1,   123,   738,    -1,   738,    -1,   660,
      -1,   372,   738,   373,    -1,    41,   756,   753,   755,   104,
      -1,   754,    -1,   753,   754,    -1,   339,   726,   307,   726,
      -1,   100,   726,    -1,    -1,   726,    -1,    -1,   767,    -1,
     767,   759,    -1,   375,   774,    -1,   375,   365,    -1,   370,
     726,   371,    -1,   370,   726,   378,   726,   371,    -1,   758,
      -1,   759,   758,    -1,    -1,   760,   758,    -1,    24,    -1,
      -1,   726,    -1,    84,    -1,   762,    -1,   763,   377,   762,
      -1,   372,   763,   373,    -1,   766,    -1,   765,   377,   766,
      -1,   726,    20,   786,    -1,   726,    -1,   365,    -1,   791,
      -1,   783,    -1,   769,    -1,   768,   377,   769,    -1,   767,
      -1,   767,   759,    -1,   771,    -1,   770,   377,   771,    -1,
     783,    -1,   783,    -1,   783,    -1,   786,    -1,   783,    -1,
     780,    -1,   785,    -1,   767,   759,    -1,   779,    -1,   352,
      -1,   780,    -1,   354,    -1,   355,    -1,   705,   780,    -1,
     723,   780,   725,    -1,   723,   372,   779,   373,   780,   725,
      -1,   316,    -1,   114,    -1,   213,    -1,   357,    -1,   353,
      -1,   783,    -1,   357,    -1,   364,   357,    -1,   351,    -1,
     787,    -1,   788,    -1,   351,    -1,   787,    -1,   351,    -1,
     787,    -1,   789,    -1,   351,    -1,   787,    -1,   788,    -1,
     789,    -1,   790,    -1,     3,    -1,     4,    -1,     5,    -1,
       6,    -1,     7,    -1,     8,    -1,     9,    -1,    10,    -1,
      12,    -1,    13,    -1,    22,    -1,    23,    -1,    25,    -1,
      27,    -1,    28,    -1,    29,    -1,    36,    -1,    37,    -1,
      38,    -1,    39,    -1,    40,    -1,    43,    -1,    46,    -1,
      48,    -1,    49,    -1,    50,    -1,    51,    -1,    55,    -1,
      56,    -1,    57,    -1,    58,    -1,    59,    -1,    61,    -1,
      62,    -1,    64,    -1,    66,    -1,    67,    -1,    68,    -1,
      70,    -1,    76,    -1,    77,    -1,    78,    -1,    79,    -1,
      80,    -1,    83,    -1,    85,    -1,    87,    -1,    88,    -1,
      89,    -1,    90,    -1,    91,    -1,    93,    -1,    96,    -1,
      97,    -1,    98,    -1,    99,    -1,   101,    -1,   102,    -1,
     103,    -1,   105,    -1,   107,    -1,   108,    -1,   109,    -1,
     111,    -1,   112,    -1,   115,    -1,   116,    -1,   119,    -1,
     121,    -1,   125,    -1,   126,    -1,   128,    -1,   131,    -1,
     133,    -1,   134,    -1,   135,    -1,   136,    -1,   138,    -1,
     139,    -1,   140,    -1,   142,    -1,   143,    -1,   144,    -1,
     145,    -1,   146,    -1,   147,    -1,   151,    -1,   152,    -1,
     153,    -1,   154,    -1,   160,    -1,   163,    -1,   165,    -1,
     166,    -1,   167,    -1,   168,    -1,   169,    -1,   173,    -1,
     176,    -1,   177,    -1,   178,    -1,   181,    -1,   182,    -1,
     183,    -1,   184,    -1,   185,    -1,   186,    -1,   187,    -1,
     188,    -1,   189,    -1,   190,    -1,   194,    -1,   199,    -1,
     200,    -1,   201,    -1,   202,    -1,   203,    -1,   204,    -1,
     205,    -1,   207,    -1,   209,    -1,   210,    -1,   212,    -1,
     216,    -1,   217,    -1,   220,    -1,   224,    -1,   225,    -1,
     232,    -1,   233,    -1,   234,    -1,   235,    -1,   240,    -1,
     241,    -1,   239,    -1,   243,    -1,   244,    -1,   245,    -1,
     246,    -1,   247,    -1,   248,    -1,   250,    -1,   251,    -1,
     253,    -1,   254,    -1,   255,    -1,   256,    -1,   257,    -1,
     258,    -1,   259,    -1,   260,    -1,   261,    -1,   263,    -1,
     264,    -1,   266,    -1,   267,    -1,   269,    -1,   270,    -1,
     271,    -1,   272,    -1,   273,    -1,   274,    -1,   275,    -1,
     277,    -1,   278,    -1,   279,    -1,   281,    -1,   283,    -1,
     284,    -1,   286,    -1,   289,    -1,   290,    -1,   291,    -1,
     292,    -1,   293,    -1,   294,    -1,   295,    -1,   298,    -1,
     300,    -1,   301,    -1,   296,    -1,   303,    -1,   304,    -1,
     305,    -1,   306,    -1,   312,    -1,   314,    -1,   317,    -1,
     318,    -1,   319,    -1,   320,    -1,   321,    -1,   324,    -1,
     325,    -1,   326,    -1,   327,    -1,   330,    -1,   331,    -1,
     332,    -1,   335,    -1,   337,    -1,   338,    -1,   341,    -1,
     343,    -1,   344,    -1,   345,    -1,   346,    -1,   347,    -1,
      31,    -1,    33,    -1,    34,    -1,    44,    -1,    45,    -1,
      52,    -1,    63,    -1,    81,    -1,    82,    -1,   110,    -1,
     113,    -1,   117,    -1,   129,    -1,   150,    -1,   155,    -1,
     156,    -1,   158,    -1,   171,    -1,   195,    -1,   197,    -1,
     206,    -1,   214,    -1,   215,    -1,   228,    -1,   231,    -1,
     237,    -1,   238,    -1,   249,    -1,   268,    -1,   282,    -1,
     287,    -1,   297,    -1,   308,    -1,   309,    -1,   313,    -1,
     315,    -1,   333,    -1,   334,    -1,    26,    -1,    30,    -1,
      32,    -1,    69,    -1,   122,    -1,   124,    -1,   137,    -1,
     149,    -1,   161,    -1,   162,    -1,   164,    -1,   172,    -1,
     174,    -1,   196,    -1,   211,    -1,   229,    -1,   230,    -1,
     265,    -1,   285,    -1,   336,    -1,    11,    -1,    14,    -1,
      15,    -1,    16,    -1,    17,    -1,    19,    -1,    20,    -1,
      21,    -1,    24,    -1,    35,    -1,    41,    -1,    42,    -1,
      47,    -1,    53,    -1,    54,    -1,    60,    -1,    65,    -1,
      71,    -1,    72,    -1,    73,    -1,    74,    -1,    75,    -1,
      84,    -1,    86,    -1,    92,    -1,    94,    -1,    95,    -1,
     100,    -1,   104,    -1,   106,    -1,   114,    -1,   118,    -1,
     120,    -1,   123,    -1,   127,    -1,   130,    -1,   132,    -1,
     141,    -1,   148,    -1,   157,    -1,   159,    -1,   170,    -1,
     175,    -1,   179,    -1,   180,    -1,   198,    -1,   208,    -1,
     213,    -1,   218,    -1,   219,    -1,   221,    -1,   222,    -1,
     223,    -1,   226,    -1,   227,    -1,   236,    -1,   242,    -1,
     252,    -1,   262,    -1,   276,    -1,   280,    -1,   288,    -1,
     299,    -1,   302,    -1,   307,    -1,   310,    -1,   311,    -1,
     316,    -1,   322,    -1,   323,    -1,   328,    -1,   329,    -1,
     339,    -1,   340,    -1,   221,    -1,   198,    -1
};

/* YYRLINE[YYN] -- source line where rule number YYN was defined.  */
static const yytype_uint16 yyrline[] =
{
       0,   510,   510,   514,   520,   529,   530,   531,   532,   533,
     534,   535,   536,   537,   538,   539,   540,   541,   542,   543,
     544,   545,   546,   547,   548,   549,   550,   551,   552,   553,
     554,   555,   556,   557,   558,   559,   560,   561,   562,   563,
     564,   565,   566,   567,   568,   569,   570,   571,   572,   573,
     574,   575,   576,   577,   578,   579,   580,   581,   582,   583,
     584,   585,   586,   587,   588,   589,   590,   591,   592,   593,
     594,   595,   596,   597,   598,   599,   600,   601,   602,   603,
     604,   605,   606,   607,   608,   609,   610,   611,   612,   613,
     615,   625,   636,   637,   646,   647,   651,   656,   660,   665,
     670,   674,   678,   682,   686,   690,   694,   698,   702,   707,
     711,   715,   719,   723,   728,   733,   737,   741,   745,   749,
     763,   781,   792,   800,   818,   830,   838,   859,   866,   885,
     892,   909,   927,   938,   939,   951,   958,   975,   987,   999,
    1000,  1004,  1005,  1013,  1014,  1015,  1016,  1017,  1018,  1032,
    1038,  1044,  1052,  1059,  1066,  1074,  1081,  1088,  1096,  1103,
    1110,  1120,  1121,  1133,  1134,  1137,  1138,  1141,  1143,  1145,
    1149,  1150,  1151,  1152,  1156,  1157,  1158,  1159,  1171,  1175,
    1179,  1192,  1219,  1220,  1221,  1225,  1226,  1227,  1231,  1232,
    1237,  1243,  1249,  1255,  1261,  1270,  1276,  1282,  1288,  1294,
    1304,  1314,  1315,  1319,  1320,  1328,  1343,  1351,  1362,  1363,
    1369,  1377,  1386,  1394,  1402,  1411,  1420,  1432,  1442,  1450,
    1459,  1466,  1474,  1482,  1490,  1497,  1504,  1512,  1519,  1526,
    1534,  1541,  1548,  1549,  1555,  1563,  1571,  1579,  1589,  1597,
    1601,  1602,  1603,  1607,  1608,  1621,  1644,  1666,  1681,  1682,
    1691,  1692,  1693,  1699,  1700,  1705,  1709,  1713,  1717,  1721,
    1725,  1729,  1733,  1737,  1741,  1750,  1754,  1758,  1762,  1767,
    1771,  1775,  1776,  1787,  1801,  1827,  1828,  1829,  1830,  1831,
    1832,  1833,  1837,  1838,  1842,  1846,  1853,  1854,  1855,  1858,
    1870,  1871,  1875,  1896,  1897,  1916,  1927,  1938,  1950,  1962,
    1973,  1992,  2020,  2026,  2032,  2038,  2056,  2066,  2067,  2071,
    2072,  2073,  2074,  2075,  2076,  2085,  2106,  2110,  2120,  2132,
    2144,  2162,  2163,  2167,  2168,  2171,  2177,  2181,  2188,  2193,
    2205,  2207,  2209,  2211,  2214,  2217,  2220,  2224,  2225,  2226,
    2227,  2228,  2231,  2232,  2237,  2238,  2239,  2240,  2243,  2244,
    2245,  2246,  2249,  2250,  2253,  2254,  2264,  2290,  2291,  2295,
    2296,  2300,  2325,  2336,  2345,  2346,  2349,  2353,  2357,  2361,
    2365,  2369,  2373,  2377,  2381,  2385,  2389,  2395,  2396,  2400,
    2401,  2404,  2405,  2412,  2424,  2434,  2448,  2449,  2457,  2458,
    2462,  2463,  2467,  2468,  2472,  2480,  2491,  2492,  2502,  2512,
    2513,  2526,  2533,  2551,  2569,  2593,  2594,  2598,  2604,  2610,
    2619,  2620,  2621,  2625,  2630,  2640,  2641,  2645,  2646,  2650,
    2651,  2652,  2656,  2662,  2663,  2664,  2665,  2666,  2670,  2671,
    2675,  2677,  2685,  2692,  2701,  2705,  2706,  2710,  2711,  2716,
    2726,  2748,  2767,  2790,  2800,  2811,  2821,  2831,  2842,  2878,
    2881,  2882,  2885,  2889,  2896,  2897,  2898,  2899,  2900,  2901,
    2904,  2905,  2909,  2910,  2913,  2916,  2917,  2920,  2936,  2950,
    2951,  2955,  2965,  2975,  2984,  2993,  2994,  2997,  2998,  3003,
    3012,  3032,  3042,  3060,  3069,  3081,  3082,  3083,  3084,  3085,
    3086,  3087,  3088,  3092,  3093,  3096,  3097,  3100,  3102,  3115,
    3143,  3152,  3161,  3170,  3180,  3189,  3198,  3208,  3217,  3226,
    3235,  3244,  3256,  3257,  3258,  3259,  3260,  3261,  3262,  3263,
    3264,  3265,  3266,  3267,  3271,  3272,  3282,  3289,  3298,  3305,
    3318,  3324,  3331,  3338,  3345,  3352,  3359,  3366,  3373,  3380,
    3387,  3394,  3401,  3408,  3415,  3424,  3425,  3435,  3450,  3463,
    3489,  3491,  3493,  3497,  3499,  3503,  3504,  3505,  3506,  3514,
    3521,  3528,  3535,  3542,  3549,  3556,  3563,  3574,  3575,  3578,
    3588,  3602,  3603,  3607,  3608,  3613,  3629,  3642,  3652,  3664,
    3665,  3668,  3669,  3684,  3700,  3719,  3720,  3724,  3725,  3728,
    3729,  3737,  3744,  3751,  3760,  3761,  3762,  3777,  3789,  3804,
    3805,  3808,  3809,  3813,  3814,  3828,  3836,  3844,  3852,  3860,
    3871,  3872,  3873,  3874,  3880,  3884,  3898,  3899,  3907,  3921,
    3922,  3929,  3933,  3937,  3941,  3945,  3949,  3953,  3957,  3961,
    3965,  3972,  3976,  3980,  3986,  3987,  3994,  3995,  4007,  4018,
    4019,  4024,  4025,  4040,  4050,  4063,  4073,  4086,  4096,  4109,
    4116,  4118,  4120,  4125,  4127,  4138,  4148,  4160,  4161,  4162,
    4166,  4177,  4178,  4192,  4200,  4210,  4223,  4224,  4227,  4228,
    4238,  4247,  4255,  4263,  4272,  4280,  4288,  4297,  4305,  4314,
    4323,  4332,  4341,  4349,  4357,  4367,  4368,  4378,  4387,  4395,
    4404,  4412,  4420,  4436,  4445,  4453,  4461,  4469,  4478,  4487,
    4496,  4504,  4512,  4530,  4529,  4548,  4549,  4550,  4555,  4561,
    4570,  4571,  4572,  4573,  4574,  4578,  4579,  4582,  4583,  4584,
    4585,  4589,  4590,  4591,  4596,  4606,  4627,  4635,  4644,  4650,
    4671,  4678,  4685,  4692,  4699,  4706,  4713,  4721,  4729,  4737,
    4745,  4753,  4760,  4767,  4776,  4777,  4778,  4782,  4785,  4788,
    4795,  4797,  4799,  4804,  4806,  4818,  4829,  4847,  4853,  4859,
    4865,  4875,  4891,  4901,  4902,  4906,  4910,  4914,  4918,  4922,
    4926,  4930,  4934,  4938,  4942,  4946,  4950,  4960,  4961,  4972,
    4982,  4990,  5002,  5003,  5007,  5021,  5028,  5045,  5057,  5066,
    5074,  5082,  5091,  5102,  5103,  5117,  5140,  5147,  5154,  5171,
    5183,  5195,  5207,  5219,  5234,  5235,  5239,  5240,  5243,  5244,
    5247,  5248,  5252,  5253,  5264,  5275,  5276,  5277,  5278,  5279,
    5280,  5284,  5285,  5295,  5305,  5306,  5309,  5310,  5315,  5316,
    5317,  5318,  5328,  5336,  5357,  5358,  5368,  5374,  5390,  5399,
    5405,  5411,  5420,  5422,  5427,  5438,  5439,  5450,  5463,  5464,
    5467,  5478,  5479,  5482,  5483,  5484,  5485,  5486,  5487,  5488,
    5489,  5492,  5493,  5504,  5521,  5522,  5526,  5527,  5531,  5539,
    5566,  5577,  5578,  5588,  5600,  5601,  5602,  5603,  5604,  5607,
    5608,  5609,  5657,  5658,  5662,  5663,  5673,  5674,  5680,  5686,
    5695,  5696,  5741,  5765,  5766,  5770,  5774,  5781,  5782,  5790,
    5795,  5800,  5805,  5810,  5815,  5820,  5825,  5832,  5833,  5836,
    5837,  5838,  5845,  5846,  5847,  5848,  5852,  5853,  5857,  5861,
    5862,  5865,  5872,  5879,  5886,  5897,  5899,  5901,  5903,  5905,
    5916,  5918,  5922,  5923,  5933,  5937,  5938,  5943,  5944,  5949,
    5950,  5955,  5956,  5961,  5962,  5966,  5967,  5971,  5972,  5976,
    5977,  5981,  5989,  6000,  6001,  6006,  6012,  6030,  6031,  6035,
    6036,  6046,  6050,  6055,  6062,  6070,  6077,  6087,  6097,  6123,
    6130,  6134,  6160,  6164,  6176,  6189,  6203,  6214,  6229,  6235,
    6240,  6246,  6253,  6254,  6255,  6256,  6260,  6261,  6273,  6274,
    6279,  6286,  6293,  6300,  6319,  6323,  6330,  6340,  6345,  6347,
    6349,  6354,  6358,  6364,  6385,  6390,  6396,  6402,  6412,  6414,
    6417,  6429,  6430,  6431,  6432,  6433,  6434,  6440,  6458,  6477,
    6478,  6479,  6480,  6481,  6485,  6497,  6501,  6505,  6509,  6513,
    6517,  6521,  6525,  6530,  6535,  6540,  6546,  6562,  6568,  6583,
    6594,  6601,  6616,  6627,  6638,  6642,  6650,  6654,  6662,  6683,
    6704,  6708,  6714,  6718,  6731,  6766,  6789,  6791,  6793,  6795,
    6797,  6799,  6804,  6805,  6809,  6810,  6814,  6840,  6851,  6873,
    6883,  6887,  6888,  6889,  6893,  6894,  6895,  6896,  6897,  6898,
    6899,  6901,  6903,  6906,  6909,  6911,  6914,  6916,  6942,  6943,
    6945,  6964,  6966,  6968,  6970,  6972,  6974,  6976,  6978,  6980,
    6982,  6984,  6987,  6989,  6991,  6994,  6996,  6998,  7001,  7003,
    7013,  7015,  7025,  7027,  7037,  7039,  7050,  7062,  7072,  7084,
    7104,  7111,  7118,  7125,  7132,  7136,  7143,  7150,  7157,  7164,
    7171,  7178,  7182,  7190,  7194,  7198,  7205,  7212,  7225,  7238,
    7256,  7276,  7285,  7292,  7318,  7320,  7322,  7324,  7326,  7328,
    7330,  7332,  7334,  7336,  7338,  7340,  7342,  7344,  7346,  7348,
    7350,  7354,  7359,  7363,  7377,  7378,  7379,  7393,  7405,  7407,
    7409,  7418,  7427,  7436,  7438,  7455,  7465,  7475,  7489,  7499,
    7519,  7547,  7564,  7594,  7608,  7639,  7656,  7686,  7703,  7734,
    7744,  7754,  7764,  7774,  7776,  7786,  7801,  7812,  7825,  7844,
    7857,  7867,  7877,  7887,  7902,  7912,  7916,  7922,  7929,  7940,
    7942,  7944,  7959,  7960,  7961,  7964,  7965,  7966,  7969,  7970,
    7973,  7974,  7975,  7976,  7977,  7978,  7979,  7980,  7981,  7984,
    7986,  7991,  7993,  7998,  8000,  8002,  8004,  8006,  8008,  8020,
    8024,  8031,  8038,  8041,  8045,  8051,  8053,  8057,  8063,  8076,
    8077,  8078,  8079,  8080,  8081,  8082,  8083,  8092,  8096,  8103,
    8110,  8111,  8127,  8131,  8136,  8140,  8155,  8160,  8164,  8167,
    8170,  8171,  8172,  8175,  8182,  8192,  8205,  8206,  8210,  8220,
    8221,  8224,  8225,  8233,  8237,  8244,  8248,  8252,  8259,  8269,
    8270,  8274,  8275,  8278,  8279,  8290,  8291,  8295,  8296,  8304,
    8315,  8316,  8320,  8328,  8336,  8358,  8359,  8363,  8364,  8375,
    8382,  8408,  8410,  8415,  8418,  8421,  8423,  8425,  8427,  8437,
    8439,  8447,  8454,  8461,  8468,  8475,  8487,  8495,  8506,  8529,
    8533,  8537,  8545,  8546,  8547,  8549,  8550,  8566,  8567,  8568,
    8573,  8574,  8580,  8581,  8582,  8588,  8589,  8590,  8591,  8592,
    8608,  8609,  8610,  8611,  8612,  8613,  8614,  8615,  8616,  8617,
    8618,  8619,  8620,  8621,  8622,  8623,  8624,  8625,  8626,  8627,
    8628,  8629,  8630,  8631,  8632,  8633,  8634,  8635,  8636,  8637,
    8638,  8639,  8640,  8641,  8642,  8643,  8644,  8645,  8646,  8647,
    8648,  8649,  8650,  8651,  8652,  8653,  8654,  8655,  8656,  8657,
    8658,  8659,  8660,  8661,  8662,  8663,  8664,  8665,  8666,  8667,
    8668,  8669,  8670,  8671,  8672,  8673,  8674,  8675,  8676,  8677,
    8678,  8679,  8680,  8681,  8682,  8683,  8684,  8685,  8686,  8687,
    8688,  8689,  8690,  8691,  8692,  8693,  8694,  8695,  8696,  8697,
    8698,  8699,  8700,  8701,  8702,  8703,  8704,  8705,  8706,  8707,
    8708,  8709,  8710,  8711,  8712,  8713,  8714,  8715,  8716,  8717,
    8718,  8719,  8720,  8721,  8722,  8723,  8724,  8725,  8726,  8727,
    8728,  8729,  8730,  8731,  8732,  8733,  8734,  8735,  8736,  8737,
    8738,  8739,  8740,  8741,  8742,  8743,  8744,  8745,  8746,  8747,
    8748,  8749,  8750,  8751,  8752,  8753,  8754,  8755,  8756,  8757,
    8758,  8759,  8760,  8761,  8762,  8763,  8764,  8765,  8766,  8767,
    8768,  8769,  8770,  8771,  8772,  8773,  8774,  8775,  8776,  8777,
    8778,  8779,  8780,  8781,  8782,  8783,  8784,  8785,  8786,  8787,
    8788,  8789,  8790,  8791,  8792,  8793,  8794,  8795,  8796,  8797,
    8798,  8799,  8800,  8801,  8802,  8803,  8804,  8805,  8806,  8807,
    8808,  8809,  8810,  8811,  8812,  8813,  8814,  8815,  8829,  8830,
    8831,  8832,  8833,  8834,  8835,  8836,  8837,  8838,  8839,  8840,
    8841,  8842,  8843,  8844,  8845,  8846,  8847,  8848,  8849,  8850,
    8851,  8852,  8853,  8854,  8855,  8856,  8857,  8858,  8859,  8860,
    8861,  8862,  8863,  8864,  8865,  8866,  8880,  8881,  8882,  8883,
    8884,  8885,  8886,  8887,  8888,  8889,  8890,  8891,  8892,  8893,
    8894,  8895,  8896,  8897,  8898,  8899,  8909,  8910,  8911,  8912,
    8913,  8914,  8915,  8916,  8917,  8918,  8919,  8920,  8921,  8922,
    8923,  8924,  8925,  8926,  8927,  8928,  8929,  8930,  8931,  8932,
    8933,  8934,  8935,  8936,  8937,  8938,  8939,  8940,  8941,  8942,
    8943,  8944,  8945,  8946,  8947,  8948,  8949,  8950,  8951,  8952,
    8953,  8954,  8955,  8956,  8957,  8958,  8959,  8960,  8961,  8962,
    8963,  8964,  8965,  8966,  8967,  8968,  8969,  8970,  8971,  8972,
    8973,  8974,  8975,  8976,  8977,  8978,  8979,  8980,  8981,  8982,
    8987,  8996
};
#endif

#if YYDEBUG || YYERROR_VERBOSE || YYTOKEN_TABLE
/* YYTNAME[SYMBOL-NUM] -- String name of the symbol SYMBOL-NUM.
   First, the terminals, then, starting at YYNTOKENS, nonterminals.  */
static const char *const yytname[] =
{
  "$end", "error", "$undefined", "ABORT_P", "ABSOLUTE_P", "ACCESS",
  "ACTION", "ADD_P", "ADMIN", "AFTER", "AGGREGATE", "ALL", "ALSO", "ALTER",
  "ANALYSE", "ANALYZE", "AND", "ANY", "AROUND", "ARRAY", "AS", "ASC",
  "ASSERTION", "ASSIGNMENT", "ASYMMETRIC", "AT", "AUTHORIZATION",
  "BACKWARD", "BEFORE", "BEGIN_P", "BETWEEN", "BIGINT", "BINARY", "BIT",
  "BOOLEAN_P", "BOTH", "BY", "CACHE", "CALLED", "CASCADE", "CASCADED",
  "CASE", "CAST", "CHAIN", "CHAR_P", "CHARACTER", "CHARACTERISTICS",
  "CHECK", "CHECKPOINT", "CLASS", "CLOSE", "CLUSTER", "COALESCE",
  "COLLATE", "COLUMN", "COMMENT", "COMMIT", "COMMITTED", "CONCURRENTLY",
  "CONNECTION", "CONSTRAINT", "CONSTRAINTS", "CONVERSION_P", "CONVERT",
  "COPY", "CREATE", "CREATEDB", "CREATEROLE", "CREATEUSER", "CROSS", "CSV",
  "CURRENT_DATE", "CURRENT_ROLE", "CURRENT_TIME", "CURRENT_TIMESTAMP",
  "CURRENT_USER", "CURSOR", "CYCLE", "DATABASE", "DAY_P", "DEALLOCATE",
  "DEC", "DECIMAL_P", "DECLARE", "DEFAULT", "DEFAULTS", "DEFERRABLE",
  "DEFERRED", "DEFINER", "DELETE_P", "DELIMITER", "DELIMITERS", "DESC",
  "DISABLE_P", "DISTINCT", "DO", "DOMAIN_P", "DOUBLE_P", "DROP", "EACH",
  "ELSE", "ENABLE_P", "ENCODING", "ENCRYPTED", "END_P", "ESCAPE", "EXCEPT",
  "EXCLUDING", "EXCLUSIVE", "EXECUTE", "EXISTS", "EXPLAIN", "EXTERNAL",
  "EXTRACT", "FALSE_P", "FETCH", "FIRST_P", "FLOAT_P", "FOR", "FORCE",
  "FOREIGN", "FORWARD", "FREEZE", "FROM", "FULL", "FUNCTION", "GLOBAL",
  "GRANT", "GRANTED", "GREATEST", "GROUP_P", "HANDLER", "HAVING",
  "HEADER_P", "HOLD", "HOUR_P", "IF_P", "ILIKE", "IMMEDIATE", "IMMUTABLE",
  "IMPLICIT_P", "IN_P", "INCLUDING", "INCREMENT", "INDEX", "INDEXES",
  "INHERIT", "INHERITS", "INITIALLY", "INNER_P", "INOUT", "INPUT_P",
  "INSENSITIVE", "INSERT", "INSTEAD", "INT_P", "INTEGER", "INTERSECT",
  "INTERVAL", "INTO", "INVOKER", "IS", "ISNULL", "ISOLATION", "JOIN",
  "KEY", "LANCOMPILER", "LANGUAGE", "LARGE_P", "LAST_P", "LEADING",
  "LEAST", "LEFT", "LEVEL", "LIKE", "LIMIT", "LISTEN", "LOAD", "LOCAL",
  "LOCALTIME", "LOCALTIMESTAMP", "LOCATION", "LOCK_P", "LOGIN_P", "MATCH",
  "MAXVALUE", "MINUTE_P", "MINVALUE", "MODE", "MONTH_P", "MOVE",
  "MAXELEMSEP", "MAXGROUPDIAM", "MAXJOINDIAM", "NAMES", "NATIONAL",
  "NATURAL", "NCHAR", "NEW", "NEXT", "NO", "NOCREATEDB", "NOCREATEROLE",
  "NOCREATEUSER", "NOINHERIT", "NOLOGIN_P", "NONE", "NOSUPERUSER", "NOT",
  "NOTHING", "NOTIFY", "NOTNULL", "NOWAIT", "NULL_P", "NULLIF", "NUMERIC",
  "OBJECT_P", "OF", "OFF", "OFFSET", "OIDS", "OLD", "ON", "ONLY",
  "OPERATOR", "OPTION", "OR", "ORDER", "OUT_P", "OUTER_P", "OVERLAPS",
  "OVERLAY", "OWNED", "OWNER", "PARTIAL", "PASSWORD", "PLACING",
  "POSITION", "PRECISION", "PRESERVE", "PREPARE", "PREPARED", "PRIMARY",
  "PRIOR", "PRIVILEGES", "PROCEDURAL", "PROCEDURE", "QUOTE", "READ",
  "REAL", "REASSIGN", "RECHECK", "REFERENCES", "REINDEX", "RELATIVE_P",
  "RELEASE", "RENAME", "REPEATABLE", "REPLACE", "RESET", "RESTART",
  "RESTRICT", "RETURNING", "RETURNS", "REVOKE", "RIGHT", "ROLE",
  "ROLLBACK", "ROW", "ROWS", "RULE", "SAVEPOINT", "SCHEMA", "SCROLL",
  "SECOND_P", "SECURITY", "SELECT", "SEQUENCE", "SERIALIZABLE", "SESSION",
  "SESSION_USER", "SET", "SETOF", "SHARE", "SHOW", "SIMILAR", "SIMPLE",
  "SMALLINT", "SOME", "STABLE", "START", "STATEMENT", "STATISTICS",
  "STDIN", "STDOUT", "STORAGE", "STRICT_P", "SUBSTRING", "SUPERUSER_P",
  "SYMMETRIC", "SYSID", "SYSTEM_P", "TABLE", "TABLESPACE", "TEMP",
  "TEMPLATE", "TEMPORARY", "THEN", "TIME", "TIMESTAMP", "TO", "TRAILING",
  "TRANSACTION", "TREAT", "TRIGGER", "TRIM", "TRUE_P", "TRUNCATE",
  "TRUSTED", "TYPE_P", "UNCOMMITTED", "UNENCRYPTED", "UNION", "UNIQUE",
  "UNKNOWN", "UNLISTEN", "UNTIL", "UPDATE", "USER", "USING", "VACUUM",
  "VALID", "VALIDATOR", "VALUES", "VARCHAR", "VARYING", "VERBOSE", "VIEW",
  "VOLATILE", "WHEN", "WHERE", "WITH", "WITHIN", "WITHOUT", "WORK",
  "WRITE", "YEAR_P", "ZONE", "WITH_CASCADED", "WITH_LOCAL", "WITH_CHECK",
  "IDENT", "FCONST", "SCONST", "BCONST", "XCONST", "Op", "ICONST", "PARAM",
  "'='", "'<'", "'>'", "POSTFIXOP", "'+'", "'-'", "'*'", "'/'", "'%'",
  "'^'", "UMINUS", "'['", "']'", "'('", "')'", "TYPECAST", "'.'", "';'",
  "','", "':'", "$accept", "stmtblock", "stmtmulti", "stmt",
  "CreateRoleStmt", "opt_with", "OptRoleList", "OptRoleElem",
  "CreateUserStmt", "AlterRoleStmt", "AlterRoleSetStmt", "AlterUserStmt",
  "AlterUserSetStmt", "DropRoleStmt", "DropUserStmt", "CreateGroupStmt",
  "AlterGroupStmt", "add_drop", "DropGroupStmt", "CreateSchemaStmt",
  "OptSchemaName", "OptSchemaEltList", "schema_stmt", "VariableSetStmt",
  "set_rest", "var_name", "var_list_or_default", "var_list", "var_value",
  "iso_level", "opt_boolean", "zone_value", "opt_encoding",
  "ColId_or_Sconst", "VariableShowStmt", "VariableResetStmt",
  "ConstraintsSetStmt", "constraints_set_list", "constraints_set_mode",
  "CheckPointStmt", "AlterTableStmt", "alter_table_cmds",
  "alter_table_cmd", "alter_rel_cmds", "alter_rel_cmd",
  "alter_column_default", "opt_drop_behavior", "alter_using",
  "ClosePortalStmt", "CopyStmt", "copy_from", "copy_file_name",
  "copy_opt_list", "copy_opt_item", "opt_binary", "opt_oids",
  "copy_delimiter", "opt_using", "CreateStmt", "OptTemp",
  "OptTableElementList", "TableElementList", "TableElement", "columnDef",
  "ColQualList", "ColConstraint", "ColConstraintElem", "ConstraintAttr",
  "TableLikeClause", "TableLikeOptionList", "TableLikeOption",
  "TableConstraint", "ConstraintElem", "opt_column_list", "columnList",
  "columnElem", "key_match", "key_actions", "key_update", "key_delete",
  "key_action", "OptInherit", "OptWith", "OnCommitOption", "OptTableSpace",
  "OptConsTableSpace", "CreateAsStmt", "OptCreateAs", "CreateAsList",
  "CreateAsElement", "CreateSeqStmt", "AlterSeqStmt", "OptSeqList",
  "OptSeqElem", "opt_by", "NumericOnly", "FloatOnly", "IntegerOnly",
  "CreatePLangStmt", "opt_trusted", "handler_name", "opt_validator",
  "opt_lancompiler", "DropPLangStmt", "opt_procedural",
  "CreateTableSpaceStmt", "OptTableSpaceOwner", "DropTableSpaceStmt",
  "CreateTrigStmt", "TriggerActionTime", "TriggerEvents",
  "TriggerOneEvent", "TriggerForSpec", "TriggerForOpt", "TriggerForType",
  "TriggerFuncArgs", "TriggerFuncArg", "OptConstrFromTable",
  "ConstraintAttributeSpec", "ConstraintDeferrabilitySpec",
  "ConstraintTimeSpec", "DropTrigStmt", "CreateAssertStmt",
  "DropAssertStmt", "DefineStmt", "definition", "def_list", "def_elem",
  "def_arg", "aggr_args", "aggr_args_list", "old_aggr_definition",
  "old_aggr_list", "old_aggr_elem", "CreateOpClassStmt",
  "opclass_item_list", "opclass_item", "opt_default", "opt_recheck",
  "DropOpClassStmt", "DropOwnedStmt", "ReassignOwnedStmt", "DropStmt",
  "drop_type", "any_name_list", "any_name", "attrs", "TruncateStmt",
  "CommentStmt", "comment_type", "comment_text", "FetchStmt",
  "fetch_direction", "from_in", "GrantStmt", "RevokeStmt", "privileges",
  "privilege_list", "privilege", "privilege_target", "grantee_list",
  "grantee", "opt_grant_grant_option", "function_with_argtypes_list",
  "function_with_argtypes", "GrantRoleStmt", "RevokeRoleStmt",
  "opt_grant_admin_option", "opt_granted_by", "IndexStmt",
  "index_opt_unique", "access_method_clause", "index_params", "index_elem",
  "opt_class", "CreateFunctionStmt", "opt_or_replace", "func_args",
  "func_args_list", "func_arg", "arg_class", "param_name", "func_return",
  "func_type", "createfunc_opt_list", "common_func_opt_item",
  "createfunc_opt_item", "func_as", "opt_definition", "AlterFunctionStmt",
  "alterfunc_opt_list", "opt_restrict", "RemoveFuncStmt", "RemoveAggrStmt",
  "RemoveOperStmt", "oper_argtypes", "any_operator", "CreateCastStmt",
  "cast_context", "DropCastStmt", "opt_if_exists", "ReindexStmt",
  "reindex_type", "opt_force", "RenameStmt", "opt_column",
  "AlterObjectSchemaStmt", "AlterOwnerStmt", "RuleStmt", "$@1",
  "RuleActionList", "RuleActionMulti", "RuleActionStmt",
  "RuleActionStmtOrEmpty", "event", "opt_instead", "DropRuleStmt",
  "NotifyStmt", "ListenStmt", "UnlistenStmt", "TransactionStmt",
  "opt_transaction", "transaction_mode_item", "transaction_mode_list",
  "transaction_mode_list_or_empty", "ViewStmt", "opt_check_option",
  "LoadStmt", "CreatedbStmt", "createdb_opt_list", "createdb_opt_item",
  "opt_equal", "AlterDatabaseStmt", "AlterDatabaseSetStmt",
  "alterdb_opt_list", "alterdb_opt_item", "DropdbStmt", "CreateDomainStmt",
  "AlterDomainStmt", "opt_as", "CreateConversionStmt", "ClusterStmt",
  "VacuumStmt", "AnalyzeStmt", "analyze_keyword", "opt_verbose",
  "opt_full", "opt_freeze", "opt_name_list", "ExplainStmt",
  "ExplainableStmt", "opt_analyze", "PrepareStmt", "prep_type_clause",
  "prep_type_list", "PreparableStmt", "ExecuteStmt",
  "execute_param_clause", "DeallocateStmt", "InsertStmt", "insert_rest",
  "insert_column_list", "insert_column_item", "returning_clause",
  "DeleteStmt", "using_clause", "LockStmt", "opt_lock", "lock_type",
  "opt_nowait", "UpdateStmt", "set_clause_list", "set_clause",
  "single_set_clause", "multiple_set_clause", "set_target",
  "set_target_list", "DeclareCursorStmt", "cursor_options", "opt_hold",
  "SelectStmt", "select_with_parens", "select_no_parens", "select_clause",
  "simple_select", "into_clause", "OptTempTableName", "opt_table",
  "opt_all", "opt_distinct", "opt_sort_clause", "sort_clause",
  "sortby_list", "sortby", "select_limit", "opt_select_limit",
  "select_limit_value", "select_offset_value", "group_clause",
  "sgb_aroundSelectStmt_clause", "sgb_MaxGroupDiam_clause",
  "sgb_MaxElemSep_clause", "having_clause", "for_locking_clause",
  "opt_for_locking_clause", "for_locking_items", "for_locking_item",
  "locked_rels_list", "values_clause", "from_clause", "from_list",
  "table_ref", "joined_table", "alias_clause", "join_type", "join_outer",
  "join_qual", "relation_expr", "relation_expr_opt_alias", "func_table",
  "where_clause", "TableFuncElementList", "TableFuncElement", "Typename",
  "opt_array_bounds", "SimpleTypename", "ConstTypename", "GenericType",
  "Numeric", "opt_float", "opt_numeric", "opt_decimal", "Bit", "ConstBit",
  "BitWithLength", "BitWithoutLength", "Character", "ConstCharacter",
  "CharacterWithLength", "CharacterWithoutLength", "character",
  "opt_varying", "opt_charset", "ConstDatetime", "ConstInterval",
  "opt_timezone", "opt_interval", "a_expr", "b_expr", "c_expr",
  "func_expr", "sj_expr", "row", "sub_type", "all_Op", "MathOp", "qual_Op",
  "qual_all_Op", "subquery_Op", "expr_list", "extract_list", "type_list",
  "array_expr_list", "array_expr", "extract_arg", "overlay_list",
  "overlay_placing", "position_list", "substr_list", "substr_from",
  "substr_for", "trim_list", "in_expr", "case_expr", "when_clause_list",
  "when_clause", "case_default", "case_arg", "columnref", "indirection_el",
  "indirection", "opt_indirection", "opt_asymmetric", "ctext_expr",
  "ctext_expr_list", "ctext_row", "target_list", "target_el",
  "relation_name", "qualified_name_list", "qualified_name", "name_list",
  "name", "database_name", "access_method", "attr_name", "index_name",
  "file_name", "func_name", "AexprConst", "Iconst", "Sconst", "RoleId",
  "SignedIconst", "ColId", "type_name", "function_name", "ColLabel",
  "unreserved_keyword", "col_name_keyword", "func_name_keyword",
  "reserved_keyword", "SpecialRuleRelation", 0
};
#endif

# ifdef YYPRINT
/* YYTOKNUM[YYLEX-NUM] -- Internal token number corresponding to
   token YYLEX-NUM.  */
static const yytype_uint16 yytoknum[] =
{
       0,   256,   257,   258,   259,   260,   261,   262,   263,   264,
     265,   266,   267,   268,   269,   270,   271,   272,   273,   274,
     275,   276,   277,   278,   279,   280,   281,   282,   283,   284,
     285,   286,   287,   288,   289,   290,   291,   292,   293,   294,
     295,   296,   297,   298,   299,   300,   301,   302,   303,   304,
     305,   306,   307,   308,   309,   310,   311,   312,   313,   314,
     315,   316,   317,   318,   319,   320,   321,   322,   323,   324,
     325,   326,   327,   328,   329,   330,   331,   332,   333,   334,
     335,   336,   337,   338,   339,   340,   341,   342,   343,   344,
     345,   346,   347,   348,   349,   350,   351,   352,   353,   354,
     355,   356,   357,   358,   359,   360,   361,   362,   363,   364,
     365,   366,   367,   368,   369,   370,   371,   372,   373,   374,
     375,   376,   377,   378,   379,   380,   381,   382,   383,   384,
     385,   386,   387,   388,   389,   390,   391,   392,   393,   394,
     395,   396,   397,   398,   399,   400,   401,   402,   403,   404,
     405,   406,   407,   408,   409,   410,   411,   412,   413,   414,
     415,   416,   417,   418,   419,   420,   421,   422,   423,   424,
     425,   426,   427,   428,   429,   430,   431,   432,   433,   434,
     435,   436,   437,   438,   439,   440,   441,   442,   443,   444,
     445,   446,   447,   448,   449,   450,   451,   452,   453,   454,
     455,   456,   457,   458,   459,   460,   461,   462,   463,   464,
     465,   466,   467,   468,   469,   470,   471,   472,   473,   474,
     475,   476,   477,   478,   479,   480,   481,   482,   483,   484,
     485,   486,   487,   488,   489,   490,   491,   492,   493,   494,
     495,   496,   497,   498,   499,   500,   501,   502,   503,   504,
     505,   506,   507,   508,   509,   510,   511,   512,   513,   514,
     515,   516,   517,   518,   519,   520,   521,   522,   523,   524,
     525,   526,   527,   528,   529,   530,   531,   532,   533,   534,
     535,   536,   537,   538,   539,   540,   541,   542,   543,   544,
     545,   546,   547,   548,   549,   550,   551,   552,   553,   554,
     555,   556,   557,   558,   559,   560,   561,   562,   563,   564,
     565,   566,   567,   568,   569,   570,   571,   572,   573,   574,
     575,   576,   577,   578,   579,   580,   581,   582,   583,   584,
     585,   586,   587,   588,   589,   590,   591,   592,   593,   594,
     595,   596,   597,   598,   599,   600,   601,   602,   603,   604,
     605,   606,   607,   608,   609,   610,   611,   612,   613,    61,
      60,    62,   614,    43,    45,    42,    47,    37,    94,   615,
      91,    93,    40,    41,   616,    46,    59,    44,    58
};
# endif

/* YYR1[YYN] -- Symbol number of symbol that rule YYN derives.  */
static const yytype_uint16 yyr1[] =
{
       0,   379,   380,   381,   381,   382,   382,   382,   382,   382,
     382,   382,   382,   382,   382,   382,   382,   382,   382,   382,
     382,   382,   382,   382,   382,   382,   382,   382,   382,   382,
     382,   382,   382,   382,   382,   382,   382,   382,   382,   382,
     382,   382,   382,   382,   382,   382,   382,   382,   382,   382,
     382,   382,   382,   382,   382,   382,   382,   382,   382,   382,
     382,   382,   382,   382,   382,   382,   382,   382,   382,   382,
     382,   382,   382,   382,   382,   382,   382,   382,   382,   382,
     382,   382,   382,   382,   382,   382,   382,   382,   382,   382,
     382,   383,   384,   384,   385,   385,   386,   386,   386,   386,
     386,   386,   386,   386,   386,   386,   386,   386,   386,   386,
     386,   386,   386,   386,   386,   386,   386,   386,   386,   386,
     387,   388,   389,   389,   390,   391,   391,   392,   392,   393,
     393,   394,   395,   396,   396,   397,   397,   398,   398,   399,
     399,   400,   400,   401,   401,   401,   401,   401,   401,   402,
     402,   402,   403,   403,   403,   403,   403,   403,   403,   403,
     403,   404,   404,   405,   405,   406,   406,   407,   407,   407,
     408,   408,   408,   408,   409,   409,   409,   409,   410,   410,
     410,   410,   410,   410,   410,   411,   411,   411,   412,   412,
     413,   413,   413,   413,   413,   414,   414,   414,   414,   414,
     415,   416,   416,   417,   417,   418,   419,   419,   420,   420,
     421,   421,   421,   421,   421,   421,   421,   421,   421,   421,
     421,   421,   421,   421,   421,   421,   421,   421,   421,   421,
     421,   421,   422,   422,   423,   423,   423,   423,   424,   424,
     425,   425,   425,   426,   426,   427,   428,   428,   429,   429,
     430,   430,   430,   431,   431,   432,   432,   432,   432,   432,
     432,   432,   432,   432,   432,   433,   433,   434,   434,   435,
     435,   436,   436,   437,   437,   438,   438,   438,   438,   438,
     438,   438,   439,   439,   440,   440,   441,   441,   441,   442,
     443,   443,   444,   444,   444,   445,   445,   445,   445,   445,
     445,   445,   446,   446,   446,   446,   447,   448,   448,   449,
     449,   449,   449,   449,   449,   450,   450,   451,   451,   451,
     451,   452,   452,   453,   453,   454,   455,   455,   455,   455,
     456,   456,   456,   456,   456,   457,   458,   459,   459,   459,
     459,   459,   460,   460,   461,   461,   461,   461,   462,   462,
     462,   462,   463,   463,   464,   464,   465,   466,   466,   467,
     467,   468,   469,   470,   471,   471,   472,   472,   472,   472,
     472,   472,   472,   472,   472,   472,   472,   473,   473,   474,
     474,   475,   475,   476,   477,   477,   478,   478,   479,   479,
     480,   480,   481,   481,   482,   482,   483,   483,   484,   485,
     485,   486,   486,   487,   487,   488,   488,   489,   489,   489,
     490,   490,   490,   491,   491,   492,   492,   493,   493,   494,
     494,   494,   495,   495,   495,   495,   495,   495,   496,   496,
     497,   497,   497,   497,   497,   498,   498,   499,   499,   500,
     500,   501,   502,   503,   503,   503,   503,   503,   503,   504,
     505,   505,   506,   506,   507,   507,   507,   507,   507,   507,
     508,   508,   509,   509,   510,   511,   511,   512,   513,   514,
     514,   515,   515,   515,   515,   516,   516,   517,   517,   518,
     518,   519,   520,   521,   521,   522,   522,   522,   522,   522,
     522,   522,   522,   523,   523,   524,   524,   525,   525,   526,
     527,   527,   527,   527,   527,   527,   527,   527,   527,   527,
     527,   527,   528,   528,   528,   528,   528,   528,   528,   528,
     528,   528,   528,   528,   529,   529,   530,   530,   530,   530,
     531,   531,   531,   531,   531,   531,   531,   531,   531,   531,
     531,   531,   531,   531,   531,   532,   532,   533,   534,   534,
     535,   535,   535,   536,   536,   537,   537,   537,   537,   538,
     538,   538,   538,   538,   538,   538,   538,   539,   539,   540,
     540,   541,   541,   542,   542,   543,   544,   545,   545,   546,
     546,   547,   547,   548,   548,   549,   549,   550,   550,   551,
     551,   552,   552,   552,   553,   553,   553,   554,   554,   555,
     555,   556,   556,   557,   557,   558,   558,   558,   558,   558,
     559,   559,   559,   559,   560,   561,   562,   562,   562,   563,
     563,   564,   564,   564,   564,   564,   564,   564,   564,   564,
     564,   565,   565,   565,   566,   566,   567,   567,   568,   569,
     569,   570,   570,   571,   571,   572,   572,   573,   573,   574,
     574,   574,   574,   575,   575,   576,   576,   577,   577,   577,
     578,   579,   579,   580,   580,   580,   581,   581,   582,   582,
     583,   583,   583,   583,   583,   583,   583,   583,   583,   583,
     583,   583,   583,   583,   583,   584,   584,   585,   585,   585,
     585,   585,   585,   586,   586,   586,   586,   586,   586,   586,
     586,   586,   586,   588,   587,   589,   589,   589,   590,   590,
     591,   591,   591,   591,   591,   592,   592,   593,   593,   593,
     593,   594,   594,   594,   595,   595,   596,   597,   598,   598,
     599,   599,   599,   599,   599,   599,   599,   599,   599,   599,
     599,   599,   599,   599,   600,   600,   600,   601,   601,   601,
     602,   602,   602,   603,   603,   604,   604,   605,   605,   605,
     605,   606,   607,   608,   608,   609,   609,   609,   609,   609,
     609,   609,   609,   609,   609,   609,   609,   610,   610,   611,
     612,   612,   613,   613,   614,   615,   615,   616,   617,   617,
     617,   617,   617,   618,   618,   619,   620,   620,   620,   621,
     621,   621,   622,   622,   623,   623,   624,   624,   625,   625,
     626,   626,   627,   627,   628,   629,   629,   629,   629,   629,
     629,   630,   630,   631,   632,   632,   633,   633,   634,   634,
     634,   634,   635,   635,   636,   636,   637,   637,   638,   639,
     639,   639,   640,   640,   641,   642,   642,   643,   644,   644,
     645,   646,   646,   647,   647,   647,   647,   647,   647,   647,
     647,   648,   648,   649,   650,   650,   651,   651,   652,   653,
     654,   655,   655,   656,   657,   657,   657,   657,   657,   658,
     658,   658,   659,   659,   660,   660,   661,   661,   661,   661,
     662,   662,   663,   663,   663,   663,   663,   664,   664,   665,
     665,   665,   665,   665,   665,   665,   665,   666,   666,   667,
     667,   667,   668,   668,   668,   668,   669,   669,   670,   671,
     671,   672,   672,   672,   672,   673,   673,   673,   673,   673,
     674,   674,   675,   675,   676,   677,   677,   678,   678,   679,
     679,   680,   680,   681,   681,   682,   682,   683,   683,   684,
     684,   685,   685,   686,   686,   687,   687,   688,   688,   689,
     689,   690,   690,   690,   690,   690,   690,   690,   690,   690,
     690,   690,   691,   691,   691,   691,   691,   691,   692,   692,
     692,   692,   693,   693,   693,   693,   694,   694,   695,   695,
     696,   696,   696,   696,   697,   697,   697,   698,   699,   699,
     699,   700,   700,   701,   702,   702,   702,   702,   703,   703,
     703,   704,   704,   704,   704,   704,   704,   704,   704,   705,
     705,   705,   705,   705,   706,   707,   707,   707,   707,   707,
     707,   707,   707,   707,   707,   707,   708,   708,   709,   709,
     709,   710,   710,   710,   711,   711,   712,   712,   713,   714,
     715,   715,   716,   716,   717,   718,   719,   719,   719,   719,
     719,   719,   720,   720,   721,   721,   722,   722,   722,   722,
     723,   724,   724,   724,   725,   725,   725,   725,   725,   725,
     725,   725,   725,   725,   725,   725,   725,   725,   726,   726,
     726,   726,   726,   726,   726,   726,   726,   726,   726,   726,
     726,   726,   726,   726,   726,   726,   726,   726,   726,   726,
     726,   726,   726,   726,   726,   726,   726,   726,   726,   726,
     726,   726,   726,   726,   726,   726,   726,   726,   726,   726,
     726,   726,   726,   726,   726,   726,   726,   726,   726,   726,
     726,   726,   726,   726,   727,   727,   727,   727,   727,   727,
     727,   727,   727,   727,   727,   727,   727,   727,   727,   727,
     727,   727,   727,   727,   728,   728,   728,   728,   728,   728,
     728,   728,   728,   728,   728,   729,   729,   729,   729,   729,
     729,   729,   729,   729,   729,   729,   729,   729,   729,   729,
     729,   729,   729,   729,   729,   729,   729,   729,   729,   729,
     729,   729,   729,   729,   729,   729,   729,   729,   729,   730,
     730,   730,   731,   731,   731,   732,   732,   732,   733,   733,
     734,   734,   734,   734,   734,   734,   734,   734,   734,   735,
     735,   736,   736,   737,   737,   737,   737,   737,   737,   738,
     738,   739,   739,   740,   740,   741,   741,   742,   742,   743,
     743,   743,   743,   743,   743,   743,   743,   744,   744,   745,
     746,   746,   747,   747,   747,   747,   747,   747,   748,   749,
     750,   750,   750,   751,   751,   752,   753,   753,   754,   755,
     755,   756,   756,   757,   757,   758,   758,   758,   758,   759,
     759,   760,   760,   761,   761,   762,   762,   763,   763,   764,
     765,   765,   766,   766,   766,   767,   767,   768,   768,   769,
     769,   770,   770,   771,   772,   773,   774,   775,   776,   777,
     777,   778,   778,   778,   778,   778,   778,   778,   778,   778,
     778,   778,   779,   780,   781,   782,   782,   783,   783,   783,
     784,   784,   785,   785,   785,   786,   786,   786,   786,   786,
     787,   787,   787,   787,   787,   787,   787,   787,   787,   787,
     787,   787,   787,   787,   787,   787,   787,   787,   787,   787,
     787,   787,   787,   787,   787,   787,   787,   787,   787,   787,
     787,   787,   787,   787,   787,   787,   787,   787,   787,   787,
     787,   787,   787,   787,   787,   787,   787,   787,   787,   787,
     787,   787,   787,   787,   787,   787,   787,   787,   787,   787,
     787,   787,   787,   787,   787,   787,   787,   787,   787,   787,
     787,   787,   787,   787,   787,   787,   787,   787,   787,   787,
     787,   787,   787,   787,   787,   787,   787,   787,   787,   787,
     787,   787,   787,   787,   787,   787,   787,   787,   787,   787,
     787,   787,   787,   787,   787,   787,   787,   787,   787,   787,
     787,   787,   787,   787,   787,   787,   787,   787,   787,   787,
     787,   787,   787,   787,   787,   787,   787,   787,   787,   787,
     787,   787,   787,   787,   787,   787,   787,   787,   787,   787,
     787,   787,   787,   787,   787,   787,   787,   787,   787,   787,
     787,   787,   787,   787,   787,   787,   787,   787,   787,   787,
     787,   787,   787,   787,   787,   787,   787,   787,   787,   787,
     787,   787,   787,   787,   787,   787,   787,   787,   787,   787,
     787,   787,   787,   787,   787,   787,   787,   787,   787,   787,
     787,   787,   787,   787,   787,   787,   787,   787,   787,   787,
     787,   787,   787,   787,   787,   787,   787,   787,   788,   788,
     788,   788,   788,   788,   788,   788,   788,   788,   788,   788,
     788,   788,   788,   788,   788,   788,   788,   788,   788,   788,
     788,   788,   788,   788,   788,   788,   788,   788,   788,   788,
     788,   788,   788,   788,   788,   788,   789,   789,   789,   789,
     789,   789,   789,   789,   789,   789,   789,   789,   789,   789,
     789,   789,   789,   789,   789,   789,   790,   790,   790,   790,
     790,   790,   790,   790,   790,   790,   790,   790,   790,   790,
     790,   790,   790,   790,   790,   790,   790,   790,   790,   790,
     790,   790,   790,   790,   790,   790,   790,   790,   790,   790,
     790,   790,   790,   790,   790,   790,   790,   790,   790,   790,
     790,   790,   790,   790,   790,   790,   790,   790,   790,   790,
     790,   790,   790,   790,   790,   790,   790,   790,   790,   790,
     790,   790,   790,   790,   790,   790,   790,   790,   790,   790,
     791,   791
};

/* YYR2[YYN] -- Number of symbols composing right hand side of rule YYN.  */
static const yytype_uint8 yyr2[] =
{
       0,     2,     1,     3,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       0,     5,     1,     0,     2,     0,     2,     2,     3,     3,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     3,     3,     2,     2,     2,     2,     3,     3,
       5,     5,     5,     4,     5,     5,     4,     3,     5,     3,
       5,     5,     6,     1,     1,     3,     5,     6,     4,     1,
       0,     2,     0,     1,     1,     1,     1,     1,     1,     2,
       3,     3,     3,     3,     3,     2,     5,     2,     2,     3,
       3,     1,     3,     1,     1,     1,     3,     1,     1,     1,
       2,     2,     2,     1,     1,     1,     1,     1,     1,     1,
       3,     6,     1,     1,     1,     1,     1,     0,     1,     1,
       2,     3,     4,     3,     2,     2,     3,     4,     3,     2,
       4,     1,     1,     1,     1,     1,     4,     4,     1,     3,
       3,     4,     6,     6,     6,     6,     4,     6,     2,     4,
       3,     3,     3,     3,     3,     3,     3,     3,     3,     2,
       3,     1,     1,     3,     3,     3,     2,     2,     3,     2,
       1,     1,     0,     2,     0,     2,    10,     6,     1,     1,
       1,     1,     1,     2,     0,     1,     1,     3,     3,     1,
       1,     3,     3,     3,     4,     1,     0,     2,     0,     3,
       0,     1,     0,    11,    12,     1,     1,     2,     2,     2,
       2,     0,     1,     0,     1,     3,     1,     1,     1,     3,
       2,     0,     3,     1,     1,     2,     1,     3,     4,     4,
       2,     5,     1,     2,     2,     2,     3,     2,     0,     2,
       2,     2,     2,     2,     2,     3,     1,     4,     6,     7,
      11,     3,     0,     1,     3,     1,     2,     2,     2,     0,
       1,     1,     2,     2,     0,     3,     3,     2,     1,     1,
       2,     2,     4,     0,     2,     2,     2,     0,     3,     4,
       4,     0,     2,     0,     4,     0,    10,     3,     0,     1,
       3,     1,     5,     4,     2,     0,     2,     1,     2,     3,
       2,     2,     2,     2,     3,     3,     3,     1,     0,     1,
       1,     1,     2,     1,     5,     9,     1,     0,     1,     2,
       2,     0,     2,     0,     5,     7,     1,     0,     6,     2,
       0,     3,     5,    14,    19,     1,     1,     1,     3,     5,
       1,     1,     1,     3,     0,     1,     0,     1,     1,     1,
       3,     0,     1,     1,     1,     1,     1,     1,     2,     0,
       1,     2,     1,     2,     0,     2,     1,     2,     2,     6,
       8,     8,     4,     5,     4,     4,     4,     3,     7,     3,
       1,     3,     3,     1,     1,     1,     1,     1,     1,     1,
       3,     3,     1,     3,     3,     1,     3,     3,    12,     1,
       3,     4,     7,     4,     2,     1,     0,     1,     0,     7,
       9,     5,     6,     6,     4,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     3,     1,     2,     2,     3,     4,
       6,     7,     7,     9,     8,     8,     6,     8,     9,     7,
      10,     7,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     4,     2,     4,     2,
       0,     1,     1,     1,     1,     2,     2,     1,     1,     1,
       2,     2,     1,     2,     2,     1,     1,     7,     7,    10,
       1,     1,     2,     1,     3,     1,     1,     1,     1,     1,
       2,     2,     2,     2,     2,     2,     2,     1,     3,     1,
       2,     3,     0,     1,     3,     2,     6,     6,     9,     3,
       0,     3,     0,    13,    14,     1,     0,     2,     0,     1,
       3,     2,     2,     4,     1,     2,     0,     9,     7,     2,
       0,     3,     2,     1,     3,     3,     3,     2,     2,     1,
       1,     1,     1,     2,     1,     1,     1,     4,     5,     1,
       2,     4,     5,     1,     1,     1,     1,     3,     3,     2,
       2,     2,     2,     1,     1,     3,     2,     0,     5,     1,
       2,     1,     0,     5,     7,     5,     7,     7,     9,     1,
       3,     3,     3,     1,     3,    11,    10,     2,     2,     0,
       9,     2,     0,     4,     4,     4,     1,     1,     1,     0,
       7,     6,     6,     7,     6,     6,     9,     6,     6,     6,
       8,     8,     6,     6,     6,     1,     0,     7,     6,     7,
       6,     6,     6,     7,     6,     6,     6,     7,     9,     9,
       6,     6,     6,     0,    14,     1,     1,     3,     3,     1,
       1,     1,     1,     1,     1,     1,     0,     1,     1,     1,
       1,     1,     1,     0,     6,     8,     2,     2,     2,     2,
       2,     3,     3,     2,     2,     2,     2,     3,     2,     5,
       4,     3,     3,     3,     1,     1,     0,     3,     2,     2,
       1,     3,     2,     1,     0,     8,    10,     2,     3,     3,
       0,     2,     5,     2,     0,     3,     3,     3,     3,     3,
       3,     3,     3,     3,     4,     3,     3,     1,     0,     5,
       5,     4,     2,     0,     4,     3,     5,     6,     4,     6,
       6,     5,     7,     1,     0,    10,     4,     2,     1,     4,
       5,     5,     2,     4,     1,     1,     1,     0,     1,     0,
       1,     0,     3,     0,     4,     1,     1,     1,     1,     1,
       1,     1,     0,     5,     3,     0,     1,     3,     1,     1,
       1,     1,     3,    12,     3,     0,     2,     3,     5,     1,
       4,     2,     1,     3,     2,     2,     0,     6,     2,     0,
       5,     3,     0,     2,     2,     2,     3,     1,     3,     1,
       2,     1,     0,     7,     1,     3,     1,     1,     3,     5,
       2,     1,     3,     7,     0,     3,     2,     2,     2,     0,
       2,     2,     1,     1,     3,     3,     1,     2,     4,     4,
       1,     1,    11,     1,     4,     4,     4,     2,     0,     3,
       3,     4,     4,     4,     4,     2,     1,     1,     0,     1,
       1,     0,     1,     5,     1,     0,     1,     0,     3,     1,
       3,     3,     2,     2,     1,     4,     4,     2,     2,     4,
       1,     0,     1,     1,     1,     3,     0,     2,     0,     2,
       0,     2,     0,     2,     0,     1,     3,     1,     0,     1,
       2,     4,     4,     2,     0,     2,     3,     2,     0,     1,
       3,     1,     2,     1,     2,     5,     6,     5,     1,     2,
       1,     4,     3,     4,     5,     4,     5,     4,     5,     2,
       4,     1,     2,     2,     2,     1,     1,     0,     4,     2,
       1,     2,     2,     4,     1,     2,     3,     1,     2,     2,
       0,     1,     3,     2,     2,     3,     5,     6,     3,     4,
       0,     1,     1,     1,     1,     1,     2,     5,     2,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       2,     2,     2,     2,     2,     1,     3,     0,     5,     3,
       0,     5,     3,     0,     1,     1,     1,     1,     5,     2,
       1,     1,     1,     1,     5,     2,     2,     2,     1,     3,
       3,     2,     1,     0,     3,     0,     5,     2,     5,     2,
       1,     3,     3,     0,     1,     1,     1,     1,     1,     1,
       3,     3,     3,     3,     3,     3,     3,     0,     1,     3,
       5,     2,     2,     3,     3,     3,     3,     3,     3,     3,
       3,     3,     3,     2,     2,     3,     3,     2,     3,     5,
       4,     6,     3,     5,     4,     6,     4,     6,     5,     7,
       3,     2,     4,     2,     3,     3,     4,     3,     4,     3,
       4,     5,     6,     6,     7,     6,     7,     6,     7,     3,
       4,     4,     6,     2,     1,     3,     2,     2,     3,     3,
       3,     3,     3,     3,     3,     3,     3,     3,     2,     2,
       5,     6,     6,     7,     1,     1,     2,     4,     1,     1,
       1,     2,     2,     2,     1,     3,     4,     5,     5,     4,
       1,     1,     4,     1,     4,     1,     4,     1,     4,     1,
       1,     1,     1,     6,     4,     4,     4,     4,     6,     5,
       5,     5,     4,     6,     4,     6,     4,     4,     4,     5,
       5,     3,     4,     3,     5,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       4,     1,     4,     1,     4,     1,     2,     1,     2,     1,
       3,     3,     0,     3,     1,     1,     3,     3,     3,     1,
       1,     1,     1,     1,     1,     1,     1,     4,     3,     2,
       3,     0,     3,     3,     2,     2,     1,     0,     2,     2,
       3,     2,     1,     1,     3,     5,     1,     2,     4,     2,
       0,     1,     0,     1,     2,     2,     2,     3,     5,     1,
       2,     0,     2,     1,     0,     1,     1,     1,     3,     3,
       1,     3,     3,     1,     1,     1,     1,     1,     3,     1,
       2,     1,     3,     1,     1,     1,     1,     1,     1,     1,
       2,     1,     1,     1,     1,     1,     2,     3,     6,     1,
       1,     1,     1,     1,     1,     1,     2,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1
};

/* YYDEFACT[STATE-NAME] -- Default rule to reduce with in state
   STATE-NUM when YYTABLE doesn't specify something else to do.  Zero
   means the default is an error.  */
static const yytype_uint16 yydefact[] =
{
      90,   746,     0,   805,   804,   746,   205,     0,   798,     0,
     746,   266,   281,     0,     0,     0,   397,   746,     0,   822,
     530,     0,     0,     0,     0,   908,   530,     0,     0,     0,
       0,     0,     0,     0,   746,     0,   915,     0,     0,     0,
     908,     0,     0,   809,     0,     0,     0,     2,     4,    39,
      40,    15,    14,    17,    16,    56,    57,    31,     9,    48,
      34,    87,    88,    86,    23,    19,    13,    20,    24,    36,
      25,    35,    12,    33,    51,    37,    54,    38,    55,    26,
      46,    44,    32,    49,    50,    71,    53,    82,    22,    61,
      62,    77,    63,    78,    64,    30,     8,    74,    73,    75,
      27,    47,    72,    76,    10,    11,    79,    52,    69,    66,
      83,    81,    89,    67,    41,     5,     6,    58,    29,     7,
      28,    21,    85,    18,   807,    60,    70,    59,    42,    65,
      45,    68,    84,    43,    80,   883,   882,   917,   886,   893,
     745,   744,   730,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
     754,  1350,  1351,  1352,  1353,  1354,  1355,  1356,  1357,  1358,
    1359,  1360,  1361,  1362,  1363,  1364,  1365,  1558,  1559,  1560,
    1366,  1367,  1368,  1369,  1370,  1371,  1561,  1562,  1372,  1373,
    1374,  1375,  1376,  1563,  1377,  1378,  1379,  1380,  1381,  1382,
    1383,  1564,  1384,  1385,  1386,  1387,  1388,  1389,  1390,  1391,
    1392,  1393,  1565,  1566,  1394,  1395,  1396,  1397,  1398,  1399,
    1400,  1401,  1402,  1403,  1404,  1405,  1406,  1407,  1408,  1409,
    1410,  1411,  1412,  1567,  1413,  1414,  1568,  1415,  1416,  1569,
    1417,  1418,  1419,  1420,  1421,  1570,  1422,  1423,  1424,  1425,
    1426,  1427,  1428,  1429,  1430,  1431,  1432,  1433,  1434,  1435,
    1571,  1436,  1437,  1438,  1439,  1572,  1573,  1574,  1440,  1441,
    1442,  1443,  1444,  1445,  1446,  1575,  1447,  1448,  1449,  1450,
    1451,  1452,  1453,  1454,  1455,  1456,  1457,  1458,  1459,  1460,
    1461,  1576,  1577,  1462,  1463,  1464,  1465,  1466,  1467,  1468,
    1578,  1469,  1470,  1471,  1472,  1579,  1580,  1473,  1474,  1475,
    1476,  1477,  1581,  1582,  1478,  1479,  1480,  1481,  1583,  1584,
    1484,  1482,  1483,  1485,  1486,  1487,  1488,  1489,  1490,  1585,
    1491,  1492,  1493,  1494,  1495,  1496,  1497,  1498,  1499,  1500,
    1501,  1502,  1503,  1504,  1505,  1586,  1506,  1507,  1508,  1509,
    1510,  1511,  1512,  1513,  1514,  1515,  1516,  1587,  1517,  1518,
    1519,  1588,  1520,  1521,  1522,  1523,  1524,  1525,  1526,  1530,
    1589,  1527,  1528,  1529,  1531,  1532,  1533,  1534,  1590,  1591,
    1535,  1592,  1536,  1593,  1537,  1538,  1539,  1540,  1541,  1542,
    1543,  1544,  1545,  1546,  1547,  1548,  1594,  1595,  1549,  1550,
    1551,  1552,  1553,  1554,  1555,  1556,  1557,  1337,   245,  1313,
    1338,  1339,  1691,  1690,  1309,   797,     0,  1306,  1305,   397,
       0,   733,   265,     0,     0,     0,     0,     0,     0,     0,
     475,     0,     0,     0,     0,     0,     0,     0,   140,     0,
     276,   275,     0,   386,     0,   585,     0,     0,   397,     0,
       0,     0,  1482,   836,   874,     0,     0,     0,   662,   491,
       0,   490,     0,     0,   488,     0,     0,   396,     0,     0,
     492,   486,   485,     0,     0,   489,     0,   487,     0,     0,
     734,   835,   821,   807,  1351,   538,   542,   533,   539,   534,
     531,   532,  1494,  1335,     0,     0,   527,   537,   551,   557,
     556,   555,     0,   550,   553,   558,     0,   727,  1306,  1333,
     761,  1318,   907,     0,     0,   529,   726,  1535,   825,     0,
       0,   666,     0,   667,     0,  1508,   738,   199,  1515,  1590,
    1535,   195,   161,  1355,     0,     0,   550,     0,   735,   736,
     914,   912,     0,  1382,  1450,  1461,  1504,  1515,  1590,  1535,
     149,     0,   194,  1515,  1590,  1535,   190,   754,     0,   729,
     728,     0,   994,     0,   990,   808,   811,     0,   955,   891,
       0,     1,    90,   806,   802,   911,   911,     0,   911,     0,
     887,     0,  1596,  1597,  1598,  1599,  1600,  1601,  1602,  1603,
    1604,  1605,  1606,  1607,  1608,  1609,  1610,  1611,  1612,  1613,
    1614,  1615,  1337,     0,     0,  1319,  1338,  1344,     0,   495,
      93,  1314,     0,     0,     0,     0,  1334,     0,     0,  1374,
    1218,  1228,  1226,  1227,  1220,  1221,  1222,  1223,  1224,  1225,
       0,   653,  1219,     0,    93,     0,     0,   365,     0,     0,
       0,     0,    93,     0,     0,   750,   753,   731,     0,     0,
    1289,  1310,     0,     0,     0,   512,     0,   521,   513,   518,
       0,   515,     0,     0,   523,     0,   514,   516,   517,   522,
       0,   519,   520,     0,     0,   742,   322,     0,     0,     0,
       0,     0,    93,   794,   280,   279,    93,   278,   277,  1374,
       0,   599,    93,     0,   142,   400,     0,   447,    93,     0,
       0,     0,     0,     0,     0,     0,     0,   837,     0,   849,
    1426,     0,   242,     0,     0,  1426,   785,  1426,     0,  1426,
     135,  1311,  1374,  1426,     0,     0,  1426,   127,  1426,     0,
    1426,   401,  1426,     0,  1426,   129,     0,  1426,   242,   493,
       0,   832,     0,   535,   544,   543,   541,   540,   536,  1336,
     545,   546,     0,   552,     0,     0,     0,     0,   852,  1307,
       0,   741,     0,     0,     0,   669,   669,   669,   737,   198,
     196,     0,     0,     0,     0,     0,     0,   743,     0,     0,
       0,  1558,  1559,  1560,  1282,     0,  1561,  1562,  1563,  1564,
    1180,  1189,  1181,  1183,  1190,  1565,  1566,  1403,  1567,  1568,
    1330,  1569,  1570,  1572,  1573,  1574,  1575,  1185,  1187,  1576,
    1577,     0,  1331,  1579,  1580,  1476,  1582,  1583,  1585,  1586,
    1191,  1588,  1589,  1590,  1591,  1592,  1593,  1329,     0,  1192,
    1595,  1337,  1322,  1324,  1325,  1229,  1332,  1291,     0,     0,
    1304,     0,  1170,     0,  1019,  1020,  1021,  1046,  1047,  1022,
    1052,  1053,  1065,  1023,     0,  1303,  1088,  1169,  1174,     0,
    1168,  1164,   898,  1300,  1283,     0,  1165,  1321,  1323,  1024,
    1338,   201,     0,   202,  1515,   150,   186,   157,   185,   189,
     158,   188,     0,  1372,   151,     0,   155,     0,     0,   193,
     191,     0,   732,   242,     0,   992,     0,   995,     0,   991,
     810,   807,  1296,  1295,  1297,     0,   885,   884,     3,   813,
     909,   910,     0,     0,     0,     0,     0,     0,     0,   948,
     931,   945,   949,   956,  1320,     0,     0,     0,     0,     0,
     496,     0,     0,     0,    92,   783,   781,     0,     0,     0,
       0,   788,     0,     0,   624,     0,     0,   625,   623,   626,
     639,   642,     0,   575,   133,   134,     0,     0,     0,     0,
       0,     0,   207,   232,     0,     0,     0,     0,     0,     0,
      95,   123,     0,     0,     0,   363,   686,   686,     0,     0,
     686,     0,     0,     0,   686,     0,   206,   208,   231,     0,
       0,     0,     0,     0,     0,     0,    95,   126,     0,   748,
     749,     0,   752,     0,  1616,  1617,  1618,  1619,  1620,  1621,
    1622,  1623,  1624,  1625,  1626,  1627,  1628,  1629,  1630,  1631,
    1632,  1633,  1634,  1635,  1636,  1637,  1638,  1639,  1640,  1641,
    1642,  1643,  1644,  1645,  1646,  1647,  1648,  1649,  1650,  1651,
    1652,  1653,  1654,  1655,  1656,  1657,  1658,  1659,  1660,  1661,
    1662,  1663,  1664,  1665,  1666,  1667,  1668,  1669,  1670,  1671,
    1672,  1673,  1674,  1675,  1676,  1677,  1678,  1679,  1680,  1681,
    1682,  1683,  1684,  1685,  1686,  1687,  1688,  1689,  1345,  1286,
    1285,  1316,  1346,  1347,  1348,  1349,  1290,   796,     0,     0,
       0,     0,     0,  1374,     0,     0,     0,     0,     0,     0,
     268,   251,   252,    93,   250,     0,     0,   444,     0,  1028,
    1063,  1035,  1063,  1063,  1043,  1043,  1037,  1025,  1026,  1070,
       0,  1063,  1040,  1029,     0,  1027,  1073,  1073,  1058,  1340,
       0,  1010,  1011,  1012,  1013,  1044,  1045,  1014,  1050,  1051,
    1015,  1087,  1024,  1341,     0,   764,   793,     0,    95,   476,
       0,   445,     0,    95,     0,   138,     0,     0,   406,   405,
       0,     0,   446,    95,   365,   358,   322,     0,     0,  1380,
       0,  1317,     0,     0,   877,   879,   878,     0,   876,     0,
    1000,     0,   242,   240,   241,   442,   661,     0,     0,     0,
     242,     0,     0,  1426,     0,     0,     0,   242,     0,     0,
       0,     0,     0,     0,     0,  1426,   242,     0,     0,   484,
    1239,     0,   281,   814,   820,   816,   818,   817,   819,   815,
     526,  1391,  1419,  1444,  1509,  1513,     0,  1531,     0,   559,
     580,   554,     0,     0,   846,   839,     0,     0,   862,   528,
       0,   826,     0,     0,   668,   665,   664,   663,   197,   162,
       0,     0,     0,   582,  1508,   740,     0,     0,  1172,  1173,
    1062,  1049,  1281,     0,     0,  1057,  1056,     0,     0,     0,
       0,     0,  1033,  1032,  1031,  1171,  1242,     0,  1030,     0,
       0,     0,     0,  1063,  1063,  1061,  1107,     0,     0,  1034,
       0,     0,  1261,     0,  1267,     0,     0,     0,  1069,     0,
    1067,     0,     0,  1143,  1166,  1091,  1092,  1594,  1170,  1239,
       0,  1326,     0,     0,  1055,     0,  1087,     0,     0,     0,
    1294,  1237,     0,     0,  1121,  1235,     0,  1123,     0,     0,
       0,  1229,  1228,  1226,  1227,  1220,  1221,  1222,  1223,  1224,
    1225,     0,  1233,  1104,     0,     0,  1103,     0,     0,   958,
    1284,     0,   203,   204,   200,     0,   160,   159,     0,   183,
     184,   179,   381,     0,   154,   182,   379,   380,     0,   178,
     383,   164,   175,   177,   176,   174,   152,   163,   165,   167,
     168,   169,   153,   192,   499,     0,   996,     0,   958,   864,
     866,   867,     0,  1291,   799,  1299,     0,     0,   803,   891,
     896,   890,   895,   918,   919,   924,   894,     0,   954,   954,
     933,   927,   932,   928,   934,   947,   889,   930,   888,     0,
     950,     0,     0,   462,     0,     0,     0,     0,     0,   497,
       0,     0,     0,   780,   779,     0,     0,     0,     0,     0,
     791,   316,     0,   239,     0,     0,     0,     0,     0,     0,
       0,     0,   629,   630,   641,   640,   638,   610,   612,   611,
       0,  1342,   602,     0,   603,     0,     0,   609,   616,  1024,
     614,  1343,     0,     0,     0,     0,     0,     0,     0,   237,
       0,   236,     0,     0,     0,     0,     0,   649,   654,     0,
     122,   121,     0,     0,     0,     0,   367,   378,     0,     0,
       0,     0,    93,    93,   364,   685,   218,     0,     0,     0,
       0,     0,     0,     0,   229,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,   125,   124,     0,
       0,   173,   747,   751,  1287,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,   323,
     325,     0,     0,   254,  1340,     0,   465,   443,     0,  1010,
       0,     0,  1004,  1076,  1077,  1078,  1075,  1079,  1074,     0,
    1016,  1018,     0,   762,   291,   131,     0,     0,   450,   453,
       0,    91,   142,   281,     0,   141,   143,   145,   146,   147,
     144,   148,   399,     0,   411,   410,   412,     0,   407,     0,
     120,   362,     0,   283,   347,     0,   384,     0,     0,     0,
       0,   703,     0,     0,     0,   875,     0,   968,   848,   959,
     970,   961,   963,   997,  1309,     0,   846,     0,   645,     0,
     786,     0,   643,   136,  1312,     0,     0,     0,     0,   481,
     128,     0,   242,   402,     0,   242,   130,     0,   394,   242,
     494,   834,     0,     0,   563,   562,   573,     0,   564,   565,
     561,   560,   566,     0,     0,   582,   841,     0,   842,  1291,
       0,   838,     0,   859,     0,   857,     0,  1308,   861,   850,
     824,     0,   823,   829,   831,   830,   828,     0,     0,     0,
     550,     0,     0,   242,   739,     0,     0,     0,  1245,     0,
       0,  1280,  1276,     0,     0,  1239,     0,     0,     0,     0,
    1252,  1253,  1254,  1251,  1255,  1250,  1249,  1256,     0,     0,
       0,     0,     0,     0,     0,  1060,  1059,     0,     0,     0,
       0,     0,     0,     0,     0,  1144,  1174,     0,     0,  1213,
       0,  1239,  1266,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,  1239,  1272,     0,  1292,  1291,     0,     0,
       0,     0,  1327,  1105,  1302,     0,  1293,     0,     0,  1112,
       0,  1273,  1139,     0,  1127,     0,  1120,     0,  1125,  1129,
    1108,  1294,  1238,     0,  1236,     0,     0,  1106,     0,  1101,
    1099,  1100,  1093,  1094,  1095,  1096,  1097,  1098,  1089,  1102,
    1217,  1215,  1216,     0,     0,     0,  1124,  1420,  1450,     0,
     908,   908,   897,   906,  1301,     0,  1000,     0,     0,     0,
    1175,     0,     0,   382,     0,  1087,     0,   993,   871,     0,
       0,  1000,     0,   870,   801,   800,  1298,     0,     0,   922,
     923,     0,   946,     0,   862,   862,     0,     0,     0,   461,
     460,     0,     0,     0,     0,   694,   671,   498,   695,   672,
       0,   782,     0,     0,     0,     0,     0,   242,   789,   696,
     238,   790,   688,     0,   627,   628,     0,   613,  1024,   601,
       0,     0,   608,     0,   607,  1018,     0,     0,     0,   674,
     132,   234,   679,   235,   233,   675,     0,  1315,     0,     0,
       0,   682,     0,     0,   104,   106,   108,     0,     0,   102,
     110,   105,   107,   109,   103,   111,   101,     0,     0,   100,
       0,     0,     0,     0,    94,   700,   677,   690,   366,   377,
       0,   370,   371,   368,   372,   373,     0,     0,     0,   210,
       0,     0,   221,   227,   228,   226,   242,   242,   224,   225,
     223,   230,   678,     0,   691,   222,   220,     0,   209,   702,
     684,     0,   701,   692,   683,   171,   170,   172,     0,     0,
       0,     0,     0,     0,     0,     0,   525,   506,   524,     0,
       0,     0,   500,   321,     0,   267,   248,   249,     0,   247,
       0,   464,     0,     0,     0,  1005,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,   778,   778,   778,   778,
     778,   763,   787,     0,   449,     0,     0,   322,   137,     0,
       0,   398,     0,     0,     0,  1001,     0,     0,     0,     0,
     282,   284,   286,   287,   288,     0,   359,   361,     0,     0,
     351,     0,     0,     0,     0,   588,     0,     0,     0,   637,
     633,   619,     0,   880,   881,     0,   891,     0,   970,     0,
     969,   981,     0,     0,   987,   985,     0,   987,     0,   987,
       0,   962,     0,   964,   981,  1310,   998,   999,   847,   242,
       0,   242,     0,   242,     0,   242,     0,   724,     0,   439,
     242,   483,  1240,     0,     0,   575,     0,   572,   567,   569,
       0,   576,     0,     0,   844,   845,   860,   853,   855,   854,
       0,     0,   851,   827,   482,     0,     0,   242,     0,   577,
     913,  1247,  1248,     0,     0,     0,     0,  1277,     0,     0,
    1206,     0,  1204,  1182,  1184,  1042,     0,  1194,     0,  1036,
    1207,  1208,  1186,  1188,     0,  1039,     0,  1230,     0,     0,
    1195,  1146,  1147,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,  1159,  1158,  1196,  1212,
       0,     0,  1264,  1265,  1197,  1071,  1072,  1073,  1073,     0,
       0,  1271,     0,     0,     0,  1202,  1167,  1240,  1064,  1065,
       0,     0,     0,     0,     0,     0,     0,     0,  1128,  1122,
       0,  1126,  1130,     0,     0,     0,     0,  1114,  1140,  1110,
       0,     0,  1116,     0,  1141,   908,   908,   908,   908,   905,
       0,     0,   957,   936,     0,     0,  1179,  1176,   156,     0,
     180,   166,     0,     0,   865,   846,   868,   812,   920,     0,
    1231,   921,   953,   952,   951,   925,   929,   926,   463,   693,
     670,   687,   778,     0,   315,     0,     0,     0,   792,   621,
       0,  1018,   604,   605,   606,     0,   697,   673,   689,     0,
       0,   651,     0,   652,   650,   116,     0,     0,     0,     0,
      97,    96,   117,   115,     0,   114,     0,   369,   374,   376,
     375,   291,     0,     0,     0,   211,   219,   216,     0,     0,
    1288,   501,     0,     0,   502,   509,     0,     0,     0,     0,
     511,   324,   270,   255,   259,   794,   794,     0,   260,   794,
     256,   794,   253,  1476,  1221,   458,   467,   454,   457,   459,
     455,   456,     0,   466,   434,     0,     0,     0,  1008,     0,
    1081,  1082,  1083,  1084,  1085,  1086,  1080,  1087,     0,   778,
     777,     0,     0,     0,     0,     0,     0,     0,     0,   302,
       0,     0,   296,     0,     0,   637,   290,   293,   294,     0,
     451,   452,     0,   281,     0,   414,   408,   448,     0,  1003,
     283,   308,   343,     0,   357,     0,   345,   344,   346,     0,
     353,   760,   391,   388,     0,   588,     0,     0,   631,   634,
     632,     0,   615,     0,   620,   598,     0,   873,   972,   979,
       0,   960,     0,   986,   982,     0,   983,     0,     0,   984,
       0,     0,   979,     0,     0,     0,   646,     0,   644,     0,
     479,     0,   647,   242,   242,   395,   358,   574,   570,     0,
       0,   547,   579,   840,   843,   858,   856,   582,     0,   548,
     581,  1246,  1048,     0,  1279,  1275,     0,     0,     0,  1241,
       0,     0,  1259,  1258,  1260,     0,     0,     0,  1156,  1154,
    1155,  1148,  1149,  1150,  1151,  1152,  1153,  1145,  1157,  1269,
    1268,  1262,  1263,  1068,  1066,     0,  1199,  1200,  1201,  1270,
    1214,  1054,  1087,  1090,     0,     0,  1113,  1274,  1131,     0,
       0,  1244,     0,  1109,     0,     0,     0,     0,  1118,  1230,
       0,     0,     0,     0,     0,     0,   900,   899,     0,   938,
    1177,  1178,     0,     0,   872,   863,     0,     0,   317,     0,
       0,   637,   622,     0,   617,     0,     0,     0,   112,    98,
     119,   118,    99,   113,   289,     0,     0,     0,     0,   244,
     680,   681,     0,   504,     0,     0,   505,   507,   271,    93,
       0,     0,     0,     0,     0,     0,     0,   436,     0,     0,
     441,   430,   432,     0,     0,     0,  1006,  1009,  1017,   429,
       0,   773,   772,   771,   768,   767,   776,   775,   766,   765,
     770,   769,     0,     0,   300,   304,   305,   303,   295,   637,
     322,   355,     0,     0,     0,   416,     0,     0,  1002,     0,
     306,     0,   347,   285,   360,   361,     0,     0,     0,     0,
       0,     0,   755,     0,   393,   389,     0,     0,   587,     0,
       0,   637,   636,   719,   720,   717,   718,     0,   971,     0,
       0,   973,     0,     0,   975,   977,     0,     0,     0,     0,
       0,  1313,  1211,     0,   242,   242,   242,   725,   440,     0,
     347,     0,   568,   242,     0,  1278,  1193,  1203,  1041,  1205,
    1038,  1257,     0,     0,     0,     0,  1198,  1328,  1137,  1135,
    1132,     0,  1133,     0,     0,     0,  1115,  1111,     0,  1117,
    1142,   904,   903,   902,   901,     0,     0,   940,  1087,   869,
       0,   784,     0,   637,   355,   618,   699,   676,   698,   212,
     213,   214,   215,     0,   217,     0,   508,   503,   254,     0,
     257,   262,     0,   263,   258,   261,   438,   437,   435,   431,
     433,  1007,     0,   659,     0,   434,   774,     0,     0,   292,
     355,   329,     0,   297,     0,   760,   283,   415,     0,     0,
     409,   347,     0,     0,   307,     0,   351,     0,   348,     0,
     352,     0,     0,     0,   757,   390,     0,   385,     0,     0,
       0,     0,   589,   596,   596,   635,   597,     0,     0,   980,
     989,     0,   976,   974,   965,     0,   967,     0,     0,   660,
     480,   648,   351,   571,   578,   242,  1160,     0,     0,     0,
    1134,  1243,  1138,  1136,  1119,   935,   937,     0,   942,   181,
    1232,     0,   355,   318,   243,   510,   246,   269,   264,   659,
       0,   656,   428,     0,   299,   298,     0,   334,     0,     0,
     756,   417,   418,   413,     0,   351,   312,   310,   314,   311,
     309,   313,     0,   353,   349,   350,     0,   356,   758,   759,
     392,   795,     0,     0,   637,     0,     0,   594,   592,   591,
    1000,   978,     0,   966,  1210,  1209,   353,   549,  1161,     0,
    1162,   939,     0,   944,   322,   319,   655,   658,   657,     0,
     326,   327,   328,     0,   301,   330,   331,     0,     0,     0,
     353,   342,   273,   835,   637,   596,   353,   590,   595,     0,
     988,     0,  1163,   941,     0,   892,   329,     0,     0,     0,
       0,   332,     0,   333,   354,     0,     0,     0,   468,   469,
     421,   274,   833,   353,   593,  1000,   723,     0,   943,   334,
       0,   339,     0,   338,     0,   336,   335,     0,     0,   474,
       0,   423,   425,   426,   422,     0,   419,   424,   427,  1000,
     583,   722,   721,     0,   434,     0,   337,   341,   340,     0,
     478,   470,   403,     0,   584,   705,   716,   704,   706,   714,
     711,   713,   712,   710,   320,     0,   473,   477,     0,   471,
     420,     0,   715,   709,   891,   882,     0,     0,   707,   716,
     421,   478,   708,     0,   472,   404
};

/* YYDEFGOTO[NTERM-NUM].  */
static const yytype_int16 yydefgoto[] =
{
      -1,    46,    47,    48,    49,   935,  1491,  1924,    50,    51,
      52,    53,    54,    55,    56,    57,    58,   957,    59,    60,
     693,  1155,  1585,    61,   550,   551,  1376,  1377,  1378,  1532,
    1379,  1364,   877,  1380,    62,    63,    64,   872,  1354,    65,
      66,   986,   987,   962,   988,   941,  1185,  2714,    67,    68,
    1988,  1103,  1989,  2322,   423,  1552,  2559,  2560,    69,  1152,
    2029,  2030,  2031,  2032,  2012,  2366,  2367,  2368,  2033,  2610,
    2754,  2034,  1441,  1100,  1548,  1549,  2827,  2884,  2885,  2886,
    2935,  2612,  2040,  2390,  2618,  2743,    70,  1604,  2035,  2036,
      71,    72,   975,  1504,  1930,  1381,  1366,  1367,    73,   448,
    2392,  2624,  2767,    74,   478,    75,  1157,    76,    77,  1160,
    1597,  1598,  2606,  2748,  2833,  2945,  2946,  2735,  2570,  2571,
    2572,    78,    79,    80,    81,  1481,  1577,  1578,  2326,   926,
    1422,  1107,  1555,  1556,    82,  2918,  2919,   449,  2979,    83,
      84,    85,    86,   479,   738,  2857,   930,    87,    88,   674,
    1977,    89,   495,   752,    90,    91,   502,  1690,   504,  1228,
    2097,  2098,  2441,  1655,   613,    92,    93,  1665,  1693,    94,
     450,  2397,  2771,  2772,  2858,    95,   451,   953,  1463,  1464,
    1465,  1466,  2401,  1467,  2049,  2050,  2051,  2398,  2405,    96,
     951,  1456,    97,    98,    99,  1486,   630,   100,  2821,   101,
     714,   102,   524,  1245,   103,  1507,   104,   105,   106,  2052,
    2967,  2981,  2982,  2983,  2637,  2953,   107,  2969,   109,   110,
     111,   142,   645,   646,   647,   112,  2622,   113,   114,  1573,
    2011,  2351,   115,   116,  1434,  1861,   117,   118,   119,  1147,
     120,   121,   122,   123,   124,   574,   566,   901,  1398,   125,
    1213,   483,   126,   763,  1240,  1682,   127,   741,   128,  2970,
    1234,  1667,  1668,  1671,  2971,  1180,   131,  1238,  1676,  1679,
    2972,  1388,  1389,  1390,  1391,  1392,  1829,   133,   708,  1614,
    2973,   842,   136,   137,   138,  1349,  1812,   513,   912,   542,
     579,   580,  1403,  1404,   919,  1418,  1411,  1413,  2519,  2697,
    2808,  2873,  2905,   920,  1416,   921,   922,  1844,   139,  1816,
    1618,  1619,  1620,  2060,  2070,  2414,  2644,  1621,   563,  1622,
    1626,  2024,  2025,  1468,  1562,  1131,   843,   844,   845,  1278,
    1289,  1272,  1134,   846,   847,   848,  1137,   849,   850,   851,
     852,  1261,  1314,   853,   854,  1298,  1570,  1210,  1734,   856,
     857,  2077,   858,  1803,  1342,   632,   859,  2328,  1344,  1754,
    1718,  2502,  1697,  1259,  1719,  1731,  2149,  1738,  1743,  2172,
    2173,  1755,  1772,   860,  1701,  1702,  2128,  1263,   861,   650,
     651,  1304,  1768,   904,   905,   568,   862,   863,   864,  1229,
     564,  2640,   721,   610,  1896,  1080,   416,   510,   865,   866,
     867,   868,  2099,  1370,   508,   869,   605,  1081,   410,   411,
     607,  1085,   418
};

/* YYPACT[STATE-NUM] -- Index in YYTABLE of the portion describing
   STATE-NUM.  */
#define YYPACT_NINF -2559
static const int yypact[] =
{
    6722,   -48,  3513, -2559, -2559,   -48, -2559, 32702, 27816,    54,
     -32,    79, 41378, 33051, 32702,   430,  1828,   -48, 32702,  1077,
   20564, 25373,    95, 27816,  -129,   242, 20564, 27816, 33400,   382,
     663, 33749, 29212, 24675,   -23, 32702,   203, 34098, 29561,   250,
     242, 18793, 26071,   550,   337,   619,   716,   389, -2559, -2559,
   -2559, -2559, -2559, -2559, -2559, -2559, -2559, -2559, -2559, -2559,
   -2559, -2559, -2559, -2559, -2559, -2559, -2559, -2559, -2559, -2559,
   -2559, -2559, -2559, -2559, -2559, -2559, -2559, -2559, -2559, -2559,
   -2559, -2559, -2559, -2559, -2559, -2559, -2559, -2559, -2559, -2559,
   -2559, -2559, -2559, -2559, -2559, -2559, -2559, -2559, -2559, -2559,
   -2559, -2559, -2559, -2559, -2559, -2559, -2559, -2559, -2559, -2559,
   -2559, -2559, -2559, -2559, -2559, -2559, -2559, -2559, -2559, -2559,
   -2559, -2559, -2559, -2559,   439, -2559, -2559, -2559, -2559, -2559,
   -2559, -2559, -2559, -2559, -2559,  1427, -2559,   372,  1470,   409,
   -2559, -2559, -2559, 23279, 32702, 32702, 32702, 23279, 32702, 26071,
   32702, 16614, 32702, 32702, 26071, 26071, 32702, 32702, 32702, 32702,
     498, -2559, -2559, -2559, -2559, -2559, -2559, -2559, -2559, -2559,
   -2559, -2559, -2559, -2559, -2559, -2559, -2559, -2559, -2559, -2559,
   -2559, -2559, -2559, -2559, -2559, -2559, -2559, -2559, -2559, -2559,
   -2559, -2559, -2559, -2559, -2559, -2559, -2559, -2559, -2559, -2559,
   -2559, -2559, -2559, -2559, -2559, -2559, -2559, -2559, -2559, -2559,
   -2559, -2559, -2559, -2559, -2559, -2559, -2559, -2559, -2559, -2559,
   -2559, -2559, -2559, -2559, -2559, -2559, -2559, -2559, -2559, -2559,
   -2559, -2559, -2559, -2559, -2559, -2559, -2559, -2559, -2559, -2559,
   -2559, -2559, -2559, -2559, -2559, -2559, -2559, -2559, -2559, -2559,
   -2559, -2559, -2559, -2559, -2559, -2559, -2559, -2559, -2559, -2559,
   -2559, -2559, -2559, -2559, -2559, -2559, -2559, -2559, -2559, -2559,
   -2559, -2559, -2559, -2559, -2559, -2559, -2559, -2559, -2559, -2559,
   -2559, -2559, -2559, -2559, -2559, -2559, -2559, -2559, -2559, -2559,
   -2559, -2559, -2559, -2559, -2559, -2559, -2559, -2559, -2559, -2559,
   -2559, -2559, -2559, -2559, -2559, -2559, -2559, -2559, -2559, -2559,
   -2559, -2559, -2559, -2559, -2559, -2559, -2559, -2559, -2559, -2559,
   -2559, -2559, -2559, -2559, -2559, -2559, -2559, -2559, -2559, -2559,
   -2559, -2559, -2559, -2559, -2559, -2559, -2559, -2559, -2559, -2559,
   -2559, -2559, -2559, -2559, -2559, -2559, -2559, -2559, -2559, -2559,
   -2559, -2559, -2559, -2559, -2559, -2559, -2559, -2559, -2559, -2559,
   -2559, -2559, -2559, -2559, -2559, -2559, -2559, -2559, -2559, -2559,
   -2559, -2559, -2559, -2559, -2559, -2559, -2559, -2559, -2559, -2559,
   -2559, -2559, -2559, -2559, -2559, -2559, -2559, -2559, -2559, -2559,
   -2559, -2559, -2559, -2559, -2559, -2559, -2559, -2559, -2559, -2559,
   -2559, -2559, -2559, -2559, -2559, -2559, -2559, -2559, -2559, -2559,
   -2559, -2559, -2559, -2559,   853, -2559,   593,   684, -2559,  6096,
    -129, -2559, -2559, 27816,   572, 23279, 32702,   577,   646, 32702,
   -2559, 32702,  1050, 32702,  1078, 16980,   738, 32702, 32702, 32702,
   -2559, -2559, 32702, -2559, 32702, -2559, 32702,   660,   780,   970,
     912,    91, 32702, -2559, -2559, 26071, 23628, 32702,   924, -2559,
   34447, -2559, 23977, 34796, -2559, 17346,  1108, -2559, 35145, 35494,
   -2559, -2559, -2559, 35843, 36192, -2559, 36541, -2559,  1009, 36890,
   -2559,   826, -2559,   439,   723, -2559,   127,   120,   176,   121,
     125,   130,   723, -2559,   881,   895, -2559, -2559,  1041, -2559,
   -2559, -2559,  1019,   378, -2559, -2559, 27816, -2559, -2559, -2559,
   -2559, -2559, -2559, 27816,   895, -2559, -2559,  -129,   943,  1217,
   32702, -2559, 32702, -2559, 27816, 32702, -2559, -2559,  1271,   965,
    1170,   961, -2559,  1117,  1126,  1155,    16,  -129,  1038, -2559,
   -2559,  1165, 10088, 26420, 37239,   106, 22228, 29910,  1047,   498,
   -2559,   -75, -2559,  1375,  1071,  1260,   961,   498, 27816, -2559,
   -2559, 14841, 37588,  1145,  1079, -2559,  1329, 10458, -2559,  1090,
    1093, -2559,  6722, -2559, 27816,   569,   569,  1435,   569,   606,
     773,   337, -2559, -2559, -2559, -2559, -2559, -2559, -2559, -2559,
   -2559, -2559, -2559, -2559, -2559, -2559, -2559, -2559, -2559, -2559,
   -2559, -2559,  1120,   853,  1130, -2559,  1150, -2559,   666,  1102,
    1037, -2559,   175,   711,  1164,   161, -2559,   861,  1239, 32702,
   -2559, -2559, -2559, -2559, -2559, -2559, -2559, -2559, -2559, -2559,
    1195, -2559, -2559,  1152,   436,   765,  1299,   274,  1587,   848,
    1367,   578,   856,  1425,    43, -2559,   330, -2559, 12308, 18444,
   -2559,   853, 27816, 23279,  1251, -2559, 32702, -2559, -2559, -2559,
   23279, -2559,  1412, 17712, -2559, 32702, -2559, -2559, -2559, -2559,
   32702, -2559, -2559,  1466, 32702, -2559,  1290,   -44,  1295,  1596,
   40380, 32702,  1327,  1655, -2559, -2559,  1327, -2559, -2559, 32702,
    1306,   462,  1327,  1656,  1660,  1448,   933,    83,  1327, 27816,
   27816, 27816,  1527, 32702, 37937, 23279, 32702, -2559,   907,  1369,
    1595,  1130,   140,  1597,  1334,  1599, -2559,  1602,  1164,  1604,
    1339, -2559, 38286,  1605,  1346, 32702,  1609,  1339,  1611,  1502,
    1615, -2559,  1616,  1506,  1620,  1339, 22579,  1622,    69, -2559,
   12308, -2559,   678, -2559, -2559, -2559, -2559, -2559, -2559, -2559,
   -2559, -2559, 32702, -2559, 26769, 32702, 27118,    49,    62, -2559,
   32702, -2559, 40380,  1714, 32702,  1617,  1617,  1617, -2559, -2559,
   -2559,  1564, 32702,  1623,  1624, 26769, 32702, -2559, 38635,  1366,
    1113,  1391,   636,  1392, 12308,  1368,    65,    65,  1374,  1376,
   -2559, -2559,  1386,  1388, -2559,   760,   760,  1525,  1393,  1394,
   -2559,   781,  1395,  1411,  1415,   796,  1399,  1401,  1406,  1143,
      65, 12308, -2559,  1407,   872,  1413,  1416,  1417,  1440,  1423,
   -2559,  1443,  1428,   858,   879,  1429,  1430, -2559,  1393, -2559,
      90,   923, -2559, -2559, -2559, -2559, -2559, -2559, 12308, 12308,
   -2559, 10828, -2559,  -129, -2559, -2559, -2559, -2559, -2559, -2559,
   -2559, -2559,   100, -2559,   934,  3970, -2559, -2559,  1517, 12308,
   -2559, -2559,    26, -2559,   853,  1434, -2559, -2559, -2559, -2559,
     938, -2559,   445,  1420,   801, -2559, -2559, -2559, -2559, -2559,
   -2559, -2559, 21877,  1779, -2559,   821,   330, 19840, 19840, -2559,
   -2559,  1635, -2559,    70, 27816, -2559, 32702, -2559, 15543, -2559,
   -2559,   439, -2559, 21150, -2559,   441, -2559, -2559, -2559,  1437,
   -2559, -2559,   619,   619, 12308,   619,   683, 11198, 12308,  1692,
     654,  1695, -2559, -2559,   853, 19142,   720,  1504,  1511, 22930,
    1441,  1512,  1513, 37239, -2559, -2559, -2559,   772,   118,  1514,
     472, -2559,  1603,  1544, -2559,  1613,   174, -2559, -2559, -2559,
   -2559,   103,  9369,   771, -2559, -2559,  1518,  1501,  1520,  1521,
    1306,   -55,  1450, -2559,  1522,  1507, 39333, 18078,  1523, 37239,
   -2559, -2559,  1530,  1531,  1563,  1819,   522,  1790,  1626,  1535,
     968,  1538, 27816,  1699,    96,   703,  1476, -2559, -2559,  1551,
    1559, 26071,  1561,  1582,  1562, 37239, -2559, -2559,   903, -2559,
   -2559,   498, -2559,  1873, -2559, -2559, -2559, -2559, -2559, -2559,
   -2559, -2559, -2559, -2559, -2559, -2559, -2559, -2559, -2559, -2559,
   -2559, -2559, -2559, -2559, -2559, -2559, -2559, -2559, -2559, -2559,
   -2559, -2559, -2559, -2559, -2559, -2559, -2559, -2559, -2559, -2559,
   -2559, -2559, -2559, -2559, -2559, -2559, -2559, -2559, -2559, -2559,
   -2559, -2559, -2559, -2559, -2559, -2559, -2559, -2559, -2559, -2559,
   -2559, -2559, -2559, -2559, -2559, -2559, -2559, -2559, -2559, -2559,
   -2559, -2559, -2559, -2559, -2559, -2559, -2559, -2559, -2559, -2559,
   -2559, -2559, -2559, -2559, -2559, -2559, -2559, -2559,  1130, 40380,
    1653,  1164,   857, 32702,  1505,    77,  1654, 32702,  1718, 32702,
    1539, -2559, -2559,  1327, -2559, 19491,  1306, -2559,  1510, -2559,
    1546, -2559,  1546,  1546,  1515,  1515,  1516, -2559, -2559, -2559,
    1143,  1546,  1532, -2559, 41078, -2559,   641,   644, -2559, -2559,
    1864,  1874, -2559, -2559, -2559, -2559, -2559, -2559, -2559, -2559,
   -2559,   514,  1102, -2559,  1883, -2559, -2559, 40380, -2559,  1810,
   22930, -2559,  1560, -2559, 32702,   196, 32702,  1724, -2559, -2559,
     219,  1537, -2559, -2559, -2559,   -34,  1290, 22228,  1789, 32702,
    1688, -2559,  1164,  1901, -2559,  1088, -2559,  1649, -2559, 14139,
    1583, 23279,   140, -2559, -2559, -2559, -2559, 40380, 32702, 23279,
     140, 32702, 32702,  1815,  1598, 18078, 39333,    98, 32702, 32702,
   27816, 32702, 32702, 27816, 32702,  1818,   140, 32702, 32702, -2559,
   21150,   467,   570, -2559, -2559, -2559, -2559, -2559, -2559, -2559,
   -2559, 32702, 23279, 32702, 32702, 27816, 27816, 32702,  1619,  1420,
     305, -2559,  1600, 15192,  1668, -2559,   129, 27816,  1719, -2559,
     495, -2559,   458,   503, -2559, -2559, -2559, -2559, -2559, -2559,
   27118, 25373,  1809,    32, 32702, -2559, 12308, 11568, -2559, -2559,
   -2559,  1565, 21150,  1601, 12308, -2559, -2559, 12308, 12308,  1584,
    1584,  1584, -2559, -2559, -2559, -2559,   604,  1584, -2559, 12308,
   12308,  1584,  1584,  1546,  1546, -2559,  2738, 12308,  1584, -2559,
   18078, 12308, 12678,  8649, 12308,  1634,  1636,  1584, -2559,  1584,
   -2559, 12308,  9718, -2559,   853,  1569,  1569,   337,  1198,  5766,
    1571, -2559,  1665,  1584, -2559,  1584,   564, 12308, 22930,  1641,
     131, 12308,  1579,   493, -2559, 12308,   141, -2559,  1580, 12308,
    1644,   132, 12308, 12308, 12308, 12308, 12308, 12308, 12308, 12308,
   12308, 40380, -2559, 13048,   135,   -45,   288, 27467, 10088,  1832,
     977,  8278, -2559, -2559, -2559,  1779, -2559, -2559,  1651, -2559,
   -2559, -2559, -2559,   839, -2559, -2559, -2559, -2559,   956, -2559,
   -2559, -2559, -2559, -2559, -2559, -2559, -2559,  1590, -2559, -2559,
   -2559, -2559, -2559, -2559, -2559,  1591, -2559, 32702,    50, -2559,
   -2559, -2559,  1610, -2559, 25722, -2559, 10458, 32702, -2559, -2559,
    1811, -2559, -2559,  1594, -2559,  4726,  1811,  1754,  1761,  1761,
   -2559,   -38, 21150,  1804, 21150, -2559, -2559, -2559, -2559,   668,
   -2559,  1607,   728, -2559,  1671,  1673,  1713, 32702, 32702, -2559,
   22930, 32702, 32702, -2559,  1927,  1618, 32702,  1823,  1824,  1621,
   -2559, -2559, 32702, -2559,  1781, 32702, 12308,  1782, 32702,  1783,
     518,  1775, -2559, -2559, -2559, -2559, -2559,  1771, -2559, -2559,
   41078,    93, -2559,   940, -2559, 28165, 38984, -2559, -2559,  1102,
   -2559,   227,  1690,  1691,  1730, 32702, 32702, 32702, 32702, -2559,
   32702, -2559,   699, 32702, 32702,  1628,  1630,  1631, -2559, 32702,
   -2559,  5162, 32702, 32702, 32702,   857, -2559,  1973,   857,   857,
     443,  1976,  1327,  1327, -2559, -2559, -2559, 32702, 32702, 32702,
   28514, 32702, 32702, 28863, -2559, 27816, 32702, 32702, 32702,   160,
    2116, 32702, 32702,  1757, 32702, 32702, 32702, -2559,  5162,   156,
    1768, -2559, -2559, -2559, -2559, 12308,  1857,  2000, 32702,  1860,
    1865,  1696, 39333,    -1, 32702, 32702,  1866,    -1,   952, -2559,
   -2559,  1808,    61, -2559,  1672,   990, -2559, -2559, 12308,  2011,
   40380,  1663,  1666,  1727,  1729,  1733, -2559, -2559,  1734,  1584,
   -2559,  1441,   219,   845, -2559,  5162,  1922,   992, -2559,  1686,
   27816,  5162, -2559,  1373, 25373, -2559, -2559, -2559, -2559, -2559,
   -2559, -2559, -2559,  -129, -2559, -2559, -2559,  1826,  1820, 32702,
    5162,  1819, 27816, 24326,  1178,  2029,  1919,  -129,  1831, 27816,
     547, -2559,  1920,  1923,  1938, -2559, 13788, 30259,  1682,   139,
   -2559, 30259, 30608, -2559,   853, 12308,  1668,  1130, -2559,  2043,
   -2559,  1164, -2559,  1339, -2559, 32702, 32702,  1693,  1694, -2559,
    1339,  1842,   140, -2559,  1846,   140,  1339, 22228, -2559,    69,
   -2559, -2559, 12308,  1769,  1339,  1697, -2559,  1164,  1339,  1339,
    1420,  1420,  1339, 30957,  2062,  1947, -2559,   997, -2559, -2559,
   10088, -2559,   240, -2559,   259,   296,  1888, -2559, -2559, -2559,
   -2559, 40380, -2559, -2559, -2559, -2559, -2559, 32702,    51,  1856,
    1703, 30957,  2046,   140, -2559,   998,   -90,   896, -2559,  1584,
   12308,    75, -2559,  5888,   999,  6340,  1012,  1712,  1715,  1020,
   -2559, -2559, -2559, -2559, -2559, -2559, -2559, -2559,  1716,  1963,
    1723,  1026,  1027,  1728,  1735, -2559, -2559,  1999,  1034,  1737,
    6715,  1738, 12678, 12678,  2087, -2559, -2559, 12678,  1739, -2559,
    1059,  3119,  1710,  1740,  1744,  1745,  1741,  1742,  6768, 11938,
   12308, 11938, 11938,  7003,  1710,  1743, -2559, -2559, 12308, 32702,
    1748,  1749, -2559,  2738, -2559,  1756, -2559, 12678, 12678,  2384,
   10828, -2559, -2559,  1983, -2559,   995, -2559,  1746, -2559, -2559,
    3399,   134, 12308,  1579, 12308,  1807, 18078, 21022, 12308,   705,
    2502,  2502,   252,   252,    80,    80,    80,   115, -2559,   288,
   -2559, -2559, -2559,  1752,  1423, 12308, -2559,  1311,  1338, 27816,
    3244,  3569, -2559, -2559, -2559, 14139,  1583, 12308, 12308,  1753,
   -2559,  1061,   498, -2559,  1584,   564, 20202, -2559, -2559,  1064,
   15543,  1583, 10458,   853, -2559, -2559, -2559,  1070, 12308, -2559,
   -2559,  1911, -2559, 32702,  1719,  1719, 12308, 12308, 11198, -2559,
   -2559, 40380, 32702, 32702, 32702, -2559, -2559, -2559, -2559, -2559,
    1950, -2559, 12308,   299,  1755,  1760, 32702,   140, -2559, -2559,
   21150, -2559, -2559,  1977, -2559, -2559,  1921, -2559,  1102, -2559,
   25024, 40729, -2559, 40729, -2559,   825, 32702, 32702, 32702, -2559,
    1339, -2559, -2559, -2559, -2559, -2559,   913, -2559, 40380,  1900,
   39682, -2559, 32702,  1962, -2559, -2559, -2559,  1903,   144, -2559,
   -2559, -2559, -2559, -2559, -2559, -2559, -2559,    20, 32702, -2559,
    1584,  1904, 32702,  1817, -2559, -2559, -2559, -2559, -2559, -2559,
     857, -2559, -2559, -2559, -2559, -2559, 32702,   857,   857, -2559,
   40380,    72, -2559, -2559, -2559, -2559,   140,   140, -2559, -2559,
   -2559, -2559, -2559,  1835, -2559, -2559, -2559,   298, -2559, -2559,
   -2559,  1836, -2559, -2559, -2559, -2559, -2559, -2559,  7131,    -1,
   40380,  1980,    -1,    -1, 32702,  1776, -2559, -2559, -2559,  1987,
    1989,    -1, -2559, -2559, 32702, -2559, -2559, -2559,   -44,  1175,
   16248, -2559,  1801,  7150,  1784,  1666,  1780,  1584,   696,    86,
      89,  1881,  1968,  1786,  1940,  1993,  1805,  1805,  1805,  1805,
    1805, -2559,  1016,  1850, -2559, 22930, 16248,  1290,   196,  1912,
     686, -2559, 27816,   219,  1073, -2559, 40380,  1799, 27816,  1802,
    1795, -2559, -2559, -2559, -2559,  1076, -2559, 40380,   -29,  1956,
    1955,   619, 32702,  1868, 27816,  1851,  -129, 22228, 40031,  1123,
   -2559, -2559,  1959, -2559, -2559,   619,  9020,   139,  1816, 32702,
   -2559,  1812, 14139,  2018,  1954, -2559, 14139,  1954,   747,  1954,
    2026, -2559, 15894, -2559,  1821,   977,  4817, -2559, -2559,   140,
   40380,   140,  1862,   140, 39333,   140, 27816, -2559, 27816, -2559,
     140, -2559, 21150, 27816, 23279, -2559, 32702,   475, -2559, -2559,
    1967, -2559,   619, 32702,   853,  1822, -2559, -2559, -2559, -2559,
    2086,  2090, -2559, -2559, -2559, 32702, 26769,   133, 32702, -2559,
   -2559, -2559, -2559,  1830,  1829,  7245, 12308, -2559,  2097, 40380,
   -2559, 32702, -2559, -2559, -2559, -2559,  1584, -2559, 12308, -2559,
   -2559, -2559, -2559, -2559, 12308, -2559,  1584, -2559, 12308,  2082,
   -2559,  1834,  1834, 12678,   511,  1413, 12678, 12678, 12678, 12678,
   12678, 12678, 12678, 12678, 12678, 40380, 13418,  1336, -2559, -2559,
   12308, 12308,  2088,  2082, -2559, -2559, -2559,  1330,  1330, 40380,
    1838,  1710,  1839,  1843, 12308, -2559,   853,  7456, -2559,  2170,
    -129, 12308,   674,  1245, 12308,  1085, 12308,  2095, -2559, -2559,
    1847, -2559, -2559, 40380, 12308, 12678, 12678,  3663, -2559,  4100,
   12308,  1848,  4334, 10828, -2559,   242,   242,   242,   242, -2559,
   27816, 27816,  1682,  2092,  1095,  1105, -2559, -2559,   330,  1853,
   -2559, -2559,  1861, 32702, -2559,  1668, -2559, -2559, -2559,  1855,
   -2559, -2559,  1339, -2559, -2559, -2559, -2559, -2559, -2559, -2559,
   -2559, -2559,  1805,  7496, -2559, 32702, 32702,  1121, -2559, -2559,
    2080,   899, -2559, -2559, -2559,  1916, -2559, -2559, -2559,  1932,
    1933, -2559,  1939, -2559, -2559,  1339,   723,  -129, 32702, 32702,
   -2559, -2559,  1339, -2559,  -129,  1339,  -129, -2559, -2559, -2559,
   -2559, -2559,   136,   497, 40380, -2559, -2559, -2559, 32702, 32702,
   -2559, -2559,  1879,    -1, -2559, -2559,  2093,  2094,    -1,    -1,
   -2559, -2559,   214, -2559, -2559,  1655,  1655,    45, -2559,  1655,
   -2559,  1655, -2559,  1855,   839, -2559, -2559, -2559, -2559, -2559,
   -2559, -2559,  1672, -2559,   517,  1584,  1331,  1882, -2559,  1885,
   -2559, -2559, -2559, -2559, -2559, -2559, -2559,   564, 27816,  1805,
   -2559,    85,    63, 31306, 31655, 32004,  1887, 32702, 12678, -2559,
     537,   111, -2559,  2096, 27816,  1924, -2559, -2559, -2559, 40380,
   -2559, -2559,  2240,   570, 27816,  2145,  2040, -2559, 32702, -2559,
   24326, -2559,  2126, 24326, -2559, 32702, -2559, -2559, -2559,  2226,
    1982,  1204,  1957,  1102,  -129,  1851, 32702,  1914, -2559,  1910,
   -2559,  1509, -2559,  1306, -2559, -2559,    78, -2559, 30259,  1925,
   32702,   139, 14139, -2559, -2559,  2134, -2559, 14139,  2127, -2559,
   14139, 32702,  1928, 32702, 12308,  1941, -2559,  1929, -2559, 32702,
   -2559,  1934, -2559,   140,   140, -2559,  1936, -2559, -2559,  2165,
   30957, -2559, -2559, -2559, -2559, -2559, -2559,    32,  2171, -2559,
   -2559, -2559, -2559, 12308, 21150, -2559,  1937,  1942,  1944, 21150,
   20850,  1946, 21150,  2088,  2119,  2178,   123,  1951,  2119,  2627,
    2627,  1140,  1140,   946,   946,   946,  1834, -2559,  1336, 21150,
   21150, -2559, -2559, -2559, -2559,  1949, -2559, -2559, -2559,  1710,
   -2559, -2559,   564,  1569, 12678, 12678,   994, -2559,   270, 12308,
   40380, -2559,  1127,   994,  1499,  1552, 12308, 12308,  4427,   137,
   12308, 20888, 27816, 27816, 27816, 27816, -2559, -2559,  2269,  2294,
   -2559, -2559,  -129,   337, -2559, -2559, 18078,   723, -2559,  1161,
    1162,  1924, -2559,  1994, -2559, 32702, 32702, 32702, -2559, -2559,
    1339,  1339, -2559, -2559,  1016,  2101,  2115,   723, 32702,  2002,
   -2559, -2559,  2168, -2559,    -1,    -1, -2559, -2559, -2559,  1327,
    2241,  -129,  -129,  2121, 32702,  -129,  -129, -2559,   695,  2249,
   -2559,  2189,   421,  1970,  2213,  2214, -2559, -2559, -2559,  2221,
     723, -2559, -2559, -2559, -2559, -2559, -2559, -2559, -2559, -2559,
   -2559, -2559, 12308,   925,  2119, -2559, -2559, -2559, -2559,  1924,
    1290,  2016,  2019,   619,   -31,  2251,  2243,   219, -2559,  1981,
     164,  1997,  1178, -2559, -2559, -2559,   147, 32702,  2333,  2314,
    2323,  2146, -2559, 32702,  2206,  1441,  2255,  2007, -2559, 14490,
    -129,  1123, -2559, -2559, -2559, -2559, -2559,  2064, -2559, 32702,
    1173, -2559, 12308,  2017, -2559, -2559, 14139,  2134,  1202, 32702,
    1208, 40380, 20907,  2174,   140,   140,   140, -2559, -2559, 32702,
    1178,  2167, -2559,   140, 30957, 21150, -2559, -2559, -2559, -2559,
   -2559, -2559, 12678,  2271,  2023, 40380, -2559, -2559,  2574,  2574,
     270,  1210, -2559, 40380, 12678, 12678,   994,   994, 12308,   994,
   -2559, -2559, -2559, -2559, -2559, 12308,  1393,  2204,   564, -2559,
    2027, -2559,  2152,  1924,  2016, -2559, -2559, -2559, -2559, -2559,
   -2559, -2559, -2559, 12308, -2559,    -1, -2559, -2559, -2559,  -129,
   -2559, -2559, 32702,  2030, -2559, -2559, -2559, -2559, -2559, -2559,
   -2559, -2559, 23279,  2386, 27816,   517, -2559, 20936,  2195, -2559,
    2016,  2227,  2266, -2559, 32702,  1204, 24326, -2559,   884,  2169,
   -2559,  1178,   171,   776, -2559, 27816,  1955,  2144, -2559,  2147,
   -2559,    57,  2193,  2194, -2559, -2559,  -129, -2559, 32702, 14490,
   12308,  1218, -2559, 32353,  7924, -2559, -2559, 27816,  1230, -2559,
   21150, 32702, -2559, -2559, -2559,  1241, -2559,  1584, 12308, -2559,
   -2559, -2559,  1955, -2559, -2559,   133,  1387, 12678, 40380,  1252,
   -2559, -2559,  2574,  2574,   994,  1710, -2559,  1584,  2230, -2559,
   -2559, 27816,  2016, -2559, 21150, -2559,  1175, -2559,  2030,  2386,
     505, -2559, -2559,  2306, -2559, -2559,    64,  2203,  2124,  2412,
   -2559, -2559, -2559, -2559, 23279,  1955, -2559, -2559, -2559, -2559,
   -2559, -2559,  1257,  1982, -2559, -2559, 32702, -2559, -2559, -2559,
   -2559, -2559,  1262, 20979,  1924, 14490, 32702, -2559, -2559, -2559,
    1583, -2559,  1263, -2559, -2559, 21150,  1982, -2559,  1387,  1279,
   -2559, -2559,  1584,  2302,  1290, -2559, -2559, -2559, -2559,  2336,
   -2559, -2559, -2559,   204, -2559,  2216,  2217, 32702,   461,  2068,
    1982, -2559, -2559,   826,  1924, 32353,  1982, -2559, -2559,  2341,
   -2559,  2422, -2559, -2559, 12308, -2559,  2227,  2177,   114,   114,
    2360, -2559,  2130, -2559, -2559,  1584,  1584, 40380,  2089, -2559,
   21522, -2559, -2559,  1982, -2559,  1583,   183,  2356, 21150,  2203,
    2358, -2559,  2462, -2559,   105, -2559, -2559, 23279, 18078, -2559,
     461, -2559, -2559, -2559, -2559,  1282, -2559, -2559, -2559,  1583,
   -2559, -2559, -2559,   587,   517,  2224, -2559, -2559, -2559,  1164,
     -25, -2559, -2559, 21522, -2559, -2559,   955, -2559, -2559, -2559,
   -2559, -2559, -2559, -2559, -2559, 23279, -2559, -2559, 39333, -2559,
   -2559,   701, -2559, -2559,   840,  1093,  2100,  2103, -2559,   955,
   21522,  2223, -2559,  1284, -2559, -2559
};

/* YYPGOTO[NTERM-NUM].  */
static const yytype_int16 yypgoto[] =
{
   -2559, -2559, -2559,  1909, -2559,  -594,  -774, -2559, -2559, -2559,
   -2559, -2559, -2559, -2559, -2559, -2559, -2559, -2559, -2559, -2559,
   -2559,   908, -2559, -2559,  -418,  1294,  1608, -2559,   665, -2559,
   -2559, -2559, -2559,  -517, -2559,   360, -2559, -2559, -2559, -2559,
   -2559, -2559,   972, -2559,  -557,   556,  -459, -2559, -2559, -2559,
   -2559,   510,  -219, -2559, -2559, -2559, -2559, -2559, -1092,     7,
     124, -2559,   128,   996,   210, -2559,   -87, -2559, -2559, -2559,
   -2559,  -392,   647, -1152, -1795,   523,  -394,  -416,  -372,  -370,
    -389, -2559, -2432, -2144, -1589, -2470, -2559,    81, -2559,   138,
   -1090, -2559,  1358, -2559, -2559,  -827, -2559,   -21, -2559, -2559,
     -99, -2559, -2559, -2559,   241, -2559, -2559, -2559, -1085, -2559,
     957, -1930, -2559, -2559, -2559,  -462,  -432, -2559, -2558,   -42,
     -37, -2559, -2559, -2559, -2559,  -674, -2559,   520,   521,  -624,
   -2559, -2559, -2559,   541, -2559, -2559,  -404,  1389,  -452, -2559,
   -2559, -2559, -2559, -2559,  1333,  -124, -1107, -2559, -2559, -2559,
   -1415, -2559,  2515,  2033, -1078, -2559,     6,    10,  1793,  -750,
   -1644,   112, -2559, -2559, -1219, -2559, -2559, -2559, -1598, -1077,
   -2559,   158,  -218,  -301, -2514, -2559, -2559,  -714, -2559,   676,
    1091,  1094, -2559, -1369,   159,  -499, -1965, -2559, -2263, -2559,
   -2559, -2559, -2559, -2559, -2559, -1184,  -433, -2559,  -257, -2559,
   -2559, -2559, -2559,   460, -2559,   182, -2559, -2559, -2559, -2559,
   -2559, -2559,  -390,  -425, -2559, -2559, -2559,   101, -2559, -2559,
   -2559,  1080,  -631,  -519,  2008, -1073,  -178, -2559, -2559, -2559,
   -2559, -1845, -2559, -2559, -2559, -2559, -2559, -2559, -2559,  -975,
   -2559, -2559, -2559,  1174,  2550,  -383, -2559, -2559, -2559, -2559,
   -2559, -2559, -2559, -2559, -2559, -2559,  1837,  -323, -2559,    36,
   -2559, -2559,   468, -1551,    37, -2559, -2559, -2559, -2559,  -581,
      41, -2559,   742, -2559, -2559, -1315, -2559,  1844, -2559, -2559,
      17,     0,   -39,   597,   751, -2559, -2559,   -30,  1114, -2559,
   -2559, -2559, -2559,   735,  1657, -2559,   730,  -303, -2559, -2559,
   -2559, -2559, -2559,  1661, -2559, -2559,  1667,  1172, -2559,  1199,
     774, -1564,   974, -1531,   524,  -376,   -56,     2,  2138, -2559,
   -1767, -2262,   216,  3389,  1040,  -980, -2559,  3171,  3537, -2559,
   -2559,  -680, -2559, -2559,  3697,  3793, -2559, -2559,  3925,  4295,
   -2559,  -668,   408,  4523,  2326,  -798, -1289,  3097,   727,   224,
   -1128, -2559, -1035, -2559,  -133, -2559,  5091,   761, -2559,  -719,
   -2559, -2385, -2559, -1200, -2559, -2559, -2559, -2559, -2559, -1437,
   -2041,  -336,   818, -2559, -2559,   904, -2559, -2559, -2559,  -623,
    -570, -1286,   823, -1297, -2559,  -576,   936,  1259,   202,  -505,
    2618,  -340,  1317,  -387, -1590,  -834,  -610, -2559,  -134, -2559,
   -1030,   352,   -35,   -19,    48,  4551,  -902, -1091,  1895,  -625,
    -560, -1195, -2559
};

/* YYTABLE[YYPACT[STATE-NUM]].  What to do in state STATE-NUM.  If
   positive, shift that token.  If negative, reduce the rule which
   number is the opposite.  If zero, do what YYDEFACT says.
   If YYTABLE_NINF, syntax error.  */
#define YYTABLE_NINF -1535
static const yytype_int16 yytable[] =
{
     135,   497,   690,  1656,  1190,   923,   570,   497,   758,   604,
     558,   424,  1638,   614,  1605,  1002,  1151,   134,   631,   447,
     608,  1211,   612,  1162,  1083,  1252,  1300,  1762,  1086,   880,
     886,   503,   724,   924,   641,  1571,   129,   130,   873,   535,
     970,   132,   682,   536,   562,   569,  2083,  2117,   996,  2223,
    1470,  1623,  2057,   893,  1106,   409,   417,  1698,  1365,  1579,
     963,   409,   409,  1586,  2235,  1587,   409,  2101,   409,   505,
    1588,  2257,  1828,   716,   409,  2078,   409,  1589,  1590,   526,
     532,   505,  1591,   539,  2404,   532,   532,  1182,  1145,  1084,
    2071,  2073,  1148,  2376,  1170,  1429,  1882,  1884,  1153,  1836,
     742,   108,  2601,  1161,  1163,  1319,  -187,  1833,  1183,  1183,
   -1063,   422, -1340,   615,   950,  2681,  1273,   634,  1265,  1266,
   -1416, -1446,  1310,   720,   642, -1462,   875, -1363,   727,   884,
   -1485,  2481,  1982,  1232,  1672, -1058,   735,  1183,   744,   776,
    1319,   942,  1285, -1218,  1559,  1312,  1800,  2584, -1234, -1218,
    1505,   617,  1801,  2931, -1234,  1766,   636,   638,  1766,  2648,
    1692,  2650,  2352,  2353,  2354,  2355,  2846,  2633,   954,  2581,
    2292,  1781,  1183,  1815,  2115,  2126, -1418,  2823,  1442,  1183,
    2756,  1846,   937,  1602,  1986,  1347,  1602,   746,  2880,  2957,
     876,  2386,   609,   611,   609,  2951,   616,  2597,   409,   633,
     616,   409,  1443,  1236,   409,   409,   609,   616,  2063,   420,
     414,  1955,  1976,  1965,   540,   943,   705,  2673,   537,  1206,
    1443,  2340,  1528,  1804,   509,   414,  2977,  1764,  2792,   414,
    1094,  2634,  2836,  2280,  2813,   887,  2757,  1673,  1543,  1707,
    1708,  1709,   944,   414,   414,  2758, -1341,  1720,  1480,  1101,
    1102,  1723,  1724,  2563,   506,  1002,  2837,  1736,  1728,   955,
    2859,  1583,  1452,  2064,   140,  1540,   999,  1746,  2704,  1747,
    2825,  2752,  2341,   938,  2278,  2343,   419,  1319,  1782,  1209,
     140,  2121,  1783,  1760,   888,  1761,  1479,  1652,  2065,   140,
    2799,   678,  2564,  2908,  1350,  1319,   141,   541,  2881,  1544,
     772,  1086,   631,  2066,  1083,  -272,  2753,   683,  1594,   509,
    1806,  2067,   141,  1319,  2932,  1784,  2838,  1150,  2958,  2835,
     697,   141,   711,  1584,  2598,    36,  1444,  1805,   718,  1300,
    1184,  1184,   631,    36,  1453,  2068,  2740,  2952,  1603,  1847,
    2674,  2746,  2875,  1150,  2545,   603,  1435,  2978,  2106,   603,
    2882,   414,   509,  2293,  2635,   739,   414,   414,  1975,  1184,
    2342,   706,  1885,  2344,  1454,  1357,   945,  2108,  2776,  1084,
    1533,  1987,  1595,   509,  1575,  2933,   511,  1539,   946,  1581,
    1956,  2924,    44,  2104,  2306,  1197,  2759,  2785,  1000,  1600,
      44,  2294,   947,   756,  1184,  2934,  2974,  1674,   686,   948,
    1260,  1184,   692,  1348,  2069,  2636,  1516,  2527,   939,  1192,
    2279,   698,  1675,  2869,  1700,  1230,   509,   956, -1063,  1437,
   -1218,  1233,  2671,  1802,  1243, -1234,  1785,  1830,   756,    45,
    1767, -1535,  1557,  2205,  1384,  1273,  1253, -1063,   509,  1237,
    2812,   949,   836, -1058,  1265,  1266,  1208,  1237,  1340,  1323,
    1324,    45,  1455,  1285,  1341,  1150,   940,   562,  1610,   509,
    2529,  2530, -1058, -1340,  1536,   743, -1340,   745, -1340,   747,
   -1340,  2186,  1313,   748,   409,  1192,  1966,   611,   575,   609,
    1559,   616,  -187,   633,   493,   616,   694,   409,  1623,  1341,
     409,   494,   609,   643,   616,   965, -1416, -1446,  2411,  1327,
     409, -1462,  2415, -1363,  2580,   409, -1485,  2567,   611,  1553,
    2440,   409,  2263,   633,  2264,  1433,   409,   409,  1394,  1088,
    1933,   409,   409,  2107,   409,  1083,  1091,   609,  2877,   576,
     631,  2909,  1352,   493,  1488,  2236,  2230,  1695,  1696,  2003,
     494,  1438,  2109,  2558,   512,  1440,  1596,    15,  1704,  1706,
    1098,  1490, -1418,   455,  2301,  -990,  1446,  2304,  2305,  1608,
    1721,  1722,   557,  1470,  2110,  1149,  2310,  2046,   409,  1435,
     409,  1172,   135,   768,  1740,  1742,  1505,  1527,   644,  1168,
     910,  1446,  1436,  1353,  1506,   942,  2915,  1773,   432,   134,
    1084,  2896,   532,  1563,   881,   532,  1857, -1341,  1194,   577,
   -1341,  1480, -1341,  2567, -1341,  2465,  1874,  1774,   129,   130,
     897,    22,  2843,   132,   519,  1725,  1726,  1337,  1338,  1339,
    1340,  2327,  1439,  2111,  2595,   414,  1341,   603,  1934,  2569,
    1935,  2923,  1821,  1335,  1336,  1337,  1338,  1339,  1340,   899,
     434,  1519,  1437,  1563,  1341,  2878,  1664,  2327,  2866,  1564,
    1606,  1335,  1336,  1337,  1338,  1339,  1340,   414,   603,   943,
     673,   643,  1341,   911,   603,  2568,  2404,   609,  1928,  2124,
    1150,  1931,  1932,   108,   565,  2596,    15,  2750,  1875,  2402,
    1447,  1756,  1192,  1710,  2525,  2916,   944,  1623,   755,   702,
    2494,  2890,   968,  1083,   578,    32,   432,  1736,  1736,  1564,
    1565,  1775,  1736,  1566,   409,  2546,  1776,  1001,   414,   567,
    1777,   633,  2463,   409,  2047,   414,   571,   969,   409,  2466,
    1660,  1661,   609,  1628,   916,  2569,   414,  1086,  2467,   409,
    1319,  1632,  1736,  1736,    36,  1320,  2482,   609,  1639,  1711,
      22,   520,   135,  1212,  1448,   414,   644,  1648,   434,   942,
    1565,   609,  1171,  1566,   409,   756,  2917,   135,  1084,  1219,
     414,    14,  1637,   414,  1438,   572,   440,    15,   441,  2723,
     609,  2261,   675,   409,  1235,   573,   414,   934,  1215,  1216,
    1258,   917,  2726,  1217,   881,    42,   581,    18,  1567,  2547,
    1712,    44,  2548,  1713,  2229,  2331,  2965,    27,  1275,  -281,
     409,  1630,   570,   409,   505,  1083,  2628,   521,   409,  1778,
    2048,   992,   409,  1687,  1395,   652,  2439,  1779,  1396,  1435,
    1249,  2331,   946,   943,   409,   918,  1255,   882,  1303,   917,
      45,    22,  1436,  2727,   631,  2154,   947,  2839,  1567,  2655,
    1651,  1308,  1321,   948,  1652,  1439,  1322,  1355,  2641,  2663,
     944,  1633,  2440,  2645,   414,   603,  2647,  1729,  1640,   993,
    1568,  2840,   603,    36,  1646,  2372,  1323,  1324,  1680,   761,
    1084,  2064,  1681,   918,   440,  2437,   441,  2638,  1714,  1325,
    1192,  1654,   677,  1658,  1659,   949,  1569,  1662,  2553,   777,
    2283,  -916,  1437,  2556,  2557,    36,  2065,   878,  2155,   927,
    2431,   414,   414,   414,  2005,  1359, -1317,   603,  1937,  1938,
    1568,  2417,  1399,  1399,    42,  1399,  1327,  2081,  2524,  2067,
      44,  2841,   928,  2451,  1579,  1894,  1586,  2818,  1587,  1328,
     881,  1407,   958,  1588,  1623,   881,   881,   699,  1623,  1174,
    1589,  1590,  1158,  2095,  1386,  1591,  1393,  2006,  -916,   680,
    1715,  1408,    44,  1424,    36,  1716,   414,  1717,   960,  2966,
     681,  1159,   700,   699,   522,   523,  1408,  2337,  2339,  1541,
     936,  1260,  2356,  1546,   945,  1518,  1425,   414,  1470,  1119,
     961,   532,  1295,  1175,  1296,  1295,   946,  1296,  2374, -1063,
    1330,    45,  -916,  1523,   971,  1409,   691,   701,   972,  1360,
     947,  1426,   997,  2079,  1472,    42,  1480,   948, -1063,  2358,
    1409,    44,  2069,  1297,  1438,   633,  1299,   532,   750,  1319,
    2795,   973,  1505,   701,  1320,   467,  2007,  1473,  1511,  1104,
     835,  2181,   703,  2156,  2157,  2158,   751,  2159,  2160,  2161,
    2162,  2163,  2164,   532,    15,  1859,  1519,  1627,  2165,   949,
      45,  2195,  1474,   836,  2075,  1631,   704,  1837,  2578,  1176,
     713,  1331,   631,  2356,  1332,  1333,  1334,  2338,  1335,  1336,
    1337,  1338,  1339,  1340,  2988,  1150,  2357,  2989,  2008,  1341,
     493,   989,  2782,   739,  1650,   160,  1310,   494,  1657,  2197,
     421,     3,     4,  2899,   958,  1439,   414,   480,  2224,  2225,
    2358,  1850,  2359,  2287,   990,  1851,  2458,  1177,    22,  2198,
    2289,  2290,   994, -1043,   538,    32,  2461,   959,  1736,  1582,
     960,  1736,  1736,  1736,  1736,  1736,  1736,  1736,  1736,  1736,
    2090,  1736,  1271,  2738, -1037,  1322,  1890,   995,  2362,  2716,
    2717,   609,   961,  2046,   725,   609,  2269,  1550,  2009, -1070,
    2010,  1529,  2831,  1277,  2829,  1323,  1324,   631,  2950,  1508,
    1530,   942,  1512,  2325,  2360,    27,  1517,  2363, -1070,  2270,
    1736,  1736,  1361,  1362,   509,  2832,   736,  2364,   493,  1617,
    1178,  1531,  2964,  2087,   414,  1363,  2089,  1283,  1284,  2325,
    2091,  1823,  2265,   414,   570,  1311,   749,   934,   740,  1295,
    1430,  1296,   616,  2677,   409,  1327,  1316,  2313,  2199,  1362,
    1756, -1073,  2200,   906,   493,   881,  -883,  1171,  1328,  1653,
    1295,  1363,  1296,   648,  2361, -1040,  1246,  1247,   649,  2362,
    1297,    36, -1073,   569,  2119,   943,   611,  1369,   749,   409,
     409,   754,   135,   633,  1288,  2314,   409,   409,  2365,   409,
     409,  1299,   409,   764,  2892,   609,   609,  1689,  2363,  1686,
    1688,  2495,   944,  2243,  2244,  2315,  2533,  2122,  2364,   409,
     931,   409,   409,  2123,  1430,   409, -1340,  2901,  1683,  1684,
    2316,  1669,    42,  1685,  1623,   753,  2625,   509,    44,  1623,
    2047, -1341,  1623,   932,  2317, -1342,    32,   769,   505,   505,
    2815,  2921,  1694,  2228,  -891,  2573,  1315,  2925,  2318,   509,
   -1343,  2201,   770,  1879,  2164,   762,  -891,  1880,   933,  2202,
    2165,  2582,  1771,  1736,   408,  1983,   531,    45,  1824,  1984,
     453,   454,   556,   771,  2949,   481,   772,   496,   633,  2365,
    2561,  2562,   773,   515,  2565,   518,  2566,   648,   778, -1320,
    1331,   774,   649,  2211,   684,  -891,   685,  1335,  1336,  1337,
    1338,  1339,  1340,  1991,  2387,  2014,  2448,  1992,  1341,  2015,
    2102,  2120,  2130,  -891,  2103,  1652,  1652,   775,   934,  2483,
    2484,  1624,   687,   603,   688,  2132,   945,   779,  2319,  1652,
    1083,   603,  1855,  2135,   885,  2320,  1858,  2136,   946,  2140,
    2141,   889,   414,  1652,  1652,   414,  2154,  2145,  2258,  2809,
    1869,  2146,   947,  2180,  1971,  2182,  2183,  -891,   890,   948,
    1979,  1980,  2321,   891,   603,  -891,   898,   414,   414,  1612,
    2330,  1613,  2169,   428,  2227,  1393,  1652,  2232,  1652,   414,
    1889,  2233,  1891,  2237,   899,   409,  2377,  1192,  2741,  2384,
    2378,   900,  1086,  2385,  1901,  1084,  2330,  1925,  2497,  1736,
    1736,   949,  1652,   906,  2403,  2489,   907,   618,  2520,  2155,
     635,   914,  1652,   639,   640,   616,   409,   929,  2521,   616,
     611,  1756,  1652,  1257,   409,    45,  1959,  2296,  2297,  1962,
     409,  1964, -1342,   616,  2531,   964,   409,  2154,  1984,   432,
    2682,  2773,   925,  2242,  2683,  2161,  2162,  2163,  2164,  1400,
    1402,  2082,  1406,  2819,  2165,  2684,  1735,  -586,  1623,  2038,
    -891,  2039, -1343,   616,   409,   616,   409,   967,   409,  2046,
    2400,   409,  1897,  -891,  2702,  2703,   952,   616,  1984,  1984,
     616,   409,   409,  2245,  2246,  -891,  2779,   942, -1535,   414,
    1192,   434,  2619,  2620,  2621,  1940,  1941,   409,   409,   409,
    1947,   409,  2275,  1756,   409,   409,   409,   966,  2685,   616,
     409,   906,   616,   409,   616,  2784,  -890,   570,  2282,  2378,
     974,  2786,  2285,  2800,  -891,  2378,   609,  2683,  -890,   991,
    2020,  2854,   609,   609,   976,  2855,   414,  1002,   998,  2019,
     977,   835,  -891,  2861,  2156,  2157,  2158,  1192,  2159,  2160,
    2161,  2162,  2163,  2164,  2863,  2215,  2056,  2216,  2378,  2165,
    2426,   943,  2428,  1089,  2430,  2870,  2432,  -890,  1092,  2683,
    2891,  2435,   505,  1097,  1237,  2894,  2900,  1736,   978,  2855,
    1192,  2773,  2217,  1108,  2218,  -890,  -891,  2026,   944,  1736,
    1736,  2037,  2902,   631,  -891,  2962,  2683,  2995,  2449,  2963,
    2154,  2963,  1099,  1401,  1401,  2061,  1401,  1105,   934,  2061,
    2074,  1295,  2574,  1296,  2575,  1146,  2047,   440,  1150,   441,
     979,  1156,  1154,   609,  1897,   980,  -139,   442,   981,  -890,
     913,  2416,   915,  2419,  1167,   881,   445,  -890,  1179,  2159,
    2160,  2161,  2162,  2163,  2164,  1181,  1187,  1186,  2240,  1188,
    2165,   616,  1189,  2154,  1191,  1195,  1192,   414,  1196,  1198,
    1825,  1199,  2906,  2155,  1200,  1201,  1202,  2773,  1203,  2632,
    1204,   570,  1207,   982,  1242,   409,  1244,  1248,  1256,   616,
    1264,  1250,  1251,   679, -1028, -1035,  1267,  1345,  1268,  -891,
    2159,  2160,  2161,  2162,  2163,  2164,   695,  2864,  1269,   696,
    1270,  2165,  1736,  1274, -1025,    45,  1276,  1279, -1026,   707,
    1308,  1280,   945,  1281,   712,  2447,  2155,  2871,  1282,  1287,
    2220,  2221,   414,  1771,   946,  1290,   729,   983,  1291,  1292,
     731,   733,  -890, -1029,  2987,  1293, -1027,  1237,   947,  1358,
    1294,  1301,  1302,  2214,   414,   948,  1351,  2188,  1383,  1397,
     916,   414,  2288,  1419,  1427,  1617,  1430,  2249,  1624,  1450,
     958,  1428,  1431,  1432,  1445,  1449,  1451,  1482,  1475,  1476,
    1477,  1478,  1483,  1489,   633,  1494,  1484,   765,   456,   766,
    1492,  1493,  2903,   984,  1505,  1515,   960,   949,  1509,  1510,
     457,  2266,  1513,  1520,  1525,   835,  1495,  2240,  2156,  2157,
    2158,  1521,  2159,  2160,  2161,  2162,  2163,  2164,   985,  1522,
     458,  1524,  1526,  2165,   881,  1538,  1545,  1542,  1393,  1547,
    1551,  1260,  1558,  2240,  1560,  2937,  2938,  1271,  1277,  1317,
     459,   409,  1572,  1561,   430,  1978,  1496,  1580,  1319,  1978,
     616,   409,   409,  1320,  1288,  1593,   460,  1607,   835,  1599,
    1609,  2156,  2157,  2158,  1550,  2159,  2160,  2161,  2162,  2163,
    2164,  1611,  1615,  1625,   461,  1635,  2165,  1636,  1647,  1663,
    1670,  1678,  1691,  1666,   616,   409,   409,  1699,  2540,  2541,
    1700,   836,  1744,  1341,  1745,  2021,  1759,  2699,  1758,  1765,
     409,  1770,  1786,   462,  1788,  1815,  1735,  1735,   463,  2043,
    1657,  1735,  1497,  1822,  1827,  2718,   409,  1826,   576,  1832,
     409,  1838,   464,  1090,  2657,  2658,  2805,  1842,  1843,  1848,
    1849,  1852,  1095,  1853,   609,  1854,  1860,  1096,  1864,  1865,
    1862,  1735,  1735,  1866,  1868,  1871,  1873,  1876,  1144,  1877,
    1886,  1887,  1888,  1899,  1498,  1898,  1499,  2457,  1900,  1929,
    1321,   414,  1936,  1961,  1322,  1317,  1967,  1624,  1969,  1500,
    1970,  1972,  1897,  1173,  1319,  1974,  1973,  1981,  1985,  1320,
    1994,  1990,  1550,  1997,  1323,  1324,  1998,  1999,   606,  2000,
    2013,   135,   606,  2001,  2002,  2016,  2023,  1325,  2022,  2041,
    2042,  1501,   465,  2044,  2053,   135,  2055,  2054,  2391,  2062,
     466,  2438,  1617,  2080,  2086,  2084,  1617,  2085,  2088,  1220,
    2100,  2093,  2407,   467,  2094,  1692,  2112,  1239,  2116,  1502,
     756,  1326,  2118,  2450,  1327,  2133,  2138,  1652,  2134,  2137,
     409,  2175,  2176,  2700,   468,   881,  2139,  1328,   469,  1329,
     470,  2142,   135,  2191,  2061,   471,  2196,  2409,  2143,  1503,
    2147,  2150,  2168,  2174,  2177,  2178,  2185,  2210,  2203,  2443,
    2422,  2189,  2190,   976,  2213,  2252,  2226,  2255,  2259,   977,
     472,   473,  2256,  2272,  2260,  2239,  1321,  2276,  2277,  2284,
    1322,  2303,   474,  2286,   616,  2298,  2299,   475,  2308,  2307,
    2309,  1669,  2332,  2336,  2335,  2345,   476,  2346,  1330,  2347,
    1323,  1324,  2348,   409,  2350,   477,   616,   978,  2349,  2369,
    2373,  2380,  2383,  1325,   570,  2382,  2388,  2389,  2394,   609,
    2396,  2406,  2412,  2413,  2410,  2512,  2513,  2514,  2515,  2408,
    2420,  2429,  2442,  2423,  2445,  2789,  2790,  2791,  2446,  1348,
    1257,  2455,  2452,  2063,  2794,  2171,  2170,  1326,  2165,   979,
    1327,  2486,  2487,  1308,   980,  1312,  2488,   981,  2499,  2500,
    2523,  2509,  2518,  1328,   414,  1329,  2522,  2526,  2153,  1331,
     414,  2532,  1332,  1333,  1334,  2534,  1335,  1336,  1337,  1338,
    1339,  1340,  2535,  2536,  1534,  2976,   414,  1341,  2154,  2537,
    2842,  1535,  2552,  2576,  2554,  2555,  2577,  2538,  2064,  2592,
    2603,  2599,   982,  2605,  1624,  2403,  2607,   620,  1624,  2281,
     621,   622,   623,  2611,   624,   625,   626,   627,   628,   629,
    2154,  1393,  2616,  2065,  1330,  2617,  2629,  2630,   414,  2623,
     414,  2646,  2661,  2653,  2664,   414,   603,  2639,  2066,  2778,
    2649,  2672,  2654,  1550,  1550,  2695,  2067,  2656,  2659,  2778,
    2666,  2155,  2696,  2705,  2709,  2667,   983,  2668,   414,  2670,
     606,  1978,  2676,  2675,  1978,  1978,   409,   409,  2710,  2715,
    2068,  2713,  2719,  1978,  2722,  2728,  2867,  2568,  2732,  2733,
    1104,  2731,  2329,  2155,  2734,  2742,   409,   409,  2744,   958,
    2747,   606,  2749,  2761,  2751,  1331,  2642,   606,  1332,  1333,
    1334,  2762,  1335,  1336,  1337,  1338,  1339,  1340,  2329,  2755,
    2763,  2764,  2766,  1341,  2777,   960,  2144,  1735,  2768,  2769,
    1735,  1735,  1735,  1735,  1735,  1735,  1735,  1735,  1735,  2781,
    1735,  2788,  2793,   631,  2797,  2798,  2807,  1957,  2399,  2069,
    2810,   409,   409,   409,  2811,   409,  2820,  1984,  2598,  1319,
    2828,  2826,  1617,  2844,  1320,  2834,  2845,  1617,  2848,  2849,
    1617,  2872,   414,   414,  2879,  2883,  2026,  2887,  1940,  1735,
    1735,  1940,  2888,  2615,  2904,  2907,  2926,   870,  2910,  2912,
    2920,  2862,  2927,   835,  1897,  2930,  2156,  2157,  2158,  2908,
    2159,  2160,  2161,  2162,  2163,  2164,  2061,  2909,   409,  2151,
    2152,  2165,   870,  2643,  2167,  2846,  2940,  2955,  2956,  2026,
    2975,  2651,  2990,  1592,  2977,   835,  2991,  1897,  2156,  2157,
    2158,   908,  2159,  2160,  2161,  2162,  2163,  2164,   616,  2194,
    2018,  2231,  1958,  2165,  2192,  2193,  1382,  2295,  2312,  2816,
    2706,  2544,  2708,  1939,  2609,  2960,  2739,  2311,  2701,  1634,
    2254,  2613,  2929,  2954,  2913,  2911,  1641,  2660,  1643,  1644,
    2936, -1535,  1601,  2614,  2765,  1322,  2711,  1319,  2993,  2004,
    2730,  2980,  1320,  2333,  2729,  2370,  2961,  2371,  1576,  2994,
    1649,   514,  2492,   870,  1082,  1323,  1324,   760,   606,  1231,
     414,  2852,  2662,  2627,  2897,   606,  2262,  1883, -1535,  1881,
    2631,  2736,  2876,  2968,  2992,   892,   414,  2830,  1834,   482,
    2922,  2444,  2234,  2238,   633,  1143,   414,  1417,  2247,  1214,
    1415,  1845,  1735,   616,   409,   616,  1218,  1831,  1420,  2222,
    2058,  2783,  2418,   709,  2608,  1327,  2712,  2491,  1657,  1995,
     606,  2208,  2241,   135,  2206,  2127,  2105,  1814,  1328,     0,
       0,     0,  1550,     0,  1624,     0,     0,     0,     0,  1624,
    2745,     0,  1624,     0,     0,     0,   415,     0,     0,  2539,
       0,     0,     0,     0,     0,   870,  2542,     0,  2543,  1321,
       0,   507,     0,  1322,  2851,   516,  1617,     0,     0,     0,
       0,     0,     0,     0,     0,  1978,     0,  1143,     0,   560,
    1978,  1978,     0,  1323,  1324,   409,     0,     0,     0, -1535,
       0,   409,     0,     0,     0,     0,  1325,  2774,     0,   870,
       0,     0,     0,     0,     0,     0,     0,   409,     0,     0,
       0,     0,     0,     0,     0,     0,  2806,  2651,     0,     0,
    2889,     0,     0,  2583,  2585,     0,   870,  2615,     0,     0,
       0,     0,   616,  1327,   414,   414,   414,   414,  1735,  1735,
       0,     0,     0,     0,     0,     0,  1328,     0,     0,     0,
       0,     0,  2898,   870,   870,  2154,   870,     0,     0,     0,
    1331,     0,     0,     0,     0,  1856,  2626,  1335,  1336,  1337,
    1338,  1339,  1340,  1863,   870,     0,     0,     0,  1341,  1867,
       0,   135,     0,  1319,     0,  1872,     0,     0,  1320,     0,
    1550,     0,   637,     0,     0,     0,     0,     0,  2847,     0,
       0,     0,     0,     0,     0,     0,     0,  1330,  2154,     0,
       0,     0,  1897,     0,  1940,  1892,     0,  1893,  2155,     0,
    1895,     0,     0,  2959,     0,   631,     0,     0,     0,   870,
    1926,  1927,   870,   870,     0,     0,   609,  2774,     0,     0,
    1143,   609,   609,     0,  1082,     0,  1942,  1945,  1946,   409,
    1950,   603,     0,  1952,  1953,  1954,     0,     0,     0,  1960,
       0,  2986,  1963,     0,     0,     0,     0,  1471,  1624,     0,
       0,  2155,     0,     0,     0,     0,     0,     0,  1331,     0,
       0,  1143, -1535, -1535,     0,  1335,  1336,  1337,  1338,  1339,
    1340,     0,     0,     0,  2698,  1321,  1341,     0,     0,  1322,
    2464,     0,     0,  2468,  2469,  2470,  2471,  2472,  2473,  2474,
    2475,  2476,     0,  2478,   409,     0,  1735,     0,     0,  1323,
    1324,     0,     0,  2774,   609,     0,  1978,  1978,  1735,  1735,
       0,     0,  1325,  2720,  2721,     0,     0,  2724,  2725,     0,
       0,     0,     0,     0,     0,     0,     0,  2985,     0,     0,
     835,     0,  2504,  2505,   603,   409,   414,  2159,  2160,  2161,
    2162,  2163,  2164,   609,     0,     0,  1326,     0,  2165,  1327,
       0,     0,     0,   135,     0,     0,     0,   414,     0,     0,
       0,     0,  1328,     0,     0,     0,  2984,     0,  2948,     0,
       0,   603,     0,     0,     0,     0,     0,     0,     0,   414,
       0,     0,  2775,   835,  1143,     0,   633, -1535, -1535,   135,
    2159,  2160,  2161,  2162,  2163,  2164,     0,     0,     0,     0,
    1143,  2165,     0,     0,  2114,     0,  1141,     0,     0,     0,
       0,  2948,     0,   414,     0,     0,     0,     0,     0,  1143,
       0,  1735,     0,  1330,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,   603,     0,  2948,     0,
       0,   676,  1143,     0,     0,  1082,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,   603,     0,     0,
       0,     0,     0,     0,     0,     0,     0,  1978,     0,     0,
       0,  2817,     0,     0,   606,     0,   606,     0,     0,     0,
       0,     0,  1143,     0,   606,  2594,     0,     0,  1141,     0,
       0,  1143,     0,     0,  1331,     0,     0,  1332,  1333,  1334,
       0,  1335,  1336,  1337,  1338,  1339,  1340,     0,     0,     0,
       0,     0,  1341,     0,     0,     0,     0,   606,  2850,     0,
       0,     0,     0,     0,   757,     0,     0,     0,     0,     0,
       0,   759,     0,     0,     0,  1317,     0,     0,     0,   603,
       0,     0,   767,     0,  1319,     0,     0,     0,     0,  1320,
       0,   870,   870,     0,     0,     0,     0,     0,     0,   870,
       0,   759,   870,   870,     0,     0,     0,     0,     0,     0,
    2250,  2251,     0,     0,   870,   870,   759,   603,     0,   895,
       0,     0,   870,     0,     0,     0,   870,   870,   870,   870,
       0,     0,   909,     0,     0,     0,   870,   870,     0,     0,
       0,     0,     0,     0,  2267,  2268,     0,     0,     0,     0,
       0,  1368,   870,  1082,     0,     0,   870,     0,     0,     0,
     870,  2678,  2679,     0,   870,     0,     0,   870,   870,   870,
     870,   870,   870,   870,   870,   870,  1143,  2170,   870,     0,
       0,     0,  2171,   870, -1532,     0,   870,     0,     0,     0,
       0,  1141,     0,     0,     0,     0,  1321,     0,     0,     0,
    1322,     0, -1532,     0,     0,     0,     0,     0,     0,     0,
    1087,     0,  2947,     0,     0,     0,     0,     0,  1141,     0,
    1323,  1324,     0,     0,     0,     0,     0,     0,     0,     0,
       0,   870,  1141,  1325,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0, -1532,
       0,     0,     0,     0,     0,  2947,     0,  1164,  1165,  1166,
       0,     0,     0,     0,     0,  1082,     0,  1326,     0,     0,
    1327,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,   870,  2947,  1328,     0,  1329,     0,     0,     0,     0,
   -1532,     0,     0,     0,     0,  1143,     0,     0,     0,  2393,
    1471,  1143, -1532,     0,     0,     0,     0, -1532,     0,     0,
       0, -1532,   759,     0, -1532,     0, -1532,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,   759,     0,     0,     0,     0,     0,  2796,
       0, -1532,     0,     0,  1330,     0,     0,     0,     0,     0,
       0,  2802,  2803,     0,     0,  1141,     0,     0,     0, -1532,
       0,     0,     0,     0,  1319,     0,     0,     0,     0,  1320,
     870,  1141,     0,     0,     0, -1532, -1532,  1143,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
    1141,     0,     0,   870,     0,  1143,     0,     0,     0,     0,
       0,     0,     0, -1532,     0,     0,     0,     0,     0,     0,
       0, -1532,     0,  1141,     0,  1331,     0,     0,  1332,  1333,
    1334,     0,  1335,  1336,  1337,  1338,  1339,  1340,     0,     0,
       0,     0,     0,  1341,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,  2204,     0, -1532,     0,     0,     0,
       0,   606,  1385,  1141,     0,     0,     0,     0,     0,     0,
     870,     0,  1141,   143,  2868,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0, -1535,     0,     0,     0,
    1322,     0,     0,     0,     0,     0,   512,   870,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
    1323,  1324,     0,     0,     0,   870, -1532,     0,     0, -1534,
       0,     0,     0, -1535,     0,   144,  1143,     0,     0,     0,
       0,     0,     0,     0, -1532,     0,     0, -1534,     0,     0,
       0,   145, -1532, -1532, -1532,   870,     0,     0,     0,     0,
    1514,     0,     0,     0,     0,     0,     0,     0,     0,   146,
    1327,     0,     0,     0, -1532,  2550,  2551, -1532,     0, -1532,
   -1532,     0,     0,  1328,     0,     0,     0,   870,   870,     0,
       0,     0,   870,     0, -1534,     0,     0,     0,   147,   855,
       0,     0,     0,   148,   870,   870,   870,   870,     0,     0,
       0,     0,     0,   870,     0,     0,     0,   149,     0,     0,
       0,     0,   870,   870,   903,   870,     0,  1141,     0,     0,
    2587,  2589,  2591,     0,  2593, -1534,     0,   870,     0,   870,
     150,     0,     0,   870, -1535,     0,     0, -1534,  1319,     0,
       0,     0, -1534,  1320,     0,     0, -1534,     0,     0, -1534,
     870, -1534,     0,     0,     0,     0,     0,     0,     0,     0,
     606,     0,   870,   870,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0, -1534,   870,     0,     0,
       0,     0,     0,   870,     0,     0,     0,   151,     0,     0,
       0,   870,   870,   870, -1534,  1003,  1143,     0,     0,     0,
       0,     0,     0,     0,     0,  1331,     0,   870,     0,     0,
   -1534, -1534,  1335,  1336,  1337,  1338,  1339,  1340,  2506,     0,
       0,     0,     0,  1341,     0,  1471,  1143,     0,  1143,   152,
       0,     0,     0,     0,     0,   153,  1141,     0, -1534,     0,
     154,  1141,  1141,  1143,     0,  1143, -1534,     0,     0,     0,
   -1535,     0,     0,     0,  1322,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,   155,   156,     0,  1642,     0,
       0,  1645,     0,     0,  1323,  1324,     0,   157,     0,     0,
       0, -1534,   158,     0,     0,  1143,     0, -1535,     0,     0,
       0,   159,     0,   759,   759,     0,     0,     0,     0,     0,
       0,  1132,     0,  2707,     0,  1677,     0,     0,     0,     0,
       0,     0,     0,     0,     0,  1143,     0,     0,  1141,     0,
       0,   512,     0,     0,  1327,     0,     0,     0,     0,     0,
       0,  1262,     0,     0,     0,  1143,  1141,  1328,     0,     0,
       0, -1534,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,  1286, -1534,
    1082,  1143,     0,     0,     0,     0,     0, -1534, -1534, -1534,
       0,  1143,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,  1143,  1132,  2760,  1305,  1306,     0,  1309, -1534,
    2393,     0, -1534,  1143, -1534, -1534,     0,     0, -1535,     0,
       0,     0,     0,     0,     0,     0,  1346,   606,     0,     0,
       0,   606,     0,     0,     0,  1813,     0,     0,     0,     0,
       0,     0,     0,     0,     0,  1143,     0,     0,     0,  1143,
       0,     0,     0,     0,     0,     0,  1317,     0,     0,   606,
    1318,     0,     0,     0,     0,  1319,     0,     0,     0,     0,
    1320,     0,     0,     0,     0,     0,     0,  1141,     0,     0,
       0,  1405,  1835,     0,  1412,  1414,     0,     0,     0,  1331,
       0,   870,     0,     0,  1143,     0,  1335,  1336,  1337,  1338,
    1339,  1340,     0,   870,     0,     0,     0,  1341,     0,   870,
       0,     0,     0,   870,     0,     0,     0,     0,   870,     0,
       0,   870,   870,   870,   870,   870,   870,   870,   870,   870,
    1143,   870,     0,     0,     0,   870,   870,     0,     0,  1130,
       0,     0,     0,     0,  1143,     0,     0,     0,     0,   870,
       0,     0,     0,     0,     0,     0,   870,     0,     0,   870,
       0,   870,     0,     0,     0,     0,  1132,     0,  1143,   870,
     870,   870,     0,     0,     0,   870,     0,  1321,   870,     0,
       0,  1322,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,  1132,     0,  1319,     0,     0,     0,     0,
    1320,  1323,  1324,  1951,     0,     0,     0,  1132,     0,     0,
       0,     0,     0,     0,  1325,     0,     0,     0,     0,     0,
       0,  1241,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,  2893,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,  1141,  1326,     0,
       0,  1327,     0,     0,     0,     0,     0,     0,     0,  1143,
       0,     0,     0,     0,  1328,     0,  1329,     0,  2017,     0,
       0,     0,     0,     0,  2914,  2507,  1141,  1141,     0,  1141,
       0,     0,     0,     0,     0,     0,     0,  1133,     0,     0,
    2027,     0,     0,     0,  1141,     0,  1141,  2045,     0,     0,
       0,     0,     0,     0,     0,     0,     0, -1535,     0,     0,
       0,  1322,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,   870,     0,  1330,     0,     0,     0,     0,
    1132,  1323,  1324,     0,  1143,     0,  1141,     0,     0,     0,
       0,     0,     0,     0, -1535,     0,  1132,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,  1132,  1141,     0,     0,  1133,
       0,     0,     0,     0,     0,     0,     0,   606,     0,     0,
       0,  1327,   606,     0,  1423,   606,  1141,     0,  1132,   870,
       0,     0,     0,     0,  1328,     0,  1331,     0,     0,  1332,
    1333,  1334,     0,  1335,  1336,  1337,  1338,  1339,  1340,     0,
       0,     0,  1141,     0,  1341,     0,     0,     0,   870,     0,
       0,     0,  1141,     0,     0,  1487,     0,     0,  1132,  1319,
       0,  1703,     0,  1141,  1320,  1705,     0,  1132,     0,     0,
       0,     0,     0,     0,  1141,     0,     0,  1135,     0,     0,
       0,     0,     0,     0,  1727, -1535,     0,     0,  1730,   870,
     870,  1741,     0,     0,   870,  1143,     0,     0,  1748,  1753,
       0,   870,   870,     0,     0,   870,  1141,     0,     0,     0,
    1141,     0,     0,     0,  1763,     0,     0,     0,  1769,     0,
       0,     0,  1780,     0,     0,     0,  1787,  2219,     0,  1789,
    1790,  1791,  1792,  1793,  1794,  1795,  1796,  1797,     0,  2510,
    1799,     0,     0,     0,     0,   855,     0,     0,     0,     0,
       0,     0,  1319,     0,     0,  1141,  1331,  1320,     0,  1135,
       0,     0,  1133,  1335,  1336,  1337,  1338,  1339,  1340,     0,
       0, -1535,     0,  1136,  1341,  1322,     0,     0,  1537,     0,
       0,     0,     0,     0,     0,     0,     0,   870,     0,  1133,
       0,  1141,     0,   903,  1423,  1323,  1324,     0,     0,     0,
       0,     0,     0,  1133,     0,  1141,     0,     0, -1535,     0,
       0,     0,  1132,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,   606,     0,     0,     0,     0,  1141,
       0,     0,  2688,     0,     0,     0,  1574,   870,     0,     0,
       0,   606,     0,  1870,     0,  1327,  1143,     0,     0,     0,
       0,     0,     0,     0,     0,  1136,     0,     0,  1328,     0,
       0,     0,     0,     0, -1535,     0,     0,   870,  1322,     0,
    1143,     0,     0,     0,     0,     0,  1629,     0,  1143,   870,
     870,     0,     0,   870,     0,  1487,     0,     0,  1323,  1324,
     870,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0, -1535,     0,     0,     0,  1138,     0,     0,   870,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0, -1535,
    1141,     0,  1135,     0,     0,     0,  1133,   606,     0,     0,
       0,  1132,  1968,     0,     0,     0,  1132,  1132,  1327,     0,
    2375,     0,  1133,     0,     0,     0,  2381,     0,     0,  1135,
       0,  1328,     0,     0,     0,  1993,     0,     0,     0,     0,
       0,  1133,  2395,  1135,   606,   870,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,   870,  1133,     0,     0,  1138,     0,     0,
    1331,     0,   870,  1143,     0,  1141,     0,  1335,  1336,  1337,
    1338,  1339,  1340,     0,  2433,     0,  2434,     0,  1341,     0,
       0,  2436, -1535,  1132,     0,     0,     0,     0,  1136,     0,
       0,     0,  2076,     0,  1133,     0,     0,     0,     0,   606,
    1798,  1132,     0,  1133,   759,     0,     0,     0,     0,     0,
       0,     0,  1317,     0,     0,  1136,     0,  1839,     0,  2092,
     606,  1319,     0,     0,     0,     0,  1320,     0,     0,  1136,
       0,     0,     0,     0,     0,     0,     0,   855,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,  1331,     0,     0,  1135,     0,     0,     0,
    1335,  1336,  1337,  1338,  1339,  1340,     0,  2125,     0,   870,
       0,  1341,  1135,     0,     0,     0,     0,     0,     0,     0,
       0,     0,  1143,     0,     0,     0,     0,     0,  1840,     0,
       0,  1135,     0,     0,     0,     0,  1141,     0,     0,     0,
       0,     0,   606,  1317,     0,  2424,     0,     0,  2516,  2517,
       0,     0,  1319,     0,  1135,     0,  1753,  1320,  1753,  1753,
    1138,     0,  1132,     0,     0,  2187,     0,     0,     0,     0,
       0,     0,     0,  1321,     0,     0,     0,  1322,     0,     0,
     606,     0,     0,  1143,     0,     0,     0,  1138,  1133,  2207,
       0,  2209,  1136,     0,  1135,  2212,     0,  1323,  1324,     0,
       0,  1138,     0,  1135,     0,     0,     0,     0,  1136,     0,
    1325,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,  1136,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,   903,
       0,  1487,     0,     0,  1326,  1405,     0,  1327,     0,     0,
    1136,     0,     0,  1414,  1414,  1412,     0,     0,     0,  1996,
    1328,     0,  1329,     0,  1321,     0,     0,     0,  1322,  2253,
       0,     0,     0,     0,     0,     0,  2579,     0,     0,     0,
       0,     0,     0,     0,     0,  1139,     0,  1141,  1323,  1324,
    1136,     0,  2600,     0,     0,     0,     0,     0,     0,  1136,
       0,  1325,  2604,     0,     0,     0,     0,  1133,     0,     0,
       0,  1141,  1133,  1133,     0,     0,     0,     0,     0,  1141,
       0,  1330,     0,     0,  1138,     0,     0,     0,     0,     0,
       0,     0,  1132,     0,     0,  1326,     0,     0,  1327,     0,
    1138,     0,     0,     0,     0,     0,     0,     0,  1135,     0,
       0,  1328,     0,  1329,     0,     0,     0,     0,     0,  1138,
       0,  1132,  1132,     0,  1132,  1841,     0,  1139,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,  1132,
    2113,  1132,  1138,     0,     0,     0,     0,     0,     0,  1133,
       0,     0,  1331,     0,     0,  1332,  1333,  1334,     0,  1335,
    1336,  1337,  1338,  1339,  1340,     0,     0,  1133,     0,     0,
    1341,     0,  1330,     0,     0,     0,     0,     0,     0,     0,
       0,  1132,  1138,     0,     0,     0,     0,     0,     0,     0,
       0,  1138,     0,     0,  1141,     0,     0,     0,     0,     0,
    2691,  2692,  2693,  2694,  1136,     0,     0,     0,     0,     0,
       0,  1132,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,  1135,     0,  2425,
       0,  1132,  1135,  1135,     0,     0,     0,     0,     0,     0,
    1902,     0,     0,  1331,     0,     0,  1332,  1333,  1334,     0,
    1335,  1336,  1337,  1338,  1339,  1340,     0,  1132,     0,     0,
       0,  1341,     0,     0,     0,     0,     0,  1132,     0,     0,
       0,     0,     0,  1140,     0,     0,     0,     0,  1132,     0,
       0,     0,     0,     0,     0,     0,     0,     0,  1133,  1132,
    1139,  1903,     0,  2454,     0,     0,     0,     0,  1904,  1905,
    1906,  1142,     0,     0,     0,  2459,     0,     0,     0,  1135,
    2248,  2460,     0,  1141,     0,  2462,     0,  1139,     0,     0,
       0,  1132,     0,  1136,     0,  1132,     0,  1135,  1136,  1136,
       0,  1139,     0,     0,     0,  1907,  1138,  2479,  2480,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,  1140,     0,  2271,  2493,  2274,
       0,  2496,     0,  2498,     0,     0,     0,     0,     0,     0,
    1132,  2503,     0,  1908,  1141,     0,     0,  2508,  1909,     0,
    2511,     0,     0,  1142,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,  2291,
       0,     0,     0,     0,     0,  1136,  1132,     0,     0,     0,
       0,     0,     0,     0,     0,  1910,     0,     0,     0,     0,
    1132,     0,  2822,  1136,     0,     0,     0,     0,     0,  2302,
       0,     0,     0,  1911,  1912,  1913,  1914,  1915,     0,  1916,
       0,     0,     0,   759,  1132,     0,     0,     0,  1135,     0,
       0,     0,     0,     0,  1139,  1138,     0,     0,  1133,     0,
    1138,  1138,     0,     0,     0,  2860,     0,  1917,     0,     0,
    1139,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,  2379,     0,  1133,  1133,  1139,
    1133,     0,     0,     0,     0,     0,  2291,     0,  1918,  2874,
       0,     0,     0,     0,     0,  1133,     0,  1133,     0,     0,
       0,     0,  1139,     0,     0,     0,     0,     0,  1140,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
    1919,     0,  1920,     0,     0,  1132,     0,  1138,     0,  2427,
       0,     0,     0,  1487,  1136,  1140,  1142,  1133,     0,     0,
       0,     0,  1139,  1921,     0,  1138,     0,     0,     0,  1140,
    1922,  1139,     0,  1923,     0,     0,     0,     0,     0,     0,
       0,     0,     0,  1469,     0,     0,     0,  1133,     0,     0,
       0,     0,     0,     0,     0,     0,     0,  1142,  2456,     0,
       0,  2652,     0,     0,     0,     0,     0,  1133,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
    1132,     0,     0,     0,     0,     0,     0,     0,  1135,     0,
    2665,     0,     0,  1133,  2477,     0,     0,     0,     0,     0,
       0,     0,     0,  1133,     0,     0,     0,     0,  2485,     0,
       0,     0,     0,     0,  1133,     0,     0,  1135,  1135,     0,
    1135,     0,     0,     0,     0,  1133,     0,     0,     0,     0,
       0,     0,  2501,     0,     0,  1135,  2680,  1135,     0,     0,
       0,     0,     0,  2686,  2687,     0,  1138,  2689,     0,     0,
       0,     0,  1140,     0,     0,     0,     0,  1133,     0,     0,
       0,  1133,     0,     0,     0,     0,     0,     0,  1140,     0,
       0,     0,     0,     0,     0,     0,  1139,  1135,     0,     0,
    1142,     0,     0,     0,  1136,     0,     0,  1140,     0,     0,
       0,     0,     0,     0,     0,     0,  1142,     0,     0,     0,
       0,     0,     0,     0,     0,     0,  1133,  1135,     0,     0,
    1140,  1132,     0,  1136,  1136,  1142,  1136,     0,     0,     0,
       0,     0,     0,  2549,     0,     0,     0,  1135,     0,  2737,
       0,  1136,     0,  1136,     0,     0,     0,     0,  1142,     0,
       0,     0,  1133,     0,     0,     0,     0,     0,     0,     0,
    1140,     0,     0,  1135,     0,     0,  1133,     0,     0,  1140,
       0,     0,     0,  1135,     0,     0,     0,     0,     0,     0,
       0,     0,     0,  1136,  1135,     0,     0,     0,  1142,  2780,
    1133,     0,     0,     0,     0,  1135,     0,  1142,     0,     0,
       0,     0,     0,     0,     0,  1139,     0,     0,  2602,     0,
    1139,  1139,     0,  1136,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,  1138,  1135,     0,     0,
       0,  1135,  1317,  1136,     0,  2804,     0,     0,     0,     0,
       0,  1319,     0,     0,     0,     0,  1320,     0,     0,     0,
       0,     0,     0,     0,     0,  1138,  1138,     0,  1138,  1136,
    2814,     0,     0,     0,     0,     0,     0,     0,     0,  1136,
       0,     0,  1132,  1138,     0,  1138,  1135,     0,     0,     0,
    1136,  1133,     0,     0,     0,     0,     0,  1139,     0,     0,
       0,  1136,     0,     0,     0,     0,  1132,     0,     0,     0,
       0,     0,     0,     0,  1132,  1139,     0,     0,     0,     0,
       0,     0,  1135,     0,  1140,  1138,     0,  2853,     0,     0,
       0,     0,     0,  1136,     0,     0,  1135,  1136,     0,     0,
       0,     0,     0,     0,     0,  2865,     0,     0,     0,  2501,
       0,     0,  1142,     0,     0,  1138,     0,     0,     0,     0,
    1135,     0,     0,  1321,  1317,     0,  1133,  1322,  2129,     0,
       0,     0,     0,  1319,     0,  1138,     0,     0,  1320,     0,
       0,     0,  1136,     0,     0,     0,     0,  1323,  1324,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
    1325,  1138,     0,     0,     0,     0,  1343,     0,     0,     0,
       0,  1138,     0,     0,     0,     0,     0,     0,  1136,     0,
       0,     0,  1138,     0,     0,     0,     0,     0,     0,  1132,
       0,     0,  1136,  1138,  1326,     0,  1139,  1327,     0,     0,
       0,     0,     0,  1140,     0,     0,     0,     0,  1140,  1140,
    1328,  1135,  1329,     0,  1343,     0,  1136,     0,     0,     0,
       0,  2928,     0,     0,     0,  1138,     0,     0,     0,  1138,
       0,  1878,     0,     0,     0,     0,  1469,  1469,     0,     0,
       0,     0,     0,     0,     0,  1321,     0,     0,     0,  1322,
       0,     0,     0,     0,     0,     0,     0,  1133,     0,     0,
    2379,     0,     0,     0,     0,     0,     0,     0,     0,  1323,
    1324,  1330,     0,     0,  1138,     0,     0,     0,     0,     0,
       0,     0,  1325,     0,  2501,  1140,  1135,     0,     0,     0,
       0,     0,  2801,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,  1140,     0,     0,     0,  1136,  1132,     0,
    1138,     0,     0,  1142,  1343,     0,  1326,     0,     0,  1327,
       0,     0,     0,     0,  1138,     0,   653,     0,     0,     0,
       0,  1142,  1328,     0,  1329,     0,     0,     0,     0,     0,
       0,     0,  1331,     0,     0,  1332,  1333,  1334,  1138,  1335,
    1336,  1337,  1338,  1339,  1340,     0,     0,     0,   654,  1757,
    1341,     0,     0,     0,     0,     0,  1139,     0,     0,  1132,
     655,     0,     0,     0,     0,     0,   656,     0,   657,     0,
       0,     0,  1136,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,  1330,   658,  1139,  1139,     0,  1139,     0,
       0,     0,     0,     0,     0,     0,     0,  2501,  1133,     0,
       0,     0,   659,  1139,     0,  1139,     0,  1135,     0,     0,
       0,     0,     0,     0,  1140,     0,     0,     0,     0,     0,
       0,     0,  1133,     0,     0,     0,     0,     0,     0,  1138,
    1133,   660,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,  1142,     0,     0,  1139,     0,     0,     0,     0,
     661,     0,     0,     0,  1331,     0,     0,  1332,  1333,  1334,
       0,  1335,  1336,  1337,  1338,  1339,  1340,     0,     0,     0,
       0,     0,  1341,     0,   662,  1139,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,  1139,     0,     0,     0,     0,
       0,     0,     0,  1136,  1138,     0,     0,     0,     0,     0,
       0,  1343,     0,     0,     0,     0,  2939,     0,     0,     0,
       0,  1139,     0,     0,     0,     0,     0,     0,     0,     0,
     663,  1139,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,  1139,     0,     0,  1133,     0,     0,     0,     0,
       0,   467,     0,  1139,     0,     0,     0,     0,  1135,     0,
       0,     0,     0,  1343,     0,     0,  1317,     0,     0,     0,
       0,     0,   664,     0,     0,  1319,   665,  1487,   666,     0,
    1320,     0,  1135,   667,  1140,  1139,     0,  1343,     0,  1139,
    1135,     0,     0,  1737,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,  1343,  1343,   668,   669,
    1343,     0,  1142,  1140,  1140,     0,  1140,     0,     0,     0,
     670,     0,     0,     0,     0,   671,     0,     0,     0,     0,
       0,  1140,     0,  1140,  1139,  1138,     0,     0,     0,     0,
       0,  1469,  1469,   672,  1469,     0,     0,  1343,     0,     0,
       0,     0,     0,     0,  1136,     0,     0,     0,     0,  1142,
       0,  1142,     0,     0,  1133,     0,     0,     0,     0,     0,
    1139,     0,     0,  1140,     0,     0,     0,     0,  1136,     0,
       0,     0,     0,     0,  1139,     0,  1136,  1321,     0,     0,
       0,  1322,     0,     0,     0,     0,     0,     0,     0,     0,
       0,  1142,     0,  1140,     0,  1135,  1343,     0,  1139,     0,
       0,  1323,  1324,  1343,     0,  1343,     0,     0,     0,     0,
       0,     0,     0,  1140,  1325,  1133,     0,     0,     0,     0,
       0,  1142,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,  1140,
       0,  1469,     0,     0,     0,     0,     0,     0,  1326,  1140,
       0,  1327,     0,     0,     0,     0,     0,     0,     0,     0,
    1140,     0,     0,     0,  1328,     0,  1329,  1469,     0,     0,
       0,  1140,     0,     0,     0,     0,  1138,  1142,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,  1142,  1139,
       0,  1136,     0,     0,     0,     0,     0,     0,     0,  1469,
    1138,     0,     0,  1140,     0,     0,     0,  1140,  1138,     0,
       0,     0,     0,     0,  1135,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,  1330,     0,     0,     0,     0,
       0,  1142,     0,     0,     0,  1142,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,  1140,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,  1139,     0,     0,     0,     0,  2131,
       0,     0,     0,     0,     0,  1135,     0,     0,     0,     0,
    1142,     0,     0,     0,     0,     0,     0,     0,  1140,     0,
       0,     0,     0,     0,     0,     0,  1331,     0,     0,  1332,
    1333,  1334,  1140,  1335,  1336,  1337,  1338,  1339,  1340,     0,
    1136,     0,     0,     0,  1341,     0,  1142,     0,     0,     0,
       0,     0,     0,  1138,     0,     1,  1140,     0,     0,     0,
    1142,  1317,     0,     0,     0,     2,     3,     4,     0,     0,
    1319,     0,     0,     0,     0,  1320,     0,     0,     0,     0,
       0,     5,     0,     0,  1142,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       6,  1136,     7,     8,     0,     0,     0,     9,    10,     0,
       0,     0,     0,     0,  1317,     0,    11,    12,  2179,     0,
       0,     0,     0,  1319,  1343,  1139,  1343,     0,  1320,     0,
       0,     0,    13,     0,     0,    14,     0,     0,     0,     0,
       0,    15,     0,     0,     0,     0,     0,  1140,  1343,     0,
      16,  1343,     0,  1737,  1737,  2166,    17,     0,  1737,     0,
       0,    18,  1343,    19,     0,     0,     0,    20,     0,  1343,
       0,     0,  1138,     0,  1343,  1142,     0,     0,     0,    21,
       0,     0,  1321,     0,  1343,     0,  1322,     0,  1737,  1737,
    1343,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,  1343,     0,     0,     0,    22,  1323,  1324,  1343,     0,
    1343,  1343,  1343,  1343,  1343,  1343,  1343,  1343,  1343,  1325,
    1343,     0,  1140,     0,     0,     0,     0,     0,    23,    24,
       0,     0,     0,  1138,    25,  1321,     0,     0,     0,  1322,
       0,     0,    26,     0,     0,     0,     0,     0,     0,     0,
    1142,     0,     0,  1326,     0,     0,  1327,     0,     0,  1323,
    1324,     0,    27,     0,     0,     0,     0,     0,     0,  1328,
       0,  1329,  1325,     0,     0,     0,  1139,     0,     0,     0,
       0,  2148,     0,     0,     0,     0,     0,     0,     0,     0,
       0,  1343,    28,     0,     0,     0,     0,     0,     0,     0,
    1139,     0,    29,     0,     0,    30,  1326,    31,  1139,  1327,
       0,    32,     0,     0,     0,     0,    33,     0,     0,    34,
       0,     0,  1328,    35,  1329,     0,     0,     0,    36,     0,
    1330,     0,     0,    37,     0,     0,    38,     0,     0,     0,
       0,     0,    39,     0,     0,     0,     0,     0,     0,  1317,
       0,     0,     0,  1140,     0,     0,     0,     0,  1319,     0,
       0,     0,     0,  1320,     0,     0,     0,     0,     0,    40,
       0,     0,     0,     0,     0,     0,     0,    41,     0,    42,
       0,  1142,    43,  1330,     0,    44,     0,     0,     0,  1343,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,  1331,     0,     0,  1332,  1333,  1334,     0,  1335,  1336,
    1337,  1338,  1339,  1340,  1343,     0,     0,     0,     0,  1341,
       0,     0,     0,  1139,    45,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,  1331,     0,  2184,  1332,  1333,  1334,
       0,  1335,  1336,  1337,  1338,  1339,  1340,     0,     0,     0,
    1321,     0,  1341,     0,  1322,     0,     0,  1317,     0,     0,
       0,     0,     0,     0,     0,     0,  1319,     0,     0,     0,
       0,  1320,     0,     0,  1323,  1324,  1317,  1343,     0,     0,
       0,     0,     0,     0,  1140,  1319,     0,  1325,     0,     0,
    1320,     0,     0,  1343,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,  1140,     0,
       0,     0,  1142,     0,     0,     0,  1140,     0,     0,     0,
       0,  1326,  1139,     0,  1327,     0,  1343,     0,     0,     0,
       0,     0,     0,     0,     0,     0,  1142,  1328,     0,  1329,
       0,     0,     0,     0,  1142,     0,     0,     0,     0,     0,
       0,     0,  2166,  2166,  1737,     0,     0,  1737,  1737,  1737,
    1737,  1737,  1737,  1737,  1737,  1737,     0,  1737,  2166,     0,
       0,  1317,     0,     0,     0,     0,     0,     0,  1321,     0,
    1319,     0,  1322,  1139,     0,  1320,     0,     0,  1343,     0,
       0,     0,     0,  2166,  2166,     0,     0,  1321,  1330,     0,
       0,  1322,  1323,  1324,     0,     0,  1737,  1737,  1343,     0,
    1343,     0,     0,  1343,     0,  1325,     0,     0,     0,     0,
       0,  1323,  1324,     0,     0,     0,     0,     0,     0,     0,
       0,  1140,     0,     0,  1325,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,  1326,
       0,     0,  1327,     0,  1343,     0,     0,     0,     0,  1142,
       0,     0,     0,     0,     0,  1328,     0,  1329,  1326,  1331,
       0,  1327,  1332,  1333,  1334,     0,  1335,  1336,  1337,  1338,
    1339,  1340,     0,     0,  1328,     0,  1329,  1341,     0,     0,
       0,     0,  1321,     0,     0,     0,  1322,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,  1323,  1324,     0,     0,
       0,     0,     0,     0,     0,     0,  1330,     0,     0,  1325,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,  1330,     0,     0,     0,     0,
    1140,     0,     0,     0,     0,     0,     0,     0,     0,  1737,
       0,     0,     0,  1326,     0,     0,  1327,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,  1142,  1328,
       0,  1329,  1317,     0,     0,     0,     0,     0,     0,     0,
       0,  1319,     0,     0,     0,     0,  1320,  1331,     0,     0,
    1332,  1333,  1334,     0,  1335,  1336,  1337,  1338,  1339,  1340,
       0,  1140,  2300,     0,     0,  1341,  1331,     0,     0,  1332,
    1333,  1334,  1317,  1335,  1336,  1337,  1338,  1339,  1340,     0,
       0,  1319,     0,  2334,  1341,     0,  1320,     0,     0,  1142,
    1330,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,  1343,     0,     0,     0,     0,
    1343,  1343,  2453,  1343,     0,  2166,     0,     0,     0,  2166,
    2166,  2166,  2166,  2166,  2166,  2166,  2166,  2166,     0,  2166,
    1343,  1343,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,  1343,  1737,  1737,  1343,     0,  1343,
       0,     0,     0,  1321,  1343,  2166,  2166,  1322,     0,  1343,
       0,  1331,  1343,     0,  1332,  1333,  1334,     0,  1335,  1336,
    1337,  1338,  1339,  1340,     0,     0,     0,  1323,  1324,  1341,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
    1325,     0,     0,  1321,     0,     0,     0,  1322,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,  1323,  1324,     0,
       0,     0,     0,     0,  1326,     0,     0,  1327,     0,     0,
    1325,     0,     0,     0,     0,     0,     0,     0,     0,     0,
    1328,     0,  1329,     0,     0,  2166,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,  1326,     0,     0,  1327,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
    1328,     0,  1329,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,  1330,     0,  1343,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,  1343,     0,     0,     0,
       0,     0,     0,  1737,     0,     0,     0,     0,     0,  2166,
    2166,  1343,     0,     0,     0,  1737,  1737,  1343,  1343,     0,
    1343,  1330,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,  1331,     0,     0,  1332,  1333,  1334,     0,  1335,
    1336,  1337,  1338,  1339,  1340,     0,     0,     0,  1343,  2490,
    1341,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,  1331,     0,     0,  1332,  1333,  1334,     0,  1335,
    1336,  1337,  1338,  1339,  1340,     0,     0,     0,     0,  2528,
    1341,  1343,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,  2166,  1737,     0,
       0,     0,     0,  2166,  2166,  1343,     0,     0,     0,     0,
       0,     0,     0,     0,     0,  1343,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,   161,   162,   163,
     164,   165,   166,   167,   168,     0,   169,   170,     0,     0,
       0,     0,     0,     0,  1343,     0,   171,   172,     0,   173,
       0,   174,   175,   176,     0,   177,  1343,   178,   179,  2166,
     180,   181,   182,   183,   184,     0,     0,   185,   186,   187,
     188,     0,   189,   190,   191,   192,   193,     0,     0,   194,
     195,   196,   197,   198,     0,   199,   200,   201,   202,     0,
     203,   204,   205,     0,   206,     0,     0,     0,     0,     0,
     207,   208,   209,   210,   211,   212,   213,   214,     0,   215,
       0,   216,   217,   218,   219,   220,     0,   221,     0,  1343,
     222,   223,   224,   225,     0,   226,   227,   228,     0,   229,
       0,   230,   231,   232,   233,   234,   235,   236,     0,   237,
     238,   239,     0,   240,     0,   241,     0,     0,     0,   242,
     243,     0,   244,   245,     0,   246,     0,   247,   248,   249,
     250,     0,   251,   252,   253,     0,   254,   255,   256,   257,
     258,   259,     0,     0,   260,   261,   262,   263,   264,   265,
     266,     0,   267,     0,   268,     0,     0,   269,     0,   270,
     271,   272,   273,   274,     0,   275,     0,   276,     0,     0,
     277,   278,   279,     0,     0,   280,   281,   282,   283,   284,
     285,   286,   287,   288,   289,     0,     0,     0,   290,   291,
       0,   292,     0,   293,   294,   295,   296,   297,   298,   299,
     300,   301,     0,   302,   303,     0,   304,     0,   305,   306,
     307,   308,     0,     0,   309,     0,     0,     0,   310,   311,
       0,     0,   312,     0,     0,   313,   314,   315,   316,   317,
       0,   318,   319,   320,   321,   322,     0,   323,   324,   325,
     326,   327,   328,   329,   330,   331,     0,   332,   333,   334,
     335,   336,   337,   338,   339,   340,     0,   341,   342,     0,
     343,   344,   345,   346,   347,   348,   349,   350,   351,   352,
       0,   353,   354,   355,     0,   356,   357,   358,   359,     0,
     360,   361,     0,   362,   363,   364,   365,   366,   367,   368,
     369,   370,   371,     0,   372,   373,     0,   374,   375,   376,
     377,     0,   378,   379,     0,     0,   380,   381,   382,   383,
       0,   384,   385,   386,   387,   388,     0,     0,   389,   390,
     391,   392,     0,  2856,   393,   394,   395,   396,   397,   398,
       0,   399,   400,     0,     0,   401,     0,   402,   403,   404,
     405,   406,     0,     0,     0,   407,     0,     0,     0,     0,
       0,   161,   162,   163,   164,   165,   166,   167,   168,  1817,
     169,   170,     0,     0, -1306,     0,     0,   780,     0, -1306,
     171,   172,     0,   173,   582,   174,   175,   176,   583,   781,
     584,   782,   783,     0,   180,   181,   182,   183,   184,   784,
     785,   185,   786,   787,   188,     0,   189,   190,   191,   192,
     788,     0,     0,   194,   195,   196,   197,   198,     0,   199,
     200,   789,   202,     0,   203,   204,   205,   585,   206,   790,
     791,   792,   793,   794,   207,   208,   209,   210,   211,   795,
     796,   214,     0,   215,     0,   216,   217,   218,   219,   220,
       0,   221,  1818,     0,   222,   797,   224,   225,     0,   226,
     227,   228,     0,   229,     0,   230,   231,   232,   798,   234,
     235,   799,   800,   237,   238,   801,     0,   240,     0,   241,
     586,     0,   587,   242,   243,     0,   244,   802,     0,   246,
       0,   247,   248,   249,   250,   588,   251,   252,   253,     0,
     254,   255,   256,   257,   258,   259,     0,   589,   260,   261,
     262,   263,   264,   803,   804,     0,   805,     0,   268,   590,
     591,   269,   592,   270,   271,   272,   273,   274,     0,   806,
     593,   276,   594,     0,   277,   278,   279,   807,   808,   280,
     281,   282,   283,   284,   285,   286,   287,   288,   289,     0,
       0,     0,   290,   809,   595,   810,   412,   293,   294,   295,
     296,   297,   298,   299,   300,   301,   811,   302,   303,   596,
     304,   812,   813,   814,   307,   308,     0,     0,   309,   413,
       0,     0,   815,   311,     0,     0,   312,   597,   598,   816,
     314,   315,   316,   317,     0,   817,   319,   320,   321,   322,
       0,   323,   324,   325,   326,   327,   328,   818,   330,   331,
       0,   332,   333,   334,   335,   336,   337,   338,   339,   340,
       0,   341,   342,   599,   343,   344,   819,   346,   347,   348,
     349,   350,   351,   352,     0,   353,   354,   355,   820,   356,
     357,   358,   359,   600,   360,   821,     0,   362,   363,   364,
     365,   366,   367,   368,   369,   822,   371,     0,   372,   373,
       0,   374,   375,   376,   377,     0,   823,   824,     0,     0,
     380,   825,   382,   826,   827,   384,   385,   386,   387,   388,
       0,   828,   389,   390,   391,   392,   829,     0,   393,   394,
     395,   396,   830,   398,   601,   399,   400,     0,     0,   401,
       0,   402,   403,   404,   405,   406,     0,     0,     0,   831,
     832,   509,   833,   834,   835,   836,   837,     0,     0,     0,
       0,   838,   839,  1819,     0,     0,     0,     0,     0,     0,
     841,  1820,   161,   162,   163,   164,   165,   166,   167,   168,
       0,   169,   170,     0,     0,     0,     0,     0,   780,     0,
       0,   171,   172,     0,   173,   582,   174,   175,   176,   583,
     781,   584,   782,   783,     0,   180,   181,   182,   183,   184,
     784,   785,   185,   786,   787,   188,     0,   189,   190,   191,
     192,   788,     0,     0,   194,   195,   196,   197,   198,     0,
     199,   200,   789,   202,     0,   203,   204,   205,   585,   206,
     790,   791,   792,   793,   794,   207,   208,   209,   210,   211,
     795,   796,   214,     0,   215,     0,   216,   217,   218,   219,
     220,     0,   221,     0,     0,   222,   797,   224,   225,     0,
     226,   227,   228,     0,   229,     0,   230,   231,   232,   798,
     234,   235,   799,   800,   237,   238,   801,     0,   240,     0,
     241,   586,     0,   587,   242,   243,     0,   244,   802,     0,
     246,     0,   247,   248,   249,   250,   588,   251,   252,   253,
       0,   254,   255,   256,   257,   258,   259,     0,   589,   260,
     261,   262,   263,   264,   803,   804,     0,   805,     0,   268,
     590,   591,   269,   592,   270,   271,   272,   273,   274,     0,
     806,   593,   276,   594,     0,   277,   278,   279,   807,   808,
     280,   281,   282,   283,   284,   285,   286,   287,   288,   289,
       0,     0,     0,   290,   809,   595,   810,   412,   293,   294,
     295,   296,   297,   298,   299,   300,   301,   811,   302,   303,
     596,   304,   812,   813,   814,   307,   308,     0,     0,   309,
     413,     0,     0,   815,   311,     0,     0,   312,   597,   598,
     816,   314,   315,   316,   317,     0,   817,   319,   320,   321,
     322,     0,   323,   324,   325,   326,   327,   328,   818,   330,
     331,     0,   332,   333,   334,   335,   336,   337,   338,   339,
     340,     0,   341,   342,   599,   343,   344,   819,   346,   347,
     348,   349,   350,   351,   352,     0,   353,   354,   355,   820,
     356,   357,   358,   359,   600,   360,   821,     0,   362,   363,
     364,   365,   366,   367,   368,   369,   822,   371,     0,   372,
     373,     0,   374,   375,   376,   377,     0,   823,   824,     0,
       0,   380,   825,   382,   826,   827,   384,   385,   386,   387,
     388,     0,   828,   389,   390,   391,   392,   829,     0,   393,
     394,   395,   396,   830,   398,   601,   399,   400,     0,     0,
     401,     0,   402,   403,   404,   405,   406,     0,     0,     0,
     831,   832,   509,   833,   834,   835,   836,   837,     0,     0,
       0,     0,   838,   839,     0,     0,     0,     0,     0,     0,
       0,   841,  1739,   161,   162,   163,   164,   165,   166,   167,
     168,     0,   169,   170,     0,     0,     0,     0,     0,     0,
    2059,     0,   171,   172,     0,   173,     0,   174,   175,   176,
       0,   177,     0,   178,   179,     0,   180,   181,   182,   183,
     184,     0,     0,   185,   186,   187,   188,     0,   189,   190,
     191,   192,   193,     0,     0,   194,   195,   196,   197,   198,
       0,   199,   200,   201,   202,     0,   203,   204,   205,  -968,
     206,     0,     0,     0,     0,     0,   207,   208,   209,   210,
     211,   212,   213,   214,     0,   215,     0,   216,   217,   218,
     219,   220,     0,   221,     0,     0,   222,   223,   224,   225,
       0,   226,   227,   228,     0,   229,     0,   230,   231,   232,
     233,   234,   235,   236,     0,   237,   238,   239,     0,   240,
       0,   241,     0,     0,  -968,   242,   243,     0,   244,   245,
       0,   246,     0,   247,   248,   249,   250,     0,   251,   252,
     253,     0,   254,   255,   256,   257,   258,   259,     0,  -968,
     260,   261,   262,   263,   264,   265,   266,     0,   267,     0,
     268,     0,     0,   269,  -968,   270,   271,   272,   273,   274,
       0,   275,  -968,   276,     0,     0,   277,   278,   279,     0,
       0,   280,   281,   282,   283,   284,   285,   286,   287,   288,
     289,     0,     0,     0,   290,   291,  -968,   292,     0,   293,
     294,   295,   296,   297,   298,   299,   300,   301,     0,   302,
     303,     0,   304,     0,   305,   306,   307,   308,     0,     0,
     309,     0,     0,     0,   310,   311,     0,     0,   312,     0,
       0,   313,   314,   315,   316,   317,     0,   318,   319,   320,
     321,   322,     0,   323,   324,   325,   326,   327,   328,   329,
     330,   331,     0,   332,   333,   334,   335,   336,   337,   338,
     339,   340,     0,   341,   342,  -968,   343,   344,   345,   346,
     347,   348,   349,   350,   351,   352,     0,   353,   354,   355,
       0,   356,   357,   358,   359,     0,   360,   361,     0,   362,
     363,   364,   365,   366,   367,   368,   369,   370,   371,     0,
     372,   373,     0,   374,   375,   376,   377,     0,   378,   379,
       0,     0,   380,   381,   382,   383,     0,   384,   385,   386,
     387,   388,     0,     0,   389,   390,   391,   392,     0,     0,
     393,   394,   395,   396,   397,   398,     0,   399,   400,     0,
       0,   401,     0,   402,   403,   404,   405,   406,     0,     0,
       0,   407,   161,   162,   163,   164,   165,   166,   167,   168,
       0,   169,   170,     0,     0,     0,     0,     0,     0,     0,
       0,   171,   172,   906,   173,   582,   174,   175,   176,   583,
    1109,   584,  1110,  1111,     0,   180,   181,   182,   183,   184,
       0,     0,   185,  1112,  1113,   188,     0,   189,   190,   191,
     192,     0,     0,     0,   194,   195,   196,   197,   198,     0,
     199,   200,     0,   202,     0,   203,   204,   205,   585,   206,
       0,     0,     0,     0,     0,   207,   208,   209,   210,   211,
    1114,  1115,   214,     0,   215,     0,   216,   217,   218,   219,
     220,     0,   221,     0,     0,   222,   797,   224,   225,     0,
     226,   227,   228,     0,   229,     0,   230,   231,   232,     0,
     234,   235,     0,     0,   237,   238,  1116,     0,   240,     0,
     241,   586,     0,   587,   242,   243,     0,   244,     0,     0,
     246,     0,   247,   248,   249,   250,   588,   251,   252,   253,
    1457,   254,   255,   256,   257,   258,   259,     0,   589,  1458,
     261,   262,   263,   264,  1117,  1118,     0,  1119,     0,   268,
     590,   591,   269,   592,   270,   271,   272,   273,   274,     0,
       0,   593,   276,   594,     0,   277,   278,   279,     0,     0,
     280,   281,   282,   283,   284,   285,   286,   287,   288,   289,
       0,     0,     0,   290,  1120,   595,  1121,     0,   293,   294,
     295,   296,   297,   298,   299,     0,   301,     0,   302,   303,
     596,   304,     0,     0,  1122,   307,   308,     0,     0,   309,
       0,     0,     0,   310,   311,     0,     0,  1459,   597,   598,
       0,   314,   315,   316,   317,     0,     0,     0,   320,   321,
     322,     0,   323,   324,   325,   326,   327,   328,  1123,   330,
     331,     0,   332,   333,   334,   335,   336,   337,   338,   339,
     340,     0,   341,   342,   599,   343,   344,     0,   346,   347,
     348,   349,   350,   351,   352,     0,   353,   354,   355,     0,
     356,  1460,   358,   359,   600,   360,  1125,     0,   362,   363,
     364,   365,   366,   367,   368,   369,     0,   371,     0,   372,
     373,     0,   374,   375,   376,   377,     0,  1126,  1127,     0,
       0,   380,     0,   382,     0,     0,   384,   385,   386,   387,
     388,     0,     0,   389,   390,   391,   392,     0,     0,   393,
     394,   395,     0,  1128,   398,   601,   399,   400,     0,     0,
     401,     0,   402,   403,   404,   405,   406,     0,     0,     0,
    1461,   161,   162,   163,   164,   165,   166,   167,   168,     0,
     169,   170,     0,     0,     0,     0,     0,   780,     0,     0,
     171,   172,  1462,   173,   582,   174,   175,   176,   583,   781,
     584,   782,   783,  1749,   180,   181,   182,   183,   184,   784,
     785,   185,   786,   787,   188,     0,   189,   190,   191,   192,
     788,     0,     0,   194,   195,   196,   197,   198,     0,   199,
     200,   789,   202,     0,   203,   204,   205,   585,   206,   790,
     791,   792,   793,   794,   207,   208,   209,   210,   211,   795,
     796,   214,     0,   215,     0,   216,   217,   218,   219,   220,
       0,   221,     0,     0,   222,   797,   224,   225,     0,   226,
     227,   228,     0,   229,     0,   230,   231,   232,   798,   234,
     235,   799,   800,   237,   238,   801,     0,   240,     0,   241,
     586,  1750,   587,   242,   243,     0,   244,   802,     0,   246,
       0,   247,   248,   249,   250,   588,   251,   252,   253,     0,
     254,   255,   256,   257,   258,   259,     0,   589,   260,   261,
     262,   263,   264,   803,   804,     0,   805,     0,   268,   590,
     591,   269,   592,   270,   271,   272,   273,   274,  1751,   806,
     593,   276,   594,     0,   277,   278,   279,   807,   808,   280,
     281,   282,   283,   284,   285,   286,   287,   288,   289,     0,
       0,     0,   290,   809,   595,   810,   412,   293,   294,   295,
     296,   297,   298,   299,   300,   301,   811,   302,   303,   596,
     304,   812,   813,   814,   307,   308,     0,     0,   309,   413,
       0,     0,   815,   311,     0,     0,   312,   597,   598,   816,
     314,   315,   316,   317,     0,   817,   319,   320,   321,   322,
       0,   323,   324,   325,   326,   327,   328,   818,   330,   331,
       0,   332,   333,   334,   335,   336,   337,   338,   339,   340,
       0,   341,   342,   599,   343,   344,   819,   346,   347,   348,
     349,   350,   351,   352,     0,   353,   354,   355,   820,   356,
     357,   358,   359,   600,   360,   821,     0,   362,   363,   364,
     365,   366,   367,   368,   369,   822,   371,     0,   372,   373,
       0,   374,   375,   376,   377,     0,   823,   824,     0,  1752,
     380,   825,   382,   826,   827,   384,   385,   386,   387,   388,
       0,   828,   389,   390,   391,   392,   829,     0,   393,   394,
     395,   396,   830,   398,   601,   399,   400,     0,     0,   401,
       0,   402,   403,   404,   405,   406,     0,     0,     0,   831,
     832,   509,   833,   834,   835,   836,   837,     0,     0,     0,
       0,   838,   839,     0,     0,     0,     0,     0,     0,     0,
     841,   161,   162,   163,   164,   165,   166,   167,   168,     0,
     169,   170,     0,     0,     0,     0,     0,   780,     0,     0,
     171,   172,     0,   173,   582,   174,   175,   176,   583,   781,
     584,   782,   783,     0,   180,   181,   182,   183,   184,   784,
     785,   185,   786,   787,   188,     0,   189,   190,   191,   192,
     788,     0,     0,   194,   195,   196,   197,   198,     0,   199,
     200,   789,   202,     0,   203,   204,   205,   585,   206,   790,
     791,   792,   793,   794,   207,   208,   209,   210,   211,   795,
     796,   214,     0,   215,     0,   216,   217,   218,   219,   220,
       0,   221,     0,     0,   222,   797,   224,   225,     0,   226,
     227,   228,     0,   229,     0,   230,   231,   232,   798,   234,
     235,   799,   800,   237,   238,   801,     0,   240,     0,   241,
     586,     0,   587,   242,   243,     0,   244,   802,     0,   246,
       0,   247,   248,   249,   250,   588,   251,   252,   253,     0,
     254,   255,   256,   257,   258,   259,     0,   589,   260,   261,
     262,   263,   264,   803,   804,     0,   805,     0,   268,   590,
     591,   269,   592,   270,   271,   272,   273,   274,     0,   806,
     593,   276,   594,     0,   277,   278,   279,   807,   808,   280,
     281,   282,   283,   284,   285,   286,   287,   288,   289,     0,
       0,     0,   290,   809,   595,   810,   412,   293,   294,   295,
     296,   297,   298,   299,   300,   301,   811,   302,   303,   596,
     304,   812,   813,   814,   307,   308,     0,     0,   309,   413,
       0,     0,   815,   311,     0,     0,   312,   597,   598,   816,
     314,   315,   316,   317,     0,   817,   319,   320,   321,   322,
       0,   323,   324,   325,   326,   327,   328,   818,   330,   331,
       0,   332,   333,   334,   335,   336,   337,   338,   339,   340,
       0,   341,   342,   599,   343,   344,   819,   346,   347,   348,
     349,   350,   351,   352,     0,   353,   354,   355,   820,   356,
     357,   358,   359,   600,   360,   821,     0,   362,   363,   364,
     365,   366,   367,   368,   369,   822,   371,     0,   372,   373,
       0,   374,   375,   376,   377,     0,   823,   824,     0,     0,
     380,   825,   382,   826,   827,   384,   385,   386,   387,   388,
       0,   828,   389,   390,   391,   392,   829,     0,   393,   394,
     395,   396,   830,   398,   601,   399,   400,     0,     0,   401,
       0,   402,   403,   404,   405,   406,     0,     0,     0,   831,
     832,   509,   833,   834,   835,   836,   837,     0,     0,     0,
       0,   838,   839,   840,     0,     0,     0,     0,     0,     0,
     841,   161,   162,   163,   164,   165,   166,   167,   168,     0,
     169,   170,     0,     0,     0,     0,     0,   780,     0,     0,
     171,   172,     0,   173,   582,   174,   175,   176,   583,   781,
     584,   782,   783,     0,   180,   181,   182,   183,   184,   784,
     785,   185,   786,   787,   188,     0,   189,   190,   191,   192,
     788,     0,     0,   194,   195,   196,   197,   198,     0,   199,
     200,   789,   202,     0,   203,   204,   205,   585,   206,   790,
     791,   792,   793,   794,   207,   208,   209,   210,   211,   795,
     796,   214,   902,   215,     0,   216,   217,   218,   219,   220,
       0,   221,     0,     0,   222,   797,   224,   225,     0,   226,
     227,   228,     0,   229,     0,   230,   231,   232,   798,   234,
     235,   799,   800,   237,   238,   801,     0,   240,     0,   241,
     586,     0,   587,   242,   243,     0,   244,   802,     0,   246,
       0,   247,   248,   249,   250,   588,   251,   252,   253,     0,
     254,   255,   256,   257,   258,   259,     0,   589,   260,   261,
     262,   263,   264,   803,   804,     0,   805,     0,   268,   590,
     591,   269,   592,   270,   271,   272,   273,   274,     0,   806,
     593,   276,   594,     0,   277,   278,   279,   807,   808,   280,
     281,   282,   283,   284,   285,   286,   287,   288,   289,     0,
       0,     0,   290,   809,   595,   810,   412,   293,   294,   295,
     296,   297,   298,   299,   300,   301,   811,   302,   303,   596,
     304,   812,   813,   814,   307,   308,     0,     0,   309,   413,
       0,     0,   815,   311,     0,     0,   312,   597,   598,   816,
     314,   315,   316,   317,     0,   817,   319,   320,   321,   322,
       0,   323,   324,   325,   326,   327,   328,   818,   330,   331,
       0,   332,   333,   334,   335,   336,   337,   338,   339,   340,
       0,   341,   342,   599,   343,   344,   819,   346,   347,   348,
     349,   350,   351,   352,     0,   353,   354,   355,   820,   356,
     357,   358,   359,   600,   360,   821,     0,   362,   363,   364,
     365,   366,   367,   368,   369,   822,   371,     0,   372,   373,
       0,   374,   375,   376,   377,     0,   823,   824,     0,     0,
     380,   825,   382,   826,   827,   384,   385,   386,   387,   388,
       0,   828,   389,   390,   391,   392,   829,     0,   393,   394,
     395,   396,   830,   398,   601,   399,   400,     0,     0,   401,
       0,   402,   403,   404,   405,   406,     0,     0,     0,   831,
     832,   509,   833,   834,   835,   836,   837,     0,     0,     0,
       0,   838,   839,     0,     0,     0,     0,     0,     0,     0,
     841,   161,   162,   163,   164,   165,   166,   167,   168,     0,
     169,   170,     0,     0,     0,     0,     0,   780,     0,     0,
     171,   172,     0,   173,   582,   174,   175,   176,   583,   781,
     584,   782,   783,     0,   180,   181,   182,   183,   184,   784,
     785,   185,   786,   787,   188,     0,   189,   190,   191,   192,
     788,     0,     0,   194,   195,   196,   197,   198,     0,   199,
     200,   789,   202,     0,   203,   204,   205,   585,   206,   790,
     791,   792,   793,   794,   207,   208,   209,   210,   211,   795,
     796,   214,     0,   215,     0,   216,   217,   218,   219,   220,
       0,   221,     0,     0,   222,   797,   224,   225,     0,   226,
     227,   228,     0,   229,     0,   230,   231,   232,   798,   234,
     235,   799,   800,   237,   238,   801,     0,   240,     0,   241,
     586,     0,   587,   242,   243,     0,   244,   802,     0,   246,
       0,   247,   248,   249,   250,   588,   251,   252,   253,     0,
     254,   255,   256,   257,   258,   259,     0,   589,   260,   261,
     262,   263,   264,   803,   804,     0,   805,     0,   268,   590,
     591,   269,   592,   270,   271,   272,   273,   274,     0,   806,
     593,   276,   594,     0,   277,   278,   279,   807,   808,   280,
     281,   282,   283,   284,   285,   286,   287,   288,   289,     0,
       0,     0,   290,   809,   595,   810,   412,   293,   294,   295,
     296,   297,   298,   299,   300,   301,   811,   302,   303,   596,
     304,   812,   813,   814,   307,   308,     0,     0,   309,   413,
       0,     0,   815,   311,     0,     0,   312,   597,   598,   816,
     314,   315,   316,   317,     0,   817,   319,   320,   321,   322,
       0,   323,   324,   325,   326,   327,   328,   818,   330,   331,
       0,   332,   333,   334,   335,   336,   337,   338,   339,   340,
       0,   341,   342,   599,   343,   344,   819,   346,   347,   348,
     349,   350,   351,   352,    36,   353,   354,   355,   820,   356,
     357,   358,   359,   600,   360,   821,     0,   362,   363,   364,
     365,   366,   367,   368,   369,   822,   371,     0,   372,   373,
       0,   374,   375,   376,   377,     0,   823,   824,     0,     0,
     380,   825,   382,   826,   827,   384,   385,   386,   387,   388,
       0,   828,   389,   390,   391,   392,   829,     0,   393,   394,
     395,  1307,   830,   398,   601,   399,   400,     0,     0,   401,
       0,   402,   403,   404,   405,   406,     0,     0,     0,   831,
     832,   509,   833,   834,   835,   836,   837,     0,     0,     0,
       0,   838,   839,     0,     0,     0,     0,     0,     0,     0,
     841,   161,   162,   163,   164,   165,   166,   167,   168,  1410,
     169,   170,     0,     0,     0,     0,     0,   780,     0,     0,
     171,   172,     0,   173,   582,   174,   175,   176,   583,   781,
     584,   782,   783,     0,   180,   181,   182,   183,   184,   784,
     785,   185,   786,   787,   188,     0,   189,   190,   191,   192,
     788,     0,     0,   194,   195,   196,   197,   198,     0,   199,
     200,   789,   202,     0,   203,   204,   205,   585,   206,   790,
     791,   792,   793,   794,   207,   208,   209,   210,   211,   795,
     796,   214,     0,   215,     0,   216,   217,   218,   219,   220,
       0,   221,     0,     0,   222,   797,   224,   225,     0,   226,
     227,   228,     0,   229,     0,   230,   231,   232,   798,   234,
     235,   799,   800,   237,   238,   801,     0,   240,     0,   241,
     586,     0,   587,   242,   243,     0,   244,   802,     0,   246,
       0,   247,   248,   249,   250,   588,   251,   252,   253,     0,
     254,   255,   256,   257,   258,   259,     0,   589,   260,   261,
     262,   263,   264,   803,   804,     0,   805,     0,   268,   590,
     591,   269,   592,   270,   271,   272,   273,   274,     0,   806,
     593,   276,   594,     0,   277,   278,   279,   807,   808,   280,
     281,   282,   283,   284,   285,   286,   287,   288,   289,     0,
       0,     0,   290,   809,   595,   810,   412,   293,   294,   295,
     296,   297,   298,   299,   300,   301,   811,   302,   303,   596,
     304,   812,   813,   814,   307,   308,     0,     0,   309,   413,
       0,     0,   815,   311,     0,     0,   312,   597,   598,   816,
     314,   315,   316,   317,     0,   817,   319,   320,   321,   322,
       0,   323,   324,   325,   326,   327,   328,   818,   330,   331,
       0,   332,   333,   334,   335,   336,   337,   338,   339,   340,
       0,   341,   342,   599,   343,   344,   819,   346,   347,   348,
     349,   350,   351,   352,     0,   353,   354,   355,   820,   356,
     357,   358,   359,   600,   360,   821,     0,   362,   363,   364,
     365,   366,   367,   368,   369,   822,   371,     0,   372,   373,
       0,   374,   375,   376,   377,     0,   823,   824,     0,     0,
     380,   825,   382,   826,   827,   384,   385,   386,   387,   388,
       0,   828,   389,   390,   391,   392,   829,     0,   393,   394,
     395,   396,   830,   398,   601,   399,   400,     0,     0,   401,
       0,   402,   403,   404,   405,   406,     0,     0,     0,   831,
     832,   509,   833,   834,   835,   836,   837,     0,     0,     0,
       0,   838,   839,     0,     0,     0,     0,     0,     0,     0,
     841,   161,   162,   163,   164,   165,   166,   167,   168,     0,
     169,   170,     0,     0,     0,     0,     0,   780,     0,     0,
     171,   172,     0,   173,   582,   174,   175,   176,   583,   781,
     584,   782,   783,     0,   180,   181,   182,   183,   184,   784,
     785,   185,   786,   787,   188,     0,   189,   190,   191,   192,
     788,     0,     0,   194,   195,   196,   197,   198,     0,   199,
     200,   789,   202,     0,   203,   204,   205,   585,   206,   790,
     791,   792,   793,   794,   207,   208,   209,   210,   211,   795,
     796,   214,     0,   215,     0,   216,   217,   218,   219,   220,
       0,   221,     0,     0,   222,   797,   224,   225,     0,   226,
     227,   228,     0,   229,     0,   230,   231,   232,   798,   234,
     235,   799,   800,   237,   238,   801,     0,   240,     0,   241,
     586,     0,   587,   242,   243,     0,   244,   802,     0,   246,
       0,   247,   248,   249,   250,   588,   251,   252,   253,     0,
     254,   255,   256,   257,   258,   259,     0,   589,   260,   261,
     262,   263,   264,   803,   804,     0,   805,     0,   268,   590,
     591,   269,   592,   270,   271,   272,   273,   274,     0,   806,
     593,   276,   594,     0,   277,   278,   279,   807,   808,   280,
     281,   282,   283,   284,   285,   286,   287,   288,   289,     0,
       0,     0,   290,   809,   595,   810,   412,   293,   294,   295,
     296,   297,   298,   299,   300,   301,   811,   302,   303,   596,
     304,   812,   813,   814,   307,   308,     0,     0,   309,   413,
       0,     0,   815,   311,     0,     0,   312,   597,   598,   816,
     314,   315,   316,   317,     0,   817,   319,   320,   321,   322,
       0,   323,   324,   325,   326,   327,   328,   818,   330,   331,
       0,   332,   333,   334,   335,   336,   337,   338,   339,   340,
       0,   341,   342,   599,   343,   344,   819,   346,   347,   348,
     349,   350,   351,   352,     0,   353,   354,   355,   820,   356,
     357,   358,   359,   600,   360,   821,     0,   362,   363,   364,
     365,   366,   367,   368,   369,   822,   371,     0,   372,   373,
       0,   374,   375,   376,   377,     0,   823,   824,     0,     0,
     380,   825,   382,   826,   827,   384,   385,   386,   387,   388,
       0,   828,   389,   390,   391,   392,   829,     0,   393,   394,
     395,   396,   830,   398,   601,   399,   400,     0,     0,   401,
       0,   402,   403,   404,   405,   406,     0,     0,     0,   831,
     832,   509,   833,   834,   835,   836,   837,     0,     0,     0,
       0,   838,   839,     0,     0,     0,     0,     0,  1257,     0,
     841,   161,   162,   163,   164,   165,   166,   167,   168,     0,
     169,   170,     0,     0,     0,     0,     0,   780,     0,     0,
     171,   172,     0,   173,   582,   174,   175,   176,   583,   781,
     584,   782,   783,     0,   180,   181,   182,   183,   184,   784,
     785,   185,   786,   787,   188,     0,   189,   190,   191,   192,
     788,     0,     0,   194,   195,   196,   197,   198,     0,   199,
     200,   789,   202,     0,   203,   204,   205,   585,   206,   790,
     791,   792,   793,   794,   207,   208,   209,   210,   211,   795,
     796,   214,     0,   215,     0,   216,   217,   218,   219,   220,
       0,   221,     0,     0,   222,   797,   224,   225,     0,   226,
     227,   228,     0,   229,     0,   230,   231,   232,   798,   234,
     235,   799,   800,   237,   238,   801,     0,   240,     0,   241,
     586,  1750,   587,   242,   243,     0,   244,   802,     0,   246,
       0,   247,   248,   249,   250,   588,   251,   252,   253,     0,
     254,   255,   256,   257,   258,   259,     0,   589,   260,   261,
     262,   263,   264,   803,   804,     0,   805,     0,   268,   590,
     591,   269,   592,   270,   271,   272,   273,   274,     0,   806,
     593,   276,   594,     0,   277,   278,   279,   807,   808,   280,
     281,   282,   283,   284,   285,   286,   287,   288,   289,     0,
       0,     0,   290,   809,   595,   810,   412,   293,   294,   295,
     296,   297,   298,   299,   300,   301,   811,   302,   303,   596,
     304,   812,   813,   814,   307,   308,     0,     0,   309,   413,
       0,     0,   815,   311,     0,     0,   312,   597,   598,   816,
     314,   315,   316,   317,     0,   817,   319,   320,   321,   322,
       0,   323,   324,   325,   326,   327,   328,   818,   330,   331,
       0,   332,   333,   334,   335,   336,   337,   338,   339,   340,
       0,   341,   342,   599,   343,   344,   819,   346,   347,   348,
     349,   350,   351,   352,     0,   353,   354,   355,   820,   356,
     357,   358,   359,   600,   360,   821,     0,   362,   363,   364,
     365,   366,   367,   368,   369,   822,   371,     0,   372,   373,
       0,   374,   375,   376,   377,     0,   823,   824,     0,     0,
     380,   825,   382,   826,   827,   384,   385,   386,   387,   388,
       0,   828,   389,   390,   391,   392,   829,     0,   393,   394,
     395,   396,   830,   398,   601,   399,   400,     0,     0,   401,
       0,   402,   403,   404,   405,   406,     0,     0,     0,   831,
     832,   509,   833,   834,   835,   836,   837,     0,     0,     0,
       0,   838,   839,     0,     0,     0,     0,     0,     0,     0,
     841,   161,   162,   163,   164,   165,   166,   167,   168,     0,
     169,   170,     0,     0,     0,     0,     0,   780,     0,     0,
     171,   172,     0,   173,   582,   174,   175,   176,   583,   781,
     584,   782,   783,     0,   180,   181,   182,   183,   184,   784,
     785,   185,   786,   787,   188,     0,   189,   190,   191,   192,
     788,     0,     0,   194,   195,   196,   197,   198,     0,   199,
     200,   789,   202,     0,   203,   204,   205,   585,   206,   790,
     791,   792,   793,   794,   207,   208,   209,   210,   211,   795,
     796,   214,     0,   215,     0,   216,   217,   218,   219,   220,
       0,   221,     0,     0,   222,   797,   224,   225,     0,   226,
     227,   228,     0,   229,     0,   230,   231,   232,   798,   234,
     235,   799,   800,   237,   238,   801,     0,   240,     0,   241,
     586,     0,   587,   242,   243,     0,   244,   802,     0,   246,
       0,   247,   248,   249,   250,   588,   251,   252,   253,     0,
     254,   255,   256,   257,   258,   259,     0,   589,   260,   261,
     262,   263,   264,   803,   804,     0,   805,     0,   268,   590,
     591,   269,   592,   270,   271,   272,   273,   274,     0,   806,
     593,   276,   594,     0,   277,   278,   279,   807,   808,   280,
     281,   282,   283,   284,   285,   286,   287,   288,   289,     0,
       0,     0,   290,   809,   595,   810,   412,   293,   294,   295,
     296,   297,   298,   299,   300,   301,   811,   302,   303,   596,
     304,   812,   813,   814,   307,   308,     0,     0,   309,   413,
       0,     0,   815,   311,     0,     0,   312,   597,   598,   816,
     314,   315,   316,   317,     0,   817,   319,   320,   321,   322,
       0,   323,   324,   325,   326,   327,   328,   818,   330,   331,
       0,   332,   333,   334,   335,   336,   337,   338,   339,   340,
       0,   341,   342,   599,   343,   344,   819,   346,   347,   348,
     349,   350,   351,   352,     0,   353,   354,   355,   820,   356,
     357,   358,   359,   600,   360,   821,     0,   362,   363,   364,
     365,   366,   367,   368,   369,   822,   371,     0,   372,   373,
       0,   374,   375,   376,   377,     0,   823,   824,     0,     0,
     380,   825,   382,   826,   827,   384,   385,   386,   387,   388,
       0,   828,   389,   390,   391,   392,   829,     0,   393,   394,
     395,   396,   830,   398,   601,   399,   400,     0,     0,   401,
       0,   402,   403,   404,   405,   406,     0,     0,     0,   831,
     832,   509,   833,   834,   835,   836,   837,     0,     0,     0,
       0,   838,   839,     0,     0,     0,     0,     0,     0,     0,
     841,   161,   162,   163,   164,   165,   166,   167,   168,     0,
     169,   170,     0,     0,     0,     0,     0,   780,     0,     0,
     171,   172,     0,   173,   582,   174,   175,   176,   583,   781,
     584,   782,   783,     0,   180,   181,   182,   183,   184,   784,
     785,   185,   786,   787,   188,     0,   189,   190,   191,   192,
     788,     0,     0,   194,   195,   196,   197,   198,     0,   199,
     200,   789,   202,     0,   203,   204,   205,   585,   206,   790,
     791,   792,   793,   794,   207,   208,   209,   210,   211,   795,
     796,   214,     0,   215,     0,   216,   217,   218,   219,   220,
       0,   221,     0,     0,   222,   797,   224,   225,     0,   226,
     227,   228,     0,   229,     0,   230,   231,   232,   798,   234,
     235,   799,   800,   237,   238,   801,     0,   240,     0,   241,
     586,     0,   587,   242,   243,     0,   244,   802,     0,   246,
       0,   247,   248,   249,   250,   588,   251,   252,   253,     0,
     254,   255,   256,   257,   258,   259,     0,   589,   260,   261,
     262,   263,   264,   803,   804,     0,   805,     0,   268,   590,
     591,   269,   592,   270,   271,   272,   273,   274,     0,   806,
     593,   276,   594,     0,   277,   278,   279,   807,   808,   280,
     281,   282,   283,   284,   285,   286,   287,   288,   289,     0,
       0,     0,   290,   809,   595,   810,   412,   293,   294,   295,
     296,   297,   298,   299,   300,   301,     0,   302,   303,   596,
     304,   812,   813,   814,   307,   308,     0,     0,   309,   413,
       0,     0,   815,   311,     0,     0,   312,   597,   598,   816,
     314,   315,   316,   317,     0,   817,   319,   320,   321,   322,
       0,   323,   324,   325,   326,   327,   328,   818,   330,   331,
       0,   332,   333,   334,   335,   336,   337,   338,   339,   340,
       0,   341,   342,   599,   343,   344,   819,   346,   347,   348,
     349,   350,   351,   352,     0,   353,   354,   355,   820,   356,
     357,   358,   359,   600,   360,   821,     0,   362,   363,   364,
     365,   366,   367,   368,   369,   822,   371,     0,   372,   373,
       0,   374,   375,   376,   377,     0,   823,   824,     0,     0,
     380,   825,   382,   826,   827,   384,   385,   386,   387,   388,
       0,     0,   389,   390,   391,   392,   829,     0,   393,   394,
     395,   396,   830,   398,   601,   399,   400,     0,     0,   401,
       0,   402,   403,   404,   405,   406,     0,     0,     0,   831,
     832,   509,   833,   834,   835,   836,   837,     0,     0,     0,
       0,  1732,  1733,     0,     0,     0,     0,     0,     0,     0,
     841,   161,   162,   163,   164,   165,   166,   167,   168,     0,
     169,   170,     0,     0,     0,     0,     0,   780,     0,     0,
     171,   172,     0,   173,   582,   174,   175,   176,     0,   781,
     584,   782,   783,     0,   180,   181,   182,   183,   184,   784,
     785,   185,   786,   787,   188,     0,   189,   190,   191,   192,
     788,     0,     0,   194,   195,   196,   197,   198,     0,   199,
     200,   789,   202,     0,   203,   204,   205,   585,   206,   790,
     791,   792,   793,   794,   207,   208,   209,   210,   211,   795,
     796,   214,     0,   215,     0,   216,   217,   218,   219,   220,
       0,   221,     0,     0,   222,   797,   224,   225,     0,   226,
     227,   228,     0,     0,     0,   230,   231,   232,   798,   234,
     235,   799,   800,   237,   238,   801,     0,   240,     0,   241,
     586,     0,   587,   242,   243,     0,   244,   802,     0,   246,
       0,   247,   248,   249,   250,     0,   251,   252,   253,     0,
     254,   255,   256,   257,   258,   259,     0,   589,   260,   261,
     262,   263,   264,   803,   804,     0,   805,     0,   268,   590,
     591,   269,   592,   270,   271,   272,   273,   274,     0,   806,
     593,   276,     0,     0,   277,   278,   279,   807,   808,   280,
     281,   282,   283,   284,   285,   286,   287,   288,   289,     0,
       0,     0,   290,   809,   595,   810,   412,   293,   294,   295,
     296,   297,   298,   299,   300,   301,     0,   302,   303,   596,
     304,   812,   813,   814,   307,   308,     0,     0,   309,   413,
       0,     0,   815,   311,     0,     0,   312,   597,   598,   816,
     314,   315,   316,   317,     0,   817,   319,   320,   321,   322,
       0,   323,   324,   325,   326,   327,   328,   818,   330,   331,
       0,   332,   333,   334,   335,   336,   337,   338,   339,   340,
       0,   341,   342,   599,   343,   344,   819,   346,   347,   348,
     349,   350,   351,   352,     0,   353,   354,   355,   820,   356,
     357,   358,   359,     0,   360,   821,     0,   362,   363,   364,
     365,   366,   367,   368,   369,   822,   371,     0,   372,   373,
       0,   374,   375,   376,   377,     0,   823,   824,     0,     0,
     380,   825,   382,   826,   827,   384,   385,   386,   387,   388,
       0,   828,   389,   390,   391,   392,   829,     0,   393,   394,
     395,   396,   830,   398,   601,   399,   400,     0,     0,   401,
       0,   402,   403,   404,   405,   406,     0,     0,     0,   831,
     832,   509,   833,   834,   835,   836,   837,     0,     0,     0,
       0,   838,   839,     0,     0,     0,     0,     0,     0,     0,
     841,   161,   162,   163,   164,   165,   166,   167,   168,     0,
     169,   170,     0,     0,     0,     0,     0,   780,     0,     0,
     171,   172,     0,   173,   582,   174,   175,   176,     0,   781,
     584,   782,   783,     0,   180,   181,   182,   183,   184,   784,
     785,   185,   786,   787,   188,     0,   189,   190,   191,   192,
     788,     0,     0,   194,   195,   196,   197,   198,     0,   199,
     200,   789,   202,     0,   203,   204,   205,   585,   206,   790,
     791,   792,   793,   794,   207,   208,   209,   210,   211,   795,
     796,   214,     0,   215,     0,   216,   217,   218,   219,   220,
       0,   221,     0,     0,   222,   797,   224,   225,     0,   226,
     227,   228,     0,     0,     0,   230,   231,   232,   798,   234,
     235,   799,   800,   237,   238,   801,     0,   240,     0,   241,
     586,     0,   587,   242,   243,     0,   244,   802,     0,   246,
       0,   247,   248,   249,   250,     0,   251,   252,   253,     0,
     254,   255,   256,   257,   258,   259,     0,   589,   260,   261,
     262,   263,   264,   803,   804,     0,   805,     0,   268,   590,
     591,   269,   592,   270,   271,   272,   273,   274,     0,   806,
     593,   276,     0,     0,   277,   278,   279,   807,   808,   280,
     281,   282,   283,   284,   285,   286,   287,   288,   289,     0,
       0,     0,   290,   809,   595,   810,   412,   293,   294,   295,
     296,   297,   298,   299,   300,   301,     0,   302,   303,   596,
     304,   812,   813,   814,   307,   308,     0,     0,   309,   413,
       0,     0,   815,   311,     0,     0,   312,   597,   598,   816,
     314,   315,   316,   317,     0,   817,   319,   320,   321,   322,
       0,   323,   324,   325,   326,   327,   328,   818,   330,   331,
       0,   332,   333,   334,   335,   336,   337,   338,   339,   340,
       0,   341,   342,   599,   343,   344,   819,   346,   347,   348,
     349,   350,   351,   352,     0,   353,   354,   355,   820,   356,
     357,   358,   359,     0,   360,   821,     0,   362,   363,   364,
     365,   366,   367,   368,   369,   822,   371,     0,   372,   373,
       0,   374,   375,   376,   377,     0,   823,   824,     0,     0,
     380,   825,   382,   826,   827,   384,   385,   386,   387,   388,
       0,     0,   389,   390,   391,   392,   829,     0,   393,   394,
     395,   396,   830,   398,   601,   399,   400,     0,     0,   401,
       0,   402,   403,   404,   405,   406,     0,     0,     0,   831,
     832,   509,   833,   834,   835,   836,   837,     0,     0,     0,
       0,  1732,  1733,     0,     0,     0,     0,     0,     0,     0,
     841,   161,   162,   163,   164,   165,   166,   167,   168,     0,
     169,   170,     0,     0,     0,     0,     0,     0,     0,     0,
     171,   172,     0,   173,   582,   174,   175,   176,   583,   177,
     584,   178,   179,     0,   180,   181,   182,   183,   184,     0,
     785,   185,   186,   187,   188,     0,   189,   190,   191,   192,
     788,     0,     0,   194,   195,   196,   197,   198,     0,   199,
     200,   789,   202,     0,   203,   204,   205,   585,   206,   790,
     791,   792,   793,   794,   207,   208,   209,   210,   211,   212,
     213,   214,     0,   215,     0,   216,   217,   218,   219,   220,
       0,   221,     0,     0,   222,   223,   224,   225,     0,   226,
     227,   228,     0,   229,     0,   230,   231,   232,   233,   234,
     235,   799,     0,   237,   238,   239,     0,   240,     0,   241,
     586,     0,   587,   242,   243,     0,   244,   802,     0,   246,
       0,   247,   248,   249,   250,   588,   251,   252,   253,     0,
     254,   255,   256,   257,   258,   259,     0,   589,   260,   261,
     262,   263,   264,   265,   266,     0,   267,     0,   268,   590,
     591,   269,   592,   270,   271,   272,   273,   274,     0,   806,
     593,   276,   594,     0,   277,   278,   279,   807,   808,   280,
     281,   282,   283,   284,   285,   286,   287,   288,   289,     0,
       0,     0,   290,   291,   595,   292,   412,   293,   294,   295,
     296,   297,   298,   299,   300,   301,     0,   302,   303,   596,
     304,     0,   813,   306,   307,   308,     0,     0,   309,   413,
       0,   561,   310,   311,     0,     0,   312,   597,   598,   816,
     314,   315,   316,   317,     0,   817,   319,   320,   321,   322,
       0,   323,   324,   325,   326,   327,   328,   329,   330,   331,
       0,   332,   333,   334,   335,   336,   337,   338,   339,   340,
       0,   341,   342,   599,   343,   344,   345,   346,   347,   348,
     349,   350,   351,   352,    36,   353,   354,   355,   820,   356,
     357,   358,   359,   600,   360,   361,     0,   362,   363,   364,
     365,   366,   367,   368,   369,   822,   371,     0,   372,   373,
       0,   374,   375,   376,   377,     0,   378,   379,     0,     0,
     380,   825,   382,   826,     0,   384,   385,   386,   387,   388,
       0,     0,   389,   390,   391,   392,   829,     0,   393,   394,
     395,  1307,   397,   398,   601,   399,   400,     0,     0,   401,
       0,   402,   403,   404,   405,   406,     0,     0,     0,   602,
       0,     0,   161,   162,   163,   164,   165,   166,   167,   168,
       0,   169,   170,     0,     0,     0,     0,     0,     0,     0,
    1616,   171,   172,     0,   173,   582,   174,   175,   176,   583,
     177,   584,   178,   179,     0,   180,   181,   182,   183,   184,
       0,   785,   185,   186,   187,   188,     0,   189,   190,   191,
     192,   788,     0,     0,   194,   195,   196,   197,   198,     0,
     199,   200,   789,   202,     0,   203,   204,   205,   585,   206,
     790,   791,   792,   793,   794,   207,   208,   209,   210,   211,
     212,   213,   214,     0,   215,     0,   216,   217,   218,   219,
     220,     0,   221,     0,     0,   222,   223,   224,   225,     0,
     226,   227,   228,     0,   229,     0,   230,   231,   232,   233,
     234,   235,   799,     0,   237,   238,   239,     0,   240,     0,
     241,   586,     0,   587,   242,   243,     0,   244,   802,     0,
     246,     0,   247,   248,   249,   250,   588,   251,   252,   253,
       0,   254,   255,   256,   257,   258,   259,     0,   589,   260,
     261,   262,   263,   264,   265,   266,     0,   267,     0,   268,
     590,   591,   269,   592,   270,   271,   272,   273,   274,     0,
     806,   593,   276,   594,     0,   277,   278,   279,   807,   808,
     280,   281,   282,   283,   284,   285,   286,   287,   288,   289,
       0,     0,     0,   290,   291,   595,   292,   412,   293,   294,
     295,   296,   297,   298,   299,   300,   301,     0,   302,   303,
     596,   304,     0,   813,   306,   307,   308,     0,     0,   309,
     413,     0,   561,   310,   311,     0,     0,   312,   597,   598,
     816,   314,   315,   316,   317,     0,   817,   319,   320,   321,
     322,     0,   323,   324,   325,   326,   327,   328,   329,   330,
     331,     0,   332,   333,   334,   335,   336,   337,   338,   339,
     340,     0,   341,   342,   599,   343,   344,   345,   346,   347,
     348,   349,   350,   351,   352,     0,   353,   354,   355,   820,
     356,   357,   358,   359,   600,   360,   361,     0,   362,   363,
     364,   365,   366,   367,   368,   369,   822,   371,     0,   372,
     373,     0,   374,   375,   376,   377,     0,   378,   379,     0,
       0,   380,   825,   382,   826,     0,   384,   385,   386,   387,
     388,     0,     0,   389,   390,   391,   392,   829,     0,   393,
     394,   395,   396,   397,   398,   601,   399,   400,     0,     0,
     401,     0,   402,   403,   404,   405,   406,     0,     0,     0,
     602,     0,     0,   161,   162,   163,   164,   165,   166,   167,
     168,     0,   169,   170,     0,     0,     0,     0,     0,     0,
       0,  1616,   171,   172,     0,   173,   582,   174,   175,   176,
     583,   177,   584,   178,   179,     0,   180,   181,   182,   183,
     184,     0,   785,   185,   186,   187,   188,     0,   189,   190,
     191,   192,   788,     0,     0,   194,   195,   196,   197,   198,
       0,   199,   200,   789,   202,     0,   203,   204,   205,   585,
     206,   790,   791,   792,   793,   794,   207,   208,   209,   210,
     211,   212,   213,   214,     0,   215,     0,   216,   217,   218,
     219,   220,     0,   221,     0,     0,   222,   223,   224,   225,
       0,   226,   227,   228,     0,   229,     0,   230,   231,   232,
     233,   234,   235,   799,     0,   237,   238,   239,     0,   240,
       0,   241,   586,     0,   587,   242,   243,     0,   244,   802,
       0,   246,     0,   247,   248,   249,   250,   588,   251,   252,
     253,     0,   254,   255,   256,   257,   258,   259,     0,   589,
     260,   261,   262,   263,   264,   265,   266,     0,   267,     0,
     268,   590,   591,   269,   592,   270,   271,   272,   273,   274,
       0,   806,   593,   276,   594,     0,   277,   278,   279,   807,
     808,   280,   281,   282,   283,   284,   285,   286,   287,   288,
     289,     0,     0,     0,   290,   291,   595,   292,   412,   293,
     294,   295,   296,   297,   298,   299,   300,   301,     0,   302,
     303,   596,   304,     0,   813,   306,   307,   308,     0,     0,
     309,   413,     0,     0,   310,   311,     0,     0,   312,   597,
     598,   816,   314,   315,   316,   317,     0,   817,   319,   320,
     321,   322,     0,   323,   324,   325,   326,   327,   328,   329,
     330,   331,     0,   332,   333,   334,   335,   336,   337,   338,
     339,   340,     0,   341,   342,   599,   343,   344,   345,   346,
     347,   348,   349,   350,   351,   352,     0,   353,   354,   355,
     820,   356,   357,   358,   359,   600,   360,   361,     0,   362,
     363,   364,   365,   366,   367,   368,   369,   822,   371,     0,
     372,   373,     0,   374,   375,   376,   377,     0,   378,   379,
       0,     0,   380,   825,   382,   826,     0,   384,   385,   386,
     387,   388,     0,     0,   389,   390,   391,   392,   829,     0,
     393,   394,   395,   396,   397,   398,   601,   399,   400,     0,
       0,   401,     0,   402,   403,   404,   405,   406,     0,     0,
       0,   602,     0,     0,   161,   162,   163,   164,   165,   166,
     167,   168,     0,   169,   170,     0,     0,     0,     0,     0,
       0,     0,  2770,   171,   172,     0,   173,     0,   174,   175,
     176,     0,   177,     0,   178,   179,     0,   180,   181,   182,
     183,   184,     0,     0,   185,   186,   187,   188,     0,   189,
     190,   191,   192,   193,     0,     0,   194,   195,   196,   197,
     198,     0,   199,   200,   201,   202,     0,   203,   204,   205,
       0,   206,     0,     0,     0,     0,     0,   207,   208,   209,
     210,   211,   212,   213,   214,     0,   215,     0,   216,   217,
     218,   219,   220,     0,   221,     0,     0,   222,   223,   224,
     225,     0,   226,   227,   228,     0,   229,     0,   230,   231,
     232,   233,   234,   235,   236,     0,   237,   238,   239,     0,
     240,     0,   241,     0,     0,     0,   242,   243,     0,   244,
     245,     0,   246,     0,   247,   248,   249,   250,     0,   251,
     252,   253,     0,   254,   255,   256,   257,   258,   259,     0,
       0,   260,   261,   262,   263,   264,   265,   266,     0,   267,
       0,   268,     0,     0,   269,     0,   270,   271,   272,   273,
     274,     0,   275,     0,   276,     0,     0,   277,   278,   279,
       0,     0,   280,   281,   282,   283,   284,   285,   286,   287,
     288,   289,     0,     0,     0,   290,   291,     0,   292,   412,
     293,   294,   295,   296,   297,   298,   299,   300,   301,     0,
     302,   303,     0,   304,     0,   305,   306,   307,   308,     0,
       0,   309,   413,     0,     0,   310,   311,     0,     0,   312,
       0,     0,   313,   314,   315,   316,   317,     0,   318,   319,
     320,   321,   322,     0,   323,   324,   325,   326,   327,   328,
     329,   330,   331,     0,   332,   333,   334,   335,   336,   337,
     338,   339,   340,     0,   341,   342,     0,   343,   344,   345,
     346,   347,   348,   349,   350,   351,   352,     0,   353,   354,
     355,     0,   356,   357,   358,   359,     0,   360,   361,     0,
     362,   363,   364,   365,   366,   367,   368,   369,   370,   371,
       0,   372,   373,     0,   374,   375,   376,   377,     0,   378,
     379,     0,     0,   380,   381,   382,   383,     0,   384,   385,
     386,   387,   388,     0,     0,   389,   390,   391,   392,     0,
       0,   393,   394,   395,   396,   397,   398,     0,   399,   400,
       0,     0,   401,     0,   402,   403,   404,   405,   406,     0,
       0,     0,   407,     0,     0,   161,   162,   163,   164,   165,
     166,   167,   168,     0,   169,   170,     0,     0,     0,     0,
       0,     0,     0,   894,   171,   172,     0,   173,     0,   174,
     175,   176,     0,   177,     0,   178,   179,     0,   180,   181,
     182,   183,   184,     0,     0,   185,   186,   187,   188,     0,
     189,   190,   191,   192,   193,     0,     0,   194,   195,   196,
     197,   198,     0,   199,   200,   201,   202,     0,   203,   204,
     205,     0,   206,     0,     0,     0,     0,     0,   207,   208,
     209,   210,   211,   212,   213,   214,     0,   215,     0,   216,
     217,   218,   219,   220,     0,   221,     0,     0,   222,   223,
     224,   225,     0,   226,   227,   228,     0,   229,     0,   230,
     231,   232,   233,   234,   235,   236,     0,   237,   238,   239,
       0,   240,     0,   241,     0,     0,     0,   242,   243,     0,
     244,   245,     0,   246,     0,   247,   248,   249,   250,     0,
     251,   252,   253,     0,   254,   255,   256,   257,   258,   259,
       0,     0,   260,   261,   262,   263,   264,   265,   266,     0,
     267,     0,   268,     0,     0,   269,     0,   270,   271,   272,
     273,   274,     0,   275,     0,   276,     0,     0,   277,   278,
     279,     0,     0,   280,   281,   282,   283,   284,   285,   286,
     287,   288,   289,     0,     0,     0,   290,   291,     0,   292,
       0,   293,   294,   295,   296,   297,   298,   299,   300,   301,
       0,   302,   303,     0,   304,     0,   305,   306,   307,   308,
       0,     0,   309,     0,     0,     0,   310,   311,     0,     0,
     312,     0,     0,   313,   314,   315,   316,   317,     0,   318,
     319,   320,   321,   322,     0,   323,   324,   325,   326,   327,
     328,   329,   330,   331,     0,   332,   333,   334,   335,   336,
     337,   338,   339,   340,     0,   341,   342,     0,   343,   344,
     345,   346,   347,   348,   349,   350,   351,   352,    36,   353,
     354,   355,     0,   356,   357,   358,   359,     0,   360,   361,
       0,   362,   363,   364,   365,   366,   367,   368,   369,   370,
     371,     0,   372,   373,     0,   374,   375,   376,   377,     0,
     378,   379,     0,     0,   380,   381,   382,   383,     0,   384,
     385,   386,   387,   388,     0,     0,   389,   390,   391,   392,
       0,     0,   393,   394,   395,  1307,   397,   398,     0,   399,
     400,     0,     0,   401,     0,   402,   403,   404,   405,   406,
       0,     0,     0,   407,     0,     0,   161,   162,   163,   164,
     165,   166,   167,   168,     0,   169,   170,     0,     0,     0,
       0,     0,     0,     0,    45,   171,   172,     0,   173,     0,
     174,   175,   176,     0,   177,     0,   178,   179,     0,   180,
     181,   182,   183,   184,     0,     0,   185,   186,   187,   188,
       0,   189,   190,   191,   192,   193,     0,     0,   194,   195,
     196,   197,   198,     0,   199,   200,   201,   202,     0,   203,
     204,   205,     0,   206,     0,     0,     0,     0,     0,   207,
     208,   209,   210,   211,   212,   213,   214,     0,   215,     0,
     216,   217,   218,   219,   220,     0,   221,     0,     0,   222,
     223,   224,   225,     0,   226,   227,   228,     0,   229,     0,
     230,   231,   232,   233,   234,   235,   236,     0,   237,   238,
     239,     0,   240,     0,   241,     0,     0,     0,   242,   243,
       0,   244,   245,     0,   246,     0,   247,   248,   249,   250,
       0,   251,   252,   253,     0,   254,   255,   256,   257,   258,
     259,     0,     0,   260,   261,   262,   263,   264,   265,   266,
       0,   267,     0,   268,     0,     0,   269,     0,   270,   271,
     272,   273,   274,     0,   275,     0,   276,     0,     0,   277,
     278,   279,     0,     0,   280,   281,   282,   283,   284,   285,
     286,   287,   288,   289,     0,     0,     0,   290,   291,     0,
     292,     0,   293,   294,   295,   296,   297,   298,   299,   300,
     301,     0,   302,   303,     0,   304,     0,   305,   306,   307,
     308,     0,     0,   309,     0,     0,     0,   310,   311,     0,
       0,   312,     0,     0,   313,   314,   315,   316,   317,     0,
     318,   319,   320,   321,   322,     0,   323,   324,   325,   326,
     327,   328,   329,   330,   331,     0,   332,   333,   334,   335,
     336,   337,   338,   339,   340,     0,   341,   342,     0,   343,
     344,   345,   346,   347,   348,   349,   350,   351,   352,     0,
     353,   354,   355,     0,   356,   357,   358,   359,     0,   360,
     361,     0,   362,   363,   364,   365,   366,   367,   368,   369,
     370,   371,     0,   372,   373,     0,   374,   375,   376,   377,
       0,   378,   379,     0,     0,   380,   381,   382,   383,     0,
     384,   385,   386,   387,   388,     0,     0,   389,   390,   391,
     392,     0,     0,   393,   394,   395,   396,   397,   398,     0,
     399,   400,     0,     0,   401,     0,   402,   403,   404,   405,
     406,     0,     0,     0,   407,     0,     0,   161,   162,   163,
     164,   165,   166,   167,   168,     0,   169,   170,     0,     0,
       0,     0,     0,     0,     0,  1387,   171,   172,     0,   173,
       0,   174,   175,   176,     0,   177,     0,   178,   179,     0,
     180,   181,   182,   183,   184,     0,     0,   185,   186,   187,
     188,     0,   189,   190,   191,   192,   193,     0,     0,   194,
     195,   196,   197,   198,     0,   199,   200,   201,   202,     0,
     203,   204,   205,     0,   206,     0,     0,     0,     0,     0,
     207,   208,   209,   210,   211,   212,   213,   214,     0,   215,
       0,   216,   217,   218,   219,   220,     0,   221,     0,     0,
     222,   223,   224,   225,     0,   226,   227,   228,     0,   229,
       0,   230,   231,   232,   233,   234,   235,   236,     0,   237,
     238,   239,     0,   240,     0,   241,     0,     0,     0,   242,
     243,     0,   244,   245,     0,   246,     0,   247,   248,   249,
     250,     0,   251,   252,   253,     0,   254,   255,   256,   257,
     258,   259,     0,     0,   260,   261,   262,   263,   264,   265,
     266,     0,   267,     0,   268,     0,     0,   269,     0,   270,
     271,   272,   273,   274,     0,   275,     0,   276,     0,     0,
     277,   278,   279,     0,     0,   280,   281,   282,   283,   284,
     285,   286,   287,   288,   289,     0,     0,     0,   290,   291,
       0,   292,     0,   293,   294,   295,   296,   297,   298,   299,
     300,   301,     0,   302,   303,     0,   304,     0,   305,   306,
     307,   308,     0,     0,   309,     0,     0,     0,   310,   311,
       0,     0,   312,     0,     0,   313,   314,   315,   316,   317,
       0,   318,   319,   320,   321,   322,     0,   323,   324,   325,
     326,   327,   328,   329,   330,   331,     0,   332,   333,   334,
     335,   336,   337,   338,   339,   340,     0,   341,   342,     0,
     343,   344,   345,   346,   347,   348,   349,   350,   351,   352,
       0,   353,   354,   355,     0,   356,   357,   358,   359,     0,
     360,   361,     0,   362,   363,   364,   365,   366,   367,   368,
     369,   370,   371,     0,   372,   373,     0,   374,   375,   376,
     377,     0,   378,   379,     0,     0,   380,   381,   382,   383,
       0,   384,   385,   386,   387,   388,     0,     0,   389,   390,
     391,   392,     0,     0,   393,   394,   395,   396,   397,   398,
       0,   399,   400,     0,     0,   401,     0,   402,   403,   404,
     405,   406,     0,     0,     0,   407,     0,     0,     0,     0,
       0,   161,   162,   163,   164,   165,   166,   167,   168,  1004,
     169,   170,  1005,  1006,  1007,  1008,  2421,  1009,  1010,  1011,
     171,   172,  1012,   173,   582,   174,   175,   176,   583,  1109,
     584,  1110,  1111,  1013,   180,   181,   182,   183,   184,  1014,
    1015,   185,  1112,  1113,   188,  1016,   189,   190,   191,   192,
       0,  1017,  1018,   194,   195,   196,   197,   198,  1019,   199,
     200,     0,   202,  1020,   203,   204,   205,   585,   206,  1021,
    1022,  1023,  1024,  1025,   207,   208,   209,   210,   211,  1114,
    1115,   214,  1026,   215,  1027,   216,   217,   218,   219,   220,
    1028,   221,  1029,  1030,   222,   797,   224,   225,  1031,   226,
     227,   228,  1032,   229,  1033,   230,   231,   232,     0,   234,
     235,     0,  1034,   237,   238,  1116,  1035,   240,  1036,   241,
     586,  1037,   587,   242,   243,  1038,   244,     0,  1039,   246,
    1040,   247,   248,   249,   250,   588,   251,   252,   253,  1041,
     254,   255,   256,   257,   258,   259,  1042,   589,     0,   261,
     262,   263,   264,  1117,  1118,  1043,  1119,  1044,   268,   590,
     591,   269,   592,   270,   271,   272,   273,   274,  1045,     0,
     593,   276,   594,  1046,   277,   278,   279,  1047,  1048,   280,
     281,   282,   283,   284,   285,   286,   287,   288,   289,     0,
       0,     0,   290,  1120,   595,  1121,  1049,   293,   294,   295,
     296,   297,   298,   299,     0,   301,  1050,   302,   303,   596,
     304,  1051,     0,  1122,   307,   308,  1052,  1053,   309,  1054,
    1055,  1056,  2323,   311,  1057,  1058,     0,   597,   598,     0,
     314,   315,   316,   317,  1059,     0,     0,   320,   321,   322,
    1060,   323,   324,   325,   326,   327,   328,  1123,   330,   331,
    1061,   332,   333,   334,   335,   336,   337,   338,   339,   340,
    1062,   341,   342,   599,   343,   344,     0,   346,   347,   348,
     349,   350,   351,   352,  1063,   353,   354,   355,  1064,   356,
    1460,   358,   359,   600,   360,  1125,  1065,   362,   363,   364,
     365,   366,   367,   368,   369,     0,   371,  1066,   372,   373,
    1067,   374,   375,   376,   377,  1068,  1126,  1127,  1069,  1070,
     380,     0,   382,     0,  1071,   384,   385,   386,   387,   388,
    1072,  1073,   389,   390,   391,   392,  1074,  1075,   393,   394,
     395,     0,  1128,   398,   601,   399,   400,  1076,  1077,   401,
       0,   402,   403,   404,   405,   406,     0,     0,     0,  1129,
    1362,   509,     0,     0,   620,   493,     0,   621,   622,   623,
       0,   624,  2324,   626,   627,   628,   629,   161,   162,   163,
     164,   165,   166,   167,   168,     0,   169,   170,     0,     0,
       0,     0,     0,     0,     0,     0,   171,   172,     0,   173,
       0,   174,   175,   176,     0,   177,     0,   178,   179,     0,
     180,   181,   182,   183,   184,     0,     0,   185,   186,   187,
     188,     0,   189,   619,   191,   192,   193,     0,     0,   194,
     195,   196,   197,   198,     0,   199,   200,   201,   202,     0,
     203,   204,   205,     0,   206,     0,     0,     0,     0,     0,
     207,   208,   209,   210,   211,   212,   213,   214,     0,   215,
       0,   216,   217,   218,   219,   220,     0,   221,     0,     0,
     222,   223,   224,   225,     0,   226,   227,   228,     0,   229,
       0,   230,   231,   232,   233,   234,   235,   236,     0,   237,
     238,   239,     0,   240,     0,   241,     0,     0,     0,   242,
     243,     0,   244,   245,     0,   246,     0,   247,   248,   249,
     250,     0,   251,   252,   253,     0,   254,   255,   256,   257,
     258,   259,     0,     0,   260,   261,   262,   263,   264,   265,
     266,     0,   267,     0,   268,     0,     0,   269,     0,   270,
     271,   272,   273,   274,     0,   275,     0,   276,     0,     0,
     277,   278,   279,     0,     0,   280,   281,   282,   283,   284,
     285,   286,   287,   288,   289,     0,     0,     0,   290,   291,
       0,   292,     0,   293,   294,   295,   296,   297,   298,   299,
     300,   301,     0,   302,   303,     0,   304,     0,   305,   306,
     307,   308,     0,     0,   309,     0,     0,     0,   310,   311,
       0,     0,   312,     0,     0,   313,   314,   315,   316,   317,
       0,   318,   319,   320,   321,   322,     0,   323,   324,   325,
     326,   327,   328,   329,   330,   331,     0,   332,   333,   334,
     335,   336,   337,   338,   339,   340,     0,   341,   342,     0,
     343,   344,   345,   346,   347,   348,   349,   350,   351,   352,
       0,   353,   354,   355,     0,   356,   357,   358,   359,     0,
     360,   361,     0,   362,   363,   364,   365,   366,   367,   368,
     369,   370,   371,     0,   372,   373,     0,   374,   375,   376,
     377,     0,   378,   379,     0,     0,   380,   381,   382,   383,
       0,   384,   385,   386,   387,   388,     0,     0,   389,   390,
     391,   392,     0,     0,   393,   394,   395,   396,   397,   398,
       0,   399,   400,     0,     0,   401,     0,   402,   403,   404,
     405,   406,     0,     0,     0,   407,     0,     0,     0,     0,
     620,     0,     0,   621,   622,   623,     0,   624,   625,   626,
     627,   628,   629,   161,   162,   163,   164,   165,   166,   167,
     168,     0,   169,   170,     0,     0,     0,     0,     0,     0,
       0,     0,   171,   172,     0,   173,     0,   174,   175,   176,
       0,   177,     0,   178,   179,     0,   180,   181,   182,   183,
     184,     0,     0,   185,   186,   187,   188,     0,   189,   689,
     191,   192,   193,     0,     0,   194,   195,   196,   197,   198,
       0,   199,   200,   201,   202,     0,   203,   204,   205,     0,
     206,     0,     0,     0,     0,     0,   207,   208,   209,   210,
     211,   212,   213,   214,     0,   215,     0,   216,   217,   218,
     219,   220,     0,   221,     0,     0,   222,   223,   224,   225,
       0,   226,   227,   228,     0,   229,     0,   230,   231,   232,
     233,   234,   235,   236,     0,   237,   238,   239,     0,   240,
       0,   241,     0,     0,     0,   242,   243,     0,   244,   245,
       0,   246,     0,   247,   248,   249,   250,     0,   251,   252,
     253,     0,   254,   255,   256,   257,   258,   259,     0,     0,
     260,   261,   262,   263,   264,   265,   266,     0,   267,     0,
     268,     0,     0,   269,     0,   270,   271,   272,   273,   274,
       0,   275,     0,   276,     0,     0,   277,   278,   279,     0,
       0,   280,   281,   282,   283,   284,   285,   286,   287,   288,
     289,     0,     0,     0,   290,   291,     0,   292,     0,   293,
     294,   295,   296,   297,   298,   299,   300,   301,     0,   302,
     303,     0,   304,     0,   305,   306,   307,   308,     0,     0,
     309,     0,     0,     0,   310,   311,     0,     0,   312,     0,
       0,   313,   314,   315,   316,   317,     0,   318,   319,   320,
     321,   322,     0,   323,   324,   325,   326,   327,   328,   329,
     330,   331,     0,   332,   333,   334,   335,   336,   337,   338,
     339,   340,     0,   341,   342,     0,   343,   344,   345,   346,
     347,   348,   349,   350,   351,   352,     0,   353,   354,   355,
       0,   356,   357,   358,   359,     0,   360,   361,     0,   362,
     363,   364,   365,   366,   367,   368,   369,   370,   371,     0,
     372,   373,     0,   374,   375,   376,   377,     0,   378,   379,
       0,     0,   380,   381,   382,   383,     0,   384,   385,   386,
     387,   388,     0,     0,   389,   390,   391,   392,     0,     0,
     393,   394,   395,   396,   397,   398,     0,   399,   400,     0,
       0,   401,     0,   402,   403,   404,   405,   406,     0,     0,
       0,   407,     0,     0,     0,     0,   620,     0,     0,   621,
     622,   623,     0,   624,   625,   626,   627,   628,   629,   161,
     162,   163,   164,   165,   166,   167,   168,     0,   169,   170,
       0,     0,     0,     0,     0,     0,     0,     0,   171,   172,
       0,   173,     0,   174,   175,   176,     0,   177,     0,   178,
     179,     0,   180,   181,   182,   183,   184,     0,     0,   185,
     186,   187,   188,     0,   189,   722,   191,   192,   193,     0,
       0,   194,   195,   196,   197,   198,     0,   199,   200,   201,
     202,     0,   203,   204,   205,     0,   206,     0,     0,     0,
       0,     0,   207,   208,   209,   210,   211,   212,   213,   214,
       0,   215,     0,   216,   217,   218,   219,   220,     0,   221,
       0,     0,   222,   223,   224,   225,     0,   226,   227,   228,
       0,   229,     0,   230,   231,   232,   233,   234,   235,   236,
       0,   237,   238,   239,     0,   240,     0,   241,     0,     0,
       0,   242,   243,     0,   244,   245,     0,   246,     0,   247,
     248,   249,   723,     0,   251,   252,   253,     0,   254,   255,
     256,   257,   258,   259,     0,     0,   260,   261,   262,   263,
     264,   265,   266,     0,   267,     0,   268,     0,     0,   269,
       0,   270,   271,   272,   273,   274,     0,   275,     0,   276,
       0,     0,   277,   278,   279,     0,     0,   280,   281,   282,
     283,   284,   285,   286,   287,   288,   289,     0,     0,     0,
     290,   291,     0,   292,     0,   293,   294,   295,   296,   297,
     298,   299,   300,   301,     0,   302,   303,     0,   304,     0,
     305,   306,   307,   308,     0,     0,   309,     0,     0,     0,
     310,   311,     0,     0,   312,     0,     0,   313,   314,   315,
     316,   317,     0,   318,   319,   320,   321,   322,     0,   323,
     324,   325,   326,   327,   328,   329,   330,   331,     0,   332,
     333,   334,   335,   336,   337,   338,   339,   340,     0,   341,
     342,     0,   343,   344,   345,   346,   347,   348,   349,   350,
     351,   352,     0,   353,   354,   355,     0,   356,   357,   358,
     359,     0,   360,   361,     0,   362,   363,   364,   365,   366,
     367,   368,   369,   370,   371,     0,   372,   373,     0,   374,
     375,   376,   377,     0,   378,   379,     0,     0,   380,   381,
     382,   383,     0,   384,   385,   386,   387,   388,     0,     0,
     389,   390,   391,   392,     0,     0,   393,   394,   395,   396,
     397,   398,     0,   399,   400,     0,     0,   401,     0,   402,
     403,   404,   405,   406,     0,     0,     0,   407,     0,     0,
       0,     0,   620,     0,     0,   621,   622,   623,     0,   624,
     625,   626,   627,   628,   629,   161,   162,   163,   164,   165,
     166,   167,   168,     0,   169,   170,     0,     0,     0,     0,
       0,     0,     0,     0,   171,   172,     0,   173,     0,   174,
     175,   176,     0,   177,     0,   178,   179,     0,   180,   181,
     182,   183,   184,     0,     0,   185,   186,   187,   188,     0,
     189,  1093,   191,   192,   193,     0,     0,   194,   195,   196,
     197,   198,     0,   199,   200,   201,   202,     0,   203,   204,
     205,     0,   206,     0,     0,     0,     0,     0,   207,   208,
     209,   210,   211,   212,   213,   214,     0,   215,     0,   216,
     217,   218,   219,   220,     0,   221,     0,     0,   222,   223,
     224,   225,     0,   226,   227,   228,     0,   229,     0,   230,
     231,   232,   233,   234,   235,   236,     0,   237,   238,   239,
       0,   240,     0,   241,     0,     0,     0,   242,   243,     0,
     244,   245,     0,   246,     0,   247,   248,   249,   250,     0,
     251,   252,   253,     0,   254,   255,   256,   257,   258,   259,
       0,     0,   260,   261,   262,   263,   264,   265,   266,     0,
     267,     0,   268,     0,     0,   269,     0,   270,   271,   272,
     273,   274,     0,   275,     0,   276,     0,     0,   277,   278,
     279,     0,     0,   280,   281,   282,   283,   284,   285,   286,
     287,   288,   289,     0,     0,     0,   290,   291,     0,   292,
       0,   293,   294,   295,   296,   297,   298,   299,   300,   301,
       0,   302,   303,     0,   304,     0,   305,   306,   307,   308,
       0,     0,   309,     0,     0,     0,   310,   311,     0,     0,
     312,     0,     0,   313,   314,   315,   316,   317,     0,   318,
     319,   320,   321,   322,     0,   323,   324,   325,   326,   327,
     328,   329,   330,   331,     0,   332,   333,   334,   335,   336,
     337,   338,   339,   340,     0,   341,   342,     0,   343,   344,
     345,   346,   347,   348,   349,   350,   351,   352,     0,   353,
     354,   355,     0,   356,   357,   358,   359,     0,   360,   361,
       0,   362,   363,   364,   365,   366,   367,   368,   369,   370,
     371,     0,   372,   373,     0,   374,   375,   376,   377,     0,
     378,   379,     0,     0,   380,   381,   382,   383,     0,   384,
     385,   386,   387,   388,     0,     0,   389,   390,   391,   392,
       0,     0,   393,   394,   395,   396,   397,   398,     0,   399,
     400,     0,     0,   401,     0,   402,   403,   404,   405,   406,
       0,     0,     0,   407,     0,     0,     0,     0,   620,     0,
       0,   621,   622,   623,     0,   624,   625,   626,   627,   628,
     629,   161,   162,   163,   164,   165,   166,   167,   168,     0,
     169,   170,     0,     0,     0,     0,     0,     0,     0,     0,
     171,   172,     0,   173,     0,   174,   175,   176,     0,   177,
       0,   178,   179,     0,   180,   181,   182,   183,   184,     0,
       0,   185,   186,   187,   188,     0,   189,   190,   191,   192,
     193,     0,     0,   194,   195,   196,   197,   198,     0,   199,
     200,   201,   202,     0,   203,   204,   205,     0,   206,     0,
       0,     0,     0,     0,   207,   208,   209,   210,   211,   212,
     213,   214,     0,   215,     0,   216,   217,   218,   219,   220,
       0,   221,     0,     0,   222,   223,   224,   225,     0,   226,
     227,   228,     0,   229,     0,   230,   231,   232,   233,   234,
     235,   236,     0,   237,   238,   239,     0,   240,     0,   241,
       0,     0,     0,   242,   243,     0,   244,   245,     0,   246,
       0,   247,   248,   249,   250,     0,   251,   252,   253,     0,
     254,   255,   256,   257,   258,   259,     0,     0,   260,   261,
     262,   263,   264,   265,   266,     0,   267,     0,   268,     0,
       0,   269,     0,   270,   271,   272,   273,   274,     0,   275,
       0,   276,     0,     0,   277,   278,   279,     0,     0,   280,
     281,   282,   283,   284,   285,   286,   287,   288,   289,     0,
       0,     0,   290,   291,     0,   292,     0,   293,   294,   295,
     296,   297,   298,   299,   300,   301,     0,   302,   303,     0,
     304,     0,   305,   306,   307,   308,     0,     0,   309,     0,
       0,     0,   310,   311,     0,     0,   312,     0,     0,   313,
     314,   315,   316,   317,     0,   318,   319,   320,   321,   322,
       0,   323,   324,   325,   326,   327,   328,   329,   330,   331,
       0,   332,   333,   334,   335,   336,   337,   338,   339,   340,
       0,   341,   342,     0,   343,   344,   345,   346,   347,   348,
     349,   350,   351,   352,     0,   353,   354,   355,     0,   356,
     357,   358,   359,     0,   360,   361,     0,   362,   363,   364,
     365,   366,   367,   368,   369,   370,   371,     0,   372,   373,
       0,   374,   375,   376,   377,     0,   378,   379,     0,     0,
     380,   381,   382,   383,     0,   384,   385,   386,   387,   388,
       0,     0,   389,   390,   391,   392,     0,     0,   393,   394,
     395,   396,   397,   398,     0,   399,   400,     0,     0,   401,
       0,   402,   403,   404,   405,   406,     0,     0,     0,   407,
       0,     0,     0,     0,   620,     0,     0,   621,   622,   623,
       0,   624,   625,   626,   627,   628,   629,   161,   162,   163,
     164,   165,   166,   167,   168,  1004,   169,   170,  1005,  1006,
    1007,  1008,     0,  1009,  1010,  1011,   171,   172,  1012,   173,
     582,   174,   175,   176,   583,   177,   584,   178,   179,  1013,
     180,   181,   182,   183,   184,  1014,  1015,   185,   186,   187,
     188,  1016,   189,   190,   191,   192,   193,  1017,  1018,   194,
     195,   196,   197,   198,  1019,   199,   200,   201,   202,  1020,
     203,   204,   205,   585,   206,  1021,  1022,  1023,  1024,  1025,
     207,   208,   209,   210,   211,   212,   213,   214,  1026,   215,
    1027,   216,   217,   218,   219,   220,  1028,   221,  1029,  1030,
     222,   223,   224,   225,  1031,   226,   227,   228,  1032,   229,
    1033,   230,   231,   232,   233,   234,   235,   236,  1034,   237,
     238,   239,  1035,   240,  1036,   241,   586,  1037,   587,   242,
     243,  1038,   244,   245,  1039,   246,  1040,   247,   248,   249,
     250,   588,   251,   252,   253,  1041,   254,   255,   256,   257,
     258,   259,  1042,   589,   260,   261,   262,   263,   264,   265,
     266,  1043,   267,  1044,   268,   590,   591,   269,   592,   270,
     271,   272,   273,   274,  1045,   275,   593,   276,   594,  1046,
     277,   278,   279,  1047,  1048,   280,   281,   282,   283,   284,
     285,   286,   287,   288,   289,     0,     0,     0,   290,   291,
     595,   292,  1049,   293,   294,   295,   296,   297,   298,   299,
     300,   301,  1050,   302,   303,   596,   304,  1051,   305,   306,
     307,   308,  1052,  1053,   309,  1054,  1055,  1056,   310,   311,
    1057,  1058,   312,   597,   598,   313,   314,   315,   316,   317,
    1059,   318,   319,   320,   321,   322,  1060,   323,   324,   325,
     326,   327,   328,   329,   330,   331,  1061,   332,   333,   334,
     335,   336,   337,   338,   339,   340,  1062,   341,   342,   599,
     343,   344,   345,   346,   347,   348,   349,   350,   351,   352,
    1063,   353,   354,   355,  1064,   356,   357,   358,   359,   600,
     360,   361,  1065,   362,   363,   364,   365,   366,   367,   368,
     369,   370,   371,  1066,   372,   373,  1067,   374,   375,   376,
     377,  1068,   378,   379,  1069,  1070,   380,   381,   382,   383,
    1071,   384,   385,   386,   387,   388,  1072,  1073,   389,   390,
     391,   392,  1074,  1075,   393,   394,   395,   396,   397,   398,
     601,   399,   400,  1076,  1077,   401,     0,   402,   403,   404,
     405,   406,     0,     0,     0,  1078,   161,   162,   163,   164,
     165,   166,   167,   168,     0,   169,   170,     0,     0,  1079,
       0,     0,     0,     0,     0,   171,   172,     0,   173,     0,
     174,   175,   176,     0,   177,     0,   178,   179,     0,   180,
     181,   182,   183,   184,     0,     0,   185,   186,   187,   188,
       0,   189,   190,   191,   192,   193,     0,     0,   194,   195,
     196,   197,   198,     0,   199,   200,   201,   202,     0,   203,
     204,   205,     0,   206,     0,     0,     0,     0,     0,   207,
     208,   209,   210,   211,   212,   213,   214,     0,   215,     0,
     216,   217,   218,   219,   220,     0,   221,     0,     0,   222,
     223,   224,   225,     0,   226,   227,   228,     0,   229,     0,
     230,   231,   232,   233,   234,   235,   236,     0,   237,   238,
     239,     0,   240,     0,   241,     0,     0,     0,   242,   243,
       0,   244,   245,     0,   246,     0,   247,   248,   249,   250,
       0,   251,   252,   253,     0,   254,   255,   256,   257,   258,
     259,     0,     0,   260,   261,   262,   263,   264,   265,   266,
       0,   267,     0,   268,     0,     0,   269,     0,   270,   271,
     272,   273,   274,     0,   275,     0,   276,     0,     0,   277,
     278,   279,     0,     0,   280,   281,   282,   283,   284,   285,
     286,   287,   288,   289,     0,     0,     0,   290,   291,     0,
     292,   412,   293,   294,   295,   296,   297,   298,   299,   300,
     301,     0,   302,   303,     0,   304,     0,   305,   306,   307,
     308,     0,     0,   309,   413,     0,     0,   310,   311,     0,
       0,   312,     0,     0,   313,   314,   315,   316,   317,     0,
     318,   319,   320,   321,   322,     0,   323,   324,   325,   326,
     327,   328,   329,   330,   331,     0,   332,   333,   334,   335,
     336,   337,   338,   339,   340,     0,   341,   342,     0,   343,
     344,   345,   346,   347,   348,   349,   350,   351,   352,     0,
     353,   354,   355,     0,   356,   357,   358,   359,     0,   360,
     361,     0,   362,   363,   364,   365,   366,   367,   368,   369,
     370,   371,     0,   372,   373,     0,   374,   375,   376,   377,
       0,   378,   379,     0,     0,   380,   381,   382,   383,     0,
     384,   385,   386,   387,   388,     0,     0,   389,   390,   391,
     392,     0,     0,   393,   394,   395,   396,   397,   398,     0,
     399,   400,     0,     0,   401,     0,   402,   403,   404,   405,
     406,     0,     0,     0,   407,   161,   162,   163,   164,   165,
     166,   167,   168,     0,   169,   170,     0,     0,   559,     0,
       0,     0,     0,     0,   171,   172,     0,   173,     0,   174,
     175,   176,     0,  1109,     0,  1110,  1111,     0,   180,   181,
     182,   183,   184,     0,     0,   185,  1112,  1113,   188,     0,
     189,   190,   191,   192,     0,     0,     0,   194,   195,   196,
     197,   198,     0,   199,   200,     0,   202,     0,   203,   204,
     205,     0,   206,     0,     0,     0,     0,     0,   207,   208,
     209,   210,   211,  1114,  1115,   214,     0,   215,     0,   216,
     217,   218,   219,   220,     0,   221,     0,     0,   222,   797,
     224,   225,     0,   226,   227,   228,     0,   229,     0,   230,
     231,   232,     0,   234,   235,     0,     0,   237,   238,  1116,
       0,   240,     0,   241,     0,     0,     0,   242,   243,     0,
     244,     0,     0,   246,     0,   247,   248,   249,   250,     0,
     251,   252,   253,     0,   254,   255,   256,   257,   258,   259,
       0,     0,     0,   261,   262,   263,   264,  1117,  1118,     0,
    1119,     0,   268,     0,     0,   269,     0,   270,   271,   272,
     273,   274,     0,     0,     0,   276,     0,     0,   277,   278,
     279,     0,     0,   280,   281,   282,   283,   284,   285,   286,
     287,   288,   289,     0,     0,     0,   290,  1120,     0,  1121,
       0,   293,   294,   295,   296,   297,   298,   299,     0,   301,
       0,   302,   303,     0,   304,     0,     0,  1122,   307,   308,
       0,     0,   309,     0,     0,     0,   310,   311,     0,     0,
       0,     0,     0,     0,   314,   315,   316,   317,     0,     0,
       0,   320,   321,   322,     0,   323,   324,   325,   326,   327,
     328,  1123,   330,   331,     0,   332,   333,   334,   335,   336,
     337,   338,   339,   340,     0,   341,   342,     0,   343,   344,
       0,   346,   347,   348,   349,   350,   351,   352,     0,   353,
     354,   355,     0,   356,  1124,   358,   359,     0,   360,  1125,
       0,   362,   363,   364,   365,   366,   367,   368,   369,     0,
     371,     0,   372,   373,     0,   374,   375,   376,   377,     0,
    1126,  1127,     0,     0,   380,     0,   382,     0,     0,   384,
     385,   386,   387,   388,     0,     0,   389,   390,   391,   392,
       0,     0,   393,   394,   395,     0,  1128,   398,     0,   399,
     400,     0,     0,   401,     0,   402,   403,   404,   405,   406,
       0,     0,     0,  1129,   161,   162,   163,   164,   165,   166,
     167,   168,     0,   169,   170,     0,     0,  1421,     0,     0,
       0,     0,     0,   171,   172,     0,   173,     0,   174,   175,
     176,     0,  1109,     0,  1110,  1111,     0,   180,   181,   182,
     183,   184,     0,     0,   185,  1112,  1113,   188,     0,   189,
     190,   191,   192,     0,     0,     0,   194,   195,   196,   197,
     198,     0,   199,   200,     0,   202,     0,   203,   204,   205,
       0,   206,     0,     0,     0,     0,     0,   207,   208,   209,
     210,   211,  1114,  1115,   214,     0,   215,     0,   216,   217,
     218,   219,   220,     0,   221,     0,     0,   222,   797,   224,
     225,     0,   226,   227,   228,     0,   229,     0,   230,   231,
     232,     0,   234,   235,     0,     0,   237,   238,  1116,     0,
     240,     0,   241,     0,     0,     0,   242,   243,     0,   244,
       0,     0,   246,     0,   247,   248,   249,   250,     0,   251,
     252,   253,     0,   254,   255,   256,   257,   258,   259,     0,
       0,     0,   261,   262,   263,   264,  1117,  1118,     0,  1119,
       0,   268,     0,     0,   269,     0,   270,   271,   272,   273,
     274,     0,     0,     0,   276,     0,     0,   277,   278,   279,
       0,     0,   280,   281,   282,   283,   284,   285,   286,   287,
     288,   289,     0,     0,     0,   290,  1120,     0,  1121,     0,
     293,   294,   295,   296,   297,   298,   299,     0,   301,     0,
     302,   303,     0,   304,     0,     0,  1122,   307,   308,     0,
       0,   309,     0,     0,     0,   310,   311,     0,     0,     0,
       0,     0,     0,   314,   315,   316,   317,     0,     0,     0,
     320,   321,   322,     0,   323,   324,   325,   326,   327,   328,
    1123,   330,   331,     0,   332,   333,   334,   335,   336,   337,
     338,   339,   340,     0,   341,   342,     0,   343,   344,     0,
     346,   347,   348,   349,   350,   351,   352,     0,   353,   354,
     355,     0,   356,  1124,   358,   359,     0,   360,  1125,     0,
     362,   363,   364,   365,   366,   367,   368,   369,     0,   371,
       0,   372,   373,     0,   374,   375,   376,   377,     0,  1126,
    1127,     0,     0,   380,     0,   382,     0,     0,   384,   385,
     386,   387,   388,     0,     0,   389,   390,   391,   392,     0,
       0,   393,   394,   395,     0,  1128,   398,     0,   399,   400,
       0,     0,   401,     0,   402,   403,   404,   405,   406,     0,
       0,     0,  1554,   161,   162,   163,   164,   165,   166,   167,
     168,     0,   169,   170,     0,     0,  1421,     0,     0,     0,
       0,     0,   171,   172,     0,   173,     0,   174,   175,   176,
       0,   177,     0,   178,   179,     0,   180,   181,   182,   183,
     184,     0,     0,   185,   186,   187,   188,     0,   189,   190,
     191,   192,   193,     0,     0,   194,   195,   196,   197,   198,
       0,   199,   200,   201,   202,     0,   203,   204,   205,     0,
     206,     0,     0,     0,     0,     0,   207,   208,   209,   210,
     211,   212,   213,   214,  1371,   215,     0,   216,   217,   218,
     219,   220,     0,   221,     0,     0,   222,   223,   224,   225,
       0,   226,   227,   228,     0,   229,     0,   230,   231,   232,
     233,   234,   235,   236,  1372,   237,   238,   239,     0,   240,
       0,   241,     0,     0,     0,   242,   243,     0,   244,   245,
       0,   246,     0,   247,   248,   249,   250,     0,   251,   252,
     253,     0,   254,   255,   256,   257,   258,   259,     0,     0,
     260,   261,   262,   263,   264,   265,   266,     0,   267,     0,
     268,     0,     0,   269,     0,   270,   271,   272,   273,   274,
       0,   275,     0,   276,     0,     0,   277,   278,   279,     0,
       0,   280,   281,   282,   283,   284,   285,   286,   287,   288,
     289,     0,     0,     0,   290,   291,     0,   292,     0,   293,
     294,   295,   296,   297,   298,   299,   300,   301,     0,   302,
     303,     0,   304,     0,   305,   306,   307,   308,  1373,     0,
     309,     0,  1374,     0,   310,   311,     0,     0,   312,     0,
       0,   313,   314,   315,   316,   317,     0,   318,   319,   320,
     321,   322,     0,   323,   324,   325,   326,   327,   328,   329,
     330,   331,     0,   332,   333,   334,   335,   336,   337,   338,
     339,   340,     0,   341,   342,     0,   343,   344,   345,   346,
     347,   348,   349,   350,   351,   352,     0,   353,   354,   355,
       0,   356,   357,   358,   359,     0,   360,   361,     0,   362,
     363,   364,   365,   366,   367,   368,   369,   370,   371,     0,
     372,   373,     0,   374,   375,   376,   377,     0,   378,   379,
       0,     0,   380,   381,   382,   383,  1375,   384,   385,   386,
     387,   388,     0,     0,   389,   390,   391,   392,     0,     0,
     393,   394,   395,   396,   397,   398,     0,   399,   400,     0,
       0,   401,     0,   402,   403,   404,   405,   406,     0,     0,
       0,   407,  1362,   879,     0,     0,     0,   493,     0,     0,
       0,     0,     0,     0,  1363,   161,   162,   163,   164,   165,
     166,   167,   168,     0,   169,   170,     0,     0,     0,     0,
       0,     0,     0,     0,   171,   172,     0,   173,     0,   174,
     175,   176,     0,   177,     0,   178,   179,     0,   180,   181,
     182,   183,   184,     0,     0,   185,   186,   187,   188,     0,
     189,   190,   191,   192,   193,     0,     0,   194,   195,   196,
     197,   198,     0,   199,   200,   201,   202,     0,   203,   204,
     205,     0,   206,     0,     0,     0,     0,     0,   207,   208,
     209,   210,   211,   212,   213,   214,     0,   215,     0,   216,
     217,   218,   219,   220,     0,   221,     0,     0,   222,   223,
     224,   225,     0,   226,   227,   228,     0,   229,     0,   230,
     231,   232,   233,   234,   235,   236,  1372,   237,   238,   239,
       0,   240,     0,   241,     0,     0,     0,   242,   243,     0,
     244,   245,     0,   246,     0,   247,   248,   249,   250,     0,
     251,   252,   253,     0,   254,   255,   256,   257,   258,   259,
       0,     0,   260,   261,   262,   263,   264,   265,   266,     0,
     267,     0,   268,     0,     0,   269,     0,   270,   271,   272,
     273,   274,     0,   275,     0,   276,     0,     0,   277,   278,
     279,     0,     0,   280,   281,   282,   283,   284,   285,   286,
     287,   288,   289,     0,     0,     0,   290,   291,     0,   292,
       0,   293,   294,   295,   296,   297,   298,   299,   300,   301,
       0,   302,   303,     0,   304,     0,   305,   306,   307,   308,
    1373,     0,   309,     0,  1374,     0,   310,   311,     0,     0,
     312,     0,     0,   313,   314,   315,   316,   317,     0,   318,
     319,   320,   321,   322,     0,   323,   324,   325,   326,   327,
     328,   329,   330,   331,     0,   332,   333,   334,   335,   336,
     337,   338,   339,   340,     0,   341,   342,     0,   343,   344,
     345,   346,   347,   348,   349,   350,   351,   352,     0,   353,
     354,   355,     0,   356,   357,   358,   359,     0,   360,   361,
       0,   362,   363,   364,   365,   366,   367,   368,   369,   370,
     371,     0,   372,   373,     0,   374,   375,   376,   377,     0,
     378,   379,     0,     0,   380,   381,   382,   383,  1375,   384,
     385,   386,   387,   388,     0,     0,   389,   390,   391,   392,
       0,     0,   393,   394,   395,   396,   397,   398,     0,   399,
     400,     0,     0,   401,     0,   402,   403,   404,   405,   406,
       0,     0,     0,   407,  1362,   879,     0,     0,     0,   493,
       0,     0,     0,     0,     0,     0,  1363,   161,   484,   163,
     164,   165,   166,   167,   168,   485,   169,   170,     0,     0,
       0,     0,     0,     0,     0,     0,   171,   172,     0,   173,
       0,   486,   175,   176,     0,   177,     0,   178,   179,     0,
     180,   181,   182,   183,   184,     0,     0,   185,   186,   187,
     188,     0,   189,   190,   191,   192,   193,     0,     0,   194,
     195,   196,   197,   198,     0,   199,   200,   201,   202,     0,
     203,   204,   205,     0,   206,     0,     0,     0,     0,     0,
     207,   208,   209,   210,   211,   212,   213,   214,     0,   215,
       0,   216,   217,   218,   219,   220,     0,   221,     0,     0,
     222,   223,   224,   225,     0,   226,   227,   228,     0,   229,
       0,   230,   231,   232,   233,   234,   235,   236,     0,   237,
     487,   239,     0,   240,     0,   488,     0,     0,     0,   242,
     243,     0,   244,   245,     0,   246,     0,   247,   248,   249,
     250,     0,   251,   252,   253,     0,   254,   255,   256,   257,
     258,   259,     0,     0,   260,   261,   262,   263,   264,   265,
     266,     0,   267,     0,   268,     0,     0,   269,     0,   270,
     271,   272,   273,   489,     0,   275,     0,   276,     0,     0,
     277,   278,   279,     0,     0,   280,   281,   282,   283,   284,
     285,   286,   287,   288,   289,     0,     0,     0,   290,   291,
       0,   292,     0,   490,   294,   295,   296,   297,   298,   299,
     300,   301,     0,   302,   303,     0,   304,     0,   305,   306,
     307,   308,     0,     0,   309,     0,     0,     0,   310,   311,
       0,     0,   312,     0,     0,   313,   314,   315,   316,   317,
       0,   318,   319,   320,   321,   322,     0,   491,   324,   325,
     326,   327,   328,   329,   330,   331,     0,   332,   492,   334,
     335,   336,   337,   338,   339,   340,     0,   341,   342,     0,
     343,   344,   345,   346,   347,   348,   349,   350,   351,   352,
       0,   353,   354,   355,     0,   356,   357,   358,   359,     0,
     360,   361,     0,   362,   363,   364,   365,   366,   367,   368,
     369,   370,   371,     0,   372,   373,  1317,   374,   375,   376,
     377,     0,   378,   379,     0,  1319,   380,   381,   382,   383,
    1320,   384,   385,   386,   387,   388,     0,     0,   389,   390,
     391,   392,     0,     0,   393,   394,   395,   396,   397,   398,
       0,   399,   400,     0,  1317,   401,     0,   402,   403,   404,
     405,   406,     0,  1319,     0,   407,     0,     0,  1320,     0,
       0,   493,     0,  1317,     0,     0,     0,     0,   494,     0,
       0,     0,  1319,     0,     0,     0,     0,  1320,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,  1317,     0,     0,     0,     0,     0,     0,     0,
       0,  1319,     0,     0,     0,     0,  1320,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,  1321,     0,     0,
       0,  1322,     0,     0,     0,  1317,     0,     0,     0,     0,
       0,     0,     0,     0,  1319,     0,     0,     0,     0,  1320,
       0,  1323,  1324,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,  1325,  1321,     0,     0,     0,  1322,
       0,     0,     0,     0,     0,     0,     0,     0,  1317,     0,
       0,     0,     0,     0,  1321,     0,     0,  1319,  1322,  1323,
    1324,     0,  1320,     0,     0,     0,     0,     0,  1326,     0,
       0,  1327,  1325,     0,     0,     0,     0,     0,  1323,  1324,
       0,     0,     0,  1321,  1328,     0,  1329,  1322,     0,     0,
       0,  1325,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,  1326,  1323,  1324,  1327,
    2787,     0,     0,     0,     0,     0,     0,     0,     0,     0,
    1325,     0,  1328,     0,  1329,  1326,  1321,     0,  1327,     0,
    1322,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,  1328,     0,  1329,     0,  1330,     0,     0,     0,     0,
    1323,  1324,     0,     0,  1326,     0,     0,  1327,     0,     0,
       0,     0,     0,  1325,     0,     0,     0,     0,     0,  1321,
    1328,     0,  1329,  1322,     0,     0,  1317,     0,     0,     0,
       0,     0,     0,  1330,     0,  1319,     0,     0,     0,     0,
    1320,     0,     0,  1323,  1324,     0,     0,  1326,     0,     0,
    1327,     0,  1330,     0,     0,     0,  1325,     0,     0,     0,
       0,     0,     0,  1328,     0,  1329,  1331,     0,     0,  1332,
    1333,  1334,     0,  1335,  1336,  1337,  1338,  1339,  1340,     0,
       0,  1330,     0,  2669,  1341,     0,     0,     0,     0,     0,
    1326,     0,     0,  1327,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,  1331,     0,  1328,  1332,  1333,  1334,
       0,  1335,  1336,  1337,  1338,  1339,  1340,     0,     0,     0,
       0,  2690,  1341,  1331,  1330,     0,  1332,  1333,  1334,     0,
    1335,  1336,  1337,  1338,  1339,  1340,     0,     0,     0,     0,
       0,  1341,     0,     0,     0,     0,     0,  1321,     0,     0,
       0,  1322,  1331,     0,     0,  1332,  1333,  1334,     0,  1335,
    1336,  1337,  1338,  1339,  1340,     0,     0,  1330,     0,  2824,
    1341,  1323,  1324,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,  1325,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,  1331,     0,     0,  1332,  1333,
    1334,     0,  1335,  1336,  1337,  1338,  1339,  1340,     0,     0,
       0,     0,  2895,  1341,     0,     0,     0,     0,  1326,     0,
       0,  1327,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,  1328,     0,  1329,     0,  1331,     0,
       0,  1332,  1333,  1334,     0,  1335,  1336,  1337,  1338,  1339,
    1340,     0,     0,     0,     0,     0,  1341,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,  1330,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,  1331,     0,     0,  1332,
    1333,  1334,     0,  1335,  1336,  1337,  1338,  1339,  1340,     0,
       0,     0,     0,     0,  1341,   161,   162,   163,   164,   165,
     166,   167,   168,     0,   169,   170,     0,     0,     0,     0,
       0,     0,     0,     0,   171,   172,     0,   173,     0,   174,
     175,   176,     0,   177,     0,   178,   179,     0,   180,   181,
     182,   183,   184,     0,     0,   185,   186,   187,   188,     0,
     189,   190,   191,   192,   193,     0,     0,   194,   195,   196,
     197,   198,     0,   199,   200,   201,   202,     0,   203,   204,
     205,     0,   206,     0,     0,     0,     0,     0,   207,   208,
     209,   210,   211,   212,   213,   214,     0,   215,     0,   216,
     217,   218,   219,   220,     0,   221,     0,     0,   222,   223,
     224,   225,     0,   226,   227,   228,     0,   229,     0,   230,
     231,   232,   233,   234,   235,   236,     0,   237,   238,   239,
       0,   240,     0,   241,     0,     0,     0,   242,   243,     0,
     244,   245,     0,   246,     0,   247,   248,   249,   250,     0,
     251,   252,   253,     0,   254,   255,   256,   257,   258,   259,
       0,     0,   260,   261,   262,   263,   264,   265,   266,     0,
     267,     0,   268,     0,     0,   269,     0,   270,   271,   272,
     273,   274,     0,   275,     0,   276,     0,     0,   277,   278,
     279,     0,     0,   280,   281,   282,   283,   284,   285,   286,
     287,   288,   289,     0,     0,     0,   290,   291,     0,   292,
       0,   293,   294,   295,   296,   297,   298,   299,   300,   301,
       0,   302,   303,     0,   304,     0,   305,   306,   307,   308,
       0,     0,   309,     0,     0,     0,   310,   311,     0,     0,
     312,     0,     0,   313,   314,   315,   316,   317,     0,   318,
     319,   320,   321,   322,     0,   323,   324,   325,   326,   327,
     328,   329,   330,   331,     0,   332,   333,   334,   335,   336,
     337,   338,   339,   340,     0,   341,   342,     0,   343,   344,
     345,   346,   347,   348,   349,   350,   351,   352,     0,   353,
     354,   355,     0,   356,   357,   358,   359,     0,   360,   361,
       0,   362,   363,   364,   365,   366,   367,   368,   369,   370,
     371,     0,   372,   373,     0,   374,   375,   376,   377,     0,
     378,   379,     0,     0,   380,   381,   382,   383,     0,   384,
     385,   386,   387,   388,     0,     0,   389,   390,   391,   392,
       0,     0,   393,   394,   395,   396,   397,   398,     0,   399,
     400,     0,     0,   401,     0,   402,   403,   404,   405,   406,
       0,     0,     0,   407,  2941,   509,  2942,  2943,     0,  2944,
     161,   162,   163,   164,   165,   166,   167,   168,     0,   169,
     170,     0,     0,     0,     0,     0,     0,     0,     0,   171,
     172,     0,   173,     0,   174,   175,   176,     0,   177,     0,
     178,   179,     0,   180,   181,   182,   183,   184,     0,     0,
     185,   186,   187,   188,     0,   189,   190,   191,   192,   193,
       0,     0,   194,   195,   196,   197,   198,     0,   199,   200,
     201,   202,     0,   203,   204,   205,     0,   206,     0,     0,
       0,     0,     0,   207,   208,   209,   210,   211,   212,   213,
     214,  1356,   215,     0,   216,   217,   218,   219,   220,     0,
     221,     0,     0,   222,   223,   224,   225,     0,   226,   227,
     228,     0,   229,     0,   230,   231,   232,   233,   234,   235,
     236,     0,   237,   238,   239,     0,   240,     0,   241,     0,
       0,     0,   242,   243,     0,   244,   245,     0,   246,     0,
     247,   248,   249,   250,     0,   251,   252,   253,     0,   254,
     255,   256,   257,   258,   259,     0,     0,   260,   261,   262,
     263,   264,   265,   266,     0,   267,     0,   268,     0,     0,
     269,     0,   270,   271,   272,   273,   274,     0,   275,     0,
     276,     0,     0,   277,   278,   279,     0,     0,   280,   281,
     282,   283,   284,   285,   286,   287,   288,   289,     0,     0,
       0,   290,   291,     0,   292,     0,   293,   294,   295,   296,
     297,   298,   299,   300,   301,     0,   302,   303,     0,   304,
       0,   305,   306,   307,   308,     0,     0,   309,     0,     0,
       0,   310,   311,     0,     0,   312,     0,     0,   313,   314,
     315,   316,   317,     0,   318,   319,   320,   321,   322,     0,
     323,   324,   325,   326,   327,   328,   329,   330,   331,     0,
     332,   333,   334,   335,   336,   337,   338,   339,   340,     0,
     341,   342,     0,   343,   344,   345,   346,   347,   348,   349,
     350,   351,   352,     0,   353,   354,   355,     0,   356,   357,
     358,   359,     0,   360,   361,     0,   362,   363,   364,   365,
     366,   367,   368,   369,   370,   371,     0,   372,   373,     0,
     374,   375,   376,   377,     0,   378,   379,     0,     0,   380,
     381,   382,   383,     0,   384,   385,   386,   387,   388,     0,
       0,   389,   390,   391,   392,     0,     0,   393,   394,   395,
     396,   397,   398,     0,   399,   400,     0,     0,   401,     0,
     402,   403,   404,   405,   406,     0,     0,     0,   407,     0,
     879,   161,   162,   163,   164,   165,   166,   167,   168,     0,
     169,   170,     0,     0,     0,     0,     0,     0,     0,     0,
     171,   172,     0,   173,     0,   174,   175,   176,     0,   177,
       0,   178,   179,     0,   180,   181,   182,   183,   184,     0,
       0,   185,   186,   187,   188,     0,   189,   190,   191,   192,
     193,     0,     0,   194,   195,   196,   197,   198,     0,   199,
     200,   201,   202,     0,   203,   204,   205,     0,   206,     0,
       0,     0,     0,     0,   207,   208,   209,   210,   211,   212,
     213,   214,     0,   215,     0,   216,   217,   218,   219,   220,
       0,   221,     0,     0,   222,   223,   224,   225,     0,   226,
     227,   228,     0,   229,     0,   230,   231,   232,   233,   234,
     235,   236,     0,   237,   238,   239,     0,   240,     0,   241,
       0,     0,     0,   242,   243,     0,   244,   245,     0,   246,
       0,   247,   248,   249,   250,     0,   251,   252,   253,     0,
     254,   255,   256,   257,   258,   259,     0,     0,   260,   261,
     262,   263,   264,   265,   266,     0,   267,     0,   268,     0,
       0,   269,     0,   270,   271,   272,   273,   274,     0,   275,
       0,   276,     0,     0,   277,   278,   279,     0,     0,   280,
     281,   282,   283,   284,   285,   286,   287,   288,   289,     0,
       0,     0,   290,   291,     0,   292,     0,   293,   294,   295,
     296,   297,   298,   299,   300,   301,     0,   302,   303,     0,
     304,     0,   305,   306,   307,   308,     0,     0,   309,     0,
       0,     0,   310,   311,     0,     0,   312,     0,     0,   313,
     314,   315,   316,   317,     0,   318,   319,   320,   321,   322,
       0,   323,   324,   325,   326,   327,   328,   329,   330,   331,
       0,   332,   333,   334,   335,   336,   337,   338,   339,   340,
       0,   341,   342,     0,   343,   344,   345,   346,   347,   348,
     349,   350,   351,   352,     0,   353,   354,   355,     0,   356,
     357,   358,   359,     0,   360,   361,     0,   362,   363,   364,
     365,   366,   367,   368,   369,   370,   371,     0,   372,   373,
       0,   374,   375,   376,   377,     0,   378,   379,     0,     0,
     380,   381,   382,   383,     0,   384,   385,   386,   387,   388,
       0,     0,   389,   390,   391,   392,     0,     0,   393,   394,
     395,   396,   397,   398,     0,   399,   400,     0,     0,   401,
       0,   402,   403,   404,   405,   406,     0,     0,     0,   407,
       0,   879,   161,   162,   163,   164,   165,   166,   167,   168,
       0,   169,   170,     0,     0,     0,     0,     0,     0,     0,
       0,   171,   172,     0,   173,     0,   174,   175,   176,     0,
     177,     0,   178,   179,     0,   180,   181,   182,   183,   184,
       0,     0,   185,   186,   187,   188,     0,   189,   190,   191,
     192,   193,     0,     0,   194,   195,   196,   197,   198,     0,
     199,   200,   201,   202,     0,   203,   204,   205,     0,   206,
       0,     0,     0,     0,     0,   207,   208,   209,   210,   211,
     212,   213,   214,     0,   215,     0,   216,   217,   218,   219,
     220,     0,   221,     0,     0,   222,   223,   224,   225,     0,
     226,   227,   228,     0,   229,     0,   230,   231,   232,   233,
     234,   235,   236,     0,   237,   238,   239,     0,   240,     0,
     241,     0,     0,     0,   242,   243,     0,   244,   245,     0,
     246,     0,   247,   248,   249,  1205,     0,   251,   252,   253,
       0,   254,   255,   256,   257,   258,   259,     0,     0,   260,
     261,   262,   263,   264,   265,   266,     0,   267,     0,   268,
       0,     0,   269,     0,   270,   271,   272,   273,   274,     0,
     275,     0,   276,     0,     0,   277,   278,   279,     0,     0,
     280,   281,   282,   283,   284,   285,   286,   287,   288,   289,
       0,     0,     0,   290,   291,     0,   292,     0,   293,   294,
     295,   296,   297,   298,   299,   300,   301,     0,   302,   303,
       0,   304,     0,   305,   306,   307,   308,     0,     0,   309,
       0,     0,     0,   310,   311,     0,     0,   312,     0,     0,
     313,   314,   315,   316,   317,     0,   318,   319,   320,   321,
     322,     0,   323,   324,   325,   326,   327,   328,   329,   330,
     331,     0,   332,   333,   334,   335,   336,   337,   338,   339,
     340,     0,   341,   342,     0,   343,   344,   345,   346,   347,
     348,   349,   350,   351,   352,     0,   353,   354,   355,     0,
     356,   357,   358,   359,     0,   360,   361,     0,   362,   363,
     364,   365,   366,   367,   368,   369,   370,   371,     0,   372,
     373,     0,   374,   375,   376,   377,     0,   378,   379,     0,
       0,   380,   381,   382,   383,     0,   384,   385,   386,   387,
     388,     0,     0,   389,   390,   391,   392,     0,     0,   393,
     394,   395,   396,   397,   398,     0,   399,   400,     0,     0,
     401,     0,   402,   403,   404,   405,   406,     0,     0,     0,
     407,     0,   879,   161,   162,   163,   164,   165,   166,   167,
     168,  1004,   169,   170,  1005,  1006,  1007,  1008,     0,  1009,
    1010,  1011,   171,   172,  1012,   173,   582,   174,   175,   176,
     583,   177,   584,   178,   179,  1013,   180,   181,   182,   183,
     184,  1014,  1015,   185,   186,   187,   188,  1016,   189,   190,
     191,   192,   193,  1017,  1018,   194,   195,   196,   197,   198,
    1019,   199,   200,   201,   202,  1020,   203,   204,   205,   585,
     206,  1021,  1022,  1023,  1024,  1025,   207,   208,   209,   210,
     211,   212,   213,   214,  1026,   215,  1027,   216,   217,   218,
     219,   220,  1028,   221,  1029,  1030,   222,   223,   224,   225,
    1031,   226,   227,   228,  1032,   229,  1033,   230,   231,   232,
     233,   234,   235,   236,  1034,   237,   238,   239,  1035,   240,
    1036,   241,   586,  1037,   587,   242,   243,  1038,   244,   245,
    1039,   246,  1040,   247,   248,   249,   250,   588,   251,   252,
     253,  1041,   254,   255,   256,   257,   258,   259,  1042,   589,
     260,   261,   262,   263,   264,   265,   266,  1043,   267,  1044,
     268,   590,   591,   269,   592,   270,   271,   272,   273,   274,
    1045,   275,   593,   276,   594,  1046,   277,   278,   279,  1047,
    1048,   280,   281,   282,   283,   284,   285,   286,   287,   288,
     289,     0,     0,     0,   290,   291,   595,   292,  1049,   293,
     294,   295,   296,   297,   298,   299,   300,   301,  1050,   302,
     303,   596,   304,  1051,   305,   306,   307,   308,  1052,  1053,
     309,  1054,  1055,  1056,   310,   311,  1057,  1058,   312,   597,
     598,   313,   314,   315,   316,   317,  1059,   318,   319,   320,
     321,   322,  1060,   323,   324,   325,   326,   327,   328,   329,
     330,   331,  1061,   332,   333,   334,   335,   336,   337,   338,
     339,   340,  1062,   341,   342,   599,   343,   344,   345,   346,
     347,   348,   349,   350,   351,   352,  1063,   353,   354,   355,
    1064,   356,   357,   358,   359,   600,   360,   361,  1065,   362,
     363,   364,   365,   366,   367,   368,   369,   370,   371,  1066,
     372,   373,  1067,   374,   375,   376,   377,  1068,   378,   379,
    1069,  1070,   380,   381,   382,   383,  1071,   384,   385,   386,
     387,   388,  1072,  1073,   389,   390,   391,   392,  1074,  1075,
     393,   394,   395,   396,   397,   398,   601,   399,   400,  1076,
    1077,   401,     0,   402,   403,   404,   405,   406,     0,     0,
       0,  1078,   161,   162,   163,   164,   165,   166,   167,   168,
       0,   169,   170,     0,     0,     0,     0,     0,     0,     0,
       0,   171,   172,     0,   173,   582,   174,   175,   176,   583,
     177,   584,   178,   179,     0,   180,   181,   182,   183,   184,
       0,     0,   185,   186,   187,   188,     0,   189,   190,   191,
     192,   193,     0,     0,   194,   195,   196,   197,   198,     0,
     199,   200,   201,   202,     0,   203,   204,   205,   585,   206,
       0,     0,     0,     0,     0,   207,   208,   209,   210,   211,
     212,   213,   214,     0,   215,     0,   216,   217,   218,   219,
     220,     0,   221,     0,     0,   222,   223,   224,   225,     0,
     226,   227,   228,     0,   229,     0,   230,   231,   232,   233,
     234,   235,   236,     0,   237,   238,   239,     0,   240,     0,
     241,   586,     0,   587,   242,   243,     0,   244,   245,     0,
     246,     0,   247,   248,   249,   250,   588,   251,   252,   253,
       0,   254,   255,   256,   257,   258,   259,     0,   589,   260,
     261,   262,   263,   264,   265,   266,     0,   267,     0,   268,
     590,   591,   269,   592,   270,   271,   272,   273,   274,     0,
     275,   593,   276,   594,     0,   277,   278,   279,     0,     0,
     280,   281,   282,   283,   284,   285,   286,   287,   288,   289,
       0,     0,     0,   290,   291,   595,   292,   412,   293,   294,
     295,   296,   297,   298,   299,   300,   301,     0,   302,   303,
     596,   304,     0,   305,   306,   307,   308,     0,     0,   309,
     413,     0,     0,   310,   311,     0,     0,   312,   597,   598,
     313,   314,   315,   316,   317,     0,   318,   319,   320,   321,
     322,     0,   323,   324,   325,   326,   327,   328,   329,   330,
     331,     0,   332,   333,   334,   335,   336,   337,   338,   339,
     340,     0,   341,   342,   599,   343,   344,   345,   346,   347,
     348,   349,   350,   351,   352,     0,   353,   354,   355,     0,
     356,   357,   358,   359,   600,   360,   361,     0,   362,   363,
     364,   365,   366,   367,   368,   369,   370,   371,     0,   372,
     373,     0,   374,   375,   376,   377,     0,   378,   379,     0,
       0,   380,   381,   382,   383,     0,   384,   385,   386,   387,
     388,     0,     0,   389,   390,   391,   392,     0,     0,   393,
     394,   395,   396,   397,   398,   601,   399,   400,     0,     0,
     401,     0,   402,   403,   404,   405,   406,     0,     0,     0,
     602,   161,   162,   163,   164,   165,   166,   167,   168,     0,
     169,   170,     0,     0,     0,     0,     0,     0,     0,     0,
     171,   172,     0,   173,   582,   174,   175,   176,   583,   177,
     584,   178,   179,     0,   180,   181,   182,   183,   184,     0,
       0,   185,   186,   187,   188,     0,   189,   190,   191,   192,
     193,     0,     0,   194,   195,   196,   197,   198,     0,   199,
     200,   201,   202,     0,   203,   204,   205,   585,   206,     0,
       0,     0,     0,     0,   207,   208,   209,   210,   211,   212,
     213,   214,     0,   215,     0,   216,   217,   218,   219,   220,
       0,   221,     0,     0,   222,   223,   224,   225,     0,   226,
     227,   228,     0,   229,     0,   230,   231,   232,   233,   234,
     235,   236,     0,   237,   238,   239,     0,   240,     0,   241,
     586,     0,   587,   242,   243,     0,   244,   245,     0,   246,
       0,   247,   248,   249,   710,   588,   251,   252,   253,     0,
     254,   255,   256,   257,   258,   259,     0,   589,   260,   261,
     262,   263,   264,   265,   266,     0,   267,     0,   268,   590,
     591,   269,   592,   270,   271,   272,   273,   274,     0,   275,
     593,   276,   594,     0,   277,   278,   279,     0,     0,   280,
     281,   282,   283,   284,   285,   286,   287,   288,   289,     0,
       0,     0,   290,   291,   595,   292,   412,   293,   294,   295,
     296,   297,   298,   299,   300,   301,     0,   302,   303,   596,
     304,     0,   305,   306,   307,   308,     0,     0,   309,   413,
       0,     0,   310,   311,     0,     0,   312,   597,   598,   313,
     314,   315,   316,   317,     0,   318,   319,   320,   321,   322,
       0,   323,   324,   325,   326,   327,   328,   329,   330,   331,
       0,   332,   333,   334,   335,   336,   337,   338,   339,   340,
       0,   341,   342,   599,   343,   344,   345,   346,   347,   348,
     349,   350,   351,   352,     0,   353,   354,   355,     0,   356,
     357,   358,   359,   600,   360,   361,     0,   362,   363,   364,
     365,   366,   367,   368,   369,   370,   371,     0,   372,   373,
       0,   374,   375,   376,   377,     0,   378,   379,     0,     0,
     380,   381,   382,   383,     0,   384,   385,   386,   387,   388,
       0,     0,   389,   390,   391,   392,     0,     0,   393,   394,
     395,   396,   397,   398,   601,   399,   400,     0,     0,   401,
       0,   402,   403,   404,   405,   406,     0,     0,     0,   602,
     161,   162,   163,   164,   165,   166,   167,   168,     0,   169,
     170,     0,     0,     0,     0,     0,     0,     0,     0,   171,
     172,     0,   173,   582,   174,   175,   176,   583,   177,   584,
     178,   179,     0,   180,   181,   182,   183,   184,     0,     0,
     185,   186,   187,   188,     0,   189,   190,   191,   192,   193,
       0,     0,   194,   195,   196,   197,   198,     0,   199,   200,
     201,   202,     0,   203,   204,   205,   585,   206,     0,     0,
       0,     0,     0,   207,   208,   209,   210,   211,   212,   213,
     214,     0,   215,     0,   216,   217,   218,   219,   220,     0,
     221,     0,     0,   222,   223,   224,   225,     0,   226,   227,
     228,     0,   229,     0,   230,   231,   232,   233,   234,   235,
     236,     0,   237,   238,   239,     0,   240,     0,   241,   586,
       0,   587,   242,   243,     0,   244,   245,     0,   246,     0,
     247,   248,   249,   717,   588,   251,   252,   253,     0,   254,
     255,   256,   257,   258,   259,     0,   589,   260,   261,   262,
     263,   264,   265,   266,     0,   267,     0,   268,   590,   591,
     269,   592,   270,   271,   272,   273,   274,     0,   275,   593,
     276,   594,     0,   277,   278,   279,     0,     0,   280,   281,
     282,   283,   284,   285,   286,   287,   288,   289,     0,     0,
       0,   290,   291,   595,   292,   412,   293,   294,   295,   296,
     297,   298,   299,   300,   301,     0,   302,   303,   596,   304,
       0,   305,   306,   307,   308,     0,     0,   309,   413,     0,
       0,   310,   311,     0,     0,   312,   597,   598,   313,   314,
     315,   316,   317,     0,   318,   319,   320,   321,   322,     0,
     323,   324,   325,   326,   327,   328,   329,   330,   331,     0,
     332,   333,   334,   335,   336,   337,   338,   339,   340,     0,
     341,   342,   599,   343,   344,   345,   346,   347,   348,   349,
     350,   351,   352,     0,   353,   354,   355,     0,   356,   357,
     358,   359,   600,   360,   361,     0,   362,   363,   364,   365,
     366,   367,   368,   369,   370,   371,     0,   372,   373,     0,
     374,   375,   376,   377,     0,   378,   379,     0,     0,   380,
     381,   382,   383,     0,   384,   385,   386,   387,   388,     0,
       0,   389,   390,   391,   392,     0,     0,   393,   394,   395,
     396,   397,   398,   601,   399,   400,     0,     0,   401,     0,
     402,   403,   404,   405,   406,     0,     0,     0,   602,   161,
     162,   163,   164,   165,   166,   167,   168,     0,   169,   170,
       0,     0,     0,     0,     0,     0,     0,     0,   171,   172,
       0,   173,     0,   174,   175,   176,     0,   177,     0,   178,
     179,     0,   180,   181,   182,   183,   184,     0,     0,   185,
     186,   187,   188,  1435,   189,   190,   191,   192,   193,     0,
       0,   194,   195,   196,   197,   198,  1436,   199,   200,   201,
     202,     0,   203,   204,   205,     0,   206,     0,     0,     0,
       0,     0,   207,   208,   209,   210,   211,   212,   213,   214,
       0,   215,     0,   216,   217,   218,   219,   220,     0,   221,
       0,     0,   222,   223,   224,   225,     0,   226,   227,   228,
       0,   229,     0,   230,   231,   232,   233,   234,   235,   236,
       0,   237,   238,   239,     0,   240,  1437,   241,     0,     0,
       0,   242,   243,     0,   244,   245,     0,   246,     0,   247,
     248,   249,   250,     0,   251,   252,   253,     0,   254,   255,
     256,   257,   258,   259,     0,     0,   260,   261,   262,   263,
     264,   265,   266,     0,   267,     0,   268,     0,     0,   269,
       0,   270,   271,   272,   273,   274,     0,   275,     0,   276,
    2028,     0,   277,   278,   279,     0,     0,   280,   281,   282,
     283,   284,   285,   286,   287,   288,   289,     0,     0,     0,
     290,   291,     0,   292,     0,   293,   294,   295,   296,   297,
     298,   299,   300,   301,     0,   302,   303,     0,   304,     0,
     305,   306,   307,   308,     0,     0,   309,     0,     0,     0,
     310,   311,     0,     0,   312,     0,     0,   313,   314,   315,
     316,   317,     0,   318,   319,   320,   321,   322,  1438,   323,
     324,   325,   326,   327,   328,   329,   330,   331,     0,   332,
     333,   334,   335,   336,   337,   338,   339,   340,     0,   341,
     342,     0,   343,   344,   345,   346,   347,   348,   349,   350,
     351,   352,     0,   353,   354,   355,     0,   356,   357,   358,
     359,     0,   360,   361,     0,   362,   363,   364,   365,   366,
     367,   368,   369,   370,   371,     0,   372,   373,     0,   374,
     375,   376,   377,     0,   378,   379,     0,     0,   380,   381,
     382,   383,     0,   384,   385,   386,   387,   388,     0,  1439,
     389,   390,   391,   392,     0,     0,   393,   394,   395,   396,
     397,   398,     0,   399,   400,     0,     0,   401,     0,   402,
     403,   404,   405,   406,     0,     0,     0,   407,   161,   162,
     163,   164,   165,   533,   167,   168,   498,   169,   170,     0,
       0,     0,     0,     0,     0,     0,     0,   171,   172,     0,
     173,     0,   174,   175,   176,     0,   177,     0,   178,   179,
       0,   180,   181,   182,   183,   184,     0,     0,   185,   186,
     187,   188,     0,   189,   190,   191,   192,   193,     0,     0,
     194,   195,   196,   197,   198,     0,   199,   200,   201,   202,
     499,   203,   204,   205,     0,   206,     0,     0,     0,     0,
       0,   207,   208,   209,   210,   211,   212,   213,   214,     0,
     215,     0,   216,   217,   218,   219,   220,     0,   221,     0,
       0,   222,   223,   224,   225,     0,   226,   227,   228,     0,
     229,     0,   230,   231,   232,   233,   234,   235,   236,     0,
     237,   238,   239,     0,   240,     0,   241,     0,     0,     0,
     242,   243,   534,   244,   245,     0,   246,     0,   247,   248,
     249,   250,     0,   251,   252,   253,     0,   254,   255,   256,
     257,   258,   259,     0,     0,   260,   261,   262,   263,   264,
     265,   266,     0,   267,     0,   268,     0,     0,   269,     0,
     270,   271,   272,   273,   274,     0,   275,     0,   276,     0,
       0,   277,   278,   279,     0,     0,   280,   281,   282,   283,
     284,   285,   286,   287,   288,   289,     0,     0,     0,   290,
     291,     0,   292,     0,   293,   294,   295,   296,   297,   298,
     299,   300,   301,     0,   302,   303,     0,   304,     0,   305,
     306,   307,   308,     0,     0,   309,     0,     0,     0,   310,
     311,     0,     0,   312,     0,     0,   313,   314,   315,   316,
     317,     0,   318,   319,   320,   321,   322,     0,   323,   324,
     325,   326,   327,   328,   329,   330,   331,   500,   332,   333,
     334,   335,   336,   337,   338,   339,   340,     0,   341,   342,
       0,   343,   344,   345,   346,   347,   348,   349,   350,   351,
     352,   501,   353,   354,   355,     0,   356,   357,   358,   359,
       0,   360,   361,     0,   362,   363,   364,   365,   366,   367,
     368,   369,   370,   371,     0,   372,   373,     0,   374,   375,
     376,   377,     0,   378,   379,     0,     0,   380,   381,   382,
     383,     0,   384,   385,   386,   387,   388,     0,     0,   389,
     390,   391,   392,     0,     0,   393,   394,   395,   396,   397,
     398,     0,   399,   400,     0,     0,   401,     0,   402,   403,
     404,   405,   406,     0,     0,     0,   407,   161,   162,   163,
     164,   165,   166,   167,   168,     0,   169,   170,     0,     0,
       0,     0,     0,     0,     0,     0,   171,   172,     0,   173,
     582,   174,   175,   176,   583,  1109,   584,  1110,  1111,     0,
     180,   181,   182,   183,   184,     0,     0,   185,  1112,  1113,
     188,     0,   189,   190,   191,   192,     0,     0,     0,   194,
     195,   196,   197,   198,     0,   199,   200,     0,   202,     0,
     203,   204,   205,   585,   206,     0,     0,     0,     0,     0,
     207,   208,   209,   210,   211,  1114,  1115,   214,     0,   215,
       0,   216,   217,   218,   219,   220,     0,   221,     0,     0,
     222,   797,   224,   225,     0,   226,   227,   228,     0,   229,
       0,   230,   231,   232,     0,   234,   235,     0,     0,   237,
     238,  1116,     0,   240,     0,   241,   586,     0,   587,   242,
     243,     0,   244,     0,     0,   246,     0,   247,   248,   249,
     250,   588,   251,   252,   253,  1457,   254,   255,   256,   257,
     258,   259,     0,   589,  1458,   261,   262,   263,   264,  1117,
    1118,     0,  1119,     0,   268,   590,   591,   269,   592,   270,
     271,   272,   273,   274,     0,     0,   593,   276,   594,     0,
     277,   278,   279,     0,     0,   280,   281,   282,   283,   284,
     285,   286,   287,   288,   289,     0,     0,     0,   290,  1120,
     595,  1121,     0,   293,   294,   295,   296,   297,   298,   299,
       0,   301,     0,   302,   303,   596,   304,     0,     0,  1122,
     307,   308,     0,     0,   309,     0,     0,     0,   310,   311,
       0,     0,  1459,   597,   598,     0,   314,   315,   316,   317,
       0,     0,     0,   320,   321,   322,     0,   323,   324,   325,
     326,   327,   328,  1123,   330,   331,     0,   332,   333,   334,
     335,   336,   337,   338,   339,   340,     0,   341,   342,   599,
     343,   344,     0,   346,   347,   348,   349,   350,   351,   352,
       0,   353,   354,   355,     0,   356,  1460,   358,   359,   600,
     360,  1125,     0,   362,   363,   364,   365,   366,   367,   368,
     369,     0,   371,     0,   372,   373,     0,   374,   375,   376,
     377,     0,  1126,  1127,     0,     0,   380,     0,   382,     0,
       0,   384,   385,   386,   387,   388,     0,     0,   389,   390,
     391,   392,     0,     0,   393,   394,   395,     0,  1128,   398,
     601,   399,   400,     0,     0,   401,     0,   402,   403,   404,
     405,   406,     0,     0,     0,  1461,   161,   162,   163,   164,
     165,   166,   167,   168,   498,   169,   170,     0,     0,     0,
       0,     0,     0,     0,     0,   171,   172,     0,   173,     0,
     174,   175,   176,     0,   177,     0,   178,   179,     0,   180,
     181,   182,   183,   184,     0,     0,   185,   186,   187,   188,
       0,   189,   190,   191,   192,   193,     0,     0,   194,   195,
     196,   197,   198,     0,   199,   200,   201,   202,   499,   203,
     204,   205,     0,   206,     0,     0,     0,     0,     0,   207,
     208,   209,   210,   211,   212,   213,   214,     0,   215,     0,
     216,   217,   218,   219,   220,     0,   221,     0,     0,   222,
     223,   224,   225,     0,   226,   227,   228,     0,   229,     0,
     230,   231,   232,   233,   234,   235,   236,     0,   237,   238,
     239,     0,   240,     0,   241,     0,     0,     0,   242,   243,
       0,   244,   245,     0,   246,     0,   247,   248,   249,   250,
       0,   251,   252,   253,     0,   254,   255,   256,   257,   258,
     259,     0,     0,   260,   261,   262,   263,   264,   265,   266,
       0,   267,     0,   268,     0,     0,   269,     0,   270,   271,
     272,   273,   274,     0,   275,     0,   276,     0,     0,   277,
     278,   279,     0,     0,   280,   281,   282,   283,   284,   285,
     286,   287,   288,   289,     0,     0,     0,   290,   291,     0,
     292,     0,   293,   294,   295,   296,   297,   298,   299,   300,
     301,     0,   302,   303,     0,   304,     0,   305,   306,   307,
     308,     0,     0,   309,     0,     0,     0,   310,   311,     0,
       0,   312,     0,     0,   313,   314,   315,   316,   317,     0,
     318,   319,   320,   321,   322,     0,   323,   324,   325,   326,
     327,   328,   329,   330,   331,   500,   332,   333,   334,   335,
     336,   337,   338,   339,   340,     0,   341,   342,     0,   343,
     344,   345,   346,   347,   348,   349,   350,   351,   352,   501,
     353,   354,   355,     0,   356,   357,   358,   359,     0,   360,
     361,     0,   362,   363,   364,   365,   366,   367,   368,   369,
     370,   371,     0,   372,   373,     0,   374,   375,   376,   377,
       0,   378,   379,     0,     0,   380,   381,   382,   383,     0,
     384,   385,   386,   387,   388,     0,     0,   389,   390,   391,
     392,     0,     0,   393,   394,   395,   396,   397,   398,     0,
     399,   400,     0,     0,   401,     0,   402,   403,   404,   405,
     406,     0,     0,     0,   407,   161,   162,   163,   164,   165,
     166,   167,   168,     0,   169,   170,     3,     4,     0,     0,
       0,     0,     0,     0,   171,   172,     0,   173,     0,   174,
     175,   176,     0,   177,     0,   178,   179,     0,   180,   181,
     182,   183,   184,     0,     0,   185,   186,   187,   188,     0,
     189,   190,   191,   192,   193,     0,     0,   194,   195,   196,
     197,   198,     0,   199,   200,   201,   202,     0,   203,   204,
     205,     0,   206,     0,     0,     0,     0,     0,   207,   208,
     209,   210,   211,   212,   213,   214,     0,   215,     0,   216,
     217,   218,   219,   220,     0,   221,     0,     0,   222,   223,
     224,   225,     0,   226,   227,   228,     0,   229,     0,   230,
     231,   232,   233,   234,   235,   236,     0,   237,   238,   239,
       0,   240,     0,   241,     0,     0,     0,   242,   243,     0,
     244,   245,     0,   246,     0,   247,   248,   249,   250,     0,
     251,   252,   253,     0,   254,   255,   256,   257,   258,   259,
       0,     0,   260,   261,   262,   263,   264,   265,   266,     0,
     267,     0,   268,     0,     0,   269,     0,   270,   271,   272,
     273,   274,     0,   275,     0,   276,     0,     0,   277,   278,
     279,     0,     0,   280,   281,   282,   283,   284,   285,   286,
     287,   288,   289,     0,     0,     0,   290,   291,     0,   292,
     412,   293,   294,   295,   296,   297,   298,   299,   300,   301,
       0,   302,   303,     0,   304,     0,   305,   306,   307,   308,
       0,     0,   309,   413,     0,     0,   310,   311,     0,     0,
     312,     0,     0,   313,   314,   315,   316,   317,     0,   318,
     319,   320,   321,   322,     0,   323,   324,   325,   326,   327,
     328,   329,   330,   331,     0,   332,   333,   334,   335,   336,
     337,   338,   339,   340,     0,   341,   342,     0,   343,   344,
     345,   346,   347,   348,   349,   350,   351,   352,     0,   353,
     354,   355,     0,   356,   357,   358,   359,     0,   360,   361,
       0,   362,   363,   364,   365,   366,   367,   368,   369,   370,
     371,     0,   372,   373,     0,   374,   375,   376,   377,     0,
     378,   379,     0,     0,   380,   381,   382,   383,     0,   384,
     385,   386,   387,   388,     0,     0,   389,   390,   391,   392,
       0,     0,   393,   394,   395,   396,   397,   398,     0,   399,
     400,     0,     0,   401,     0,   402,   403,   404,   405,   406,
       0,     0,     0,   407,   161,   162,   163,   164,   165,   166,
     167,   168,     0,   169,   170,     0,     0,     0,     0,     0,
       0,     0,     0,   171,   172,     0,   173,     0,   174,   175,
     176,     0,   177,     0,   178,   179,     0,   180,   181,   182,
     183,   184,     0,     0,   185,   186,   187,   188,     0,   189,
     190,   191,   192,   193,     0,     0,   194,   195,   196,   197,
     198,     0,   199,   200,   201,   202,     0,   203,   204,   205,
       0,   206,     0,     0,     0,     0,     0,   207,   208,   209,
     210,   211,   212,   213,   214,     0,   215,     0,   216,   217,
     218,   219,   220,     0,   221,     0,     0,   222,   223,   224,
     225,     0,   226,   227,   228,     0,   229,     0,   230,   231,
     232,   233,   234,   235,   236,     0,   237,   238,   239,     0,
     240,     0,   241,     0,     0,     0,   242,   243,     0,   244,
     245,     0,   246,     0,   247,   248,   249,   250,     0,   251,
     252,   253,     0,   254,   255,   256,   257,   258,   259,     0,
       0,   260,   261,   262,   263,   264,   265,   266,     0,   267,
       0,   268,     0,     0,   269,     0,   270,   271,   272,   273,
     274,     0,   275,     0,   276,     0,     0,   277,   278,   279,
       0,     0,   280,   281,   282,   283,   284,   285,   286,   287,
     288,   289,     0,     0,     0,   290,   291,     0,   292,   412,
     293,   294,   295,   296,   297,   298,   299,   300,   301,     0,
     302,   303,     0,   304,     0,   305,   306,   307,   308,     0,
       0,   309,   413,     0,   561,   310,   311,     0,     0,   312,
       0,     0,   313,   314,   315,   316,   317,     0,   318,   319,
     320,   321,   322,     0,   323,   324,   325,   326,   327,   328,
     329,   330,   331,     0,   332,   333,   334,   335,   336,   337,
     338,   339,   340,     0,   341,   342,     0,   343,   344,   345,
     346,   347,   348,   349,   350,   351,   352,     0,   353,   354,
     355,     0,   356,   357,   358,   359,     0,   360,   361,     0,
     362,   363,   364,   365,   366,   367,   368,   369,   370,   371,
       0,   372,   373,     0,   374,   375,   376,   377,     0,   378,
     379,     0,     0,   380,   381,   382,   383,     0,   384,   385,
     386,   387,   388,     0,     0,   389,   390,   391,   392,     0,
       0,   393,   394,   395,   396,   397,   398,     0,   399,   400,
       0,     0,   401,     0,   402,   403,   404,   405,   406,     0,
       0,     0,   407,   161,   162,   163,   164,   165,   166,   167,
     168,   871,   169,   170,     0,     0,     0,     0,     0,     0,
       0,     0,   171,   172,     0,   173,     0,   174,   175,   176,
       0,   177,     0,   178,   179,     0,   180,   181,   182,   183,
     184,     0,     0,   185,   186,   187,   188,     0,   189,   190,
     191,   192,   193,     0,     0,   194,   195,   196,   197,   198,
       0,   199,   200,   201,   202,     0,   203,   204,   205,     0,
     206,     0,     0,     0,     0,     0,   207,   208,   209,   210,
     211,   212,   213,   214,     0,   215,     0,   216,   217,   218,
     219,   220,     0,   221,     0,     0,   222,   223,   224,   225,
       0,   226,   227,   228,     0,   229,     0,   230,   231,   232,
     233,   234,   235,   236,     0,   237,   238,   239,     0,   240,
       0,   241,     0,     0,     0,   242,   243,     0,   244,   245,
       0,   246,     0,   247,   248,   249,   250,     0,   251,   252,
     253,     0,   254,   255,   256,   257,   258,   259,     0,     0,
     260,   261,   262,   263,   264,   265,   266,     0,   267,     0,
     268,     0,     0,   269,     0,   270,   271,   272,   273,   274,
       0,   275,     0,   276,     0,     0,   277,   278,   279,     0,
       0,   280,   281,   282,   283,   284,   285,   286,   287,   288,
     289,     0,     0,     0,   290,   291,     0,   292,   412,   293,
     294,   295,   296,   297,   298,   299,   300,   301,     0,   302,
     303,     0,   304,     0,   305,   306,   307,   308,     0,     0,
     309,   413,     0,     0,   310,   311,     0,     0,   312,     0,
       0,   313,   314,   315,   316,   317,     0,   318,   319,   320,
     321,   322,     0,   323,   324,   325,   326,   327,   328,   329,
     330,   331,     0,   332,   333,   334,   335,   336,   337,   338,
     339,   340,     0,   341,   342,     0,   343,   344,   345,   346,
     347,   348,   349,   350,   351,   352,     0,   353,   354,   355,
       0,   356,   357,   358,   359,     0,   360,   361,     0,   362,
     363,   364,   365,   366,   367,   368,   369,   370,   371,     0,
     372,   373,     0,   374,   375,   376,   377,     0,   378,   379,
       0,     0,   380,   381,   382,   383,     0,   384,   385,   386,
     387,   388,     0,     0,   389,   390,   391,   392,     0,     0,
     393,   394,   395,   396,   397,   398,     0,   399,   400,     0,
       0,   401,     0,   402,   403,   404,   405,   406,     0,     0,
       0,   407,   161,   162,   163,   164,   165,   166,   167,   168,
       0,   169,   170,     0,     0,     0,     0,     0,     0,     0,
       0,   171,   172,     0,   173,     0,   174,   175,   176,     0,
     177,     0,   178,   179,     0,   180,   181,   182,   183,   184,
       0,     0,   185,   186,   187,   188,     0,   189,   190,   191,
     192,   193,     0,     0,   194,   195,   196,   197,   198,     0,
     199,   200,   201,   202,     0,   203,   204,   205,     0,   206,
       0,     0,     0,     0,     0,   207,   208,  1221,   210,   211,
     212,   213,   214,     0,   215,     0,   216,   217,   218,   219,
     220,     0,   221,     0,     0,   222,   223,   224,   225,     0,
     226,   227,   228,     0,   229,     0,   230,   231,   232,   233,
     234,   235,   236,     0,   237,   238,   239,     0,   240,     0,
     241,     0,     0,     0,  1222,   243,     0,   244,   245,     0,
     246,     0,   247,   248,   249,   250,     0,   251,   252,   253,
       0,   254,   255,   256,   257,   258,   259,     0,     0,   260,
     261,   262,   263,   264,   265,   266,     0,   267,     0,   268,
       0,     0,   269,     0,   270,   271,  1223,   273,   274,     0,
     275,     0,   276,     0,     0,   277,   278,   279,     0,     0,
     280,   281,   282,   283,   284,   285,   286,   287,   288,   289,
       0,     0,     0,   290,   291,     0,   292,   412,   293,   294,
     295,   296,   297,   298,   299,   300,   301,     0,   302,   303,
       0,   304,     0,   305,   306,   307,   308,     0,     0,   309,
     413,     0,     0,   310,   311,     0,     0,   312,     0,     0,
     313,   314,   315,   316,   317,     0,   318,   319,   320,   321,
     322,     0,   323,   324,   325,   326,   327,   328,   329,   330,
     331,     0,   332,   333,   334,   335,   336,   337,   338,   339,
     340,     0,   341,   342,     0,   343,   344,   345,   346,   347,
     348,  1224,   350,   351,   352,     0,  1225,   354,   355,     0,
     356,   357,   358,   359,     0,   360,   361,     0,   362,   363,
     364,   365,   366,   367,   368,   369,   370,   371,     0,   372,
     373,  1226,  1227,   375,   376,   377,     0,   378,   379,     0,
       0,   380,   381,   382,   383,     0,   384,   385,   386,   387,
     388,     0,     0,   389,   390,   391,   392,     0,     0,   393,
     394,   395,   396,   397,   398,     0,   399,   400,     0,     0,
     401,     0,   402,   403,   404,   405,   406,     0,     0,     0,
     407,   161,   162,   163,   164,   165,   166,   167,   168,     0,
     169,   170,     0,     0,     0,     0,     0,     0,     0,     0,
     171,   172,     0,   173,     0,   174,   175,   176,     0,   177,
       0,   178,   179,     0,   180,   181,   182,   183,   184,     0,
       0,   185,   186,   187,   188,     0,   189,   190,   191,   192,
     193,     0,     0,   194,   195,   196,   197,   198,     0,   199,
     200,   201,   202,   499,   203,   204,   205,     0,   206,     0,
       0,     0,     0,     0,   207,   208,   209,   210,   211,   212,
     213,   214,     0,   215,     0,   216,   217,   218,   219,   220,
       0,   221,     0,     0,   222,   223,   224,   225,     0,   226,
     227,   228,     0,   229,     0,   230,   231,   232,   233,   234,
     235,   236,     0,   237,   238,   239,     0,   240,     0,   241,
       0,     0,     0,   242,   243,     0,   244,   245,     0,   246,
       0,   247,   248,   249,   250,     0,   251,   252,   253,     0,
     254,   255,   256,   257,   258,   259,     0,     0,   260,   261,
     262,   263,   264,   265,   266,     0,   267,     0,   268,     0,
       0,   269,     0,   270,   271,   272,   273,   274,     0,   275,
       0,   276,     0,     0,   277,   278,   279,     0,     0,   280,
     281,   282,   283,   284,   285,   286,   287,   288,   289,     0,
       0,     0,   290,   291,     0,   292,     0,   293,   294,   295,
     296,   297,   298,   299,   300,   301,     0,   302,   303,     0,
     304,     0,   305,   306,   307,   308,     0,     0,   309,     0,
       0,     0,   310,   311,     0,     0,   312,     0,     0,   313,
     314,   315,   316,   317,     0,   318,   319,   320,   321,   322,
       0,   323,   324,   325,   326,   327,   328,   329,   330,   331,
     500,   332,   333,   334,   335,   336,   337,   338,   339,   340,
       0,   341,   342,     0,   343,   344,   345,   346,   347,   348,
     349,   350,   351,   352,   501,   353,   354,   355,     0,   356,
     357,   358,   359,     0,   360,   361,     0,   362,   363,   364,
     365,   366,   367,   368,   369,   370,   371,     0,   372,   373,
       0,   374,   375,   376,   377,     0,   378,   379,     0,     0,
     380,   381,   382,   383,     0,   384,   385,   386,   387,   388,
       0,     0,   389,   390,   391,   392,     0,     0,   393,   394,
     395,   396,   397,   398,     0,   399,   400,     0,     0,   401,
       0,   402,   403,   404,   405,   406,     0,     0,     0,   407,
     161,   162,   163,   164,   165,   166,   167,   168,     0,   169,
     170,     0,     0,     0,     0,     0,     0,     0,     0,   171,
     172,     0,   173,     0,   174,   175,   176,     0,   177,     0,
     178,   179,     0,   180,   181,   182,   183,   184,     0,     0,
     185,   186,   187,   188,     0,   189,   190,   191,   192,   193,
       0,     0,   194,   195,   196,   197,   198,     0,   199,   200,
     201,   202,     0,   203,   204,   205,     0,   206,     0,     0,
       0,     0,     0,   207,   208,   209,   210,   211,   212,   213,
     214,     0,   215,     0,   216,   217,   218,   219,   220,     0,
     221,     0,     0,   222,   223,   224,   225,     0,   226,   227,
     228,     0,   229,     0,   230,   231,   232,   233,   234,   235,
     236,     0,   237,   238,   239,     0,   240,     0,   241,     0,
       0,     0,   242,  1807,     0,   244,   245,     0,   246,     0,
     247,   248,   249,   250,     0,   251,   252,   253,     0,   254,
     255,   256,   257,   258,   259,     0,     0,   260,   261,   262,
     263,   264,   265,   266,     0,   267,     0,   268,     0,     0,
     269,     0,   270,   271,   272,   273,   274,     0,   275,     0,
     276,     0,     0,   277,   278,  1808,     0,     0,   280,   281,
     282,   283,   284,   285,   286,   287,   288,   289,     0,     0,
       0,   290,   291,     0,   292,   412,   293,   294,   295,   296,
     297,   298,   299,   300,   301,     0,   302,   303,     0,   304,
       0,   305,   306,   307,   308,     0,     0,   309,   413,     0,
       0,   310,   311,     0,     0,   312,     0,     0,   313,   314,
     315,   316,   317,     0,   318,   319,   320,   321,   322,     0,
     323,   324,   325,   326,   327,   328,   329,   330,   331,     0,
     332,   333,   334,   335,   336,   337,   338,   339,   340,     0,
     341,   342,     0,   343,   344,   345,   346,   347,   348,   349,
     350,   351,   352,     0,   353,   354,   355,     0,   356,   357,
     358,   359,     0,   360,   361,     0,   362,   363,   364,   365,
     366,   367,   368,   369,   370,   371,     0,   372,   373,  1809,
     374,  1810,   376,  1811,     0,   378,   379,     0,     0,   380,
     381,   382,   383,     0,   384,   385,   386,   387,   388,     0,
       0,   389,   390,   391,   392,     0,     0,   393,   394,   395,
     396,   397,   398,     0,   399,   400,     0,     0,   401,     0,
     402,   403,   404,   405,   406,     0,     0,     0,   407,   161,
     162,   163,   164,   165,   166,   167,   168,     0,   169,   170,
       0,     0,     0,     0,     0,     0,     0,     0,   171,   172,
       0,   173,     0,   174,   175,   176,     0,   177,     0,   178,
     179,     0,   180,   181,   182,   183,   184,     0,     0,   185,
     186,   187,   188,     0,   189,   190,   191,   192,   193,     0,
       0,   194,   195,   196,   197,   198,     0,   199,   200,   201,
     202,     0,   203,   204,   205,     0,   206,     0,     0,     0,
       0,     0,   207,   208,   209,   210,   211,   212,   213,   214,
       0,   215,     0,   216,   217,   218,   219,   220,     0,   221,
       0,     0,   222,   223,   224,   225,     0,   226,   227,   228,
       0,   229,     0,   230,   231,   232,   233,   234,   235,   236,
       0,   237,   238,   239,     0,   240,     0,   241,     0,     0,
       0,   242,   243,     0,   244,   245,     0,   246,     0,   247,
     248,   249,   250,     0,   251,   252,   253,     0,   254,   255,
     256,   257,   258,   259,     0,     0,   260,   261,   262,   263,
     264,   265,   266,     0,   267,     0,   268,     0,     0,   269,
       0,   270,   271,   272,   273,   274,     0,   275,     0,   276,
       0,     0,   277,   278,   279,     0,     0,   280,   281,   282,
     283,   284,   285,   286,   287,   288,   289,     0,     0,     0,
     290,   291,     0,   292,   412,   293,   294,   295,   296,   297,
     298,   299,   300,   301,     0,   302,   303,     0,   304,     0,
     305,   306,   307,   308,     0,     0,   309,   413,     0,     0,
     310,   311,     0,     0,   312,     0,     0,   313,   314,   315,
     316,   317,     0,   318,   319,   320,   321,   322,     0,   323,
     324,   325,   326,   327,   328,   329,   330,   331,     0,   332,
     333,   334,   335,   336,   337,   338,   339,   340,     0,   341,
     342,     0,   343,   344,   345,   346,   347,   348,   349,   350,
     351,   352,     0,   353,   354,   355,     0,   356,   357,   358,
     359,     0,   360,   361,     0,   362,   363,   364,   365,   366,
     367,   368,   369,   370,   371,     0,   372,   373,     0,   374,
     375,   376,   377,     0,   378,   379,     0,     0,   380,   381,
     382,   383,     0,   384,   385,   386,   387,   388,     0,     0,
     389,   390,   391,   392,     0,     0,   393,   394,   395,   396,
     397,   398,     0,   399,   400,     0,     0,   401,     0,   402,
     403,   404,   405,   406,     0,     0,     0,   407,   161,   162,
     163,   164,   165,   166,   167,   168,     0,   169,   170,     0,
       0,     0,     0,     0,     0,     0,     0,   171,   172,     0,
     173,   582,   174,   175,   176,   583,  1109,   584,  1110,  1111,
       0,   180,   181,   182,   183,   184,     0,     0,   185,  1112,
    1113,   188,     0,   189,   190,   191,   192,     0,     0,     0,
     194,   195,   196,   197,   198,     0,   199,   200,     0,   202,
       0,   203,   204,   205,   585,   206,     0,     0,     0,     0,
       0,   207,   208,   209,   210,   211,  1114,  1115,   214,     0,
     215,     0,   216,   217,   218,   219,   220,     0,   221,     0,
       0,   222,   797,   224,   225,     0,   226,   227,   228,     0,
     229,     0,   230,   231,   232,     0,   234,   235,     0,     0,
     237,   238,  1116,     0,   240,     0,   241,   586,     0,   587,
     242,   243,     0,   244,     0,     0,   246,     0,   247,   248,
     249,   250,   588,   251,   252,   253,     0,   254,   255,   256,
     257,   258,   259,     0,   589,     0,   261,   262,   263,   264,
    1117,  1118,     0,  1119,     0,   268,   590,   591,   269,   592,
     270,   271,   272,   273,   274,     0,     0,   593,   276,   594,
       0,   277,   278,   279,     0,     0,   280,   281,   282,   283,
     284,   285,   286,   287,   288,   289,     0,     0,     0,   290,
    1120,   595,  1121,     0,   293,   294,   295,   296,   297,   298,
     299,     0,   301,     0,   302,   303,   596,   304,     0,     0,
    1122,   307,   308,     0,     0,   309,     0,     0,     0,   310,
     311,     0,     0,     0,   597,   598,     0,   314,   315,   316,
     317,     0,     0,     0,   320,   321,   322,     0,   323,   324,
     325,   326,   327,   328,  1123,   330,   331,     0,   332,   333,
     334,   335,   336,   337,   338,   339,   340,     0,   341,   342,
     599,   343,   344,     0,   346,   347,   348,   349,   350,   351,
     352,     0,   353,   354,   355,     0,   356,  1460,   358,   359,
     600,   360,  1125,     0,   362,   363,   364,   365,   366,   367,
     368,   369,     0,   371,     0,   372,   373,     0,   374,   375,
     376,   377,     0,  1126,  1127,     0,     0,   380,     0,   382,
       0,     0,   384,   385,   386,   387,   388,     0,     0,   389,
     390,   391,   392,     0,     0,   393,   394,   395,     0,  1128,
     398,   601,   399,   400,     0,     0,   401,     0,   402,   403,
     404,   405,   406,     0,     0,     0,  1461,   161,   162,   163,
     164,   165,   166,   167,   168,  1943,   169,   170,     0,     0,
       0,     0,     0,     0,     0,     0,   171,   172,     0,   173,
       0,   174,   175,   176,     0,   177,     0,   178,   179,     0,
     180,   181,   182,   183,   184,     0,     0,   185,   186,   187,
     188,     0,   189,   190,   191,   192,   193,     0,     0,   194,
     195,   196,   197,   198,     0,   199,   200,   201,   202,     0,
     203,   204,   205,     0,   206,     0,     0,     0,     0,     0,
     207,   208,   209,   210,   211,   212,   213,   214,     0,   215,
       0,   216,   217,   218,   219,   220,     0,   221,     0,     0,
     222,   223,   224,   225,     0,   226,   227,   228,     0,   229,
       0,   230,   231,   232,   233,   234,   235,   236,     0,   237,
     238,   239,     0,   240,     0,   241,     0,     0,     0,   242,
     243,     0,   244,   245,     0,   246,     0,   247,   248,   249,
     250,     0,   251,   252,   253,     0,   254,   255,   256,   257,
     258,   259,     0,     0,   260,   261,   262,   263,   264,   265,
     266,     0,   267,     0,   268,     0,     0,   269,     0,   270,
     271,   272,   273,   274,     0,   275,     0,   276,     0,     0,
     277,   278,   279,     0,     0,   280,   281,   282,   283,   284,
     285,   286,   287,   288,   289,     0,     0,     0,   290,   291,
       0,   292,     0,   293,   294,   295,   296,   297,   298,   299,
     300,   301,     0,   302,   303,     0,   304,     0,   305,   306,
     307,   308,     0,     0,   309,     0,     0,     0,   310,   311,
       0,     0,   312,     0,     0,   313,   314,   315,   316,   317,
       0,   318,   319,   320,   321,   322,     0,   323,   324,   325,
     326,   327,   328,   329,   330,   331,     0,   332,   333,   334,
     335,   336,   337,   338,   339,   340,     0,   341,   342,     0,
     343,   344,   345,   346,   347,   348,   349,   350,   351,   352,
       0,   353,   354,   355,     0,   356,   357,   358,   359,     0,
     360,   361,     0,   362,   363,   364,   365,   366,   367,   368,
     369,   370,   371,     0,   372,   373,     0,   374,   375,   376,
     377,     0,   378,   379,     0,     0,   380,   381,   382,   383,
       0,   384,   385,   386,   387,   388,     0,     0,   389,   390,
     391,   392,  1944,     0,   393,   394,   395,   396,   397,   398,
       0,   399,   400,     0,     0,   401,     0,   402,   403,   404,
     405,   406,     0,     0,     0,   407,   161,   162,   163,   164,
     165,   166,   167,   168,  1948,   169,   170,     0,     0,     0,
       0,     0,     0,     0,     0,   171,   172,     0,   173,     0,
     174,   175,   176,     0,   177,     0,   178,   179,     0,   180,
     181,   182,   183,   184,     0,     0,   185,   186,   187,   188,
       0,   189,   190,   191,   192,   193,     0,     0,   194,   195,
     196,   197,   198,     0,   199,   200,   201,   202,     0,   203,
     204,   205,     0,   206,     0,     0,     0,     0,     0,   207,
     208,   209,   210,   211,   212,   213,   214,     0,   215,     0,
     216,   217,   218,   219,   220,     0,   221,     0,     0,   222,
     223,   224,   225,     0,   226,   227,   228,     0,   229,     0,
     230,   231,   232,   233,   234,   235,   236,     0,   237,   238,
     239,     0,   240,     0,   241,     0,     0,     0,   242,   243,
       0,   244,   245,     0,   246,     0,   247,   248,   249,   250,
       0,   251,   252,   253,     0,   254,   255,   256,   257,   258,
     259,     0,     0,   260,   261,   262,   263,   264,   265,   266,
       0,   267,     0,   268,     0,     0,   269,     0,   270,   271,
     272,   273,   274,     0,   275,     0,   276,     0,     0,   277,
     278,   279,     0,     0,   280,   281,   282,   283,   284,   285,
     286,   287,   288,   289,     0,     0,     0,   290,   291,     0,
     292,     0,   293,   294,   295,   296,   297,   298,   299,   300,
     301,     0,   302,   303,     0,   304,     0,   305,   306,   307,
     308,     0,     0,   309,     0,     0,     0,   310,   311,     0,
       0,   312,     0,     0,   313,   314,   315,   316,   317,     0,
     318,   319,   320,   321,   322,     0,   323,   324,   325,   326,
     327,   328,   329,   330,   331,     0,   332,   333,   334,   335,
     336,   337,   338,   339,   340,     0,   341,   342,     0,   343,
     344,   345,   346,   347,   348,   349,   350,   351,   352,     0,
     353,   354,   355,     0,   356,   357,   358,   359,     0,   360,
     361,     0,   362,   363,   364,   365,   366,   367,   368,   369,
     370,   371,     0,   372,   373,     0,   374,   375,   376,   377,
       0,   378,   379,     0,     0,   380,   381,   382,   383,     0,
     384,   385,   386,   387,   388,     0,     0,   389,   390,   391,
     392,  1949,     0,   393,   394,   395,   396,   397,   398,     0,
     399,   400,     0,     0,   401,     0,   402,   403,   404,   405,
     406,     0,     0,     0,   407,   161,   162,   163,   164,   165,
     166,   167,   168,   527,   169,   170,     0,     0,     0,     0,
       0,     0,     0,     0,   171,   172,     0,   173,     0,   174,
     175,   176,     0,   177,     0,   178,   179,     0,   180,   181,
     182,   183,   184,     0,     0,   185,   186,   187,   188,     0,
     189,   190,   191,   192,   193,     0,     0,   194,   195,   196,
     197,   198,     0,   199,   200,   201,   202,     0,   203,   204,
     205,     0,   206,     0,     0,     0,     0,     0,   207,   208,
     209,   210,   211,   212,   213,   214,     0,   215,     0,   216,
     217,   218,   219,   220,     0,   221,     0,     0,   222,   223,
     224,   225,     0,   226,   227,   228,     0,   229,     0,   230,
     231,   232,   233,   234,   235,   236,     0,   237,   238,   239,
       0,   240,     0,   241,     0,     0,     0,   242,   243,     0,
     244,   245,     0,   246,     0,   247,   248,   249,   250,     0,
     251,   252,   253,     0,   254,   255,   256,   257,   258,   259,
       0,     0,   260,   261,   262,   263,   264,   265,   266,     0,
     267,     0,   268,     0,     0,   269,     0,   270,   271,   272,
     273,   274,     0,   275,     0,   276,     0,     0,   277,   278,
     279,     0,     0,   280,   281,   282,   283,   284,   285,   286,
     287,   288,   289,     0,     0,     0,   290,   291,     0,   292,
       0,   293,   294,   295,   296,   297,   298,   299,   300,   301,
       0,   302,   303,     0,   304,     0,   305,   306,   307,   308,
       0,     0,   309,     0,     0,     0,   310,   311,     0,     0,
     312,     0,     0,   313,   314,   315,   316,   317,     0,   318,
     319,   320,   321,   322,     0,   323,   324,   325,   326,   327,
     328,   329,   330,   331,     0,   332,   333,   334,   335,   336,
     337,   338,   339,   340,     0,   341,   342,     0,   343,   344,
     345,   346,   347,   348,   349,   350,   351,   352,     0,   353,
     354,   528,     0,   356,   357,   358,   359,     0,   360,   361,
       0,   362,   363,   364,   365,   366,   367,   368,   369,   370,
     371,     0,   372,   373,     0,   374,   375,   376,   377,     0,
     529,   379,     0,     0,   530,   381,   382,   383,     0,   384,
     385,   386,   387,   388,     0,     0,   389,   390,   391,   392,
       0,     0,   393,   394,   395,   396,   397,   398,     0,   399,
     400,     0,     0,   401,     0,   402,   403,   404,   405,   406,
       0,     0,     0,   407,   161,   162,   163,   164,   165,   166,
     167,   168,   552,   169,   170,     0,     0,     0,     0,     0,
       0,     0,     0,   171,   172,     0,   173,     0,   174,   175,
     176,     0,   177,     0,   178,   179,     0,   180,   181,   182,
     183,   184,     0,     0,   185,   186,   187,   188,     0,   189,
     190,   191,   192,   193,     0,     0,   194,   195,   196,   197,
     198,     0,   199,   200,   201,   202,     0,   203,   204,   205,
       0,   206,     0,     0,     0,     0,     0,   207,   208,   209,
     210,   211,   212,   213,   214,     0,   215,     0,   216,   217,
     218,   219,   220,     0,   221,     0,     0,   222,   223,   224,
     225,     0,   226,   227,   228,     0,   229,     0,   230,   231,
     232,   233,   234,   235,   236,     0,   237,   238,   239,     0,
     240,     0,   241,     0,     0,     0,   242,   243,     0,   244,
     245,     0,   246,     0,   247,   248,   249,   250,     0,   251,
     252,   253,     0,   254,   255,   256,   257,   258,   259,     0,
       0,   260,   261,   262,   263,   264,   265,   266,     0,   267,
       0,   268,     0,     0,   269,     0,   270,   271,   272,   273,
     274,     0,   275,     0,   276,     0,     0,   277,   278,   279,
       0,     0,   280,   281,   282,   283,   284,   285,   286,   287,
     288,   289,     0,     0,     0,   290,   291,     0,   292,     0,
     293,   294,   295,   296,   297,   298,   299,   300,   301,     0,
     302,   303,     0,   304,     0,   305,   306,   307,   308,     0,
       0,   309,     0,     0,     0,   310,   311,     0,     0,   312,
       0,     0,   313,   314,   315,   316,   317,     0,   318,   319,
     320,   321,   322,     0,   323,   324,   325,   326,   327,   328,
     329,   330,   331,     0,   332,   333,   334,   335,   336,   337,
     338,   339,   340,     0,   341,   342,     0,   343,   344,   345,
     346,   347,   348,   349,   350,   351,   352,     0,   353,   354,
     553,     0,   356,   357,   358,   359,     0,   360,   361,     0,
     362,   363,   364,   365,   366,   367,   368,   369,   370,   371,
       0,   372,   373,     0,   374,   375,   376,   377,     0,   554,
     379,     0,     0,   555,   381,   382,   383,     0,   384,   385,
     386,   387,   388,     0,     0,   389,   390,   391,   392,     0,
       0,   393,   394,   395,   396,   397,   398,     0,   399,   400,
       0,     0,   401,     0,   402,   403,   404,   405,   406,     0,
       0,     0,   407,   161,   162,   163,   164,   165,   166,   167,
     168,     0,   169,   170,     0,     0,     0,     0,     0,     0,
       0,     0,   171,   172,     0,   173,   882,   174,   175,   176,
       0,   177,     0,   178,   179,     0,   180,   181,   182,   183,
     184,     0,     0,   185,   186,   187,   883,     0,   189,   190,
     191,   192,   193,     0,     0,   194,   195,   196,   197,   198,
       0,   199,   200,   201,   202,     0,   203,   204,   205,     0,
     206,     0,     0,     0,     0,     0,   207,   208,   209,   210,
     211,   212,   213,   214,     0,   215,     0,   216,   217,   218,
     219,   220,     0,   221,     0,     0,   222,   223,   224,   225,
       0,   226,   227,   228,     0,   229,     0,   230,   231,   232,
     233,   234,   235,   236,     0,   237,   238,   239,     0,   240,
       0,   241,     0,     0,     0,   242,   243,     0,   244,   245,
       0,   246,     0,   247,   248,   249,   250,     0,   251,   252,
     253,     0,   254,   255,   256,   257,   258,   259,     0,     0,
     260,   261,   262,   263,   264,   265,   266,     0,   267,     0,
     268,     0,     0,   269,     0,   270,   271,   272,   273,   274,
       0,   275,     0,   276,     0,     0,   277,   278,   279,     0,
       0,   280,   281,   282,   283,   284,   285,   286,   287,   288,
     289,     0,     0,     0,   545,   291,     0,   292,     0,   293,
     294,   295,   296,   297,   298,   299,   300,   301,     0,   302,
     303,     0,   304,     0,   305,   306,   307,   308,     0,     0,
     309,     0,     0,     0,   310,   311,     0,     0,   312,     0,
       0,   313,   314,   315,   316,   317,     0,   318,   319,   320,
     321,   322,     0,   323,   324,   325,   326,   327,   328,   329,
     330,   331,     0,   332,   333,   334,   335,   336,   337,   338,
     339,   340,     0,   341,   342,     0,   546,   344,   345,   346,
     347,   348,   349,   350,   351,   352,     0,   353,   354,   874,
       0,   356,   357,   358,   359,     0,   360,   361,     0,   362,
     363,   364,   365,   366,   367,   368,   369,   370,   371,     0,
     372,   373,     0,   374,   375,   376,   377,     0,   548,   379,
       0,     0,   549,   381,   382,   383,     0,   384,   385,   386,
     387,   388,     0,     0,   389,   390,   391,   392,     0,     0,
     393,   394,   395,   396,   397,   398,     0,   399,   400,     0,
       0,   401,     0,   402,   403,   404,   405,   406,     0,     0,
       0,   407,   161,   162,   163,   164,   165,   166,   167,   168,
       0,   169,   170,     0,     0,     0,     0,     0,     0,  2059,
       0,   171,   172,     0,   173,     0,   174,   175,   176,     0,
     177,     0,   178,   179,     0,   180,   181,   182,   183,   184,
       0,     0,   185,   186,   187,   188,     0,   189,   190,   191,
     192,   193,     0,     0,   194,   195,   196,   197,   198,     0,
     199,   200,   201,   202,     0,   203,   204,   205,     0,   206,
       0,     0,     0,     0,     0,   207,   208,   209,   210,   211,
     212,   213,   214,     0,   215,     0,   216,   217,   218,   219,
     220,     0,   221,     0,     0,   222,   223,   224,   225,     0,
     226,   227,   228,     0,   229,     0,   230,   231,   232,   233,
     234,   235,   236,     0,   237,   238,   239,     0,   240,     0,
     241,     0,     0,     0,   242,   243,     0,   244,   245,     0,
     246,     0,   247,   248,   249,   250,     0,   251,   252,   253,
       0,   254,   255,   256,   257,   258,   259,     0,     0,   260,
     261,   262,   263,   264,   265,   266,     0,   267,     0,   268,
       0,     0,   269,     0,   270,   271,   272,   273,   274,     0,
     275,     0,   276,     0,     0,   277,   278,   279,     0,     0,
     280,   281,   282,   283,   284,   285,   286,   287,   288,   289,
       0,     0,     0,   290,   291,     0,   292,     0,   293,   294,
     295,   296,   297,   298,   299,   300,   301,     0,   302,   303,
       0,   304,     0,   305,   306,   307,   308,     0,     0,   309,
       0,     0,     0,   310,   311,     0,     0,   312,     0,     0,
     313,   314,   315,   316,   317,     0,   318,   319,   320,   321,
     322,     0,   323,   324,   325,   326,   327,   328,   329,   330,
     331,     0,   332,   333,   334,   335,   336,   337,   338,   339,
     340,     0,   341,   342,     0,   343,   344,   345,   346,   347,
     348,   349,   350,   351,   352,     0,   353,   354,   355,     0,
     356,   357,   358,   359,     0,   360,   361,     0,   362,   363,
     364,   365,   366,   367,   368,   369,   370,   371,     0,   372,
     373,     0,   374,   375,   376,   377,     0,   378,   379,     0,
       0,   380,   381,   382,   383,     0,   384,   385,   386,   387,
     388,     0,     0,   389,   390,   391,   392,     0,     0,   393,
     394,   395,   396,   397,   398,     0,   399,   400,     0,     0,
     401,     0,   402,   403,   404,   405,   406,     0,     0,     0,
     407,   161,   162,   163,   164,   165,   166,   167,   168,     0,
     169,   170,     0,     0,     0,     0,     0,     0,  2072,     0,
     171,   172,     0,   173,     0,   174,   175,   176,     0,   177,
       0,   178,   179,     0,   180,   181,   182,   183,   184,     0,
       0,   185,   186,   187,   188,     0,   189,   190,   191,   192,
     193,     0,     0,   194,   195,   196,   197,   198,     0,   199,
     200,   201,   202,     0,   203,   204,   205,     0,   206,     0,
       0,     0,     0,     0,   207,   208,   209,   210,   211,   212,
     213,   214,     0,   215,     0,   216,   217,   218,   219,   220,
       0,   221,     0,     0,   222,   223,   224,   225,     0,   226,
     227,   228,     0,   229,     0,   230,   231,   232,   233,   234,
     235,   236,     0,   237,   238,   239,     0,   240,     0,   241,
       0,     0,     0,   242,   243,     0,   244,   245,     0,   246,
       0,   247,   248,   249,   250,     0,   251,   252,   253,     0,
     254,   255,   256,   257,   258,   259,     0,     0,   260,   261,
     262,   263,   264,   265,   266,     0,   267,     0,   268,     0,
       0,   269,     0,   270,   271,   272,   273,   274,     0,   275,
       0,   276,     0,     0,   277,   278,   279,     0,     0,   280,
     281,   282,   283,   284,   285,   286,   287,   288,   289,     0,
       0,     0,   290,   291,     0,   292,     0,   293,   294,   295,
     296,   297,   298,   299,   300,   301,     0,   302,   303,     0,
     304,     0,   305,   306,   307,   308,     0,     0,   309,     0,
       0,     0,   310,   311,     0,     0,   312,     0,     0,   313,
     314,   315,   316,   317,     0,   318,   319,   320,   321,   322,
       0,   323,   324,   325,   326,   327,   328,   329,   330,   331,
       0,   332,   333,   334,   335,   336,   337,   338,   339,   340,
       0,   341,   342,     0,   343,   344,   345,   346,   347,   348,
     349,   350,   351,   352,     0,   353,   354,   355,     0,   356,
     357,   358,   359,     0,   360,   361,     0,   362,   363,   364,
     365,   366,   367,   368,   369,   370,   371,     0,   372,   373,
       0,   374,   375,   376,   377,     0,   378,   379,     0,     0,
     380,   381,   382,   383,     0,   384,   385,   386,   387,   388,
       0,     0,   389,   390,   391,   392,     0,     0,   393,   394,
     395,   396,   397,   398,     0,   399,   400,     0,     0,   401,
       0,   402,   403,   404,   405,   406,     0,     0,     0,   407,
     161,   162,   163,   164,   165,   166,   167,   168,     0,   169,
     170,     0,     0,     0,     0,     0,     0,     0,     0,   171,
     172,     0,   173,     0,   174,   175,   176,     0,   177,     0,
     178,   179,     0,   180,   181,   182,   183,   184,     0,     0,
     185,   186,   187,   188,     0,   189,   190,   191,   192,   193,
       0,     0,   194,   195,   196,   197,   198,     0,   199,   200,
     201,   202,     0,   203,   204,   205,     0,   206,     0,     0,
       0,     0,     0,   207,   208,   209,   210,   211,   212,   213,
     214,     0,   215,     0,   216,   217,   218,   219,   220,     0,
     221,     0,     0,   222,   223,   224,   225,     0,   226,   227,
     228,     0,   229,     0,   230,   231,   232,   233,   234,   235,
     236,     0,   237,   238,   239,     0,   240,     0,   241,     0,
       0,     0,   242,   243,     0,   244,   245,  2096,   246,     0,
     247,   248,   249,   250,     0,   251,   252,   253,     0,   254,
     255,   256,   257,   258,   259,     0,     0,   260,   261,   262,
     263,   264,   265,   266,     0,   267,     0,   268,     0,     0,
     269,     0,   270,   271,   272,   273,   274,     0,   275,     0,
     276,     0,     0,   277,   278,   279,     0,     0,   280,   281,
     282,   283,   284,   285,   286,   287,   288,   289,     0,     0,
       0,   290,   291,     0,   292,     0,   293,   294,   295,   296,
     297,   298,   299,   300,   301,     0,   302,   303,     0,   304,
       0,   305,   306,   307,   308,     0,     0,   309,     0,     0,
       0,   310,   311,     0,     0,   312,     0,     0,   313,   314,
     315,   316,   317,     0,   318,   319,   320,   321,   322,     0,
     323,   324,   325,   326,   327,   328,   329,   330,   331,     0,
     332,   333,   334,   335,   336,   337,   338,   339,   340,     0,
     341,   342,     0,   343,   344,   345,   346,   347,   348,   349,
     350,   351,   352,     0,   353,   354,   355,     0,   356,   357,
     358,   359,     0,   360,   361,     0,   362,   363,   364,   365,
     366,   367,   368,   369,   370,   371,     0,   372,   373,     0,
     374,   375,   376,   377,     0,   378,   379,     0,     0,   380,
     381,   382,   383,     0,   384,   385,   386,   387,   388,     0,
       0,   389,   390,   391,   392,     0,     0,   393,   394,   395,
     396,   397,   398,     0,   399,   400,     0,     0,   401,     0,
     402,   403,   404,   405,   406,     0,     0,     0,   407,   161,
     162,   163,   164,   165,   166,   167,   168,     0,   169,   170,
       0,     0,     0,     0,     0,     0,     0,     0,   171,   172,
       0,   173,     0,   174,   175,   176,     0,   177,     0,   178,
     179,     0,   180,   181,   182,   183,   184,     0,     0,   185,
     186,   187,   188,     0,   189,   190,   191,   192,   193,     0,
       0,   194,   195,   196,   197,   198,     0,   199,   200,   201,
     202,     0,   203,   204,   205,     0,   206,     0,     0,     0,
       0,     0,   207,   208,   209,   210,   211,   212,   213,   214,
    2586,   215,     0,   216,   217,   218,   219,   220,     0,   221,
       0,     0,   222,   223,   224,   225,     0,   226,   227,   228,
       0,   229,     0,   230,   231,   232,   233,   234,   235,   236,
       0,   237,   238,   239,     0,   240,     0,   241,     0,     0,
       0,   242,   243,     0,   244,   245,     0,   246,     0,   247,
     248,   249,   250,     0,   251,   252,   253,     0,   254,   255,
     256,   257,   258,   259,     0,     0,   260,   261,   262,   263,
     264,   265,   266,     0,   267,     0,   268,     0,     0,   269,
       0,   270,   271,   272,   273,   274,     0,   275,     0,   276,
       0,     0,   277,   278,   279,     0,     0,   280,   281,   282,
     283,   284,   285,   286,   287,   288,   289,     0,     0,     0,
     290,   291,     0,   292,     0,   293,   294,   295,   296,   297,
     298,   299,   300,   301,     0,   302,   303,     0,   304,     0,
     305,   306,   307,   308,     0,     0,   309,     0,     0,     0,
     310,   311,     0,     0,   312,     0,     0,   313,   314,   315,
     316,   317,     0,   318,   319,   320,   321,   322,     0,   323,
     324,   325,   326,   327,   328,   329,   330,   331,     0,   332,
     333,   334,   335,   336,   337,   338,   339,   340,     0,   341,
     342,     0,   343,   344,   345,   346,   347,   348,   349,   350,
     351,   352,     0,   353,   354,   355,     0,   356,   357,   358,
     359,     0,   360,   361,     0,   362,   363,   364,   365,   366,
     367,   368,   369,   370,   371,     0,   372,   373,     0,   374,
     375,   376,   377,     0,   378,   379,     0,     0,   380,   381,
     382,   383,     0,   384,   385,   386,   387,   388,     0,     0,
     389,   390,   391,   392,     0,     0,   393,   394,   395,   396,
     397,   398,     0,   399,   400,     0,     0,   401,     0,   402,
     403,   404,   405,   406,     0,     0,     0,   407,   161,   162,
     163,   164,   165,   166,   167,   168,     0,   169,   170,     0,
       0,     0,     0,     0,     0,     0,     0,   171,   172,     0,
     173,     0,   174,   175,   176,     0,   177,     0,   178,   179,
       0,   180,   181,   182,   183,   184,     0,     0,   185,   186,
     187,   188,     0,   189,   190,   191,   192,   193,     0,     0,
     194,   195,   196,   197,   198,     0,   199,   200,   201,   202,
       0,   203,   204,   205,     0,   206,     0,     0,     0,     0,
       0,   207,   208,   209,   210,   211,   212,   213,   214,  2588,
     215,     0,   216,   217,   218,   219,   220,     0,   221,     0,
       0,   222,   223,   224,   225,     0,   226,   227,   228,     0,
     229,     0,   230,   231,   232,   233,   234,   235,   236,     0,
     237,   238,   239,     0,   240,     0,   241,     0,     0,     0,
     242,   243,     0,   244,   245,     0,   246,     0,   247,   248,
     249,   250,     0,   251,   252,   253,     0,   254,   255,   256,
     257,   258,   259,     0,     0,   260,   261,   262,   263,   264,
     265,   266,     0,   267,     0,   268,     0,     0,   269,     0,
     270,   271,   272,   273,   274,     0,   275,     0,   276,     0,
       0,   277,   278,   279,     0,     0,   280,   281,   282,   283,
     284,   285,   286,   287,   288,   289,     0,     0,     0,   290,
     291,     0,   292,     0,   293,   294,   295,   296,   297,   298,
     299,   300,   301,     0,   302,   303,     0,   304,     0,   305,
     306,   307,   308,     0,     0,   309,     0,     0,     0,   310,
     311,     0,     0,   312,     0,     0,   313,   314,   315,   316,
     317,     0,   318,   319,   320,   321,   322,     0,   323,   324,
     325,   326,   327,   328,   329,   330,   331,     0,   332,   333,
     334,   335,   336,   337,   338,   339,   340,     0,   341,   342,
       0,   343,   344,   345,   346,   347,   348,   349,   350,   351,
     352,     0,   353,   354,   355,     0,   356,   357,   358,   359,
       0,   360,   361,     0,   362,   363,   364,   365,   366,   367,
     368,   369,   370,   371,     0,   372,   373,     0,   374,   375,
     376,   377,     0,   378,   379,     0,     0,   380,   381,   382,
     383,     0,   384,   385,   386,   387,   388,     0,     0,   389,
     390,   391,   392,     0,     0,   393,   394,   395,   396,   397,
     398,     0,   399,   400,     0,     0,   401,     0,   402,   403,
     404,   405,   406,     0,     0,     0,   407,   161,   162,   163,
     164,   165,   166,   167,   168,     0,   169,   170,     0,     0,
       0,     0,     0,     0,     0,     0,   171,   172,     0,   173,
       0,   174,   175,   176,     0,   177,     0,   178,   179,     0,
     180,   181,   182,   183,   184,     0,     0,   185,   186,   187,
     188,     0,   189,   190,   191,   192,   193,     0,     0,   194,
     195,   196,   197,   198,     0,   199,   200,   201,   202,     0,
     203,   204,   205,     0,   206,     0,     0,     0,     0,     0,
     207,   208,   209,   210,   211,   212,   213,   214,  2590,   215,
       0,   216,   217,   218,   219,   220,     0,   221,     0,     0,
     222,   223,   224,   225,     0,   226,   227,   228,     0,   229,
       0,   230,   231,   232,   233,   234,   235,   236,     0,   237,
     238,   239,     0,   240,     0,   241,     0,     0,     0,   242,
     243,     0,   244,   245,     0,   246,     0,   247,   248,   249,
     250,     0,   251,   252,   253,     0,   254,   255,   256,   257,
     258,   259,     0,     0,   260,   261,   262,   263,   264,   265,
     266,     0,   267,     0,   268,     0,     0,   269,     0,   270,
     271,   272,   273,   274,     0,   275,     0,   276,     0,     0,
     277,   278,   279,     0,     0,   280,   281,   282,   283,   284,
     285,   286,   287,   288,   289,     0,     0,     0,   290,   291,
       0,   292,     0,   293,   294,   295,   296,   297,   298,   299,
     300,   301,     0,   302,   303,     0,   304,     0,   305,   306,
     307,   308,     0,     0,   309,     0,     0,     0,   310,   311,
       0,     0,   312,     0,     0,   313,   314,   315,   316,   317,
       0,   318,   319,   320,   321,   322,     0,   323,   324,   325,
     326,   327,   328,   329,   330,   331,     0,   332,   333,   334,
     335,   336,   337,   338,   339,   340,     0,   341,   342,     0,
     343,   344,   345,   346,   347,   348,   349,   350,   351,   352,
       0,   353,   354,   355,     0,   356,   357,   358,   359,     0,
     360,   361,     0,   362,   363,   364,   365,   366,   367,   368,
     369,   370,   371,     0,   372,   373,     0,   374,   375,   376,
     377,     0,   378,   379,     0,     0,   380,   381,   382,   383,
       0,   384,   385,   386,   387,   388,     0,     0,   389,   390,
     391,   392,     0,     0,   393,   394,   395,   396,   397,   398,
       0,   399,   400,     0,     0,   401,     0,   402,   403,   404,
     405,   406,     0,     0,     0,   407,   161,   162,   163,   164,
     165,   166,   167,   168,     0,   169,   170,     0,     0,     0,
       0,     0,     0,     0,     0,   171,   172,     0,   173,     0,
     174,   175,   176,     0,   177,     0,   178,   179,     0,   180,
     181,   182,   183,   184,     0,     0,   185,   186,   187,   188,
       0,   189,   190,   191,   192,   193,     0,     0,   194,   195,
     196,   197,   198,     0,   199,   200,   201,   202,     0,   203,
     204,   205,     0,   206,     0,     0,     0,     0,     0,   207,
     208,   209,   210,   211,   212,   213,   214,     0,   215,     0,
     216,   217,   218,   219,   220,     0,   221,     0,     0,   222,
     223,   224,   225,     0,   226,   227,   228,     0,   229,     0,
     230,   231,   232,   233,   234,   235,   236,     0,   237,   238,
     239,     0,   240,     0,   241,     0,     0,     0,   242,   243,
       0,   244,   245,     0,   246,     0,   247,   248,   249,   250,
       0,   251,   252,   253,     0,   254,   255,   256,   257,   258,
     259,     0,     0,   260,   261,   262,   263,   264,   265,   266,
       0,   267,     0,   268,     0,     0,   269,     0,   270,   271,
     272,   273,   274,     0,   275,     0,   276,     0,     0,   277,
     278,   279,     0,     0,   280,   281,   282,   283,   284,   285,
     286,   287,   288,   289,     0,     0,     0,   290,   291,     0,
     292,     0,   293,   294,   295,   296,   297,   298,   299,   300,
     301,     0,   302,   303,     0,   304,     0,   305,   306,   307,
     308,     0,     0,   309,     0,     0,     0,   310,   311,     0,
       0,   312,     0,     0,   313,   314,   315,   316,   317,     0,
     318,   319,   320,   321,   322,     0,   323,   324,   325,   326,
     327,   328,   329,   330,   331,     0,   332,   333,   334,   335,
     336,   337,   338,   339,   340,     0,   341,   342,     0,   343,
     344,   345,   346,   347,   348,   349,   350,   351,   352,     0,
     353,   354,   355,     0,   356,   357,   358,   359,     0,   360,
     361,     0,   362,   363,   364,   365,   366,   367,   368,   369,
     370,   371,     0,   372,   373,     0,   374,   375,   376,   377,
       0,   378,   379,     0,     0,   380,   381,   382,   383,     0,
     384,   385,   386,   387,   388,     0,     0,   389,   390,   391,
     392,     0,  2856,   393,   394,   395,   396,   397,   398,     0,
     399,   400,     0,     0,   401,     0,   402,   403,   404,   405,
     406,     0,     0,     0,   407,   161,   162,   163,   164,   165,
     166,   167,   168,     0,   169,   170,     0,     0,     0,     0,
       0,     0,     0,     0,   171,   172,     0,   173,     0,   174,
     175,   176,     0,   177,     0,   178,   179,     0,   180,   181,
     182,   183,   184,     0,     0,   185,   186,   187,   188,     0,
     189,   190,   191,   192,   193,     0,     0,   194,   195,   196,
     197,   198,     0,   199,   200,   201,   202,     0,   203,   204,
     205,     0,   206,     0,     0,     0,     0,     0,   207,   208,
     209,   210,   211,   212,   213,   214,     0,   215,     0,   216,
     217,   218,   219,   220,     0,   221,     0,     0,   222,   223,
     224,   225,     0,   226,   227,   228,     0,   229,     0,   230,
     231,   232,   233,   234,   235,   236,     0,   237,   238,   239,
       0,   240,     0,   241,     0,     0,     0,   242,   243,     0,
     244,   245,     0,   246,     0,   247,   248,   249,   250,     0,
     251,   252,   253,     0,   254,   255,   256,   257,   258,   259,
       0,     0,   260,   261,   262,   263,   264,   265,   266,     0,
     267,     0,   268,     0,     0,   269,     0,   270,   271,   272,
     273,   274,     0,   275,     0,   276,     0,     0,   277,   278,
     279,     0,     0,   280,   281,   282,   283,   284,   285,   286,
     287,   288,   289,     0,     0,     0,   290,   291,     0,   292,
       0,   293,   294,   295,   296,   297,   298,   299,   300,   301,
       0,   302,   303,     0,   304,     0,   305,   306,   307,   308,
       0,     0,   309,     0,     0,     0,   310,   311,     0,     0,
     312,     0,     0,   313,   314,   315,   316,   317,     0,   318,
     319,   320,   321,   322,     0,   323,   324,   325,   326,   327,
     328,   329,   330,   331,     0,   332,   333,   334,   335,   336,
     337,   338,   339,   340,     0,   341,   342,     0,   343,   344,
     345,   346,   347,   348,   349,   350,   351,   352,     0,   353,
     354,   355,     0,   356,   357,   358,   359,     0,   360,   361,
       0,   362,   363,   364,   365,   366,   367,   368,   369,   370,
     371,     0,   372,   373,     0,   374,   375,   376,   377,     0,
     378,   379,     0,     0,   380,   381,   382,   383,     0,   384,
     385,   386,   387,   388,     0,     0,   389,   390,   391,   392,
       0,     0,   393,   394,   395,   396,   397,   398,     0,   399,
     400,     0,     0,   401,     0,   402,   403,   404,   405,   406,
       0,     0,     0,   407,   161,   162,   163,   164,   165,   166,
     167,   168,     0,   169,   170,     0,     0,     0,     0,     0,
       0,     0,     0,   171,   172,     0,   173,     0,   174,   175,
     176,     0,   177,     0,   178,   179,     0,   180,   181,   182,
     183,   184,     0,     0,   185,   186,   187,   188,     0,   189,
     190,   191,   192,   193,     0,     0,   194,   195,   196,   197,
     198,     0,   199,   200,   201,   202,     0,   203,   204,   205,
       0,   206,     0,     0,     0,     0,     0,   207,   208,   209,
     210,   211,   212,   213,   214,     0,   215,     0,   216,   217,
     218,   219,   220,     0,   221,     0,     0,   222,   223,   224,
     225,     0,   226,   227,   228,     0,   229,     0,   230,   231,
     232,   233,   234,   235,   236,     0,   237,   238,   239,     0,
     240,     0,   241,     0,     0,     0,   242,   243,     0,   244,
     245,     0,   246,     0,   247,   248,   249,   250,     0,   251,
     252,   253,     0,   254,   255,   256,   257,   258,   259,     0,
       0,   260,   261,   262,   263,   264,   265,   266,     0,   267,
       0,   268,     0,     0,   269,     0,   270,   271,   272,   273,
     274,     0,   275,     0,   276,     0,     0,   277,   278,   279,
       0,     0,   280,   281,   282,   283,   284,   285,   286,   287,
     288,   289,     0,     0,     0,   290,   291,     0,   292,     0,
     293,   294,   295,   296,   297,   298,   299,   300,   301,     0,
     302,   303,     0,   304,     0,   305,   306,   307,   308,     0,
       0,   309,     0,     0,     0,   310,   311,     0,     0,   312,
       0,     0,   313,   314,   315,   316,   317,     0,   318,   319,
     320,   452,   322,     0,   323,   324,   325,   326,   327,   328,
     329,   330,   331,     0,   332,   333,   334,   335,   336,   337,
     338,   339,   340,     0,   341,   342,     0,   343,   344,   345,
     346,   347,   348,   349,   350,   351,   352,     0,   353,   354,
     355,     0,   356,   357,   358,   359,     0,   360,   361,     0,
     362,   363,   364,   365,   366,   367,   368,   369,   370,   371,
       0,   372,   373,     0,   374,   375,   376,   377,     0,   378,
     379,     0,     0,   380,   381,   382,   383,     0,   384,   385,
     386,   387,   388,     0,     0,   389,   390,   391,   392,     0,
       0,   393,   394,   395,   396,   397,   398,     0,   399,   400,
       0,     0,   401,     0,   402,   403,   404,   405,   406,     0,
       0,     0,   407,   161,   162,   163,   164,   165,   166,   167,
     168,     0,   169,   170,     0,     0,     0,     0,     0,     0,
       0,     0,   171,   172,     0,   173,     0,   174,   175,   176,
       0,   177,     0,   178,   179,     0,   180,   181,   182,   183,
     184,     0,     0,   185,   186,   187,   188,     0,   189,   190,
     191,   192,   193,     0,     0,   194,   195,   196,   197,   198,
       0,   199,   200,   201,   202,     0,   203,   204,   205,     0,
     206,     0,     0,     0,     0,     0,   207,   208,   209,   210,
     211,   212,   213,   214,     0,   215,     0,   216,   217,   218,
     219,   220,     0,   221,     0,     0,   222,   223,   224,   225,
       0,   226,   227,   228,     0,   229,     0,   230,   231,   232,
     233,   234,   235,   236,     0,   237,   238,   239,     0,   240,
       0,   241,     0,     0,     0,   242,   243,     0,   244,   245,
       0,   246,     0,   247,   248,   249,   250,     0,   251,   252,
     253,     0,   254,   255,   256,   257,   258,   259,     0,     0,
     260,   261,   262,   263,   264,   265,   266,     0,   267,     0,
     268,     0,     0,   269,     0,   270,   271,   272,   273,   274,
       0,   275,     0,   276,     0,     0,   277,   278,   279,     0,
       0,   280,   281,   282,   283,   284,   285,   286,   287,   288,
     289,     0,     0,     0,   290,   291,     0,   292,     0,   293,
     294,   295,   296,   297,   298,   299,   300,   301,     0,   302,
     303,     0,   304,     0,   305,   306,   307,   308,     0,     0,
     309,     0,     0,     0,   310,   311,     0,     0,   312,     0,
       0,   313,   314,   315,   316,   317,     0,   318,   319,   320,
     321,   322,     0,   323,   324,   325,   326,   327,   328,   329,
     330,   331,     0,   332,   333,   334,   335,   336,   337,   338,
     339,   340,     0,   341,   342,     0,   343,   344,   345,   346,
     347,   348,   349,   350,   351,   352,     0,   353,   354,   355,
       0,   356,   357,   358,   359,     0,   360,   361,     0,   362,
     363,   364,   365,   366,   367,   368,   369,   370,   371,     0,
     372,   373,     0,   374,   375,   376,   377,     0,   378,   379,
       0,     0,   517,   381,   382,   383,     0,   384,   385,   386,
     387,   388,     0,     0,   389,   390,   391,   392,     0,     0,
     393,   394,   395,   396,   397,   398,     0,   399,   400,     0,
       0,   401,     0,   402,   403,   404,   405,   406,     0,     0,
       0,   407,   161,   162,   163,   164,   165,   166,   167,   168,
       0,   169,   170,     0,     0,     0,     0,     0,     0,     0,
       0,   171,   172,     0,   173,     0,   174,   175,   176,     0,
     177,     0,   178,   179,     0,   180,   181,   182,   183,   184,
       0,     0,   185,   186,   187,   188,     0,   189,   190,   191,
     192,   193,     0,     0,   194,   195,   196,   197,   198,     0,
     199,   200,   201,   202,     0,   203,   204,   205,     0,   206,
       0,     0,     0,     0,     0,   207,   208,   209,   210,   211,
     212,   213,   214,     0,   215,     0,   216,   217,   218,   219,
     220,     0,   221,     0,     0,   222,   223,   224,   225,     0,
     226,   227,   228,     0,   229,     0,   230,   231,   232,   233,
     234,   235,   236,     0,   237,   238,   239,     0,   240,     0,
     241,     0,     0,     0,   242,   243,     0,   244,   245,     0,
     246,     0,   247,   248,   249,   250,     0,   251,   252,   253,
       0,   254,   255,   256,   257,   258,   259,     0,     0,   260,
     261,   262,   263,   264,   265,   266,     0,   267,     0,   268,
       0,     0,   269,     0,   270,   271,   272,   273,   274,     0,
     275,     0,   276,     0,     0,   277,   278,   279,     0,     0,
     280,   281,   282,   283,   284,   285,   286,   287,   288,   289,
       0,     0,     0,   290,   291,     0,   292,     0,   293,   294,
     295,   296,   297,   298,   299,   300,   301,     0,   302,   303,
       0,   304,     0,   305,   306,   307,   308,     0,     0,   309,
       0,     0,     0,   310,   311,     0,     0,   312,     0,     0,
     313,   314,   315,   316,   317,     0,   318,   319,   320,   321,
     322,     0,   323,   324,   325,   326,   327,   328,   329,   330,
     331,     0,   332,   333,   334,   335,   336,   337,   338,   339,
     340,     0,   341,   342,     0,   343,   344,   345,   346,   347,
     525,   349,   350,   351,   352,     0,   353,   354,   355,     0,
     356,   357,   358,   359,     0,   360,   361,     0,   362,   363,
     364,   365,   366,   367,   368,   369,   370,   371,     0,   372,
     373,     0,   374,   375,   376,   377,     0,   378,   379,     0,
       0,   380,   381,   382,   383,     0,   384,   385,   386,   387,
     388,     0,     0,   389,   390,   391,   392,     0,     0,   393,
     394,   395,   396,   397,   398,     0,   399,   400,     0,     0,
     401,     0,   402,   403,   404,   405,   406,     0,     0,     0,
     407,   161,   162,   163,   164,   165,   166,   167,   168,     0,
     169,   170,     0,     0,     0,     0,     0,     0,     0,     0,
     171,   172,     0,   173,     0,   174,   175,   176,     0,   177,
       0,   178,   179,     0,   180,   181,   182,   183,   184,     0,
       0,   185,   186,   187,   188,     0,   189,   190,   191,   192,
     193,     0,     0,   194,   195,   196,   197,   198,     0,   543,
     200,   201,   202,     0,   203,   204,   205,     0,   206,     0,
       0,     0,     0,     0,   207,   208,   209,   210,   211,   212,
     213,   214,     0,   215,     0,   216,   217,   218,   219,   220,
       0,   221,     0,     0,   222,   223,   224,   225,     0,   226,
     227,   228,     0,   229,     0,   230,   231,   232,   233,   234,
     235,   236,     0,   237,   238,   239,     0,   240,     0,   241,
       0,     0,     0,   242,   243,     0,   244,   245,     0,   246,
       0,   247,   248,   249,   250,     0,   251,   252,   253,     0,
     254,   255,   256,   257,   258,   259,     0,     0,   260,   261,
     262,   263,   264,   265,   266,     0,   267,     0,   268,     0,
       0,   269,     0,   270,   271,   272,   273,   274,     0,   275,
       0,   276,     0,     0,   277,   278,   544,     0,     0,   280,
     281,   282,   283,   284,   285,   286,   287,   288,   289,     0,
       0,     0,   545,   291,     0,   292,     0,   293,   294,   295,
     296,   297,   298,   299,   300,   301,     0,   302,   303,     0,
     304,     0,   305,   306,   307,   308,     0,     0,   309,     0,
       0,     0,   310,   311,     0,     0,   312,     0,     0,   313,
     314,   315,   316,   317,     0,   318,   319,   320,   321,   322,
       0,   323,   324,   325,   326,   327,   328,   329,   330,   331,
       0,   332,   333,   334,   335,   336,   337,   338,   339,   340,
       0,   341,   342,     0,   546,   344,   345,   346,   347,   348,
     349,   350,   351,   352,     0,   353,   354,   547,     0,   356,
     357,   358,   359,     0,   360,   361,     0,   362,   363,   364,
     365,   366,   367,   368,   369,   370,   371,     0,   372,   373,
       0,   374,   375,   376,   377,     0,   548,   379,     0,     0,
     549,   381,   382,   383,     0,   384,   385,   386,   387,   388,
       0,     0,   389,   390,   391,   392,     0,     0,   393,   394,
     395,   396,   397,   398,     0,   399,   400,     0,     0,   401,
       0,   402,   403,   404,   405,   406,     0,     0,     0,   407,
     161,   162,   163,   164,   165,   166,   167,   168,     0,   169,
     170,     0,     0,     0,     0,     0,     0,     0,     0,   171,
     172,     0,   173,     0,   174,   175,   176,     0,   177,     0,
     178,   179,     0,   180,   181,   182,   183,   184,     0,     0,
     185,   186,   187,   188,     0,   189,   190,   191,   192,   193,
       0,     0,   194,   195,   196,   197,   198,     0,   199,   200,
     201,   202,     0,   203,   204,   205,     0,   206,     0,     0,
       0,     0,     0,   207,   208,   209,   210,   211,   212,   213,
     214,     0,   215,     0,   216,   217,   218,   219,   220,     0,
     221,     0,     0,   222,   223,   224,   225,     0,   226,   227,
     228,     0,   229,     0,   230,   231,   232,   233,   234,   235,
     236,     0,   237,   238,   239,     0,   240,     0,   241,     0,
       0,     0,   242,   243,     0,   244,   245,     0,   246,     0,
     247,   248,   249,   715,     0,   251,   252,   253,     0,   254,
     255,   256,   257,   258,   259,     0,     0,   260,   261,   262,
     263,   264,   265,   266,     0,   267,     0,   268,     0,     0,
     269,     0,   270,   271,   272,   273,   274,     0,   275,     0,
     276,     0,     0,   277,   278,   279,     0,     0,   280,   281,
     282,   283,   284,   285,   286,   287,   288,   289,     0,     0,
       0,   290,   291,     0,   292,     0,   293,   294,   295,   296,
     297,   298,   299,   300,   301,     0,   302,   303,     0,   304,
       0,   305,   306,   307,   308,     0,     0,   309,     0,     0,
       0,   310,   311,     0,     0,   312,     0,     0,   313,   314,
     315,   316,   317,     0,   318,   319,   320,   321,   322,     0,
     323,   324,   325,   326,   327,   328,   329,   330,   331,     0,
     332,   333,   334,   335,   336,   337,   338,   339,   340,     0,
     341,   342,     0,   343,   344,   345,   346,   347,   348,   349,
     350,   351,   352,     0,   353,   354,   355,     0,   356,   357,
     358,   359,     0,   360,   361,     0,   362,   363,   364,   365,
     366,   367,   368,   369,   370,   371,     0,   372,   373,     0,
     374,   375,   376,   377,     0,   378,   379,     0,     0,   380,
     381,   382,   383,     0,   384,   385,   386,   387,   388,     0,
       0,   389,   390,   391,   392,     0,     0,   393,   394,   395,
     396,   397,   398,     0,   399,   400,     0,     0,   401,     0,
     402,   403,   404,   405,   406,     0,     0,     0,   407,   161,
     162,   163,   164,   165,   166,   167,   168,     0,   169,   170,
       0,     0,     0,     0,     0,     0,     0,     0,   171,   172,
       0,   173,     0,   174,   175,   176,     0,   177,     0,   178,
     179,     0,   180,   181,   182,   183,   184,     0,     0,   185,
     186,   187,   188,     0,   189,   190,   191,   192,   193,     0,
       0,   194,   195,   196,   197,   198,     0,   199,   200,   201,
     202,     0,   203,   204,   205,     0,   206,     0,     0,     0,
       0,     0,   207,   208,   209,   210,   211,   212,   213,   214,
       0,   215,     0,   216,   217,   218,   219,   220,     0,   221,
       0,     0,   222,   223,   224,   225,     0,   226,   227,   228,
       0,   229,     0,   230,   231,   232,   233,   234,   235,   236,
       0,   237,   238,   239,     0,   240,     0,   241,     0,     0,
       0,   242,   243,     0,   244,   245,     0,   246,     0,   247,
     248,   249,   719,     0,   251,   252,   253,     0,   254,   255,
     256,   257,   258,   259,     0,     0,   260,   261,   262,   263,
     264,   265,   266,     0,   267,     0,   268,     0,     0,   269,
       0,   270,   271,   272,   273,   274,     0,   275,     0,   276,
       0,     0,   277,   278,   279,     0,     0,   280,   281,   282,
     283,   284,   285,   286,   287,   288,   289,     0,     0,     0,
     290,   291,     0,   292,     0,   293,   294,   295,   296,   297,
     298,   299,   300,   301,     0,   302,   303,     0,   304,     0,
     305,   306,   307,   308,     0,     0,   309,     0,     0,     0,
     310,   311,     0,     0,   312,     0,     0,   313,   314,   315,
     316,   317,     0,   318,   319,   320,   321,   322,     0,   323,
     324,   325,   326,   327,   328,   329,   330,   331,     0,   332,
     333,   334,   335,   336,   337,   338,   339,   340,     0,   341,
     342,     0,   343,   344,   345,   346,   347,   348,   349,   350,
     351,   352,     0,   353,   354,   355,     0,   356,   357,   358,
     359,     0,   360,   361,     0,   362,   363,   364,   365,   366,
     367,   368,   369,   370,   371,     0,   372,   373,     0,   374,
     375,   376,   377,     0,   378,   379,     0,     0,   380,   381,
     382,   383,     0,   384,   385,   386,   387,   388,     0,     0,
     389,   390,   391,   392,     0,     0,   393,   394,   395,   396,
     397,   398,     0,   399,   400,     0,     0,   401,     0,   402,
     403,   404,   405,   406,     0,     0,     0,   407,   161,   162,
     163,   164,   165,   166,   167,   168,     0,   169,   170,     0,
       0,     0,     0,     0,     0,     0,     0,   171,   172,     0,
     173,     0,   174,   175,   176,     0,   177,     0,   178,   179,
       0,   180,   181,   182,   183,   184,     0,     0,   185,   186,
     187,   188,     0,   189,   190,   191,   192,   193,     0,     0,
     194,   195,   196,   197,   198,     0,   199,   200,   201,   202,
       0,   203,   204,   205,     0,   206,     0,     0,     0,     0,
       0,   207,   208,   209,   210,   211,   212,   213,   214,     0,
     215,     0,   216,   217,   218,   219,   220,     0,   221,     0,
       0,   222,   223,   224,   225,     0,   226,   227,   228,     0,
     229,     0,   230,   231,   232,   233,   234,   235,   236,     0,
     237,   238,   239,     0,   240,     0,   241,     0,     0,     0,
     242,   243,     0,   244,   245,     0,   246,     0,   247,   248,
     249,   726,     0,   251,   252,   253,     0,   254,   255,   256,
     257,   258,   259,     0,     0,   260,   261,   262,   263,   264,
     265,   266,     0,   267,     0,   268,     0,     0,   269,     0,
     270,   271,   272,   273,   274,     0,   275,     0,   276,     0,
       0,   277,   278,   279,     0,     0,   280,   281,   282,   283,
     284,   285,   286,   287,   288,   289,     0,     0,     0,   290,
     291,     0,   292,     0,   293,   294,   295,   296,   297,   298,
     299,   300,   301,     0,   302,   303,     0,   304,     0,   305,
     306,   307,   308,     0,     0,   309,     0,     0,     0,   310,
     311,     0,     0,   312,     0,     0,   313,   314,   315,   316,
     317,     0,   318,   319,   320,   321,   322,     0,   323,   324,
     325,   326,   327,   328,   329,   330,   331,     0,   332,   333,
     334,   335,   336,   337,   338,   339,   340,     0,   341,   342,
       0,   343,   344,   345,   346,   347,   348,   349,   350,   351,
     352,     0,   353,   354,   355,     0,   356,   357,   358,   359,
       0,   360,   361,     0,   362,   363,   364,   365,   366,   367,
     368,   369,   370,   371,     0,   372,   373,     0,   374,   375,
     376,   377,     0,   378,   379,     0,     0,   380,   381,   382,
     383,     0,   384,   385,   386,   387,   388,     0,     0,   389,
     390,   391,   392,     0,     0,   393,   394,   395,   396,   397,
     398,     0,   399,   400,     0,     0,   401,     0,   402,   403,
     404,   405,   406,     0,     0,     0,   407,   161,   162,   163,
     164,   165,   166,   167,   168,     0,   169,   170,     0,     0,
       0,     0,     0,     0,     0,     0,   171,   172,     0,   173,
       0,   174,   175,   176,     0,   177,     0,   178,   179,     0,
     180,   181,   182,   183,   184,     0,     0,   185,   186,   187,
     188,     0,   189,   190,   191,   192,   193,     0,     0,   194,
     195,   196,   197,   198,     0,   199,   200,   201,   202,     0,
     203,   204,   205,     0,   206,     0,     0,     0,     0,     0,
     207,   208,   209,   210,   211,   212,   213,   214,     0,   215,
       0,   216,   217,   218,   219,   220,     0,   221,     0,     0,
     222,   223,   224,   225,     0,   226,   227,   228,     0,   229,
       0,   230,   231,   232,   233,   234,   235,   236,     0,   237,
     238,   239,     0,   240,     0,   241,     0,     0,     0,   242,
     243,     0,   244,   245,     0,   246,     0,   247,   248,   249,
     728,     0,   251,   252,   253,     0,   254,   255,   256,   257,
     258,   259,     0,     0,   260,   261,   262,   263,   264,   265,
     266,     0,   267,     0,   268,     0,     0,   269,     0,   270,
     271,   272,   273,   274,     0,   275,     0,   276,     0,     0,
     277,   278,   279,     0,     0,   280,   281,   282,   283,   284,
     285,   286,   287,   288,   289,     0,     0,     0,   290,   291,
       0,   292,     0,   293,   294,   295,   296,   297,   298,   299,
     300,   301,     0,   302,   303,     0,   304,     0,   305,   306,
     307,   308,     0,     0,   309,     0,     0,     0,   310,   311,
       0,     0,   312,     0,     0,   313,   314,   315,   316,   317,
       0,   318,   319,   320,   321,   322,     0,   323,   324,   325,
     326,   327,   328,   329,   330,   331,     0,   332,   333,   334,
     335,   336,   337,   338,   339,   340,     0,   341,   342,     0,
     343,   344,   345,   346,   347,   348,   349,   350,   351,   352,
       0,   353,   354,   355,     0,   356,   357,   358,   359,     0,
     360,   361,     0,   362,   363,   364,   365,   366,   367,   368,
     369,   370,   371,     0,   372,   373,     0,   374,   375,   376,
     377,     0,   378,   379,     0,     0,   380,   381,   382,   383,
       0,   384,   385,   386,   387,   388,     0,     0,   389,   390,
     391,   392,     0,     0,   393,   394,   395,   396,   397,   398,
       0,   399,   400,     0,     0,   401,     0,   402,   403,   404,
     405,   406,     0,     0,     0,   407,   161,   162,   163,   164,
     165,   166,   167,   168,     0,   169,   170,     0,     0,     0,
       0,     0,     0,     0,     0,   171,   172,     0,   173,     0,
     174,   175,   176,     0,   177,     0,   178,   179,     0,   180,
     181,   182,   183,   184,     0,     0,   185,   186,   187,   188,
       0,   189,   190,   191,   192,   193,     0,     0,   194,   195,
     196,   197,   198,     0,   199,   200,   201,   202,     0,   203,
     204,   205,     0,   206,     0,     0,     0,     0,     0,   207,
     208,   209,   210,   211,   212,   213,   214,     0,   215,     0,
     216,   217,   218,   219,   220,     0,   221,     0,     0,   222,
     223,   224,   225,     0,   226,   227,   228,     0,   229,     0,
     230,   231,   232,   233,   234,   235,   236,     0,   237,   238,
     239,     0,   240,     0,   241,     0,     0,     0,   242,   243,
       0,   244,   245,     0,   246,     0,   247,   248,   249,   730,
       0,   251,   252,   253,     0,   254,   255,   256,   257,   258,
     259,     0,     0,   260,   261,   262,   263,   264,   265,   266,
       0,   267,     0,   268,     0,     0,   269,     0,   270,   271,
     272,   273,   274,     0,   275,     0,   276,     0,     0,   277,
     278,   279,     0,     0,   280,   281,   282,   283,   284,   285,
     286,   287,   288,   289,     0,     0,     0,   290,   291,     0,
     292,     0,   293,   294,   295,   296,   297,   298,   299,   300,
     301,     0,   302,   303,     0,   304,     0,   305,   306,   307,
     308,     0,     0,   309,     0,     0,     0,   310,   311,     0,
       0,   312,     0,     0,   313,   314,   315,   316,   317,     0,
     318,   319,   320,   321,   322,     0,   323,   324,   325,   326,
     327,   328,   329,   330,   331,     0,   332,   333,   334,   335,
     336,   337,   338,   339,   340,     0,   341,   342,     0,   343,
     344,   345,   346,   347,   348,   349,   350,   351,   352,     0,
     353,   354,   355,     0,   356,   357,   358,   359,     0,   360,
     361,     0,   362,   363,   364,   365,   366,   367,   368,   369,
     370,   371,     0,   372,   373,     0,   374,   375,   376,   377,
       0,   378,   379,     0,     0,   380,   381,   382,   383,     0,
     384,   385,   386,   387,   388,     0,     0,   389,   390,   391,
     392,     0,     0,   393,   394,   395,   396,   397,   398,     0,
     399,   400,     0,     0,   401,     0,   402,   403,   404,   405,
     406,     0,     0,     0,   407,   161,   162,   163,   164,   165,
     166,   167,   168,     0,   169,   170,     0,     0,     0,     0,
       0,     0,     0,     0,   171,   172,     0,   173,     0,   174,
     175,   176,     0,   177,     0,   178,   179,     0,   180,   181,
     182,   183,   184,     0,     0,   185,   186,   187,   188,     0,
     189,   190,   191,   192,   193,     0,     0,   194,   195,   196,
     197,   198,     0,   199,   200,   201,   202,     0,   203,   204,
     205,     0,   206,     0,     0,     0,     0,     0,   207,   208,
     209,   210,   211,   212,   213,   214,     0,   215,     0,   216,
     217,   218,   219,   220,     0,   221,     0,     0,   222,   223,
     224,   225,     0,   226,   227,   228,     0,   229,     0,   230,
     231,   232,   233,   234,   235,   236,     0,   237,   238,   239,
       0,   240,     0,   241,     0,     0,     0,   242,   243,     0,
     244,   245,     0,   246,     0,   247,   248,   249,   732,     0,
     251,   252,   253,     0,   254,   255,   256,   257,   258,   259,
       0,     0,   260,   261,   262,   263,   264,   265,   266,     0,
     267,     0,   268,     0,     0,   269,     0,   270,   271,   272,
     273,   274,     0,   275,     0,   276,     0,     0,   277,   278,
     279,     0,     0,   280,   281,   282,   283,   284,   285,   286,
     287,   288,   289,     0,     0,     0,   290,   291,     0,   292,
       0,   293,   294,   295,   296,   297,   298,   299,   300,   301,
       0,   302,   303,     0,   304,     0,   305,   306,   307,   308,
       0,     0,   309,     0,     0,     0,   310,   311,     0,     0,
     312,     0,     0,   313,   314,   315,   316,   317,     0,   318,
     319,   320,   321,   322,     0,   323,   324,   325,   326,   327,
     328,   329,   330,   331,     0,   332,   333,   334,   335,   336,
     337,   338,   339,   340,     0,   341,   342,     0,   343,   344,
     345,   346,   347,   348,   349,   350,   351,   352,     0,   353,
     354,   355,     0,   356,   357,   358,   359,     0,   360,   361,
       0,   362,   363,   364,   365,   366,   367,   368,   369,   370,
     371,     0,   372,   373,     0,   374,   375,   376,   377,     0,
     378,   379,     0,     0,   380,   381,   382,   383,     0,   384,
     385,   386,   387,   388,     0,     0,   389,   390,   391,   392,
       0,     0,   393,   394,   395,   396,   397,   398,     0,   399,
     400,     0,     0,   401,     0,   402,   403,   404,   405,   406,
       0,     0,     0,   407,   161,   162,   163,   164,   165,   166,
     167,   168,     0,   169,   170,     0,     0,     0,     0,     0,
       0,     0,     0,   171,   172,     0,   173,     0,   174,   175,
     176,     0,   177,     0,   178,   179,     0,   180,   181,   182,
     183,   184,     0,     0,   185,   186,   187,   188,     0,   189,
     190,   191,   192,   193,     0,     0,   194,   195,   196,   197,
     198,     0,   199,   200,   201,   202,     0,   203,   204,   205,
       0,   206,     0,     0,     0,     0,     0,   207,   208,   209,
     210,   211,   212,   213,   214,     0,   215,     0,   216,   217,
     218,   219,   220,     0,   221,     0,     0,   222,   223,   224,
     225,     0,   226,   227,   228,     0,   229,     0,   230,   231,
     232,   233,   234,   235,   236,     0,   237,   238,   239,     0,
     240,     0,   241,     0,     0,     0,   242,   243,     0,   244,
     245,     0,   246,     0,   247,   248,   249,   734,     0,   251,
     252,   253,     0,   254,   255,   256,   257,   258,   259,     0,
       0,   260,   261,   262,   263,   264,   265,   266,     0,   267,
       0,   268,     0,     0,   269,     0,   270,   271,   272,   273,
     274,     0,   275,     0,   276,     0,     0,   277,   278,   279,
       0,     0,   280,   281,   282,   283,   284,   285,   286,   287,
     288,   289,     0,     0,     0,   290,   291,     0,   292,     0,
     293,   294,   295,   296,   297,   298,   299,   300,   301,     0,
     302,   303,     0,   304,     0,   305,   306,   307,   308,     0,
       0,   309,     0,     0,     0,   310,   311,     0,     0,   312,
       0,     0,   313,   314,   315,   316,   317,     0,   318,   319,
     320,   321,   322,     0,   323,   324,   325,   326,   327,   328,
     329,   330,   331,     0,   332,   333,   334,   335,   336,   337,
     338,   339,   340,     0,   341,   342,     0,   343,   344,   345,
     346,   347,   348,   349,   350,   351,   352,     0,   353,   354,
     355,     0,   356,   357,   358,   359,     0,   360,   361,     0,
     362,   363,   364,   365,   366,   367,   368,   369,   370,   371,
       0,   372,   373,     0,   374,   375,   376,   377,     0,   378,
     379,     0,     0,   380,   381,   382,   383,     0,   384,   385,
     386,   387,   388,     0,     0,   389,   390,   391,   392,     0,
       0,   393,   394,   395,   396,   397,   398,     0,   399,   400,
       0,     0,   401,     0,   402,   403,   404,   405,   406,     0,
       0,     0,   407,   161,   162,   163,   164,   165,   166,   167,
     168,     0,   169,   170,     0,     0,     0,     0,     0,     0,
       0,     0,   171,   172,     0,   173,     0,   174,   175,   176,
       0,   177,     0,   178,   179,     0,   180,   181,   182,   183,
     184,     0,     0,   185,   186,   187,   188,     0,   189,   190,
     191,   192,   193,     0,     0,   194,   195,   196,   197,   198,
       0,   199,   200,   201,   202,     0,   203,   204,   205,     0,
     206,     0,     0,     0,     0,     0,   207,   208,   209,   210,
     211,   212,   213,   214,     0,   215,     0,   216,   217,   218,
     219,   220,     0,   221,     0,     0,   222,   223,   224,   225,
       0,   226,   227,   228,     0,   229,     0,   230,   231,   232,
     233,   234,   235,   236,     0,   237,   238,   239,     0,   240,
       0,   241,     0,     0,     0,   242,   243,     0,   244,   245,
       0,   246,     0,   247,   248,   249,   737,     0,   251,   252,
     253,     0,   254,   255,   256,   257,   258,   259,     0,     0,
     260,   261,   262,   263,   264,   265,   266,     0,   267,     0,
     268,     0,     0,   269,     0,   270,   271,   272,   273,   274,
       0,   275,     0,   276,     0,     0,   277,   278,   279,     0,
       0,   280,   281,   282,   283,   284,   285,   286,   287,   288,
     289,     0,     0,     0,   290,   291,     0,   292,     0,   293,
     294,   295,   296,   297,   298,   299,   300,   301,     0,   302,
     303,     0,   304,     0,   305,   306,   307,   308,     0,     0,
     309,     0,     0,     0,   310,   311,     0,     0,   312,     0,
       0,   313,   314,   315,   316,   317,     0,   318,   319,   320,
     321,   322,     0,   323,   324,   325,   326,   327,   328,   329,
     330,   331,     0,   332,   333,   334,   335,   336,   337,   338,
     339,   340,     0,   341,   342,     0,   343,   344,   345,   346,
     347,   348,   349,   350,   351,   352,     0,   353,   354,   355,
       0,   356,   357,   358,   359,     0,   360,   361,     0,   362,
     363,   364,   365,   366,   367,   368,   369,   370,   371,     0,
     372,   373,     0,   374,   375,   376,   377,     0,   378,   379,
       0,     0,   380,   381,   382,   383,     0,   384,   385,   386,
     387,   388,     0,     0,   389,   390,   391,   392,     0,     0,
     393,   394,   395,   396,   397,   398,     0,   399,   400,     0,
       0,   401,     0,   402,   403,   404,   405,   406,     0,     0,
       0,   407,   161,   162,   163,   164,   165,   166,   167,   168,
       0,   169,   170,     0,     0,     0,     0,     0,     0,     0,
       0,   171,   172,     0,   173,     0,   174,   175,   176,     0,
     177,     0,   178,   179,     0,   180,   181,   182,   183,   184,
       0,     0,   185,   186,   187,   188,     0,   189,   190,   191,
     192,   193,     0,     0,   194,   195,   196,   197,   198,     0,
     199,   200,   201,   202,     0,   203,   204,   205,     0,   206,
       0,     0,     0,     0,     0,   207,   208,   209,   210,   211,
     212,   213,   214,     0,   215,     0,   216,   217,   218,   219,
     220,     0,   221,     0,     0,   222,   223,   224,   225,     0,
     226,   227,   228,     0,   229,     0,   230,   231,   232,   233,
     234,   235,   236,     0,   237,   238,   239,     0,   240,     0,
     241,     0,     0,     0,   242,   243,     0,   244,   245,     0,
     246,     0,   247,   248,   249,   250,     0,   251,   252,   253,
       0,   254,   255,   256,   257,   258,   259,     0,     0,   260,
     261,   262,   263,   264,   265,   266,     0,   267,     0,   268,
       0,     0,   269,     0,   270,   271,   272,   273,   274,     0,
     275,     0,   276,     0,     0,   277,   278,   279,     0,     0,
     280,   281,   282,   283,   284,   285,   286,   287,   288,   289,
       0,     0,     0,   545,   291,     0,   292,     0,   293,   294,
     295,   296,   297,   298,   299,   300,   301,     0,   302,   303,
       0,   304,     0,   305,   306,   307,   308,     0,     0,   309,
       0,     0,     0,   310,   311,     0,     0,   312,     0,     0,
     313,   314,   315,   316,   317,     0,   318,   319,   320,   321,
     322,     0,   323,   324,   325,   326,   327,   328,   329,   330,
     331,     0,   332,   333,   334,   335,   336,   337,   338,   339,
     340,     0,   341,   342,     0,   546,   344,   345,   346,   347,
     348,   349,   350,   351,   352,     0,   353,   354,   874,     0,
     356,   357,   358,   359,     0,   360,   361,     0,   362,   363,
     364,   365,   366,   367,   368,   369,   370,   371,     0,   372,
     373,     0,   374,   375,   376,   377,     0,   548,   379,     0,
       0,   549,   381,   382,   383,     0,   384,   385,   386,   387,
     388,     0,     0,   389,   390,   391,   392,     0,     0,   393,
     394,   395,   396,   397,   398,     0,   399,   400,     0,     0,
     401,     0,   402,   403,   404,   405,   406,     0,     0,     0,
     407,   161,   162,   163,   164,   165,   166,   167,   168,     0,
     169,   170,     0,     0,     0,     0,     0,     0,   896,     0,
     171,   172,     0,   173,     0,   174,   175,   176,     0,   177,
       0,   178,   179,     0,   180,   181,   182,   183,   184,     0,
       0,   185,   186,   187,   188,     0,   189,   190,   191,   192,
     193,     0,     0,   194,   195,   196,   197,   198,     0,   199,
     200,   201,   202,     0,   203,   204,   205,     0,   206,     0,
       0,     0,     0,     0,   207,   208,   209,   210,   211,   212,
     213,   214,     0,   215,     0,   216,   217,   218,   219,   220,
       0,   221,     0,     0,   222,   223,   224,   225,     0,   226,
     227,   228,     0,   229,     0,   230,   231,   232,   233,   234,
     235,   236,     0,   237,   238,   239,     0,   240,     0,   241,
       0,     0,     0,   242,   243,     0,   244,   245,     0,   246,
       0,   247,   248,   249,   250,     0,   251,   252,   253,     0,
     254,   255,   256,   257,   258,   259,     0,     0,   260,   261,
     262,   263,   264,   265,   266,     0,   267,     0,   268,     0,
       0,   269,     0,   270,   271,   272,   273,   274,     0,   275,
       0,   276,     0,     0,   277,   278,   279,     0,     0,   280,
     281,   282,   283,   284,   285,   286,   287,   288,   289,     0,
       0,     0,   290,   291,     0,   292,     0,   293,   294,   295,
     296,   297,   298,   299,   300,   301,     0,   302,   303,     0,
     304,     0,   305,   306,   307,   308,     0,     0,   309,     0,
       0,     0,   310,   311,     0,     0,   312,     0,     0,   313,
     314,   315,   316,   317,     0,   318,   319,   320,   321,   322,
       0,   323,   324,   325,   326,   327,   328,   329,   330,   331,
       0,   332,   333,   334,   335,   336,   337,   338,   339,   340,
       0,   341,   342,     0,   343,   344,   345,   346,   347,   348,
     349,   350,   351,   352,     0,   353,   354,   355,     0,     0,
     357,   358,   359,     0,   360,   361,     0,   362,   363,   364,
     365,   366,   367,   368,   369,   370,   371,     0,   372,   373,
       0,   374,   375,   376,   377,     0,   378,   379,     0,     0,
     380,   381,   382,   383,     0,   384,   385,   386,   387,   388,
       0,     0,   389,   390,   391,   392,     0,     0,   393,   394,
     395,   396,   397,   398,     0,   399,   400,     0,     0,   401,
       0,   402,   403,   404,   405,   406,     0,     0,     0,   407,
     161,   162,   163,   164,   165,   166,   167,   168,     0,   169,
     170,     0,     0,     0,     0,     0,     0,     0,     0,   171,
     172,     0,   173,     0,   174,   175,   176,     0,   177,     0,
     178,   179,     0,   180,   181,   182,   183,   184,     0,     0,
     185,   186,   187,   188,     0,   189,   190,   191,   192,   193,
       0,     0,   194,   195,   196,  1169,   198,     0,   199,   200,
     201,   202,     0,   203,   204,   205,     0,   206,     0,     0,
       0,     0,     0,   207,   208,   209,   210,   211,   212,   213,
     214,     0,   215,     0,   216,   217,   218,   219,   220,     0,
     221,     0,     0,   222,   223,   224,   225,     0,   226,   227,
     228,     0,   229,     0,   230,   231,   232,   233,   234,   235,
     236,     0,   237,   238,   239,     0,   240,     0,   241,     0,
       0,     0,   242,   243,     0,   244,   245,     0,   246,     0,
     247,   248,   249,   250,     0,   251,   252,   253,     0,   254,
     255,   256,   257,   258,   259,     0,     0,   260,   261,   262,
     263,   264,   265,   266,     0,   267,     0,   268,     0,     0,
     269,     0,   270,   271,   272,   273,   274,     0,   275,     0,
     276,     0,     0,   277,   278,   279,     0,     0,   280,   281,
     282,   283,   284,   285,   286,   287,   288,   289,     0,     0,
       0,   290,   291,     0,   292,     0,   293,   294,   295,   296,
     297,   298,   299,   300,   301,     0,   302,   303,     0,   304,
       0,   305,   306,   307,   308,     0,     0,   309,     0,     0,
       0,   310,   311,     0,     0,   312,     0,     0,   313,   314,
     315,   316,   317,     0,   318,   319,   320,   321,   322,     0,
     323,   324,   325,   326,   327,   328,   329,   330,   331,     0,
     332,   333,   334,   335,   336,   337,   338,   339,   340,     0,
     341,   342,     0,   343,   344,   345,   346,   347,   348,   349,
     350,   351,   352,     0,   353,   354,   355,     0,   356,   357,
     358,   359,     0,   360,   361,     0,   362,   363,   364,   365,
     366,   367,   368,   369,   370,   371,     0,   372,   373,     0,
     374,   375,   376,   377,     0,   378,   379,     0,     0,   380,
     381,   382,   383,     0,   384,   385,   386,   387,   388,     0,
       0,   389,   390,   391,   392,     0,     0,   393,   394,   395,
     396,   397,   398,     0,   399,   400,     0,     0,   401,     0,
     402,   403,   404,   405,   406,     0,     0,     0,   407,   161,
     162,   163,   164,   165,   166,   167,   168,     0,   169,   170,
       0,     0,     0,     0,     0,     0,     0,     0,   171,   172,
       0,   173,     0,   174,   175,   176,     0,   177,     0,   178,
     179,     0,   180,   181,   182,   183,   184,     0,     0,   185,
     186,   187,   188,     0,   189,   190,   191,   192,   193,     0,
       0,   194,   195,   196,   197,   198,     0,   199,   200,   201,
     202,     0,   203,   204,   205,     0,   206,     0,     0,     0,
       0,     0,   207,   208,   209,   210,   211,   212,   213,   214,
       0,   215,     0,   216,   217,   218,   219,   220,     0,   221,
       0,     0,   222,   223,   224,   225,     0,   226,   227,   228,
       0,   229,     0,   230,   231,   232,   233,   234,   235,   236,
       0,   237,   238,   239,     0,   240,     0,   241,     0,     0,
       0,   242,   243,     0,   244,   245,     0,   246,     0,   247,
     248,   249,  1193,     0,   251,   252,   253,     0,   254,   255,
     256,   257,   258,   259,     0,     0,   260,   261,   262,   263,
     264,   265,   266,     0,   267,     0,   268,     0,     0,   269,
       0,   270,   271,   272,   273,   274,     0,   275,     0,   276,
       0,     0,   277,   278,   279,     0,     0,   280,   281,   282,
     283,   284,   285,   286,   287,   288,   289,     0,     0,     0,
     290,   291,     0,   292,     0,   293,   294,   295,   296,   297,
     298,   299,   300,   301,     0,   302,   303,     0,   304,     0,
     305,   306,   307,   308,     0,     0,   309,     0,     0,     0,
     310,   311,     0,     0,   312,     0,     0,   313,   314,   315,
     316,   317,     0,   318,   319,   320,   321,   322,     0,   323,
     324,   325,   326,   327,   328,   329,   330,   331,     0,   332,
     333,   334,   335,   336,   337,   338,   339,   340,     0,   341,
     342,     0,   343,   344,   345,   346,   347,   348,   349,   350,
     351,   352,     0,   353,   354,   355,     0,   356,   357,   358,
     359,     0,   360,   361,     0,   362,   363,   364,   365,   366,
     367,   368,   369,   370,   371,     0,   372,   373,     0,   374,
     375,   376,   377,     0,   378,   379,     0,     0,   380,   381,
     382,   383,     0,   384,   385,   386,   387,   388,     0,     0,
     389,   390,   391,   392,     0,     0,   393,   394,   395,   396,
     397,   398,     0,   399,   400,     0,     0,   401,     0,   402,
     403,   404,   405,   406,     0,     0,     0,   407,   161,   162,
     163,   164,   165,   166,   167,   168,     0,   169,   170,     0,
       0,     0,     0,     0,     0,     0,     0,   171,   172,     0,
     173,     0,   174,   175,   176,     0,   177,     0,   178,   179,
       0,   180,   181,   182,   183,   184,     0,     0,   185,   186,
     187,   188,     0,   189,   190,   191,   192,   193,     0,     0,
     194,   195,   196,   197,   198,     0,   199,   200,   201,   202,
       0,   203,   204,   205,     0,   206,     0,     0,     0,     0,
       0,   207,   208,   209,   210,   211,   212,   213,   214,     0,
     215,     0,   216,   217,   218,   219,   220,     0,   221,     0,
       0,   222,   223,   224,   225,     0,   226,   227,   228,     0,
     229,     0,   230,   231,   232,   233,   234,   235,   236,     0,
     237,   238,   239,     0,   240,     0,   241,     0,     0,     0,
     242,   243,     0,   244,   245,     0,   246,     0,   247,   248,
     249,   250,     0,   251,   252,   253,     0,   254,   255,   256,
     257,   258,   259,     0,     0,   260,   261,   262,   263,   264,
     265,   266,     0,   267,     0,   268,     0,     0,   269,     0,
     270,   271,   272,   273,   274,     0,   275,     0,   276,     0,
       0,   277,   278,   279,     0,     0,   280,   281,   282,   283,
     284,   285,   286,   287,   288,   289,     0,     0,     0,   290,
     291,     0,   292,     0,   293,   294,   295,   296,   297,   298,
     299,   300,   301,     0,   302,   303,     0,   304,     0,   305,
     306,   307,   308,     0,     0,   309,     0,     0,     0,   310,
     311,     0,     0,   312,     0,     0,   313,   314,   315,   316,
     317,     0,   318,   319,   320,   321,   322,     0,   323,   324,
     325,   326,   327,   328,   329,   330,   331,     0,   332,   333,
     334,   335,   336,   337,   338,   339,   340,     0,   341,   342,
       0,   343,   344,   345,   346,   347,  1254,   349,   350,   351,
     352,     0,   353,   354,   355,     0,   356,   357,   358,   359,
       0,   360,   361,     0,   362,   363,   364,   365,   366,   367,
     368,   369,   370,   371,     0,   372,   373,     0,   374,   375,
     376,   377,     0,   378,   379,     0,     0,   380,   381,   382,
     383,     0,   384,   385,   386,   387,   388,     0,     0,   389,
     390,   391,   392,     0,     0,   393,   394,   395,   396,   397,
     398,     0,   399,   400,     0,     0,   401,     0,   402,   403,
     404,   405,   406,     0,     0,     0,   407,   161,   162,   163,
     164,   165,   166,   167,   168,     0,   169,   170,     0,     0,
       0,     0,     0,     0,     0,     0,   171,   172,     0,   173,
       0,   174,   175,   176,     0,  1109,     0,  1110,  1111,     0,
     180,   181,   182,   183,   184,     0,     0,   185,  1112,  1113,
     188,     0,   189,   190,   191,   192,     0,     0,     0,   194,
     195,   196,   197,   198,     0,   199,   200,     0,   202,     0,
     203,   204,   205,     0,   206,     0,     0,     0,     0,     0,
     207,   208,   209,   210,   211,  1114,  1115,   214,     0,   215,
       0,   216,   217,   218,   219,   220,     0,   221,     0,     0,
     222,   797,   224,   225,     0,   226,   227,   228,     0,   229,
       0,   230,   231,   232,     0,   234,   235,     0,     0,   237,
     238,  1116,     0,   240,     0,   241,     0,     0,     0,   242,
     243,     0,   244,     0,     0,   246,     0,   247,   248,   249,
     250,     0,   251,   252,   253,  1457,   254,   255,   256,   257,
     258,   259,     0,     0,  1458,   261,   262,   263,   264,  1117,
    1118,     0,  1119,     0,   268,     0,     0,   269,     0,   270,
     271,   272,   273,   274,     0,     0,     0,   276,     0,     0,
     277,   278,   279,     0,     0,   280,   281,   282,   283,   284,
     285,   286,   287,   288,   289,     0,     0,     0,   290,  1120,
       0,  1121,     0,   293,   294,   295,   296,   297,   298,   299,
       0,   301,     0,   302,   303,     0,   304,     0,     0,  1122,
     307,   308,     0,     0,   309,     0,     0,     0,   310,   311,
       0,     0,  1459,     0,     0,     0,   314,   315,   316,   317,
       0,     0,     0,   320,   321,   322,     0,   323,   324,   325,
     326,   327,   328,  1123,   330,   331,     0,   332,   333,   334,
     335,   336,   337,   338,   339,   340,     0,   341,   342,     0,
     343,   344,     0,   346,   347,   348,   349,   350,   351,   352,
       0,   353,   354,   355,     0,   356,  1460,   358,   359,     0,
     360,  1125,     0,   362,   363,   364,   365,   366,   367,   368,
     369,     0,   371,     0,   372,   373,     0,   374,   375,   376,
     377,     0,  1126,  1127,     0,     0,   380,     0,   382,     0,
       0,   384,   385,   386,   387,   388,     0,     0,   389,   390,
     391,   392,     0,     0,   393,   394,   395,     0,  1128,   398,
       0,   399,   400,     0,     0,   401,     0,   402,   403,   404,
     405,   406,     0,     0,     0,  1129,   161,   162,   163,   164,
     165,   166,   167,   168,     0,   169,   170,     0,     0,     0,
       0,     0,     0,     0,     0,   171,   172,     0,   173,     0,
     174,   175,   176,     0,  1109,     0,  1110,  1111,     0,   180,
     181,   182,   183,   184,     0,     0,   185,  1112,  1113,   188,
       0,   189,   190,   191,   192,     0,     0,     0,   194,   195,
     196,   197,   198,     0,   199,   200,     0,   202,     0,   203,
     204,   205,     0,   206,     0,     0,     0,     0,     0,   207,
     208,   209,   210,   211,  1114,  1115,   214,     0,   215,     0,
     216,   217,   218,   219,   220,     0,   221,     0,     0,   222,
     797,   224,   225,     0,   226,   227,   228,     0,   229,     0,
     230,   231,   232,     0,   234,   235,     0,     0,   237,   238,
    1116,     0,   240,     0,   241,     0,     0,     0,   242,   243,
       0,   244,     0,     0,   246,     0,   247,   248,   249,   250,
       0,   251,   252,   253,     0,   254,   255,   256,   257,   258,
     259,     0,     0,     0,   261,   262,   263,   264,  1117,  1118,
       0,  1119,     0,   268,     0,     0,   269,     0,   270,   271,
     272,   273,   274,     0,     0,     0,   276,     0,     0,   277,
     278,   279,     0,     0,   280,   281,   282,   283,   284,   285,
     286,   287,   288,   289,     0,     0,     0,   290,  1120,     0,
    1121,     0,   293,   294,   295,   296,   297,   298,   299,  1485,
     301,     0,   302,   303,     0,   304,     0,     0,  1122,   307,
     308,     0,     0,   309,     0,     0,     0,   310,   311,     0,
       0,     0,     0,     0,     0,   314,   315,   316,   317,     0,
       0,     0,   320,   321,   322,     0,   323,   324,   325,   326,
     327,   328,  1123,   330,   331,     0,   332,   333,   334,   335,
     336,   337,   338,   339,   340,     0,   341,   342,     0,   343,
     344,     0,   346,   347,   348,   349,   350,   351,   352,     0,
     353,   354,   355,     0,   356,  1124,   358,   359,     0,   360,
    1125,     0,   362,   363,   364,   365,   366,   367,   368,   369,
       0,   371,     0,   372,   373,     0,   374,   375,   376,   377,
       0,  1126,  1127,     0,     0,   380,     0,   382,     0,     0,
     384,   385,   386,   387,   388,     0,     0,   389,   390,   391,
     392,     0,     0,   393,   394,   395,     0,  1128,   398,     0,
     399,   400,     0,     0,   401,     0,   402,   403,   404,   405,
     406,     0,     0,     0,  1129,   161,   162,   163,   164,   165,
     166,   167,   168,     0,   169,   170,     0,     0,     0,     0,
       0,     0,     0,     0,   171,   172,     0,   173,     0,   174,
     175,   176,     0,  1109,     0,  1110,  1111,     0,   180,   181,
     182,   183,   184,     0,     0,   185,  1112,  1113,   188,     0,
     189,   190,   191,   192,     0,     0,     0,   194,   195,   196,
     197,   198,     0,   199,   200,     0,   202,     0,   203,   204,
     205,     0,   206,     0,     0,     0,     0,     0,   207,   208,
     209,   210,   211,  1114,  1115,   214,     0,   215,     0,   216,
     217,   218,   219,   220,     0,   221,     0,     0,   222,   797,
     224,   225,     0,   226,   227,   228,     0,   229,     0,   230,
     231,   232,     0,   234,   235,     0,     0,   237,   238,  1116,
       0,   240,     0,   241,     0,     0,     0,   242,   243,     0,
     244,     0,     0,   246,     0,   247,   248,   249,   250,     0,
     251,   252,   253,     0,   254,   255,   256,   257,   258,   259,
       0,     0,     0,   261,   262,   263,   264,  1117,  1118,     0,
    1119,     0,   268,     0,     0,   269,     0,   270,   271,   272,
     273,   274,     0,     0,     0,   276,     0,     0,   277,   278,
     279,     0,     0,   280,   281,   282,   283,   284,   285,   286,
     287,   288,   289,     0,     0,     0,   290,  1120,     0,  1121,
       0,   293,   294,   295,   296,   297,   298,   299,  2273,   301,
       0,   302,   303,     0,   304,     0,     0,  1122,   307,   308,
       0,     0,   309,     0,     0,     0,   310,   311,     0,     0,
       0,     0,     0,     0,   314,   315,   316,   317,     0,     0,
       0,   320,   321,   322,     0,   323,   324,   325,   326,   327,
     328,  1123,   330,   331,     0,   332,   333,   334,   335,   336,
     337,   338,   339,   340,     0,   341,   342,     0,   343,   344,
       0,   346,   347,   348,   349,   350,   351,   352,     0,   353,
     354,   355,     0,   356,  1124,   358,   359,     0,   360,  1125,
       0,   362,   363,   364,   365,   366,   367,   368,   369,     0,
     371,     0,   372,   373,     0,   374,   375,   376,   377,     0,
    1126,  1127,     0,     0,   380,     0,   382,     0,     0,   384,
     385,   386,   387,   388,     0,     0,   389,   390,   391,   392,
       0,     0,   393,   394,   395,     0,  1128,   398,     0,   399,
     400,     0,     0,   401,     0,   402,   403,   404,   405,   406,
       0,     0,     0,  1129,   161,   162,   163,   164,   165,   166,
     167,   168,     0,   169,   170,     0,     0,     0,     0,     0,
       0,     0,     0,   171,   172,     0,   173,     0,   174,   175,
     176,     0,  1109,     0,  1110,  1111,     0,   180,   181,   182,
     183,   184,     0,     0,   185,  1112,  1113,   188,     0,   189,
     190,   191,   192,     0,     0,     0,   194,   195,   196,   197,
     198,     0,   199,   200,     0,   202,     0,   203,   204,   205,
       0,   206,     0,     0,     0,     0,     0,   207,   208,   209,
     210,   211,  1114,  1115,   214,     0,   215,     0,   216,   217,
     218,   219,   220,     0,   221,     0,     0,   222,   797,   224,
     225,     0,   226,   227,   228,     0,   229,     0,   230,   231,
     232,     0,   234,   235,     0,     0,   237,   238,  1116,     0,
     240,     0,   241,     0,     0,     0,   242,   243,     0,   244,
       0,     0,   246,     0,   247,   248,   249,   250,     0,   251,
     252,   253,     0,   254,   255,   256,   257,   258,   259,     0,
       0,     0,   261,   262,   263,   264,  1117,  1118,     0,  1119,
       0,   268,     0,     0,   269,     0,   270,   271,   272,   273,
     274,     0,     0,     0,   276,     0,     0,   277,   278,   279,
       0,     0,   280,   281,   282,   283,   284,   285,   286,   287,
     288,   289,     0,     0,     0,   290,  1120,     0,  1121,     0,
     293,   294,   295,   296,   297,   298,   299,     0,   301,     0,
     302,   303,     0,   304,  1451,     0,  1122,   307,   308,     0,
       0,   309,     0,     0,     0,   310,   311,     0,     0,     0,
       0,     0,     0,   314,   315,   316,   317,     0,     0,     0,
     320,   321,   322,     0,   323,   324,   325,   326,   327,   328,
    1123,   330,   331,     0,   332,   333,   334,   335,   336,   337,
     338,   339,   340,     0,   341,   342,     0,   343,   344,     0,
     346,   347,   348,   349,   350,   351,   352,     0,   353,   354,
     355,     0,   356,  1460,   358,   359,     0,   360,  1125,     0,
     362,   363,   364,   365,   366,   367,   368,   369,     0,   371,
       0,   372,   373,     0,   374,   375,   376,   377,     0,  1126,
    1127,     0,     0,   380,     0,   382,     0,     0,   384,   385,
     386,   387,   388,     0,     0,   389,   390,   391,   392,     0,
       0,   393,   394,   395,     0,  1128,   398,     0,   399,   400,
       0,     0,   401,     0,   402,   403,   404,   405,   406,     0,
       0,     0,  1129,   161,   162,   163,   164,   165,   166,   167,
     168,     0,   169,   170,     0,     0,     0,     0,     0,     0,
       0,     0,   171,   172,     0,   173,     0,   174,   175,   176,
       0,  1109,     0,  1110,  1111,     0,   180,   181,   182,   183,
     184,     0,     0,   185,  1112,  1113,   188,     0,   189,   190,
     191,   192,     0,     0,     0,   194,   195,   196,   197,   198,
       0,   199,   200,     0,   202,     0,   203,   204,   205,     0,
     206,     0,     0,     0,     0,     0,   207,   208,   209,   210,
     211,  1114,  1115,   214,     0,   215,     0,   216,   217,   218,
     219,   220,     0,   221,     0,     0,   222,   797,   224,   225,
       0,   226,   227,   228,     0,   229,     0,   230,   231,   232,
       0,   234,   235,     0,     0,   237,   238,  1116,     0,   240,
       0,   241,     0,     0,     0,   242,   243,     0,   244,     0,
       0,   246,     0,   247,   248,   249,   250,     0,   251,   252,
     253,     0,   254,   255,   256,   257,   258,   259,     0,     0,
       0,   261,   262,   263,   264,  1117,  1118,     0,  1119,     0,
     268,     0,     0,   269,     0,   270,   271,   272,   273,   274,
       0,     0,     0,   276,     0,     0,   277,   278,   279,     0,
       0,   280,   281,   282,   283,   284,   285,   286,   287,   288,
     289,     0,     0,     0,   290,  1120,     0,  1121,     0,   293,
     294,   295,   296,   297,   298,   299,     0,   301,     0,   302,
     303,     0,   304,     0,     0,  1122,   307,   308,     0,     0,
     309,     0,     0,     0,   310,   311,     0,     0,     0,     0,
       0,     0,   314,   315,   316,   317,     0,     0,     0,   320,
     321,   322,     0,   323,   324,   325,   326,   327,   328,  1123,
     330,   331,     0,   332,   333,   334,   335,   336,   337,   338,
     339,   340,     0,   341,   342,     0,   343,   344,     0,   346,
     347,   348,   349,   350,   351,   352,     0,   353,   354,   355,
       0,   356,  1124,   358,   359,     0,   360,  1125,     0,   362,
     363,   364,   365,   366,   367,   368,   369,     0,   371,     0,
     372,   373,     0,   374,   375,   376,   377,     0,  1126,  1127,
       0,     0,   380,     0,   382,     0,     0,   384,   385,   386,
     387,   388,     0,     0,   389,   390,   391,   392,     0,     0,
     393,   394,   395,     0,  1128,   398,     0,   399,   400,     0,
       0,   401,     0,   402,   403,   404,   405,   406,     0,     0,
       0,  1129,   161,   162,   163,   164,   165,   166,   167,   168,
       0,   169,   170,     0,     0,     0,     0,     0,     0,     0,
       0,   171,   172,     0,   173,     0,   174,   175,   176,     0,
    1109,     0,  1110,  1111,     0,   180,   181,   182,   183,   184,
       0,     0,   185,  1112,  1113,   188,     0,   189,   190,   191,
     192,     0,     0,     0,   194,   195,   196,   197,   198,     0,
     199,   200,     0,   202,     0,   203,   204,   205,     0,   206,
       0,     0,     0,     0,     0,   207,   208,   209,   210,   211,
    1114,  1115,   214,     0,   215,     0,   216,   217,   218,   219,
     220,     0,   221,     0,     0,   222,   797,   224,   225,     0,
     226,   227,   228,     0,   229,     0,   230,   231,   232,     0,
     234,   235,     0,     0,   237,   238,  1116,     0,   240,     0,
     241,     0,     0,     0,   242,   243,     0,   244,     0,     0,
     246,     0,   247,   248,   249,   250,     0,   251,   252,   253,
       0,   254,   255,   256,   257,   258,   259,     0,     0,     0,
     261,   262,   263,   264,  1117,  1118,     0,  1119,     0,   268,
       0,     0,   269,     0,   270,   271,   272,   273,   274,     0,
       0,     0,   276,     0,     0,   277,   278,   279,     0,     0,
     280,   281,   282,   283,   284,   285,   286,   287,   288,   289,
       0,     0,     0,   290,  1120,     0,  1121,     0,   293,   294,
     295,   296,   297,   298,   299,     0,   301,     0,   302,   303,
       0,   304,     0,     0,  1122,   307,   308,     0,     0,   309,
       0,     0,     0,   310,   311,     0,     0,     0,     0,     0,
       0,   314,   315,   316,   317,     0,     0,     0,   320,   321,
     322,     0,   323,   324,   325,   326,   327,   328,  1123,   330,
     331,     0,   332,   333,   334,   335,   336,   337,   338,   339,
     340,     0,   341,   342,     0,   343,   344,     0,   346,   347,
     348,   349,   350,   351,   352,     0,   353,   354,   355,     0,
     356,  1460,   358,   359,     0,   360,  1125,     0,   362,   363,
     364,   365,   366,   367,   368,   369,     0,   371,     0,   372,
     373,     0,   374,   375,   376,   377,     0,  1126,  1127,     0,
       0,   380,     0,   382,     0,     0,   384,   385,   386,   387,
     388,     0,     0,   389,   390,   391,   392,     0,     0,   393,
     394,   395,     0,  1128,   398,     0,   399,   400,     0,     0,
     401,     0,   402,   403,   404,   405,   406,     0,     0,     0,
    1129,   161,   162,   163,   164,   165,   166,   167,   168,     0,
     169,   170,     0,     0,     0,     0,     0,     0,     0,     0,
     171,   172,     0,   173,     0,   174,   175,   176,     0,  1109,
       0,  1110,  1111,     0,   180,   181,   182,   183,   184,     0,
       0,   185,  1112,  1113,   188,     0,   189,   190,   191,   192,
       0,     0,     0,   194,   195,   196,   197,   198,     0,   199,
     200,     0,   202,     0,   203,   204,   205,     0,   206,     0,
       0,     0,     0,     0,   207,   208,   209,   210,   211,  1114,
    1115,   214,     0,   215,     0,   216,   217,   218,   219,   220,
       0,   221,     0,     0,   222,   797,   224,   225,     0,   226,
     227,   228,     0,   229,     0,   230,   231,   232,     0,   234,
     235,     0,     0,   237,   238,  1116,     0,   240,     0,   241,
       0,     0,     0,   242,   243,     0,   244,     0,     0,   246,
       0,   247,   248,   249,   250,     0,   251,   252,   253,     0,
     254,   255,   256,   257,   258,   259,     0,     0,     0,   261,
     262,   263,   264,  1117,  1118,     0,  1119,     0,   268,     0,
       0,   269,     0,   270,   271,   272,   273,   274,     0,     0,
       0,   276,     0,     0,   277,   278,   279,     0,     0,   280,
     281,   282,   283,   284,   285,   286,   287,   288,   289,     0,
       0,     0,   290,  1120,     0,  1121,     0,   293,   294,   295,
     296,   297,   298,   299,     0,   301,     0,   302,   303,     0,
     304,     0,     0,  1122,   307,   308,     0,     0,   309,     0,
       0,     0,   310,   311,     0,     0,     0,     0,     0,     0,
     314,   315,   316,   317,     0,     0,     0,   320,   321,   322,
       0,   323,   324,   325,   326,   327,   328,  1123,   330,   331,
       0,   332,   333,   334,   335,   336,   337,   338,   339,   340,
       0,   341,   342,     0,   343,   344,     0,   346,   347,   348,
     349,   350,   351,   352,     0,   353,   354,   355,     0,   356,
       0,   358,   359,     0,   360,  1125,     0,   362,   363,   364,
     365,   366,   367,   368,   369,     0,   371,     0,   372,   373,
       0,   374,   375,   376,   377,     0,  1126,  1127,   425,     0,
     380,     0,   382,     0,     0,   384,   385,   386,   387,   388,
     426,     0,   389,   390,   391,   392,     0,     0,   393,   394,
     395,     0,  1128,   398,     0,   399,   400,     0,     0,   401,
     427,   402,   403,   404,   405,   406,     0,     0,     0,  1129,
       0,     0,     0,     0,     0,     0,     0,     0,   428,     0,
    -476,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,   429,     0,     0,     0,
       0,     0,   430,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,   431,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,  -600,   432,     0,     0,     0,   433,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,  -586,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,  -387,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,   434,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,   435,     0,   436,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,  -387,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,   437,     0,     0,     0,  -600,     0,
     438,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,   439,   440,     0,   441,     0,     0,     0,     0,     0,
       0,     0,   442,     0,     0,     0,   443,   444,     0,     0,
       0,   445,     0,     0,     0,     0,   446
};

static const yytype_int16 yycheck[] =
{
       0,    20,   435,  1222,   718,   581,    45,    26,   513,   143,
      40,    11,  1196,   147,  1166,   646,   690,     0,   151,    12,
     144,   740,   146,   697,   649,   775,   824,  1316,   651,   546,
     549,    21,   465,   603,   158,  1142,     0,     0,   543,    33,
     634,     0,   429,    33,    42,    45,  1636,  1691,   642,  1816,
     952,  1179,  1616,   558,   678,     7,     8,  1257,   885,  1150,
     617,    13,    14,  1155,  1831,  1155,    18,  1665,    20,    21,
    1155,  1866,  1387,   460,    26,  1626,    28,  1155,  1155,    31,
      32,    33,  1155,    35,  2049,    37,    38,   711,   682,   649,
    1621,  1622,   686,  2023,   704,   929,  1465,  1466,   692,  1396,
     483,     0,  2365,    20,   698,    25,     0,  1393,    39,    39,
      45,    32,    19,   148,   613,  2500,   796,   152,   786,   787,
       0,     0,   841,   463,   159,     0,   544,     0,   468,   547,
       0,  2172,  1547,    84,     5,    45,   476,    39,    11,   123,
      25,    38,   810,    11,  1124,    45,    11,    84,    11,    17,
      54,   149,    17,    39,    17,    24,   154,   155,    24,  2421,
     128,  2423,  2007,  2008,  2009,  2010,   109,    89,     7,    84,
      98,    30,    39,   123,   123,   100,     0,  2735,    60,    39,
    2612,   219,     7,   217,   123,   159,   217,    11,   124,    84,
      84,   220,   144,   145,   146,    12,   148,    86,   150,   151,
     152,   153,    84,   141,   156,   157,   158,   159,    69,   241,
       8,    51,   213,    57,    11,   112,   125,    94,   241,   736,
      84,   135,   996,   268,   353,    23,   251,  1318,  2660,    27,
     663,   153,    61,   213,  2704,   310,    89,   108,   161,  1269,
    1270,  1271,   139,    41,    42,    98,    19,  1277,   303,   293,
     294,  1281,  1282,   208,   159,   886,    85,  1292,  1288,    98,
    2774,    65,    88,   124,   312,  1092,   223,  1297,  2531,  1299,
    2740,   107,   186,    98,   130,   186,   222,    25,   137,   738,
     312,   371,   141,  1313,   359,  1315,   960,   377,   149,   312,
    2675,   425,   247,    89,   864,    25,   344,    94,   234,   222,
     375,   924,   435,   164,   929,    91,   142,   431,    89,   353,
    1345,   172,   344,    25,   200,   174,   145,   372,   213,  2751,
     444,   344,   456,   127,   213,   276,   208,   372,   462,  1127,
     261,   261,   465,   276,   160,   196,  2599,   154,   372,   377,
     217,   372,  2812,   372,   208,   143,    47,   372,   108,   147,
     286,   149,   353,   281,   276,   479,   154,   155,  1542,   261,
     274,   270,  1469,   274,   261,   882,   263,   108,  2631,   929,
    1001,   310,   153,   353,  1148,   261,    24,  1091,   275,  1153,
     220,  2895,   333,  1669,  1974,   725,   239,  2649,   345,  1163,
     333,   319,   289,   377,   261,   281,  2954,   268,   433,   296,
     335,   261,   437,   377,   265,   327,   310,  2252,   233,   377,
     266,   446,   283,  2798,   339,   755,   353,   256,   353,   120,
     288,   372,  2463,   288,   764,   288,   285,   377,   377,   372,
     299,   161,  1106,   299,   893,  1115,   776,   372,   353,   377,
    2703,   338,   357,   353,  1112,  1113,   377,   377,   368,   161,
     162,   372,   951,  1121,   374,   372,   281,   455,  1172,   353,
    2255,  2256,   372,   370,  1088,   484,   373,   486,   375,   488,
     377,  1757,   372,   492,   426,   377,   320,   429,   106,   431,
    1460,   433,   376,   435,   357,   437,   438,   439,  1616,   374,
     442,   364,   444,   163,   446,   619,   376,   376,  2062,   211,
     452,   376,  2066,   376,  2349,   457,   376,    86,   460,  1103,
     377,   463,  1881,   465,  1883,   933,   468,   469,   901,   653,
      77,   473,   474,   283,   476,  1150,   660,   479,    23,   157,
     663,   327,    87,   357,   967,  1832,  1825,  1256,  1257,  1569,
     364,   242,   283,   329,   302,   937,   327,    89,  1267,  1268,
     674,   969,   376,   123,  1969,   281,    84,  1972,  1973,  1169,
    1279,  1280,   312,  1465,   268,   689,  1981,    20,   520,    47,
     522,   705,   572,   525,  1293,  1294,    54,   995,   248,   703,
      11,    84,    60,   138,   976,    38,   125,    94,   126,   572,
    1150,  2854,   544,    79,   546,   547,  1430,   370,   722,   227,
     373,   303,   375,    86,   377,    94,    88,   114,   572,   572,
     562,   153,  2756,   572,   232,  1283,  1284,   365,   366,   367,
     368,  1990,   323,   327,    87,   423,   374,   425,   185,   208,
     187,  2894,  1351,   363,   364,   365,   366,   367,   368,   365,
     178,   343,   120,    79,   374,   140,   341,  2016,  2792,   135,
    1167,   363,   364,   365,   366,   367,   368,   455,   456,   112,
     419,   163,   374,    94,   462,   148,  2631,   619,  1495,  1699,
     372,  1498,  1499,   572,   124,   138,    89,  2607,   160,  2048,
     208,  1304,   377,    79,  2235,   224,   139,  1815,   310,   448,
      16,  2835,   256,  1318,   322,   259,   126,  1732,  1733,   135,
     186,   208,  1737,   189,   656,   208,   213,   377,   506,   372,
     217,   663,  2149,   665,   167,   513,     0,   281,   670,   208,
    1225,  1226,   674,  1182,   118,   208,   524,  1350,   217,   681,
      25,  1190,  1767,  1768,   276,    30,  2173,   689,  1197,   135,
     153,    78,   742,    65,   272,   543,   248,  1206,   178,    38,
     186,   703,   704,   189,   706,   377,   295,   757,  1318,   742,
     558,    83,  1195,   561,   242,   376,   304,    89,   306,  2564,
     722,  1878,   420,   725,   757,   336,   574,   341,   742,   742,
     780,   175,    87,   742,   736,   327,   377,   109,   274,   292,
     186,   333,   295,   189,  1824,  1990,   209,   210,   798,   337,
     752,  1188,   841,   755,   756,  1430,  2396,   144,   760,   316,
     263,   233,   764,   310,   373,   222,   341,   324,   377,    47,
     772,  2016,   275,   112,   776,   219,   778,    26,   828,   175,
     372,   153,    60,   138,   967,   161,   289,    61,   274,  2429,
     373,   841,   137,   296,   377,   323,   141,    46,  2412,  2447,
     139,  1191,   377,  2417,   652,   653,  2420,  1290,  1198,   281,
     346,    85,   660,   276,  1204,  2017,   161,   162,   373,   517,
    1430,   124,   377,   219,   304,  2094,   306,  2408,   274,   174,
     377,  1221,   310,  1223,  1224,   338,   372,  1227,  2303,   537,
    1920,   118,   120,  2308,  2309,   276,   149,   545,   224,   233,
    2084,   699,   700,   701,    59,    84,   222,   705,  1502,  1503,
     346,   164,   912,   913,   327,   915,   211,  1631,  2233,   172,
     333,   145,   256,  2123,  2015,  1482,  2018,  2722,  2018,   224,
     882,   248,   233,  2018,  2062,   887,   888,   277,  2066,    32,
    2018,  2018,     9,  1657,   896,  2018,   898,   102,   175,   372,
     346,   283,   333,   233,   276,   351,   754,   353,   259,   372,
     314,    28,   302,   277,   301,   302,   283,  1997,  1998,  1093,
     610,   335,    47,  1097,   263,   272,   256,   775,  1880,   158,
     281,   933,   341,    76,   343,   341,   275,   343,   302,   353,
     285,   372,   219,   991,   634,   327,   258,   337,   233,   178,
     289,   281,   642,  1627,   233,   327,   303,   296,   372,    84,
     327,   333,   265,   372,   242,   967,   372,   969,   123,    25,
    2664,   256,    54,   337,    30,   245,   181,   256,    60,   677,
     356,  1750,    62,   359,   360,   361,   141,   363,   364,   365,
     366,   367,   368,   995,    89,  1432,   343,  1181,   374,   338,
     372,  1770,   281,   357,  1624,  1189,   144,  1397,  2347,   152,
     136,   356,  1195,    47,   359,   360,   361,   371,   363,   364,
     365,   366,   367,   368,   373,   372,    60,   376,   233,   374,
     357,   233,  2646,  1207,  1208,     5,  1805,   364,  1222,    94,
      10,    14,    15,  2860,   233,   323,   894,    17,  1817,  1818,
      84,   373,    86,  1930,   256,   377,  2136,   200,   153,   114,
    1937,  1938,   256,   353,    34,   259,  2146,   256,  2153,  1154,
     259,  2156,  2157,  2158,  2159,  2160,  2161,  2162,  2163,  2164,
    1647,  2166,   372,   208,   353,   141,  1476,   281,   213,  2554,
    2555,  1093,   281,    20,    36,  1097,   233,  1099,   303,   353,
     305,   248,   268,   372,  2744,   161,   162,  1290,  2925,   977,
     257,    38,   980,  1990,   148,   210,   984,   242,   372,   256,
    2205,  2206,   351,   352,   353,   291,   167,   252,   357,  1179,
     273,   278,  2949,  1642,   982,   364,  1645,    44,    45,  2016,
    1649,   352,   367,   991,  1233,   843,   357,   341,   372,   341,
     375,   343,  1154,  2492,  1156,   211,   854,    32,   213,   352,
    1833,   353,   217,   373,   357,  1167,   376,  1169,   224,  1212,
     341,   364,   343,   370,   208,   353,   766,   767,   375,   213,
     372,   276,   353,  1233,  1693,   112,  1188,   885,   357,  1191,
    1192,   222,  1242,  1195,   372,    70,  1198,  1199,   323,  1201,
    1202,   372,  1204,    36,  2843,  1207,  1208,  1251,   242,  1242,
    1250,    16,   139,  1844,  1845,    90,   367,   371,   252,  1221,
     233,  1223,  1224,   377,   375,  1227,   353,  2866,  1242,  1242,
     105,  1233,   327,  1242,  2412,   244,  2393,   353,   333,  2417,
     167,   353,  2420,   256,   119,   372,   259,    26,  1250,  1251,
    2715,  2890,  1254,  1822,   106,  2335,   372,  2896,   133,   353,
     372,   316,   347,   373,   368,   372,   118,   377,   281,   324,
     374,  2351,  1322,  2358,     7,   373,    32,   372,   372,   377,
      13,    14,    38,   163,  2923,    18,   375,    20,  1290,   323,
    2315,  2316,   225,    26,  2319,    28,  2321,   370,   310,   372,
     356,   225,   375,  1786,   304,   157,   306,   363,   364,   365,
     366,   367,   368,   373,  2038,   373,  2116,   377,   374,   377,
     373,   373,   373,   175,   377,   377,   377,   222,   341,  2177,
    2178,  1179,   304,  1181,   306,   373,   263,   222,   213,   377,
    2015,  1189,  1427,   373,   347,   220,  1431,   377,   275,   373,
     373,    26,  1200,   377,   377,  1203,   161,   373,  1867,  2698,
    1445,   377,   289,  1749,  1538,  1751,  1752,   219,   347,   296,
    1544,  1545,   247,   163,  1222,   227,   281,  1225,  1226,   341,
    1990,   343,   373,    60,   373,  1387,   377,   373,   377,  1237,
    1475,   377,  1477,   373,   365,  1397,   373,   377,  2600,   373,
     377,   122,  2075,   377,  1489,  2015,  2016,  1492,   373,  2494,
    2495,   338,   377,   373,   341,  2184,   373,   150,   373,   224,
     153,    36,   377,   156,   157,  1427,  1428,   375,   373,  1431,
    1432,  2104,   377,   370,  1436,   372,  1521,  1946,  1947,  1524,
    1442,  1526,   372,  1445,   373,   256,  1448,   161,   377,   126,
     373,  2629,   372,  1843,   377,   365,   366,   367,   368,   912,
     913,  1635,   915,  2732,   374,    16,  1292,   144,  2646,   341,
     322,   343,   372,  1475,  1476,  1477,  1478,   375,  1480,    20,
    2047,  1483,  1484,   106,   373,   373,   372,  1489,   377,   377,
    1492,  1493,  1494,  1846,  1847,   118,   373,    38,   161,  1347,
     377,   178,   348,   349,   350,  1507,  1508,  1509,  1510,  1511,
    1512,  1513,  1902,  2186,  1516,  1517,  1518,   372,    16,  1521,
    1522,   373,  1524,  1525,  1526,   373,   106,  1616,  1918,   377,
     281,   373,  1922,   373,   157,   377,  1538,   377,   118,   222,
    1583,   373,  1544,  1545,     7,   377,  1394,  2228,   173,   226,
      13,   356,   175,   373,   359,   360,   361,   377,   363,   364,
     365,   366,   367,   368,   373,   304,  1616,   306,   377,   374,
    2079,   112,  2081,   372,  2083,   373,  2085,   157,   216,   377,
     373,  2090,  1584,   167,   377,   373,   373,  2672,    51,   377,
     377,  2769,   304,    47,   306,   175,   219,  1599,   139,  2684,
    2685,  1603,   373,  1786,   227,   373,   377,   373,  2117,   377,
     161,   377,   372,   912,   913,  1617,   915,   372,   341,  1621,
    1622,   341,   341,   343,   343,    20,   167,   304,   372,   306,
      93,   233,    26,  1635,  1636,    98,    26,   314,   101,   219,
     576,  2067,   578,  2069,   167,  1647,   323,   227,   329,   363,
     364,   365,   366,   367,   368,   110,   372,   110,  1841,   110,
     374,  1663,   110,   161,   110,   110,   377,  1515,   372,   110,
    1368,   110,  2874,   224,   222,   110,   110,  2855,   222,  2403,
     110,  1770,   110,   146,    20,  1687,   119,   173,   372,  1691,
     372,   118,   118,   426,   353,   353,   372,   230,   372,   322,
     363,   364,   365,   366,   367,   368,   439,  2787,   372,   442,
     372,   374,  2797,   238,   353,   372,   372,   372,   353,   452,
    1770,   372,   263,   372,   457,  2115,   224,  2807,   372,   372,
    1810,  1811,  1580,  1783,   275,   372,   469,   200,   372,   372,
     473,   474,   322,   353,  2978,   372,   353,   377,   289,    20,
     372,   372,   372,  1803,  1602,   296,   372,  1759,   173,   372,
     118,  1609,  1936,   118,   310,  1815,   375,  1852,  1616,   275,
     233,   310,   310,   310,   310,   222,   213,   377,   310,   328,
     310,   310,   310,   310,  1786,   272,   329,   520,    10,   522,
     310,   310,  2872,   256,    54,   146,   259,   338,   222,   314,
      22,  1886,   314,   377,   272,   356,    37,  1990,   359,   360,
     361,   310,   363,   364,   365,   366,   367,   368,   281,   310,
      42,   310,   310,   374,  1826,   222,   222,   372,  1830,   161,
     341,   335,   372,  2016,    20,  2915,  2916,   372,   372,    16,
      62,  1843,     9,    19,    84,  1543,    77,   337,    25,  1547,
    1852,  1853,  1854,    30,   372,   181,    78,   118,   356,   372,
     222,   359,   360,   361,  1866,   363,   364,   365,   366,   367,
     368,    20,   273,   340,    96,   110,   374,   329,   110,   310,
     262,   212,   123,   333,  1886,  1887,  1888,   372,  2278,  2279,
     339,   357,   308,   374,   308,  1593,   281,  2523,   377,   308,
    1902,   372,   372,   125,   310,   123,  1732,  1733,   130,  1607,
    2094,  1737,   143,   312,   373,  2559,  1918,   377,   157,   359,
    1922,   377,   144,   656,  2433,  2434,  2695,   223,   217,   175,
     373,   310,   665,   310,  1936,   272,    59,   670,   165,   165,
     372,  1767,  1768,   372,   213,   213,   213,   222,   681,   228,
     310,   310,   272,   373,   185,   377,   187,  2131,   377,    36,
     137,  1809,    36,   256,   141,    16,   248,  1815,   161,   200,
      20,   161,  1974,   706,    25,   329,   161,   161,   220,    30,
      19,   359,  1984,   370,   161,   162,   370,   310,   143,   310,
     118,  2041,   147,   310,   310,   359,   226,   174,   222,    20,
     131,   232,   224,   222,   134,  2055,   118,   134,  2041,   377,
     232,  2096,  2062,    20,   222,   372,  2066,   373,   222,   752,
       8,   302,  2055,   245,   377,   128,   188,   760,   222,   260,
     377,   208,    36,  2118,   211,   373,   123,   377,   373,   373,
    2042,   347,   347,  2526,   266,  2047,   373,   224,   270,   226,
     272,   373,  2102,   347,  2056,   277,   123,  2059,   373,   290,
     373,   373,   373,   373,   373,   373,   373,   310,   372,  2102,
    2072,   373,   373,     7,   372,   175,   373,   372,   151,    13,
     302,   303,   372,   233,   213,   224,   137,   175,   235,   235,
     141,   161,   314,   326,  2096,   310,   310,   319,   161,   373,
     161,  2103,   351,   373,   370,   274,   328,   189,   285,   373,
     161,   162,   222,  2115,   359,   337,  2118,    51,   175,   319,
     258,   372,   377,   174,  2213,   373,   220,   222,   310,  2131,
     329,   222,   164,   229,   372,  2215,  2216,  2217,  2218,   373,
     164,   329,   225,   372,   108,  2654,  2655,  2656,   108,   377,
     370,   104,   373,    69,  2663,   123,   118,   208,   374,    93,
     211,   373,   373,  2213,    98,    45,   373,   101,   123,   372,
     359,   373,   130,   224,  2022,   226,   373,   372,   141,   356,
    2028,   151,   359,   360,   361,   319,   363,   364,   365,   366,
     367,   368,   310,   310,   371,  2959,  2044,   374,   161,   310,
    2755,   378,   373,   371,   161,   161,   371,  2276,   124,   372,
      20,   165,   146,   118,  2062,   341,   226,   356,  2066,  1917,
     359,   360,   361,   147,   363,   364,   365,   366,   367,   368,
     161,  2233,    56,   149,   285,   303,   372,   377,  2086,   332,
    2088,   164,   127,   352,   123,  2093,  2094,   372,   164,  2639,
     372,   123,   373,  2255,  2256,    36,   172,   373,   372,  2649,
     373,   224,    18,   319,   213,   373,   200,   373,  2116,   373,
     425,  1969,   373,   372,  1972,  1973,  2278,  2279,   213,   161,
     196,   329,    91,  1981,   213,    86,  2795,   148,   125,   125,
    1988,   371,  1990,   224,   123,   329,  2298,  2299,   329,   233,
      99,   456,   109,    20,   373,   356,   222,   462,   359,   360,
     361,    47,   363,   364,   365,   366,   367,   368,  2016,   372,
      47,   225,   166,   374,   310,   259,   377,  2153,   123,   372,
    2156,  2157,  2158,  2159,  2160,  2161,  2162,  2163,  2164,   372,
    2166,   217,   225,  2526,   123,   372,   192,   281,  2046,   265,
     373,  2353,  2354,  2355,   252,  2357,    20,   377,   213,    25,
     144,   184,  2412,   269,    30,   246,   269,  2417,   225,   225,
    2420,   191,  2220,  2221,   118,   222,  2378,   303,  2380,  2205,
    2206,  2383,    20,  2385,   132,    99,    95,   542,   222,   222,
     372,  2781,    20,   356,  2396,   268,   359,   360,   361,    89,
     363,   364,   365,   366,   367,   368,  2408,   327,  2410,  1732,
    1733,   374,   567,   329,  1737,   109,   377,   109,     6,  2421,
     246,  2423,   372,  1156,   251,   356,   373,  2429,   359,   360,
     361,   572,   363,   364,   365,   366,   367,   368,  2440,   105,
    1582,  1826,  1520,   374,  1767,  1768,   888,  1941,  1988,  2718,
    2535,  2291,  2537,  1507,  2380,  2938,  2593,  1984,  2527,  1192,
    1863,  2383,  2906,  2929,  2886,  2885,  1199,  2436,  1201,  1202,
    2909,   137,  1164,  2385,  2623,   141,  2547,    25,  2990,  1572,
    2572,  2963,    30,  1992,  2571,  2015,  2940,  2016,  1149,  2991,
    1207,    26,  2190,   648,   649,   161,   162,   514,   653,   756,
    2348,  2769,  2440,  2395,  2855,   660,  1880,  1466,   174,  1465,
    2401,  2580,  2819,  2953,  2989,   557,  2364,  2745,  1394,    19,
    2893,  2103,  1830,  1838,  2526,   680,  2374,   920,  1848,   742,
     919,  1409,  2358,  2535,  2536,  2537,   742,  1388,   921,  1815,
    1616,  2647,  2068,   455,  2378,   211,  2548,  2189,  2732,  1559,
     705,  1783,  1841,  2603,  1781,  1701,  1670,  1348,   224,    -1,
      -1,    -1,  2564,    -1,  2412,    -1,    -1,    -1,    -1,  2417,
    2603,    -1,  2420,    -1,    -1,    -1,     8,    -1,    -1,  2277,
      -1,    -1,    -1,    -1,    -1,   740,  2284,    -1,  2286,   137,
      -1,    23,    -1,   141,  2768,    27,  2646,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,  2303,    -1,   762,    -1,    41,
    2308,  2309,    -1,   161,   162,  2617,    -1,    -1,    -1,   285,
      -1,  2623,    -1,    -1,    -1,    -1,   174,  2629,    -1,   784,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,  2639,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,  2696,  2649,    -1,    -1,
    2834,    -1,    -1,  2351,  2352,    -1,   811,  2659,    -1,    -1,
      -1,    -1,  2664,   211,  2512,  2513,  2514,  2515,  2494,  2495,
      -1,    -1,    -1,    -1,    -1,    -1,   224,    -1,    -1,    -1,
      -1,    -1,  2856,   838,   839,   161,   841,    -1,    -1,    -1,
     356,    -1,    -1,    -1,    -1,  1428,  2394,   363,   364,   365,
     366,   367,   368,  1436,   859,    -1,    -1,    -1,   374,  1442,
      -1,  2761,    -1,    25,    -1,  1448,    -1,    -1,    30,    -1,
    2722,    -1,   154,    -1,    -1,    -1,    -1,    -1,  2761,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,   285,   161,    -1,
      -1,    -1,  2744,    -1,  2746,  1478,    -1,  1480,   224,    -1,
    1483,    -1,    -1,  2937,    -1,  2938,    -1,    -1,    -1,   914,
    1493,  1494,   917,   918,    -1,    -1,  2768,  2769,    -1,    -1,
     925,  2773,  2774,    -1,   929,    -1,  1509,  1510,  1511,  2781,
    1513,  2629,    -1,  1516,  1517,  1518,    -1,    -1,    -1,  1522,
      -1,  2975,  1525,    -1,    -1,    -1,    -1,   952,  2646,    -1,
      -1,   224,    -1,    -1,    -1,    -1,    -1,    -1,   356,    -1,
      -1,   966,   360,   361,    -1,   363,   364,   365,   366,   367,
     368,    -1,    -1,    -1,  2522,   137,   374,    -1,    -1,   141,
    2153,    -1,    -1,  2156,  2157,  2158,  2159,  2160,  2161,  2162,
    2163,  2164,    -1,  2166,  2846,    -1,  2672,    -1,    -1,   161,
     162,    -1,    -1,  2855,  2856,    -1,  2554,  2555,  2684,  2685,
      -1,    -1,   174,  2561,  2562,    -1,    -1,  2565,  2566,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,  2966,    -1,    -1,
     356,    -1,  2205,  2206,  2732,  2887,  2734,   363,   364,   365,
     366,   367,   368,  2895,    -1,    -1,   208,    -1,   374,   211,
      -1,    -1,    -1,  2953,    -1,    -1,    -1,  2755,    -1,    -1,
      -1,    -1,   224,    -1,    -1,    -1,  2966,    -1,  2920,    -1,
      -1,  2769,    -1,    -1,    -1,    -1,    -1,    -1,    -1,  2777,
      -1,    -1,  2630,   356,  1089,    -1,  2938,   360,   361,  2989,
     363,   364,   365,   366,   367,   368,    -1,    -1,    -1,    -1,
    1105,   374,    -1,    -1,  1687,    -1,   680,    -1,    -1,    -1,
      -1,  2963,    -1,  2811,    -1,    -1,    -1,    -1,    -1,  1124,
      -1,  2797,    -1,   285,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,  2834,    -1,  2990,    -1,
      -1,   423,  1147,    -1,    -1,  1150,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,  2855,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,  2715,    -1,    -1,
      -1,  2719,    -1,    -1,  1179,    -1,  1181,    -1,    -1,    -1,
      -1,    -1,  1187,    -1,  1189,  2358,    -1,    -1,   762,    -1,
      -1,  1196,    -1,    -1,   356,    -1,    -1,   359,   360,   361,
      -1,   363,   364,   365,   366,   367,   368,    -1,    -1,    -1,
      -1,    -1,   374,    -1,    -1,    -1,    -1,  1222,  2766,    -1,
      -1,    -1,    -1,    -1,   506,    -1,    -1,    -1,    -1,    -1,
      -1,   513,    -1,    -1,    -1,    16,    -1,    -1,    -1,  2937,
      -1,    -1,   524,    -1,    25,    -1,    -1,    -1,    -1,    30,
      -1,  1256,  1257,    -1,    -1,    -1,    -1,    -1,    -1,  1264,
      -1,   543,  1267,  1268,    -1,    -1,    -1,    -1,    -1,    -1,
    1853,  1854,    -1,    -1,  1279,  1280,   558,  2975,    -1,   561,
      -1,    -1,  1287,    -1,    -1,    -1,  1291,  1292,  1293,  1294,
      -1,    -1,   574,    -1,    -1,    -1,  1301,  1302,    -1,    -1,
      -1,    -1,    -1,    -1,  1887,  1888,    -1,    -1,    -1,    -1,
      -1,   885,  1317,  1318,    -1,    -1,  1321,    -1,    -1,    -1,
    1325,  2494,  2495,    -1,  1329,    -1,    -1,  1332,  1333,  1334,
    1335,  1336,  1337,  1338,  1339,  1340,  1341,   118,  1343,    -1,
      -1,    -1,   123,  1348,     0,    -1,  1351,    -1,    -1,    -1,
      -1,   925,    -1,    -1,    -1,    -1,   137,    -1,    -1,    -1,
     141,    -1,    18,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
     652,    -1,  2920,    -1,    -1,    -1,    -1,    -1,   952,    -1,
     161,   162,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,  1396,   966,   174,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    65,
      -1,    -1,    -1,    -1,    -1,  2963,    -1,   699,   700,   701,
      -1,    -1,    -1,    -1,    -1,  1430,    -1,   208,    -1,    -1,
     211,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,  1446,  2990,   224,    -1,   226,    -1,    -1,    -1,    -1,
     106,    -1,    -1,    -1,    -1,  1460,    -1,    -1,    -1,  2042,
    1465,  1466,   118,    -1,    -1,    -1,    -1,   123,    -1,    -1,
      -1,   127,   754,    -1,   130,    -1,   132,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,   775,    -1,    -1,    -1,    -1,    -1,  2672,
      -1,   157,    -1,    -1,   285,    -1,    -1,    -1,    -1,    -1,
      -1,  2684,  2685,    -1,    -1,  1089,    -1,    -1,    -1,   175,
      -1,    -1,    -1,    -1,    25,    -1,    -1,    -1,    -1,    30,
    1535,  1105,    -1,    -1,    -1,   191,   192,  1542,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
    1124,    -1,    -1,  1558,    -1,  1560,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,   219,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,   227,    -1,  1147,    -1,   356,    -1,    -1,   359,   360,
     361,    -1,   363,   364,   365,   366,   367,   368,    -1,    -1,
      -1,    -1,    -1,   374,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,   105,    -1,   262,    -1,    -1,    -1,
      -1,  1616,   894,  1187,    -1,    -1,    -1,    -1,    -1,    -1,
    1625,    -1,  1196,    10,  2797,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,   137,    -1,    -1,    -1,
     141,    -1,    -1,    -1,    -1,    -1,   302,  1652,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
     161,   162,    -1,    -1,    -1,  1670,   322,    -1,    -1,     0,
      -1,    -1,    -1,   174,    -1,    62,  1681,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,   340,    -1,    -1,    18,    -1,    -1,
      -1,    78,   348,   349,   350,  1700,    -1,    -1,    -1,    -1,
     982,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    96,
     211,    -1,    -1,    -1,   370,  2298,  2299,   373,    -1,   375,
     376,    -1,    -1,   224,    -1,    -1,    -1,  1732,  1733,    -1,
      -1,    -1,  1737,    -1,    65,    -1,    -1,    -1,   125,   542,
      -1,    -1,    -1,   130,  1749,  1750,  1751,  1752,    -1,    -1,
      -1,    -1,    -1,  1758,    -1,    -1,    -1,   144,    -1,    -1,
      -1,    -1,  1767,  1768,   567,  1770,    -1,  1341,    -1,    -1,
    2353,  2354,  2355,    -1,  2357,   106,    -1,  1782,    -1,  1784,
     167,    -1,    -1,  1788,   285,    -1,    -1,   118,    25,    -1,
      -1,    -1,   123,    30,    -1,    -1,   127,    -1,    -1,   130,
    1805,   132,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
    1815,    -1,  1817,  1818,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,   157,  1832,    -1,    -1,
      -1,    -1,    -1,  1838,    -1,    -1,    -1,   224,    -1,    -1,
      -1,  1846,  1847,  1848,   175,   648,  1851,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,   356,    -1,  1862,    -1,    -1,
     191,   192,   363,   364,   365,   366,   367,   368,   105,    -1,
      -1,    -1,    -1,   374,    -1,  1880,  1881,    -1,  1883,   266,
      -1,    -1,    -1,    -1,    -1,   272,  1460,    -1,   219,    -1,
     277,  1465,  1466,  1898,    -1,  1900,   227,    -1,    -1,    -1,
     137,    -1,    -1,    -1,   141,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,   302,   303,    -1,  1200,    -1,
      -1,  1203,    -1,    -1,   161,   162,    -1,   314,    -1,    -1,
      -1,   262,   319,    -1,    -1,  1940,    -1,   174,    -1,    -1,
      -1,   328,    -1,  1225,  1226,    -1,    -1,    -1,    -1,    -1,
      -1,   680,    -1,  2536,    -1,  1237,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,  1970,    -1,    -1,  1542,    -1,
      -1,   302,    -1,    -1,   211,    -1,    -1,    -1,    -1,    -1,
      -1,   784,    -1,    -1,    -1,  1990,  1560,   224,    -1,    -1,
      -1,   322,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,   811,   340,
    2015,  2016,    -1,    -1,    -1,    -1,    -1,   348,   349,   350,
      -1,  2026,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,  2037,   762,  2617,   838,   839,    -1,   841,   370,
    2623,    -1,   373,  2048,   375,   376,    -1,    -1,   285,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,   859,  2062,    -1,    -1,
      -1,  2066,    -1,    -1,    -1,  1347,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,  2080,    -1,    -1,    -1,  2084,
      -1,    -1,    -1,    -1,    -1,    -1,    16,    -1,    -1,  2094,
      20,    -1,    -1,    -1,    -1,    25,    -1,    -1,    -1,    -1,
      30,    -1,    -1,    -1,    -1,    -1,    -1,  1681,    -1,    -1,
      -1,   914,  1394,    -1,   917,   918,    -1,    -1,    -1,   356,
      -1,  2126,    -1,    -1,  2129,    -1,   363,   364,   365,   366,
     367,   368,    -1,  2138,    -1,    -1,    -1,   374,    -1,  2144,
      -1,    -1,    -1,  2148,    -1,    -1,    -1,    -1,  2153,    -1,
      -1,  2156,  2157,  2158,  2159,  2160,  2161,  2162,  2163,  2164,
    2165,  2166,    -1,    -1,    -1,  2170,  2171,    -1,    -1,   680,
      -1,    -1,    -1,    -1,  2179,    -1,    -1,    -1,    -1,  2184,
      -1,    -1,    -1,    -1,    -1,    -1,  2191,    -1,    -1,  2194,
      -1,  2196,    -1,    -1,    -1,    -1,   925,    -1,  2203,  2204,
    2205,  2206,    -1,    -1,    -1,  2210,    -1,   137,  2213,    -1,
      -1,   141,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,   952,    -1,    25,    -1,    -1,    -1,    -1,
      30,   161,   162,  1515,    -1,    -1,    -1,   966,    -1,    -1,
      -1,    -1,    -1,    -1,   174,    -1,    -1,    -1,    -1,    -1,
      -1,   762,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,  2846,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,  1851,   208,    -1,
      -1,   211,    -1,    -1,    -1,    -1,    -1,    -1,    -1,  2294,
      -1,    -1,    -1,    -1,   224,    -1,   226,    -1,  1580,    -1,
      -1,    -1,    -1,    -1,  2887,   105,  1880,  1881,    -1,  1883,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,   680,    -1,    -1,
    1602,    -1,    -1,    -1,  1898,    -1,  1900,  1609,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,   137,    -1,    -1,
      -1,   141,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,  2358,    -1,   285,    -1,    -1,    -1,    -1,
    1089,   161,   162,    -1,  2369,    -1,  1940,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,   174,    -1,  1105,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,  1124,  1970,    -1,    -1,   762,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,  2412,    -1,    -1,
      -1,   211,  2417,    -1,   925,  2420,  1990,    -1,  1147,  2424,
      -1,    -1,    -1,    -1,   224,    -1,   356,    -1,    -1,   359,
     360,   361,    -1,   363,   364,   365,   366,   367,   368,    -1,
      -1,    -1,  2016,    -1,   374,    -1,    -1,    -1,  2453,    -1,
      -1,    -1,  2026,    -1,    -1,   966,    -1,    -1,  1187,    25,
      -1,  1264,    -1,  2037,    30,  1268,    -1,  1196,    -1,    -1,
      -1,    -1,    -1,    -1,  2048,    -1,    -1,   680,    -1,    -1,
      -1,    -1,    -1,    -1,  1287,   285,    -1,    -1,  1291,  2494,
    2495,  1294,    -1,    -1,  2499,  2500,    -1,    -1,  1301,  1302,
      -1,  2506,  2507,    -1,    -1,  2510,  2080,    -1,    -1,    -1,
    2084,    -1,    -1,    -1,  1317,    -1,    -1,    -1,  1321,    -1,
      -1,    -1,  1325,    -1,    -1,    -1,  1329,  1809,    -1,  1332,
    1333,  1334,  1335,  1336,  1337,  1338,  1339,  1340,    -1,   105,
    1343,    -1,    -1,    -1,    -1,  1348,    -1,    -1,    -1,    -1,
      -1,    -1,    25,    -1,    -1,  2129,   356,    30,    -1,   762,
      -1,    -1,   925,   363,   364,   365,   366,   367,   368,    -1,
      -1,   137,    -1,   680,   374,   141,    -1,    -1,  1089,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,  2592,    -1,   952,
      -1,  2165,    -1,  1396,  1105,   161,   162,    -1,    -1,    -1,
      -1,    -1,    -1,   966,    -1,  2179,    -1,    -1,   174,    -1,
      -1,    -1,  1341,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,  2629,    -1,    -1,    -1,    -1,  2203,
      -1,    -1,   105,    -1,    -1,    -1,  1147,  2642,    -1,    -1,
      -1,  2646,    -1,  1446,    -1,   211,  2651,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,   762,    -1,    -1,   224,    -1,
      -1,    -1,    -1,    -1,   137,    -1,    -1,  2672,   141,    -1,
    2675,    -1,    -1,    -1,    -1,    -1,  1187,    -1,  2683,  2684,
    2685,    -1,    -1,  2688,    -1,  1196,    -1,    -1,   161,   162,
    2695,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,   174,    -1,    -1,    -1,   680,    -1,    -1,  2713,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,   285,
    2294,    -1,   925,    -1,    -1,    -1,  1089,  2732,    -1,    -1,
      -1,  1460,  1535,    -1,    -1,    -1,  1465,  1466,   211,    -1,
    2022,    -1,  1105,    -1,    -1,    -1,  2028,    -1,    -1,   952,
      -1,   224,    -1,    -1,    -1,  1558,    -1,    -1,    -1,    -1,
      -1,  1124,  2044,   966,  2769,  2770,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,  2788,  1147,    -1,    -1,   762,    -1,    -1,
     356,    -1,  2797,  2798,    -1,  2369,    -1,   363,   364,   365,
     366,   367,   368,    -1,  2086,    -1,  2088,    -1,   374,    -1,
      -1,  2093,   285,  1542,    -1,    -1,    -1,    -1,   925,    -1,
      -1,    -1,  1625,    -1,  1187,    -1,    -1,    -1,    -1,  2834,
    1341,  1560,    -1,  1196,  2116,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    16,    -1,    -1,   952,    -1,    21,    -1,  1652,
    2855,    25,    -1,    -1,    -1,    -1,    30,    -1,    -1,   966,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,  1670,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,   356,    -1,    -1,  1089,    -1,    -1,    -1,
     363,   364,   365,   366,   367,   368,    -1,  1700,    -1,  2904,
      -1,   374,  1105,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,  2917,    -1,    -1,    -1,    -1,    -1,    92,    -1,
      -1,  1124,    -1,    -1,    -1,    -1,  2500,    -1,    -1,    -1,
      -1,    -1,  2937,    16,    -1,    18,    -1,    -1,  2220,  2221,
      -1,    -1,    25,    -1,  1147,    -1,  1749,    30,  1751,  1752,
     925,    -1,  1681,    -1,    -1,  1758,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,   137,    -1,    -1,    -1,   141,    -1,    -1,
    2975,    -1,    -1,  2978,    -1,    -1,    -1,   952,  1341,  1782,
      -1,  1784,  1089,    -1,  1187,  1788,    -1,   161,   162,    -1,
      -1,   966,    -1,  1196,    -1,    -1,    -1,    -1,  1105,    -1,
     174,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,  1124,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,  1832,
      -1,  1542,    -1,    -1,   208,  1838,    -1,   211,    -1,    -1,
    1147,    -1,    -1,  1846,  1847,  1848,    -1,    -1,    -1,  1560,
     224,    -1,   226,    -1,   137,    -1,    -1,    -1,   141,  1862,
      -1,    -1,    -1,    -1,    -1,    -1,  2348,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,   680,    -1,  2651,   161,   162,
    1187,    -1,  2364,    -1,    -1,    -1,    -1,    -1,    -1,  1196,
      -1,   174,  2374,    -1,    -1,    -1,    -1,  1460,    -1,    -1,
      -1,  2675,  1465,  1466,    -1,    -1,    -1,    -1,    -1,  2683,
      -1,   285,    -1,    -1,  1089,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,  1851,    -1,    -1,   208,    -1,    -1,   211,    -1,
    1105,    -1,    -1,    -1,    -1,    -1,    -1,    -1,  1341,    -1,
      -1,   224,    -1,   226,    -1,    -1,    -1,    -1,    -1,  1124,
      -1,  1880,  1881,    -1,  1883,   329,    -1,   762,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,  1898,
    1681,  1900,  1147,    -1,    -1,    -1,    -1,    -1,    -1,  1542,
      -1,    -1,   356,    -1,    -1,   359,   360,   361,    -1,   363,
     364,   365,   366,   367,   368,    -1,    -1,  1560,    -1,    -1,
     374,    -1,   285,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,  1940,  1187,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,  1196,    -1,    -1,  2798,    -1,    -1,    -1,    -1,    -1,
    2512,  2513,  2514,  2515,  1341,    -1,    -1,    -1,    -1,    -1,
      -1,  1970,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,  1460,    -1,   342,
      -1,  1990,  1465,  1466,    -1,    -1,    -1,    -1,    -1,    -1,
       8,    -1,    -1,   356,    -1,    -1,   359,   360,   361,    -1,
     363,   364,   365,   366,   367,   368,    -1,  2016,    -1,    -1,
      -1,   374,    -1,    -1,    -1,    -1,    -1,  2026,    -1,    -1,
      -1,    -1,    -1,   680,    -1,    -1,    -1,    -1,  2037,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,  1681,  2048,
     925,    59,    -1,  2126,    -1,    -1,    -1,    -1,    66,    67,
      68,   680,    -1,    -1,    -1,  2138,    -1,    -1,    -1,  1542,
    1851,  2144,    -1,  2917,    -1,  2148,    -1,   952,    -1,    -1,
      -1,  2080,    -1,  1460,    -1,  2084,    -1,  1560,  1465,  1466,
      -1,   966,    -1,    -1,    -1,   103,  1341,  2170,  2171,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,   762,    -1,  1898,  2191,  1900,
      -1,  2194,    -1,  2196,    -1,    -1,    -1,    -1,    -1,    -1,
    2129,  2204,    -1,   141,  2978,    -1,    -1,  2210,   146,    -1,
    2213,    -1,    -1,   762,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,  1940,
      -1,    -1,    -1,    -1,    -1,  1542,  2165,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,   183,    -1,    -1,    -1,    -1,
    2179,    -1,  2734,  1560,    -1,    -1,    -1,    -1,    -1,  1970,
      -1,    -1,    -1,   201,   202,   203,   204,   205,    -1,   207,
      -1,    -1,    -1,  2755,  2203,    -1,    -1,    -1,  1681,    -1,
      -1,    -1,    -1,    -1,  1089,  1460,    -1,    -1,  1851,    -1,
    1465,  1466,    -1,    -1,    -1,  2777,    -1,   235,    -1,    -1,
    1105,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,  2026,    -1,  1880,  1881,  1124,
    1883,    -1,    -1,    -1,    -1,    -1,  2037,    -1,   266,  2811,
      -1,    -1,    -1,    -1,    -1,  1898,    -1,  1900,    -1,    -1,
      -1,    -1,  1147,    -1,    -1,    -1,    -1,    -1,   925,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
     298,    -1,   300,    -1,    -1,  2294,    -1,  1542,    -1,  2080,
      -1,    -1,    -1,  2084,  1681,   952,   925,  1940,    -1,    -1,
      -1,    -1,  1187,   321,    -1,  1560,    -1,    -1,    -1,   966,
     328,  1196,    -1,   331,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,   952,    -1,    -1,    -1,  1970,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,   966,  2129,    -1,
      -1,  2424,    -1,    -1,    -1,    -1,    -1,  1990,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
    2369,    -1,    -1,    -1,    -1,    -1,    -1,    -1,  1851,    -1,
    2453,    -1,    -1,  2016,  2165,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,  2026,    -1,    -1,    -1,    -1,  2179,    -1,
      -1,    -1,    -1,    -1,  2037,    -1,    -1,  1880,  1881,    -1,
    1883,    -1,    -1,    -1,    -1,  2048,    -1,    -1,    -1,    -1,
      -1,    -1,  2203,    -1,    -1,  1898,  2499,  1900,    -1,    -1,
      -1,    -1,    -1,  2506,  2507,    -1,  1681,  2510,    -1,    -1,
      -1,    -1,  1089,    -1,    -1,    -1,    -1,  2080,    -1,    -1,
      -1,  2084,    -1,    -1,    -1,    -1,    -1,    -1,  1105,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,  1341,  1940,    -1,    -1,
    1089,    -1,    -1,    -1,  1851,    -1,    -1,  1124,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,  1105,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,  2129,  1970,    -1,    -1,
    1147,  2500,    -1,  1880,  1881,  1124,  1883,    -1,    -1,    -1,
      -1,    -1,    -1,  2294,    -1,    -1,    -1,  1990,    -1,  2592,
      -1,  1898,    -1,  1900,    -1,    -1,    -1,    -1,  1147,    -1,
      -1,    -1,  2165,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
    1187,    -1,    -1,  2016,    -1,    -1,  2179,    -1,    -1,  1196,
      -1,    -1,    -1,  2026,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,  1940,  2037,    -1,    -1,    -1,  1187,  2642,
    2203,    -1,    -1,    -1,    -1,  2048,    -1,  1196,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,  1460,    -1,    -1,  2369,    -1,
    1465,  1466,    -1,  1970,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,  1851,  2080,    -1,    -1,
      -1,  2084,    16,  1990,    -1,  2688,    -1,    -1,    -1,    -1,
      -1,    25,    -1,    -1,    -1,    -1,    30,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,  1880,  1881,    -1,  1883,  2016,
    2713,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,  2026,
      -1,    -1,  2651,  1898,    -1,  1900,  2129,    -1,    -1,    -1,
    2037,  2294,    -1,    -1,    -1,    -1,    -1,  1542,    -1,    -1,
      -1,  2048,    -1,    -1,    -1,    -1,  2675,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,  2683,  1560,    -1,    -1,    -1,    -1,
      -1,    -1,  2165,    -1,  1341,  1940,    -1,  2770,    -1,    -1,
      -1,    -1,    -1,  2080,    -1,    -1,  2179,  2084,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,  2788,    -1,    -1,    -1,  2500,
      -1,    -1,  1341,    -1,    -1,  1970,    -1,    -1,    -1,    -1,
    2203,    -1,    -1,   137,    16,    -1,  2369,   141,    20,    -1,
      -1,    -1,    -1,    25,    -1,  1990,    -1,    -1,    30,    -1,
      -1,    -1,  2129,    -1,    -1,    -1,    -1,   161,   162,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
     174,  2016,    -1,    -1,    -1,    -1,   855,    -1,    -1,    -1,
      -1,  2026,    -1,    -1,    -1,    -1,    -1,    -1,  2165,    -1,
      -1,    -1,  2037,    -1,    -1,    -1,    -1,    -1,    -1,  2798,
      -1,    -1,  2179,  2048,   208,    -1,  1681,   211,    -1,    -1,
      -1,    -1,    -1,  1460,    -1,    -1,    -1,    -1,  1465,  1466,
     224,  2294,   226,    -1,   903,    -1,  2203,    -1,    -1,    -1,
      -1,  2904,    -1,    -1,    -1,  2080,    -1,    -1,    -1,  2084,
      -1,  1460,    -1,    -1,    -1,    -1,  1465,  1466,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,   137,    -1,    -1,    -1,   141,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,  2500,    -1,    -1,
    2651,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,   161,
     162,   285,    -1,    -1,  2129,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,   174,    -1,  2675,  1542,  2369,    -1,    -1,    -1,
      -1,    -1,  2683,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,  1560,    -1,    -1,    -1,  2294,  2917,    -1,
    2165,    -1,    -1,  1542,  1003,    -1,   208,    -1,    -1,   211,
      -1,    -1,    -1,    -1,  2179,    -1,    10,    -1,    -1,    -1,
      -1,  1560,   224,    -1,   226,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,   356,    -1,    -1,   359,   360,   361,  2203,   363,
     364,   365,   366,   367,   368,    -1,    -1,    -1,    42,   373,
     374,    -1,    -1,    -1,    -1,    -1,  1851,    -1,    -1,  2978,
      54,    -1,    -1,    -1,    -1,    -1,    60,    -1,    62,    -1,
      -1,    -1,  2369,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,   285,    78,  1880,  1881,    -1,  1883,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,  2798,  2651,    -1,
      -1,    -1,    96,  1898,    -1,  1900,    -1,  2500,    -1,    -1,
      -1,    -1,    -1,    -1,  1681,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,  2675,    -1,    -1,    -1,    -1,    -1,    -1,  2294,
    2683,   125,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,  1681,    -1,    -1,  1940,    -1,    -1,    -1,    -1,
     144,    -1,    -1,    -1,   356,    -1,    -1,   359,   360,   361,
      -1,   363,   364,   365,   366,   367,   368,    -1,    -1,    -1,
      -1,    -1,   374,    -1,   168,  1970,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,  1990,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,  2500,  2369,    -1,    -1,    -1,    -1,    -1,
      -1,  1210,    -1,    -1,    -1,    -1,  2917,    -1,    -1,    -1,
      -1,  2016,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
     224,  2026,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,  2037,    -1,    -1,  2798,    -1,    -1,    -1,    -1,
      -1,   245,    -1,  2048,    -1,    -1,    -1,    -1,  2651,    -1,
      -1,    -1,    -1,  1262,    -1,    -1,    16,    -1,    -1,    -1,
      -1,    -1,   266,    -1,    -1,    25,   270,  2978,   272,    -1,
      30,    -1,  2675,   277,  1851,  2080,    -1,  1286,    -1,  2084,
    2683,    -1,    -1,  1292,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,  1305,  1306,   302,   303,
    1309,    -1,  1851,  1880,  1881,    -1,  1883,    -1,    -1,    -1,
     314,    -1,    -1,    -1,    -1,   319,    -1,    -1,    -1,    -1,
      -1,  1898,    -1,  1900,  2129,  2500,    -1,    -1,    -1,    -1,
      -1,  1880,  1881,   337,  1883,    -1,    -1,  1346,    -1,    -1,
      -1,    -1,    -1,    -1,  2651,    -1,    -1,    -1,    -1,  1898,
      -1,  1900,    -1,    -1,  2917,    -1,    -1,    -1,    -1,    -1,
    2165,    -1,    -1,  1940,    -1,    -1,    -1,    -1,  2675,    -1,
      -1,    -1,    -1,    -1,  2179,    -1,  2683,   137,    -1,    -1,
      -1,   141,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,  1940,    -1,  1970,    -1,  2798,  1405,    -1,  2203,    -1,
      -1,   161,   162,  1412,    -1,  1414,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,  1990,   174,  2978,    -1,    -1,    -1,    -1,
      -1,  1970,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,  2016,
      -1,  1990,    -1,    -1,    -1,    -1,    -1,    -1,   208,  2026,
      -1,   211,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
    2037,    -1,    -1,    -1,   224,    -1,   226,  2016,    -1,    -1,
      -1,  2048,    -1,    -1,    -1,    -1,  2651,  2026,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,  2037,  2294,
      -1,  2798,    -1,    -1,    -1,    -1,    -1,    -1,    -1,  2048,
    2675,    -1,    -1,  2080,    -1,    -1,    -1,  2084,  2683,    -1,
      -1,    -1,    -1,    -1,  2917,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,   285,    -1,    -1,    -1,    -1,
      -1,  2080,    -1,    -1,    -1,  2084,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,  2129,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,  2369,    -1,    -1,    -1,    -1,   329,
      -1,    -1,    -1,    -1,    -1,  2978,    -1,    -1,    -1,    -1,
    2129,    -1,    -1,    -1,    -1,    -1,    -1,    -1,  2165,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,   356,    -1,    -1,   359,
     360,   361,  2179,   363,   364,   365,   366,   367,   368,    -1,
    2917,    -1,    -1,    -1,   374,    -1,  2165,    -1,    -1,    -1,
      -1,    -1,    -1,  2798,    -1,     3,  2203,    -1,    -1,    -1,
    2179,    16,    -1,    -1,    -1,    13,    14,    15,    -1,    -1,
      25,    -1,    -1,    -1,    -1,    30,    -1,    -1,    -1,    -1,
      -1,    29,    -1,    -1,  2203,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      48,  2978,    50,    51,    -1,    -1,    -1,    55,    56,    -1,
      -1,    -1,    -1,    -1,    16,    -1,    64,    65,    20,    -1,
      -1,    -1,    -1,    25,  1703,  2500,  1705,    -1,    30,    -1,
      -1,    -1,    80,    -1,    -1,    83,    -1,    -1,    -1,    -1,
      -1,    89,    -1,    -1,    -1,    -1,    -1,  2294,  1727,    -1,
      98,  1730,    -1,  1732,  1733,  1734,   104,    -1,  1737,    -1,
      -1,   109,  1741,   111,    -1,    -1,    -1,   115,    -1,  1748,
      -1,    -1,  2917,    -1,  1753,  2294,    -1,    -1,    -1,   127,
      -1,    -1,   137,    -1,  1763,    -1,   141,    -1,  1767,  1768,
    1769,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,  1780,    -1,    -1,    -1,   153,   161,   162,  1787,    -1,
    1789,  1790,  1791,  1792,  1793,  1794,  1795,  1796,  1797,   174,
    1799,    -1,  2369,    -1,    -1,    -1,    -1,    -1,   176,   177,
      -1,    -1,    -1,  2978,   182,   137,    -1,    -1,    -1,   141,
      -1,    -1,   190,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
    2369,    -1,    -1,   208,    -1,    -1,   211,    -1,    -1,   161,
     162,    -1,   210,    -1,    -1,    -1,    -1,    -1,    -1,   224,
      -1,   226,   174,    -1,    -1,    -1,  2651,    -1,    -1,    -1,
      -1,   236,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,  1870,   240,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
    2675,    -1,   250,    -1,    -1,   253,   208,   255,  2683,   211,
      -1,   259,    -1,    -1,    -1,    -1,   264,    -1,    -1,   267,
      -1,    -1,   224,   271,   226,    -1,    -1,    -1,   276,    -1,
     285,    -1,    -1,   281,    -1,    -1,   284,    -1,    -1,    -1,
      -1,    -1,   290,    -1,    -1,    -1,    -1,    -1,    -1,    16,
      -1,    -1,    -1,  2500,    -1,    -1,    -1,    -1,    25,    -1,
      -1,    -1,    -1,    30,    -1,    -1,    -1,    -1,    -1,   317,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,   325,    -1,   327,
      -1,  2500,   330,   285,    -1,   333,    -1,    -1,    -1,  1968,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,   356,    -1,    -1,   359,   360,   361,    -1,   363,   364,
     365,   366,   367,   368,  1993,    -1,    -1,    -1,    -1,   374,
      -1,    -1,    -1,  2798,   372,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,   356,    -1,   123,   359,   360,   361,
      -1,   363,   364,   365,   366,   367,   368,    -1,    -1,    -1,
     137,    -1,   374,    -1,   141,    -1,    -1,    16,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    25,    -1,    -1,    -1,
      -1,    30,    -1,    -1,   161,   162,    16,  2076,    -1,    -1,
      -1,    -1,    -1,    -1,  2651,    25,    -1,   174,    -1,    -1,
      30,    -1,    -1,  2092,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,  2675,    -1,
      -1,    -1,  2651,    -1,    -1,    -1,  2683,    -1,    -1,    -1,
      -1,   208,  2917,    -1,   211,    -1,  2125,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,  2675,   224,    -1,   226,
      -1,    -1,    -1,    -1,  2683,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,  2151,  2152,  2153,    -1,    -1,  2156,  2157,  2158,
    2159,  2160,  2161,  2162,  2163,  2164,    -1,  2166,  2167,    -1,
      -1,    16,    -1,    -1,    -1,    -1,    -1,    -1,   137,    -1,
      25,    -1,   141,  2978,    -1,    30,    -1,    -1,  2187,    -1,
      -1,    -1,    -1,  2192,  2193,    -1,    -1,   137,   285,    -1,
      -1,   141,   161,   162,    -1,    -1,  2205,  2206,  2207,    -1,
    2209,    -1,    -1,  2212,    -1,   174,    -1,    -1,    -1,    -1,
      -1,   161,   162,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,  2798,    -1,    -1,   174,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,   208,
      -1,    -1,   211,    -1,  2253,    -1,    -1,    -1,    -1,  2798,
      -1,    -1,    -1,    -1,    -1,   224,    -1,   226,   208,   356,
      -1,   211,   359,   360,   361,    -1,   363,   364,   365,   366,
     367,   368,    -1,    -1,   224,    -1,   226,   374,    -1,    -1,
      -1,    -1,   137,    -1,    -1,    -1,   141,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,   161,   162,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,   285,    -1,    -1,   174,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,   285,    -1,    -1,    -1,    -1,
    2917,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,  2358,
      -1,    -1,    -1,   208,    -1,    -1,   211,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,  2917,   224,
      -1,   226,    16,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    25,    -1,    -1,    -1,    -1,    30,   356,    -1,    -1,
     359,   360,   361,    -1,   363,   364,   365,   366,   367,   368,
      -1,  2978,   371,    -1,    -1,   374,   356,    -1,    -1,   359,
     360,   361,    16,   363,   364,   365,   366,   367,   368,    -1,
      -1,    25,    -1,   373,   374,    -1,    30,    -1,    -1,  2978,
     285,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,  2454,    -1,    -1,    -1,    -1,
    2459,  2460,   307,  2462,    -1,  2464,    -1,    -1,    -1,  2468,
    2469,  2470,  2471,  2472,  2473,  2474,  2475,  2476,    -1,  2478,
    2479,  2480,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,  2493,  2494,  2495,  2496,    -1,  2498,
      -1,    -1,    -1,   137,  2503,  2504,  2505,   141,    -1,  2508,
      -1,   356,  2511,    -1,   359,   360,   361,    -1,   363,   364,
     365,   366,   367,   368,    -1,    -1,    -1,   161,   162,   374,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
     174,    -1,    -1,   137,    -1,    -1,    -1,   141,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,   161,   162,    -1,
      -1,    -1,    -1,    -1,   208,    -1,    -1,   211,    -1,    -1,
     174,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
     224,    -1,   226,    -1,    -1,  2594,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,   208,    -1,    -1,   211,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
     224,    -1,   226,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,   285,    -1,  2652,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,  2665,    -1,    -1,    -1,
      -1,    -1,    -1,  2672,    -1,    -1,    -1,    -1,    -1,  2678,
    2679,  2680,    -1,    -1,    -1,  2684,  2685,  2686,  2687,    -1,
    2689,   285,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,   356,    -1,    -1,   359,   360,   361,    -1,   363,
     364,   365,   366,   367,   368,    -1,    -1,    -1,  2737,   373,
     374,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,   356,    -1,    -1,   359,   360,   361,    -1,   363,
     364,   365,   366,   367,   368,    -1,    -1,    -1,    -1,   373,
     374,  2780,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,  2796,  2797,    -1,
      -1,    -1,    -1,  2802,  2803,  2804,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,  2814,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,     3,     4,     5,
       6,     7,     8,     9,    10,    -1,    12,    13,    -1,    -1,
      -1,    -1,    -1,    -1,  2853,    -1,    22,    23,    -1,    25,
      -1,    27,    28,    29,    -1,    31,  2865,    33,    34,  2868,
      36,    37,    38,    39,    40,    -1,    -1,    43,    44,    45,
      46,    -1,    48,    49,    50,    51,    52,    -1,    -1,    55,
      56,    57,    58,    59,    -1,    61,    62,    63,    64,    -1,
      66,    67,    68,    -1,    70,    -1,    -1,    -1,    -1,    -1,
      76,    77,    78,    79,    80,    81,    82,    83,    -1,    85,
      -1,    87,    88,    89,    90,    91,    -1,    93,    -1,  2928,
      96,    97,    98,    99,    -1,   101,   102,   103,    -1,   105,
      -1,   107,   108,   109,   110,   111,   112,   113,    -1,   115,
     116,   117,    -1,   119,    -1,   121,    -1,    -1,    -1,   125,
     126,    -1,   128,   129,    -1,   131,    -1,   133,   134,   135,
     136,    -1,   138,   139,   140,    -1,   142,   143,   144,   145,
     146,   147,    -1,    -1,   150,   151,   152,   153,   154,   155,
     156,    -1,   158,    -1,   160,    -1,    -1,   163,    -1,   165,
     166,   167,   168,   169,    -1,   171,    -1,   173,    -1,    -1,
     176,   177,   178,    -1,    -1,   181,   182,   183,   184,   185,
     186,   187,   188,   189,   190,    -1,    -1,    -1,   194,   195,
      -1,   197,    -1,   199,   200,   201,   202,   203,   204,   205,
     206,   207,    -1,   209,   210,    -1,   212,    -1,   214,   215,
     216,   217,    -1,    -1,   220,    -1,    -1,    -1,   224,   225,
      -1,    -1,   228,    -1,    -1,   231,   232,   233,   234,   235,
      -1,   237,   238,   239,   240,   241,    -1,   243,   244,   245,
     246,   247,   248,   249,   250,   251,    -1,   253,   254,   255,
     256,   257,   258,   259,   260,   261,    -1,   263,   264,    -1,
     266,   267,   268,   269,   270,   271,   272,   273,   274,   275,
      -1,   277,   278,   279,    -1,   281,   282,   283,   284,    -1,
     286,   287,    -1,   289,   290,   291,   292,   293,   294,   295,
     296,   297,   298,    -1,   300,   301,    -1,   303,   304,   305,
     306,    -1,   308,   309,    -1,    -1,   312,   313,   314,   315,
      -1,   317,   318,   319,   320,   321,    -1,    -1,   324,   325,
     326,   327,    -1,   329,   330,   331,   332,   333,   334,   335,
      -1,   337,   338,    -1,    -1,   341,    -1,   343,   344,   345,
     346,   347,    -1,    -1,    -1,   351,    -1,    -1,    -1,    -1,
      -1,     3,     4,     5,     6,     7,     8,     9,    10,    11,
      12,    13,    -1,    -1,   370,    -1,    -1,    19,    -1,   375,
      22,    23,    -1,    25,    26,    27,    28,    29,    30,    31,
      32,    33,    34,    -1,    36,    37,    38,    39,    40,    41,
      42,    43,    44,    45,    46,    -1,    48,    49,    50,    51,
      52,    -1,    -1,    55,    56,    57,    58,    59,    -1,    61,
      62,    63,    64,    -1,    66,    67,    68,    69,    70,    71,
      72,    73,    74,    75,    76,    77,    78,    79,    80,    81,
      82,    83,    -1,    85,    -1,    87,    88,    89,    90,    91,
      -1,    93,    94,    -1,    96,    97,    98,    99,    -1,   101,
     102,   103,    -1,   105,    -1,   107,   108,   109,   110,   111,
     112,   113,   114,   115,   116,   117,    -1,   119,    -1,   121,
     122,    -1,   124,   125,   126,    -1,   128,   129,    -1,   131,
      -1,   133,   134,   135,   136,   137,   138,   139,   140,    -1,
     142,   143,   144,   145,   146,   147,    -1,   149,   150,   151,
     152,   153,   154,   155,   156,    -1,   158,    -1,   160,   161,
     162,   163,   164,   165,   166,   167,   168,   169,    -1,   171,
     172,   173,   174,    -1,   176,   177,   178,   179,   180,   181,
     182,   183,   184,   185,   186,   187,   188,   189,   190,    -1,
      -1,    -1,   194,   195,   196,   197,   198,   199,   200,   201,
     202,   203,   204,   205,   206,   207,   208,   209,   210,   211,
     212,   213,   214,   215,   216,   217,    -1,    -1,   220,   221,
      -1,    -1,   224,   225,    -1,    -1,   228,   229,   230,   231,
     232,   233,   234,   235,    -1,   237,   238,   239,   240,   241,
      -1,   243,   244,   245,   246,   247,   248,   249,   250,   251,
      -1,   253,   254,   255,   256,   257,   258,   259,   260,   261,
      -1,   263,   264,   265,   266,   267,   268,   269,   270,   271,
     272,   273,   274,   275,    -1,   277,   278,   279,   280,   281,
     282,   283,   284,   285,   286,   287,    -1,   289,   290,   291,
     292,   293,   294,   295,   296,   297,   298,    -1,   300,   301,
      -1,   303,   304,   305,   306,    -1,   308,   309,    -1,    -1,
     312,   313,   314,   315,   316,   317,   318,   319,   320,   321,
      -1,   323,   324,   325,   326,   327,   328,    -1,   330,   331,
     332,   333,   334,   335,   336,   337,   338,    -1,    -1,   341,
      -1,   343,   344,   345,   346,   347,    -1,    -1,    -1,   351,
     352,   353,   354,   355,   356,   357,   358,    -1,    -1,    -1,
      -1,   363,   364,   365,    -1,    -1,    -1,    -1,    -1,    -1,
     372,   373,     3,     4,     5,     6,     7,     8,     9,    10,
      -1,    12,    13,    -1,    -1,    -1,    -1,    -1,    19,    -1,
      -1,    22,    23,    -1,    25,    26,    27,    28,    29,    30,
      31,    32,    33,    34,    -1,    36,    37,    38,    39,    40,
      41,    42,    43,    44,    45,    46,    -1,    48,    49,    50,
      51,    52,    -1,    -1,    55,    56,    57,    58,    59,    -1,
      61,    62,    63,    64,    -1,    66,    67,    68,    69,    70,
      71,    72,    73,    74,    75,    76,    77,    78,    79,    80,
      81,    82,    83,    -1,    85,    -1,    87,    88,    89,    90,
      91,    -1,    93,    -1,    -1,    96,    97,    98,    99,    -1,
     101,   102,   103,    -1,   105,    -1,   107,   108,   109,   110,
     111,   112,   113,   114,   115,   116,   117,    -1,   119,    -1,
     121,   122,    -1,   124,   125,   126,    -1,   128,   129,    -1,
     131,    -1,   133,   134,   135,   136,   137,   138,   139,   140,
      -1,   142,   143,   144,   145,   146,   147,    -1,   149,   150,
     151,   152,   153,   154,   155,   156,    -1,   158,    -1,   160,
     161,   162,   163,   164,   165,   166,   167,   168,   169,    -1,
     171,   172,   173,   174,    -1,   176,   177,   178,   179,   180,
     181,   182,   183,   184,   185,   186,   187,   188,   189,   190,
      -1,    -1,    -1,   194,   195,   196,   197,   198,   199,   200,
     201,   202,   203,   204,   205,   206,   207,   208,   209,   210,
     211,   212,   213,   214,   215,   216,   217,    -1,    -1,   220,
     221,    -1,    -1,   224,   225,    -1,    -1,   228,   229,   230,
     231,   232,   233,   234,   235,    -1,   237,   238,   239,   240,
     241,    -1,   243,   244,   245,   246,   247,   248,   249,   250,
     251,    -1,   253,   254,   255,   256,   257,   258,   259,   260,
     261,    -1,   263,   264,   265,   266,   267,   268,   269,   270,
     271,   272,   273,   274,   275,    -1,   277,   278,   279,   280,
     281,   282,   283,   284,   285,   286,   287,    -1,   289,   290,
     291,   292,   293,   294,   295,   296,   297,   298,    -1,   300,
     301,    -1,   303,   304,   305,   306,    -1,   308,   309,    -1,
      -1,   312,   313,   314,   315,   316,   317,   318,   319,   320,
     321,    -1,   323,   324,   325,   326,   327,   328,    -1,   330,
     331,   332,   333,   334,   335,   336,   337,   338,    -1,    -1,
     341,    -1,   343,   344,   345,   346,   347,    -1,    -1,    -1,
     351,   352,   353,   354,   355,   356,   357,   358,    -1,    -1,
      -1,    -1,   363,   364,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,   372,   373,     3,     4,     5,     6,     7,     8,     9,
      10,    -1,    12,    13,    -1,    -1,    -1,    -1,    -1,    -1,
      20,    -1,    22,    23,    -1,    25,    -1,    27,    28,    29,
      -1,    31,    -1,    33,    34,    -1,    36,    37,    38,    39,
      40,    -1,    -1,    43,    44,    45,    46,    -1,    48,    49,
      50,    51,    52,    -1,    -1,    55,    56,    57,    58,    59,
      -1,    61,    62,    63,    64,    -1,    66,    67,    68,    69,
      70,    -1,    -1,    -1,    -1,    -1,    76,    77,    78,    79,
      80,    81,    82,    83,    -1,    85,    -1,    87,    88,    89,
      90,    91,    -1,    93,    -1,    -1,    96,    97,    98,    99,
      -1,   101,   102,   103,    -1,   105,    -1,   107,   108,   109,
     110,   111,   112,   113,    -1,   115,   116,   117,    -1,   119,
      -1,   121,    -1,    -1,   124,   125,   126,    -1,   128,   129,
      -1,   131,    -1,   133,   134,   135,   136,    -1,   138,   139,
     140,    -1,   142,   143,   144,   145,   146,   147,    -1,   149,
     150,   151,   152,   153,   154,   155,   156,    -1,   158,    -1,
     160,    -1,    -1,   163,   164,   165,   166,   167,   168,   169,
      -1,   171,   172,   173,    -1,    -1,   176,   177,   178,    -1,
      -1,   181,   182,   183,   184,   185,   186,   187,   188,   189,
     190,    -1,    -1,    -1,   194,   195,   196,   197,    -1,   199,
     200,   201,   202,   203,   204,   205,   206,   207,    -1,   209,
     210,    -1,   212,    -1,   214,   215,   216,   217,    -1,    -1,
     220,    -1,    -1,    -1,   224,   225,    -1,    -1,   228,    -1,
      -1,   231,   232,   233,   234,   235,    -1,   237,   238,   239,
     240,   241,    -1,   243,   244,   245,   246,   247,   248,   249,
     250,   251,    -1,   253,   254,   255,   256,   257,   258,   259,
     260,   261,    -1,   263,   264,   265,   266,   267,   268,   269,
     270,   271,   272,   273,   274,   275,    -1,   277,   278,   279,
      -1,   281,   282,   283,   284,    -1,   286,   287,    -1,   289,
     290,   291,   292,   293,   294,   295,   296,   297,   298,    -1,
     300,   301,    -1,   303,   304,   305,   306,    -1,   308,   309,
      -1,    -1,   312,   313,   314,   315,    -1,   317,   318,   319,
     320,   321,    -1,    -1,   324,   325,   326,   327,    -1,    -1,
     330,   331,   332,   333,   334,   335,    -1,   337,   338,    -1,
      -1,   341,    -1,   343,   344,   345,   346,   347,    -1,    -1,
      -1,   351,     3,     4,     5,     6,     7,     8,     9,    10,
      -1,    12,    13,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    22,    23,   373,    25,    26,    27,    28,    29,    30,
      31,    32,    33,    34,    -1,    36,    37,    38,    39,    40,
      -1,    -1,    43,    44,    45,    46,    -1,    48,    49,    50,
      51,    -1,    -1,    -1,    55,    56,    57,    58,    59,    -1,
      61,    62,    -1,    64,    -1,    66,    67,    68,    69,    70,
      -1,    -1,    -1,    -1,    -1,    76,    77,    78,    79,    80,
      81,    82,    83,    -1,    85,    -1,    87,    88,    89,    90,
      91,    -1,    93,    -1,    -1,    96,    97,    98,    99,    -1,
     101,   102,   103,    -1,   105,    -1,   107,   108,   109,    -1,
     111,   112,    -1,    -1,   115,   116,   117,    -1,   119,    -1,
     121,   122,    -1,   124,   125,   126,    -1,   128,    -1,    -1,
     131,    -1,   133,   134,   135,   136,   137,   138,   139,   140,
     141,   142,   143,   144,   145,   146,   147,    -1,   149,   150,
     151,   152,   153,   154,   155,   156,    -1,   158,    -1,   160,
     161,   162,   163,   164,   165,   166,   167,   168,   169,    -1,
      -1,   172,   173,   174,    -1,   176,   177,   178,    -1,    -1,
     181,   182,   183,   184,   185,   186,   187,   188,   189,   190,
      -1,    -1,    -1,   194,   195,   196,   197,    -1,   199,   200,
     201,   202,   203,   204,   205,    -1,   207,    -1,   209,   210,
     211,   212,    -1,    -1,   215,   216,   217,    -1,    -1,   220,
      -1,    -1,    -1,   224,   225,    -1,    -1,   228,   229,   230,
      -1,   232,   233,   234,   235,    -1,    -1,    -1,   239,   240,
     241,    -1,   243,   244,   245,   246,   247,   248,   249,   250,
     251,    -1,   253,   254,   255,   256,   257,   258,   259,   260,
     261,    -1,   263,   264,   265,   266,   267,    -1,   269,   270,
     271,   272,   273,   274,   275,    -1,   277,   278,   279,    -1,
     281,   282,   283,   284,   285,   286,   287,    -1,   289,   290,
     291,   292,   293,   294,   295,   296,    -1,   298,    -1,   300,
     301,    -1,   303,   304,   305,   306,    -1,   308,   309,    -1,
      -1,   312,    -1,   314,    -1,    -1,   317,   318,   319,   320,
     321,    -1,    -1,   324,   325,   326,   327,    -1,    -1,   330,
     331,   332,    -1,   334,   335,   336,   337,   338,    -1,    -1,
     341,    -1,   343,   344,   345,   346,   347,    -1,    -1,    -1,
     351,     3,     4,     5,     6,     7,     8,     9,    10,    -1,
      12,    13,    -1,    -1,    -1,    -1,    -1,    19,    -1,    -1,
      22,    23,   373,    25,    26,    27,    28,    29,    30,    31,
      32,    33,    34,    35,    36,    37,    38,    39,    40,    41,
      42,    43,    44,    45,    46,    -1,    48,    49,    50,    51,
      52,    -1,    -1,    55,    56,    57,    58,    59,    -1,    61,
      62,    63,    64,    -1,    66,    67,    68,    69,    70,    71,
      72,    73,    74,    75,    76,    77,    78,    79,    80,    81,
      82,    83,    -1,    85,    -1,    87,    88,    89,    90,    91,
      -1,    93,    -1,    -1,    96,    97,    98,    99,    -1,   101,
     102,   103,    -1,   105,    -1,   107,   108,   109,   110,   111,
     112,   113,   114,   115,   116,   117,    -1,   119,    -1,   121,
     122,   123,   124,   125,   126,    -1,   128,   129,    -1,   131,
      -1,   133,   134,   135,   136,   137,   138,   139,   140,    -1,
     142,   143,   144,   145,   146,   147,    -1,   149,   150,   151,
     152,   153,   154,   155,   156,    -1,   158,    -1,   160,   161,
     162,   163,   164,   165,   166,   167,   168,   169,   170,   171,
     172,   173,   174,    -1,   176,   177,   178,   179,   180,   181,
     182,   183,   184,   185,   186,   187,   188,   189,   190,    -1,
      -1,    -1,   194,   195,   196,   197,   198,   199,   200,   201,
     202,   203,   204,   205,   206,   207,   208,   209,   210,   211,
     212,   213,   214,   215,   216,   217,    -1,    -1,   220,   221,
      -1,    -1,   224,   225,    -1,    -1,   228,   229,   230,   231,
     232,   233,   234,   235,    -1,   237,   238,   239,   240,   241,
      -1,   243,   244,   245,   246,   247,   248,   249,   250,   251,
      -1,   253,   254,   255,   256,   257,   258,   259,   260,   261,
      -1,   263,   264,   265,   266,   267,   268,   269,   270,   271,
     272,   273,   274,   275,    -1,   277,   278,   279,   280,   281,
     282,   283,   284,   285,   286,   287,    -1,   289,   290,   291,
     292,   293,   294,   295,   296,   297,   298,    -1,   300,   301,
      -1,   303,   304,   305,   306,    -1,   308,   309,    -1,   311,
     312,   313,   314,   315,   316,   317,   318,   319,   320,   321,
      -1,   323,   324,   325,   326,   327,   328,    -1,   330,   331,
     332,   333,   334,   335,   336,   337,   338,    -1,    -1,   341,
      -1,   343,   344,   345,   346,   347,    -1,    -1,    -1,   351,
     352,   353,   354,   355,   356,   357,   358,    -1,    -1,    -1,
      -1,   363,   364,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
     372,     3,     4,     5,     6,     7,     8,     9,    10,    -1,
      12,    13,    -1,    -1,    -1,    -1,    -1,    19,    -1,    -1,
      22,    23,    -1,    25,    26,    27,    28,    29,    30,    31,
      32,    33,    34,    -1,    36,    37,    38,    39,    40,    41,
      42,    43,    44,    45,    46,    -1,    48,    49,    50,    51,
      52,    -1,    -1,    55,    56,    57,    58,    59,    -1,    61,
      62,    63,    64,    -1,    66,    67,    68,    69,    70,    71,
      72,    73,    74,    75,    76,    77,    78,    79,    80,    81,
      82,    83,    -1,    85,    -1,    87,    88,    89,    90,    91,
      -1,    93,    -1,    -1,    96,    97,    98,    99,    -1,   101,
     102,   103,    -1,   105,    -1,   107,   108,   109,   110,   111,
     112,   113,   114,   115,   116,   117,    -1,   119,    -1,   121,
     122,    -1,   124,   125,   126,    -1,   128,   129,    -1,   131,
      -1,   133,   134,   135,   136,   137,   138,   139,   140,    -1,
     142,   143,   144,   145,   146,   147,    -1,   149,   150,   151,
     152,   153,   154,   155,   156,    -1,   158,    -1,   160,   161,
     162,   163,   164,   165,   166,   167,   168,   169,    -1,   171,
     172,   173,   174,    -1,   176,   177,   178,   179,   180,   181,
     182,   183,   184,   185,   186,   187,   188,   189,   190,    -1,
      -1,    -1,   194,   195,   196,   197,   198,   199,   200,   201,
     202,   203,   204,   205,   206,   207,   208,   209,   210,   211,
     212,   213,   214,   215,   216,   217,    -1,    -1,   220,   221,
      -1,    -1,   224,   225,    -1,    -1,   228,   229,   230,   231,
     232,   233,   234,   235,    -1,   237,   238,   239,   240,   241,
      -1,   243,   244,   245,   246,   247,   248,   249,   250,   251,
      -1,   253,   254,   255,   256,   257,   258,   259,   260,   261,
      -1,   263,   264,   265,   266,   267,   268,   269,   270,   271,
     272,   273,   274,   275,    -1,   277,   278,   279,   280,   281,
     282,   283,   284,   285,   286,   287,    -1,   289,   290,   291,
     292,   293,   294,   295,   296,   297,   298,    -1,   300,   301,
      -1,   303,   304,   305,   306,    -1,   308,   309,    -1,    -1,
     312,   313,   314,   315,   316,   317,   318,   319,   320,   321,
      -1,   323,   324,   325,   326,   327,   328,    -1,   330,   331,
     332,   333,   334,   335,   336,   337,   338,    -1,    -1,   341,
      -1,   343,   344,   345,   346,   347,    -1,    -1,    -1,   351,
     352,   353,   354,   355,   356,   357,   358,    -1,    -1,    -1,
      -1,   363,   364,   365,    -1,    -1,    -1,    -1,    -1,    -1,
     372,     3,     4,     5,     6,     7,     8,     9,    10,    -1,
      12,    13,    -1,    -1,    -1,    -1,    -1,    19,    -1,    -1,
      22,    23,    -1,    25,    26,    27,    28,    29,    30,    31,
      32,    33,    34,    -1,    36,    37,    38,    39,    40,    41,
      42,    43,    44,    45,    46,    -1,    48,    49,    50,    51,
      52,    -1,    -1,    55,    56,    57,    58,    59,    -1,    61,
      62,    63,    64,    -1,    66,    67,    68,    69,    70,    71,
      72,    73,    74,    75,    76,    77,    78,    79,    80,    81,
      82,    83,    84,    85,    -1,    87,    88,    89,    90,    91,
      -1,    93,    -1,    -1,    96,    97,    98,    99,    -1,   101,
     102,   103,    -1,   105,    -1,   107,   108,   109,   110,   111,
     112,   113,   114,   115,   116,   117,    -1,   119,    -1,   121,
     122,    -1,   124,   125,   126,    -1,   128,   129,    -1,   131,
      -1,   133,   134,   135,   136,   137,   138,   139,   140,    -1,
     142,   143,   144,   145,   146,   147,    -1,   149,   150,   151,
     152,   153,   154,   155,   156,    -1,   158,    -1,   160,   161,
     162,   163,   164,   165,   166,   167,   168,   169,    -1,   171,
     172,   173,   174,    -1,   176,   177,   178,   179,   180,   181,
     182,   183,   184,   185,   186,   187,   188,   189,   190,    -1,
      -1,    -1,   194,   195,   196,   197,   198,   199,   200,   201,
     202,   203,   204,   205,   206,   207,   208,   209,   210,   211,
     212,   213,   214,   215,   216,   217,    -1,    -1,   220,   221,
      -1,    -1,   224,   225,    -1,    -1,   228,   229,   230,   231,
     232,   233,   234,   235,    -1,   237,   238,   239,   240,   241,
      -1,   243,   244,   245,   246,   247,   248,   249,   250,   251,
      -1,   253,   254,   255,   256,   257,   258,   259,   260,   261,
      -1,   263,   264,   265,   266,   267,   268,   269,   270,   271,
     272,   273,   274,   275,    -1,   277,   278,   279,   280,   281,
     282,   283,   284,   285,   286,   287,    -1,   289,   290,   291,
     292,   293,   294,   295,   296,   297,   298,    -1,   300,   301,
      -1,   303,   304,   305,   306,    -1,   308,   309,    -1,    -1,
     312,   313,   314,   315,   316,   317,   318,   319,   320,   321,
      -1,   323,   324,   325,   326,   327,   328,    -1,   330,   331,
     332,   333,   334,   335,   336,   337,   338,    -1,    -1,   341,
      -1,   343,   344,   345,   346,   347,    -1,    -1,    -1,   351,
     352,   353,   354,   355,   356,   357,   358,    -1,    -1,    -1,
      -1,   363,   364,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
     372,     3,     4,     5,     6,     7,     8,     9,    10,    -1,
      12,    13,    -1,    -1,    -1,    -1,    -1,    19,    -1,    -1,
      22,    23,    -1,    25,    26,    27,    28,    29,    30,    31,
      32,    33,    34,    -1,    36,    37,    38,    39,    40,    41,
      42,    43,    44,    45,    46,    -1,    48,    49,    50,    51,
      52,    -1,    -1,    55,    56,    57,    58,    59,    -1,    61,
      62,    63,    64,    -1,    66,    67,    68,    69,    70,    71,
      72,    73,    74,    75,    76,    77,    78,    79,    80,    81,
      82,    83,    -1,    85,    -1,    87,    88,    89,    90,    91,
      -1,    93,    -1,    -1,    96,    97,    98,    99,    -1,   101,
     102,   103,    -1,   105,    -1,   107,   108,   109,   110,   111,
     112,   113,   114,   115,   116,   117,    -1,   119,    -1,   121,
     122,    -1,   124,   125,   126,    -1,   128,   129,    -1,   131,
      -1,   133,   134,   135,   136,   137,   138,   139,   140,    -1,
     142,   143,   144,   145,   146,   147,    -1,   149,   150,   151,
     152,   153,   154,   155,   156,    -1,   158,    -1,   160,   161,
     162,   163,   164,   165,   166,   167,   168,   169,    -1,   171,
     172,   173,   174,    -1,   176,   177,   178,   179,   180,   181,
     182,   183,   184,   185,   186,   187,   188,   189,   190,    -1,
      -1,    -1,   194,   195,   196,   197,   198,   199,   200,   201,
     202,   203,   204,   205,   206,   207,   208,   209,   210,   211,
     212,   213,   214,   215,   216,   217,    -1,    -1,   220,   221,
      -1,    -1,   224,   225,    -1,    -1,   228,   229,   230,   231,
     232,   233,   234,   235,    -1,   237,   238,   239,   240,   241,
      -1,   243,   244,   245,   246,   247,   248,   249,   250,   251,
      -1,   253,   254,   255,   256,   257,   258,   259,   260,   261,
      -1,   263,   264,   265,   266,   267,   268,   269,   270,   271,
     272,   273,   274,   275,   276,   277,   278,   279,   280,   281,
     282,   283,   284,   285,   286,   287,    -1,   289,   290,   291,
     292,   293,   294,   295,   296,   297,   298,    -1,   300,   301,
      -1,   303,   304,   305,   306,    -1,   308,   309,    -1,    -1,
     312,   313,   314,   315,   316,   317,   318,   319,   320,   321,
      -1,   323,   324,   325,   326,   327,   328,    -1,   330,   331,
     332,   333,   334,   335,   336,   337,   338,    -1,    -1,   341,
      -1,   343,   344,   345,   346,   347,    -1,    -1,    -1,   351,
     352,   353,   354,   355,   356,   357,   358,    -1,    -1,    -1,
      -1,   363,   364,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
     372,     3,     4,     5,     6,     7,     8,     9,    10,    11,
      12,    13,    -1,    -1,    -1,    -1,    -1,    19,    -1,    -1,
      22,    23,    -1,    25,    26,    27,    28,    29,    30,    31,
      32,    33,    34,    -1,    36,    37,    38,    39,    40,    41,
      42,    43,    44,    45,    46,    -1,    48,    49,    50,    51,
      52,    -1,    -1,    55,    56,    57,    58,    59,    -1,    61,
      62,    63,    64,    -1,    66,    67,    68,    69,    70,    71,
      72,    73,    74,    75,    76,    77,    78,    79,    80,    81,
      82,    83,    -1,    85,    -1,    87,    88,    89,    90,    91,
      -1,    93,    -1,    -1,    96,    97,    98,    99,    -1,   101,
     102,   103,    -1,   105,    -1,   107,   108,   109,   110,   111,
     112,   113,   114,   115,   116,   117,    -1,   119,    -1,   121,
     122,    -1,   124,   125,   126,    -1,   128,   129,    -1,   131,
      -1,   133,   134,   135,   136,   137,   138,   139,   140,    -1,
     142,   143,   144,   145,   146,   147,    -1,   149,   150,   151,
     152,   153,   154,   155,   156,    -1,   158,    -1,   160,   161,
     162,   163,   164,   165,   166,   167,   168,   169,    -1,   171,
     172,   173,   174,    -1,   176,   177,   178,   179,   180,   181,
     182,   183,   184,   185,   186,   187,   188,   189,   190,    -1,
      -1,    -1,   194,   195,   196,   197,   198,   199,   200,   201,
     202,   203,   204,   205,   206,   207,   208,   209,   210,   211,
     212,   213,   214,   215,   216,   217,    -1,    -1,   220,   221,
      -1,    -1,   224,   225,    -1,    -1,   228,   229,   230,   231,
     232,   233,   234,   235,    -1,   237,   238,   239,   240,   241,
      -1,   243,   244,   245,   246,   247,   248,   249,   250,   251,
      -1,   253,   254,   255,   256,   257,   258,   259,   260,   261,
      -1,   263,   264,   265,   266,   267,   268,   269,   270,   271,
     272,   273,   274,   275,    -1,   277,   278,   279,   280,   281,
     282,   283,   284,   285,   286,   287,    -1,   289,   290,   291,
     292,   293,   294,   295,   296,   297,   298,    -1,   300,   301,
      -1,   303,   304,   305,   306,    -1,   308,   309,    -1,    -1,
     312,   313,   314,   315,   316,   317,   318,   319,   320,   321,
      -1,   323,   324,   325,   326,   327,   328,    -1,   330,   331,
     332,   333,   334,   335,   336,   337,   338,    -1,    -1,   341,
      -1,   343,   344,   345,   346,   347,    -1,    -1,    -1,   351,
     352,   353,   354,   355,   356,   357,   358,    -1,    -1,    -1,
      -1,   363,   364,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
     372,     3,     4,     5,     6,     7,     8,     9,    10,    -1,
      12,    13,    -1,    -1,    -1,    -1,    -1,    19,    -1,    -1,
      22,    23,    -1,    25,    26,    27,    28,    29,    30,    31,
      32,    33,    34,    -1,    36,    37,    38,    39,    40,    41,
      42,    43,    44,    45,    46,    -1,    48,    49,    50,    51,
      52,    -1,    -1,    55,    56,    57,    58,    59,    -1,    61,
      62,    63,    64,    -1,    66,    67,    68,    69,    70,    71,
      72,    73,    74,    75,    76,    77,    78,    79,    80,    81,
      82,    83,    -1,    85,    -1,    87,    88,    89,    90,    91,
      -1,    93,    -1,    -1,    96,    97,    98,    99,    -1,   101,
     102,   103,    -1,   105,    -1,   107,   108,   109,   110,   111,
     112,   113,   114,   115,   116,   117,    -1,   119,    -1,   121,
     122,    -1,   124,   125,   126,    -1,   128,   129,    -1,   131,
      -1,   133,   134,   135,   136,   137,   138,   139,   140,    -1,
     142,   143,   144,   145,   146,   147,    -1,   149,   150,   151,
     152,   153,   154,   155,   156,    -1,   158,    -1,   160,   161,
     162,   163,   164,   165,   166,   167,   168,   169,    -1,   171,
     172,   173,   174,    -1,   176,   177,   178,   179,   180,   181,
     182,   183,   184,   185,   186,   187,   188,   189,   190,    -1,
      -1,    -1,   194,   195,   196,   197,   198,   199,   200,   201,
     202,   203,   204,   205,   206,   207,   208,   209,   210,   211,
     212,   213,   214,   215,   216,   217,    -1,    -1,   220,   221,
      -1,    -1,   224,   225,    -1,    -1,   228,   229,   230,   231,
     232,   233,   234,   235,    -1,   237,   238,   239,   240,   241,
      -1,   243,   244,   245,   246,   247,   248,   249,   250,   251,
      -1,   253,   254,   255,   256,   257,   258,   259,   260,   261,
      -1,   263,   264,   265,   266,   267,   268,   269,   270,   271,
     272,   273,   274,   275,    -1,   277,   278,   279,   280,   281,
     282,   283,   284,   285,   286,   287,    -1,   289,   290,   291,
     292,   293,   294,   295,   296,   297,   298,    -1,   300,   301,
      -1,   303,   304,   305,   306,    -1,   308,   309,    -1,    -1,
     312,   313,   314,   315,   316,   317,   318,   319,   320,   321,
      -1,   323,   324,   325,   326,   327,   328,    -1,   330,   331,
     332,   333,   334,   335,   336,   337,   338,    -1,    -1,   341,
      -1,   343,   344,   345,   346,   347,    -1,    -1,    -1,   351,
     352,   353,   354,   355,   356,   357,   358,    -1,    -1,    -1,
      -1,   363,   364,    -1,    -1,    -1,    -1,    -1,   370,    -1,
     372,     3,     4,     5,     6,     7,     8,     9,    10,    -1,
      12,    13,    -1,    -1,    -1,    -1,    -1,    19,    -1,    -1,
      22,    23,    -1,    25,    26,    27,    28,    29,    30,    31,
      32,    33,    34,    -1,    36,    37,    38,    39,    40,    41,
      42,    43,    44,    45,    46,    -1,    48,    49,    50,    51,
      52,    -1,    -1,    55,    56,    57,    58,    59,    -1,    61,
      62,    63,    64,    -1,    66,    67,    68,    69,    70,    71,
      72,    73,    74,    75,    76,    77,    78,    79,    80,    81,
      82,    83,    -1,    85,    -1,    87,    88,    89,    90,    91,
      -1,    93,    -1,    -1,    96,    97,    98,    99,    -1,   101,
     102,   103,    -1,   105,    -1,   107,   108,   109,   110,   111,
     112,   113,   114,   115,   116,   117,    -1,   119,    -1,   121,
     122,   123,   124,   125,   126,    -1,   128,   129,    -1,   131,
      -1,   133,   134,   135,   136,   137,   138,   139,   140,    -1,
     142,   143,   144,   145,   146,   147,    -1,   149,   150,   151,
     152,   153,   154,   155,   156,    -1,   158,    -1,   160,   161,
     162,   163,   164,   165,   166,   167,   168,   169,    -1,   171,
     172,   173,   174,    -1,   176,   177,   178,   179,   180,   181,
     182,   183,   184,   185,   186,   187,   188,   189,   190,    -1,
      -1,    -1,   194,   195,   196,   197,   198,   199,   200,   201,
     202,   203,   204,   205,   206,   207,   208,   209,   210,   211,
     212,   213,   214,   215,   216,   217,    -1,    -1,   220,   221,
      -1,    -1,   224,   225,    -1,    -1,   228,   229,   230,   231,
     232,   233,   234,   235,    -1,   237,   238,   239,   240,   241,
      -1,   243,   244,   245,   246,   247,   248,   249,   250,   251,
      -1,   253,   254,   255,   256,   257,   258,   259,   260,   261,
      -1,   263,   264,   265,   266,   267,   268,   269,   270,   271,
     272,   273,   274,   275,    -1,   277,   278,   279,   280,   281,
     282,   283,   284,   285,   286,   287,    -1,   289,   290,   291,
     292,   293,   294,   295,   296,   297,   298,    -1,   300,   301,
      -1,   303,   304,   305,   306,    -1,   308,   309,    -1,    -1,
     312,   313,   314,   315,   316,   317,   318,   319,   320,   321,
      -1,   323,   324,   325,   326,   327,   328,    -1,   330,   331,
     332,   333,   334,   335,   336,   337,   338,    -1,    -1,   341,
      -1,   343,   344,   345,   346,   347,    -1,    -1,    -1,   351,
     352,   353,   354,   355,   356,   357,   358,    -1,    -1,    -1,
      -1,   363,   364,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
     372,     3,     4,     5,     6,     7,     8,     9,    10,    -1,
      12,    13,    -1,    -1,    -1,    -1,    -1,    19,    -1,    -1,
      22,    23,    -1,    25,    26,    27,    28,    29,    30,    31,
      32,    33,    34,    -1,    36,    37,    38,    39,    40,    41,
      42,    43,    44,    45,    46,    -1,    48,    49,    50,    51,
      52,    -1,    -1,    55,    56,    57,    58,    59,    -1,    61,
      62,    63,    64,    -1,    66,    67,    68,    69,    70,    71,
      72,    73,    74,    75,    76,    77,    78,    79,    80,    81,
      82,    83,    -1,    85,    -1,    87,    88,    89,    90,    91,
      -1,    93,    -1,    -1,    96,    97,    98,    99,    -1,   101,
     102,   103,    -1,   105,    -1,   107,   108,   109,   110,   111,
     112,   113,   114,   115,   116,   117,    -1,   119,    -1,   121,
     122,    -1,   124,   125,   126,    -1,   128,   129,    -1,   131,
      -1,   133,   134,   135,   136,   137,   138,   139,   140,    -1,
     142,   143,   144,   145,   146,   147,    -1,   149,   150,   151,
     152,   153,   154,   155,   156,    -1,   158,    -1,   160,   161,
     162,   163,   164,   165,   166,   167,   168,   169,    -1,   171,
     172,   173,   174,    -1,   176,   177,   178,   179,   180,   181,
     182,   183,   184,   185,   186,   187,   188,   189,   190,    -1,
      -1,    -1,   194,   195,   196,   197,   198,   199,   200,   201,
     202,   203,   204,   205,   206,   207,   208,   209,   210,   211,
     212,   213,   214,   215,   216,   217,    -1,    -1,   220,   221,
      -1,    -1,   224,   225,    -1,    -1,   228,   229,   230,   231,
     232,   233,   234,   235,    -1,   237,   238,   239,   240,   241,
      -1,   243,   244,   245,   246,   247,   248,   249,   250,   251,
      -1,   253,   254,   255,   256,   257,   258,   259,   260,   261,
      -1,   263,   264,   265,   266,   267,   268,   269,   270,   271,
     272,   273,   274,   275,    -1,   277,   278,   279,   280,   281,
     282,   283,   284,   285,   286,   287,    -1,   289,   290,   291,
     292,   293,   294,   295,   296,   297,   298,    -1,   300,   301,
      -1,   303,   304,   305,   306,    -1,   308,   309,    -1,    -1,
     312,   313,   314,   315,   316,   317,   318,   319,   320,   321,
      -1,   323,   324,   325,   326,   327,   328,    -1,   330,   331,
     332,   333,   334,   335,   336,   337,   338,    -1,    -1,   341,
      -1,   343,   344,   345,   346,   347,    -1,    -1,    -1,   351,
     352,   353,   354,   355,   356,   357,   358,    -1,    -1,    -1,
      -1,   363,   364,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
     372,     3,     4,     5,     6,     7,     8,     9,    10,    -1,
      12,    13,    -1,    -1,    -1,    -1,    -1,    19,    -1,    -1,
      22,    23,    -1,    25,    26,    27,    28,    29,    30,    31,
      32,    33,    34,    -1,    36,    37,    38,    39,    40,    41,
      42,    43,    44,    45,    46,    -1,    48,    49,    50,    51,
      52,    -1,    -1,    55,    56,    57,    58,    59,    -1,    61,
      62,    63,    64,    -1,    66,    67,    68,    69,    70,    71,
      72,    73,    74,    75,    76,    77,    78,    79,    80,    81,
      82,    83,    -1,    85,    -1,    87,    88,    89,    90,    91,
      -1,    93,    -1,    -1,    96,    97,    98,    99,    -1,   101,
     102,   103,    -1,   105,    -1,   107,   108,   109,   110,   111,
     112,   113,   114,   115,   116,   117,    -1,   119,    -1,   121,
     122,    -1,   124,   125,   126,    -1,   128,   129,    -1,   131,
      -1,   133,   134,   135,   136,   137,   138,   139,   140,    -1,
     142,   143,   144,   145,   146,   147,    -1,   149,   150,   151,
     152,   153,   154,   155,   156,    -1,   158,    -1,   160,   161,
     162,   163,   164,   165,   166,   167,   168,   169,    -1,   171,
     172,   173,   174,    -1,   176,   177,   178,   179,   180,   181,
     182,   183,   184,   185,   186,   187,   188,   189,   190,    -1,
      -1,    -1,   194,   195,   196,   197,   198,   199,   200,   201,
     202,   203,   204,   205,   206,   207,    -1,   209,   210,   211,
     212,   213,   214,   215,   216,   217,    -1,    -1,   220,   221,
      -1,    -1,   224,   225,    -1,    -1,   228,   229,   230,   231,
     232,   233,   234,   235,    -1,   237,   238,   239,   240,   241,
      -1,   243,   244,   245,   246,   247,   248,   249,   250,   251,
      -1,   253,   254,   255,   256,   257,   258,   259,   260,   261,
      -1,   263,   264,   265,   266,   267,   268,   269,   270,   271,
     272,   273,   274,   275,    -1,   277,   278,   279,   280,   281,
     282,   283,   284,   285,   286,   287,    -1,   289,   290,   291,
     292,   293,   294,   295,   296,   297,   298,    -1,   300,   301,
      -1,   303,   304,   305,   306,    -1,   308,   309,    -1,    -1,
     312,   313,   314,   315,   316,   317,   318,   319,   320,   321,
      -1,    -1,   324,   325,   326,   327,   328,    -1,   330,   331,
     332,   333,   334,   335,   336,   337,   338,    -1,    -1,   341,
      -1,   343,   344,   345,   346,   347,    -1,    -1,    -1,   351,
     352,   353,   354,   355,   356,   357,   358,    -1,    -1,    -1,
      -1,   363,   364,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
     372,     3,     4,     5,     6,     7,     8,     9,    10,    -1,
      12,    13,    -1,    -1,    -1,    -1,    -1,    19,    -1,    -1,
      22,    23,    -1,    25,    26,    27,    28,    29,    -1,    31,
      32,    33,    34,    -1,    36,    37,    38,    39,    40,    41,
      42,    43,    44,    45,    46,    -1,    48,    49,    50,    51,
      52,    -1,    -1,    55,    56,    57,    58,    59,    -1,    61,
      62,    63,    64,    -1,    66,    67,    68,    69,    70,    71,
      72,    73,    74,    75,    76,    77,    78,    79,    80,    81,
      82,    83,    -1,    85,    -1,    87,    88,    89,    90,    91,
      -1,    93,    -1,    -1,    96,    97,    98,    99,    -1,   101,
     102,   103,    -1,    -1,    -1,   107,   108,   109,   110,   111,
     112,   113,   114,   115,   116,   117,    -1,   119,    -1,   121,
     122,    -1,   124,   125,   126,    -1,   128,   129,    -1,   131,
      -1,   133,   134,   135,   136,    -1,   138,   139,   140,    -1,
     142,   143,   144,   145,   146,   147,    -1,   149,   150,   151,
     152,   153,   154,   155,   156,    -1,   158,    -1,   160,   161,
     162,   163,   164,   165,   166,   167,   168,   169,    -1,   171,
     172,   173,    -1,    -1,   176,   177,   178,   179,   180,   181,
     182,   183,   184,   185,   186,   187,   188,   189,   190,    -1,
      -1,    -1,   194,   195,   196,   197,   198,   199,   200,   201,
     202,   203,   204,   205,   206,   207,    -1,   209,   210,   211,
     212,   213,   214,   215,   216,   217,    -1,    -1,   220,   221,
      -1,    -1,   224,   225,    -1,    -1,   228,   229,   230,   231,
     232,   233,   234,   235,    -1,   237,   238,   239,   240,   241,
      -1,   243,   244,   245,   246,   247,   248,   249,   250,   251,
      -1,   253,   254,   255,   256,   257,   258,   259,   260,   261,
      -1,   263,   264,   265,   266,   267,   268,   269,   270,   271,
     272,   273,   274,   275,    -1,   277,   278,   279,   280,   281,
     282,   283,   284,    -1,   286,   287,    -1,   289,   290,   291,
     292,   293,   294,   295,   296,   297,   298,    -1,   300,   301,
      -1,   303,   304,   305,   306,    -1,   308,   309,    -1,    -1,
     312,   313,   314,   315,   316,   317,   318,   319,   320,   321,
      -1,   323,   324,   325,   326,   327,   328,    -1,   330,   331,
     332,   333,   334,   335,   336,   337,   338,    -1,    -1,   341,
      -1,   343,   344,   345,   346,   347,    -1,    -1,    -1,   351,
     352,   353,   354,   355,   356,   357,   358,    -1,    -1,    -1,
      -1,   363,   364,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
     372,     3,     4,     5,     6,     7,     8,     9,    10,    -1,
      12,    13,    -1,    -1,    -1,    -1,    -1,    19,    -1,    -1,
      22,    23,    -1,    25,    26,    27,    28,    29,    -1,    31,
      32,    33,    34,    -1,    36,    37,    38,    39,    40,    41,
      42,    43,    44,    45,    46,    -1,    48,    49,    50,    51,
      52,    -1,    -1,    55,    56,    57,    58,    59,    -1,    61,
      62,    63,    64,    -1,    66,    67,    68,    69,    70,    71,
      72,    73,    74,    75,    76,    77,    78,    79,    80,    81,
      82,    83,    -1,    85,    -1,    87,    88,    89,    90,    91,
      -1,    93,    -1,    -1,    96,    97,    98,    99,    -1,   101,
     102,   103,    -1,    -1,    -1,   107,   108,   109,   110,   111,
     112,   113,   114,   115,   116,   117,    -1,   119,    -1,   121,
     122,    -1,   124,   125,   126,    -1,   128,   129,    -1,   131,
      -1,   133,   134,   135,   136,    -1,   138,   139,   140,    -1,
     142,   143,   144,   145,   146,   147,    -1,   149,   150,   151,
     152,   153,   154,   155,   156,    -1,   158,    -1,   160,   161,
     162,   163,   164,   165,   166,   167,   168,   169,    -1,   171,
     172,   173,    -1,    -1,   176,   177,   178,   179,   180,   181,
     182,   183,   184,   185,   186,   187,   188,   189,   190,    -1,
      -1,    -1,   194,   195,   196,   197,   198,   199,   200,   201,
     202,   203,   204,   205,   206,   207,    -1,   209,   210,   211,
     212,   213,   214,   215,   216,   217,    -1,    -1,   220,   221,
      -1,    -1,   224,   225,    -1,    -1,   228,   229,   230,   231,
     232,   233,   234,   235,    -1,   237,   238,   239,   240,   241,
      -1,   243,   244,   245,   246,   247,   248,   249,   250,   251,
      -1,   253,   254,   255,   256,   257,   258,   259,   260,   261,
      -1,   263,   264,   265,   266,   267,   268,   269,   270,   271,
     272,   273,   274,   275,    -1,   277,   278,   279,   280,   281,
     282,   283,   284,    -1,   286,   287,    -1,   289,   290,   291,
     292,   293,   294,   295,   296,   297,   298,    -1,   300,   301,
      -1,   303,   304,   305,   306,    -1,   308,   309,    -1,    -1,
     312,   313,   314,   315,   316,   317,   318,   319,   320,   321,
      -1,    -1,   324,   325,   326,   327,   328,    -1,   330,   331,
     332,   333,   334,   335,   336,   337,   338,    -1,    -1,   341,
      -1,   343,   344,   345,   346,   347,    -1,    -1,    -1,   351,
     352,   353,   354,   355,   356,   357,   358,    -1,    -1,    -1,
      -1,   363,   364,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
     372,     3,     4,     5,     6,     7,     8,     9,    10,    -1,
      12,    13,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      22,    23,    -1,    25,    26,    27,    28,    29,    30,    31,
      32,    33,    34,    -1,    36,    37,    38,    39,    40,    -1,
      42,    43,    44,    45,    46,    -1,    48,    49,    50,    51,
      52,    -1,    -1,    55,    56,    57,    58,    59,    -1,    61,
      62,    63,    64,    -1,    66,    67,    68,    69,    70,    71,
      72,    73,    74,    75,    76,    77,    78,    79,    80,    81,
      82,    83,    -1,    85,    -1,    87,    88,    89,    90,    91,
      -1,    93,    -1,    -1,    96,    97,    98,    99,    -1,   101,
     102,   103,    -1,   105,    -1,   107,   108,   109,   110,   111,
     112,   113,    -1,   115,   116,   117,    -1,   119,    -1,   121,
     122,    -1,   124,   125,   126,    -1,   128,   129,    -1,   131,
      -1,   133,   134,   135,   136,   137,   138,   139,   140,    -1,
     142,   143,   144,   145,   146,   147,    -1,   149,   150,   151,
     152,   153,   154,   155,   156,    -1,   158,    -1,   160,   161,
     162,   163,   164,   165,   166,   167,   168,   169,    -1,   171,
     172,   173,   174,    -1,   176,   177,   178,   179,   180,   181,
     182,   183,   184,   185,   186,   187,   188,   189,   190,    -1,
      -1,    -1,   194,   195,   196,   197,   198,   199,   200,   201,
     202,   203,   204,   205,   206,   207,    -1,   209,   210,   211,
     212,    -1,   214,   215,   216,   217,    -1,    -1,   220,   221,
      -1,   223,   224,   225,    -1,    -1,   228,   229,   230,   231,
     232,   233,   234,   235,    -1,   237,   238,   239,   240,   241,
      -1,   243,   244,   245,   246,   247,   248,   249,   250,   251,
      -1,   253,   254,   255,   256,   257,   258,   259,   260,   261,
      -1,   263,   264,   265,   266,   267,   268,   269,   270,   271,
     272,   273,   274,   275,   276,   277,   278,   279,   280,   281,
     282,   283,   284,   285,   286,   287,    -1,   289,   290,   291,
     292,   293,   294,   295,   296,   297,   298,    -1,   300,   301,
      -1,   303,   304,   305,   306,    -1,   308,   309,    -1,    -1,
     312,   313,   314,   315,    -1,   317,   318,   319,   320,   321,
      -1,    -1,   324,   325,   326,   327,   328,    -1,   330,   331,
     332,   333,   334,   335,   336,   337,   338,    -1,    -1,   341,
      -1,   343,   344,   345,   346,   347,    -1,    -1,    -1,   351,
      -1,    -1,     3,     4,     5,     6,     7,     8,     9,    10,
      -1,    12,    13,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
     372,    22,    23,    -1,    25,    26,    27,    28,    29,    30,
      31,    32,    33,    34,    -1,    36,    37,    38,    39,    40,
      -1,    42,    43,    44,    45,    46,    -1,    48,    49,    50,
      51,    52,    -1,    -1,    55,    56,    57,    58,    59,    -1,
      61,    62,    63,    64,    -1,    66,    67,    68,    69,    70,
      71,    72,    73,    74,    75,    76,    77,    78,    79,    80,
      81,    82,    83,    -1,    85,    -1,    87,    88,    89,    90,
      91,    -1,    93,    -1,    -1,    96,    97,    98,    99,    -1,
     101,   102,   103,    -1,   105,    -1,   107,   108,   109,   110,
     111,   112,   113,    -1,   115,   116,   117,    -1,   119,    -1,
     121,   122,    -1,   124,   125,   126,    -1,   128,   129,    -1,
     131,    -1,   133,   134,   135,   136,   137,   138,   139,   140,
      -1,   142,   143,   144,   145,   146,   147,    -1,   149,   150,
     151,   152,   153,   154,   155,   156,    -1,   158,    -1,   160,
     161,   162,   163,   164,   165,   166,   167,   168,   169,    -1,
     171,   172,   173,   174,    -1,   176,   177,   178,   179,   180,
     181,   182,   183,   184,   185,   186,   187,   188,   189,   190,
      -1,    -1,    -1,   194,   195,   196,   197,   198,   199,   200,
     201,   202,   203,   204,   205,   206,   207,    -1,   209,   210,
     211,   212,    -1,   214,   215,   216,   217,    -1,    -1,   220,
     221,    -1,   223,   224,   225,    -1,    -1,   228,   229,   230,
     231,   232,   233,   234,   235,    -1,   237,   238,   239,   240,
     241,    -1,   243,   244,   245,   246,   247,   248,   249,   250,
     251,    -1,   253,   254,   255,   256,   257,   258,   259,   260,
     261,    -1,   263,   264,   265,   266,   267,   268,   269,   270,
     271,   272,   273,   274,   275,    -1,   277,   278,   279,   280,
     281,   282,   283,   284,   285,   286,   287,    -1,   289,   290,
     291,   292,   293,   294,   295,   296,   297,   298,    -1,   300,
     301,    -1,   303,   304,   305,   306,    -1,   308,   309,    -1,
      -1,   312,   313,   314,   315,    -1,   317,   318,   319,   320,
     321,    -1,    -1,   324,   325,   326,   327,   328,    -1,   330,
     331,   332,   333,   334,   335,   336,   337,   338,    -1,    -1,
     341,    -1,   343,   344,   345,   346,   347,    -1,    -1,    -1,
     351,    -1,    -1,     3,     4,     5,     6,     7,     8,     9,
      10,    -1,    12,    13,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,   372,    22,    23,    -1,    25,    26,    27,    28,    29,
      30,    31,    32,    33,    34,    -1,    36,    37,    38,    39,
      40,    -1,    42,    43,    44,    45,    46,    -1,    48,    49,
      50,    51,    52,    -1,    -1,    55,    56,    57,    58,    59,
      -1,    61,    62,    63,    64,    -1,    66,    67,    68,    69,
      70,    71,    72,    73,    74,    75,    76,    77,    78,    79,
      80,    81,    82,    83,    -1,    85,    -1,    87,    88,    89,
      90,    91,    -1,    93,    -1,    -1,    96,    97,    98,    99,
      -1,   101,   102,   103,    -1,   105,    -1,   107,   108,   109,
     110,   111,   112,   113,    -1,   115,   116,   117,    -1,   119,
      -1,   121,   122,    -1,   124,   125,   126,    -1,   128,   129,
      -1,   131,    -1,   133,   134,   135,   136,   137,   138,   139,
     140,    -1,   142,   143,   144,   145,   146,   147,    -1,   149,
     150,   151,   152,   153,   154,   155,   156,    -1,   158,    -1,
     160,   161,   162,   163,   164,   165,   166,   167,   168,   169,
      -1,   171,   172,   173,   174,    -1,   176,   177,   178,   179,
     180,   181,   182,   183,   184,   185,   186,   187,   188,   189,
     190,    -1,    -1,    -1,   194,   195,   196,   197,   198,   199,
     200,   201,   202,   203,   204,   205,   206,   207,    -1,   209,
     210,   211,   212,    -1,   214,   215,   216,   217,    -1,    -1,
     220,   221,    -1,    -1,   224,   225,    -1,    -1,   228,   229,
     230,   231,   232,   233,   234,   235,    -1,   237,   238,   239,
     240,   241,    -1,   243,   244,   245,   246,   247,   248,   249,
     250,   251,    -1,   253,   254,   255,   256,   257,   258,   259,
     260,   261,    -1,   263,   264,   265,   266,   267,   268,   269,
     270,   271,   272,   273,   274,   275,    -1,   277,   278,   279,
     280,   281,   282,   283,   284,   285,   286,   287,    -1,   289,
     290,   291,   292,   293,   294,   295,   296,   297,   298,    -1,
     300,   301,    -1,   303,   304,   305,   306,    -1,   308,   309,
      -1,    -1,   312,   313,   314,   315,    -1,   317,   318,   319,
     320,   321,    -1,    -1,   324,   325,   326,   327,   328,    -1,
     330,   331,   332,   333,   334,   335,   336,   337,   338,    -1,
      -1,   341,    -1,   343,   344,   345,   346,   347,    -1,    -1,
      -1,   351,    -1,    -1,     3,     4,     5,     6,     7,     8,
       9,    10,    -1,    12,    13,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,   372,    22,    23,    -1,    25,    -1,    27,    28,
      29,    -1,    31,    -1,    33,    34,    -1,    36,    37,    38,
      39,    40,    -1,    -1,    43,    44,    45,    46,    -1,    48,
      49,    50,    51,    52,    -1,    -1,    55,    56,    57,    58,
      59,    -1,    61,    62,    63,    64,    -1,    66,    67,    68,
      -1,    70,    -1,    -1,    -1,    -1,    -1,    76,    77,    78,
      79,    80,    81,    82,    83,    -1,    85,    -1,    87,    88,
      89,    90,    91,    -1,    93,    -1,    -1,    96,    97,    98,
      99,    -1,   101,   102,   103,    -1,   105,    -1,   107,   108,
     109,   110,   111,   112,   113,    -1,   115,   116,   117,    -1,
     119,    -1,   121,    -1,    -1,    -1,   125,   126,    -1,   128,
     129,    -1,   131,    -1,   133,   134,   135,   136,    -1,   138,
     139,   140,    -1,   142,   143,   144,   145,   146,   147,    -1,
      -1,   150,   151,   152,   153,   154,   155,   156,    -1,   158,
      -1,   160,    -1,    -1,   163,    -1,   165,   166,   167,   168,
     169,    -1,   171,    -1,   173,    -1,    -1,   176,   177,   178,
      -1,    -1,   181,   182,   183,   184,   185,   186,   187,   188,
     189,   190,    -1,    -1,    -1,   194,   195,    -1,   197,   198,
     199,   200,   201,   202,   203,   204,   205,   206,   207,    -1,
     209,   210,    -1,   212,    -1,   214,   215,   216,   217,    -1,
      -1,   220,   221,    -1,    -1,   224,   225,    -1,    -1,   228,
      -1,    -1,   231,   232,   233,   234,   235,    -1,   237,   238,
     239,   240,   241,    -1,   243,   244,   245,   246,   247,   248,
     249,   250,   251,    -1,   253,   254,   255,   256,   257,   258,
     259,   260,   261,    -1,   263,   264,    -1,   266,   267,   268,
     269,   270,   271,   272,   273,   274,   275,    -1,   277,   278,
     279,    -1,   281,   282,   283,   284,    -1,   286,   287,    -1,
     289,   290,   291,   292,   293,   294,   295,   296,   297,   298,
      -1,   300,   301,    -1,   303,   304,   305,   306,    -1,   308,
     309,    -1,    -1,   312,   313,   314,   315,    -1,   317,   318,
     319,   320,   321,    -1,    -1,   324,   325,   326,   327,    -1,
      -1,   330,   331,   332,   333,   334,   335,    -1,   337,   338,
      -1,    -1,   341,    -1,   343,   344,   345,   346,   347,    -1,
      -1,    -1,   351,    -1,    -1,     3,     4,     5,     6,     7,
       8,     9,    10,    -1,    12,    13,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,   372,    22,    23,    -1,    25,    -1,    27,
      28,    29,    -1,    31,    -1,    33,    34,    -1,    36,    37,
      38,    39,    40,    -1,    -1,    43,    44,    45,    46,    -1,
      48,    49,    50,    51,    52,    -1,    -1,    55,    56,    57,
      58,    59,    -1,    61,    62,    63,    64,    -1,    66,    67,
      68,    -1,    70,    -1,    -1,    -1,    -1,    -1,    76,    77,
      78,    79,    80,    81,    82,    83,    -1,    85,    -1,    87,
      88,    89,    90,    91,    -1,    93,    -1,    -1,    96,    97,
      98,    99,    -1,   101,   102,   103,    -1,   105,    -1,   107,
     108,   109,   110,   111,   112,   113,    -1,   115,   116,   117,
      -1,   119,    -1,   121,    -1,    -1,    -1,   125,   126,    -1,
     128,   129,    -1,   131,    -1,   133,   134,   135,   136,    -1,
     138,   139,   140,    -1,   142,   143,   144,   145,   146,   147,
      -1,    -1,   150,   151,   152,   153,   154,   155,   156,    -1,
     158,    -1,   160,    -1,    -1,   163,    -1,   165,   166,   167,
     168,   169,    -1,   171,    -1,   173,    -1,    -1,   176,   177,
     178,    -1,    -1,   181,   182,   183,   184,   185,   186,   187,
     188,   189,   190,    -1,    -1,    -1,   194,   195,    -1,   197,
      -1,   199,   200,   201,   202,   203,   204,   205,   206,   207,
      -1,   209,   210,    -1,   212,    -1,   214,   215,   216,   217,
      -1,    -1,   220,    -1,    -1,    -1,   224,   225,    -1,    -1,
     228,    -1,    -1,   231,   232,   233,   234,   235,    -1,   237,
     238,   239,   240,   241,    -1,   243,   244,   245,   246,   247,
     248,   249,   250,   251,    -1,   253,   254,   255,   256,   257,
     258,   259,   260,   261,    -1,   263,   264,    -1,   266,   267,
     268,   269,   270,   271,   272,   273,   274,   275,   276,   277,
     278,   279,    -1,   281,   282,   283,   284,    -1,   286,   287,
      -1,   289,   290,   291,   292,   293,   294,   295,   296,   297,
     298,    -1,   300,   301,    -1,   303,   304,   305,   306,    -1,
     308,   309,    -1,    -1,   312,   313,   314,   315,    -1,   317,
     318,   319,   320,   321,    -1,    -1,   324,   325,   326,   327,
      -1,    -1,   330,   331,   332,   333,   334,   335,    -1,   337,
     338,    -1,    -1,   341,    -1,   343,   344,   345,   346,   347,
      -1,    -1,    -1,   351,    -1,    -1,     3,     4,     5,     6,
       7,     8,     9,    10,    -1,    12,    13,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,   372,    22,    23,    -1,    25,    -1,
      27,    28,    29,    -1,    31,    -1,    33,    34,    -1,    36,
      37,    38,    39,    40,    -1,    -1,    43,    44,    45,    46,
      -1,    48,    49,    50,    51,    52,    -1,    -1,    55,    56,
      57,    58,    59,    -1,    61,    62,    63,    64,    -1,    66,
      67,    68,    -1,    70,    -1,    -1,    -1,    -1,    -1,    76,
      77,    78,    79,    80,    81,    82,    83,    -1,    85,    -1,
      87,    88,    89,    90,    91,    -1,    93,    -1,    -1,    96,
      97,    98,    99,    -1,   101,   102,   103,    -1,   105,    -1,
     107,   108,   109,   110,   111,   112,   113,    -1,   115,   116,
     117,    -1,   119,    -1,   121,    -1,    -1,    -1,   125,   126,
      -1,   128,   129,    -1,   131,    -1,   133,   134,   135,   136,
      -1,   138,   139,   140,    -1,   142,   143,   144,   145,   146,
     147,    -1,    -1,   150,   151,   152,   153,   154,   155,   156,
      -1,   158,    -1,   160,    -1,    -1,   163,    -1,   165,   166,
     167,   168,   169,    -1,   171,    -1,   173,    -1,    -1,   176,
     177,   178,    -1,    -1,   181,   182,   183,   184,   185,   186,
     187,   188,   189,   190,    -1,    -1,    -1,   194,   195,    -1,
     197,    -1,   199,   200,   201,   202,   203,   204,   205,   206,
     207,    -1,   209,   210,    -1,   212,    -1,   214,   215,   216,
     217,    -1,    -1,   220,    -1,    -1,    -1,   224,   225,    -1,
      -1,   228,    -1,    -1,   231,   232,   233,   234,   235,    -1,
     237,   238,   239,   240,   241,    -1,   243,   244,   245,   246,
     247,   248,   249,   250,   251,    -1,   253,   254,   255,   256,
     257,   258,   259,   260,   261,    -1,   263,   264,    -1,   266,
     267,   268,   269,   270,   271,   272,   273,   274,   275,    -1,
     277,   278,   279,    -1,   281,   282,   283,   284,    -1,   286,
     287,    -1,   289,   290,   291,   292,   293,   294,   295,   296,
     297,   298,    -1,   300,   301,    -1,   303,   304,   305,   306,
      -1,   308,   309,    -1,    -1,   312,   313,   314,   315,    -1,
     317,   318,   319,   320,   321,    -1,    -1,   324,   325,   326,
     327,    -1,    -1,   330,   331,   332,   333,   334,   335,    -1,
     337,   338,    -1,    -1,   341,    -1,   343,   344,   345,   346,
     347,    -1,    -1,    -1,   351,    -1,    -1,     3,     4,     5,
       6,     7,     8,     9,    10,    -1,    12,    13,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,   372,    22,    23,    -1,    25,
      -1,    27,    28,    29,    -1,    31,    -1,    33,    34,    -1,
      36,    37,    38,    39,    40,    -1,    -1,    43,    44,    45,
      46,    -1,    48,    49,    50,    51,    52,    -1,    -1,    55,
      56,    57,    58,    59,    -1,    61,    62,    63,    64,    -1,
      66,    67,    68,    -1,    70,    -1,    -1,    -1,    -1,    -1,
      76,    77,    78,    79,    80,    81,    82,    83,    -1,    85,
      -1,    87,    88,    89,    90,    91,    -1,    93,    -1,    -1,
      96,    97,    98,    99,    -1,   101,   102,   103,    -1,   105,
      -1,   107,   108,   109,   110,   111,   112,   113,    -1,   115,
     116,   117,    -1,   119,    -1,   121,    -1,    -1,    -1,   125,
     126,    -1,   128,   129,    -1,   131,    -1,   133,   134,   135,
     136,    -1,   138,   139,   140,    -1,   142,   143,   144,   145,
     146,   147,    -1,    -1,   150,   151,   152,   153,   154,   155,
     156,    -1,   158,    -1,   160,    -1,    -1,   163,    -1,   165,
     166,   167,   168,   169,    -1,   171,    -1,   173,    -1,    -1,
     176,   177,   178,    -1,    -1,   181,   182,   183,   184,   185,
     186,   187,   188,   189,   190,    -1,    -1,    -1,   194,   195,
      -1,   197,    -1,   199,   200,   201,   202,   203,   204,   205,
     206,   207,    -1,   209,   210,    -1,   212,    -1,   214,   215,
     216,   217,    -1,    -1,   220,    -1,    -1,    -1,   224,   225,
      -1,    -1,   228,    -1,    -1,   231,   232,   233,   234,   235,
      -1,   237,   238,   239,   240,   241,    -1,   243,   244,   245,
     246,   247,   248,   249,   250,   251,    -1,   253,   254,   255,
     256,   257,   258,   259,   260,   261,    -1,   263,   264,    -1,
     266,   267,   268,   269,   270,   271,   272,   273,   274,   275,
      -1,   277,   278,   279,    -1,   281,   282,   283,   284,    -1,
     286,   287,    -1,   289,   290,   291,   292,   293,   294,   295,
     296,   297,   298,    -1,   300,   301,    -1,   303,   304,   305,
     306,    -1,   308,   309,    -1,    -1,   312,   313,   314,   315,
      -1,   317,   318,   319,   320,   321,    -1,    -1,   324,   325,
     326,   327,    -1,    -1,   330,   331,   332,   333,   334,   335,
      -1,   337,   338,    -1,    -1,   341,    -1,   343,   344,   345,
     346,   347,    -1,    -1,    -1,   351,    -1,    -1,    -1,    -1,
      -1,     3,     4,     5,     6,     7,     8,     9,    10,    11,
      12,    13,    14,    15,    16,    17,   372,    19,    20,    21,
      22,    23,    24,    25,    26,    27,    28,    29,    30,    31,
      32,    33,    34,    35,    36,    37,    38,    39,    40,    41,
      42,    43,    44,    45,    46,    47,    48,    49,    50,    51,
      -1,    53,    54,    55,    56,    57,    58,    59,    60,    61,
      62,    -1,    64,    65,    66,    67,    68,    69,    70,    71,
      72,    73,    74,    75,    76,    77,    78,    79,    80,    81,
      82,    83,    84,    85,    86,    87,    88,    89,    90,    91,
      92,    93,    94,    95,    96,    97,    98,    99,   100,   101,
     102,   103,   104,   105,   106,   107,   108,   109,    -1,   111,
     112,    -1,   114,   115,   116,   117,   118,   119,   120,   121,
     122,   123,   124,   125,   126,   127,   128,    -1,   130,   131,
     132,   133,   134,   135,   136,   137,   138,   139,   140,   141,
     142,   143,   144,   145,   146,   147,   148,   149,    -1,   151,
     152,   153,   154,   155,   156,   157,   158,   159,   160,   161,
     162,   163,   164,   165,   166,   167,   168,   169,   170,    -1,
     172,   173,   174,   175,   176,   177,   178,   179,   180,   181,
     182,   183,   184,   185,   186,   187,   188,   189,   190,    -1,
      -1,    -1,   194,   195,   196,   197,   198,   199,   200,   201,
     202,   203,   204,   205,    -1,   207,   208,   209,   210,   211,
     212,   213,    -1,   215,   216,   217,   218,   219,   220,   221,
     222,   223,   224,   225,   226,   227,    -1,   229,   230,    -1,
     232,   233,   234,   235,   236,    -1,    -1,   239,   240,   241,
     242,   243,   244,   245,   246,   247,   248,   249,   250,   251,
     252,   253,   254,   255,   256,   257,   258,   259,   260,   261,
     262,   263,   264,   265,   266,   267,    -1,   269,   270,   271,
     272,   273,   274,   275,   276,   277,   278,   279,   280,   281,
     282,   283,   284,   285,   286,   287,   288,   289,   290,   291,
     292,   293,   294,   295,   296,    -1,   298,   299,   300,   301,
     302,   303,   304,   305,   306,   307,   308,   309,   310,   311,
     312,    -1,   314,    -1,   316,   317,   318,   319,   320,   321,
     322,   323,   324,   325,   326,   327,   328,   329,   330,   331,
     332,    -1,   334,   335,   336,   337,   338,   339,   340,   341,
      -1,   343,   344,   345,   346,   347,    -1,    -1,    -1,   351,
     352,   353,    -1,    -1,   356,   357,    -1,   359,   360,   361,
      -1,   363,   364,   365,   366,   367,   368,     3,     4,     5,
       6,     7,     8,     9,    10,    -1,    12,    13,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    22,    23,    -1,    25,
      -1,    27,    28,    29,    -1,    31,    -1,    33,    34,    -1,
      36,    37,    38,    39,    40,    -1,    -1,    43,    44,    45,
      46,    -1,    48,    49,    50,    51,    52,    -1,    -1,    55,
      56,    57,    58,    59,    -1,    61,    62,    63,    64,    -1,
      66,    67,    68,    -1,    70,    -1,    -1,    -1,    -1,    -1,
      76,    77,    78,    79,    80,    81,    82,    83,    -1,    85,
      -1,    87,    88,    89,    90,    91,    -1,    93,    -1,    -1,
      96,    97,    98,    99,    -1,   101,   102,   103,    -1,   105,
      -1,   107,   108,   109,   110,   111,   112,   113,    -1,   115,
     116,   117,    -1,   119,    -1,   121,    -1,    -1,    -1,   125,
     126,    -1,   128,   129,    -1,   131,    -1,   133,   134,   135,
     136,    -1,   138,   139,   140,    -1,   142,   143,   144,   145,
     146,   147,    -1,    -1,   150,   151,   152,   153,   154,   155,
     156,    -1,   158,    -1,   160,    -1,    -1,   163,    -1,   165,
     166,   167,   168,   169,    -1,   171,    -1,   173,    -1,    -1,
     176,   177,   178,    -1,    -1,   181,   182,   183,   184,   185,
     186,   187,   188,   189,   190,    -1,    -1,    -1,   194,   195,
      -1,   197,    -1,   199,   200,   201,   202,   203,   204,   205,
     206,   207,    -1,   209,   210,    -1,   212,    -1,   214,   215,
     216,   217,    -1,    -1,   220,    -1,    -1,    -1,   224,   225,
      -1,    -1,   228,    -1,    -1,   231,   232,   233,   234,   235,
      -1,   237,   238,   239,   240,   241,    -1,   243,   244,   245,
     246,   247,   248,   249,   250,   251,    -1,   253,   254,   255,
     256,   257,   258,   259,   260,   261,    -1,   263,   264,    -1,
     266,   267,   268,   269,   270,   271,   272,   273,   274,   275,
      -1,   277,   278,   279,    -1,   281,   282,   283,   284,    -1,
     286,   287,    -1,   289,   290,   291,   292,   293,   294,   295,
     296,   297,   298,    -1,   300,   301,    -1,   303,   304,   305,
     306,    -1,   308,   309,    -1,    -1,   312,   313,   314,   315,
      -1,   317,   318,   319,   320,   321,    -1,    -1,   324,   325,
     326,   327,    -1,    -1,   330,   331,   332,   333,   334,   335,
      -1,   337,   338,    -1,    -1,   341,    -1,   343,   344,   345,
     346,   347,    -1,    -1,    -1,   351,    -1,    -1,    -1,    -1,
     356,    -1,    -1,   359,   360,   361,    -1,   363,   364,   365,
     366,   367,   368,     3,     4,     5,     6,     7,     8,     9,
      10,    -1,    12,    13,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    22,    23,    -1,    25,    -1,    27,    28,    29,
      -1,    31,    -1,    33,    34,    -1,    36,    37,    38,    39,
      40,    -1,    -1,    43,    44,    45,    46,    -1,    48,    49,
      50,    51,    52,    -1,    -1,    55,    56,    57,    58,    59,
      -1,    61,    62,    63,    64,    -1,    66,    67,    68,    -1,
      70,    -1,    -1,    -1,    -1,    -1,    76,    77,    78,    79,
      80,    81,    82,    83,    -1,    85,    -1,    87,    88,    89,
      90,    91,    -1,    93,    -1,    -1,    96,    97,    98,    99,
      -1,   101,   102,   103,    -1,   105,    -1,   107,   108,   109,
     110,   111,   112,   113,    -1,   115,   116,   117,    -1,   119,
      -1,   121,    -1,    -1,    -1,   125,   126,    -1,   128,   129,
      -1,   131,    -1,   133,   134,   135,   136,    -1,   138,   139,
     140,    -1,   142,   143,   144,   145,   146,   147,    -1,    -1,
     150,   151,   152,   153,   154,   155,   156,    -1,   158,    -1,
     160,    -1,    -1,   163,    -1,   165,   166,   167,   168,   169,
      -1,   171,    -1,   173,    -1,    -1,   176,   177,   178,    -1,
      -1,   181,   182,   183,   184,   185,   186,   187,   188,   189,
     190,    -1,    -1,    -1,   194,   195,    -1,   197,    -1,   199,
     200,   201,   202,   203,   204,   205,   206,   207,    -1,   209,
     210,    -1,   212,    -1,   214,   215,   216,   217,    -1,    -1,
     220,    -1,    -1,    -1,   224,   225,    -1,    -1,   228,    -1,
      -1,   231,   232,   233,   234,   235,    -1,   237,   238,   239,
     240,   241,    -1,   243,   244,   245,   246,   247,   248,   249,
     250,   251,    -1,   253,   254,   255,   256,   257,   258,   259,
     260,   261,    -1,   263,   264,    -1,   266,   267,   268,   269,
     270,   271,   272,   273,   274,   275,    -1,   277,   278,   279,
      -1,   281,   282,   283,   284,    -1,   286,   287,    -1,   289,
     290,   291,   292,   293,   294,   295,   296,   297,   298,    -1,
     300,   301,    -1,   303,   304,   305,   306,    -1,   308,   309,
      -1,    -1,   312,   313,   314,   315,    -1,   317,   318,   319,
     320,   321,    -1,    -1,   324,   325,   326,   327,    -1,    -1,
     330,   331,   332,   333,   334,   335,    -1,   337,   338,    -1,
      -1,   341,    -1,   343,   344,   345,   346,   347,    -1,    -1,
      -1,   351,    -1,    -1,    -1,    -1,   356,    -1,    -1,   359,
     360,   361,    -1,   363,   364,   365,   366,   367,   368,     3,
       4,     5,     6,     7,     8,     9,    10,    -1,    12,    13,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    22,    23,
      -1,    25,    -1,    27,    28,    29,    -1,    31,    -1,    33,
      34,    -1,    36,    37,    38,    39,    40,    -1,    -1,    43,
      44,    45,    46,    -1,    48,    49,    50,    51,    52,    -1,
      -1,    55,    56,    57,    58,    59,    -1,    61,    62,    63,
      64,    -1,    66,    67,    68,    -1,    70,    -1,    -1,    -1,
      -1,    -1,    76,    77,    78,    79,    80,    81,    82,    83,
      -1,    85,    -1,    87,    88,    89,    90,    91,    -1,    93,
      -1,    -1,    96,    97,    98,    99,    -1,   101,   102,   103,
      -1,   105,    -1,   107,   108,   109,   110,   111,   112,   113,
      -1,   115,   116,   117,    -1,   119,    -1,   121,    -1,    -1,
      -1,   125,   126,    -1,   128,   129,    -1,   131,    -1,   133,
     134,   135,   136,    -1,   138,   139,   140,    -1,   142,   143,
     144,   145,   146,   147,    -1,    -1,   150,   151,   152,   153,
     154,   155,   156,    -1,   158,    -1,   160,    -1,    -1,   163,
      -1,   165,   166,   167,   168,   169,    -1,   171,    -1,   173,
      -1,    -1,   176,   177,   178,    -1,    -1,   181,   182,   183,
     184,   185,   186,   187,   188,   189,   190,    -1,    -1,    -1,
     194,   195,    -1,   197,    -1,   199,   200,   201,   202,   203,
     204,   205,   206,   207,    -1,   209,   210,    -1,   212,    -1,
     214,   215,   216,   217,    -1,    -1,   220,    -1,    -1,    -1,
     224,   225,    -1,    -1,   228,    -1,    -1,   231,   232,   233,
     234,   235,    -1,   237,   238,   239,   240,   241,    -1,   243,
     244,   245,   246,   247,   248,   249,   250,   251,    -1,   253,
     254,   255,   256,   257,   258,   259,   260,   261,    -1,   263,
     264,    -1,   266,   267,   268,   269,   270,   271,   272,   273,
     274,   275,    -1,   277,   278,   279,    -1,   281,   282,   283,
     284,    -1,   286,   287,    -1,   289,   290,   291,   292,   293,
     294,   295,   296,   297,   298,    -1,   300,   301,    -1,   303,
     304,   305,   306,    -1,   308,   309,    -1,    -1,   312,   313,
     314,   315,    -1,   317,   318,   319,   320,   321,    -1,    -1,
     324,   325,   326,   327,    -1,    -1,   330,   331,   332,   333,
     334,   335,    -1,   337,   338,    -1,    -1,   341,    -1,   343,
     344,   345,   346,   347,    -1,    -1,    -1,   351,    -1,    -1,
      -1,    -1,   356,    -1,    -1,   359,   360,   361,    -1,   363,
     364,   365,   366,   367,   368,     3,     4,     5,     6,     7,
       8,     9,    10,    -1,    12,    13,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    22,    23,    -1,    25,    -1,    27,
      28,    29,    -1,    31,    -1,    33,    34,    -1,    36,    37,
      38,    39,    40,    -1,    -1,    43,    44,    45,    46,    -1,
      48,    49,    50,    51,    52,    -1,    -1,    55,    56,    57,
      58,    59,    -1,    61,    62,    63,    64,    -1,    66,    67,
      68,    -1,    70,    -1,    -1,    -1,    -1,    -1,    76,    77,
      78,    79,    80,    81,    82,    83,    -1,    85,    -1,    87,
      88,    89,    90,    91,    -1,    93,    -1,    -1,    96,    97,
      98,    99,    -1,   101,   102,   103,    -1,   105,    -1,   107,
     108,   109,   110,   111,   112,   113,    -1,   115,   116,   117,
      -1,   119,    -1,   121,    -1,    -1,    -1,   125,   126,    -1,
     128,   129,    -1,   131,    -1,   133,   134,   135,   136,    -1,
     138,   139,   140,    -1,   142,   143,   144,   145,   146,   147,
      -1,    -1,   150,   151,   152,   153,   154,   155,   156,    -1,
     158,    -1,   160,    -1,    -1,   163,    -1,   165,   166,   167,
     168,   169,    -1,   171,    -1,   173,    -1,    -1,   176,   177,
     178,    -1,    -1,   181,   182,   183,   184,   185,   186,   187,
     188,   189,   190,    -1,    -1,    -1,   194,   195,    -1,   197,
      -1,   199,   200,   201,   202,   203,   204,   205,   206,   207,
      -1,   209,   210,    -1,   212,    -1,   214,   215,   216,   217,
      -1,    -1,   220,    -1,    -1,    -1,   224,   225,    -1,    -1,
     228,    -1,    -1,   231,   232,   233,   234,   235,    -1,   237,
     238,   239,   240,   241,    -1,   243,   244,   245,   246,   247,
     248,   249,   250,   251,    -1,   253,   254,   255,   256,   257,
     258,   259,   260,   261,    -1,   263,   264,    -1,   266,   267,
     268,   269,   270,   271,   272,   273,   274,   275,    -1,   277,
     278,   279,    -1,   281,   282,   283,   284,    -1,   286,   287,
      -1,   289,   290,   291,   292,   293,   294,   295,   296,   297,
     298,    -1,   300,   301,    -1,   303,   304,   305,   306,    -1,
     308,   309,    -1,    -1,   312,   313,   314,   315,    -1,   317,
     318,   319,   320,   321,    -1,    -1,   324,   325,   326,   327,
      -1,    -1,   330,   331,   332,   333,   334,   335,    -1,   337,
     338,    -1,    -1,   341,    -1,   343,   344,   345,   346,   347,
      -1,    -1,    -1,   351,    -1,    -1,    -1,    -1,   356,    -1,
      -1,   359,   360,   361,    -1,   363,   364,   365,   366,   367,
     368,     3,     4,     5,     6,     7,     8,     9,    10,    -1,
      12,    13,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      22,    23,    -1,    25,    -1,    27,    28,    29,    -1,    31,
      -1,    33,    34,    -1,    36,    37,    38,    39,    40,    -1,
      -1,    43,    44,    45,    46,    -1,    48,    49,    50,    51,
      52,    -1,    -1,    55,    56,    57,    58,    59,    -1,    61,
      62,    63,    64,    -1,    66,    67,    68,    -1,    70,    -1,
      -1,    -1,    -1,    -1,    76,    77,    78,    79,    80,    81,
      82,    83,    -1,    85,    -1,    87,    88,    89,    90,    91,
      -1,    93,    -1,    -1,    96,    97,    98,    99,    -1,   101,
     102,   103,    -1,   105,    -1,   107,   108,   109,   110,   111,
     112,   113,    -1,   115,   116,   117,    -1,   119,    -1,   121,
      -1,    -1,    -1,   125,   126,    -1,   128,   129,    -1,   131,
      -1,   133,   134,   135,   136,    -1,   138,   139,   140,    -1,
     142,   143,   144,   145,   146,   147,    -1,    -1,   150,   151,
     152,   153,   154,   155,   156,    -1,   158,    -1,   160,    -1,
      -1,   163,    -1,   165,   166,   167,   168,   169,    -1,   171,
      -1,   173,    -1,    -1,   176,   177,   178,    -1,    -1,   181,
     182,   183,   184,   185,   186,   187,   188,   189,   190,    -1,
      -1,    -1,   194,   195,    -1,   197,    -1,   199,   200,   201,
     202,   203,   204,   205,   206,   207,    -1,   209,   210,    -1,
     212,    -1,   214,   215,   216,   217,    -1,    -1,   220,    -1,
      -1,    -1,   224,   225,    -1,    -1,   228,    -1,    -1,   231,
     232,   233,   234,   235,    -1,   237,   238,   239,   240,   241,
      -1,   243,   244,   245,   246,   247,   248,   249,   250,   251,
      -1,   253,   254,   255,   256,   257,   258,   259,   260,   261,
      -1,   263,   264,    -1,   266,   267,   268,   269,   270,   271,
     272,   273,   274,   275,    -1,   277,   278,   279,    -1,   281,
     282,   283,   284,    -1,   286,   287,    -1,   289,   290,   291,
     292,   293,   294,   295,   296,   297,   298,    -1,   300,   301,
      -1,   303,   304,   305,   306,    -1,   308,   309,    -1,    -1,
     312,   313,   314,   315,    -1,   317,   318,   319,   320,   321,
      -1,    -1,   324,   325,   326,   327,    -1,    -1,   330,   331,
     332,   333,   334,   335,    -1,   337,   338,    -1,    -1,   341,
      -1,   343,   344,   345,   346,   347,    -1,    -1,    -1,   351,
      -1,    -1,    -1,    -1,   356,    -1,    -1,   359,   360,   361,
      -1,   363,   364,   365,   366,   367,   368,     3,     4,     5,
       6,     7,     8,     9,    10,    11,    12,    13,    14,    15,
      16,    17,    -1,    19,    20,    21,    22,    23,    24,    25,
      26,    27,    28,    29,    30,    31,    32,    33,    34,    35,
      36,    37,    38,    39,    40,    41,    42,    43,    44,    45,
      46,    47,    48,    49,    50,    51,    52,    53,    54,    55,
      56,    57,    58,    59,    60,    61,    62,    63,    64,    65,
      66,    67,    68,    69,    70,    71,    72,    73,    74,    75,
      76,    77,    78,    79,    80,    81,    82,    83,    84,    85,
      86,    87,    88,    89,    90,    91,    92,    93,    94,    95,
      96,    97,    98,    99,   100,   101,   102,   103,   104,   105,
     106,   107,   108,   109,   110,   111,   112,   113,   114,   115,
     116,   117,   118,   119,   120,   121,   122,   123,   124,   125,
     126,   127,   128,   129,   130,   131,   132,   133,   134,   135,
     136,   137,   138,   139,   140,   141,   142,   143,   144,   145,
     146,   147,   148,   149,   150,   151,   152,   153,   154,   155,
     156,   157,   158,   159,   160,   161,   162,   163,   164,   165,
     166,   167,   168,   169,   170,   171,   172,   173,   174,   175,
     176,   177,   178,   179,   180,   181,   182,   183,   184,   185,
     186,   187,   188,   189,   190,    -1,    -1,    -1,   194,   195,
     196,   197,   198,   199,   200,   201,   202,   203,   204,   205,
     206,   207,   208,   209,   210,   211,   212,   213,   214,   215,
     216,   217,   218,   219,   220,   221,   222,   223,   224,   225,
     226,   227,   228,   229,   230,   231,   232,   233,   234,   235,
     236,   237,   238,   239,   240,   241,   242,   243,   244,   245,
     246,   247,   248,   249,   250,   251,   252,   253,   254,   255,
     256,   257,   258,   259,   260,   261,   262,   263,   264,   265,
     266,   267,   268,   269,   270,   271,   272,   273,   274,   275,
     276,   277,   278,   279,   280,   281,   282,   283,   284,   285,
     286,   287,   288,   289,   290,   291,   292,   293,   294,   295,
     296,   297,   298,   299,   300,   301,   302,   303,   304,   305,
     306,   307,   308,   309,   310,   311,   312,   313,   314,   315,
     316,   317,   318,   319,   320,   321,   322,   323,   324,   325,
     326,   327,   328,   329,   330,   331,   332,   333,   334,   335,
     336,   337,   338,   339,   340,   341,    -1,   343,   344,   345,
     346,   347,    -1,    -1,    -1,   351,     3,     4,     5,     6,
       7,     8,     9,    10,    -1,    12,    13,    -1,    -1,   365,
      -1,    -1,    -1,    -1,    -1,    22,    23,    -1,    25,    -1,
      27,    28,    29,    -1,    31,    -1,    33,    34,    -1,    36,
      37,    38,    39,    40,    -1,    -1,    43,    44,    45,    46,
      -1,    48,    49,    50,    51,    52,    -1,    -1,    55,    56,
      57,    58,    59,    -1,    61,    62,    63,    64,    -1,    66,
      67,    68,    -1,    70,    -1,    -1,    -1,    -1,    -1,    76,
      77,    78,    79,    80,    81,    82,    83,    -1,    85,    -1,
      87,    88,    89,    90,    91,    -1,    93,    -1,    -1,    96,
      97,    98,    99,    -1,   101,   102,   103,    -1,   105,    -1,
     107,   108,   109,   110,   111,   112,   113,    -1,   115,   116,
     117,    -1,   119,    -1,   121,    -1,    -1,    -1,   125,   126,
      -1,   128,   129,    -1,   131,    -1,   133,   134,   135,   136,
      -1,   138,   139,   140,    -1,   142,   143,   144,   145,   146,
     147,    -1,    -1,   150,   151,   152,   153,   154,   155,   156,
      -1,   158,    -1,   160,    -1,    -1,   163,    -1,   165,   166,
     167,   168,   169,    -1,   171,    -1,   173,    -1,    -1,   176,
     177,   178,    -1,    -1,   181,   182,   183,   184,   185,   186,
     187,   188,   189,   190,    -1,    -1,    -1,   194,   195,    -1,
     197,   198,   199,   200,   201,   202,   203,   204,   205,   206,
     207,    -1,   209,   210,    -1,   212,    -1,   214,   215,   216,
     217,    -1,    -1,   220,   221,    -1,    -1,   224,   225,    -1,
      -1,   228,    -1,    -1,   231,   232,   233,   234,   235,    -1,
     237,   238,   239,   240,   241,    -1,   243,   244,   245,   246,
     247,   248,   249,   250,   251,    -1,   253,   254,   255,   256,
     257,   258,   259,   260,   261,    -1,   263,   264,    -1,   266,
     267,   268,   269,   270,   271,   272,   273,   274,   275,    -1,
     277,   278,   279,    -1,   281,   282,   283,   284,    -1,   286,
     287,    -1,   289,   290,   291,   292,   293,   294,   295,   296,
     297,   298,    -1,   300,   301,    -1,   303,   304,   305,   306,
      -1,   308,   309,    -1,    -1,   312,   313,   314,   315,    -1,
     317,   318,   319,   320,   321,    -1,    -1,   324,   325,   326,
     327,    -1,    -1,   330,   331,   332,   333,   334,   335,    -1,
     337,   338,    -1,    -1,   341,    -1,   343,   344,   345,   346,
     347,    -1,    -1,    -1,   351,     3,     4,     5,     6,     7,
       8,     9,    10,    -1,    12,    13,    -1,    -1,   365,    -1,
      -1,    -1,    -1,    -1,    22,    23,    -1,    25,    -1,    27,
      28,    29,    -1,    31,    -1,    33,    34,    -1,    36,    37,
      38,    39,    40,    -1,    -1,    43,    44,    45,    46,    -1,
      48,    49,    50,    51,    -1,    -1,    -1,    55,    56,    57,
      58,    59,    -1,    61,    62,    -1,    64,    -1,    66,    67,
      68,    -1,    70,    -1,    -1,    -1,    -1,    -1,    76,    77,
      78,    79,    80,    81,    82,    83,    -1,    85,    -1,    87,
      88,    89,    90,    91,    -1,    93,    -1,    -1,    96,    97,
      98,    99,    -1,   101,   102,   103,    -1,   105,    -1,   107,
     108,   109,    -1,   111,   112,    -1,    -1,   115,   116,   117,
      -1,   119,    -1,   121,    -1,    -1,    -1,   125,   126,    -1,
     128,    -1,    -1,   131,    -1,   133,   134,   135,   136,    -1,
     138,   139,   140,    -1,   142,   143,   144,   145,   146,   147,
      -1,    -1,    -1,   151,   152,   153,   154,   155,   156,    -1,
     158,    -1,   160,    -1,    -1,   163,    -1,   165,   166,   167,
     168,   169,    -1,    -1,    -1,   173,    -1,    -1,   176,   177,
     178,    -1,    -1,   181,   182,   183,   184,   185,   186,   187,
     188,   189,   190,    -1,    -1,    -1,   194,   195,    -1,   197,
      -1,   199,   200,   201,   202,   203,   204,   205,    -1,   207,
      -1,   209,   210,    -1,   212,    -1,    -1,   215,   216,   217,
      -1,    -1,   220,    -1,    -1,    -1,   224,   225,    -1,    -1,
      -1,    -1,    -1,    -1,   232,   233,   234,   235,    -1,    -1,
      -1,   239,   240,   241,    -1,   243,   244,   245,   246,   247,
     248,   249,   250,   251,    -1,   253,   254,   255,   256,   257,
     258,   259,   260,   261,    -1,   263,   264,    -1,   266,   267,
      -1,   269,   270,   271,   272,   273,   274,   275,    -1,   277,
     278,   279,    -1,   281,   282,   283,   284,    -1,   286,   287,
      -1,   289,   290,   291,   292,   293,   294,   295,   296,    -1,
     298,    -1,   300,   301,    -1,   303,   304,   305,   306,    -1,
     308,   309,    -1,    -1,   312,    -1,   314,    -1,    -1,   317,
     318,   319,   320,   321,    -1,    -1,   324,   325,   326,   327,
      -1,    -1,   330,   331,   332,    -1,   334,   335,    -1,   337,
     338,    -1,    -1,   341,    -1,   343,   344,   345,   346,   347,
      -1,    -1,    -1,   351,     3,     4,     5,     6,     7,     8,
       9,    10,    -1,    12,    13,    -1,    -1,   365,    -1,    -1,
      -1,    -1,    -1,    22,    23,    -1,    25,    -1,    27,    28,
      29,    -1,    31,    -1,    33,    34,    -1,    36,    37,    38,
      39,    40,    -1,    -1,    43,    44,    45,    46,    -1,    48,
      49,    50,    51,    -1,    -1,    -1,    55,    56,    57,    58,
      59,    -1,    61,    62,    -1,    64,    -1,    66,    67,    68,
      -1,    70,    -1,    -1,    -1,    -1,    -1,    76,    77,    78,
      79,    80,    81,    82,    83,    -1,    85,    -1,    87,    88,
      89,    90,    91,    -1,    93,    -1,    -1,    96,    97,    98,
      99,    -1,   101,   102,   103,    -1,   105,    -1,   107,   108,
     109,    -1,   111,   112,    -1,    -1,   115,   116,   117,    -1,
     119,    -1,   121,    -1,    -1,    -1,   125,   126,    -1,   128,
      -1,    -1,   131,    -1,   133,   134,   135,   136,    -1,   138,
     139,   140,    -1,   142,   143,   144,   145,   146,   147,    -1,
      -1,    -1,   151,   152,   153,   154,   155,   156,    -1,   158,
      -1,   160,    -1,    -1,   163,    -1,   165,   166,   167,   168,
     169,    -1,    -1,    -1,   173,    -1,    -1,   176,   177,   178,
      -1,    -1,   181,   182,   183,   184,   185,   186,   187,   188,
     189,   190,    -1,    -1,    -1,   194,   195,    -1,   197,    -1,
     199,   200,   201,   202,   203,   204,   205,    -1,   207,    -1,
     209,   210,    -1,   212,    -1,    -1,   215,   216,   217,    -1,
      -1,   220,    -1,    -1,    -1,   224,   225,    -1,    -1,    -1,
      -1,    -1,    -1,   232,   233,   234,   235,    -1,    -1,    -1,
     239,   240,   241,    -1,   243,   244,   245,   246,   247,   248,
     249,   250,   251,    -1,   253,   254,   255,   256,   257,   258,
     259,   260,   261,    -1,   263,   264,    -1,   266,   267,    -1,
     269,   270,   271,   272,   273,   274,   275,    -1,   277,   278,
     279,    -1,   281,   282,   283,   284,    -1,   286,   287,    -1,
     289,   290,   291,   292,   293,   294,   295,   296,    -1,   298,
      -1,   300,   301,    -1,   303,   304,   305,   306,    -1,   308,
     309,    -1,    -1,   312,    -1,   314,    -1,    -1,   317,   318,
     319,   320,   321,    -1,    -1,   324,   325,   326,   327,    -1,
      -1,   330,   331,   332,    -1,   334,   335,    -1,   337,   338,
      -1,    -1,   341,    -1,   343,   344,   345,   346,   347,    -1,
      -1,    -1,   351,     3,     4,     5,     6,     7,     8,     9,
      10,    -1,    12,    13,    -1,    -1,   365,    -1,    -1,    -1,
      -1,    -1,    22,    23,    -1,    25,    -1,    27,    28,    29,
      -1,    31,    -1,    33,    34,    -1,    36,    37,    38,    39,
      40,    -1,    -1,    43,    44,    45,    46,    -1,    48,    49,
      50,    51,    52,    -1,    -1,    55,    56,    57,    58,    59,
      -1,    61,    62,    63,    64,    -1,    66,    67,    68,    -1,
      70,    -1,    -1,    -1,    -1,    -1,    76,    77,    78,    79,
      80,    81,    82,    83,    84,    85,    -1,    87,    88,    89,
      90,    91,    -1,    93,    -1,    -1,    96,    97,    98,    99,
      -1,   101,   102,   103,    -1,   105,    -1,   107,   108,   109,
     110,   111,   112,   113,   114,   115,   116,   117,    -1,   119,
      -1,   121,    -1,    -1,    -1,   125,   126,    -1,   128,   129,
      -1,   131,    -1,   133,   134,   135,   136,    -1,   138,   139,
     140,    -1,   142,   143,   144,   145,   146,   147,    -1,    -1,
     150,   151,   152,   153,   154,   155,   156,    -1,   158,    -1,
     160,    -1,    -1,   163,    -1,   165,   166,   167,   168,   169,
      -1,   171,    -1,   173,    -1,    -1,   176,   177,   178,    -1,
      -1,   181,   182,   183,   184,   185,   186,   187,   188,   189,
     190,    -1,    -1,    -1,   194,   195,    -1,   197,    -1,   199,
     200,   201,   202,   203,   204,   205,   206,   207,    -1,   209,
     210,    -1,   212,    -1,   214,   215,   216,   217,   218,    -1,
     220,    -1,   222,    -1,   224,   225,    -1,    -1,   228,    -1,
      -1,   231,   232,   233,   234,   235,    -1,   237,   238,   239,
     240,   241,    -1,   243,   244,   245,   246,   247,   248,   249,
     250,   251,    -1,   253,   254,   255,   256,   257,   258,   259,
     260,   261,    -1,   263,   264,    -1,   266,   267,   268,   269,
     270,   271,   272,   273,   274,   275,    -1,   277,   278,   279,
      -1,   281,   282,   283,   284,    -1,   286,   287,    -1,   289,
     290,   291,   292,   293,   294,   295,   296,   297,   298,    -1,
     300,   301,    -1,   303,   304,   305,   306,    -1,   308,   309,
      -1,    -1,   312,   313,   314,   315,   316,   317,   318,   319,
     320,   321,    -1,    -1,   324,   325,   326,   327,    -1,    -1,
     330,   331,   332,   333,   334,   335,    -1,   337,   338,    -1,
      -1,   341,    -1,   343,   344,   345,   346,   347,    -1,    -1,
      -1,   351,   352,   353,    -1,    -1,    -1,   357,    -1,    -1,
      -1,    -1,    -1,    -1,   364,     3,     4,     5,     6,     7,
       8,     9,    10,    -1,    12,    13,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    22,    23,    -1,    25,    -1,    27,
      28,    29,    -1,    31,    -1,    33,    34,    -1,    36,    37,
      38,    39,    40,    -1,    -1,    43,    44,    45,    46,    -1,
      48,    49,    50,    51,    52,    -1,    -1,    55,    56,    57,
      58,    59,    -1,    61,    62,    63,    64,    -1,    66,    67,
      68,    -1,    70,    -1,    -1,    -1,    -1,    -1,    76,    77,
      78,    79,    80,    81,    82,    83,    -1,    85,    -1,    87,
      88,    89,    90,    91,    -1,    93,    -1,    -1,    96,    97,
      98,    99,    -1,   101,   102,   103,    -1,   105,    -1,   107,
     108,   109,   110,   111,   112,   113,   114,   115,   116,   117,
      -1,   119,    -1,   121,    -1,    -1,    -1,   125,   126,    -1,
     128,   129,    -1,   131,    -1,   133,   134,   135,   136,    -1,
     138,   139,   140,    -1,   142,   143,   144,   145,   146,   147,
      -1,    -1,   150,   151,   152,   153,   154,   155,   156,    -1,
     158,    -1,   160,    -1,    -1,   163,    -1,   165,   166,   167,
     168,   169,    -1,   171,    -1,   173,    -1,    -1,   176,   177,
     178,    -1,    -1,   181,   182,   183,   184,   185,   186,   187,
     188,   189,   190,    -1,    -1,    -1,   194,   195,    -1,   197,
      -1,   199,   200,   201,   202,   203,   204,   205,   206,   207,
      -1,   209,   210,    -1,   212,    -1,   214,   215,   216,   217,
     218,    -1,   220,    -1,   222,    -1,   224,   225,    -1,    -1,
     228,    -1,    -1,   231,   232,   233,   234,   235,    -1,   237,
     238,   239,   240,   241,    -1,   243,   244,   245,   246,   247,
     248,   249,   250,   251,    -1,   253,   254,   255,   256,   257,
     258,   259,   260,   261,    -1,   263,   264,    -1,   266,   267,
     268,   269,   270,   271,   272,   273,   274,   275,    -1,   277,
     278,   279,    -1,   281,   282,   283,   284,    -1,   286,   287,
      -1,   289,   290,   291,   292,   293,   294,   295,   296,   297,
     298,    -1,   300,   301,    -1,   303,   304,   305,   306,    -1,
     308,   309,    -1,    -1,   312,   313,   314,   315,   316,   317,
     318,   319,   320,   321,    -1,    -1,   324,   325,   326,   327,
      -1,    -1,   330,   331,   332,   333,   334,   335,    -1,   337,
     338,    -1,    -1,   341,    -1,   343,   344,   345,   346,   347,
      -1,    -1,    -1,   351,   352,   353,    -1,    -1,    -1,   357,
      -1,    -1,    -1,    -1,    -1,    -1,   364,     3,     4,     5,
       6,     7,     8,     9,    10,    11,    12,    13,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    22,    23,    -1,    25,
      -1,    27,    28,    29,    -1,    31,    -1,    33,    34,    -1,
      36,    37,    38,    39,    40,    -1,    -1,    43,    44,    45,
      46,    -1,    48,    49,    50,    51,    52,    -1,    -1,    55,
      56,    57,    58,    59,    -1,    61,    62,    63,    64,    -1,
      66,    67,    68,    -1,    70,    -1,    -1,    -1,    -1,    -1,
      76,    77,    78,    79,    80,    81,    82,    83,    -1,    85,
      -1,    87,    88,    89,    90,    91,    -1,    93,    -1,    -1,
      96,    97,    98,    99,    -1,   101,   102,   103,    -1,   105,
      -1,   107,   108,   109,   110,   111,   112,   113,    -1,   115,
     116,   117,    -1,   119,    -1,   121,    -1,    -1,    -1,   125,
     126,    -1,   128,   129,    -1,   131,    -1,   133,   134,   135,
     136,    -1,   138,   139,   140,    -1,   142,   143,   144,   145,
     146,   147,    -1,    -1,   150,   151,   152,   153,   154,   155,
     156,    -1,   158,    -1,   160,    -1,    -1,   163,    -1,   165,
     166,   167,   168,   169,    -1,   171,    -1,   173,    -1,    -1,
     176,   177,   178,    -1,    -1,   181,   182,   183,   184,   185,
     186,   187,   188,   189,   190,    -1,    -1,    -1,   194,   195,
      -1,   197,    -1,   199,   200,   201,   202,   203,   204,   205,
     206,   207,    -1,   209,   210,    -1,   212,    -1,   214,   215,
     216,   217,    -1,    -1,   220,    -1,    -1,    -1,   224,   225,
      -1,    -1,   228,    -1,    -1,   231,   232,   233,   234,   235,
      -1,   237,   238,   239,   240,   241,    -1,   243,   244,   245,
     246,   247,   248,   249,   250,   251,    -1,   253,   254,   255,
     256,   257,   258,   259,   260,   261,    -1,   263,   264,    -1,
     266,   267,   268,   269,   270,   271,   272,   273,   274,   275,
      -1,   277,   278,   279,    -1,   281,   282,   283,   284,    -1,
     286,   287,    -1,   289,   290,   291,   292,   293,   294,   295,
     296,   297,   298,    -1,   300,   301,    16,   303,   304,   305,
     306,    -1,   308,   309,    -1,    25,   312,   313,   314,   315,
      30,   317,   318,   319,   320,   321,    -1,    -1,   324,   325,
     326,   327,    -1,    -1,   330,   331,   332,   333,   334,   335,
      -1,   337,   338,    -1,    16,   341,    -1,   343,   344,   345,
     346,   347,    -1,    25,    -1,   351,    -1,    -1,    30,    -1,
      -1,   357,    -1,    16,    -1,    -1,    -1,    -1,   364,    -1,
      -1,    -1,    25,    -1,    -1,    -1,    -1,    30,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    16,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    25,    -1,    -1,    -1,    -1,    30,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,   137,    -1,    -1,
      -1,   141,    -1,    -1,    -1,    16,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    25,    -1,    -1,    -1,    -1,    30,
      -1,   161,   162,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,   174,   137,    -1,    -1,    -1,   141,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    16,    -1,
      -1,    -1,    -1,    -1,   137,    -1,    -1,    25,   141,   161,
     162,    -1,    30,    -1,    -1,    -1,    -1,    -1,   208,    -1,
      -1,   211,   174,    -1,    -1,    -1,    -1,    -1,   161,   162,
      -1,    -1,    -1,   137,   224,    -1,   226,   141,    -1,    -1,
      -1,   174,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,   208,   161,   162,   211,
     193,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
     174,    -1,   224,    -1,   226,   208,   137,    -1,   211,    -1,
     141,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,   224,    -1,   226,    -1,   285,    -1,    -1,    -1,    -1,
     161,   162,    -1,    -1,   208,    -1,    -1,   211,    -1,    -1,
      -1,    -1,    -1,   174,    -1,    -1,    -1,    -1,    -1,   137,
     224,    -1,   226,   141,    -1,    -1,    16,    -1,    -1,    -1,
      -1,    -1,    -1,   285,    -1,    25,    -1,    -1,    -1,    -1,
      30,    -1,    -1,   161,   162,    -1,    -1,   208,    -1,    -1,
     211,    -1,   285,    -1,    -1,    -1,   174,    -1,    -1,    -1,
      -1,    -1,    -1,   224,    -1,   226,   356,    -1,    -1,   359,
     360,   361,    -1,   363,   364,   365,   366,   367,   368,    -1,
      -1,   285,    -1,   373,   374,    -1,    -1,    -1,    -1,    -1,
     208,    -1,    -1,   211,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,   356,    -1,   224,   359,   360,   361,
      -1,   363,   364,   365,   366,   367,   368,    -1,    -1,    -1,
      -1,   373,   374,   356,   285,    -1,   359,   360,   361,    -1,
     363,   364,   365,   366,   367,   368,    -1,    -1,    -1,    -1,
      -1,   374,    -1,    -1,    -1,    -1,    -1,   137,    -1,    -1,
      -1,   141,   356,    -1,    -1,   359,   360,   361,    -1,   363,
     364,   365,   366,   367,   368,    -1,    -1,   285,    -1,   373,
     374,   161,   162,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,   174,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,   356,    -1,    -1,   359,   360,
     361,    -1,   363,   364,   365,   366,   367,   368,    -1,    -1,
      -1,    -1,   373,   374,    -1,    -1,    -1,    -1,   208,    -1,
      -1,   211,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,   224,    -1,   226,    -1,   356,    -1,
      -1,   359,   360,   361,    -1,   363,   364,   365,   366,   367,
     368,    -1,    -1,    -1,    -1,    -1,   374,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,   285,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,   356,    -1,    -1,   359,
     360,   361,    -1,   363,   364,   365,   366,   367,   368,    -1,
      -1,    -1,    -1,    -1,   374,     3,     4,     5,     6,     7,
       8,     9,    10,    -1,    12,    13,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    22,    23,    -1,    25,    -1,    27,
      28,    29,    -1,    31,    -1,    33,    34,    -1,    36,    37,
      38,    39,    40,    -1,    -1,    43,    44,    45,    46,    -1,
      48,    49,    50,    51,    52,    -1,    -1,    55,    56,    57,
      58,    59,    -1,    61,    62,    63,    64,    -1,    66,    67,
      68,    -1,    70,    -1,    -1,    -1,    -1,    -1,    76,    77,
      78,    79,    80,    81,    82,    83,    -1,    85,    -1,    87,
      88,    89,    90,    91,    -1,    93,    -1,    -1,    96,    97,
      98,    99,    -1,   101,   102,   103,    -1,   105,    -1,   107,
     108,   109,   110,   111,   112,   113,    -1,   115,   116,   117,
      -1,   119,    -1,   121,    -1,    -1,    -1,   125,   126,    -1,
     128,   129,    -1,   131,    -1,   133,   134,   135,   136,    -1,
     138,   139,   140,    -1,   142,   143,   144,   145,   146,   147,
      -1,    -1,   150,   151,   152,   153,   154,   155,   156,    -1,
     158,    -1,   160,    -1,    -1,   163,    -1,   165,   166,   167,
     168,   169,    -1,   171,    -1,   173,    -1,    -1,   176,   177,
     178,    -1,    -1,   181,   182,   183,   184,   185,   186,   187,
     188,   189,   190,    -1,    -1,    -1,   194,   195,    -1,   197,
      -1,   199,   200,   201,   202,   203,   204,   205,   206,   207,
      -1,   209,   210,    -1,   212,    -1,   214,   215,   216,   217,
      -1,    -1,   220,    -1,    -1,    -1,   224,   225,    -1,    -1,
     228,    -1,    -1,   231,   232,   233,   234,   235,    -1,   237,
     238,   239,   240,   241,    -1,   243,   244,   245,   246,   247,
     248,   249,   250,   251,    -1,   253,   254,   255,   256,   257,
     258,   259,   260,   261,    -1,   263,   264,    -1,   266,   267,
     268,   269,   270,   271,   272,   273,   274,   275,    -1,   277,
     278,   279,    -1,   281,   282,   283,   284,    -1,   286,   287,
      -1,   289,   290,   291,   292,   293,   294,   295,   296,   297,
     298,    -1,   300,   301,    -1,   303,   304,   305,   306,    -1,
     308,   309,    -1,    -1,   312,   313,   314,   315,    -1,   317,
     318,   319,   320,   321,    -1,    -1,   324,   325,   326,   327,
      -1,    -1,   330,   331,   332,   333,   334,   335,    -1,   337,
     338,    -1,    -1,   341,    -1,   343,   344,   345,   346,   347,
      -1,    -1,    -1,   351,   352,   353,   354,   355,    -1,   357,
       3,     4,     5,     6,     7,     8,     9,    10,    -1,    12,
      13,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    22,
      23,    -1,    25,    -1,    27,    28,    29,    -1,    31,    -1,
      33,    34,    -1,    36,    37,    38,    39,    40,    -1,    -1,
      43,    44,    45,    46,    -1,    48,    49,    50,    51,    52,
      -1,    -1,    55,    56,    57,    58,    59,    -1,    61,    62,
      63,    64,    -1,    66,    67,    68,    -1,    70,    -1,    -1,
      -1,    -1,    -1,    76,    77,    78,    79,    80,    81,    82,
      83,    84,    85,    -1,    87,    88,    89,    90,    91,    -1,
      93,    -1,    -1,    96,    97,    98,    99,    -1,   101,   102,
     103,    -1,   105,    -1,   107,   108,   109,   110,   111,   112,
     113,    -1,   115,   116,   117,    -1,   119,    -1,   121,    -1,
      -1,    -1,   125,   126,    -1,   128,   129,    -1,   131,    -1,
     133,   134,   135,   136,    -1,   138,   139,   140,    -1,   142,
     143,   144,   145,   146,   147,    -1,    -1,   150,   151,   152,
     153,   154,   155,   156,    -1,   158,    -1,   160,    -1,    -1,
     163,    -1,   165,   166,   167,   168,   169,    -1,   171,    -1,
     173,    -1,    -1,   176,   177,   178,    -1,    -1,   181,   182,
     183,   184,   185,   186,   187,   188,   189,   190,    -1,    -1,
      -1,   194,   195,    -1,   197,    -1,   199,   200,   201,   202,
     203,   204,   205,   206,   207,    -1,   209,   210,    -1,   212,
      -1,   214,   215,   216,   217,    -1,    -1,   220,    -1,    -1,
      -1,   224,   225,    -1,    -1,   228,    -1,    -1,   231,   232,
     233,   234,   235,    -1,   237,   238,   239,   240,   241,    -1,
     243,   244,   245,   246,   247,   248,   249,   250,   251,    -1,
     253,   254,   255,   256,   257,   258,   259,   260,   261,    -1,
     263,   264,    -1,   266,   267,   268,   269,   270,   271,   272,
     273,   274,   275,    -1,   277,   278,   279,    -1,   281,   282,
     283,   284,    -1,   286,   287,    -1,   289,   290,   291,   292,
     293,   294,   295,   296,   297,   298,    -1,   300,   301,    -1,
     303,   304,   305,   306,    -1,   308,   309,    -1,    -1,   312,
     313,   314,   315,    -1,   317,   318,   319,   320,   321,    -1,
      -1,   324,   325,   326,   327,    -1,    -1,   330,   331,   332,
     333,   334,   335,    -1,   337,   338,    -1,    -1,   341,    -1,
     343,   344,   345,   346,   347,    -1,    -1,    -1,   351,    -1,
     353,     3,     4,     5,     6,     7,     8,     9,    10,    -1,
      12,    13,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      22,    23,    -1,    25,    -1,    27,    28,    29,    -1,    31,
      -1,    33,    34,    -1,    36,    37,    38,    39,    40,    -1,
      -1,    43,    44,    45,    46,    -1,    48,    49,    50,    51,
      52,    -1,    -1,    55,    56,    57,    58,    59,    -1,    61,
      62,    63,    64,    -1,    66,    67,    68,    -1,    70,    -1,
      -1,    -1,    -1,    -1,    76,    77,    78,    79,    80,    81,
      82,    83,    -1,    85,    -1,    87,    88,    89,    90,    91,
      -1,    93,    -1,    -1,    96,    97,    98,    99,    -1,   101,
     102,   103,    -1,   105,    -1,   107,   108,   109,   110,   111,
     112,   113,    -1,   115,   116,   117,    -1,   119,    -1,   121,
      -1,    -1,    -1,   125,   126,    -1,   128,   129,    -1,   131,
      -1,   133,   134,   135,   136,    -1,   138,   139,   140,    -1,
     142,   143,   144,   145,   146,   147,    -1,    -1,   150,   151,
     152,   153,   154,   155,   156,    -1,   158,    -1,   160,    -1,
      -1,   163,    -1,   165,   166,   167,   168,   169,    -1,   171,
      -1,   173,    -1,    -1,   176,   177,   178,    -1,    -1,   181,
     182,   183,   184,   185,   186,   187,   188,   189,   190,    -1,
      -1,    -1,   194,   195,    -1,   197,    -1,   199,   200,   201,
     202,   203,   204,   205,   206,   207,    -1,   209,   210,    -1,
     212,    -1,   214,   215,   216,   217,    -1,    -1,   220,    -1,
      -1,    -1,   224,   225,    -1,    -1,   228,    -1,    -1,   231,
     232,   233,   234,   235,    -1,   237,   238,   239,   240,   241,
      -1,   243,   244,   245,   246,   247,   248,   249,   250,   251,
      -1,   253,   254,   255,   256,   257,   258,   259,   260,   261,
      -1,   263,   264,    -1,   266,   267,   268,   269,   270,   271,
     272,   273,   274,   275,    -1,   277,   278,   279,    -1,   281,
     282,   283,   284,    -1,   286,   287,    -1,   289,   290,   291,
     292,   293,   294,   295,   296,   297,   298,    -1,   300,   301,
      -1,   303,   304,   305,   306,    -1,   308,   309,    -1,    -1,
     312,   313,   314,   315,    -1,   317,   318,   319,   320,   321,
      -1,    -1,   324,   325,   326,   327,    -1,    -1,   330,   331,
     332,   333,   334,   335,    -1,   337,   338,    -1,    -1,   341,
      -1,   343,   344,   345,   346,   347,    -1,    -1,    -1,   351,
      -1,   353,     3,     4,     5,     6,     7,     8,     9,    10,
      -1,    12,    13,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    22,    23,    -1,    25,    -1,    27,    28,    29,    -1,
      31,    -1,    33,    34,    -1,    36,    37,    38,    39,    40,
      -1,    -1,    43,    44,    45,    46,    -1,    48,    49,    50,
      51,    52,    -1,    -1,    55,    56,    57,    58,    59,    -1,
      61,    62,    63,    64,    -1,    66,    67,    68,    -1,    70,
      -1,    -1,    -1,    -1,    -1,    76,    77,    78,    79,    80,
      81,    82,    83,    -1,    85,    -1,    87,    88,    89,    90,
      91,    -1,    93,    -1,    -1,    96,    97,    98,    99,    -1,
     101,   102,   103,    -1,   105,    -1,   107,   108,   109,   110,
     111,   112,   113,    -1,   115,   116,   117,    -1,   119,    -1,
     121,    -1,    -1,    -1,   125,   126,    -1,   128,   129,    -1,
     131,    -1,   133,   134,   135,   136,    -1,   138,   139,   140,
      -1,   142,   143,   144,   145,   146,   147,    -1,    -1,   150,
     151,   152,   153,   154,   155,   156,    -1,   158,    -1,   160,
      -1,    -1,   163,    -1,   165,   166,   167,   168,   169,    -1,
     171,    -1,   173,    -1,    -1,   176,   177,   178,    -1,    -1,
     181,   182,   183,   184,   185,   186,   187,   188,   189,   190,
      -1,    -1,    -1,   194,   195,    -1,   197,    -1,   199,   200,
     201,   202,   203,   204,   205,   206,   207,    -1,   209,   210,
      -1,   212,    -1,   214,   215,   216,   217,    -1,    -1,   220,
      -1,    -1,    -1,   224,   225,    -1,    -1,   228,    -1,    -1,
     231,   232,   233,   234,   235,    -1,   237,   238,   239,   240,
     241,    -1,   243,   244,   245,   246,   247,   248,   249,   250,
     251,    -1,   253,   254,   255,   256,   257,   258,   259,   260,
     261,    -1,   263,   264,    -1,   266,   267,   268,   269,   270,
     271,   272,   273,   274,   275,    -1,   277,   278,   279,    -1,
     281,   282,   283,   284,    -1,   286,   287,    -1,   289,   290,
     291,   292,   293,   294,   295,   296,   297,   298,    -1,   300,
     301,    -1,   303,   304,   305,   306,    -1,   308,   309,    -1,
      -1,   312,   313,   314,   315,    -1,   317,   318,   319,   320,
     321,    -1,    -1,   324,   325,   326,   327,    -1,    -1,   330,
     331,   332,   333,   334,   335,    -1,   337,   338,    -1,    -1,
     341,    -1,   343,   344,   345,   346,   347,    -1,    -1,    -1,
     351,    -1,   353,     3,     4,     5,     6,     7,     8,     9,
      10,    11,    12,    13,    14,    15,    16,    17,    -1,    19,
      20,    21,    22,    23,    24,    25,    26,    27,    28,    29,
      30,    31,    32,    33,    34,    35,    36,    37,    38,    39,
      40,    41,    42,    43,    44,    45,    46,    47,    48,    49,
      50,    51,    52,    53,    54,    55,    56,    57,    58,    59,
      60,    61,    62,    63,    64,    65,    66,    67,    68,    69,
      70,    71,    72,    73,    74,    75,    76,    77,    78,    79,
      80,    81,    82,    83,    84,    85,    86,    87,    88,    89,
      90,    91,    92,    93,    94,    95,    96,    97,    98,    99,
     100,   101,   102,   103,   104,   105,   106,   107,   108,   109,
     110,   111,   112,   113,   114,   115,   116,   117,   118,   119,
     120,   121,   122,   123,   124,   125,   126,   127,   128,   129,
     130,   131,   132,   133,   134,   135,   136,   137,   138,   139,
     140,   141,   142,   143,   144,   145,   146,   147,   148,   149,
     150,   151,   152,   153,   154,   155,   156,   157,   158,   159,
     160,   161,   162,   163,   164,   165,   166,   167,   168,   169,
     170,   171,   172,   173,   174,   175,   176,   177,   178,   179,
     180,   181,   182,   183,   184,   185,   186,   187,   188,   189,
     190,    -1,    -1,    -1,   194,   195,   196,   197,   198,   199,
     200,   201,   202,   203,   204,   205,   206,   207,   208,   209,
     210,   211,   212,   213,   214,   215,   216,   217,   218,   219,
     220,   221,   222,   223,   224,   225,   226,   227,   228,   229,
     230,   231,   232,   233,   234,   235,   236,   237,   238,   239,
     240,   241,   242,   243,   244,   245,   246,   247,   248,   249,
     250,   251,   252,   253,   254,   255,   256,   257,   258,   259,
     260,   261,   262,   263,   264,   265,   266,   267,   268,   269,
     270,   271,   272,   273,   274,   275,   276,   277,   278,   279,
     280,   281,   282,   283,   284,   285,   286,   287,   288,   289,
     290,   291,   292,   293,   294,   295,   296,   297,   298,   299,
     300,   301,   302,   303,   304,   305,   306,   307,   308,   309,
     310,   311,   312,   313,   314,   315,   316,   317,   318,   319,
     320,   321,   322,   323,   324,   325,   326,   327,   328,   329,
     330,   331,   332,   333,   334,   335,   336,   337,   338,   339,
     340,   341,    -1,   343,   344,   345,   346,   347,    -1,    -1,
      -1,   351,     3,     4,     5,     6,     7,     8,     9,    10,
      -1,    12,    13,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    22,    23,    -1,    25,    26,    27,    28,    29,    30,
      31,    32,    33,    34,    -1,    36,    37,    38,    39,    40,
      -1,    -1,    43,    44,    45,    46,    -1,    48,    49,    50,
      51,    52,    -1,    -1,    55,    56,    57,    58,    59,    -1,
      61,    62,    63,    64,    -1,    66,    67,    68,    69,    70,
      -1,    -1,    -1,    -1,    -1,    76,    77,    78,    79,    80,
      81,    82,    83,    -1,    85,    -1,    87,    88,    89,    90,
      91,    -1,    93,    -1,    -1,    96,    97,    98,    99,    -1,
     101,   102,   103,    -1,   105,    -1,   107,   108,   109,   110,
     111,   112,   113,    -1,   115,   116,   117,    -1,   119,    -1,
     121,   122,    -1,   124,   125,   126,    -1,   128,   129,    -1,
     131,    -1,   133,   134,   135,   136,   137,   138,   139,   140,
      -1,   142,   143,   144,   145,   146,   147,    -1,   149,   150,
     151,   152,   153,   154,   155,   156,    -1,   158,    -1,   160,
     161,   162,   163,   164,   165,   166,   167,   168,   169,    -1,
     171,   172,   173,   174,    -1,   176,   177,   178,    -1,    -1,
     181,   182,   183,   184,   185,   186,   187,   188,   189,   190,
      -1,    -1,    -1,   194,   195,   196,   197,   198,   199,   200,
     201,   202,   203,   204,   205,   206,   207,    -1,   209,   210,
     211,   212,    -1,   214,   215,   216,   217,    -1,    -1,   220,
     221,    -1,    -1,   224,   225,    -1,    -1,   228,   229,   230,
     231,   232,   233,   234,   235,    -1,   237,   238,   239,   240,
     241,    -1,   243,   244,   245,   246,   247,   248,   249,   250,
     251,    -1,   253,   254,   255,   256,   257,   258,   259,   260,
     261,    -1,   263,   264,   265,   266,   267,   268,   269,   270,
     271,   272,   273,   274,   275,    -1,   277,   278,   279,    -1,
     281,   282,   283,   284,   285,   286,   287,    -1,   289,   290,
     291,   292,   293,   294,   295,   296,   297,   298,    -1,   300,
     301,    -1,   303,   304,   305,   306,    -1,   308,   309,    -1,
      -1,   312,   313,   314,   315,    -1,   317,   318,   319,   320,
     321,    -1,    -1,   324,   325,   326,   327,    -1,    -1,   330,
     331,   332,   333,   334,   335,   336,   337,   338,    -1,    -1,
     341,    -1,   343,   344,   345,   346,   347,    -1,    -1,    -1,
     351,     3,     4,     5,     6,     7,     8,     9,    10,    -1,
      12,    13,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      22,    23,    -1,    25,    26,    27,    28,    29,    30,    31,
      32,    33,    34,    -1,    36,    37,    38,    39,    40,    -1,
      -1,    43,    44,    45,    46,    -1,    48,    49,    50,    51,
      52,    -1,    -1,    55,    56,    57,    58,    59,    -1,    61,
      62,    63,    64,    -1,    66,    67,    68,    69,    70,    -1,
      -1,    -1,    -1,    -1,    76,    77,    78,    79,    80,    81,
      82,    83,    -1,    85,    -1,    87,    88,    89,    90,    91,
      -1,    93,    -1,    -1,    96,    97,    98,    99,    -1,   101,
     102,   103,    -1,   105,    -1,   107,   108,   109,   110,   111,
     112,   113,    -1,   115,   116,   117,    -1,   119,    -1,   121,
     122,    -1,   124,   125,   126,    -1,   128,   129,    -1,   131,
      -1,   133,   134,   135,   136,   137,   138,   139,   140,    -1,
     142,   143,   144,   145,   146,   147,    -1,   149,   150,   151,
     152,   153,   154,   155,   156,    -1,   158,    -1,   160,   161,
     162,   163,   164,   165,   166,   167,   168,   169,    -1,   171,
     172,   173,   174,    -1,   176,   177,   178,    -1,    -1,   181,
     182,   183,   184,   185,   186,   187,   188,   189,   190,    -1,
      -1,    -1,   194,   195,   196,   197,   198,   199,   200,   201,
     202,   203,   204,   205,   206,   207,    -1,   209,   210,   211,
     212,    -1,   214,   215,   216,   217,    -1,    -1,   220,   221,
      -1,    -1,   224,   225,    -1,    -1,   228,   229,   230,   231,
     232,   233,   234,   235,    -1,   237,   238,   239,   240,   241,
      -1,   243,   244,   245,   246,   247,   248,   249,   250,   251,
      -1,   253,   254,   255,   256,   257,   258,   259,   260,   261,
      -1,   263,   264,   265,   266,   267,   268,   269,   270,   271,
     272,   273,   274,   275,    -1,   277,   278,   279,    -1,   281,
     282,   283,   284,   285,   286,   287,    -1,   289,   290,   291,
     292,   293,   294,   295,   296,   297,   298,    -1,   300,   301,
      -1,   303,   304,   305,   306,    -1,   308,   309,    -1,    -1,
     312,   313,   314,   315,    -1,   317,   318,   319,   320,   321,
      -1,    -1,   324,   325,   326,   327,    -1,    -1,   330,   331,
     332,   333,   334,   335,   336,   337,   338,    -1,    -1,   341,
      -1,   343,   344,   345,   346,   347,    -1,    -1,    -1,   351,
       3,     4,     5,     6,     7,     8,     9,    10,    -1,    12,
      13,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    22,
      23,    -1,    25,    26,    27,    28,    29,    30,    31,    32,
      33,    34,    -1,    36,    37,    38,    39,    40,    -1,    -1,
      43,    44,    45,    46,    -1,    48,    49,    50,    51,    52,
      -1,    -1,    55,    56,    57,    58,    59,    -1,    61,    62,
      63,    64,    -1,    66,    67,    68,    69,    70,    -1,    -1,
      -1,    -1,    -1,    76,    77,    78,    79,    80,    81,    82,
      83,    -1,    85,    -1,    87,    88,    89,    90,    91,    -1,
      93,    -1,    -1,    96,    97,    98,    99,    -1,   101,   102,
     103,    -1,   105,    -1,   107,   108,   109,   110,   111,   112,
     113,    -1,   115,   116,   117,    -1,   119,    -1,   121,   122,
      -1,   124,   125,   126,    -1,   128,   129,    -1,   131,    -1,
     133,   134,   135,   136,   137,   138,   139,   140,    -1,   142,
     143,   144,   145,   146,   147,    -1,   149,   150,   151,   152,
     153,   154,   155,   156,    -1,   158,    -1,   160,   161,   162,
     163,   164,   165,   166,   167,   168,   169,    -1,   171,   172,
     173,   174,    -1,   176,   177,   178,    -1,    -1,   181,   182,
     183,   184,   185,   186,   187,   188,   189,   190,    -1,    -1,
      -1,   194,   195,   196,   197,   198,   199,   200,   201,   202,
     203,   204,   205,   206,   207,    -1,   209,   210,   211,   212,
      -1,   214,   215,   216,   217,    -1,    -1,   220,   221,    -1,
      -1,   224,   225,    -1,    -1,   228,   229,   230,   231,   232,
     233,   234,   235,    -1,   237,   238,   239,   240,   241,    -1,
     243,   244,   245,   246,   247,   248,   249,   250,   251,    -1,
     253,   254,   255,   256,   257,   258,   259,   260,   261,    -1,
     263,   264,   265,   266,   267,   268,   269,   270,   271,   272,
     273,   274,   275,    -1,   277,   278,   279,    -1,   281,   282,
     283,   284,   285,   286,   287,    -1,   289,   290,   291,   292,
     293,   294,   295,   296,   297,   298,    -1,   300,   301,    -1,
     303,   304,   305,   306,    -1,   308,   309,    -1,    -1,   312,
     313,   314,   315,    -1,   317,   318,   319,   320,   321,    -1,
      -1,   324,   325,   326,   327,    -1,    -1,   330,   331,   332,
     333,   334,   335,   336,   337,   338,    -1,    -1,   341,    -1,
     343,   344,   345,   346,   347,    -1,    -1,    -1,   351,     3,
       4,     5,     6,     7,     8,     9,    10,    -1,    12,    13,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    22,    23,
      -1,    25,    -1,    27,    28,    29,    -1,    31,    -1,    33,
      34,    -1,    36,    37,    38,    39,    40,    -1,    -1,    43,
      44,    45,    46,    47,    48,    49,    50,    51,    52,    -1,
      -1,    55,    56,    57,    58,    59,    60,    61,    62,    63,
      64,    -1,    66,    67,    68,    -1,    70,    -1,    -1,    -1,
      -1,    -1,    76,    77,    78,    79,    80,    81,    82,    83,
      -1,    85,    -1,    87,    88,    89,    90,    91,    -1,    93,
      -1,    -1,    96,    97,    98,    99,    -1,   101,   102,   103,
      -1,   105,    -1,   107,   108,   109,   110,   111,   112,   113,
      -1,   115,   116,   117,    -1,   119,   120,   121,    -1,    -1,
      -1,   125,   126,    -1,   128,   129,    -1,   131,    -1,   133,
     134,   135,   136,    -1,   138,   139,   140,    -1,   142,   143,
     144,   145,   146,   147,    -1,    -1,   150,   151,   152,   153,
     154,   155,   156,    -1,   158,    -1,   160,    -1,    -1,   163,
      -1,   165,   166,   167,   168,   169,    -1,   171,    -1,   173,
     174,    -1,   176,   177,   178,    -1,    -1,   181,   182,   183,
     184,   185,   186,   187,   188,   189,   190,    -1,    -1,    -1,
     194,   195,    -1,   197,    -1,   199,   200,   201,   202,   203,
     204,   205,   206,   207,    -1,   209,   210,    -1,   212,    -1,
     214,   215,   216,   217,    -1,    -1,   220,    -1,    -1,    -1,
     224,   225,    -1,    -1,   228,    -1,    -1,   231,   232,   233,
     234,   235,    -1,   237,   238,   239,   240,   241,   242,   243,
     244,   245,   246,   247,   248,   249,   250,   251,    -1,   253,
     254,   255,   256,   257,   258,   259,   260,   261,    -1,   263,
     264,    -1,   266,   267,   268,   269,   270,   271,   272,   273,
     274,   275,    -1,   277,   278,   279,    -1,   281,   282,   283,
     284,    -1,   286,   287,    -1,   289,   290,   291,   292,   293,
     294,   295,   296,   297,   298,    -1,   300,   301,    -1,   303,
     304,   305,   306,    -1,   308,   309,    -1,    -1,   312,   313,
     314,   315,    -1,   317,   318,   319,   320,   321,    -1,   323,
     324,   325,   326,   327,    -1,    -1,   330,   331,   332,   333,
     334,   335,    -1,   337,   338,    -1,    -1,   341,    -1,   343,
     344,   345,   346,   347,    -1,    -1,    -1,   351,     3,     4,
       5,     6,     7,     8,     9,    10,    11,    12,    13,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    22,    23,    -1,
      25,    -1,    27,    28,    29,    -1,    31,    -1,    33,    34,
      -1,    36,    37,    38,    39,    40,    -1,    -1,    43,    44,
      45,    46,    -1,    48,    49,    50,    51,    52,    -1,    -1,
      55,    56,    57,    58,    59,    -1,    61,    62,    63,    64,
      65,    66,    67,    68,    -1,    70,    -1,    -1,    -1,    -1,
      -1,    76,    77,    78,    79,    80,    81,    82,    83,    -1,
      85,    -1,    87,    88,    89,    90,    91,    -1,    93,    -1,
      -1,    96,    97,    98,    99,    -1,   101,   102,   103,    -1,
     105,    -1,   107,   108,   109,   110,   111,   112,   113,    -1,
     115,   116,   117,    -1,   119,    -1,   121,    -1,    -1,    -1,
     125,   126,   127,   128,   129,    -1,   131,    -1,   133,   134,
     135,   136,    -1,   138,   139,   140,    -1,   142,   143,   144,
     145,   146,   147,    -1,    -1,   150,   151,   152,   153,   154,
     155,   156,    -1,   158,    -1,   160,    -1,    -1,   163,    -1,
     165,   166,   167,   168,   169,    -1,   171,    -1,   173,    -1,
      -1,   176,   177,   178,    -1,    -1,   181,   182,   183,   184,
     185,   186,   187,   188,   189,   190,    -1,    -1,    -1,   194,
     195,    -1,   197,    -1,   199,   200,   201,   202,   203,   204,
     205,   206,   207,    -1,   209,   210,    -1,   212,    -1,   214,
     215,   216,   217,    -1,    -1,   220,    -1,    -1,    -1,   224,
     225,    -1,    -1,   228,    -1,    -1,   231,   232,   233,   234,
     235,    -1,   237,   238,   239,   240,   241,    -1,   243,   244,
     245,   246,   247,   248,   249,   250,   251,   252,   253,   254,
     255,   256,   257,   258,   259,   260,   261,    -1,   263,   264,
      -1,   266,   267,   268,   269,   270,   271,   272,   273,   274,
     275,   276,   277,   278,   279,    -1,   281,   282,   283,   284,
      -1,   286,   287,    -1,   289,   290,   291,   292,   293,   294,
     295,   296,   297,   298,    -1,   300,   301,    -1,   303,   304,
     305,   306,    -1,   308,   309,    -1,    -1,   312,   313,   314,
     315,    -1,   317,   318,   319,   320,   321,    -1,    -1,   324,
     325,   326,   327,    -1,    -1,   330,   331,   332,   333,   334,
     335,    -1,   337,   338,    -1,    -1,   341,    -1,   343,   344,
     345,   346,   347,    -1,    -1,    -1,   351,     3,     4,     5,
       6,     7,     8,     9,    10,    -1,    12,    13,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    22,    23,    -1,    25,
      26,    27,    28,    29,    30,    31,    32,    33,    34,    -1,
      36,    37,    38,    39,    40,    -1,    -1,    43,    44,    45,
      46,    -1,    48,    49,    50,    51,    -1,    -1,    -1,    55,
      56,    57,    58,    59,    -1,    61,    62,    -1,    64,    -1,
      66,    67,    68,    69,    70,    -1,    -1,    -1,    -1,    -1,
      76,    77,    78,    79,    80,    81,    82,    83,    -1,    85,
      -1,    87,    88,    89,    90,    91,    -1,    93,    -1,    -1,
      96,    97,    98,    99,    -1,   101,   102,   103,    -1,   105,
      -1,   107,   108,   109,    -1,   111,   112,    -1,    -1,   115,
     116,   117,    -1,   119,    -1,   121,   122,    -1,   124,   125,
     126,    -1,   128,    -1,    -1,   131,    -1,   133,   134,   135,
     136,   137,   138,   139,   140,   141,   142,   143,   144,   145,
     146,   147,    -1,   149,   150,   151,   152,   153,   154,   155,
     156,    -1,   158,    -1,   160,   161,   162,   163,   164,   165,
     166,   167,   168,   169,    -1,    -1,   172,   173,   174,    -1,
     176,   177,   178,    -1,    -1,   181,   182,   183,   184,   185,
     186,   187,   188,   189,   190,    -1,    -1,    -1,   194,   195,
     196,   197,    -1,   199,   200,   201,   202,   203,   204,   205,
      -1,   207,    -1,   209,   210,   211,   212,    -1,    -1,   215,
     216,   217,    -1,    -1,   220,    -1,    -1,    -1,   224,   225,
      -1,    -1,   228,   229,   230,    -1,   232,   233,   234,   235,
      -1,    -1,    -1,   239,   240,   241,    -1,   243,   244,   245,
     246,   247,   248,   249,   250,   251,    -1,   253,   254,   255,
     256,   257,   258,   259,   260,   261,    -1,   263,   264,   265,
     266,   267,    -1,   269,   270,   271,   272,   273,   274,   275,
      -1,   277,   278,   279,    -1,   281,   282,   283,   284,   285,
     286,   287,    -1,   289,   290,   291,   292,   293,   294,   295,
     296,    -1,   298,    -1,   300,   301,    -1,   303,   304,   305,
     306,    -1,   308,   309,    -1,    -1,   312,    -1,   314,    -1,
      -1,   317,   318,   319,   320,   321,    -1,    -1,   324,   325,
     326,   327,    -1,    -1,   330,   331,   332,    -1,   334,   335,
     336,   337,   338,    -1,    -1,   341,    -1,   343,   344,   345,
     346,   347,    -1,    -1,    -1,   351,     3,     4,     5,     6,
       7,     8,     9,    10,    11,    12,    13,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    22,    23,    -1,    25,    -1,
      27,    28,    29,    -1,    31,    -1,    33,    34,    -1,    36,
      37,    38,    39,    40,    -1,    -1,    43,    44,    45,    46,
      -1,    48,    49,    50,    51,    52,    -1,    -1,    55,    56,
      57,    58,    59,    -1,    61,    62,    63,    64,    65,    66,
      67,    68,    -1,    70,    -1,    -1,    -1,    -1,    -1,    76,
      77,    78,    79,    80,    81,    82,    83,    -1,    85,    -1,
      87,    88,    89,    90,    91,    -1,    93,    -1,    -1,    96,
      97,    98,    99,    -1,   101,   102,   103,    -1,   105,    -1,
     107,   108,   109,   110,   111,   112,   113,    -1,   115,   116,
     117,    -1,   119,    -1,   121,    -1,    -1,    -1,   125,   126,
      -1,   128,   129,    -1,   131,    -1,   133,   134,   135,   136,
      -1,   138,   139,   140,    -1,   142,   143,   144,   145,   146,
     147,    -1,    -1,   150,   151,   152,   153,   154,   155,   156,
      -1,   158,    -1,   160,    -1,    -1,   163,    -1,   165,   166,
     167,   168,   169,    -1,   171,    -1,   173,    -1,    -1,   176,
     177,   178,    -1,    -1,   181,   182,   183,   184,   185,   186,
     187,   188,   189,   190,    -1,    -1,    -1,   194,   195,    -1,
     197,    -1,   199,   200,   201,   202,   203,   204,   205,   206,
     207,    -1,   209,   210,    -1,   212,    -1,   214,   215,   216,
     217,    -1,    -1,   220,    -1,    -1,    -1,   224,   225,    -1,
      -1,   228,    -1,    -1,   231,   232,   233,   234,   235,    -1,
     237,   238,   239,   240,   241,    -1,   243,   244,   245,   246,
     247,   248,   249,   250,   251,   252,   253,   254,   255,   256,
     257,   258,   259,   260,   261,    -1,   263,   264,    -1,   266,
     267,   268,   269,   270,   271,   272,   273,   274,   275,   276,
     277,   278,   279,    -1,   281,   282,   283,   284,    -1,   286,
     287,    -1,   289,   290,   291,   292,   293,   294,   295,   296,
     297,   298,    -1,   300,   301,    -1,   303,   304,   305,   306,
      -1,   308,   309,    -1,    -1,   312,   313,   314,   315,    -1,
     317,   318,   319,   320,   321,    -1,    -1,   324,   325,   326,
     327,    -1,    -1,   330,   331,   332,   333,   334,   335,    -1,
     337,   338,    -1,    -1,   341,    -1,   343,   344,   345,   346,
     347,    -1,    -1,    -1,   351,     3,     4,     5,     6,     7,
       8,     9,    10,    -1,    12,    13,    14,    15,    -1,    -1,
      -1,    -1,    -1,    -1,    22,    23,    -1,    25,    -1,    27,
      28,    29,    -1,    31,    -1,    33,    34,    -1,    36,    37,
      38,    39,    40,    -1,    -1,    43,    44,    45,    46,    -1,
      48,    49,    50,    51,    52,    -1,    -1,    55,    56,    57,
      58,    59,    -1,    61,    62,    63,    64,    -1,    66,    67,
      68,    -1,    70,    -1,    -1,    -1,    -1,    -1,    76,    77,
      78,    79,    80,    81,    82,    83,    -1,    85,    -1,    87,
      88,    89,    90,    91,    -1,    93,    -1,    -1,    96,    97,
      98,    99,    -1,   101,   102,   103,    -1,   105,    -1,   107,
     108,   109,   110,   111,   112,   113,    -1,   115,   116,   117,
      -1,   119,    -1,   121,    -1,    -1,    -1,   125,   126,    -1,
     128,   129,    -1,   131,    -1,   133,   134,   135,   136,    -1,
     138,   139,   140,    -1,   142,   143,   144,   145,   146,   147,
      -1,    -1,   150,   151,   152,   153,   154,   155,   156,    -1,
     158,    -1,   160,    -1,    -1,   163,    -1,   165,   166,   167,
     168,   169,    -1,   171,    -1,   173,    -1,    -1,   176,   177,
     178,    -1,    -1,   181,   182,   183,   184,   185,   186,   187,
     188,   189,   190,    -1,    -1,    -1,   194,   195,    -1,   197,
     198,   199,   200,   201,   202,   203,   204,   205,   206,   207,
      -1,   209,   210,    -1,   212,    -1,   214,   215,   216,   217,
      -1,    -1,   220,   221,    -1,    -1,   224,   225,    -1,    -1,
     228,    -1,    -1,   231,   232,   233,   234,   235,    -1,   237,
     238,   239,   240,   241,    -1,   243,   244,   245,   246,   247,
     248,   249,   250,   251,    -1,   253,   254,   255,   256,   257,
     258,   259,   260,   261,    -1,   263,   264,    -1,   266,   267,
     268,   269,   270,   271,   272,   273,   274,   275,    -1,   277,
     278,   279,    -1,   281,   282,   283,   284,    -1,   286,   287,
      -1,   289,   290,   291,   292,   293,   294,   295,   296,   297,
     298,    -1,   300,   301,    -1,   303,   304,   305,   306,    -1,
     308,   309,    -1,    -1,   312,   313,   314,   315,    -1,   317,
     318,   319,   320,   321,    -1,    -1,   324,   325,   326,   327,
      -1,    -1,   330,   331,   332,   333,   334,   335,    -1,   337,
     338,    -1,    -1,   341,    -1,   343,   344,   345,   346,   347,
      -1,    -1,    -1,   351,     3,     4,     5,     6,     7,     8,
       9,    10,    -1,    12,    13,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    22,    23,    -1,    25,    -1,    27,    28,
      29,    -1,    31,    -1,    33,    34,    -1,    36,    37,    38,
      39,    40,    -1,    -1,    43,    44,    45,    46,    -1,    48,
      49,    50,    51,    52,    -1,    -1,    55,    56,    57,    58,
      59,    -1,    61,    62,    63,    64,    -1,    66,    67,    68,
      -1,    70,    -1,    -1,    -1,    -1,    -1,    76,    77,    78,
      79,    80,    81,    82,    83,    -1,    85,    -1,    87,    88,
      89,    90,    91,    -1,    93,    -1,    -1,    96,    97,    98,
      99,    -1,   101,   102,   103,    -1,   105,    -1,   107,   108,
     109,   110,   111,   112,   113,    -1,   115,   116,   117,    -1,
     119,    -1,   121,    -1,    -1,    -1,   125,   126,    -1,   128,
     129,    -1,   131,    -1,   133,   134,   135,   136,    -1,   138,
     139,   140,    -1,   142,   143,   144,   145,   146,   147,    -1,
      -1,   150,   151,   152,   153,   154,   155,   156,    -1,   158,
      -1,   160,    -1,    -1,   163,    -1,   165,   166,   167,   168,
     169,    -1,   171,    -1,   173,    -1,    -1,   176,   177,   178,
      -1,    -1,   181,   182,   183,   184,   185,   186,   187,   188,
     189,   190,    -1,    -1,    -1,   194,   195,    -1,   197,   198,
     199,   200,   201,   202,   203,   204,   205,   206,   207,    -1,
     209,   210,    -1,   212,    -1,   214,   215,   216,   217,    -1,
      -1,   220,   221,    -1,   223,   224,   225,    -1,    -1,   228,
      -1,    -1,   231,   232,   233,   234,   235,    -1,   237,   238,
     239,   240,   241,    -1,   243,   244,   245,   246,   247,   248,
     249,   250,   251,    -1,   253,   254,   255,   256,   257,   258,
     259,   260,   261,    -1,   263,   264,    -1,   266,   267,   268,
     269,   270,   271,   272,   273,   274,   275,    -1,   277,   278,
     279,    -1,   281,   282,   283,   284,    -1,   286,   287,    -1,
     289,   290,   291,   292,   293,   294,   295,   296,   297,   298,
      -1,   300,   301,    -1,   303,   304,   305,   306,    -1,   308,
     309,    -1,    -1,   312,   313,   314,   315,    -1,   317,   318,
     319,   320,   321,    -1,    -1,   324,   325,   326,   327,    -1,
      -1,   330,   331,   332,   333,   334,   335,    -1,   337,   338,
      -1,    -1,   341,    -1,   343,   344,   345,   346,   347,    -1,
      -1,    -1,   351,     3,     4,     5,     6,     7,     8,     9,
      10,    11,    12,    13,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    22,    23,    -1,    25,    -1,    27,    28,    29,
      -1,    31,    -1,    33,    34,    -1,    36,    37,    38,    39,
      40,    -1,    -1,    43,    44,    45,    46,    -1,    48,    49,
      50,    51,    52,    -1,    -1,    55,    56,    57,    58,    59,
      -1,    61,    62,    63,    64,    -1,    66,    67,    68,    -1,
      70,    -1,    -1,    -1,    -1,    -1,    76,    77,    78,    79,
      80,    81,    82,    83,    -1,    85,    -1,    87,    88,    89,
      90,    91,    -1,    93,    -1,    -1,    96,    97,    98,    99,
      -1,   101,   102,   103,    -1,   105,    -1,   107,   108,   109,
     110,   111,   112,   113,    -1,   115,   116,   117,    -1,   119,
      -1,   121,    -1,    -1,    -1,   125,   126,    -1,   128,   129,
      -1,   131,    -1,   133,   134,   135,   136,    -1,   138,   139,
     140,    -1,   142,   143,   144,   145,   146,   147,    -1,    -1,
     150,   151,   152,   153,   154,   155,   156,    -1,   158,    -1,
     160,    -1,    -1,   163,    -1,   165,   166,   167,   168,   169,
      -1,   171,    -1,   173,    -1,    -1,   176,   177,   178,    -1,
      -1,   181,   182,   183,   184,   185,   186,   187,   188,   189,
     190,    -1,    -1,    -1,   194,   195,    -1,   197,   198,   199,
     200,   201,   202,   203,   204,   205,   206,   207,    -1,   209,
     210,    -1,   212,    -1,   214,   215,   216,   217,    -1,    -1,
     220,   221,    -1,    -1,   224,   225,    -1,    -1,   228,    -1,
      -1,   231,   232,   233,   234,   235,    -1,   237,   238,   239,
     240,   241,    -1,   243,   244,   245,   246,   247,   248,   249,
     250,   251,    -1,   253,   254,   255,   256,   257,   258,   259,
     260,   261,    -1,   263,   264,    -1,   266,   267,   268,   269,
     270,   271,   272,   273,   274,   275,    -1,   277,   278,   279,
      -1,   281,   282,   283,   284,    -1,   286,   287,    -1,   289,
     290,   291,   292,   293,   294,   295,   296,   297,   298,    -1,
     300,   301,    -1,   303,   304,   305,   306,    -1,   308,   309,
      -1,    -1,   312,   313,   314,   315,    -1,   317,   318,   319,
     320,   321,    -1,    -1,   324,   325,   326,   327,    -1,    -1,
     330,   331,   332,   333,   334,   335,    -1,   337,   338,    -1,
      -1,   341,    -1,   343,   344,   345,   346,   347,    -1,    -1,
      -1,   351,     3,     4,     5,     6,     7,     8,     9,    10,
      -1,    12,    13,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    22,    23,    -1,    25,    -1,    27,    28,    29,    -1,
      31,    -1,    33,    34,    -1,    36,    37,    38,    39,    40,
      -1,    -1,    43,    44,    45,    46,    -1,    48,    49,    50,
      51,    52,    -1,    -1,    55,    56,    57,    58,    59,    -1,
      61,    62,    63,    64,    -1,    66,    67,    68,    -1,    70,
      -1,    -1,    -1,    -1,    -1,    76,    77,    78,    79,    80,
      81,    82,    83,    -1,    85,    -1,    87,    88,    89,    90,
      91,    -1,    93,    -1,    -1,    96,    97,    98,    99,    -1,
     101,   102,   103,    -1,   105,    -1,   107,   108,   109,   110,
     111,   112,   113,    -1,   115,   116,   117,    -1,   119,    -1,
     121,    -1,    -1,    -1,   125,   126,    -1,   128,   129,    -1,
     131,    -1,   133,   134,   135,   136,    -1,   138,   139,   140,
      -1,   142,   143,   144,   145,   146,   147,    -1,    -1,   150,
     151,   152,   153,   154,   155,   156,    -1,   158,    -1,   160,
      -1,    -1,   163,    -1,   165,   166,   167,   168,   169,    -1,
     171,    -1,   173,    -1,    -1,   176,   177,   178,    -1,    -1,
     181,   182,   183,   184,   185,   186,   187,   188,   189,   190,
      -1,    -1,    -1,   194,   195,    -1,   197,   198,   199,   200,
     201,   202,   203,   204,   205,   206,   207,    -1,   209,   210,
      -1,   212,    -1,   214,   215,   216,   217,    -1,    -1,   220,
     221,    -1,    -1,   224,   225,    -1,    -1,   228,    -1,    -1,
     231,   232,   233,   234,   235,    -1,   237,   238,   239,   240,
     241,    -1,   243,   244,   245,   246,   247,   248,   249,   250,
     251,    -1,   253,   254,   255,   256,   257,   258,   259,   260,
     261,    -1,   263,   264,    -1,   266,   267,   268,   269,   270,
     271,   272,   273,   274,   275,    -1,   277,   278,   279,    -1,
     281,   282,   283,   284,    -1,   286,   287,    -1,   289,   290,
     291,   292,   293,   294,   295,   296,   297,   298,    -1,   300,
     301,   302,   303,   304,   305,   306,    -1,   308,   309,    -1,
      -1,   312,   313,   314,   315,    -1,   317,   318,   319,   320,
     321,    -1,    -1,   324,   325,   326,   327,    -1,    -1,   330,
     331,   332,   333,   334,   335,    -1,   337,   338,    -1,    -1,
     341,    -1,   343,   344,   345,   346,   347,    -1,    -1,    -1,
     351,     3,     4,     5,     6,     7,     8,     9,    10,    -1,
      12,    13,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      22,    23,    -1,    25,    -1,    27,    28,    29,    -1,    31,
      -1,    33,    34,    -1,    36,    37,    38,    39,    40,    -1,
      -1,    43,    44,    45,    46,    -1,    48,    49,    50,    51,
      52,    -1,    -1,    55,    56,    57,    58,    59,    -1,    61,
      62,    63,    64,    65,    66,    67,    68,    -1,    70,    -1,
      -1,    -1,    -1,    -1,    76,    77,    78,    79,    80,    81,
      82,    83,    -1,    85,    -1,    87,    88,    89,    90,    91,
      -1,    93,    -1,    -1,    96,    97,    98,    99,    -1,   101,
     102,   103,    -1,   105,    -1,   107,   108,   109,   110,   111,
     112,   113,    -1,   115,   116,   117,    -1,   119,    -1,   121,
      -1,    -1,    -1,   125,   126,    -1,   128,   129,    -1,   131,
      -1,   133,   134,   135,   136,    -1,   138,   139,   140,    -1,
     142,   143,   144,   145,   146,   147,    -1,    -1,   150,   151,
     152,   153,   154,   155,   156,    -1,   158,    -1,   160,    -1,
      -1,   163,    -1,   165,   166,   167,   168,   169,    -1,   171,
      -1,   173,    -1,    -1,   176,   177,   178,    -1,    -1,   181,
     182,   183,   184,   185,   186,   187,   188,   189,   190,    -1,
      -1,    -1,   194,   195,    -1,   197,    -1,   199,   200,   201,
     202,   203,   204,   205,   206,   207,    -1,   209,   210,    -1,
     212,    -1,   214,   215,   216,   217,    -1,    -1,   220,    -1,
      -1,    -1,   224,   225,    -1,    -1,   228,    -1,    -1,   231,
     232,   233,   234,   235,    -1,   237,   238,   239,   240,   241,
      -1,   243,   244,   245,   246,   247,   248,   249,   250,   251,
     252,   253,   254,   255,   256,   257,   258,   259,   260,   261,
      -1,   263,   264,    -1,   266,   267,   268,   269,   270,   271,
     272,   273,   274,   275,   276,   277,   278,   279,    -1,   281,
     282,   283,   284,    -1,   286,   287,    -1,   289,   290,   291,
     292,   293,   294,   295,   296,   297,   298,    -1,   300,   301,
      -1,   303,   304,   305,   306,    -1,   308,   309,    -1,    -1,
     312,   313,   314,   315,    -1,   317,   318,   319,   320,   321,
      -1,    -1,   324,   325,   326,   327,    -1,    -1,   330,   331,
     332,   333,   334,   335,    -1,   337,   338,    -1,    -1,   341,
      -1,   343,   344,   345,   346,   347,    -1,    -1,    -1,   351,
       3,     4,     5,     6,     7,     8,     9,    10,    -1,    12,
      13,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    22,
      23,    -1,    25,    -1,    27,    28,    29,    -1,    31,    -1,
      33,    34,    -1,    36,    37,    38,    39,    40,    -1,    -1,
      43,    44,    45,    46,    -1,    48,    49,    50,    51,    52,
      -1,    -1,    55,    56,    57,    58,    59,    -1,    61,    62,
      63,    64,    -1,    66,    67,    68,    -1,    70,    -1,    -1,
      -1,    -1,    -1,    76,    77,    78,    79,    80,    81,    82,
      83,    -1,    85,    -1,    87,    88,    89,    90,    91,    -1,
      93,    -1,    -1,    96,    97,    98,    99,    -1,   101,   102,
     103,    -1,   105,    -1,   107,   108,   109,   110,   111,   112,
     113,    -1,   115,   116,   117,    -1,   119,    -1,   121,    -1,
      -1,    -1,   125,   126,    -1,   128,   129,    -1,   131,    -1,
     133,   134,   135,   136,    -1,   138,   139,   140,    -1,   142,
     143,   144,   145,   146,   147,    -1,    -1,   150,   151,   152,
     153,   154,   155,   156,    -1,   158,    -1,   160,    -1,    -1,
     163,    -1,   165,   166,   167,   168,   169,    -1,   171,    -1,
     173,    -1,    -1,   176,   177,   178,    -1,    -1,   181,   182,
     183,   184,   185,   186,   187,   188,   189,   190,    -1,    -1,
      -1,   194,   195,    -1,   197,   198,   199,   200,   201,   202,
     203,   204,   205,   206,   207,    -1,   209,   210,    -1,   212,
      -1,   214,   215,   216,   217,    -1,    -1,   220,   221,    -1,
      -1,   224,   225,    -1,    -1,   228,    -1,    -1,   231,   232,
     233,   234,   235,    -1,   237,   238,   239,   240,   241,    -1,
     243,   244,   245,   246,   247,   248,   249,   250,   251,    -1,
     253,   254,   255,   256,   257,   258,   259,   260,   261,    -1,
     263,   264,    -1,   266,   267,   268,   269,   270,   271,   272,
     273,   274,   275,    -1,   277,   278,   279,    -1,   281,   282,
     283,   284,    -1,   286,   287,    -1,   289,   290,   291,   292,
     293,   294,   295,   296,   297,   298,    -1,   300,   301,   302,
     303,   304,   305,   306,    -1,   308,   309,    -1,    -1,   312,
     313,   314,   315,    -1,   317,   318,   319,   320,   321,    -1,
      -1,   324,   325,   326,   327,    -1,    -1,   330,   331,   332,
     333,   334,   335,    -1,   337,   338,    -1,    -1,   341,    -1,
     343,   344,   345,   346,   347,    -1,    -1,    -1,   351,     3,
       4,     5,     6,     7,     8,     9,    10,    -1,    12,    13,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    22,    23,
      -1,    25,    -1,    27,    28,    29,    -1,    31,    -1,    33,
      34,    -1,    36,    37,    38,    39,    40,    -1,    -1,    43,
      44,    45,    46,    -1,    48,    49,    50,    51,    52,    -1,
      -1,    55,    56,    57,    58,    59,    -1,    61,    62,    63,
      64,    -1,    66,    67,    68,    -1,    70,    -1,    -1,    -1,
      -1,    -1,    76,    77,    78,    79,    80,    81,    82,    83,
      -1,    85,    -1,    87,    88,    89,    90,    91,    -1,    93,
      -1,    -1,    96,    97,    98,    99,    -1,   101,   102,   103,
      -1,   105,    -1,   107,   108,   109,   110,   111,   112,   113,
      -1,   115,   116,   117,    -1,   119,    -1,   121,    -1,    -1,
      -1,   125,   126,    -1,   128,   129,    -1,   131,    -1,   133,
     134,   135,   136,    -1,   138,   139,   140,    -1,   142,   143,
     144,   145,   146,   147,    -1,    -1,   150,   151,   152,   153,
     154,   155,   156,    -1,   158,    -1,   160,    -1,    -1,   163,
      -1,   165,   166,   167,   168,   169,    -1,   171,    -1,   173,
      -1,    -1,   176,   177,   178,    -1,    -1,   181,   182,   183,
     184,   185,   186,   187,   188,   189,   190,    -1,    -1,    -1,
     194,   195,    -1,   197,   198,   199,   200,   201,   202,   203,
     204,   205,   206,   207,    -1,   209,   210,    -1,   212,    -1,
     214,   215,   216,   217,    -1,    -1,   220,   221,    -1,    -1,
     224,   225,    -1,    -1,   228,    -1,    -1,   231,   232,   233,
     234,   235,    -1,   237,   238,   239,   240,   241,    -1,   243,
     244,   245,   246,   247,   248,   249,   250,   251,    -1,   253,
     254,   255,   256,   257,   258,   259,   260,   261,    -1,   263,
     264,    -1,   266,   267,   268,   269,   270,   271,   272,   273,
     274,   275,    -1,   277,   278,   279,    -1,   281,   282,   283,
     284,    -1,   286,   287,    -1,   289,   290,   291,   292,   293,
     294,   295,   296,   297,   298,    -1,   300,   301,    -1,   303,
     304,   305,   306,    -1,   308,   309,    -1,    -1,   312,   313,
     314,   315,    -1,   317,   318,   319,   320,   321,    -1,    -1,
     324,   325,   326,   327,    -1,    -1,   330,   331,   332,   333,
     334,   335,    -1,   337,   338,    -1,    -1,   341,    -1,   343,
     344,   345,   346,   347,    -1,    -1,    -1,   351,     3,     4,
       5,     6,     7,     8,     9,    10,    -1,    12,    13,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    22,    23,    -1,
      25,    26,    27,    28,    29,    30,    31,    32,    33,    34,
      -1,    36,    37,    38,    39,    40,    -1,    -1,    43,    44,
      45,    46,    -1,    48,    49,    50,    51,    -1,    -1,    -1,
      55,    56,    57,    58,    59,    -1,    61,    62,    -1,    64,
      -1,    66,    67,    68,    69,    70,    -1,    -1,    -1,    -1,
      -1,    76,    77,    78,    79,    80,    81,    82,    83,    -1,
      85,    -1,    87,    88,    89,    90,    91,    -1,    93,    -1,
      -1,    96,    97,    98,    99,    -1,   101,   102,   103,    -1,
     105,    -1,   107,   108,   109,    -1,   111,   112,    -1,    -1,
     115,   116,   117,    -1,   119,    -1,   121,   122,    -1,   124,
     125,   126,    -1,   128,    -1,    -1,   131,    -1,   133,   134,
     135,   136,   137,   138,   139,   140,    -1,   142,   143,   144,
     145,   146,   147,    -1,   149,    -1,   151,   152,   153,   154,
     155,   156,    -1,   158,    -1,   160,   161,   162,   163,   164,
     165,   166,   167,   168,   169,    -1,    -1,   172,   173,   174,
      -1,   176,   177,   178,    -1,    -1,   181,   182,   183,   184,
     185,   186,   187,   188,   189,   190,    -1,    -1,    -1,   194,
     195,   196,   197,    -1,   199,   200,   201,   202,   203,   204,
     205,    -1,   207,    -1,   209,   210,   211,   212,    -1,    -1,
     215,   216,   217,    -1,    -1,   220,    -1,    -1,    -1,   224,
     225,    -1,    -1,    -1,   229,   230,    -1,   232,   233,   234,
     235,    -1,    -1,    -1,   239,   240,   241,    -1,   243,   244,
     245,   246,   247,   248,   249,   250,   251,    -1,   253,   254,
     255,   256,   257,   258,   259,   260,   261,    -1,   263,   264,
     265,   266,   267,    -1,   269,   270,   271,   272,   273,   274,
     275,    -1,   277,   278,   279,    -1,   281,   282,   283,   284,
     285,   286,   287,    -1,   289,   290,   291,   292,   293,   294,
     295,   296,    -1,   298,    -1,   300,   301,    -1,   303,   304,
     305,   306,    -1,   308,   309,    -1,    -1,   312,    -1,   314,
      -1,    -1,   317,   318,   319,   320,   321,    -1,    -1,   324,
     325,   326,   327,    -1,    -1,   330,   331,   332,    -1,   334,
     335,   336,   337,   338,    -1,    -1,   341,    -1,   343,   344,
     345,   346,   347,    -1,    -1,    -1,   351,     3,     4,     5,
       6,     7,     8,     9,    10,    11,    12,    13,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    22,    23,    -1,    25,
      -1,    27,    28,    29,    -1,    31,    -1,    33,    34,    -1,
      36,    37,    38,    39,    40,    -1,    -1,    43,    44,    45,
      46,    -1,    48,    49,    50,    51,    52,    -1,    -1,    55,
      56,    57,    58,    59,    -1,    61,    62,    63,    64,    -1,
      66,    67,    68,    -1,    70,    -1,    -1,    -1,    -1,    -1,
      76,    77,    78,    79,    80,    81,    82,    83,    -1,    85,
      -1,    87,    88,    89,    90,    91,    -1,    93,    -1,    -1,
      96,    97,    98,    99,    -1,   101,   102,   103,    -1,   105,
      -1,   107,   108,   109,   110,   111,   112,   113,    -1,   115,
     116,   117,    -1,   119,    -1,   121,    -1,    -1,    -1,   125,
     126,    -1,   128,   129,    -1,   131,    -1,   133,   134,   135,
     136,    -1,   138,   139,   140,    -1,   142,   143,   144,   145,
     146,   147,    -1,    -1,   150,   151,   152,   153,   154,   155,
     156,    -1,   158,    -1,   160,    -1,    -1,   163,    -1,   165,
     166,   167,   168,   169,    -1,   171,    -1,   173,    -1,    -1,
     176,   177,   178,    -1,    -1,   181,   182,   183,   184,   185,
     186,   187,   188,   189,   190,    -1,    -1,    -1,   194,   195,
      -1,   197,    -1,   199,   200,   201,   202,   203,   204,   205,
     206,   207,    -1,   209,   210,    -1,   212,    -1,   214,   215,
     216,   217,    -1,    -1,   220,    -1,    -1,    -1,   224,   225,
      -1,    -1,   228,    -1,    -1,   231,   232,   233,   234,   235,
      -1,   237,   238,   239,   240,   241,    -1,   243,   244,   245,
     246,   247,   248,   249,   250,   251,    -1,   253,   254,   255,
     256,   257,   258,   259,   260,   261,    -1,   263,   264,    -1,
     266,   267,   268,   269,   270,   271,   272,   273,   274,   275,
      -1,   277,   278,   279,    -1,   281,   282,   283,   284,    -1,
     286,   287,    -1,   289,   290,   291,   292,   293,   294,   295,
     296,   297,   298,    -1,   300,   301,    -1,   303,   304,   305,
     306,    -1,   308,   309,    -1,    -1,   312,   313,   314,   315,
      -1,   317,   318,   319,   320,   321,    -1,    -1,   324,   325,
     326,   327,   328,    -1,   330,   331,   332,   333,   334,   335,
      -1,   337,   338,    -1,    -1,   341,    -1,   343,   344,   345,
     346,   347,    -1,    -1,    -1,   351,     3,     4,     5,     6,
       7,     8,     9,    10,    11,    12,    13,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    22,    23,    -1,    25,    -1,
      27,    28,    29,    -1,    31,    -1,    33,    34,    -1,    36,
      37,    38,    39,    40,    -1,    -1,    43,    44,    45,    46,
      -1,    48,    49,    50,    51,    52,    -1,    -1,    55,    56,
      57,    58,    59,    -1,    61,    62,    63,    64,    -1,    66,
      67,    68,    -1,    70,    -1,    -1,    -1,    -1,    -1,    76,
      77,    78,    79,    80,    81,    82,    83,    -1,    85,    -1,
      87,    88,    89,    90,    91,    -1,    93,    -1,    -1,    96,
      97,    98,    99,    -1,   101,   102,   103,    -1,   105,    -1,
     107,   108,   109,   110,   111,   112,   113,    -1,   115,   116,
     117,    -1,   119,    -1,   121,    -1,    -1,    -1,   125,   126,
      -1,   128,   129,    -1,   131,    -1,   133,   134,   135,   136,
      -1,   138,   139,   140,    -1,   142,   143,   144,   145,   146,
     147,    -1,    -1,   150,   151,   152,   153,   154,   155,   156,
      -1,   158,    -1,   160,    -1,    -1,   163,    -1,   165,   166,
     167,   168,   169,    -1,   171,    -1,   173,    -1,    -1,   176,
     177,   178,    -1,    -1,   181,   182,   183,   184,   185,   186,
     187,   188,   189,   190,    -1,    -1,    -1,   194,   195,    -1,
     197,    -1,   199,   200,   201,   202,   203,   204,   205,   206,
     207,    -1,   209,   210,    -1,   212,    -1,   214,   215,   216,
     217,    -1,    -1,   220,    -1,    -1,    -1,   224,   225,    -1,
      -1,   228,    -1,    -1,   231,   232,   233,   234,   235,    -1,
     237,   238,   239,   240,   241,    -1,   243,   244,   245,   246,
     247,   248,   249,   250,   251,    -1,   253,   254,   255,   256,
     257,   258,   259,   260,   261,    -1,   263,   264,    -1,   266,
     267,   268,   269,   270,   271,   272,   273,   274,   275,    -1,
     277,   278,   279,    -1,   281,   282,   283,   284,    -1,   286,
     287,    -1,   289,   290,   291,   292,   293,   294,   295,   296,
     297,   298,    -1,   300,   301,    -1,   303,   304,   305,   306,
      -1,   308,   309,    -1,    -1,   312,   313,   314,   315,    -1,
     317,   318,   319,   320,   321,    -1,    -1,   324,   325,   326,
     327,   328,    -1,   330,   331,   332,   333,   334,   335,    -1,
     337,   338,    -1,    -1,   341,    -1,   343,   344,   345,   346,
     347,    -1,    -1,    -1,   351,     3,     4,     5,     6,     7,
       8,     9,    10,    11,    12,    13,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    22,    23,    -1,    25,    -1,    27,
      28,    29,    -1,    31,    -1,    33,    34,    -1,    36,    37,
      38,    39,    40,    -1,    -1,    43,    44,    45,    46,    -1,
      48,    49,    50,    51,    52,    -1,    -1,    55,    56,    57,
      58,    59,    -1,    61,    62,    63,    64,    -1,    66,    67,
      68,    -1,    70,    -1,    -1,    -1,    -1,    -1,    76,    77,
      78,    79,    80,    81,    82,    83,    -1,    85,    -1,    87,
      88,    89,    90,    91,    -1,    93,    -1,    -1,    96,    97,
      98,    99,    -1,   101,   102,   103,    -1,   105,    -1,   107,
     108,   109,   110,   111,   112,   113,    -1,   115,   116,   117,
      -1,   119,    -1,   121,    -1,    -1,    -1,   125,   126,    -1,
     128,   129,    -1,   131,    -1,   133,   134,   135,   136,    -1,
     138,   139,   140,    -1,   142,   143,   144,   145,   146,   147,
      -1,    -1,   150,   151,   152,   153,   154,   155,   156,    -1,
     158,    -1,   160,    -1,    -1,   163,    -1,   165,   166,   167,
     168,   169,    -1,   171,    -1,   173,    -1,    -1,   176,   177,
     178,    -1,    -1,   181,   182,   183,   184,   185,   186,   187,
     188,   189,   190,    -1,    -1,    -1,   194,   195,    -1,   197,
      -1,   199,   200,   201,   202,   203,   204,   205,   206,   207,
      -1,   209,   210,    -1,   212,    -1,   214,   215,   216,   217,
      -1,    -1,   220,    -1,    -1,    -1,   224,   225,    -1,    -1,
     228,    -1,    -1,   231,   232,   233,   234,   235,    -1,   237,
     238,   239,   240,   241,    -1,   243,   244,   245,   246,   247,
     248,   249,   250,   251,    -1,   253,   254,   255,   256,   257,
     258,   259,   260,   261,    -1,   263,   264,    -1,   266,   267,
     268,   269,   270,   271,   272,   273,   274,   275,    -1,   277,
     278,   279,    -1,   281,   282,   283,   284,    -1,   286,   287,
      -1,   289,   290,   291,   292,   293,   294,   295,   296,   297,
     298,    -1,   300,   301,    -1,   303,   304,   305,   306,    -1,
     308,   309,    -1,    -1,   312,   313,   314,   315,    -1,   317,
     318,   319,   320,   321,    -1,    -1,   324,   325,   326,   327,
      -1,    -1,   330,   331,   332,   333,   334,   335,    -1,   337,
     338,    -1,    -1,   341,    -1,   343,   344,   345,   346,   347,
      -1,    -1,    -1,   351,     3,     4,     5,     6,     7,     8,
       9,    10,    11,    12,    13,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    22,    23,    -1,    25,    -1,    27,    28,
      29,    -1,    31,    -1,    33,    34,    -1,    36,    37,    38,
      39,    40,    -1,    -1,    43,    44,    45,    46,    -1,    48,
      49,    50,    51,    52,    -1,    -1,    55,    56,    57,    58,
      59,    -1,    61,    62,    63,    64,    -1,    66,    67,    68,
      -1,    70,    -1,    -1,    -1,    -1,    -1,    76,    77,    78,
      79,    80,    81,    82,    83,    -1,    85,    -1,    87,    88,
      89,    90,    91,    -1,    93,    -1,    -1,    96,    97,    98,
      99,    -1,   101,   102,   103,    -1,   105,    -1,   107,   108,
     109,   110,   111,   112,   113,    -1,   115,   116,   117,    -1,
     119,    -1,   121,    -1,    -1,    -1,   125,   126,    -1,   128,
     129,    -1,   131,    -1,   133,   134,   135,   136,    -1,   138,
     139,   140,    -1,   142,   143,   144,   145,   146,   147,    -1,
      -1,   150,   151,   152,   153,   154,   155,   156,    -1,   158,
      -1,   160,    -1,    -1,   163,    -1,   165,   166,   167,   168,
     169,    -1,   171,    -1,   173,    -1,    -1,   176,   177,   178,
      -1,    -1,   181,   182,   183,   184,   185,   186,   187,   188,
     189,   190,    -1,    -1,    -1,   194,   195,    -1,   197,    -1,
     199,   200,   201,   202,   203,   204,   205,   206,   207,    -1,
     209,   210,    -1,   212,    -1,   214,   215,   216,   217,    -1,
      -1,   220,    -1,    -1,    -1,   224,   225,    -1,    -1,   228,
      -1,    -1,   231,   232,   233,   234,   235,    -1,   237,   238,
     239,   240,   241,    -1,   243,   244,   245,   246,   247,   248,
     249,   250,   251,    -1,   253,   254,   255,   256,   257,   258,
     259,   260,   261,    -1,   263,   264,    -1,   266,   267,   268,
     269,   270,   271,   272,   273,   274,   275,    -1,   277,   278,
     279,    -1,   281,   282,   283,   284,    -1,   286,   287,    -1,
     289,   290,   291,   292,   293,   294,   295,   296,   297,   298,
      -1,   300,   301,    -1,   303,   304,   305,   306,    -1,   308,
     309,    -1,    -1,   312,   313,   314,   315,    -1,   317,   318,
     319,   320,   321,    -1,    -1,   324,   325,   326,   327,    -1,
      -1,   330,   331,   332,   333,   334,   335,    -1,   337,   338,
      -1,    -1,   341,    -1,   343,   344,   345,   346,   347,    -1,
      -1,    -1,   351,     3,     4,     5,     6,     7,     8,     9,
      10,    -1,    12,    13,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    22,    23,    -1,    25,    26,    27,    28,    29,
      -1,    31,    -1,    33,    34,    -1,    36,    37,    38,    39,
      40,    -1,    -1,    43,    44,    45,    46,    -1,    48,    49,
      50,    51,    52,    -1,    -1,    55,    56,    57,    58,    59,
      -1,    61,    62,    63,    64,    -1,    66,    67,    68,    -1,
      70,    -1,    -1,    -1,    -1,    -1,    76,    77,    78,    79,
      80,    81,    82,    83,    -1,    85,    -1,    87,    88,    89,
      90,    91,    -1,    93,    -1,    -1,    96,    97,    98,    99,
      -1,   101,   102,   103,    -1,   105,    -1,   107,   108,   109,
     110,   111,   112,   113,    -1,   115,   116,   117,    -1,   119,
      -1,   121,    -1,    -1,    -1,   125,   126,    -1,   128,   129,
      -1,   131,    -1,   133,   134,   135,   136,    -1,   138,   139,
     140,    -1,   142,   143,   144,   145,   146,   147,    -1,    -1,
     150,   151,   152,   153,   154,   155,   156,    -1,   158,    -1,
     160,    -1,    -1,   163,    -1,   165,   166,   167,   168,   169,
      -1,   171,    -1,   173,    -1,    -1,   176,   177,   178,    -1,
      -1,   181,   182,   183,   184,   185,   186,   187,   188,   189,
     190,    -1,    -1,    -1,   194,   195,    -1,   197,    -1,   199,
     200,   201,   202,   203,   204,   205,   206,   207,    -1,   209,
     210,    -1,   212,    -1,   214,   215,   216,   217,    -1,    -1,
     220,    -1,    -1,    -1,   224,   225,    -1,    -1,   228,    -1,
      -1,   231,   232,   233,   234,   235,    -1,   237,   238,   239,
     240,   241,    -1,   243,   244,   245,   246,   247,   248,   249,
     250,   251,    -1,   253,   254,   255,   256,   257,   258,   259,
     260,   261,    -1,   263,   264,    -1,   266,   267,   268,   269,
     270,   271,   272,   273,   274,   275,    -1,   277,   278,   279,
      -1,   281,   282,   283,   284,    -1,   286,   287,    -1,   289,
     290,   291,   292,   293,   294,   295,   296,   297,   298,    -1,
     300,   301,    -1,   303,   304,   305,   306,    -1,   308,   309,
      -1,    -1,   312,   313,   314,   315,    -1,   317,   318,   319,
     320,   321,    -1,    -1,   324,   325,   326,   327,    -1,    -1,
     330,   331,   332,   333,   334,   335,    -1,   337,   338,    -1,
      -1,   341,    -1,   343,   344,   345,   346,   347,    -1,    -1,
      -1,   351,     3,     4,     5,     6,     7,     8,     9,    10,
      -1,    12,    13,    -1,    -1,    -1,    -1,    -1,    -1,    20,
      -1,    22,    23,    -1,    25,    -1,    27,    28,    29,    -1,
      31,    -1,    33,    34,    -1,    36,    37,    38,    39,    40,
      -1,    -1,    43,    44,    45,    46,    -1,    48,    49,    50,
      51,    52,    -1,    -1,    55,    56,    57,    58,    59,    -1,
      61,    62,    63,    64,    -1,    66,    67,    68,    -1,    70,
      -1,    -1,    -1,    -1,    -1,    76,    77,    78,    79,    80,
      81,    82,    83,    -1,    85,    -1,    87,    88,    89,    90,
      91,    -1,    93,    -1,    -1,    96,    97,    98,    99,    -1,
     101,   102,   103,    -1,   105,    -1,   107,   108,   109,   110,
     111,   112,   113,    -1,   115,   116,   117,    -1,   119,    -1,
     121,    -1,    -1,    -1,   125,   126,    -1,   128,   129,    -1,
     131,    -1,   133,   134,   135,   136,    -1,   138,   139,   140,
      -1,   142,   143,   144,   145,   146,   147,    -1,    -1,   150,
     151,   152,   153,   154,   155,   156,    -1,   158,    -1,   160,
      -1,    -1,   163,    -1,   165,   166,   167,   168,   169,    -1,
     171,    -1,   173,    -1,    -1,   176,   177,   178,    -1,    -1,
     181,   182,   183,   184,   185,   186,   187,   188,   189,   190,
      -1,    -1,    -1,   194,   195,    -1,   197,    -1,   199,   200,
     201,   202,   203,   204,   205,   206,   207,    -1,   209,   210,
      -1,   212,    -1,   214,   215,   216,   217,    -1,    -1,   220,
      -1,    -1,    -1,   224,   225,    -1,    -1,   228,    -1,    -1,
     231,   232,   233,   234,   235,    -1,   237,   238,   239,   240,
     241,    -1,   243,   244,   245,   246,   247,   248,   249,   250,
     251,    -1,   253,   254,   255,   256,   257,   258,   259,   260,
     261,    -1,   263,   264,    -1,   266,   267,   268,   269,   270,
     271,   272,   273,   274,   275,    -1,   277,   278,   279,    -1,
     281,   282,   283,   284,    -1,   286,   287,    -1,   289,   290,
     291,   292,   293,   294,   295,   296,   297,   298,    -1,   300,
     301,    -1,   303,   304,   305,   306,    -1,   308,   309,    -1,
      -1,   312,   313,   314,   315,    -1,   317,   318,   319,   320,
     321,    -1,    -1,   324,   325,   326,   327,    -1,    -1,   330,
     331,   332,   333,   334,   335,    -1,   337,   338,    -1,    -1,
     341,    -1,   343,   344,   345,   346,   347,    -1,    -1,    -1,
     351,     3,     4,     5,     6,     7,     8,     9,    10,    -1,
      12,    13,    -1,    -1,    -1,    -1,    -1,    -1,    20,    -1,
      22,    23,    -1,    25,    -1,    27,    28,    29,    -1,    31,
      -1,    33,    34,    -1,    36,    37,    38,    39,    40,    -1,
      -1,    43,    44,    45,    46,    -1,    48,    49,    50,    51,
      52,    -1,    -1,    55,    56,    57,    58,    59,    -1,    61,
      62,    63,    64,    -1,    66,    67,    68,    -1,    70,    -1,
      -1,    -1,    -1,    -1,    76,    77,    78,    79,    80,    81,
      82,    83,    -1,    85,    -1,    87,    88,    89,    90,    91,
      -1,    93,    -1,    -1,    96,    97,    98,    99,    -1,   101,
     102,   103,    -1,   105,    -1,   107,   108,   109,   110,   111,
     112,   113,    -1,   115,   116,   117,    -1,   119,    -1,   121,
      -1,    -1,    -1,   125,   126,    -1,   128,   129,    -1,   131,
      -1,   133,   134,   135,   136,    -1,   138,   139,   140,    -1,
     142,   143,   144,   145,   146,   147,    -1,    -1,   150,   151,
     152,   153,   154,   155,   156,    -1,   158,    -1,   160,    -1,
      -1,   163,    -1,   165,   166,   167,   168,   169,    -1,   171,
      -1,   173,    -1,    -1,   176,   177,   178,    -1,    -1,   181,
     182,   183,   184,   185,   186,   187,   188,   189,   190,    -1,
      -1,    -1,   194,   195,    -1,   197,    -1,   199,   200,   201,
     202,   203,   204,   205,   206,   207,    -1,   209,   210,    -1,
     212,    -1,   214,   215,   216,   217,    -1,    -1,   220,    -1,
      -1,    -1,   224,   225,    -1,    -1,   228,    -1,    -1,   231,
     232,   233,   234,   235,    -1,   237,   238,   239,   240,   241,
      -1,   243,   244,   245,   246,   247,   248,   249,   250,   251,
      -1,   253,   254,   255,   256,   257,   258,   259,   260,   261,
      -1,   263,   264,    -1,   266,   267,   268,   269,   270,   271,
     272,   273,   274,   275,    -1,   277,   278,   279,    -1,   281,
     282,   283,   284,    -1,   286,   287,    -1,   289,   290,   291,
     292,   293,   294,   295,   296,   297,   298,    -1,   300,   301,
      -1,   303,   304,   305,   306,    -1,   308,   309,    -1,    -1,
     312,   313,   314,   315,    -1,   317,   318,   319,   320,   321,
      -1,    -1,   324,   325,   326,   327,    -1,    -1,   330,   331,
     332,   333,   334,   335,    -1,   337,   338,    -1,    -1,   341,
      -1,   343,   344,   345,   346,   347,    -1,    -1,    -1,   351,
       3,     4,     5,     6,     7,     8,     9,    10,    -1,    12,
      13,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    22,
      23,    -1,    25,    -1,    27,    28,    29,    -1,    31,    -1,
      33,    34,    -1,    36,    37,    38,    39,    40,    -1,    -1,
      43,    44,    45,    46,    -1,    48,    49,    50,    51,    52,
      -1,    -1,    55,    56,    57,    58,    59,    -1,    61,    62,
      63,    64,    -1,    66,    67,    68,    -1,    70,    -1,    -1,
      -1,    -1,    -1,    76,    77,    78,    79,    80,    81,    82,
      83,    -1,    85,    -1,    87,    88,    89,    90,    91,    -1,
      93,    -1,    -1,    96,    97,    98,    99,    -1,   101,   102,
     103,    -1,   105,    -1,   107,   108,   109,   110,   111,   112,
     113,    -1,   115,   116,   117,    -1,   119,    -1,   121,    -1,
      -1,    -1,   125,   126,    -1,   128,   129,   130,   131,    -1,
     133,   134,   135,   136,    -1,   138,   139,   140,    -1,   142,
     143,   144,   145,   146,   147,    -1,    -1,   150,   151,   152,
     153,   154,   155,   156,    -1,   158,    -1,   160,    -1,    -1,
     163,    -1,   165,   166,   167,   168,   169,    -1,   171,    -1,
     173,    -1,    -1,   176,   177,   178,    -1,    -1,   181,   182,
     183,   184,   185,   186,   187,   188,   189,   190,    -1,    -1,
      -1,   194,   195,    -1,   197,    -1,   199,   200,   201,   202,
     203,   204,   205,   206,   207,    -1,   209,   210,    -1,   212,
      -1,   214,   215,   216,   217,    -1,    -1,   220,    -1,    -1,
      -1,   224,   225,    -1,    -1,   228,    -1,    -1,   231,   232,
     233,   234,   235,    -1,   237,   238,   239,   240,   241,    -1,
     243,   244,   245,   246,   247,   248,   249,   250,   251,    -1,
     253,   254,   255,   256,   257,   258,   259,   260,   261,    -1,
     263,   264,    -1,   266,   267,   268,   269,   270,   271,   272,
     273,   274,   275,    -1,   277,   278,   279,    -1,   281,   282,
     283,   284,    -1,   286,   287,    -1,   289,   290,   291,   292,
     293,   294,   295,   296,   297,   298,    -1,   300,   301,    -1,
     303,   304,   305,   306,    -1,   308,   309,    -1,    -1,   312,
     313,   314,   315,    -1,   317,   318,   319,   320,   321,    -1,
      -1,   324,   325,   326,   327,    -1,    -1,   330,   331,   332,
     333,   334,   335,    -1,   337,   338,    -1,    -1,   341,    -1,
     343,   344,   345,   346,   347,    -1,    -1,    -1,   351,     3,
       4,     5,     6,     7,     8,     9,    10,    -1,    12,    13,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    22,    23,
      -1,    25,    -1,    27,    28,    29,    -1,    31,    -1,    33,
      34,    -1,    36,    37,    38,    39,    40,    -1,    -1,    43,
      44,    45,    46,    -1,    48,    49,    50,    51,    52,    -1,
      -1,    55,    56,    57,    58,    59,    -1,    61,    62,    63,
      64,    -1,    66,    67,    68,    -1,    70,    -1,    -1,    -1,
      -1,    -1,    76,    77,    78,    79,    80,    81,    82,    83,
      84,    85,    -1,    87,    88,    89,    90,    91,    -1,    93,
      -1,    -1,    96,    97,    98,    99,    -1,   101,   102,   103,
      -1,   105,    -1,   107,   108,   109,   110,   111,   112,   113,
      -1,   115,   116,   117,    -1,   119,    -1,   121,    -1,    -1,
      -1,   125,   126,    -1,   128,   129,    -1,   131,    -1,   133,
     134,   135,   136,    -1,   138,   139,   140,    -1,   142,   143,
     144,   145,   146,   147,    -1,    -1,   150,   151,   152,   153,
     154,   155,   156,    -1,   158,    -1,   160,    -1,    -1,   163,
      -1,   165,   166,   167,   168,   169,    -1,   171,    -1,   173,
      -1,    -1,   176,   177,   178,    -1,    -1,   181,   182,   183,
     184,   185,   186,   187,   188,   189,   190,    -1,    -1,    -1,
     194,   195,    -1,   197,    -1,   199,   200,   201,   202,   203,
     204,   205,   206,   207,    -1,   209,   210,    -1,   212,    -1,
     214,   215,   216,   217,    -1,    -1,   220,    -1,    -1,    -1,
     224,   225,    -1,    -1,   228,    -1,    -1,   231,   232,   233,
     234,   235,    -1,   237,   238,   239,   240,   241,    -1,   243,
     244,   245,   246,   247,   248,   249,   250,   251,    -1,   253,
     254,   255,   256,   257,   258,   259,   260,   261,    -1,   263,
     264,    -1,   266,   267,   268,   269,   270,   271,   272,   273,
     274,   275,    -1,   277,   278,   279,    -1,   281,   282,   283,
     284,    -1,   286,   287,    -1,   289,   290,   291,   292,   293,
     294,   295,   296,   297,   298,    -1,   300,   301,    -1,   303,
     304,   305,   306,    -1,   308,   309,    -1,    -1,   312,   313,
     314,   315,    -1,   317,   318,   319,   320,   321,    -1,    -1,
     324,   325,   326,   327,    -1,    -1,   330,   331,   332,   333,
     334,   335,    -1,   337,   338,    -1,    -1,   341,    -1,   343,
     344,   345,   346,   347,    -1,    -1,    -1,   351,     3,     4,
       5,     6,     7,     8,     9,    10,    -1,    12,    13,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    22,    23,    -1,
      25,    -1,    27,    28,    29,    -1,    31,    -1,    33,    34,
      -1,    36,    37,    38,    39,    40,    -1,    -1,    43,    44,
      45,    46,    -1,    48,    49,    50,    51,    52,    -1,    -1,
      55,    56,    57,    58,    59,    -1,    61,    62,    63,    64,
      -1,    66,    67,    68,    -1,    70,    -1,    -1,    -1,    -1,
      -1,    76,    77,    78,    79,    80,    81,    82,    83,    84,
      85,    -1,    87,    88,    89,    90,    91,    -1,    93,    -1,
      -1,    96,    97,    98,    99,    -1,   101,   102,   103,    -1,
     105,    -1,   107,   108,   109,   110,   111,   112,   113,    -1,
     115,   116,   117,    -1,   119,    -1,   121,    -1,    -1,    -1,
     125,   126,    -1,   128,   129,    -1,   131,    -1,   133,   134,
     135,   136,    -1,   138,   139,   140,    -1,   142,   143,   144,
     145,   146,   147,    -1,    -1,   150,   151,   152,   153,   154,
     155,   156,    -1,   158,    -1,   160,    -1,    -1,   163,    -1,
     165,   166,   167,   168,   169,    -1,   171,    -1,   173,    -1,
      -1,   176,   177,   178,    -1,    -1,   181,   182,   183,   184,
     185,   186,   187,   188,   189,   190,    -1,    -1,    -1,   194,
     195,    -1,   197,    -1,   199,   200,   201,   202,   203,   204,
     205,   206,   207,    -1,   209,   210,    -1,   212,    -1,   214,
     215,   216,   217,    -1,    -1,   220,    -1,    -1,    -1,   224,
     225,    -1,    -1,   228,    -1,    -1,   231,   232,   233,   234,
     235,    -1,   237,   238,   239,   240,   241,    -1,   243,   244,
     245,   246,   247,   248,   249,   250,   251,    -1,   253,   254,
     255,   256,   257,   258,   259,   260,   261,    -1,   263,   264,
      -1,   266,   267,   268,   269,   270,   271,   272,   273,   274,
     275,    -1,   277,   278,   279,    -1,   281,   282,   283,   284,
      -1,   286,   287,    -1,   289,   290,   291,   292,   293,   294,
     295,   296,   297,   298,    -1,   300,   301,    -1,   303,   304,
     305,   306,    -1,   308,   309,    -1,    -1,   312,   313,   314,
     315,    -1,   317,   318,   319,   320,   321,    -1,    -1,   324,
     325,   326,   327,    -1,    -1,   330,   331,   332,   333,   334,
     335,    -1,   337,   338,    -1,    -1,   341,    -1,   343,   344,
     345,   346,   347,    -1,    -1,    -1,   351,     3,     4,     5,
       6,     7,     8,     9,    10,    -1,    12,    13,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    22,    23,    -1,    25,
      -1,    27,    28,    29,    -1,    31,    -1,    33,    34,    -1,
      36,    37,    38,    39,    40,    -1,    -1,    43,    44,    45,
      46,    -1,    48,    49,    50,    51,    52,    -1,    -1,    55,
      56,    57,    58,    59,    -1,    61,    62,    63,    64,    -1,
      66,    67,    68,    -1,    70,    -1,    -1,    -1,    -1,    -1,
      76,    77,    78,    79,    80,    81,    82,    83,    84,    85,
      -1,    87,    88,    89,    90,    91,    -1,    93,    -1,    -1,
      96,    97,    98,    99,    -1,   101,   102,   103,    -1,   105,
      -1,   107,   108,   109,   110,   111,   112,   113,    -1,   115,
     116,   117,    -1,   119,    -1,   121,    -1,    -1,    -1,   125,
     126,    -1,   128,   129,    -1,   131,    -1,   133,   134,   135,
     136,    -1,   138,   139,   140,    -1,   142,   143,   144,   145,
     146,   147,    -1,    -1,   150,   151,   152,   153,   154,   155,
     156,    -1,   158,    -1,   160,    -1,    -1,   163,    -1,   165,
     166,   167,   168,   169,    -1,   171,    -1,   173,    -1,    -1,
     176,   177,   178,    -1,    -1,   181,   182,   183,   184,   185,
     186,   187,   188,   189,   190,    -1,    -1,    -1,   194,   195,
      -1,   197,    -1,   199,   200,   201,   202,   203,   204,   205,
     206,   207,    -1,   209,   210,    -1,   212,    -1,   214,   215,
     216,   217,    -1,    -1,   220,    -1,    -1,    -1,   224,   225,
      -1,    -1,   228,    -1,    -1,   231,   232,   233,   234,   235,
      -1,   237,   238,   239,   240,   241,    -1,   243,   244,   245,
     246,   247,   248,   249,   250,   251,    -1,   253,   254,   255,
     256,   257,   258,   259,   260,   261,    -1,   263,   264,    -1,
     266,   267,   268,   269,   270,   271,   272,   273,   274,   275,
      -1,   277,   278,   279,    -1,   281,   282,   283,   284,    -1,
     286,   287,    -1,   289,   290,   291,   292,   293,   294,   295,
     296,   297,   298,    -1,   300,   301,    -1,   303,   304,   305,
     306,    -1,   308,   309,    -1,    -1,   312,   313,   314,   315,
      -1,   317,   318,   319,   320,   321,    -1,    -1,   324,   325,
     326,   327,    -1,    -1,   330,   331,   332,   333,   334,   335,
      -1,   337,   338,    -1,    -1,   341,    -1,   343,   344,   345,
     346,   347,    -1,    -1,    -1,   351,     3,     4,     5,     6,
       7,     8,     9,    10,    -1,    12,    13,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    22,    23,    -1,    25,    -1,
      27,    28,    29,    -1,    31,    -1,    33,    34,    -1,    36,
      37,    38,    39,    40,    -1,    -1,    43,    44,    45,    46,
      -1,    48,    49,    50,    51,    52,    -1,    -1,    55,    56,
      57,    58,    59,    -1,    61,    62,    63,    64,    -1,    66,
      67,    68,    -1,    70,    -1,    -1,    -1,    -1,    -1,    76,
      77,    78,    79,    80,    81,    82,    83,    -1,    85,    -1,
      87,    88,    89,    90,    91,    -1,    93,    -1,    -1,    96,
      97,    98,    99,    -1,   101,   102,   103,    -1,   105,    -1,
     107,   108,   109,   110,   111,   112,   113,    -1,   115,   116,
     117,    -1,   119,    -1,   121,    -1,    -1,    -1,   125,   126,
      -1,   128,   129,    -1,   131,    -1,   133,   134,   135,   136,
      -1,   138,   139,   140,    -1,   142,   143,   144,   145,   146,
     147,    -1,    -1,   150,   151,   152,   153,   154,   155,   156,
      -1,   158,    -1,   160,    -1,    -1,   163,    -1,   165,   166,
     167,   168,   169,    -1,   171,    -1,   173,    -1,    -1,   176,
     177,   178,    -1,    -1,   181,   182,   183,   184,   185,   186,
     187,   188,   189,   190,    -1,    -1,    -1,   194,   195,    -1,
     197,    -1,   199,   200,   201,   202,   203,   204,   205,   206,
     207,    -1,   209,   210,    -1,   212,    -1,   214,   215,   216,
     217,    -1,    -1,   220,    -1,    -1,    -1,   224,   225,    -1,
      -1,   228,    -1,    -1,   231,   232,   233,   234,   235,    -1,
     237,   238,   239,   240,   241,    -1,   243,   244,   245,   246,
     247,   248,   249,   250,   251,    -1,   253,   254,   255,   256,
     257,   258,   259,   260,   261,    -1,   263,   264,    -1,   266,
     267,   268,   269,   270,   271,   272,   273,   274,   275,    -1,
     277,   278,   279,    -1,   281,   282,   283,   284,    -1,   286,
     287,    -1,   289,   290,   291,   292,   293,   294,   295,   296,
     297,   298,    -1,   300,   301,    -1,   303,   304,   305,   306,
      -1,   308,   309,    -1,    -1,   312,   313,   314,   315,    -1,
     317,   318,   319,   320,   321,    -1,    -1,   324,   325,   326,
     327,    -1,   329,   330,   331,   332,   333,   334,   335,    -1,
     337,   338,    -1,    -1,   341,    -1,   343,   344,   345,   346,
     347,    -1,    -1,    -1,   351,     3,     4,     5,     6,     7,
       8,     9,    10,    -1,    12,    13,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    22,    23,    -1,    25,    -1,    27,
      28,    29,    -1,    31,    -1,    33,    34,    -1,    36,    37,
      38,    39,    40,    -1,    -1,    43,    44,    45,    46,    -1,
      48,    49,    50,    51,    52,    -1,    -1,    55,    56,    57,
      58,    59,    -1,    61,    62,    63,    64,    -1,    66,    67,
      68,    -1,    70,    -1,    -1,    -1,    -1,    -1,    76,    77,
      78,    79,    80,    81,    82,    83,    -1,    85,    -1,    87,
      88,    89,    90,    91,    -1,    93,    -1,    -1,    96,    97,
      98,    99,    -1,   101,   102,   103,    -1,   105,    -1,   107,
     108,   109,   110,   111,   112,   113,    -1,   115,   116,   117,
      -1,   119,    -1,   121,    -1,    -1,    -1,   125,   126,    -1,
     128,   129,    -1,   131,    -1,   133,   134,   135,   136,    -1,
     138,   139,   140,    -1,   142,   143,   144,   145,   146,   147,
      -1,    -1,   150,   151,   152,   153,   154,   155,   156,    -1,
     158,    -1,   160,    -1,    -1,   163,    -1,   165,   166,   167,
     168,   169,    -1,   171,    -1,   173,    -1,    -1,   176,   177,
     178,    -1,    -1,   181,   182,   183,   184,   185,   186,   187,
     188,   189,   190,    -1,    -1,    -1,   194,   195,    -1,   197,
      -1,   199,   200,   201,   202,   203,   204,   205,   206,   207,
      -1,   209,   210,    -1,   212,    -1,   214,   215,   216,   217,
      -1,    -1,   220,    -1,    -1,    -1,   224,   225,    -1,    -1,
     228,    -1,    -1,   231,   232,   233,   234,   235,    -1,   237,
     238,   239,   240,   241,    -1,   243,   244,   245,   246,   247,
     248,   249,   250,   251,    -1,   253,   254,   255,   256,   257,
     258,   259,   260,   261,    -1,   263,   264,    -1,   266,   267,
     268,   269,   270,   271,   272,   273,   274,   275,    -1,   277,
     278,   279,    -1,   281,   282,   283,   284,    -1,   286,   287,
      -1,   289,   290,   291,   292,   293,   294,   295,   296,   297,
     298,    -1,   300,   301,    -1,   303,   304,   305,   306,    -1,
     308,   309,    -1,    -1,   312,   313,   314,   315,    -1,   317,
     318,   319,   320,   321,    -1,    -1,   324,   325,   326,   327,
      -1,    -1,   330,   331,   332,   333,   334,   335,    -1,   337,
     338,    -1,    -1,   341,    -1,   343,   344,   345,   346,   347,
      -1,    -1,    -1,   351,     3,     4,     5,     6,     7,     8,
       9,    10,    -1,    12,    13,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    22,    23,    -1,    25,    -1,    27,    28,
      29,    -1,    31,    -1,    33,    34,    -1,    36,    37,    38,
      39,    40,    -1,    -1,    43,    44,    45,    46,    -1,    48,
      49,    50,    51,    52,    -1,    -1,    55,    56,    57,    58,
      59,    -1,    61,    62,    63,    64,    -1,    66,    67,    68,
      -1,    70,    -1,    -1,    -1,    -1,    -1,    76,    77,    78,
      79,    80,    81,    82,    83,    -1,    85,    -1,    87,    88,
      89,    90,    91,    -1,    93,    -1,    -1,    96,    97,    98,
      99,    -1,   101,   102,   103,    -1,   105,    -1,   107,   108,
     109,   110,   111,   112,   113,    -1,   115,   116,   117,    -1,
     119,    -1,   121,    -1,    -1,    -1,   125,   126,    -1,   128,
     129,    -1,   131,    -1,   133,   134,   135,   136,    -1,   138,
     139,   140,    -1,   142,   143,   144,   145,   146,   147,    -1,
      -1,   150,   151,   152,   153,   154,   155,   156,    -1,   158,
      -1,   160,    -1,    -1,   163,    -1,   165,   166,   167,   168,
     169,    -1,   171,    -1,   173,    -1,    -1,   176,   177,   178,
      -1,    -1,   181,   182,   183,   184,   185,   186,   187,   188,
     189,   190,    -1,    -1,    -1,   194,   195,    -1,   197,    -1,
     199,   200,   201,   202,   203,   204,   205,   206,   207,    -1,
     209,   210,    -1,   212,    -1,   214,   215,   216,   217,    -1,
      -1,   220,    -1,    -1,    -1,   224,   225,    -1,    -1,   228,
      -1,    -1,   231,   232,   233,   234,   235,    -1,   237,   238,
     239,   240,   241,    -1,   243,   244,   245,   246,   247,   248,
     249,   250,   251,    -1,   253,   254,   255,   256,   257,   258,
     259,   260,   261,    -1,   263,   264,    -1,   266,   267,   268,
     269,   270,   271,   272,   273,   274,   275,    -1,   277,   278,
     279,    -1,   281,   282,   283,   284,    -1,   286,   287,    -1,
     289,   290,   291,   292,   293,   294,   295,   296,   297,   298,
      -1,   300,   301,    -1,   303,   304,   305,   306,    -1,   308,
     309,    -1,    -1,   312,   313,   314,   315,    -1,   317,   318,
     319,   320,   321,    -1,    -1,   324,   325,   326,   327,    -1,
      -1,   330,   331,   332,   333,   334,   335,    -1,   337,   338,
      -1,    -1,   341,    -1,   343,   344,   345,   346,   347,    -1,
      -1,    -1,   351,     3,     4,     5,     6,     7,     8,     9,
      10,    -1,    12,    13,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    22,    23,    -1,    25,    -1,    27,    28,    29,
      -1,    31,    -1,    33,    34,    -1,    36,    37,    38,    39,
      40,    -1,    -1,    43,    44,    45,    46,    -1,    48,    49,
      50,    51,    52,    -1,    -1,    55,    56,    57,    58,    59,
      -1,    61,    62,    63,    64,    -1,    66,    67,    68,    -1,
      70,    -1,    -1,    -1,    -1,    -1,    76,    77,    78,    79,
      80,    81,    82,    83,    -1,    85,    -1,    87,    88,    89,
      90,    91,    -1,    93,    -1,    -1,    96,    97,    98,    99,
      -1,   101,   102,   103,    -1,   105,    -1,   107,   108,   109,
     110,   111,   112,   113,    -1,   115,   116,   117,    -1,   119,
      -1,   121,    -1,    -1,    -1,   125,   126,    -1,   128,   129,
      -1,   131,    -1,   133,   134,   135,   136,    -1,   138,   139,
     140,    -1,   142,   143,   144,   145,   146,   147,    -1,    -1,
     150,   151,   152,   153,   154,   155,   156,    -1,   158,    -1,
     160,    -1,    -1,   163,    -1,   165,   166,   167,   168,   169,
      -1,   171,    -1,   173,    -1,    -1,   176,   177,   178,    -1,
      -1,   181,   182,   183,   184,   185,   186,   187,   188,   189,
     190,    -1,    -1,    -1,   194,   195,    -1,   197,    -1,   199,
     200,   201,   202,   203,   204,   205,   206,   207,    -1,   209,
     210,    -1,   212,    -1,   214,   215,   216,   217,    -1,    -1,
     220,    -1,    -1,    -1,   224,   225,    -1,    -1,   228,    -1,
      -1,   231,   232,   233,   234,   235,    -1,   237,   238,   239,
     240,   241,    -1,   243,   244,   245,   246,   247,   248,   249,
     250,   251,    -1,   253,   254,   255,   256,   257,   258,   259,
     260,   261,    -1,   263,   264,    -1,   266,   267,   268,   269,
     270,   271,   272,   273,   274,   275,    -1,   277,   278,   279,
      -1,   281,   282,   283,   284,    -1,   286,   287,    -1,   289,
     290,   291,   292,   293,   294,   295,   296,   297,   298,    -1,
     300,   301,    -1,   303,   304,   305,   306,    -1,   308,   309,
      -1,    -1,   312,   313,   314,   315,    -1,   317,   318,   319,
     320,   321,    -1,    -1,   324,   325,   326,   327,    -1,    -1,
     330,   331,   332,   333,   334,   335,    -1,   337,   338,    -1,
      -1,   341,    -1,   343,   344,   345,   346,   347,    -1,    -1,
      -1,   351,     3,     4,     5,     6,     7,     8,     9,    10,
      -1,    12,    13,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    22,    23,    -1,    25,    -1,    27,    28,    29,    -1,
      31,    -1,    33,    34,    -1,    36,    37,    38,    39,    40,
      -1,    -1,    43,    44,    45,    46,    -1,    48,    49,    50,
      51,    52,    -1,    -1,    55,    56,    57,    58,    59,    -1,
      61,    62,    63,    64,    -1,    66,    67,    68,    -1,    70,
      -1,    -1,    -1,    -1,    -1,    76,    77,    78,    79,    80,
      81,    82,    83,    -1,    85,    -1,    87,    88,    89,    90,
      91,    -1,    93,    -1,    -1,    96,    97,    98,    99,    -1,
     101,   102,   103,    -1,   105,    -1,   107,   108,   109,   110,
     111,   112,   113,    -1,   115,   116,   117,    -1,   119,    -1,
     121,    -1,    -1,    -1,   125,   126,    -1,   128,   129,    -1,
     131,    -1,   133,   134,   135,   136,    -1,   138,   139,   140,
      -1,   142,   143,   144,   145,   146,   147,    -1,    -1,   150,
     151,   152,   153,   154,   155,   156,    -1,   158,    -1,   160,
      -1,    -1,   163,    -1,   165,   166,   167,   168,   169,    -1,
     171,    -1,   173,    -1,    -1,   176,   177,   178,    -1,    -1,
     181,   182,   183,   184,   185,   186,   187,   188,   189,   190,
      -1,    -1,    -1,   194,   195,    -1,   197,    -1,   199,   200,
     201,   202,   203,   204,   205,   206,   207,    -1,   209,   210,
      -1,   212,    -1,   214,   215,   216,   217,    -1,    -1,   220,
      -1,    -1,    -1,   224,   225,    -1,    -1,   228,    -1,    -1,
     231,   232,   233,   234,   235,    -1,   237,   238,   239,   240,
     241,    -1,   243,   244,   245,   246,   247,   248,   249,   250,
     251,    -1,   253,   254,   255,   256,   257,   258,   259,   260,
     261,    -1,   263,   264,    -1,   266,   267,   268,   269,   270,
     271,   272,   273,   274,   275,    -1,   277,   278,   279,    -1,
     281,   282,   283,   284,    -1,   286,   287,    -1,   289,   290,
     291,   292,   293,   294,   295,   296,   297,   298,    -1,   300,
     301,    -1,   303,   304,   305,   306,    -1,   308,   309,    -1,
      -1,   312,   313,   314,   315,    -1,   317,   318,   319,   320,
     321,    -1,    -1,   324,   325,   326,   327,    -1,    -1,   330,
     331,   332,   333,   334,   335,    -1,   337,   338,    -1,    -1,
     341,    -1,   343,   344,   345,   346,   347,    -1,    -1,    -1,
     351,     3,     4,     5,     6,     7,     8,     9,    10,    -1,
      12,    13,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      22,    23,    -1,    25,    -1,    27,    28,    29,    -1,    31,
      -1,    33,    34,    -1,    36,    37,    38,    39,    40,    -1,
      -1,    43,    44,    45,    46,    -1,    48,    49,    50,    51,
      52,    -1,    -1,    55,    56,    57,    58,    59,    -1,    61,
      62,    63,    64,    -1,    66,    67,    68,    -1,    70,    -1,
      -1,    -1,    -1,    -1,    76,    77,    78,    79,    80,    81,
      82,    83,    -1,    85,    -1,    87,    88,    89,    90,    91,
      -1,    93,    -1,    -1,    96,    97,    98,    99,    -1,   101,
     102,   103,    -1,   105,    -1,   107,   108,   109,   110,   111,
     112,   113,    -1,   115,   116,   117,    -1,   119,    -1,   121,
      -1,    -1,    -1,   125,   126,    -1,   128,   129,    -1,   131,
      -1,   133,   134,   135,   136,    -1,   138,   139,   140,    -1,
     142,   143,   144,   145,   146,   147,    -1,    -1,   150,   151,
     152,   153,   154,   155,   156,    -1,   158,    -1,   160,    -1,
      -1,   163,    -1,   165,   166,   167,   168,   169,    -1,   171,
      -1,   173,    -1,    -1,   176,   177,   178,    -1,    -1,   181,
     182,   183,   184,   185,   186,   187,   188,   189,   190,    -1,
      -1,    -1,   194,   195,    -1,   197,    -1,   199,   200,   201,
     202,   203,   204,   205,   206,   207,    -1,   209,   210,    -1,
     212,    -1,   214,   215,   216,   217,    -1,    -1,   220,    -1,
      -1,    -1,   224,   225,    -1,    -1,   228,    -1,    -1,   231,
     232,   233,   234,   235,    -1,   237,   238,   239,   240,   241,
      -1,   243,   244,   245,   246,   247,   248,   249,   250,   251,
      -1,   253,   254,   255,   256,   257,   258,   259,   260,   261,
      -1,   263,   264,    -1,   266,   267,   268,   269,   270,   271,
     272,   273,   274,   275,    -1,   277,   278,   279,    -1,   281,
     282,   283,   284,    -1,   286,   287,    -1,   289,   290,   291,
     292,   293,   294,   295,   296,   297,   298,    -1,   300,   301,
      -1,   303,   304,   305,   306,    -1,   308,   309,    -1,    -1,
     312,   313,   314,   315,    -1,   317,   318,   319,   320,   321,
      -1,    -1,   324,   325,   326,   327,    -1,    -1,   330,   331,
     332,   333,   334,   335,    -1,   337,   338,    -1,    -1,   341,
      -1,   343,   344,   345,   346,   347,    -1,    -1,    -1,   351,
       3,     4,     5,     6,     7,     8,     9,    10,    -1,    12,
      13,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    22,
      23,    -1,    25,    -1,    27,    28,    29,    -1,    31,    -1,
      33,    34,    -1,    36,    37,    38,    39,    40,    -1,    -1,
      43,    44,    45,    46,    -1,    48,    49,    50,    51,    52,
      -1,    -1,    55,    56,    57,    58,    59,    -1,    61,    62,
      63,    64,    -1,    66,    67,    68,    -1,    70,    -1,    -1,
      -1,    -1,    -1,    76,    77,    78,    79,    80,    81,    82,
      83,    -1,    85,    -1,    87,    88,    89,    90,    91,    -1,
      93,    -1,    -1,    96,    97,    98,    99,    -1,   101,   102,
     103,    -1,   105,    -1,   107,   108,   109,   110,   111,   112,
     113,    -1,   115,   116,   117,    -1,   119,    -1,   121,    -1,
      -1,    -1,   125,   126,    -1,   128,   129,    -1,   131,    -1,
     133,   134,   135,   136,    -1,   138,   139,   140,    -1,   142,
     143,   144,   145,   146,   147,    -1,    -1,   150,   151,   152,
     153,   154,   155,   156,    -1,   158,    -1,   160,    -1,    -1,
     163,    -1,   165,   166,   167,   168,   169,    -1,   171,    -1,
     173,    -1,    -1,   176,   177,   178,    -1,    -1,   181,   182,
     183,   184,   185,   186,   187,   188,   189,   190,    -1,    -1,
      -1,   194,   195,    -1,   197,    -1,   199,   200,   201,   202,
     203,   204,   205,   206,   207,    -1,   209,   210,    -1,   212,
      -1,   214,   215,   216,   217,    -1,    -1,   220,    -1,    -1,
      -1,   224,   225,    -1,    -1,   228,    -1,    -1,   231,   232,
     233,   234,   235,    -1,   237,   238,   239,   240,   241,    -1,
     243,   244,   245,   246,   247,   248,   249,   250,   251,    -1,
     253,   254,   255,   256,   257,   258,   259,   260,   261,    -1,
     263,   264,    -1,   266,   267,   268,   269,   270,   271,   272,
     273,   274,   275,    -1,   277,   278,   279,    -1,   281,   282,
     283,   284,    -1,   286,   287,    -1,   289,   290,   291,   292,
     293,   294,   295,   296,   297,   298,    -1,   300,   301,    -1,
     303,   304,   305,   306,    -1,   308,   309,    -1,    -1,   312,
     313,   314,   315,    -1,   317,   318,   319,   320,   321,    -1,
      -1,   324,   325,   326,   327,    -1,    -1,   330,   331,   332,
     333,   334,   335,    -1,   337,   338,    -1,    -1,   341,    -1,
     343,   344,   345,   346,   347,    -1,    -1,    -1,   351,     3,
       4,     5,     6,     7,     8,     9,    10,    -1,    12,    13,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    22,    23,
      -1,    25,    -1,    27,    28,    29,    -1,    31,    -1,    33,
      34,    -1,    36,    37,    38,    39,    40,    -1,    -1,    43,
      44,    45,    46,    -1,    48,    49,    50,    51,    52,    -1,
      -1,    55,    56,    57,    58,    59,    -1,    61,    62,    63,
      64,    -1,    66,    67,    68,    -1,    70,    -1,    -1,    -1,
      -1,    -1,    76,    77,    78,    79,    80,    81,    82,    83,
      -1,    85,    -1,    87,    88,    89,    90,    91,    -1,    93,
      -1,    -1,    96,    97,    98,    99,    -1,   101,   102,   103,
      -1,   105,    -1,   107,   108,   109,   110,   111,   112,   113,
      -1,   115,   116,   117,    -1,   119,    -1,   121,    -1,    -1,
      -1,   125,   126,    -1,   128,   129,    -1,   131,    -1,   133,
     134,   135,   136,    -1,   138,   139,   140,    -1,   142,   143,
     144,   145,   146,   147,    -1,    -1,   150,   151,   152,   153,
     154,   155,   156,    -1,   158,    -1,   160,    -1,    -1,   163,
      -1,   165,   166,   167,   168,   169,    -1,   171,    -1,   173,
      -1,    -1,   176,   177,   178,    -1,    -1,   181,   182,   183,
     184,   185,   186,   187,   188,   189,   190,    -1,    -1,    -1,
     194,   195,    -1,   197,    -1,   199,   200,   201,   202,   203,
     204,   205,   206,   207,    -1,   209,   210,    -1,   212,    -1,
     214,   215,   216,   217,    -1,    -1,   220,    -1,    -1,    -1,
     224,   225,    -1,    -1,   228,    -1,    -1,   231,   232,   233,
     234,   235,    -1,   237,   238,   239,   240,   241,    -1,   243,
     244,   245,   246,   247,   248,   249,   250,   251,    -1,   253,
     254,   255,   256,   257,   258,   259,   260,   261,    -1,   263,
     264,    -1,   266,   267,   268,   269,   270,   271,   272,   273,
     274,   275,    -1,   277,   278,   279,    -1,   281,   282,   283,
     284,    -1,   286,   287,    -1,   289,   290,   291,   292,   293,
     294,   295,   296,   297,   298,    -1,   300,   301,    -1,   303,
     304,   305,   306,    -1,   308,   309,    -1,    -1,   312,   313,
     314,   315,    -1,   317,   318,   319,   320,   321,    -1,    -1,
     324,   325,   326,   327,    -1,    -1,   330,   331,   332,   333,
     334,   335,    -1,   337,   338,    -1,    -1,   341,    -1,   343,
     344,   345,   346,   347,    -1,    -1,    -1,   351,     3,     4,
       5,     6,     7,     8,     9,    10,    -1,    12,    13,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    22,    23,    -1,
      25,    -1,    27,    28,    29,    -1,    31,    -1,    33,    34,
      -1,    36,    37,    38,    39,    40,    -1,    -1,    43,    44,
      45,    46,    -1,    48,    49,    50,    51,    52,    -1,    -1,
      55,    56,    57,    58,    59,    -1,    61,    62,    63,    64,
      -1,    66,    67,    68,    -1,    70,    -1,    -1,    -1,    -1,
      -1,    76,    77,    78,    79,    80,    81,    82,    83,    -1,
      85,    -1,    87,    88,    89,    90,    91,    -1,    93,    -1,
      -1,    96,    97,    98,    99,    -1,   101,   102,   103,    -1,
     105,    -1,   107,   108,   109,   110,   111,   112,   113,    -1,
     115,   116,   117,    -1,   119,    -1,   121,    -1,    -1,    -1,
     125,   126,    -1,   128,   129,    -1,   131,    -1,   133,   134,
     135,   136,    -1,   138,   139,   140,    -1,   142,   143,   144,
     145,   146,   147,    -1,    -1,   150,   151,   152,   153,   154,
     155,   156,    -1,   158,    -1,   160,    -1,    -1,   163,    -1,
     165,   166,   167,   168,   169,    -1,   171,    -1,   173,    -1,
      -1,   176,   177,   178,    -1,    -1,   181,   182,   183,   184,
     185,   186,   187,   188,   189,   190,    -1,    -1,    -1,   194,
     195,    -1,   197,    -1,   199,   200,   201,   202,   203,   204,
     205,   206,   207,    -1,   209,   210,    -1,   212,    -1,   214,
     215,   216,   217,    -1,    -1,   220,    -1,    -1,    -1,   224,
     225,    -1,    -1,   228,    -1,    -1,   231,   232,   233,   234,
     235,    -1,   237,   238,   239,   240,   241,    -1,   243,   244,
     245,   246,   247,   248,   249,   250,   251,    -1,   253,   254,
     255,   256,   257,   258,   259,   260,   261,    -1,   263,   264,
      -1,   266,   267,   268,   269,   270,   271,   272,   273,   274,
     275,    -1,   277,   278,   279,    -1,   281,   282,   283,   284,
      -1,   286,   287,    -1,   289,   290,   291,   292,   293,   294,
     295,   296,   297,   298,    -1,   300,   301,    -1,   303,   304,
     305,   306,    -1,   308,   309,    -1,    -1,   312,   313,   314,
     315,    -1,   317,   318,   319,   320,   321,    -1,    -1,   324,
     325,   326,   327,    -1,    -1,   330,   331,   332,   333,   334,
     335,    -1,   337,   338,    -1,    -1,   341,    -1,   343,   344,
     345,   346,   347,    -1,    -1,    -1,   351,     3,     4,     5,
       6,     7,     8,     9,    10,    -1,    12,    13,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    22,    23,    -1,    25,
      -1,    27,    28,    29,    -1,    31,    -1,    33,    34,    -1,
      36,    37,    38,    39,    40,    -1,    -1,    43,    44,    45,
      46,    -1,    48,    49,    50,    51,    52,    -1,    -1,    55,
      56,    57,    58,    59,    -1,    61,    62,    63,    64,    -1,
      66,    67,    68,    -1,    70,    -1,    -1,    -1,    -1,    -1,
      76,    77,    78,    79,    80,    81,    82,    83,    -1,    85,
      -1,    87,    88,    89,    90,    91,    -1,    93,    -1,    -1,
      96,    97,    98,    99,    -1,   101,   102,   103,    -1,   105,
      -1,   107,   108,   109,   110,   111,   112,   113,    -1,   115,
     116,   117,    -1,   119,    -1,   121,    -1,    -1,    -1,   125,
     126,    -1,   128,   129,    -1,   131,    -1,   133,   134,   135,
     136,    -1,   138,   139,   140,    -1,   142,   143,   144,   145,
     146,   147,    -1,    -1,   150,   151,   152,   153,   154,   155,
     156,    -1,   158,    -1,   160,    -1,    -1,   163,    -1,   165,
     166,   167,   168,   169,    -1,   171,    -1,   173,    -1,    -1,
     176,   177,   178,    -1,    -1,   181,   182,   183,   184,   185,
     186,   187,   188,   189,   190,    -1,    -1,    -1,   194,   195,
      -1,   197,    -1,   199,   200,   201,   202,   203,   204,   205,
     206,   207,    -1,   209,   210,    -1,   212,    -1,   214,   215,
     216,   217,    -1,    -1,   220,    -1,    -1,    -1,   224,   225,
      -1,    -1,   228,    -1,    -1,   231,   232,   233,   234,   235,
      -1,   237,   238,   239,   240,   241,    -1,   243,   244,   245,
     246,   247,   248,   249,   250,   251,    -1,   253,   254,   255,
     256,   257,   258,   259,   260,   261,    -1,   263,   264,    -1,
     266,   267,   268,   269,   270,   271,   272,   273,   274,   275,
      -1,   277,   278,   279,    -1,   281,   282,   283,   284,    -1,
     286,   287,    -1,   289,   290,   291,   292,   293,   294,   295,
     296,   297,   298,    -1,   300,   301,    -1,   303,   304,   305,
     306,    -1,   308,   309,    -1,    -1,   312,   313,   314,   315,
      -1,   317,   318,   319,   320,   321,    -1,    -1,   324,   325,
     326,   327,    -1,    -1,   330,   331,   332,   333,   334,   335,
      -1,   337,   338,    -1,    -1,   341,    -1,   343,   344,   345,
     346,   347,    -1,    -1,    -1,   351,     3,     4,     5,     6,
       7,     8,     9,    10,    -1,    12,    13,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    22,    23,    -1,    25,    -1,
      27,    28,    29,    -1,    31,    -1,    33,    34,    -1,    36,
      37,    38,    39,    40,    -1,    -1,    43,    44,    45,    46,
      -1,    48,    49,    50,    51,    52,    -1,    -1,    55,    56,
      57,    58,    59,    -1,    61,    62,    63,    64,    -1,    66,
      67,    68,    -1,    70,    -1,    -1,    -1,    -1,    -1,    76,
      77,    78,    79,    80,    81,    82,    83,    -1,    85,    -1,
      87,    88,    89,    90,    91,    -1,    93,    -1,    -1,    96,
      97,    98,    99,    -1,   101,   102,   103,    -1,   105,    -1,
     107,   108,   109,   110,   111,   112,   113,    -1,   115,   116,
     117,    -1,   119,    -1,   121,    -1,    -1,    -1,   125,   126,
      -1,   128,   129,    -1,   131,    -1,   133,   134,   135,   136,
      -1,   138,   139,   140,    -1,   142,   143,   144,   145,   146,
     147,    -1,    -1,   150,   151,   152,   153,   154,   155,   156,
      -1,   158,    -1,   160,    -1,    -1,   163,    -1,   165,   166,
     167,   168,   169,    -1,   171,    -1,   173,    -1,    -1,   176,
     177,   178,    -1,    -1,   181,   182,   183,   184,   185,   186,
     187,   188,   189,   190,    -1,    -1,    -1,   194,   195,    -1,
     197,    -1,   199,   200,   201,   202,   203,   204,   205,   206,
     207,    -1,   209,   210,    -1,   212,    -1,   214,   215,   216,
     217,    -1,    -1,   220,    -1,    -1,    -1,   224,   225,    -1,
      -1,   228,    -1,    -1,   231,   232,   233,   234,   235,    -1,
     237,   238,   239,   240,   241,    -1,   243,   244,   245,   246,
     247,   248,   249,   250,   251,    -1,   253,   254,   255,   256,
     257,   258,   259,   260,   261,    -1,   263,   264,    -1,   266,
     267,   268,   269,   270,   271,   272,   273,   274,   275,    -1,
     277,   278,   279,    -1,   281,   282,   283,   284,    -1,   286,
     287,    -1,   289,   290,   291,   292,   293,   294,   295,   296,
     297,   298,    -1,   300,   301,    -1,   303,   304,   305,   306,
      -1,   308,   309,    -1,    -1,   312,   313,   314,   315,    -1,
     317,   318,   319,   320,   321,    -1,    -1,   324,   325,   326,
     327,    -1,    -1,   330,   331,   332,   333,   334,   335,    -1,
     337,   338,    -1,    -1,   341,    -1,   343,   344,   345,   346,
     347,    -1,    -1,    -1,   351,     3,     4,     5,     6,     7,
       8,     9,    10,    -1,    12,    13,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    22,    23,    -1,    25,    -1,    27,
      28,    29,    -1,    31,    -1,    33,    34,    -1,    36,    37,
      38,    39,    40,    -1,    -1,    43,    44,    45,    46,    -1,
      48,    49,    50,    51,    52,    -1,    -1,    55,    56,    57,
      58,    59,    -1,    61,    62,    63,    64,    -1,    66,    67,
      68,    -1,    70,    -1,    -1,    -1,    -1,    -1,    76,    77,
      78,    79,    80,    81,    82,    83,    -1,    85,    -1,    87,
      88,    89,    90,    91,    -1,    93,    -1,    -1,    96,    97,
      98,    99,    -1,   101,   102,   103,    -1,   105,    -1,   107,
     108,   109,   110,   111,   112,   113,    -1,   115,   116,   117,
      -1,   119,    -1,   121,    -1,    -1,    -1,   125,   126,    -1,
     128,   129,    -1,   131,    -1,   133,   134,   135,   136,    -1,
     138,   139,   140,    -1,   142,   143,   144,   145,   146,   147,
      -1,    -1,   150,   151,   152,   153,   154,   155,   156,    -1,
     158,    -1,   160,    -1,    -1,   163,    -1,   165,   166,   167,
     168,   169,    -1,   171,    -1,   173,    -1,    -1,   176,   177,
     178,    -1,    -1,   181,   182,   183,   184,   185,   186,   187,
     188,   189,   190,    -1,    -1,    -1,   194,   195,    -1,   197,
      -1,   199,   200,   201,   202,   203,   204,   205,   206,   207,
      -1,   209,   210,    -1,   212,    -1,   214,   215,   216,   217,
      -1,    -1,   220,    -1,    -1,    -1,   224,   225,    -1,    -1,
     228,    -1,    -1,   231,   232,   233,   234,   235,    -1,   237,
     238,   239,   240,   241,    -1,   243,   244,   245,   246,   247,
     248,   249,   250,   251,    -1,   253,   254,   255,   256,   257,
     258,   259,   260,   261,    -1,   263,   264,    -1,   266,   267,
     268,   269,   270,   271,   272,   273,   274,   275,    -1,   277,
     278,   279,    -1,   281,   282,   283,   284,    -1,   286,   287,
      -1,   289,   290,   291,   292,   293,   294,   295,   296,   297,
     298,    -1,   300,   301,    -1,   303,   304,   305,   306,    -1,
     308,   309,    -1,    -1,   312,   313,   314,   315,    -1,   317,
     318,   319,   320,   321,    -1,    -1,   324,   325,   326,   327,
      -1,    -1,   330,   331,   332,   333,   334,   335,    -1,   337,
     338,    -1,    -1,   341,    -1,   343,   344,   345,   346,   347,
      -1,    -1,    -1,   351,     3,     4,     5,     6,     7,     8,
       9,    10,    -1,    12,    13,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    22,    23,    -1,    25,    -1,    27,    28,
      29,    -1,    31,    -1,    33,    34,    -1,    36,    37,    38,
      39,    40,    -1,    -1,    43,    44,    45,    46,    -1,    48,
      49,    50,    51,    52,    -1,    -1,    55,    56,    57,    58,
      59,    -1,    61,    62,    63,    64,    -1,    66,    67,    68,
      -1,    70,    -1,    -1,    -1,    -1,    -1,    76,    77,    78,
      79,    80,    81,    82,    83,    -1,    85,    -1,    87,    88,
      89,    90,    91,    -1,    93,    -1,    -1,    96,    97,    98,
      99,    -1,   101,   102,   103,    -1,   105,    -1,   107,   108,
     109,   110,   111,   112,   113,    -1,   115,   116,   117,    -1,
     119,    -1,   121,    -1,    -1,    -1,   125,   126,    -1,   128,
     129,    -1,   131,    -1,   133,   134,   135,   136,    -1,   138,
     139,   140,    -1,   142,   143,   144,   145,   146,   147,    -1,
      -1,   150,   151,   152,   153,   154,   155,   156,    -1,   158,
      -1,   160,    -1,    -1,   163,    -1,   165,   166,   167,   168,
     169,    -1,   171,    -1,   173,    -1,    -1,   176,   177,   178,
      -1,    -1,   181,   182,   183,   184,   185,   186,   187,   188,
     189,   190,    -1,    -1,    -1,   194,   195,    -1,   197,    -1,
     199,   200,   201,   202,   203,   204,   205,   206,   207,    -1,
     209,   210,    -1,   212,    -1,   214,   215,   216,   217,    -1,
      -1,   220,    -1,    -1,    -1,   224,   225,    -1,    -1,   228,
      -1,    -1,   231,   232,   233,   234,   235,    -1,   237,   238,
     239,   240,   241,    -1,   243,   244,   245,   246,   247,   248,
     249,   250,   251,    -1,   253,   254,   255,   256,   257,   258,
     259,   260,   261,    -1,   263,   264,    -1,   266,   267,   268,
     269,   270,   271,   272,   273,   274,   275,    -1,   277,   278,
     279,    -1,   281,   282,   283,   284,    -1,   286,   287,    -1,
     289,   290,   291,   292,   293,   294,   295,   296,   297,   298,
      -1,   300,   301,    -1,   303,   304,   305,   306,    -1,   308,
     309,    -1,    -1,   312,   313,   314,   315,    -1,   317,   318,
     319,   320,   321,    -1,    -1,   324,   325,   326,   327,    -1,
      -1,   330,   331,   332,   333,   334,   335,    -1,   337,   338,
      -1,    -1,   341,    -1,   343,   344,   345,   346,   347,    -1,
      -1,    -1,   351,     3,     4,     5,     6,     7,     8,     9,
      10,    -1,    12,    13,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    22,    23,    -1,    25,    -1,    27,    28,    29,
      -1,    31,    -1,    33,    34,    -1,    36,    37,    38,    39,
      40,    -1,    -1,    43,    44,    45,    46,    -1,    48,    49,
      50,    51,    52,    -1,    -1,    55,    56,    57,    58,    59,
      -1,    61,    62,    63,    64,    -1,    66,    67,    68,    -1,
      70,    -1,    -1,    -1,    -1,    -1,    76,    77,    78,    79,
      80,    81,    82,    83,    -1,    85,    -1,    87,    88,    89,
      90,    91,    -1,    93,    -1,    -1,    96,    97,    98,    99,
      -1,   101,   102,   103,    -1,   105,    -1,   107,   108,   109,
     110,   111,   112,   113,    -1,   115,   116,   117,    -1,   119,
      -1,   121,    -1,    -1,    -1,   125,   126,    -1,   128,   129,
      -1,   131,    -1,   133,   134,   135,   136,    -1,   138,   139,
     140,    -1,   142,   143,   144,   145,   146,   147,    -1,    -1,
     150,   151,   152,   153,   154,   155,   156,    -1,   158,    -1,
     160,    -1,    -1,   163,    -1,   165,   166,   167,   168,   169,
      -1,   171,    -1,   173,    -1,    -1,   176,   177,   178,    -1,
      -1,   181,   182,   183,   184,   185,   186,   187,   188,   189,
     190,    -1,    -1,    -1,   194,   195,    -1,   197,    -1,   199,
     200,   201,   202,   203,   204,   205,   206,   207,    -1,   209,
     210,    -1,   212,    -1,   214,   215,   216,   217,    -1,    -1,
     220,    -1,    -1,    -1,   224,   225,    -1,    -1,   228,    -1,
      -1,   231,   232,   233,   234,   235,    -1,   237,   238,   239,
     240,   241,    -1,   243,   244,   245,   246,   247,   248,   249,
     250,   251,    -1,   253,   254,   255,   256,   257,   258,   259,
     260,   261,    -1,   263,   264,    -1,   266,   267,   268,   269,
     270,   271,   272,   273,   274,   275,    -1,   277,   278,   279,
      -1,   281,   282,   283,   284,    -1,   286,   287,    -1,   289,
     290,   291,   292,   293,   294,   295,   296,   297,   298,    -1,
     300,   301,    -1,   303,   304,   305,   306,    -1,   308,   309,
      -1,    -1,   312,   313,   314,   315,    -1,   317,   318,   319,
     320,   321,    -1,    -1,   324,   325,   326,   327,    -1,    -1,
     330,   331,   332,   333,   334,   335,    -1,   337,   338,    -1,
      -1,   341,    -1,   343,   344,   345,   346,   347,    -1,    -1,
      -1,   351,     3,     4,     5,     6,     7,     8,     9,    10,
      -1,    12,    13,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    22,    23,    -1,    25,    -1,    27,    28,    29,    -1,
      31,    -1,    33,    34,    -1,    36,    37,    38,    39,    40,
      -1,    -1,    43,    44,    45,    46,    -1,    48,    49,    50,
      51,    52,    -1,    -1,    55,    56,    57,    58,    59,    -1,
      61,    62,    63,    64,    -1,    66,    67,    68,    -1,    70,
      -1,    -1,    -1,    -1,    -1,    76,    77,    78,    79,    80,
      81,    82,    83,    -1,    85,    -1,    87,    88,    89,    90,
      91,    -1,    93,    -1,    -1,    96,    97,    98,    99,    -1,
     101,   102,   103,    -1,   105,    -1,   107,   108,   109,   110,
     111,   112,   113,    -1,   115,   116,   117,    -1,   119,    -1,
     121,    -1,    -1,    -1,   125,   126,    -1,   128,   129,    -1,
     131,    -1,   133,   134,   135,   136,    -1,   138,   139,   140,
      -1,   142,   143,   144,   145,   146,   147,    -1,    -1,   150,
     151,   152,   153,   154,   155,   156,    -1,   158,    -1,   160,
      -1,    -1,   163,    -1,   165,   166,   167,   168,   169,    -1,
     171,    -1,   173,    -1,    -1,   176,   177,   178,    -1,    -1,
     181,   182,   183,   184,   185,   186,   187,   188,   189,   190,
      -1,    -1,    -1,   194,   195,    -1,   197,    -1,   199,   200,
     201,   202,   203,   204,   205,   206,   207,    -1,   209,   210,
      -1,   212,    -1,   214,   215,   216,   217,    -1,    -1,   220,
      -1,    -1,    -1,   224,   225,    -1,    -1,   228,    -1,    -1,
     231,   232,   233,   234,   235,    -1,   237,   238,   239,   240,
     241,    -1,   243,   244,   245,   246,   247,   248,   249,   250,
     251,    -1,   253,   254,   255,   256,   257,   258,   259,   260,
     261,    -1,   263,   264,    -1,   266,   267,   268,   269,   270,
     271,   272,   273,   274,   275,    -1,   277,   278,   279,    -1,
     281,   282,   283,   284,    -1,   286,   287,    -1,   289,   290,
     291,   292,   293,   294,   295,   296,   297,   298,    -1,   300,
     301,    -1,   303,   304,   305,   306,    -1,   308,   309,    -1,
      -1,   312,   313,   314,   315,    -1,   317,   318,   319,   320,
     321,    -1,    -1,   324,   325,   326,   327,    -1,    -1,   330,
     331,   332,   333,   334,   335,    -1,   337,   338,    -1,    -1,
     341,    -1,   343,   344,   345,   346,   347,    -1,    -1,    -1,
     351,     3,     4,     5,     6,     7,     8,     9,    10,    -1,
      12,    13,    -1,    -1,    -1,    -1,    -1,    -1,    20,    -1,
      22,    23,    -1,    25,    -1,    27,    28,    29,    -1,    31,
      -1,    33,    34,    -1,    36,    37,    38,    39,    40,    -1,
      -1,    43,    44,    45,    46,    -1,    48,    49,    50,    51,
      52,    -1,    -1,    55,    56,    57,    58,    59,    -1,    61,
      62,    63,    64,    -1,    66,    67,    68,    -1,    70,    -1,
      -1,    -1,    -1,    -1,    76,    77,    78,    79,    80,    81,
      82,    83,    -1,    85,    -1,    87,    88,    89,    90,    91,
      -1,    93,    -1,    -1,    96,    97,    98,    99,    -1,   101,
     102,   103,    -1,   105,    -1,   107,   108,   109,   110,   111,
     112,   113,    -1,   115,   116,   117,    -1,   119,    -1,   121,
      -1,    -1,    -1,   125,   126,    -1,   128,   129,    -1,   131,
      -1,   133,   134,   135,   136,    -1,   138,   139,   140,    -1,
     142,   143,   144,   145,   146,   147,    -1,    -1,   150,   151,
     152,   153,   154,   155,   156,    -1,   158,    -1,   160,    -1,
      -1,   163,    -1,   165,   166,   167,   168,   169,    -1,   171,
      -1,   173,    -1,    -1,   176,   177,   178,    -1,    -1,   181,
     182,   183,   184,   185,   186,   187,   188,   189,   190,    -1,
      -1,    -1,   194,   195,    -1,   197,    -1,   199,   200,   201,
     202,   203,   204,   205,   206,   207,    -1,   209,   210,    -1,
     212,    -1,   214,   215,   216,   217,    -1,    -1,   220,    -1,
      -1,    -1,   224,   225,    -1,    -1,   228,    -1,    -1,   231,
     232,   233,   234,   235,    -1,   237,   238,   239,   240,   241,
      -1,   243,   244,   245,   246,   247,   248,   249,   250,   251,
      -1,   253,   254,   255,   256,   257,   258,   259,   260,   261,
      -1,   263,   264,    -1,   266,   267,   268,   269,   270,   271,
     272,   273,   274,   275,    -1,   277,   278,   279,    -1,    -1,
     282,   283,   284,    -1,   286,   287,    -1,   289,   290,   291,
     292,   293,   294,   295,   296,   297,   298,    -1,   300,   301,
      -1,   303,   304,   305,   306,    -1,   308,   309,    -1,    -1,
     312,   313,   314,   315,    -1,   317,   318,   319,   320,   321,
      -1,    -1,   324,   325,   326,   327,    -1,    -1,   330,   331,
     332,   333,   334,   335,    -1,   337,   338,    -1,    -1,   341,
      -1,   343,   344,   345,   346,   347,    -1,    -1,    -1,   351,
       3,     4,     5,     6,     7,     8,     9,    10,    -1,    12,
      13,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    22,
      23,    -1,    25,    -1,    27,    28,    29,    -1,    31,    -1,
      33,    34,    -1,    36,    37,    38,    39,    40,    -1,    -1,
      43,    44,    45,    46,    -1,    48,    49,    50,    51,    52,
      -1,    -1,    55,    56,    57,    58,    59,    -1,    61,    62,
      63,    64,    -1,    66,    67,    68,    -1,    70,    -1,    -1,
      -1,    -1,    -1,    76,    77,    78,    79,    80,    81,    82,
      83,    -1,    85,    -1,    87,    88,    89,    90,    91,    -1,
      93,    -1,    -1,    96,    97,    98,    99,    -1,   101,   102,
     103,    -1,   105,    -1,   107,   108,   109,   110,   111,   112,
     113,    -1,   115,   116,   117,    -1,   119,    -1,   121,    -1,
      -1,    -1,   125,   126,    -1,   128,   129,    -1,   131,    -1,
     133,   134,   135,   136,    -1,   138,   139,   140,    -1,   142,
     143,   144,   145,   146,   147,    -1,    -1,   150,   151,   152,
     153,   154,   155,   156,    -1,   158,    -1,   160,    -1,    -1,
     163,    -1,   165,   166,   167,   168,   169,    -1,   171,    -1,
     173,    -1,    -1,   176,   177,   178,    -1,    -1,   181,   182,
     183,   184,   185,   186,   187,   188,   189,   190,    -1,    -1,
      -1,   194,   195,    -1,   197,    -1,   199,   200,   201,   202,
     203,   204,   205,   206,   207,    -1,   209,   210,    -1,   212,
      -1,   214,   215,   216,   217,    -1,    -1,   220,    -1,    -1,
      -1,   224,   225,    -1,    -1,   228,    -1,    -1,   231,   232,
     233,   234,   235,    -1,   237,   238,   239,   240,   241,    -1,
     243,   244,   245,   246,   247,   248,   249,   250,   251,    -1,
     253,   254,   255,   256,   257,   258,   259,   260,   261,    -1,
     263,   264,    -1,   266,   267,   268,   269,   270,   271,   272,
     273,   274,   275,    -1,   277,   278,   279,    -1,   281,   282,
     283,   284,    -1,   286,   287,    -1,   289,   290,   291,   292,
     293,   294,   295,   296,   297,   298,    -1,   300,   301,    -1,
     303,   304,   305,   306,    -1,   308,   309,    -1,    -1,   312,
     313,   314,   315,    -1,   317,   318,   319,   320,   321,    -1,
      -1,   324,   325,   326,   327,    -1,    -1,   330,   331,   332,
     333,   334,   335,    -1,   337,   338,    -1,    -1,   341,    -1,
     343,   344,   345,   346,   347,    -1,    -1,    -1,   351,     3,
       4,     5,     6,     7,     8,     9,    10,    -1,    12,    13,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    22,    23,
      -1,    25,    -1,    27,    28,    29,    -1,    31,    -1,    33,
      34,    -1,    36,    37,    38,    39,    40,    -1,    -1,    43,
      44,    45,    46,    -1,    48,    49,    50,    51,    52,    -1,
      -1,    55,    56,    57,    58,    59,    -1,    61,    62,    63,
      64,    -1,    66,    67,    68,    -1,    70,    -1,    -1,    -1,
      -1,    -1,    76,    77,    78,    79,    80,    81,    82,    83,
      -1,    85,    -1,    87,    88,    89,    90,    91,    -1,    93,
      -1,    -1,    96,    97,    98,    99,    -1,   101,   102,   103,
      -1,   105,    -1,   107,   108,   109,   110,   111,   112,   113,
      -1,   115,   116,   117,    -1,   119,    -1,   121,    -1,    -1,
      -1,   125,   126,    -1,   128,   129,    -1,   131,    -1,   133,
     134,   135,   136,    -1,   138,   139,   140,    -1,   142,   143,
     144,   145,   146,   147,    -1,    -1,   150,   151,   152,   153,
     154,   155,   156,    -1,   158,    -1,   160,    -1,    -1,   163,
      -1,   165,   166,   167,   168,   169,    -1,   171,    -1,   173,
      -1,    -1,   176,   177,   178,    -1,    -1,   181,   182,   183,
     184,   185,   186,   187,   188,   189,   190,    -1,    -1,    -1,
     194,   195,    -1,   197,    -1,   199,   200,   201,   202,   203,
     204,   205,   206,   207,    -1,   209,   210,    -1,   212,    -1,
     214,   215,   216,   217,    -1,    -1,   220,    -1,    -1,    -1,
     224,   225,    -1,    -1,   228,    -1,    -1,   231,   232,   233,
     234,   235,    -1,   237,   238,   239,   240,   241,    -1,   243,
     244,   245,   246,   247,   248,   249,   250,   251,    -1,   253,
     254,   255,   256,   257,   258,   259,   260,   261,    -1,   263,
     264,    -1,   266,   267,   268,   269,   270,   271,   272,   273,
     274,   275,    -1,   277,   278,   279,    -1,   281,   282,   283,
     284,    -1,   286,   287,    -1,   289,   290,   291,   292,   293,
     294,   295,   296,   297,   298,    -1,   300,   301,    -1,   303,
     304,   305,   306,    -1,   308,   309,    -1,    -1,   312,   313,
     314,   315,    -1,   317,   318,   319,   320,   321,    -1,    -1,
     324,   325,   326,   327,    -1,    -1,   330,   331,   332,   333,
     334,   335,    -1,   337,   338,    -1,    -1,   341,    -1,   343,
     344,   345,   346,   347,    -1,    -1,    -1,   351,     3,     4,
       5,     6,     7,     8,     9,    10,    -1,    12,    13,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    22,    23,    -1,
      25,    -1,    27,    28,    29,    -1,    31,    -1,    33,    34,
      -1,    36,    37,    38,    39,    40,    -1,    -1,    43,    44,
      45,    46,    -1,    48,    49,    50,    51,    52,    -1,    -1,
      55,    56,    57,    58,    59,    -1,    61,    62,    63,    64,
      -1,    66,    67,    68,    -1,    70,    -1,    -1,    -1,    -1,
      -1,    76,    77,    78,    79,    80,    81,    82,    83,    -1,
      85,    -1,    87,    88,    89,    90,    91,    -1,    93,    -1,
      -1,    96,    97,    98,    99,    -1,   101,   102,   103,    -1,
     105,    -1,   107,   108,   109,   110,   111,   112,   113,    -1,
     115,   116,   117,    -1,   119,    -1,   121,    -1,    -1,    -1,
     125,   126,    -1,   128,   129,    -1,   131,    -1,   133,   134,
     135,   136,    -1,   138,   139,   140,    -1,   142,   143,   144,
     145,   146,   147,    -1,    -1,   150,   151,   152,   153,   154,
     155,   156,    -1,   158,    -1,   160,    -1,    -1,   163,    -1,
     165,   166,   167,   168,   169,    -1,   171,    -1,   173,    -1,
      -1,   176,   177,   178,    -1,    -1,   181,   182,   183,   184,
     185,   186,   187,   188,   189,   190,    -1,    -1,    -1,   194,
     195,    -1,   197,    -1,   199,   200,   201,   202,   203,   204,
     205,   206,   207,    -1,   209,   210,    -1,   212,    -1,   214,
     215,   216,   217,    -1,    -1,   220,    -1,    -1,    -1,   224,
     225,    -1,    -1,   228,    -1,    -1,   231,   232,   233,   234,
     235,    -1,   237,   238,   239,   240,   241,    -1,   243,   244,
     245,   246,   247,   248,   249,   250,   251,    -1,   253,   254,
     255,   256,   257,   258,   259,   260,   261,    -1,   263,   264,
      -1,   266,   267,   268,   269,   270,   271,   272,   273,   274,
     275,    -1,   277,   278,   279,    -1,   281,   282,   283,   284,
      -1,   286,   287,    -1,   289,   290,   291,   292,   293,   294,
     295,   296,   297,   298,    -1,   300,   301,    -1,   303,   304,
     305,   306,    -1,   308,   309,    -1,    -1,   312,   313,   314,
     315,    -1,   317,   318,   319,   320,   321,    -1,    -1,   324,
     325,   326,   327,    -1,    -1,   330,   331,   332,   333,   334,
     335,    -1,   337,   338,    -1,    -1,   341,    -1,   343,   344,
     345,   346,   347,    -1,    -1,    -1,   351,     3,     4,     5,
       6,     7,     8,     9,    10,    -1,    12,    13,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    22,    23,    -1,    25,
      -1,    27,    28,    29,    -1,    31,    -1,    33,    34,    -1,
      36,    37,    38,    39,    40,    -1,    -1,    43,    44,    45,
      46,    -1,    48,    49,    50,    51,    -1,    -1,    -1,    55,
      56,    57,    58,    59,    -1,    61,    62,    -1,    64,    -1,
      66,    67,    68,    -1,    70,    -1,    -1,    -1,    -1,    -1,
      76,    77,    78,    79,    80,    81,    82,    83,    -1,    85,
      -1,    87,    88,    89,    90,    91,    -1,    93,    -1,    -1,
      96,    97,    98,    99,    -1,   101,   102,   103,    -1,   105,
      -1,   107,   108,   109,    -1,   111,   112,    -1,    -1,   115,
     116,   117,    -1,   119,    -1,   121,    -1,    -1,    -1,   125,
     126,    -1,   128,    -1,    -1,   131,    -1,   133,   134,   135,
     136,    -1,   138,   139,   140,   141,   142,   143,   144,   145,
     146,   147,    -1,    -1,   150,   151,   152,   153,   154,   155,
     156,    -1,   158,    -1,   160,    -1,    -1,   163,    -1,   165,
     166,   167,   168,   169,    -1,    -1,    -1,   173,    -1,    -1,
     176,   177,   178,    -1,    -1,   181,   182,   183,   184,   185,
     186,   187,   188,   189,   190,    -1,    -1,    -1,   194,   195,
      -1,   197,    -1,   199,   200,   201,   202,   203,   204,   205,
      -1,   207,    -1,   209,   210,    -1,   212,    -1,    -1,   215,
     216,   217,    -1,    -1,   220,    -1,    -1,    -1,   224,   225,
      -1,    -1,   228,    -1,    -1,    -1,   232,   233,   234,   235,
      -1,    -1,    -1,   239,   240,   241,    -1,   243,   244,   245,
     246,   247,   248,   249,   250,   251,    -1,   253,   254,   255,
     256,   257,   258,   259,   260,   261,    -1,   263,   264,    -1,
     266,   267,    -1,   269,   270,   271,   272,   273,   274,   275,
      -1,   277,   278,   279,    -1,   281,   282,   283,   284,    -1,
     286,   287,    -1,   289,   290,   291,   292,   293,   294,   295,
     296,    -1,   298,    -1,   300,   301,    -1,   303,   304,   305,
     306,    -1,   308,   309,    -1,    -1,   312,    -1,   314,    -1,
      -1,   317,   318,   319,   320,   321,    -1,    -1,   324,   325,
     326,   327,    -1,    -1,   330,   331,   332,    -1,   334,   335,
      -1,   337,   338,    -1,    -1,   341,    -1,   343,   344,   345,
     346,   347,    -1,    -1,    -1,   351,     3,     4,     5,     6,
       7,     8,     9,    10,    -1,    12,    13,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    22,    23,    -1,    25,    -1,
      27,    28,    29,    -1,    31,    -1,    33,    34,    -1,    36,
      37,    38,    39,    40,    -1,    -1,    43,    44,    45,    46,
      -1,    48,    49,    50,    51,    -1,    -1,    -1,    55,    56,
      57,    58,    59,    -1,    61,    62,    -1,    64,    -1,    66,
      67,    68,    -1,    70,    -1,    -1,    -1,    -1,    -1,    76,
      77,    78,    79,    80,    81,    82,    83,    -1,    85,    -1,
      87,    88,    89,    90,    91,    -1,    93,    -1,    -1,    96,
      97,    98,    99,    -1,   101,   102,   103,    -1,   105,    -1,
     107,   108,   109,    -1,   111,   112,    -1,    -1,   115,   116,
     117,    -1,   119,    -1,   121,    -1,    -1,    -1,   125,   126,
      -1,   128,    -1,    -1,   131,    -1,   133,   134,   135,   136,
      -1,   138,   139,   140,    -1,   142,   143,   144,   145,   146,
     147,    -1,    -1,    -1,   151,   152,   153,   154,   155,   156,
      -1,   158,    -1,   160,    -1,    -1,   163,    -1,   165,   166,
     167,   168,   169,    -1,    -1,    -1,   173,    -1,    -1,   176,
     177,   178,    -1,    -1,   181,   182,   183,   184,   185,   186,
     187,   188,   189,   190,    -1,    -1,    -1,   194,   195,    -1,
     197,    -1,   199,   200,   201,   202,   203,   204,   205,   206,
     207,    -1,   209,   210,    -1,   212,    -1,    -1,   215,   216,
     217,    -1,    -1,   220,    -1,    -1,    -1,   224,   225,    -1,
      -1,    -1,    -1,    -1,    -1,   232,   233,   234,   235,    -1,
      -1,    -1,   239,   240,   241,    -1,   243,   244,   245,   246,
     247,   248,   249,   250,   251,    -1,   253,   254,   255,   256,
     257,   258,   259,   260,   261,    -1,   263,   264,    -1,   266,
     267,    -1,   269,   270,   271,   272,   273,   274,   275,    -1,
     277,   278,   279,    -1,   281,   282,   283,   284,    -1,   286,
     287,    -1,   289,   290,   291,   292,   293,   294,   295,   296,
      -1,   298,    -1,   300,   301,    -1,   303,   304,   305,   306,
      -1,   308,   309,    -1,    -1,   312,    -1,   314,    -1,    -1,
     317,   318,   319,   320,   321,    -1,    -1,   324,   325,   326,
     327,    -1,    -1,   330,   331,   332,    -1,   334,   335,    -1,
     337,   338,    -1,    -1,   341,    -1,   343,   344,   345,   346,
     347,    -1,    -1,    -1,   351,     3,     4,     5,     6,     7,
       8,     9,    10,    -1,    12,    13,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    22,    23,    -1,    25,    -1,    27,
      28,    29,    -1,    31,    -1,    33,    34,    -1,    36,    37,
      38,    39,    40,    -1,    -1,    43,    44,    45,    46,    -1,
      48,    49,    50,    51,    -1,    -1,    -1,    55,    56,    57,
      58,    59,    -1,    61,    62,    -1,    64,    -1,    66,    67,
      68,    -1,    70,    -1,    -1,    -1,    -1,    -1,    76,    77,
      78,    79,    80,    81,    82,    83,    -1,    85,    -1,    87,
      88,    89,    90,    91,    -1,    93,    -1,    -1,    96,    97,
      98,    99,    -1,   101,   102,   103,    -1,   105,    -1,   107,
     108,   109,    -1,   111,   112,    -1,    -1,   115,   116,   117,
      -1,   119,    -1,   121,    -1,    -1,    -1,   125,   126,    -1,
     128,    -1,    -1,   131,    -1,   133,   134,   135,   136,    -1,
     138,   139,   140,    -1,   142,   143,   144,   145,   146,   147,
      -1,    -1,    -1,   151,   152,   153,   154,   155,   156,    -1,
     158,    -1,   160,    -1,    -1,   163,    -1,   165,   166,   167,
     168,   169,    -1,    -1,    -1,   173,    -1,    -1,   176,   177,
     178,    -1,    -1,   181,   182,   183,   184,   185,   186,   187,
     188,   189,   190,    -1,    -1,    -1,   194,   195,    -1,   197,
      -1,   199,   200,   201,   202,   203,   204,   205,   206,   207,
      -1,   209,   210,    -1,   212,    -1,    -1,   215,   216,   217,
      -1,    -1,   220,    -1,    -1,    -1,   224,   225,    -1,    -1,
      -1,    -1,    -1,    -1,   232,   233,   234,   235,    -1,    -1,
      -1,   239,   240,   241,    -1,   243,   244,   245,   246,   247,
     248,   249,   250,   251,    -1,   253,   254,   255,   256,   257,
     258,   259,   260,   261,    -1,   263,   264,    -1,   266,   267,
      -1,   269,   270,   271,   272,   273,   274,   275,    -1,   277,
     278,   279,    -1,   281,   282,   283,   284,    -1,   286,   287,
      -1,   289,   290,   291,   292,   293,   294,   295,   296,    -1,
     298,    -1,   300,   301,    -1,   303,   304,   305,   306,    -1,
     308,   309,    -1,    -1,   312,    -1,   314,    -1,    -1,   317,
     318,   319,   320,   321,    -1,    -1,   324,   325,   326,   327,
      -1,    -1,   330,   331,   332,    -1,   334,   335,    -1,   337,
     338,    -1,    -1,   341,    -1,   343,   344,   345,   346,   347,
      -1,    -1,    -1,   351,     3,     4,     5,     6,     7,     8,
       9,    10,    -1,    12,    13,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    22,    23,    -1,    25,    -1,    27,    28,
      29,    -1,    31,    -1,    33,    34,    -1,    36,    37,    38,
      39,    40,    -1,    -1,    43,    44,    45,    46,    -1,    48,
      49,    50,    51,    -1,    -1,    -1,    55,    56,    57,    58,
      59,    -1,    61,    62,    -1,    64,    -1,    66,    67,    68,
      -1,    70,    -1,    -1,    -1,    -1,    -1,    76,    77,    78,
      79,    80,    81,    82,    83,    -1,    85,    -1,    87,    88,
      89,    90,    91,    -1,    93,    -1,    -1,    96,    97,    98,
      99,    -1,   101,   102,   103,    -1,   105,    -1,   107,   108,
     109,    -1,   111,   112,    -1,    -1,   115,   116,   117,    -1,
     119,    -1,   121,    -1,    -1,    -1,   125,   126,    -1,   128,
      -1,    -1,   131,    -1,   133,   134,   135,   136,    -1,   138,
     139,   140,    -1,   142,   143,   144,   145,   146,   147,    -1,
      -1,    -1,   151,   152,   153,   154,   155,   156,    -1,   158,
      -1,   160,    -1,    -1,   163,    -1,   165,   166,   167,   168,
     169,    -1,    -1,    -1,   173,    -1,    -1,   176,   177,   178,
      -1,    -1,   181,   182,   183,   184,   185,   186,   187,   188,
     189,   190,    -1,    -1,    -1,   194,   195,    -1,   197,    -1,
     199,   200,   201,   202,   203,   204,   205,    -1,   207,    -1,
     209,   210,    -1,   212,   213,    -1,   215,   216,   217,    -1,
      -1,   220,    -1,    -1,    -1,   224,   225,    -1,    -1,    -1,
      -1,    -1,    -1,   232,   233,   234,   235,    -1,    -1,    -1,
     239,   240,   241,    -1,   243,   244,   245,   246,   247,   248,
     249,   250,   251,    -1,   253,   254,   255,   256,   257,   258,
     259,   260,   261,    -1,   263,   264,    -1,   266,   267,    -1,
     269,   270,   271,   272,   273,   274,   275,    -1,   277,   278,
     279,    -1,   281,   282,   283,   284,    -1,   286,   287,    -1,
     289,   290,   291,   292,   293,   294,   295,   296,    -1,   298,
      -1,   300,   301,    -1,   303,   304,   305,   306,    -1,   308,
     309,    -1,    -1,   312,    -1,   314,    -1,    -1,   317,   318,
     319,   320,   321,    -1,    -1,   324,   325,   326,   327,    -1,
      -1,   330,   331,   332,    -1,   334,   335,    -1,   337,   338,
      -1,    -1,   341,    -1,   343,   344,   345,   346,   347,    -1,
      -1,    -1,   351,     3,     4,     5,     6,     7,     8,     9,
      10,    -1,    12,    13,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    22,    23,    -1,    25,    -1,    27,    28,    29,
      -1,    31,    -1,    33,    34,    -1,    36,    37,    38,    39,
      40,    -1,    -1,    43,    44,    45,    46,    -1,    48,    49,
      50,    51,    -1,    -1,    -1,    55,    56,    57,    58,    59,
      -1,    61,    62,    -1,    64,    -1,    66,    67,    68,    -1,
      70,    -1,    -1,    -1,    -1,    -1,    76,    77,    78,    79,
      80,    81,    82,    83,    -1,    85,    -1,    87,    88,    89,
      90,    91,    -1,    93,    -1,    -1,    96,    97,    98,    99,
      -1,   101,   102,   103,    -1,   105,    -1,   107,   108,   109,
      -1,   111,   112,    -1,    -1,   115,   116,   117,    -1,   119,
      -1,   121,    -1,    -1,    -1,   125,   126,    -1,   128,    -1,
      -1,   131,    -1,   133,   134,   135,   136,    -1,   138,   139,
     140,    -1,   142,   143,   144,   145,   146,   147,    -1,    -1,
      -1,   151,   152,   153,   154,   155,   156,    -1,   158,    -1,
     160,    -1,    -1,   163,    -1,   165,   166,   167,   168,   169,
      -1,    -1,    -1,   173,    -1,    -1,   176,   177,   178,    -1,
      -1,   181,   182,   183,   184,   185,   186,   187,   188,   189,
     190,    -1,    -1,    -1,   194,   195,    -1,   197,    -1,   199,
     200,   201,   202,   203,   204,   205,    -1,   207,    -1,   209,
     210,    -1,   212,    -1,    -1,   215,   216,   217,    -1,    -1,
     220,    -1,    -1,    -1,   224,   225,    -1,    -1,    -1,    -1,
      -1,    -1,   232,   233,   234,   235,    -1,    -1,    -1,   239,
     240,   241,    -1,   243,   244,   245,   246,   247,   248,   249,
     250,   251,    -1,   253,   254,   255,   256,   257,   258,   259,
     260,   261,    -1,   263,   264,    -1,   266,   267,    -1,   269,
     270,   271,   272,   273,   274,   275,    -1,   277,   278,   279,
      -1,   281,   282,   283,   284,    -1,   286,   287,    -1,   289,
     290,   291,   292,   293,   294,   295,   296,    -1,   298,    -1,
     300,   301,    -1,   303,   304,   305,   306,    -1,   308,   309,
      -1,    -1,   312,    -1,   314,    -1,    -1,   317,   318,   319,
     320,   321,    -1,    -1,   324,   325,   326,   327,    -1,    -1,
     330,   331,   332,    -1,   334,   335,    -1,   337,   338,    -1,
      -1,   341,    -1,   343,   344,   345,   346,   347,    -1,    -1,
      -1,   351,     3,     4,     5,     6,     7,     8,     9,    10,
      -1,    12,    13,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    22,    23,    -1,    25,    -1,    27,    28,    29,    -1,
      31,    -1,    33,    34,    -1,    36,    37,    38,    39,    40,
      -1,    -1,    43,    44,    45,    46,    -1,    48,    49,    50,
      51,    -1,    -1,    -1,    55,    56,    57,    58,    59,    -1,
      61,    62,    -1,    64,    -1,    66,    67,    68,    -1,    70,
      -1,    -1,    -1,    -1,    -1,    76,    77,    78,    79,    80,
      81,    82,    83,    -1,    85,    -1,    87,    88,    89,    90,
      91,    -1,    93,    -1,    -1,    96,    97,    98,    99,    -1,
     101,   102,   103,    -1,   105,    -1,   107,   108,   109,    -1,
     111,   112,    -1,    -1,   115,   116,   117,    -1,   119,    -1,
     121,    -1,    -1,    -1,   125,   126,    -1,   128,    -1,    -1,
     131,    -1,   133,   134,   135,   136,    -1,   138,   139,   140,
      -1,   142,   143,   144,   145,   146,   147,    -1,    -1,    -1,
     151,   152,   153,   154,   155,   156,    -1,   158,    -1,   160,
      -1,    -1,   163,    -1,   165,   166,   167,   168,   169,    -1,
      -1,    -1,   173,    -1,    -1,   176,   177,   178,    -1,    -1,
     181,   182,   183,   184,   185,   186,   187,   188,   189,   190,
      -1,    -1,    -1,   194,   195,    -1,   197,    -1,   199,   200,
     201,   202,   203,   204,   205,    -1,   207,    -1,   209,   210,
      -1,   212,    -1,    -1,   215,   216,   217,    -1,    -1,   220,
      -1,    -1,    -1,   224,   225,    -1,    -1,    -1,    -1,    -1,
      -1,   232,   233,   234,   235,    -1,    -1,    -1,   239,   240,
     241,    -1,   243,   244,   245,   246,   247,   248,   249,   250,
     251,    -1,   253,   254,   255,   256,   257,   258,   259,   260,
     261,    -1,   263,   264,    -1,   266,   267,    -1,   269,   270,
     271,   272,   273,   274,   275,    -1,   277,   278,   279,    -1,
     281,   282,   283,   284,    -1,   286,   287,    -1,   289,   290,
     291,   292,   293,   294,   295,   296,    -1,   298,    -1,   300,
     301,    -1,   303,   304,   305,   306,    -1,   308,   309,    -1,
      -1,   312,    -1,   314,    -1,    -1,   317,   318,   319,   320,
     321,    -1,    -1,   324,   325,   326,   327,    -1,    -1,   330,
     331,   332,    -1,   334,   335,    -1,   337,   338,    -1,    -1,
     341,    -1,   343,   344,   345,   346,   347,    -1,    -1,    -1,
     351,     3,     4,     5,     6,     7,     8,     9,    10,    -1,
      12,    13,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      22,    23,    -1,    25,    -1,    27,    28,    29,    -1,    31,
      -1,    33,    34,    -1,    36,    37,    38,    39,    40,    -1,
      -1,    43,    44,    45,    46,    -1,    48,    49,    50,    51,
      -1,    -1,    -1,    55,    56,    57,    58,    59,    -1,    61,
      62,    -1,    64,    -1,    66,    67,    68,    -1,    70,    -1,
      -1,    -1,    -1,    -1,    76,    77,    78,    79,    80,    81,
      82,    83,    -1,    85,    -1,    87,    88,    89,    90,    91,
      -1,    93,    -1,    -1,    96,    97,    98,    99,    -1,   101,
     102,   103,    -1,   105,    -1,   107,   108,   109,    -1,   111,
     112,    -1,    -1,   115,   116,   117,    -1,   119,    -1,   121,
      -1,    -1,    -1,   125,   126,    -1,   128,    -1,    -1,   131,
      -1,   133,   134,   135,   136,    -1,   138,   139,   140,    -1,
     142,   143,   144,   145,   146,   147,    -1,    -1,    -1,   151,
     152,   153,   154,   155,   156,    -1,   158,    -1,   160,    -1,
      -1,   163,    -1,   165,   166,   167,   168,   169,    -1,    -1,
      -1,   173,    -1,    -1,   176,   177,   178,    -1,    -1,   181,
     182,   183,   184,   185,   186,   187,   188,   189,   190,    -1,
      -1,    -1,   194,   195,    -1,   197,    -1,   199,   200,   201,
     202,   203,   204,   205,    -1,   207,    -1,   209,   210,    -1,
     212,    -1,    -1,   215,   216,   217,    -1,    -1,   220,    -1,
      -1,    -1,   224,   225,    -1,    -1,    -1,    -1,    -1,    -1,
     232,   233,   234,   235,    -1,    -1,    -1,   239,   240,   241,
      -1,   243,   244,   245,   246,   247,   248,   249,   250,   251,
      -1,   253,   254,   255,   256,   257,   258,   259,   260,   261,
      -1,   263,   264,    -1,   266,   267,    -1,   269,   270,   271,
     272,   273,   274,   275,    -1,   277,   278,   279,    -1,   281,
      -1,   283,   284,    -1,   286,   287,    -1,   289,   290,   291,
     292,   293,   294,   295,   296,    -1,   298,    -1,   300,   301,
      -1,   303,   304,   305,   306,    -1,   308,   309,    10,    -1,
     312,    -1,   314,    -1,    -1,   317,   318,   319,   320,   321,
      22,    -1,   324,   325,   326,   327,    -1,    -1,   330,   331,
     332,    -1,   334,   335,    -1,   337,   338,    -1,    -1,   341,
      42,   343,   344,   345,   346,   347,    -1,    -1,    -1,   351,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    60,    -1,
      62,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    78,    -1,    -1,    -1,
      -1,    -1,    84,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    96,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,   125,   126,    -1,    -1,    -1,   130,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,   144,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,   167,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,   178,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,   224,    -1,   226,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,   245,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,   266,    -1,    -1,    -1,   270,    -1,
     272,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,   303,   304,    -1,   306,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,   314,    -1,    -1,    -1,   318,   319,    -1,    -1,
      -1,   323,    -1,    -1,    -1,    -1,   328
};

/* YYSTOS[STATE-NUM] -- The (internal number of the) accessing
   symbol of state STATE-NUM.  */
static const yytype_uint16 yystos[] =
{
       0,     3,    13,    14,    15,    29,    48,    50,    51,    55,
      56,    64,    65,    80,    83,    89,    98,   104,   109,   111,
     115,   127,   153,   176,   177,   182,   190,   210,   240,   250,
     253,   255,   259,   264,   267,   271,   276,   281,   284,   290,
     317,   325,   327,   330,   333,   372,   380,   381,   382,   383,
     387,   388,   389,   390,   391,   392,   393,   394,   395,   397,
     398,   402,   413,   414,   415,   418,   419,   427,   428,   437,
     465,   469,   470,   477,   482,   484,   486,   487,   500,   501,
     502,   503,   513,   518,   519,   520,   521,   526,   527,   530,
     533,   534,   544,   545,   548,   554,   568,   571,   572,   573,
     576,   578,   580,   583,   585,   586,   587,   595,   596,   597,
     598,   599,   604,   606,   607,   611,   612,   615,   616,   617,
     619,   620,   621,   622,   623,   628,   631,   635,   637,   638,
     643,   645,   649,   656,   659,   660,   661,   662,   663,   687,
     312,   344,   600,    10,    62,    78,    96,   125,   130,   144,
     167,   224,   266,   272,   277,   302,   303,   314,   319,   328,
     600,     3,     4,     5,     6,     7,     8,     9,    10,    12,
      13,    22,    23,    25,    27,    28,    29,    31,    33,    34,
      36,    37,    38,    39,    40,    43,    44,    45,    46,    48,
      49,    50,    51,    52,    55,    56,    57,    58,    59,    61,
      62,    63,    64,    66,    67,    68,    70,    76,    77,    78,
      79,    80,    81,    82,    83,    85,    87,    88,    89,    90,
      91,    93,    96,    97,    98,    99,   101,   102,   103,   105,
     107,   108,   109,   110,   111,   112,   113,   115,   116,   117,
     119,   121,   125,   126,   128,   129,   131,   133,   134,   135,
     136,   138,   139,   140,   142,   143,   144,   145,   146,   147,
     150,   151,   152,   153,   154,   155,   156,   158,   160,   163,
     165,   166,   167,   168,   169,   171,   173,   176,   177,   178,
     181,   182,   183,   184,   185,   186,   187,   188,   189,   190,
     194,   195,   197,   199,   200,   201,   202,   203,   204,   205,
     206,   207,   209,   210,   212,   214,   215,   216,   217,   220,
     224,   225,   228,   231,   232,   233,   234,   235,   237,   238,
     239,   240,   241,   243,   244,   245,   246,   247,   248,   249,
     250,   251,   253,   254,   255,   256,   257,   258,   259,   260,
     261,   263,   264,   266,   267,   268,   269,   270,   271,   272,
     273,   274,   275,   277,   278,   279,   281,   282,   283,   284,
     286,   287,   289,   290,   291,   292,   293,   294,   295,   296,
     297,   298,   300,   301,   303,   304,   305,   306,   308,   309,
     312,   313,   314,   315,   317,   318,   319,   320,   321,   324,
     325,   326,   327,   330,   331,   332,   333,   334,   335,   337,
     338,   341,   343,   344,   345,   346,   347,   351,   771,   783,
     787,   788,   198,   221,   767,   769,   775,   783,   791,   222,
     241,   600,    32,   433,   660,    10,    22,    42,    60,    78,
      84,    96,   126,   130,   178,   224,   226,   266,   272,   303,
     304,   306,   314,   318,   319,   323,   328,   438,   478,   516,
     549,   555,   240,   771,   771,   123,    10,    22,    42,    62,
      78,    96,   125,   130,   144,   224,   232,   245,   266,   270,
     272,   277,   302,   303,   314,   319,   328,   337,   483,   522,
     600,   771,   623,   630,     4,    11,    27,   116,   121,   169,
     199,   243,   254,   357,   364,   531,   771,   782,    11,    65,
     252,   276,   535,   536,   537,   783,   159,   769,   783,   353,
     776,   780,   302,   666,   531,   771,   769,   312,   771,   232,
      78,   144,   301,   302,   581,   271,   783,    11,   279,   308,
     312,   404,   783,     8,   127,   535,   536,   241,   600,   783,
      11,    94,   668,    61,   178,   194,   266,   279,   308,   312,
     403,   404,    11,   279,   308,   312,   404,   312,   666,   365,
     769,   223,   696,   697,   769,   124,   625,   372,   764,   660,
     661,     0,   376,   336,   624,   106,   157,   227,   322,   669,
     670,   377,    26,    30,    32,    69,   122,   124,   137,   149,
     161,   162,   164,   172,   174,   196,   211,   229,   230,   265,
     285,   336,   351,   767,   777,   785,   787,   789,   524,   783,
     772,   783,   524,   543,   777,   781,   783,   696,   771,    49,
     356,   359,   360,   361,   363,   364,   365,   366,   367,   368,
     575,   733,   734,   783,   781,   771,   696,   769,   696,   771,
     771,   524,   781,   163,   248,   601,   602,   603,   370,   375,
     758,   759,   222,    10,    42,    54,    60,    62,    78,    96,
     125,   144,   168,   224,   266,   270,   272,   277,   302,   303,
     314,   319,   337,   483,   528,   780,   769,   310,   777,   771,
     372,   314,   772,   524,   304,   306,   781,   304,   306,    49,
     575,   258,   781,   399,   783,   771,   771,   524,   781,   277,
     302,   337,   483,    62,   144,   125,   270,   771,   657,   697,
     136,   777,   771,   136,   579,   136,   772,   136,   777,   136,
     770,   771,    49,   136,   575,    36,   136,   770,   136,   771,
     136,   771,   136,   771,   136,   770,   167,   136,   523,   524,
     372,   636,   624,   782,    11,   782,    11,   782,   782,   357,
     123,   141,   532,   244,   222,   310,   377,   769,   768,   769,
     532,   780,   372,   632,    36,   771,   771,   769,   783,    26,
     347,   163,   375,   225,   225,   222,   123,   780,   310,   222,
      19,    31,    33,    34,    41,    42,    44,    45,    52,    63,
      71,    72,    73,    74,    75,    81,    82,    97,   110,   113,
     114,   117,   129,   155,   156,   158,   171,   179,   180,   195,
     197,   208,   213,   214,   215,   224,   231,   237,   249,   268,
     280,   287,   297,   308,   309,   313,   315,   316,   323,   328,
     334,   351,   352,   354,   355,   356,   357,   358,   363,   364,
     365,   372,   660,   705,   706,   707,   712,   713,   714,   716,
     717,   718,   719,   722,   723,   726,   728,   729,   731,   735,
     752,   757,   765,   766,   767,   777,   778,   779,   780,   784,
     787,    11,   416,   768,   279,   403,    84,   411,   780,   353,
     412,   783,    26,    46,   403,   347,   602,   310,   359,    26,
     347,   163,   603,   768,   372,   769,    20,   783,   281,   365,
     122,   626,    84,   726,   762,   763,   373,   373,   382,   769,
      11,    94,   667,   667,    36,   667,   118,   175,   219,   673,
     682,   684,   685,   764,   759,   372,   508,   233,   256,   375,
     525,   233,   256,   281,   341,   384,   414,     7,    98,   233,
     281,   424,    38,   112,   139,   263,   275,   289,   296,   338,
     564,   569,   372,   556,     7,    98,   256,   396,   233,   256,
     259,   281,   422,   423,   256,   524,   372,   375,   256,   281,
     384,   414,   233,   256,   281,   471,     7,    13,    51,    93,
      98,   101,   146,   200,   256,   281,   420,   421,   423,   233,
     256,   222,   233,   281,   256,   281,   384,   414,   173,   223,
     345,   377,   601,   726,    11,    14,    15,    16,    17,    19,
      20,    21,    24,    35,    41,    42,    47,    53,    54,    60,
      65,    71,    72,    73,    74,    75,    84,    86,    92,    94,
      95,   100,   104,   106,   114,   118,   120,   123,   127,   130,
     132,   141,   148,   157,   159,   170,   175,   179,   180,   198,
     208,   213,   218,   219,   221,   222,   223,   226,   227,   236,
     242,   252,   262,   276,   280,   288,   299,   302,   307,   310,
     311,   316,   322,   323,   328,   329,   339,   340,   351,   365,
     774,   786,   787,   788,   789,   790,   758,   769,   777,   372,
     771,   777,   216,    49,   575,   771,   771,   167,   524,   372,
     452,   293,   294,   430,   780,   372,   508,   510,    47,    31,
      33,    34,    44,    45,    81,    82,   117,   155,   156,   158,
     195,   197,   215,   249,   282,   287,   308,   309,   334,   351,
     702,   704,   706,   707,   711,   713,   714,   715,   717,   718,
     722,   723,   784,   787,   771,   384,    20,   618,   384,   524,
     372,   504,   438,   384,    26,   400,   233,   485,     9,    28,
     488,    20,   504,   384,   769,   769,   769,   167,   524,    58,
     775,   783,   777,   771,    32,    76,   152,   200,   273,   329,
     644,   110,   508,    39,   261,   425,   110,   372,   110,   110,
     556,   110,   377,   136,   524,   110,   372,   770,   110,   110,
     222,   110,   110,   222,   110,   136,   412,   110,   377,   425,
     726,   738,    65,   629,   635,   638,   643,   649,   656,   659,
     771,    78,   125,   167,   272,   277,   302,   303,   538,   768,
     770,   537,    84,   372,   639,   659,   141,   377,   646,   771,
     633,   702,    20,   770,   119,   582,   582,   582,   173,   783,
     118,   118,   538,   770,   271,   783,   372,   370,   660,   742,
     335,   720,   726,   756,   372,   720,   720,   372,   372,   372,
     372,   372,   710,   710,   238,   660,   372,   372,   708,   372,
     372,   372,   372,    44,    45,   720,   726,   372,   372,   709,
     372,   372,   372,   372,   372,   341,   343,   372,   724,   372,
     724,   372,   372,   660,   760,   726,   726,   333,   660,   726,
     738,   780,    45,   372,   721,   372,   780,    16,    20,    25,
      30,   137,   141,   161,   162,   174,   208,   211,   224,   226,
     285,   356,   359,   360,   361,   363,   364,   365,   366,   367,
     368,   374,   733,   735,   737,   230,   726,   159,   377,   664,
     759,   372,    87,   138,   417,    46,    84,   412,    20,    84,
     178,   351,   352,   364,   410,   474,   475,   476,   723,   780,
     782,    84,   114,   218,   222,   316,   405,   406,   407,   409,
     412,   474,   405,   173,   425,   769,   783,   372,   650,   651,
     652,   653,   654,   783,   624,   373,   377,   372,   627,   660,
     662,   663,   662,   671,   672,   726,   662,   248,   283,   327,
      11,   675,   726,   676,   726,   682,   683,   673,   674,   118,
     685,   365,   509,   702,   233,   256,   281,   310,   310,   774,
     375,   310,   310,   403,   613,    47,    60,   120,   242,   323,
     450,   451,    60,    84,   208,   310,    84,   208,   272,   222,
     275,   213,    88,   160,   261,   564,   570,   141,   150,   228,
     282,   351,   373,   557,   558,   559,   560,   562,   702,   784,
     785,   787,   233,   256,   281,   310,   328,   310,   310,   504,
     303,   504,   377,   310,   329,   206,   574,   702,   575,   310,
     403,   385,   310,   310,   272,    37,    77,   143,   185,   187,
     200,   232,   260,   290,   472,    54,   450,   584,   584,   222,
     314,    60,   584,   314,   769,   146,   310,   584,   272,   343,
     377,   310,   310,   696,   310,   272,   310,   403,   385,   248,
     257,   278,   408,   601,   371,   378,   508,   702,   222,   556,
     474,   524,   372,   161,   222,   222,   524,   161,   453,   454,
     783,   341,   434,   384,   351,   511,   512,   504,   372,   704,
      20,    19,   703,    79,   135,   186,   189,   274,   346,   372,
     725,   525,     9,   608,   702,   385,   516,   505,   506,   786,
     337,   385,   781,    65,   127,   401,   437,   469,   487,   533,
     548,   604,   771,   181,    89,   153,   327,   489,   490,   372,
     385,   471,   217,   372,   466,   452,   412,   118,   775,   222,
     556,    20,   341,   343,   658,   273,   372,   660,   689,   690,
     691,   696,   698,   729,   767,   340,   699,   777,   425,   702,
     772,   777,   425,   770,   771,   110,   329,   575,   574,   425,
     770,   771,   769,   771,   771,   769,   770,   110,   425,   523,
     524,   373,   377,   438,   770,   542,   543,   777,   770,   770,
     768,   768,   770,   310,   341,   546,   333,   640,   641,   783,
     262,   642,     5,   108,   268,   283,   647,   769,   212,   648,
     373,   377,   634,   638,   643,   649,   659,   310,   536,   535,
     536,   123,   128,   547,   783,   738,   738,   741,   742,   372,
     339,   753,   754,   726,   738,   726,   738,   779,   779,   779,
      79,   135,   186,   189,   274,   346,   351,   353,   739,   743,
     779,   738,   738,   779,   779,   720,   720,   726,   779,   575,
     726,   744,   363,   364,   727,   728,   731,   735,   746,   373,
     738,   726,   738,   747,   308,   308,   779,   779,   726,    35,
     123,   170,   311,   726,   738,   750,   758,   373,   377,   281,
     779,   779,   725,   726,   786,   308,    24,   299,   761,   726,
     372,   660,   751,    94,   114,   208,   213,   217,   316,   324,
     726,    30,   137,   141,   174,   285,   372,   726,   310,   726,
     726,   726,   726,   726,   726,   726,   726,   726,   702,   726,
      11,    17,   288,   732,   268,   372,   731,   126,   178,   302,
     304,   306,   665,   769,   766,   123,   688,    11,    94,   365,
     373,   738,   312,   352,   372,   780,   377,   373,   654,   655,
     377,   688,   359,   760,   622,   769,   762,   770,   377,    21,
      92,   329,   223,   217,   686,   686,   219,   377,   175,   373,
     373,   377,   310,   310,   272,   781,   771,   774,   781,   772,
      59,   614,   372,   771,   165,   165,   372,   771,   213,   781,
     726,   213,   771,   213,    88,   160,   222,   228,   784,   373,
     377,   560,   562,   559,   562,   525,   310,   310,   272,   781,
     770,   781,   771,   771,   423,   771,   773,   783,   377,   373,
     377,   781,     8,    59,    66,    67,    68,   103,   141,   146,
     183,   201,   202,   203,   204,   205,   207,   235,   266,   298,
     300,   321,   328,   331,   386,   781,   771,   771,   474,    36,
     473,   474,   474,    77,   185,   187,    36,   384,   384,   442,
     783,   783,   771,    11,   328,   771,   771,   783,    11,   328,
     771,   769,   771,   771,   771,    51,   220,   281,   421,   781,
     771,   256,   781,   771,   781,    57,   320,   248,   726,   161,
      20,   524,   161,   161,   329,   574,   213,   529,   780,   524,
     524,   161,   529,   373,   377,   220,   123,   310,   429,   431,
     359,   373,   377,   726,    19,   703,   702,   370,   370,   310,
     310,   310,   310,   779,   489,    59,   102,   181,   233,   303,
     305,   609,   443,   118,   373,   377,   359,   769,   400,   226,
     438,   780,   222,   226,   700,   701,   783,   769,   174,   439,
     440,   441,   442,   447,   450,   467,   468,   783,   341,   343,
     461,    20,   131,   780,   222,   769,    20,   167,   263,   563,
     564,   565,   588,   134,   134,   118,   660,   690,   691,    20,
     692,   783,   377,    69,   124,   149,   164,   172,   196,   265,
     693,   692,    20,   692,   783,   759,   726,   730,   642,   508,
      20,   556,   524,   773,   372,   373,   222,   425,   222,   425,
     412,   425,   726,   302,   377,   556,   130,   539,   540,   781,
       8,   547,   373,   377,   760,   765,   108,   283,   108,   283,
     268,   327,   188,   702,   771,   123,   222,   539,    36,   425,
     373,   371,   371,   377,   779,   726,   100,   754,   755,    20,
     373,   329,   373,   373,   373,   373,   377,   373,   123,   373,
     373,   373,   373,   373,   377,   373,   377,   373,   236,   745,
     373,   727,   727,   141,   161,   224,   359,   360,   361,   363,
     364,   365,   366,   367,   368,   374,   735,   727,   373,   373,
     118,   123,   748,   749,   373,   347,   347,   373,   373,    20,
     750,   738,   750,   750,   123,   373,   760,   726,   783,   373,
     373,   347,   727,   727,   105,   738,   123,    94,   114,   213,
     217,   316,   324,   372,   105,   299,   761,   726,   751,   726,
     310,   575,   726,   372,   660,   304,   306,   304,   306,   769,
     666,   666,   689,   699,   738,   738,   373,   373,   602,   779,
     725,   407,   373,   377,   651,   699,   762,   373,   672,   224,
     733,   736,   770,   648,   648,   676,   676,   675,   702,   781,
     771,   771,   175,   726,   451,   372,   372,   453,   425,   151,
     213,   525,   558,   562,   562,   367,   781,   771,   771,   233,
     256,   702,   233,   206,   702,   770,   175,   235,   130,   266,
     213,   780,   770,   779,   235,   770,   326,   474,   524,   474,
     474,   702,    98,   281,   319,   424,   425,   425,   310,   310,
     371,   529,   702,   161,   529,   529,   773,   373,   161,   161,
     529,   454,   430,    32,    70,    90,   105,   119,   133,   213,
     220,   247,   432,   224,   364,   474,   507,   562,   736,   780,
     789,   790,   351,   512,   373,   370,   373,   779,   371,   779,
     135,   186,   274,   186,   274,   274,   189,   373,   222,   175,
     359,   610,   610,   610,   610,   610,    47,    60,    84,    86,
     148,   208,   213,   242,   252,   323,   444,   445,   446,   319,
     506,   507,   452,   258,   302,   769,   490,   373,   377,   702,
     372,   769,   373,   377,   373,   377,   220,   504,   220,   222,
     462,   659,   479,   771,   310,   769,   329,   550,   566,   780,
     412,   561,   562,   341,   565,   567,   222,   659,   373,   783,
     372,   690,   164,   229,   694,   690,   694,   164,   693,   694,
     164,   372,   783,   372,    18,   342,   425,   702,   425,   329,
     425,   574,   425,   769,   769,   425,   769,   543,   781,   341,
     377,   541,   225,   659,   641,   108,   108,   770,   538,   425,
     781,   742,   373,   307,   726,   104,   702,   524,   779,   726,
     726,   779,   726,   748,   727,    94,   208,   217,   727,   727,
     727,   727,   727,   727,   727,   727,   727,   702,   727,   726,
     726,   749,   748,   724,   724,   702,   373,   373,   373,   738,
     373,   721,   780,   726,    16,    16,   726,   373,   726,   123,
     372,   702,   740,   726,   727,   727,   105,   105,   726,   373,
     105,   726,   666,   666,   666,   666,   769,   769,   130,   677,
     373,   373,   373,   359,   654,   642,   372,   610,   373,   453,
     453,   373,   151,   367,   319,   310,   310,   310,   782,   780,
     770,   770,   780,   780,   443,   208,   208,   292,   295,   702,
     771,   771,   373,   529,   161,   161,   529,   529,   329,   435,
     436,   618,   618,   208,   247,   618,   618,    86,   148,   208,
     497,   498,   499,   779,   341,   343,   371,   371,   725,   769,
     610,    84,   779,   780,    84,   780,    84,   771,    84,   771,
      84,   771,   372,   771,   727,    87,   138,    86,   213,   165,
     769,   567,   702,    20,   769,   118,   491,   226,   701,   439,
     448,   147,   460,   441,   468,   783,    56,   303,   463,   348,
     349,   350,   605,   332,   480,   525,   780,   550,   773,   372,
     377,   563,   504,    89,   153,   276,   327,   593,   692,   372,
     770,   690,   222,   329,   695,   690,   164,   690,   700,   372,
     700,   783,   726,   352,   373,   773,   373,   425,   425,   372,
     466,   127,   540,   547,   123,   726,   373,   373,   373,   373,
     373,   749,   123,    94,   217,   372,   373,   725,   727,   727,
     726,   740,   373,   377,    16,    16,   726,   726,   105,   726,
     373,   769,   769,   769,   769,    36,    18,   678,   780,   764,
     575,   782,   373,   373,   567,   319,   781,   771,   781,   213,
     213,   476,   783,   329,   426,   161,   529,   529,   384,    91,
     780,   780,   213,   453,   780,   780,    87,   138,    86,   499,
     498,   371,   125,   125,   123,   496,   782,   726,   208,   445,
     567,   452,   329,   464,   329,   659,   372,    99,   492,   109,
     490,   373,   107,   142,   449,   372,   461,    89,    98,   239,
     771,    20,    47,    47,   225,   479,   166,   481,   123,   372,
     372,   551,   552,   729,   783,   780,   567,   310,   770,   373,
     726,   372,   690,   695,   373,   700,   373,   193,   217,   425,
     425,   425,   461,   225,   425,   539,   727,   123,   372,   740,
     373,   702,   727,   727,   726,   738,   660,   192,   679,   725,
     373,   252,   567,   464,   726,   529,   431,   780,   453,   543,
      20,   577,   769,   497,   373,   464,   184,   455,   144,   773,
     605,   268,   291,   493,   246,   461,    61,    85,   145,    61,
      85,   145,   768,   462,   269,   269,   109,   659,   225,   225,
     780,   524,   551,   726,   373,   377,   329,   524,   553,   553,
     769,   373,   770,   373,   779,   726,   462,   425,   727,   740,
     373,   779,   191,   680,   769,   464,   577,    23,   140,   118,
     124,   234,   286,   222,   456,   457,   458,   303,    20,   777,
     462,   373,   463,   771,   373,   373,   567,   552,   524,   699,
     373,   463,   373,   779,   132,   681,   452,    99,    89,   327,
     222,   458,   222,   457,   771,   125,   224,   295,   514,   515,
     372,   463,   636,   567,   553,   463,    95,    20,   726,   455,
     268,    39,   200,   261,   281,   459,   459,   779,   779,   702,
     377,   352,   354,   355,   357,   494,   495,   780,   783,   463,
     699,    12,   154,   594,   456,   109,     6,    84,   213,   777,
     575,   515,   373,   377,   699,   209,   372,   589,   591,   596,
     638,   643,   649,   659,   497,   246,   556,   251,   372,   517,
     495,   590,   591,   592,   660,   661,   777,   574,   373,   376,
     372,   373,   592,   494,   517,   373
};

#define yyerrok		(yyerrstatus = 0)
#define yyclearin	(yychar = YYEMPTY)
#define YYEMPTY		(-2)
#define YYEOF		0

#define YYACCEPT	goto yyacceptlab
#define YYABORT		goto yyabortlab
#define YYERROR		goto yyerrorlab


/* Like YYERROR except do call yyerror.  This remains here temporarily
   to ease the transition to the new meaning of YYERROR, for GCC.
   Once GCC version 2 has supplanted version 1, this can go.  */

#define YYFAIL		goto yyerrlab

#define YYRECOVERING()  (!!yyerrstatus)

#define YYBACKUP(Token, Value)					\
do								\
  if (yychar == YYEMPTY && yylen == 1)				\
    {								\
      yychar = (Token);						\
      yylval = (Value);						\
      yytoken = YYTRANSLATE (yychar);				\
      YYPOPSTACK (1);						\
      goto yybackup;						\
    }								\
  else								\
    {								\
      yyerror (YY_("syntax error: cannot back up")); \
      YYERROR;							\
    }								\
while (YYID (0))


#define YYTERROR	1
#define YYERRCODE	256


/* YYLLOC_DEFAULT -- Set CURRENT to span from RHS[1] to RHS[N].
   If N is 0, then set CURRENT to the empty location which ends
   the previous symbol: RHS[0] (always defined).  */

#define YYRHSLOC(Rhs, K) ((Rhs)[K])
#ifndef YYLLOC_DEFAULT
# define YYLLOC_DEFAULT(Current, Rhs, N)				\
    do									\
      if (YYID (N))                                                    \
	{								\
	  (Current).first_line   = YYRHSLOC (Rhs, 1).first_line;	\
	  (Current).first_column = YYRHSLOC (Rhs, 1).first_column;	\
	  (Current).last_line    = YYRHSLOC (Rhs, N).last_line;		\
	  (Current).last_column  = YYRHSLOC (Rhs, N).last_column;	\
	}								\
      else								\
	{								\
	  (Current).first_line   = (Current).last_line   =		\
	    YYRHSLOC (Rhs, 0).last_line;				\
	  (Current).first_column = (Current).last_column =		\
	    YYRHSLOC (Rhs, 0).last_column;				\
	}								\
    while (YYID (0))
#endif


/* YY_LOCATION_PRINT -- Print the location on the stream.
   This macro was not mandated originally: define only if we know
   we won't break user code: when these are the locations we know.  */

#ifndef YY_LOCATION_PRINT
# if YYLTYPE_IS_TRIVIAL
#  define YY_LOCATION_PRINT(File, Loc)			\
     fprintf (File, "%d.%d-%d.%d",			\
	      (Loc).first_line, (Loc).first_column,	\
	      (Loc).last_line,  (Loc).last_column)
# else
#  define YY_LOCATION_PRINT(File, Loc) ((void) 0)
# endif
#endif


/* YYLEX -- calling `yylex' with the right arguments.  */

#ifdef YYLEX_PARAM
# define YYLEX yylex (YYLEX_PARAM)
#else
# define YYLEX yylex ()
#endif

/* Enable debugging if requested.  */
#if YYDEBUG

# ifndef YYFPRINTF
#  include <stdio.h> /* INFRINGES ON USER NAME SPACE */
#  define YYFPRINTF fprintf
# endif

# define YYDPRINTF(Args)			\
do {						\
  if (yydebug)					\
    YYFPRINTF Args;				\
} while (YYID (0))

# define YY_SYMBOL_PRINT(Title, Type, Value, Location)			  \
do {									  \
  if (yydebug)								  \
    {									  \
      YYFPRINTF (stderr, "%s ", Title);					  \
      yy_symbol_print (stderr,						  \
		  Type, Value, Location); \
      YYFPRINTF (stderr, "\n");						  \
    }									  \
} while (YYID (0))


/*--------------------------------.
| Print this symbol on YYOUTPUT.  |
`--------------------------------*/

/*ARGSUSED*/
#if (defined __STDC__ || defined __C99__FUNC__ \
     || defined __cplusplus || defined _MSC_VER)
static void
yy_symbol_value_print (FILE *yyoutput, int yytype, YYSTYPE const * const yyvaluep, YYLTYPE const * const yylocationp)
#else
static void
yy_symbol_value_print (yyoutput, yytype, yyvaluep, yylocationp)
    FILE *yyoutput;
    int yytype;
    YYSTYPE const * const yyvaluep;
    YYLTYPE const * const yylocationp;
#endif
{
  if (!yyvaluep)
    return;
  YYUSE (yylocationp);
# ifdef YYPRINT
  if (yytype < YYNTOKENS)
    YYPRINT (yyoutput, yytoknum[yytype], *yyvaluep);
# else
  YYUSE (yyoutput);
# endif
  switch (yytype)
    {
      default:
	break;
    }
}


/*--------------------------------.
| Print this symbol on YYOUTPUT.  |
`--------------------------------*/

#if (defined __STDC__ || defined __C99__FUNC__ \
     || defined __cplusplus || defined _MSC_VER)
static void
yy_symbol_print (FILE *yyoutput, int yytype, YYSTYPE const * const yyvaluep, YYLTYPE const * const yylocationp)
#else
static void
yy_symbol_print (yyoutput, yytype, yyvaluep, yylocationp)
    FILE *yyoutput;
    int yytype;
    YYSTYPE const * const yyvaluep;
    YYLTYPE const * const yylocationp;
#endif
{
  if (yytype < YYNTOKENS)
    YYFPRINTF (yyoutput, "token %s (", yytname[yytype]);
  else
    YYFPRINTF (yyoutput, "nterm %s (", yytname[yytype]);

  YY_LOCATION_PRINT (yyoutput, *yylocationp);
  YYFPRINTF (yyoutput, ": ");
  yy_symbol_value_print (yyoutput, yytype, yyvaluep, yylocationp);
  YYFPRINTF (yyoutput, ")");
}

/*------------------------------------------------------------------.
| yy_stack_print -- Print the state stack from its BOTTOM up to its |
| TOP (included).                                                   |
`------------------------------------------------------------------*/

#if (defined __STDC__ || defined __C99__FUNC__ \
     || defined __cplusplus || defined _MSC_VER)
static void
yy_stack_print (yytype_int16 *yybottom, yytype_int16 *yytop)
#else
static void
yy_stack_print (yybottom, yytop)
    yytype_int16 *yybottom;
    yytype_int16 *yytop;
#endif
{
  YYFPRINTF (stderr, "Stack now");
  for (; yybottom <= yytop; yybottom++)
    {
      int yybot = *yybottom;
      YYFPRINTF (stderr, " %d", yybot);
    }
  YYFPRINTF (stderr, "\n");
}

# define YY_STACK_PRINT(Bottom, Top)				\
do {								\
  if (yydebug)							\
    yy_stack_print ((Bottom), (Top));				\
} while (YYID (0))


/*------------------------------------------------.
| Report that the YYRULE is going to be reduced.  |
`------------------------------------------------*/

#if (defined __STDC__ || defined __C99__FUNC__ \
     || defined __cplusplus || defined _MSC_VER)
static void
yy_reduce_print (YYSTYPE *yyvsp, YYLTYPE *yylsp, int yyrule)
#else
static void
yy_reduce_print (yyvsp, yylsp, yyrule)
    YYSTYPE *yyvsp;
    YYLTYPE *yylsp;
    int yyrule;
#endif
{
  int yynrhs = yyr2[yyrule];
  int yyi;
  unsigned long int yylno = yyrline[yyrule];
  YYFPRINTF (stderr, "Reducing stack by rule %d (line %lu):\n",
	     yyrule - 1, yylno);
  /* The symbols being reduced.  */
  for (yyi = 0; yyi < yynrhs; yyi++)
    {
      YYFPRINTF (stderr, "   $%d = ", yyi + 1);
      yy_symbol_print (stderr, yyrhs[yyprhs[yyrule] + yyi],
		       &(yyvsp[(yyi + 1) - (yynrhs)])
		       , &(yylsp[(yyi + 1) - (yynrhs)])		       );
      YYFPRINTF (stderr, "\n");
    }
}

# define YY_REDUCE_PRINT(Rule)		\
do {					\
  if (yydebug)				\
    yy_reduce_print (yyvsp, yylsp, Rule); \
} while (YYID (0))

/* Nonzero means print parse trace.  It is left uninitialized so that
   multiple parsers can coexist.  */
int yydebug;
#else /* !YYDEBUG */
# define YYDPRINTF(Args)
# define YY_SYMBOL_PRINT(Title, Type, Value, Location)
# define YY_STACK_PRINT(Bottom, Top)
# define YY_REDUCE_PRINT(Rule)
#endif /* !YYDEBUG */


/* YYINITDEPTH -- initial size of the parser's stacks.  */
#ifndef	YYINITDEPTH
# define YYINITDEPTH 200
#endif

/* YYMAXDEPTH -- maximum size the stacks can grow to (effective only
   if the built-in stack extension method is used).

   Do not make this value too large; the results are undefined if
   YYSTACK_ALLOC_MAXIMUM < YYSTACK_BYTES (YYMAXDEPTH)
   evaluated with infinite-precision integer arithmetic.  */

#ifndef YYMAXDEPTH
# define YYMAXDEPTH 10000
#endif



#if YYERROR_VERBOSE

# ifndef yystrlen
#  if defined __GLIBC__ && defined _STRING_H
#   define yystrlen strlen
#  else
/* Return the length of YYSTR.  */
#if (defined __STDC__ || defined __C99__FUNC__ \
     || defined __cplusplus || defined _MSC_VER)
static YYSIZE_T
yystrlen (const char *yystr)
#else
static YYSIZE_T
yystrlen (yystr)
    const char *yystr;
#endif
{
  YYSIZE_T yylen;
  for (yylen = 0; yystr[yylen]; yylen++)
    continue;
  return yylen;
}
#  endif
# endif

# ifndef yystpcpy
#  if defined __GLIBC__ && defined _STRING_H && defined _GNU_SOURCE
#   define yystpcpy stpcpy
#  else
/* Copy YYSRC to YYDEST, returning the address of the terminating '\0' in
   YYDEST.  */
#if (defined __STDC__ || defined __C99__FUNC__ \
     || defined __cplusplus || defined _MSC_VER)
static char *
yystpcpy (char *yydest, const char *yysrc)
#else
static char *
yystpcpy (yydest, yysrc)
    char *yydest;
    const char *yysrc;
#endif
{
  char *yyd = yydest;
  const char *yys = yysrc;

  while ((*yyd++ = *yys++) != '\0')
    continue;

  return yyd - 1;
}
#  endif
# endif

# ifndef yytnamerr
/* Copy to YYRES the contents of YYSTR after stripping away unnecessary
   quotes and backslashes, so that it's suitable for yyerror.  The
   heuristic is that double-quoting is unnecessary unless the string
   contains an apostrophe, a comma, or backslash (other than
   backslash-backslash).  YYSTR is taken from yytname.  If YYRES is
   null, do not copy; instead, return the length of what the result
   would have been.  */
static YYSIZE_T
yytnamerr (char *yyres, const char *yystr)
{
  if (*yystr == '"')
    {
      YYSIZE_T yyn = 0;
      char const *yyp = yystr;

      for (;;)
	switch (*++yyp)
	  {
	  case '\'':
	  case ',':
	    goto do_not_strip_quotes;

	  case '\\':
	    if (*++yyp != '\\')
	      goto do_not_strip_quotes;
	    /* Fall through.  */
	  default:
	    if (yyres)
	      yyres[yyn] = *yyp;
	    yyn++;
	    break;

	  case '"':
	    if (yyres)
	      yyres[yyn] = '\0';
	    return yyn;
	  }
    do_not_strip_quotes: ;
    }

  if (! yyres)
    return yystrlen (yystr);

  return yystpcpy (yyres, yystr) - yyres;
}
# endif

/* Copy into YYRESULT an error message about the unexpected token
   YYCHAR while in state YYSTATE.  Return the number of bytes copied,
   including the terminating null byte.  If YYRESULT is null, do not
   copy anything; just return the number of bytes that would be
   copied.  As a special case, return 0 if an ordinary "syntax error"
   message will do.  Return YYSIZE_MAXIMUM if overflow occurs during
   size calculation.  */
static YYSIZE_T
yysyntax_error (char *yyresult, int yystate, int yychar)
{
  int yyn = yypact[yystate];

  if (! (YYPACT_NINF < yyn && yyn <= YYLAST))
    return 0;
  else
    {
      int yytype = YYTRANSLATE (yychar);
      YYSIZE_T yysize0 = yytnamerr (0, yytname[yytype]);
      YYSIZE_T yysize = yysize0;
      YYSIZE_T yysize1;
      int yysize_overflow = 0;
      enum { YYERROR_VERBOSE_ARGS_MAXIMUM = 5 };
      char const *yyarg[YYERROR_VERBOSE_ARGS_MAXIMUM];
      int yyx;

# if 0
      /* This is so xgettext sees the translatable formats that are
	 constructed on the fly.  */
      YY_("syntax error, unexpected %s");
      YY_("syntax error, unexpected %s, expecting %s");
      YY_("syntax error, unexpected %s, expecting %s or %s");
      YY_("syntax error, unexpected %s, expecting %s or %s or %s");
      YY_("syntax error, unexpected %s, expecting %s or %s or %s or %s");
# endif
      char *yyfmt;
      char const *yyf;
      static char const yyunexpected[] = "syntax error, unexpected %s";
      static char const yyexpecting[] = ", expecting %s";
      static char const yyor[] = " or %s";
      char yyformat[sizeof yyunexpected
		    + sizeof yyexpecting - 1
		    + ((YYERROR_VERBOSE_ARGS_MAXIMUM - 2)
		       * (sizeof yyor - 1))];
      char const *yyprefix = yyexpecting;

      /* Start YYX at -YYN if negative to avoid negative indexes in
	 YYCHECK.  */
      int yyxbegin = yyn < 0 ? -yyn : 0;

      /* Stay within bounds of both yycheck and yytname.  */
      int yychecklim = YYLAST - yyn + 1;
      int yyxend = yychecklim < YYNTOKENS ? yychecklim : YYNTOKENS;
      int yycount = 1;

      yyarg[0] = yytname[yytype];
      yyfmt = yystpcpy (yyformat, yyunexpected);

      for (yyx = yyxbegin; yyx < yyxend; ++yyx)
	if (yycheck[yyx + yyn] == yyx && yyx != YYTERROR)
	  {
	    if (yycount == YYERROR_VERBOSE_ARGS_MAXIMUM)
	      {
		yycount = 1;
		yysize = yysize0;
		yyformat[sizeof yyunexpected - 1] = '\0';
		break;
	      }
	    yyarg[yycount++] = yytname[yyx];
	    yysize1 = yysize + yytnamerr (0, yytname[yyx]);
	    yysize_overflow |= (yysize1 < yysize);
	    yysize = yysize1;
	    yyfmt = yystpcpy (yyfmt, yyprefix);
	    yyprefix = yyor;
	  }

      yyf = YY_(yyformat);
      yysize1 = yysize + yystrlen (yyf);
      yysize_overflow |= (yysize1 < yysize);
      yysize = yysize1;

      if (yysize_overflow)
	return YYSIZE_MAXIMUM;

      if (yyresult)
	{
	  /* Avoid sprintf, as that infringes on the user's name space.
	     Don't have undefined behavior even if the translation
	     produced a string with the wrong number of "%s"s.  */
	  char *yyp = yyresult;
	  int yyi = 0;
	  while ((*yyp = *yyf) != '\0')
	    {
	      if (*yyp == '%' && yyf[1] == 's' && yyi < yycount)
		{
		  yyp += yytnamerr (yyp, yyarg[yyi++]);
		  yyf += 2;
		}
	      else
		{
		  yyp++;
		  yyf++;
		}
	    }
	}
      return yysize;
    }
}
#endif /* YYERROR_VERBOSE */


/*-----------------------------------------------.
| Release the memory associated to this symbol.  |
`-----------------------------------------------*/

/*ARGSUSED*/
#if (defined __STDC__ || defined __C99__FUNC__ \
     || defined __cplusplus || defined _MSC_VER)
static void
yydestruct (const char *yymsg, int yytype, YYSTYPE *yyvaluep, YYLTYPE *yylocationp)
#else
static void
yydestruct (yymsg, yytype, yyvaluep, yylocationp)
    const char *yymsg;
    int yytype;
    YYSTYPE *yyvaluep;
    YYLTYPE *yylocationp;
#endif
{
  YYUSE (yyvaluep);
  YYUSE (yylocationp);

  if (!yymsg)
    yymsg = "Deleting";
  YY_SYMBOL_PRINT (yymsg, yytype, yyvaluep, yylocationp);

  switch (yytype)
    {

      default:
	break;
    }
}

/* Prevent warnings from -Wmissing-prototypes.  */
#ifdef YYPARSE_PARAM
#if defined __STDC__ || defined __cplusplus
int yyparse (void *YYPARSE_PARAM);
#else
int yyparse ();
#endif
#else /* ! YYPARSE_PARAM */
#if defined __STDC__ || defined __cplusplus
int yyparse (void);
#else
int yyparse ();
#endif
#endif /* ! YYPARSE_PARAM */


/* The lookahead symbol.  */
int yychar;

/* The semantic value of the lookahead symbol.  */
YYSTYPE yylval;

/* Location data for the lookahead symbol.  */
YYLTYPE yylloc;

/* Number of syntax errors so far.  */
int yynerrs;



/*-------------------------.
| yyparse or yypush_parse.  |
`-------------------------*/

#ifdef YYPARSE_PARAM
#if (defined __STDC__ || defined __C99__FUNC__ \
     || defined __cplusplus || defined _MSC_VER)
int
yyparse (void *YYPARSE_PARAM)
#else
int
yyparse (YYPARSE_PARAM)
    void *YYPARSE_PARAM;
#endif
#else /* ! YYPARSE_PARAM */
#if (defined __STDC__ || defined __C99__FUNC__ \
     || defined __cplusplus || defined _MSC_VER)
int
yyparse (void)
#else
int
yyparse ()

#endif
#endif
{


    int yystate;
    /* Number of tokens to shift before error messages enabled.  */
    int yyerrstatus;

    /* The stacks and their tools:
       `yyss': related to states.
       `yyvs': related to semantic values.
       `yyls': related to locations.

       Refer to the stacks thru separate pointers, to allow yyoverflow
       to reallocate them elsewhere.  */

    /* The state stack.  */
    yytype_int16 yyssa[YYINITDEPTH];
    yytype_int16 *yyss;
    yytype_int16 *yyssp;

    /* The semantic value stack.  */
    YYSTYPE yyvsa[YYINITDEPTH];
    YYSTYPE *yyvs;
    YYSTYPE *yyvsp;

    /* The location stack.  */
    YYLTYPE yylsa[YYINITDEPTH];
    YYLTYPE *yyls;
    YYLTYPE *yylsp;

    /* The locations where the error started and ended.  */
    YYLTYPE yyerror_range[2];

    YYSIZE_T yystacksize;

  int yyn;
  int yyresult;
  /* Lookahead token as an internal (translated) token number.  */
  int yytoken;
  /* The variables used to return semantic value and location from the
     action routines.  */
  YYSTYPE yyval;
  YYLTYPE yyloc;

#if YYERROR_VERBOSE
  /* Buffer for error messages, and its allocated size.  */
  char yymsgbuf[128];
  char *yymsg = yymsgbuf;
  YYSIZE_T yymsg_alloc = sizeof yymsgbuf;
#endif

#define YYPOPSTACK(N)   (yyvsp -= (N), yyssp -= (N), yylsp -= (N))

  /* The number of symbols on the RHS of the reduced rule.
     Keep to zero when no symbol should be popped.  */
  int yylen = 0;

  yytoken = 0;
  yyss = yyssa;
  yyvs = yyvsa;
  yyls = yylsa;
  yystacksize = YYINITDEPTH;

  YYDPRINTF ((stderr, "Starting parse\n"));

  yystate = 0;
  yyerrstatus = 0;
  yynerrs = 0;
  yychar = YYEMPTY; /* Cause a token to be read.  */

  /* Initialize stack pointers.
     Waste one element of value and location stack
     so that they stay on the same level as the state stack.
     The wasted elements are never initialized.  */
  yyssp = yyss;
  yyvsp = yyvs;
  yylsp = yyls;

#if YYLTYPE_IS_TRIVIAL
  /* Initialize the default location before parsing starts.  */
  yylloc.first_line   = yylloc.last_line   = 1;
  yylloc.first_column = yylloc.last_column = 1;
#endif

  goto yysetstate;

/*------------------------------------------------------------.
| yynewstate -- Push a new state, which is found in yystate.  |
`------------------------------------------------------------*/
 yynewstate:
  /* In all cases, when you get here, the value and location stacks
     have just been pushed.  So pushing a state here evens the stacks.  */
  yyssp++;

 yysetstate:
  *yyssp = yystate;

  if (yyss + yystacksize - 1 <= yyssp)
    {
      /* Get the current used size of the three stacks, in elements.  */
      YYSIZE_T yysize = yyssp - yyss + 1;

#ifdef yyoverflow
      {
	/* Give user a chance to reallocate the stack.  Use copies of
	   these so that the &'s don't force the real ones into
	   memory.  */
	YYSTYPE *yyvs1 = yyvs;
	yytype_int16 *yyss1 = yyss;
	YYLTYPE *yyls1 = yyls;

	/* Each stack pointer address is followed by the size of the
	   data in use in that stack, in bytes.  This used to be a
	   conditional around just the two extra args, but that might
	   be undefined if yyoverflow is a macro.  */
	yyoverflow (YY_("memory exhausted"),
		    &yyss1, yysize * sizeof (*yyssp),
		    &yyvs1, yysize * sizeof (*yyvsp),
		    &yyls1, yysize * sizeof (*yylsp),
		    &yystacksize);

	yyls = yyls1;
	yyss = yyss1;
	yyvs = yyvs1;
      }
#else /* no yyoverflow */
# ifndef YYSTACK_RELOCATE
      goto yyexhaustedlab;
# else
      /* Extend the stack our own way.  */
      if (YYMAXDEPTH <= yystacksize)
	goto yyexhaustedlab;
      yystacksize *= 2;
      if (YYMAXDEPTH < yystacksize)
	yystacksize = YYMAXDEPTH;

      {
	yytype_int16 *yyss1 = yyss;
	union yyalloc *yyptr =
	  (union yyalloc *) YYSTACK_ALLOC (YYSTACK_BYTES (yystacksize));
	if (! yyptr)
	  goto yyexhaustedlab;
	YYSTACK_RELOCATE (yyss_alloc, yyss);
	YYSTACK_RELOCATE (yyvs_alloc, yyvs);
	YYSTACK_RELOCATE (yyls_alloc, yyls);
#  undef YYSTACK_RELOCATE
	if (yyss1 != yyssa)
	  YYSTACK_FREE (yyss1);
      }
# endif
#endif /* no yyoverflow */

      yyssp = yyss + yysize - 1;
      yyvsp = yyvs + yysize - 1;
      yylsp = yyls + yysize - 1;

      YYDPRINTF ((stderr, "Stack size increased to %lu\n",
		  (unsigned long int) yystacksize));

      if (yyss + yystacksize - 1 <= yyssp)
	YYABORT;
    }

  YYDPRINTF ((stderr, "Entering state %d\n", yystate));

  if (yystate == YYFINAL)
    YYACCEPT;

  goto yybackup;

/*-----------.
| yybackup.  |
`-----------*/
yybackup:

  /* Do appropriate processing given the current state.  Read a
     lookahead token if we need one and don't already have one.  */

  /* First try to decide what to do without reference to lookahead token.  */
  yyn = yypact[yystate];
  if (yyn == YYPACT_NINF)
    goto yydefault;

  /* Not known => get a lookahead token if don't already have one.  */

  /* YYCHAR is either YYEMPTY or YYEOF or a valid lookahead symbol.  */
  if (yychar == YYEMPTY)
    {
      YYDPRINTF ((stderr, "Reading a token: "));
      yychar = YYLEX;
    }

  if (yychar <= YYEOF)
    {
      yychar = yytoken = YYEOF;
      YYDPRINTF ((stderr, "Now at end of input.\n"));
    }
  else
    {
      yytoken = YYTRANSLATE (yychar);
      YY_SYMBOL_PRINT ("Next token is", yytoken, &yylval, &yylloc);
    }

  /* If the proper action on seeing token YYTOKEN is to reduce or to
     detect an error, take that action.  */
  yyn += yytoken;
  if (yyn < 0 || YYLAST < yyn || yycheck[yyn] != yytoken)
    goto yydefault;
  yyn = yytable[yyn];
  if (yyn <= 0)
    {
      if (yyn == 0 || yyn == YYTABLE_NINF)
	goto yyerrlab;
      yyn = -yyn;
      goto yyreduce;
    }

  /* Count tokens shifted since error; after three, turn off error
     status.  */
  if (yyerrstatus)
    yyerrstatus--;

  /* Shift the lookahead token.  */
  YY_SYMBOL_PRINT ("Shifting", yytoken, &yylval, &yylloc);

  /* Discard the shifted token.  */
  yychar = YYEMPTY;

  yystate = yyn;
  *++yyvsp = yylval;
  *++yylsp = yylloc;
  goto yynewstate;


/*-----------------------------------------------------------.
| yydefault -- do the default action for the current state.  |
`-----------------------------------------------------------*/
yydefault:
  yyn = yydefact[yystate];
  if (yyn == 0)
    goto yyerrlab;
  goto yyreduce;


/*-----------------------------.
| yyreduce -- Do a reduction.  |
`-----------------------------*/
yyreduce:
  /* yyn is the number of a rule to reduce with.  */
  yylen = yyr2[yyn];

  /* If YYLEN is nonzero, implement the default value of the action:
     `$$ = $1'.

     Otherwise, the following line sets YYVAL to garbage.
     This behavior is undocumented and Bison
     users should not rely upon it.  Assigning to YYVAL
     unconditionally makes the parser a bit smaller, and it avoids a
     GCC warning that YYVAL may be used uninitialized.  */
  yyval = yyvsp[1-yylen];

  /* Default location.  */
  YYLLOC_DEFAULT (yyloc, (yylsp - yylen), yylen);
  YY_REDUCE_PRINT (yyn);
  switch (yyn)
    {
        case 2:

/* Line 1455 of yacc.c  */
#line 510 "gram.y"
    { parsetree = (yyvsp[(1) - (1)].list); ;}
    break;

  case 3:

/* Line 1455 of yacc.c  */
#line 515 "gram.y"
    { if ((yyvsp[(3) - (3)].node) != NULL)
					(yyval.list) = lappend((yyvsp[(1) - (3)].list), (yyvsp[(3) - (3)].node));
				  else
					(yyval.list) = (yyvsp[(1) - (3)].list);
				;}
    break;

  case 4:

/* Line 1455 of yacc.c  */
#line 521 "gram.y"
    { if ((yyvsp[(1) - (1)].node) != NULL)
						(yyval.list) = list_make1((yyvsp[(1) - (1)].node));
					  else
						(yyval.list) = NIL;
					;}
    break;

  case 90:

/* Line 1455 of yacc.c  */
#line 615 "gram.y"
    { (yyval.node) = NULL; ;}
    break;

  case 91:

/* Line 1455 of yacc.c  */
#line 626 "gram.y"
    {
					CreateRoleStmt *n = makeNode(CreateRoleStmt);
					n->stmt_type = ROLESTMT_ROLE;
					n->role = (yyvsp[(3) - (5)].str);
					n->options = (yyvsp[(5) - (5)].list);
					(yyval.node) = (Node *)n;
				;}
    break;

  case 92:

/* Line 1455 of yacc.c  */
#line 636 "gram.y"
    {;}
    break;

  case 93:

/* Line 1455 of yacc.c  */
#line 637 "gram.y"
    {;}
    break;

  case 94:

/* Line 1455 of yacc.c  */
#line 646 "gram.y"
    { (yyval.list) = lappend((yyvsp[(1) - (2)].list), (yyvsp[(2) - (2)].defelt)); ;}
    break;

  case 95:

/* Line 1455 of yacc.c  */
#line 647 "gram.y"
    { (yyval.list) = NIL; ;}
    break;

  case 96:

/* Line 1455 of yacc.c  */
#line 652 "gram.y"
    {
					(yyval.defelt) = makeDefElem("password",
									 (Node *)makeString((yyvsp[(2) - (2)].str)));
				;}
    break;

  case 97:

/* Line 1455 of yacc.c  */
#line 657 "gram.y"
    {
					(yyval.defelt) = makeDefElem("password", NULL);
				;}
    break;

  case 98:

/* Line 1455 of yacc.c  */
#line 661 "gram.y"
    {
					(yyval.defelt) = makeDefElem("encryptedPassword",
									 (Node *)makeString((yyvsp[(3) - (3)].str)));
				;}
    break;

  case 99:

/* Line 1455 of yacc.c  */
#line 666 "gram.y"
    {
					(yyval.defelt) = makeDefElem("unencryptedPassword",
									 (Node *)makeString((yyvsp[(3) - (3)].str)));
				;}
    break;

  case 100:

/* Line 1455 of yacc.c  */
#line 671 "gram.y"
    {
					(yyval.defelt) = makeDefElem("superuser", (Node *)makeInteger(TRUE));
				;}
    break;

  case 101:

/* Line 1455 of yacc.c  */
#line 675 "gram.y"
    {
					(yyval.defelt) = makeDefElem("superuser", (Node *)makeInteger(FALSE));
				;}
    break;

  case 102:

/* Line 1455 of yacc.c  */
#line 679 "gram.y"
    {
					(yyval.defelt) = makeDefElem("inherit", (Node *)makeInteger(TRUE));
				;}
    break;

  case 103:

/* Line 1455 of yacc.c  */
#line 683 "gram.y"
    {
					(yyval.defelt) = makeDefElem("inherit", (Node *)makeInteger(FALSE));
				;}
    break;

  case 104:

/* Line 1455 of yacc.c  */
#line 687 "gram.y"
    {
					(yyval.defelt) = makeDefElem("createdb", (Node *)makeInteger(TRUE));
				;}
    break;

  case 105:

/* Line 1455 of yacc.c  */
#line 691 "gram.y"
    {
					(yyval.defelt) = makeDefElem("createdb", (Node *)makeInteger(FALSE));
				;}
    break;

  case 106:

/* Line 1455 of yacc.c  */
#line 695 "gram.y"
    {
					(yyval.defelt) = makeDefElem("createrole", (Node *)makeInteger(TRUE));
				;}
    break;

  case 107:

/* Line 1455 of yacc.c  */
#line 699 "gram.y"
    {
					(yyval.defelt) = makeDefElem("createrole", (Node *)makeInteger(FALSE));
				;}
    break;

  case 108:

/* Line 1455 of yacc.c  */
#line 703 "gram.y"
    {
					/* For backwards compatibility, synonym for SUPERUSER */
					(yyval.defelt) = makeDefElem("superuser", (Node *)makeInteger(TRUE));
				;}
    break;

  case 109:

/* Line 1455 of yacc.c  */
#line 708 "gram.y"
    {
					(yyval.defelt) = makeDefElem("superuser", (Node *)makeInteger(FALSE));
				;}
    break;

  case 110:

/* Line 1455 of yacc.c  */
#line 712 "gram.y"
    {
					(yyval.defelt) = makeDefElem("canlogin", (Node *)makeInteger(TRUE));
				;}
    break;

  case 111:

/* Line 1455 of yacc.c  */
#line 716 "gram.y"
    {
					(yyval.defelt) = makeDefElem("canlogin", (Node *)makeInteger(FALSE));
				;}
    break;

  case 112:

/* Line 1455 of yacc.c  */
#line 720 "gram.y"
    {
					(yyval.defelt) = makeDefElem("connectionlimit", (Node *)makeInteger((yyvsp[(3) - (3)].ival)));
				;}
    break;

  case 113:

/* Line 1455 of yacc.c  */
#line 724 "gram.y"
    {
					(yyval.defelt) = makeDefElem("validUntil", (Node *)makeString((yyvsp[(3) - (3)].str)));
				;}
    break;

  case 114:

/* Line 1455 of yacc.c  */
#line 729 "gram.y"
    {
					(yyval.defelt) = makeDefElem("rolemembers", (Node *)(yyvsp[(2) - (2)].list));
				;}
    break;

  case 115:

/* Line 1455 of yacc.c  */
#line 734 "gram.y"
    {
					(yyval.defelt) = makeDefElem("sysid", (Node *)makeInteger((yyvsp[(2) - (2)].ival)));
				;}
    break;

  case 116:

/* Line 1455 of yacc.c  */
#line 738 "gram.y"
    {
					(yyval.defelt) = makeDefElem("adminmembers", (Node *)(yyvsp[(2) - (2)].list));
				;}
    break;

  case 117:

/* Line 1455 of yacc.c  */
#line 742 "gram.y"
    {
					(yyval.defelt) = makeDefElem("rolemembers", (Node *)(yyvsp[(2) - (2)].list));
				;}
    break;

  case 118:

/* Line 1455 of yacc.c  */
#line 746 "gram.y"
    {
					(yyval.defelt) = makeDefElem("addroleto", (Node *)(yyvsp[(3) - (3)].list));
				;}
    break;

  case 119:

/* Line 1455 of yacc.c  */
#line 750 "gram.y"
    {
					(yyval.defelt) = makeDefElem("addroleto", (Node *)(yyvsp[(3) - (3)].list));
				;}
    break;

  case 120:

/* Line 1455 of yacc.c  */
#line 764 "gram.y"
    {
					CreateRoleStmt *n = makeNode(CreateRoleStmt);
					n->stmt_type = ROLESTMT_USER;
					n->role = (yyvsp[(3) - (5)].str);
					n->options = (yyvsp[(5) - (5)].list);
					(yyval.node) = (Node *)n;
				;}
    break;

  case 121:

/* Line 1455 of yacc.c  */
#line 782 "gram.y"
    {
					AlterRoleStmt *n = makeNode(AlterRoleStmt);
					n->role = (yyvsp[(3) - (5)].str);
					n->action = +1;	/* add, if there are members */
					n->options = (yyvsp[(5) - (5)].list);
					(yyval.node) = (Node *)n;
				 ;}
    break;

  case 122:

/* Line 1455 of yacc.c  */
#line 793 "gram.y"
    {
					AlterRoleSetStmt *n = makeNode(AlterRoleSetStmt);
					n->role = (yyvsp[(3) - (5)].str);
					n->variable = (yyvsp[(5) - (5)].vsetstmt)->name;
					n->value = (yyvsp[(5) - (5)].vsetstmt)->args;
					(yyval.node) = (Node *)n;
				;}
    break;

  case 123:

/* Line 1455 of yacc.c  */
#line 801 "gram.y"
    {
					AlterRoleSetStmt *n = makeNode(AlterRoleSetStmt);
					n->role = (yyvsp[(3) - (4)].str);
					n->variable = ((VariableResetStmt *)(yyvsp[(4) - (4)].node))->name;
					n->value = NIL;
					(yyval.node) = (Node *)n;
				;}
    break;

  case 124:

/* Line 1455 of yacc.c  */
#line 819 "gram.y"
    {
					AlterRoleStmt *n = makeNode(AlterRoleStmt);
					n->role = (yyvsp[(3) - (5)].str);
					n->action = +1;	/* add, if there are members */
					n->options = (yyvsp[(5) - (5)].list);
					(yyval.node) = (Node *)n;
				 ;}
    break;

  case 125:

/* Line 1455 of yacc.c  */
#line 831 "gram.y"
    {
					AlterRoleSetStmt *n = makeNode(AlterRoleSetStmt);
					n->role = (yyvsp[(3) - (5)].str);
					n->variable = (yyvsp[(5) - (5)].vsetstmt)->name;
					n->value = (yyvsp[(5) - (5)].vsetstmt)->args;
					(yyval.node) = (Node *)n;
				;}
    break;

  case 126:

/* Line 1455 of yacc.c  */
#line 839 "gram.y"
    {
					AlterRoleSetStmt *n = makeNode(AlterRoleSetStmt);
					n->role = (yyvsp[(3) - (4)].str);
					n->variable = ((VariableResetStmt *)(yyvsp[(4) - (4)].node))->name;
					n->value = NIL;
					(yyval.node) = (Node *)n;
				;}
    break;

  case 127:

/* Line 1455 of yacc.c  */
#line 860 "gram.y"
    {
					DropRoleStmt *n = makeNode(DropRoleStmt);
					n->missing_ok = FALSE;
					n->roles = (yyvsp[(3) - (3)].list);
					(yyval.node) = (Node *)n;
				;}
    break;

  case 128:

/* Line 1455 of yacc.c  */
#line 867 "gram.y"
    {
					DropRoleStmt *n = makeNode(DropRoleStmt);
					n->missing_ok = TRUE;
					n->roles = (yyvsp[(5) - (5)].list);
					(yyval.node) = (Node *)n;
				;}
    break;

  case 129:

/* Line 1455 of yacc.c  */
#line 886 "gram.y"
    {
					DropRoleStmt *n = makeNode(DropRoleStmt);
					n->missing_ok = FALSE;
					n->roles = (yyvsp[(3) - (3)].list);
					(yyval.node) = (Node *)n;
				;}
    break;

  case 130:

/* Line 1455 of yacc.c  */
#line 893 "gram.y"
    {
					DropRoleStmt *n = makeNode(DropRoleStmt);
					n->roles = (yyvsp[(5) - (5)].list);
					n->missing_ok = TRUE;
					(yyval.node) = (Node *)n;
				;}
    break;

  case 131:

/* Line 1455 of yacc.c  */
#line 910 "gram.y"
    {
					CreateRoleStmt *n = makeNode(CreateRoleStmt);
					n->stmt_type = ROLESTMT_GROUP;
					n->role = (yyvsp[(3) - (5)].str);
					n->options = (yyvsp[(5) - (5)].list);
					(yyval.node) = (Node *)n;
				;}
    break;

  case 132:

/* Line 1455 of yacc.c  */
#line 928 "gram.y"
    {
					AlterRoleStmt *n = makeNode(AlterRoleStmt);
					n->role = (yyvsp[(3) - (6)].str);
					n->action = (yyvsp[(4) - (6)].ival);
					n->options = list_make1(makeDefElem("rolemembers",
														(Node *)(yyvsp[(6) - (6)].list)));
					(yyval.node) = (Node *)n;
				;}
    break;

  case 133:

/* Line 1455 of yacc.c  */
#line 938 "gram.y"
    { (yyval.ival) = +1; ;}
    break;

  case 134:

/* Line 1455 of yacc.c  */
#line 939 "gram.y"
    { (yyval.ival) = -1; ;}
    break;

  case 135:

/* Line 1455 of yacc.c  */
#line 952 "gram.y"
    {
					DropRoleStmt *n = makeNode(DropRoleStmt);
					n->missing_ok = FALSE;
					n->roles = (yyvsp[(3) - (3)].list);
					(yyval.node) = (Node *)n;
				;}
    break;

  case 136:

/* Line 1455 of yacc.c  */
#line 959 "gram.y"
    {
					DropRoleStmt *n = makeNode(DropRoleStmt);
					n->missing_ok = TRUE;
					n->roles = (yyvsp[(5) - (5)].list);
					(yyval.node) = (Node *)n;
				;}
    break;

  case 137:

/* Line 1455 of yacc.c  */
#line 976 "gram.y"
    {
					CreateSchemaStmt *n = makeNode(CreateSchemaStmt);
					/* One can omit the schema name or the authorization id. */
					if ((yyvsp[(3) - (6)].str) != NULL)
						n->schemaname = (yyvsp[(3) - (6)].str);
					else
						n->schemaname = (yyvsp[(5) - (6)].str);
					n->authid = (yyvsp[(5) - (6)].str);
					n->schemaElts = (yyvsp[(6) - (6)].list);
					(yyval.node) = (Node *)n;
				;}
    break;

  case 138:

/* Line 1455 of yacc.c  */
#line 988 "gram.y"
    {
					CreateSchemaStmt *n = makeNode(CreateSchemaStmt);
					/* ...but not both */
					n->schemaname = (yyvsp[(3) - (4)].str);
					n->authid = NULL;
					n->schemaElts = (yyvsp[(4) - (4)].list);
					(yyval.node) = (Node *)n;
				;}
    break;

  case 139:

/* Line 1455 of yacc.c  */
#line 999 "gram.y"
    { (yyval.str) = (yyvsp[(1) - (1)].str); ;}
    break;

  case 140:

/* Line 1455 of yacc.c  */
#line 1000 "gram.y"
    { (yyval.str) = NULL; ;}
    break;

  case 141:

/* Line 1455 of yacc.c  */
#line 1004 "gram.y"
    { (yyval.list) = lappend((yyvsp[(1) - (2)].list), (yyvsp[(2) - (2)].node)); ;}
    break;

  case 142:

/* Line 1455 of yacc.c  */
#line 1005 "gram.y"
    { (yyval.list) = NIL; ;}
    break;

  case 149:

/* Line 1455 of yacc.c  */
#line 1033 "gram.y"
    {
					VariableSetStmt *n = (yyvsp[(2) - (2)].vsetstmt);
					n->is_local = false;
					(yyval.node) = (Node *) n;
				;}
    break;

  case 150:

/* Line 1455 of yacc.c  */
#line 1039 "gram.y"
    {
					VariableSetStmt *n = (yyvsp[(3) - (3)].vsetstmt);
					n->is_local = true;
					(yyval.node) = (Node *) n;
				;}
    break;

  case 151:

/* Line 1455 of yacc.c  */
#line 1045 "gram.y"
    {
					VariableSetStmt *n = (yyvsp[(3) - (3)].vsetstmt);
					n->is_local = false;
					(yyval.node) = (Node *) n;
				;}
    break;

  case 152:

/* Line 1455 of yacc.c  */
#line 1053 "gram.y"
    {
					VariableSetStmt *n = makeNode(VariableSetStmt);
					n->name = (yyvsp[(1) - (3)].str);
					n->args = (yyvsp[(3) - (3)].list);
					(yyval.vsetstmt) = n;
				;}
    break;

  case 153:

/* Line 1455 of yacc.c  */
#line 1060 "gram.y"
    {
					VariableSetStmt *n = makeNode(VariableSetStmt);
					n->name = (yyvsp[(1) - (3)].str);
					n->args = (yyvsp[(3) - (3)].list);
					(yyval.vsetstmt) = n;
				;}
    break;

  case 154:

/* Line 1455 of yacc.c  */
#line 1067 "gram.y"
    {
					VariableSetStmt *n = makeNode(VariableSetStmt);
					n->name = "timezone";
					if ((yyvsp[(3) - (3)].node) != NULL)
						n->args = list_make1((yyvsp[(3) - (3)].node));
					(yyval.vsetstmt) = n;
				;}
    break;

  case 155:

/* Line 1455 of yacc.c  */
#line 1075 "gram.y"
    {
					VariableSetStmt *n = makeNode(VariableSetStmt);
					n->name = "TRANSACTION";
					n->args = (yyvsp[(2) - (2)].list);
					(yyval.vsetstmt) = n;
				;}
    break;

  case 156:

/* Line 1455 of yacc.c  */
#line 1082 "gram.y"
    {
					VariableSetStmt *n = makeNode(VariableSetStmt);
					n->name = "SESSION CHARACTERISTICS";
					n->args = (yyvsp[(5) - (5)].list);
					(yyval.vsetstmt) = n;
				;}
    break;

  case 157:

/* Line 1455 of yacc.c  */
#line 1089 "gram.y"
    {
					VariableSetStmt *n = makeNode(VariableSetStmt);
					n->name = "client_encoding";
					if ((yyvsp[(2) - (2)].str) != NULL)
						n->args = list_make1(makeStringConst((yyvsp[(2) - (2)].str), NULL));
					(yyval.vsetstmt) = n;
				;}
    break;

  case 158:

/* Line 1455 of yacc.c  */
#line 1097 "gram.y"
    {
					VariableSetStmt *n = makeNode(VariableSetStmt);
					n->name = "role";
					n->args = list_make1(makeStringConst((yyvsp[(2) - (2)].str), NULL));
					(yyval.vsetstmt) = n;
				;}
    break;

  case 159:

/* Line 1455 of yacc.c  */
#line 1104 "gram.y"
    {
					VariableSetStmt *n = makeNode(VariableSetStmt);
					n->name = "session_authorization";
					n->args = list_make1(makeStringConst((yyvsp[(3) - (3)].str), NULL));
					(yyval.vsetstmt) = n;
				;}
    break;

  case 160:

/* Line 1455 of yacc.c  */
#line 1111 "gram.y"
    {
					VariableSetStmt *n = makeNode(VariableSetStmt);
					n->name = "session_authorization";
					n->args = NIL;
					(yyval.vsetstmt) = n;
				;}
    break;

  case 161:

/* Line 1455 of yacc.c  */
#line 1120 "gram.y"
    { (yyval.str) = (yyvsp[(1) - (1)].str); ;}
    break;

  case 162:

/* Line 1455 of yacc.c  */
#line 1122 "gram.y"
    {
					int qLen = strlen((yyvsp[(1) - (3)].str));
					char* qualName = palloc(qLen + strlen((yyvsp[(3) - (3)].str)) + 2);
					strcpy(qualName, (yyvsp[(1) - (3)].str));
					qualName[qLen] = '.';
					strcpy(qualName + qLen + 1, (yyvsp[(3) - (3)].str));
					(yyval.str) = qualName;
				;}
    break;

  case 163:

/* Line 1455 of yacc.c  */
#line 1133 "gram.y"
    { (yyval.list) = (yyvsp[(1) - (1)].list); ;}
    break;

  case 164:

/* Line 1455 of yacc.c  */
#line 1134 "gram.y"
    { (yyval.list) = NIL; ;}
    break;

  case 165:

/* Line 1455 of yacc.c  */
#line 1137 "gram.y"
    { (yyval.list) = list_make1((yyvsp[(1) - (1)].node)); ;}
    break;

  case 166:

/* Line 1455 of yacc.c  */
#line 1138 "gram.y"
    { (yyval.list) = lappend((yyvsp[(1) - (3)].list), (yyvsp[(3) - (3)].node)); ;}
    break;

  case 167:

/* Line 1455 of yacc.c  */
#line 1142 "gram.y"
    { (yyval.node) = makeStringConst((yyvsp[(1) - (1)].str), NULL); ;}
    break;

  case 168:

/* Line 1455 of yacc.c  */
#line 1144 "gram.y"
    { (yyval.node) = makeStringConst((yyvsp[(1) - (1)].str), NULL); ;}
    break;

  case 169:

/* Line 1455 of yacc.c  */
#line 1146 "gram.y"
    { (yyval.node) = makeAConst((yyvsp[(1) - (1)].value)); ;}
    break;

  case 170:

/* Line 1455 of yacc.c  */
#line 1149 "gram.y"
    { (yyval.str) = "read uncommitted"; ;}
    break;

  case 171:

/* Line 1455 of yacc.c  */
#line 1150 "gram.y"
    { (yyval.str) = "read committed"; ;}
    break;

  case 172:

/* Line 1455 of yacc.c  */
#line 1151 "gram.y"
    { (yyval.str) = "repeatable read"; ;}
    break;

  case 173:

/* Line 1455 of yacc.c  */
#line 1152 "gram.y"
    { (yyval.str) = "serializable"; ;}
    break;

  case 174:

/* Line 1455 of yacc.c  */
#line 1156 "gram.y"
    { (yyval.str) = "true"; ;}
    break;

  case 175:

/* Line 1455 of yacc.c  */
#line 1157 "gram.y"
    { (yyval.str) = "false"; ;}
    break;

  case 176:

/* Line 1455 of yacc.c  */
#line 1158 "gram.y"
    { (yyval.str) = "on"; ;}
    break;

  case 177:

/* Line 1455 of yacc.c  */
#line 1159 "gram.y"
    { (yyval.str) = "off"; ;}
    break;

  case 178:

/* Line 1455 of yacc.c  */
#line 1172 "gram.y"
    {
					(yyval.node) = makeStringConst((yyvsp[(1) - (1)].str), NULL);
				;}
    break;

  case 179:

/* Line 1455 of yacc.c  */
#line 1176 "gram.y"
    {
					(yyval.node) = makeStringConst((yyvsp[(1) - (1)].str), NULL);
				;}
    break;

  case 180:

/* Line 1455 of yacc.c  */
#line 1180 "gram.y"
    {
					A_Const *n = (A_Const *) makeStringConst((yyvsp[(2) - (3)].str), (yyvsp[(1) - (3)].typnam));
					if ((yyvsp[(3) - (3)].ival) != INTERVAL_FULL_RANGE)
					{
						if (((yyvsp[(3) - (3)].ival) & ~(INTERVAL_MASK(HOUR) | INTERVAL_MASK(MINUTE))) != 0)
							ereport(ERROR,
									(errcode(ERRCODE_SYNTAX_ERROR),
									 errmsg("time zone interval must be HOUR or HOUR TO MINUTE")));
						n->typename->typmod = INTERVAL_TYPMOD(INTERVAL_FULL_PRECISION, (yyvsp[(3) - (3)].ival));
					}
					(yyval.node) = (Node *)n;
				;}
    break;

  case 181:

/* Line 1455 of yacc.c  */
#line 1193 "gram.y"
    {
					A_Const *n = (A_Const *) makeStringConst((yyvsp[(5) - (6)].str), (yyvsp[(1) - (6)].typnam));
					if ((yyvsp[(3) - (6)].ival) < 0)
						ereport(ERROR,
								(errcode(ERRCODE_INVALID_PARAMETER_VALUE),
								 errmsg("INTERVAL(%d) precision must not be negative",
										(yyvsp[(3) - (6)].ival))));
					if ((yyvsp[(3) - (6)].ival) > MAX_INTERVAL_PRECISION)
					{
						ereport(WARNING,
								(errcode(ERRCODE_INVALID_PARAMETER_VALUE),
								 errmsg("INTERVAL(%d) precision reduced to maximum allowed, %d",
										(yyvsp[(3) - (6)].ival), MAX_INTERVAL_PRECISION)));
						(yyvsp[(3) - (6)].ival) = MAX_INTERVAL_PRECISION;
					}

					if (((yyvsp[(6) - (6)].ival) != INTERVAL_FULL_RANGE)
						&& (((yyvsp[(6) - (6)].ival) & ~(INTERVAL_MASK(HOUR) | INTERVAL_MASK(MINUTE))) != 0))
						ereport(ERROR,
								(errcode(ERRCODE_SYNTAX_ERROR),
								 errmsg("time zone interval must be HOUR or HOUR TO MINUTE")));

					n->typename->typmod = INTERVAL_TYPMOD((yyvsp[(3) - (6)].ival), (yyvsp[(6) - (6)].ival));

					(yyval.node) = (Node *)n;
				;}
    break;

  case 182:

/* Line 1455 of yacc.c  */
#line 1219 "gram.y"
    { (yyval.node) = makeAConst((yyvsp[(1) - (1)].value)); ;}
    break;

  case 183:

/* Line 1455 of yacc.c  */
#line 1220 "gram.y"
    { (yyval.node) = NULL; ;}
    break;

  case 184:

/* Line 1455 of yacc.c  */
#line 1221 "gram.y"
    { (yyval.node) = NULL; ;}
    break;

  case 185:

/* Line 1455 of yacc.c  */
#line 1225 "gram.y"
    { (yyval.str) = (yyvsp[(1) - (1)].str); ;}
    break;

  case 186:

/* Line 1455 of yacc.c  */
#line 1226 "gram.y"
    { (yyval.str) = NULL; ;}
    break;

  case 187:

/* Line 1455 of yacc.c  */
#line 1227 "gram.y"
    { (yyval.str) = NULL; ;}
    break;

  case 188:

/* Line 1455 of yacc.c  */
#line 1231 "gram.y"
    { (yyval.str) = (yyvsp[(1) - (1)].str); ;}
    break;

  case 189:

/* Line 1455 of yacc.c  */
#line 1232 "gram.y"
    { (yyval.str) = (yyvsp[(1) - (1)].str); ;}
    break;

  case 190:

/* Line 1455 of yacc.c  */
#line 1238 "gram.y"
    {
					VariableShowStmt *n = makeNode(VariableShowStmt);
					n->name = (yyvsp[(2) - (2)].str);
					(yyval.node) = (Node *) n;
				;}
    break;

  case 191:

/* Line 1455 of yacc.c  */
#line 1244 "gram.y"
    {
					VariableShowStmt *n = makeNode(VariableShowStmt);
					n->name = "timezone";
					(yyval.node) = (Node *) n;
				;}
    break;

  case 192:

/* Line 1455 of yacc.c  */
#line 1250 "gram.y"
    {
					VariableShowStmt *n = makeNode(VariableShowStmt);
					n->name = "transaction_isolation";
					(yyval.node) = (Node *) n;
				;}
    break;

  case 193:

/* Line 1455 of yacc.c  */
#line 1256 "gram.y"
    {
					VariableShowStmt *n = makeNode(VariableShowStmt);
					n->name = "session_authorization";
					(yyval.node) = (Node *) n;
				;}
    break;

  case 194:

/* Line 1455 of yacc.c  */
#line 1262 "gram.y"
    {
					VariableShowStmt *n = makeNode(VariableShowStmt);
					n->name = "all";
					(yyval.node) = (Node *) n;
				;}
    break;

  case 195:

/* Line 1455 of yacc.c  */
#line 1271 "gram.y"
    {
					VariableResetStmt *n = makeNode(VariableResetStmt);
					n->name = (yyvsp[(2) - (2)].str);
					(yyval.node) = (Node *) n;
				;}
    break;

  case 196:

/* Line 1455 of yacc.c  */
#line 1277 "gram.y"
    {
					VariableResetStmt *n = makeNode(VariableResetStmt);
					n->name = "timezone";
					(yyval.node) = (Node *) n;
				;}
    break;

  case 197:

/* Line 1455 of yacc.c  */
#line 1283 "gram.y"
    {
					VariableResetStmt *n = makeNode(VariableResetStmt);
					n->name = "transaction_isolation";
					(yyval.node) = (Node *) n;
				;}
    break;

  case 198:

/* Line 1455 of yacc.c  */
#line 1289 "gram.y"
    {
					VariableResetStmt *n = makeNode(VariableResetStmt);
					n->name = "session_authorization";
					(yyval.node) = (Node *) n;
				;}
    break;

  case 199:

/* Line 1455 of yacc.c  */
#line 1295 "gram.y"
    {
					VariableResetStmt *n = makeNode(VariableResetStmt);
					n->name = "all";
					(yyval.node) = (Node *) n;
				;}
    break;

  case 200:

/* Line 1455 of yacc.c  */
#line 1305 "gram.y"
    {
					ConstraintsSetStmt *n = makeNode(ConstraintsSetStmt);
					n->constraints = (yyvsp[(3) - (4)].list);
					n->deferred    = (yyvsp[(4) - (4)].boolean);
					(yyval.node) = (Node *) n;
				;}
    break;

  case 201:

/* Line 1455 of yacc.c  */
#line 1314 "gram.y"
    { (yyval.list) = NIL; ;}
    break;

  case 202:

/* Line 1455 of yacc.c  */
#line 1315 "gram.y"
    { (yyval.list) = (yyvsp[(1) - (1)].list); ;}
    break;

  case 203:

/* Line 1455 of yacc.c  */
#line 1319 "gram.y"
    { (yyval.boolean) = TRUE; ;}
    break;

  case 204:

/* Line 1455 of yacc.c  */
#line 1320 "gram.y"
    { (yyval.boolean) = FALSE; ;}
    break;

  case 205:

/* Line 1455 of yacc.c  */
#line 1329 "gram.y"
    {
					CheckPointStmt *n = makeNode(CheckPointStmt);
					(yyval.node) = (Node *)n;
				;}
    break;

  case 206:

/* Line 1455 of yacc.c  */
#line 1344 "gram.y"
    {
					AlterTableStmt *n = makeNode(AlterTableStmt);
					n->relation = (yyvsp[(3) - (4)].range);
					n->cmds = (yyvsp[(4) - (4)].list);
					n->relkind = OBJECT_TABLE;
					(yyval.node) = (Node *)n;
				;}
    break;

  case 207:

/* Line 1455 of yacc.c  */
#line 1352 "gram.y"
    {
					AlterTableStmt *n = makeNode(AlterTableStmt);
					n->relation = (yyvsp[(3) - (4)].range);
					n->cmds = (yyvsp[(4) - (4)].list);
					n->relkind = OBJECT_INDEX;
					(yyval.node) = (Node *)n;
				;}
    break;

  case 208:

/* Line 1455 of yacc.c  */
#line 1362 "gram.y"
    { (yyval.list) = list_make1((yyvsp[(1) - (1)].node)); ;}
    break;

  case 209:

/* Line 1455 of yacc.c  */
#line 1363 "gram.y"
    { (yyval.list) = lappend((yyvsp[(1) - (3)].list), (yyvsp[(3) - (3)].node)); ;}
    break;

  case 210:

/* Line 1455 of yacc.c  */
#line 1370 "gram.y"
    {
					AlterTableCmd *n = makeNode(AlterTableCmd);
					n->subtype = AT_AddColumn;
					n->def = (yyvsp[(3) - (3)].node);
					(yyval.node) = (Node *)n;
				;}
    break;

  case 211:

/* Line 1455 of yacc.c  */
#line 1378 "gram.y"
    {
					AlterTableCmd *n = makeNode(AlterTableCmd);
					n->subtype = AT_ColumnDefault;
					n->name = (yyvsp[(3) - (4)].str);
					n->def = (yyvsp[(4) - (4)].node);
					(yyval.node) = (Node *)n;
				;}
    break;

  case 212:

/* Line 1455 of yacc.c  */
#line 1387 "gram.y"
    {
					AlterTableCmd *n = makeNode(AlterTableCmd);
					n->subtype = AT_DropNotNull;
					n->name = (yyvsp[(3) - (6)].str);
					(yyval.node) = (Node *)n;
				;}
    break;

  case 213:

/* Line 1455 of yacc.c  */
#line 1395 "gram.y"
    {
					AlterTableCmd *n = makeNode(AlterTableCmd);
					n->subtype = AT_SetNotNull;
					n->name = (yyvsp[(3) - (6)].str);
					(yyval.node) = (Node *)n;
				;}
    break;

  case 214:

/* Line 1455 of yacc.c  */
#line 1403 "gram.y"
    {
					AlterTableCmd *n = makeNode(AlterTableCmd);
					n->subtype = AT_SetStatistics;
					n->name = (yyvsp[(3) - (6)].str);
					n->def = (Node *) (yyvsp[(6) - (6)].value);
					(yyval.node) = (Node *)n;
				;}
    break;

  case 215:

/* Line 1455 of yacc.c  */
#line 1412 "gram.y"
    {
					AlterTableCmd *n = makeNode(AlterTableCmd);
					n->subtype = AT_SetStorage;
					n->name = (yyvsp[(3) - (6)].str);
					n->def = (Node *) makeString((yyvsp[(6) - (6)].str));
					(yyval.node) = (Node *)n;
				;}
    break;

  case 216:

/* Line 1455 of yacc.c  */
#line 1421 "gram.y"
    {
					AlterTableCmd *n = makeNode(AlterTableCmd);
					n->subtype = AT_DropColumn;
					n->name = (yyvsp[(3) - (4)].str);
					n->behavior = (yyvsp[(4) - (4)].dbehavior);
					(yyval.node) = (Node *)n;
				;}
    break;

  case 217:

/* Line 1455 of yacc.c  */
#line 1433 "gram.y"
    {
					AlterTableCmd *n = makeNode(AlterTableCmd);
					n->subtype = AT_AlterColumnType;
					n->name = (yyvsp[(3) - (6)].str);
					n->def = (Node *) (yyvsp[(5) - (6)].typnam);
					n->transform = (yyvsp[(6) - (6)].node);
					(yyval.node) = (Node *)n;
				;}
    break;

  case 218:

/* Line 1455 of yacc.c  */
#line 1443 "gram.y"
    {
					AlterTableCmd *n = makeNode(AlterTableCmd);
					n->subtype = AT_AddConstraint;
					n->def = (yyvsp[(2) - (2)].node);
					(yyval.node) = (Node *)n;
				;}
    break;

  case 219:

/* Line 1455 of yacc.c  */
#line 1451 "gram.y"
    {
					AlterTableCmd *n = makeNode(AlterTableCmd);
					n->subtype = AT_DropConstraint;
					n->name = (yyvsp[(3) - (4)].str);
					n->behavior = (yyvsp[(4) - (4)].dbehavior);
					(yyval.node) = (Node *)n;
				;}
    break;

  case 220:

/* Line 1455 of yacc.c  */
#line 1460 "gram.y"
    {
					AlterTableCmd *n = makeNode(AlterTableCmd);
					n->subtype = AT_DropOids;
					(yyval.node) = (Node *)n;
				;}
    break;

  case 221:

/* Line 1455 of yacc.c  */
#line 1467 "gram.y"
    {
					AlterTableCmd *n = makeNode(AlterTableCmd);
					n->subtype = AT_ClusterOn;
					n->name = (yyvsp[(3) - (3)].str);
					(yyval.node) = (Node *)n;
				;}
    break;

  case 222:

/* Line 1455 of yacc.c  */
#line 1475 "gram.y"
    {
					AlterTableCmd *n = makeNode(AlterTableCmd);
					n->subtype = AT_DropCluster;
					n->name = NULL;
					(yyval.node) = (Node *)n;
				;}
    break;

  case 223:

/* Line 1455 of yacc.c  */
#line 1483 "gram.y"
    {
					AlterTableCmd *n = makeNode(AlterTableCmd);
					n->subtype = AT_EnableTrig;
					n->name = (yyvsp[(3) - (3)].str);
					(yyval.node) = (Node *)n;
				;}
    break;

  case 224:

/* Line 1455 of yacc.c  */
#line 1491 "gram.y"
    {
					AlterTableCmd *n = makeNode(AlterTableCmd);
					n->subtype = AT_EnableTrigAll;
					(yyval.node) = (Node *)n;
				;}
    break;

  case 225:

/* Line 1455 of yacc.c  */
#line 1498 "gram.y"
    {
					AlterTableCmd *n = makeNode(AlterTableCmd);
					n->subtype = AT_EnableTrigUser;
					(yyval.node) = (Node *)n;
				;}
    break;

  case 226:

/* Line 1455 of yacc.c  */
#line 1505 "gram.y"
    {
					AlterTableCmd *n = makeNode(AlterTableCmd);
					n->subtype = AT_DisableTrig;
					n->name = (yyvsp[(3) - (3)].str);
					(yyval.node) = (Node *)n;
				;}
    break;

  case 227:

/* Line 1455 of yacc.c  */
#line 1513 "gram.y"
    {
					AlterTableCmd *n = makeNode(AlterTableCmd);
					n->subtype = AT_DisableTrigAll;
					(yyval.node) = (Node *)n;
				;}
    break;

  case 228:

/* Line 1455 of yacc.c  */
#line 1520 "gram.y"
    {
					AlterTableCmd *n = makeNode(AlterTableCmd);
					n->subtype = AT_DisableTrigUser;
					(yyval.node) = (Node *)n;
				;}
    break;

  case 229:

/* Line 1455 of yacc.c  */
#line 1527 "gram.y"
    {
					AlterTableCmd *n = makeNode(AlterTableCmd);
					n->subtype = AT_AddInherit;
					n->def = (Node *) (yyvsp[(2) - (2)].range);
					(yyval.node) = (Node *)n;
				;}
    break;

  case 230:

/* Line 1455 of yacc.c  */
#line 1535 "gram.y"
    {
					AlterTableCmd *n = makeNode(AlterTableCmd);
					n->subtype = AT_DropInherit;
					n->def = (Node *) (yyvsp[(3) - (3)].range);
					(yyval.node) = (Node *)n;
				;}
    break;

  case 231:

/* Line 1455 of yacc.c  */
#line 1542 "gram.y"
    {
					(yyval.node) = (yyvsp[(1) - (1)].node);
				;}
    break;

  case 232:

/* Line 1455 of yacc.c  */
#line 1548 "gram.y"
    { (yyval.list) = list_make1((yyvsp[(1) - (1)].node)); ;}
    break;

  case 233:

/* Line 1455 of yacc.c  */
#line 1549 "gram.y"
    { (yyval.list) = lappend((yyvsp[(1) - (3)].list), (yyvsp[(3) - (3)].node)); ;}
    break;

  case 234:

/* Line 1455 of yacc.c  */
#line 1556 "gram.y"
    {
					AlterTableCmd *n = makeNode(AlterTableCmd);
					n->subtype = AT_ChangeOwner;
					n->name = (yyvsp[(3) - (3)].str);
					(yyval.node) = (Node *)n;
				;}
    break;

  case 235:

/* Line 1455 of yacc.c  */
#line 1564 "gram.y"
    {
					AlterTableCmd *n = makeNode(AlterTableCmd);
					n->subtype = AT_SetTableSpace;
					n->name = (yyvsp[(3) - (3)].str);
					(yyval.node) = (Node *)n;
				;}
    break;

  case 236:

/* Line 1455 of yacc.c  */
#line 1572 "gram.y"
    {
					AlterTableCmd *n = makeNode(AlterTableCmd);
					n->subtype = AT_SetRelOptions;
					n->def = (Node *)(yyvsp[(2) - (2)].list);
					(yyval.node) = (Node *)n;
				;}
    break;

  case 237:

/* Line 1455 of yacc.c  */
#line 1580 "gram.y"
    {
					AlterTableCmd *n = makeNode(AlterTableCmd);
					n->subtype = AT_ResetRelOptions;
					n->def = (Node *)(yyvsp[(2) - (2)].list);
					(yyval.node) = (Node *)n;
				;}
    break;

  case 238:

/* Line 1455 of yacc.c  */
#line 1590 "gram.y"
    {
					/* Treat SET DEFAULT NULL the same as DROP DEFAULT */
					if (exprIsNullConstant((yyvsp[(3) - (3)].node)))
						(yyval.node) = NULL;
					else
						(yyval.node) = (yyvsp[(3) - (3)].node);
				;}
    break;

  case 239:

/* Line 1455 of yacc.c  */
#line 1597 "gram.y"
    { (yyval.node) = NULL; ;}
    break;

  case 240:

/* Line 1455 of yacc.c  */
#line 1601 "gram.y"
    { (yyval.dbehavior) = DROP_CASCADE; ;}
    break;

  case 241:

/* Line 1455 of yacc.c  */
#line 1602 "gram.y"
    { (yyval.dbehavior) = DROP_RESTRICT; ;}
    break;

  case 242:

/* Line 1455 of yacc.c  */
#line 1603 "gram.y"
    { (yyval.dbehavior) = DROP_RESTRICT; /* default */ ;}
    break;

  case 243:

/* Line 1455 of yacc.c  */
#line 1607 "gram.y"
    { (yyval.node) = (yyvsp[(2) - (2)].node); ;}
    break;

  case 244:

/* Line 1455 of yacc.c  */
#line 1608 "gram.y"
    { (yyval.node) = NULL; ;}
    break;

  case 245:

/* Line 1455 of yacc.c  */
#line 1622 "gram.y"
    {
					ClosePortalStmt *n = makeNode(ClosePortalStmt);
					n->portalname = (yyvsp[(2) - (2)].str);
					(yyval.node) = (Node *)n;
				;}
    break;

  case 246:

/* Line 1455 of yacc.c  */
#line 1646 "gram.y"
    {
					CopyStmt *n = makeNode(CopyStmt);
					n->relation = (yyvsp[(3) - (10)].range);
					n->query = NULL;
					n->attlist = (yyvsp[(4) - (10)].list);
					n->is_from = (yyvsp[(6) - (10)].boolean);
					n->filename = (yyvsp[(7) - (10)].str);

					n->options = NIL;
					/* Concatenate user-supplied flags */
					if ((yyvsp[(2) - (10)].defelt))
						n->options = lappend(n->options, (yyvsp[(2) - (10)].defelt));
					if ((yyvsp[(5) - (10)].defelt))
						n->options = lappend(n->options, (yyvsp[(5) - (10)].defelt));
					if ((yyvsp[(8) - (10)].defelt))
						n->options = lappend(n->options, (yyvsp[(8) - (10)].defelt));
					if ((yyvsp[(10) - (10)].list))
						n->options = list_concat(n->options, (yyvsp[(10) - (10)].list));
					(yyval.node) = (Node *)n;
				;}
    break;

  case 247:

/* Line 1455 of yacc.c  */
#line 1668 "gram.y"
    {
					CopyStmt *n = makeNode(CopyStmt);
					n->relation = NULL;
					n->query = (Query *) (yyvsp[(2) - (6)].node);
					n->attlist = NIL;
					n->is_from = false;
					n->filename = (yyvsp[(4) - (6)].str);
					n->options = (yyvsp[(6) - (6)].list);
					(yyval.node) = (Node *)n;
				;}
    break;

  case 248:

/* Line 1455 of yacc.c  */
#line 1681 "gram.y"
    { (yyval.boolean) = TRUE; ;}
    break;

  case 249:

/* Line 1455 of yacc.c  */
#line 1682 "gram.y"
    { (yyval.boolean) = FALSE; ;}
    break;

  case 250:

/* Line 1455 of yacc.c  */
#line 1691 "gram.y"
    { (yyval.str) = (yyvsp[(1) - (1)].str); ;}
    break;

  case 251:

/* Line 1455 of yacc.c  */
#line 1692 "gram.y"
    { (yyval.str) = NULL; ;}
    break;

  case 252:

/* Line 1455 of yacc.c  */
#line 1693 "gram.y"
    { (yyval.str) = NULL; ;}
    break;

  case 253:

/* Line 1455 of yacc.c  */
#line 1699 "gram.y"
    { (yyval.list) = lappend((yyvsp[(1) - (2)].list), (yyvsp[(2) - (2)].defelt)); ;}
    break;

  case 254:

/* Line 1455 of yacc.c  */
#line 1700 "gram.y"
    { (yyval.list) = NIL; ;}
    break;

  case 255:

/* Line 1455 of yacc.c  */
#line 1706 "gram.y"
    {
					(yyval.defelt) = makeDefElem("binary", (Node *)makeInteger(TRUE));
				;}
    break;

  case 256:

/* Line 1455 of yacc.c  */
#line 1710 "gram.y"
    {
					(yyval.defelt) = makeDefElem("oids", (Node *)makeInteger(TRUE));
				;}
    break;

  case 257:

/* Line 1455 of yacc.c  */
#line 1714 "gram.y"
    {
					(yyval.defelt) = makeDefElem("delimiter", (Node *)makeString((yyvsp[(3) - (3)].str)));
				;}
    break;

  case 258:

/* Line 1455 of yacc.c  */
#line 1718 "gram.y"
    {
					(yyval.defelt) = makeDefElem("null", (Node *)makeString((yyvsp[(3) - (3)].str)));
				;}
    break;

  case 259:

/* Line 1455 of yacc.c  */
#line 1722 "gram.y"
    {
					(yyval.defelt) = makeDefElem("csv", (Node *)makeInteger(TRUE));
				;}
    break;

  case 260:

/* Line 1455 of yacc.c  */
#line 1726 "gram.y"
    {
					(yyval.defelt) = makeDefElem("header", (Node *)makeInteger(TRUE));
				;}
    break;

  case 261:

/* Line 1455 of yacc.c  */
#line 1730 "gram.y"
    {
					(yyval.defelt) = makeDefElem("quote", (Node *)makeString((yyvsp[(3) - (3)].str)));
				;}
    break;

  case 262:

/* Line 1455 of yacc.c  */
#line 1734 "gram.y"
    {
					(yyval.defelt) = makeDefElem("escape", (Node *)makeString((yyvsp[(3) - (3)].str)));
				;}
    break;

  case 263:

/* Line 1455 of yacc.c  */
#line 1738 "gram.y"
    {
					(yyval.defelt) = makeDefElem("force_quote", (Node *)(yyvsp[(3) - (3)].list));
				;}
    break;

  case 264:

/* Line 1455 of yacc.c  */
#line 1742 "gram.y"
    {
					(yyval.defelt) = makeDefElem("force_notnull", (Node *)(yyvsp[(4) - (4)].list));
				;}
    break;

  case 265:

/* Line 1455 of yacc.c  */
#line 1751 "gram.y"
    {
					(yyval.defelt) = makeDefElem("binary", (Node *)makeInteger(TRUE));
				;}
    break;

  case 266:

/* Line 1455 of yacc.c  */
#line 1754 "gram.y"
    { (yyval.defelt) = NULL; ;}
    break;

  case 267:

/* Line 1455 of yacc.c  */
#line 1759 "gram.y"
    {
					(yyval.defelt) = makeDefElem("oids", (Node *)makeInteger(TRUE));
				;}
    break;

  case 268:

/* Line 1455 of yacc.c  */
#line 1762 "gram.y"
    { (yyval.defelt) = NULL; ;}
    break;

  case 269:

/* Line 1455 of yacc.c  */
#line 1768 "gram.y"
    {
					(yyval.defelt) = makeDefElem("delimiter", (Node *)makeString((yyvsp[(3) - (3)].str)));
				;}
    break;

  case 270:

/* Line 1455 of yacc.c  */
#line 1771 "gram.y"
    { (yyval.defelt) = NULL; ;}
    break;

  case 271:

/* Line 1455 of yacc.c  */
#line 1775 "gram.y"
    {;}
    break;

  case 272:

/* Line 1455 of yacc.c  */
#line 1776 "gram.y"
    {;}
    break;

  case 273:

/* Line 1455 of yacc.c  */
#line 1789 "gram.y"
    {
					CreateStmt *n = makeNode(CreateStmt);
					(yyvsp[(4) - (11)].range)->istemp = (yyvsp[(2) - (11)].boolean);
					n->relation = (yyvsp[(4) - (11)].range);
					n->tableElts = (yyvsp[(6) - (11)].list);
					n->inhRelations = (yyvsp[(8) - (11)].list);
					n->constraints = NIL;
					n->options = (yyvsp[(9) - (11)].list);
					n->oncommit = (yyvsp[(10) - (11)].oncommit);
					n->tablespacename = (yyvsp[(11) - (11)].str);
					(yyval.node) = (Node *)n;
				;}
    break;

  case 274:

/* Line 1455 of yacc.c  */
#line 1803 "gram.y"
    {
					/* SQL99 CREATE TABLE OF <UDT> (cols) seems to be satisfied
					 * by our inheritance capabilities. Let's try it...
					 */
					CreateStmt *n = makeNode(CreateStmt);
					(yyvsp[(4) - (12)].range)->istemp = (yyvsp[(2) - (12)].boolean);
					n->relation = (yyvsp[(4) - (12)].range);
					n->tableElts = (yyvsp[(8) - (12)].list);
					n->inhRelations = list_make1((yyvsp[(6) - (12)].range));
					n->constraints = NIL;
					n->options = (yyvsp[(10) - (12)].list);
					n->oncommit = (yyvsp[(11) - (12)].oncommit);
					n->tablespacename = (yyvsp[(12) - (12)].str);
					(yyval.node) = (Node *)n;
				;}
    break;

  case 275:

/* Line 1455 of yacc.c  */
#line 1827 "gram.y"
    { (yyval.boolean) = TRUE; ;}
    break;

  case 276:

/* Line 1455 of yacc.c  */
#line 1828 "gram.y"
    { (yyval.boolean) = TRUE; ;}
    break;

  case 277:

/* Line 1455 of yacc.c  */
#line 1829 "gram.y"
    { (yyval.boolean) = TRUE; ;}
    break;

  case 278:

/* Line 1455 of yacc.c  */
#line 1830 "gram.y"
    { (yyval.boolean) = TRUE; ;}
    break;

  case 279:

/* Line 1455 of yacc.c  */
#line 1831 "gram.y"
    { (yyval.boolean) = TRUE; ;}
    break;

  case 280:

/* Line 1455 of yacc.c  */
#line 1832 "gram.y"
    { (yyval.boolean) = TRUE; ;}
    break;

  case 281:

/* Line 1455 of yacc.c  */
#line 1833 "gram.y"
    { (yyval.boolean) = FALSE; ;}
    break;

  case 282:

/* Line 1455 of yacc.c  */
#line 1837 "gram.y"
    { (yyval.list) = (yyvsp[(1) - (1)].list); ;}
    break;

  case 283:

/* Line 1455 of yacc.c  */
#line 1838 "gram.y"
    { (yyval.list) = NIL; ;}
    break;

  case 284:

/* Line 1455 of yacc.c  */
#line 1843 "gram.y"
    {
					(yyval.list) = list_make1((yyvsp[(1) - (1)].node));
				;}
    break;

  case 285:

/* Line 1455 of yacc.c  */
#line 1847 "gram.y"
    {
					(yyval.list) = lappend((yyvsp[(1) - (3)].list), (yyvsp[(3) - (3)].node));
				;}
    break;

  case 286:

/* Line 1455 of yacc.c  */
#line 1853 "gram.y"
    { (yyval.node) = (yyvsp[(1) - (1)].node); ;}
    break;

  case 287:

/* Line 1455 of yacc.c  */
#line 1854 "gram.y"
    { (yyval.node) = (yyvsp[(1) - (1)].node); ;}
    break;

  case 288:

/* Line 1455 of yacc.c  */
#line 1855 "gram.y"
    { (yyval.node) = (yyvsp[(1) - (1)].node); ;}
    break;

  case 289:

/* Line 1455 of yacc.c  */
#line 1859 "gram.y"
    {
					ColumnDef *n = makeNode(ColumnDef);
					n->colname = (yyvsp[(1) - (3)].str);
					n->typename = (yyvsp[(2) - (3)].typnam);
					n->constraints = (yyvsp[(3) - (3)].list);
					n->is_local = true;
					(yyval.node) = (Node *)n;
				;}
    break;

  case 290:

/* Line 1455 of yacc.c  */
#line 1870 "gram.y"
    { (yyval.list) = lappend((yyvsp[(1) - (2)].list), (yyvsp[(2) - (2)].node)); ;}
    break;

  case 291:

/* Line 1455 of yacc.c  */
#line 1871 "gram.y"
    { (yyval.list) = NIL; ;}
    break;

  case 292:

/* Line 1455 of yacc.c  */
#line 1876 "gram.y"
    {
					switch (nodeTag((yyvsp[(3) - (3)].node)))
					{
						case T_Constraint:
							{
								Constraint *n = (Constraint *)(yyvsp[(3) - (3)].node);
								n->name = (yyvsp[(2) - (3)].str);
							}
							break;
						case T_FkConstraint:
							{
								FkConstraint *n = (FkConstraint *)(yyvsp[(3) - (3)].node);
								n->constr_name = (yyvsp[(2) - (3)].str);
							}
							break;
						default:
							break;
					}
					(yyval.node) = (yyvsp[(3) - (3)].node);
				;}
    break;

  case 293:

/* Line 1455 of yacc.c  */
#line 1896 "gram.y"
    { (yyval.node) = (yyvsp[(1) - (1)].node); ;}
    break;

  case 294:

/* Line 1455 of yacc.c  */
#line 1897 "gram.y"
    { (yyval.node) = (yyvsp[(1) - (1)].node); ;}
    break;

  case 295:

/* Line 1455 of yacc.c  */
#line 1917 "gram.y"
    {
					Constraint *n = makeNode(Constraint);
					n->contype = CONSTR_NOTNULL;
					n->name = NULL;
					n->raw_expr = NULL;
					n->cooked_expr = NULL;
					n->keys = NULL;
					n->indexspace = NULL;
					(yyval.node) = (Node *)n;
				;}
    break;

  case 296:

/* Line 1455 of yacc.c  */
#line 1928 "gram.y"
    {
					Constraint *n = makeNode(Constraint);
					n->contype = CONSTR_NULL;
					n->name = NULL;
					n->raw_expr = NULL;
					n->cooked_expr = NULL;
					n->keys = NULL;
					n->indexspace = NULL;
					(yyval.node) = (Node *)n;
				;}
    break;

  case 297:

/* Line 1455 of yacc.c  */
#line 1939 "gram.y"
    {
					Constraint *n = makeNode(Constraint);
					n->contype = CONSTR_UNIQUE;
					n->name = NULL;
					n->raw_expr = NULL;
					n->cooked_expr = NULL;
					n->keys = NULL;
					n->options = (yyvsp[(2) - (3)].list);
					n->indexspace = (yyvsp[(3) - (3)].str);
					(yyval.node) = (Node *)n;
				;}
    break;

  case 298:

/* Line 1455 of yacc.c  */
#line 1951 "gram.y"
    {
					Constraint *n = makeNode(Constraint);
					n->contype = CONSTR_PRIMARY;
					n->name = NULL;
					n->raw_expr = NULL;
					n->cooked_expr = NULL;
					n->keys = NULL;
					n->options = (yyvsp[(3) - (4)].list);
					n->indexspace = (yyvsp[(4) - (4)].str);
					(yyval.node) = (Node *)n;
				;}
    break;

  case 299:

/* Line 1455 of yacc.c  */
#line 1963 "gram.y"
    {
					Constraint *n = makeNode(Constraint);
					n->contype = CONSTR_CHECK;
					n->name = NULL;
					n->raw_expr = (yyvsp[(3) - (4)].node);
					n->cooked_expr = NULL;
					n->keys = NULL;
					n->indexspace = NULL;
					(yyval.node) = (Node *)n;
				;}
    break;

  case 300:

/* Line 1455 of yacc.c  */
#line 1974 "gram.y"
    {
					Constraint *n = makeNode(Constraint);
					n->contype = CONSTR_DEFAULT;
					n->name = NULL;
					if (exprIsNullConstant((yyvsp[(2) - (2)].node)))
					{
						/* DEFAULT NULL should be reported as empty expr */
						n->raw_expr = NULL;
					}
					else
					{
						n->raw_expr = (yyvsp[(2) - (2)].node);
					}
					n->cooked_expr = NULL;
					n->keys = NULL;
					n->indexspace = NULL;
					(yyval.node) = (Node *)n;
				;}
    break;

  case 301:

/* Line 1455 of yacc.c  */
#line 1993 "gram.y"
    {
					FkConstraint *n = makeNode(FkConstraint);
					n->constr_name		= NULL;
					n->pktable			= (yyvsp[(2) - (5)].range);
					n->fk_attrs			= NIL;
					n->pk_attrs			= (yyvsp[(3) - (5)].list);
					n->fk_matchtype		= (yyvsp[(4) - (5)].ival);
					n->fk_upd_action	= (char) ((yyvsp[(5) - (5)].ival) >> 8);
					n->fk_del_action	= (char) ((yyvsp[(5) - (5)].ival) & 0xFF);
					n->deferrable		= FALSE;
					n->initdeferred		= FALSE;
					(yyval.node) = (Node *)n;
				;}
    break;

  case 302:

/* Line 1455 of yacc.c  */
#line 2021 "gram.y"
    {
					Constraint *n = makeNode(Constraint);
					n->contype = CONSTR_ATTR_DEFERRABLE;
					(yyval.node) = (Node *)n;
				;}
    break;

  case 303:

/* Line 1455 of yacc.c  */
#line 2027 "gram.y"
    {
					Constraint *n = makeNode(Constraint);
					n->contype = CONSTR_ATTR_NOT_DEFERRABLE;
					(yyval.node) = (Node *)n;
				;}
    break;

  case 304:

/* Line 1455 of yacc.c  */
#line 2033 "gram.y"
    {
					Constraint *n = makeNode(Constraint);
					n->contype = CONSTR_ATTR_DEFERRED;
					(yyval.node) = (Node *)n;
				;}
    break;

  case 305:

/* Line 1455 of yacc.c  */
#line 2039 "gram.y"
    {
					Constraint *n = makeNode(Constraint);
					n->contype = CONSTR_ATTR_IMMEDIATE;
					(yyval.node) = (Node *)n;
				;}
    break;

  case 306:

/* Line 1455 of yacc.c  */
#line 2057 "gram.y"
    {
					InhRelation *n = makeNode(InhRelation);
					n->relation = (yyvsp[(2) - (3)].range);
					n->options = (yyvsp[(3) - (3)].list);
					(yyval.node) = (Node *)n;
				;}
    break;

  case 307:

/* Line 1455 of yacc.c  */
#line 2066 "gram.y"
    { (yyval.list) = lappend_int((yyvsp[(1) - (2)].list), (yyvsp[(2) - (2)].ival)); ;}
    break;

  case 308:

/* Line 1455 of yacc.c  */
#line 2067 "gram.y"
    { (yyval.list) = NIL; ;}
    break;

  case 309:

/* Line 1455 of yacc.c  */
#line 2071 "gram.y"
    { (yyval.ival) = 	CREATE_TABLE_LIKE_INCLUDING_DEFAULTS; ;}
    break;

  case 310:

/* Line 1455 of yacc.c  */
#line 2072 "gram.y"
    { (yyval.ival) = 	CREATE_TABLE_LIKE_EXCLUDING_DEFAULTS; ;}
    break;

  case 311:

/* Line 1455 of yacc.c  */
#line 2073 "gram.y"
    { (yyval.ival) = 	CREATE_TABLE_LIKE_INCLUDING_CONSTRAINTS; ;}
    break;

  case 312:

/* Line 1455 of yacc.c  */
#line 2074 "gram.y"
    { (yyval.ival) = 	CREATE_TABLE_LIKE_EXCLUDING_CONSTRAINTS; ;}
    break;

  case 313:

/* Line 1455 of yacc.c  */
#line 2075 "gram.y"
    { (yyval.ival) = 	CREATE_TABLE_LIKE_INCLUDING_INDEXES; ;}
    break;

  case 314:

/* Line 1455 of yacc.c  */
#line 2076 "gram.y"
    { (yyval.ival) = 	CREATE_TABLE_LIKE_EXCLUDING_INDEXES; ;}
    break;

  case 315:

/* Line 1455 of yacc.c  */
#line 2086 "gram.y"
    {
					switch (nodeTag((yyvsp[(3) - (3)].node)))
					{
						case T_Constraint:
							{
								Constraint *n = (Constraint *)(yyvsp[(3) - (3)].node);
								n->name = (yyvsp[(2) - (3)].str);
							}
							break;
						case T_FkConstraint:
							{
								FkConstraint *n = (FkConstraint *)(yyvsp[(3) - (3)].node);
								n->constr_name = (yyvsp[(2) - (3)].str);
							}
							break;
						default:
							break;
					}
					(yyval.node) = (yyvsp[(3) - (3)].node);
				;}
    break;

  case 316:

/* Line 1455 of yacc.c  */
#line 2106 "gram.y"
    { (yyval.node) = (yyvsp[(1) - (1)].node); ;}
    break;

  case 317:

/* Line 1455 of yacc.c  */
#line 2111 "gram.y"
    {
					Constraint *n = makeNode(Constraint);
					n->contype = CONSTR_CHECK;
					n->name = NULL;
					n->raw_expr = (yyvsp[(3) - (4)].node);
					n->cooked_expr = NULL;
					n->indexspace = NULL;
					(yyval.node) = (Node *)n;
				;}
    break;

  case 318:

/* Line 1455 of yacc.c  */
#line 2121 "gram.y"
    {
					Constraint *n = makeNode(Constraint);
					n->contype = CONSTR_UNIQUE;
					n->name = NULL;
					n->raw_expr = NULL;
					n->cooked_expr = NULL;
					n->keys = (yyvsp[(3) - (6)].list);
					n->options = (yyvsp[(5) - (6)].list);
					n->indexspace = (yyvsp[(6) - (6)].str);
					(yyval.node) = (Node *)n;
				;}
    break;

  case 319:

/* Line 1455 of yacc.c  */
#line 2133 "gram.y"
    {
					Constraint *n = makeNode(Constraint);
					n->contype = CONSTR_PRIMARY;
					n->name = NULL;
					n->raw_expr = NULL;
					n->cooked_expr = NULL;
					n->keys = (yyvsp[(4) - (7)].list);
					n->options = (yyvsp[(6) - (7)].list);
					n->indexspace = (yyvsp[(7) - (7)].str);
					(yyval.node) = (Node *)n;
				;}
    break;

  case 320:

/* Line 1455 of yacc.c  */
#line 2146 "gram.y"
    {
					FkConstraint *n = makeNode(FkConstraint);
					n->constr_name		= NULL;
					n->pktable			= (yyvsp[(7) - (11)].range);
					n->fk_attrs			= (yyvsp[(4) - (11)].list);
					n->pk_attrs			= (yyvsp[(8) - (11)].list);
					n->fk_matchtype		= (yyvsp[(9) - (11)].ival);
					n->fk_upd_action	= (char) ((yyvsp[(10) - (11)].ival) >> 8);
					n->fk_del_action	= (char) ((yyvsp[(10) - (11)].ival) & 0xFF);
					n->deferrable		= ((yyvsp[(11) - (11)].ival) & 1) != 0;
					n->initdeferred		= ((yyvsp[(11) - (11)].ival) & 2) != 0;
					(yyval.node) = (Node *)n;
				;}
    break;

  case 321:

/* Line 1455 of yacc.c  */
#line 2162 "gram.y"
    { (yyval.list) = (yyvsp[(2) - (3)].list); ;}
    break;

  case 322:

/* Line 1455 of yacc.c  */
#line 2163 "gram.y"
    { (yyval.list) = NIL; ;}
    break;

  case 323:

/* Line 1455 of yacc.c  */
#line 2167 "gram.y"
    { (yyval.list) = list_make1((yyvsp[(1) - (1)].node)); ;}
    break;

  case 324:

/* Line 1455 of yacc.c  */
#line 2168 "gram.y"
    { (yyval.list) = lappend((yyvsp[(1) - (3)].list), (yyvsp[(3) - (3)].node)); ;}
    break;

  case 325:

/* Line 1455 of yacc.c  */
#line 2172 "gram.y"
    {
					(yyval.node) = (Node *) makeString((yyvsp[(1) - (1)].str));
				;}
    break;

  case 326:

/* Line 1455 of yacc.c  */
#line 2178 "gram.y"
    {
				(yyval.ival) = FKCONSTR_MATCH_FULL;
			;}
    break;

  case 327:

/* Line 1455 of yacc.c  */
#line 2182 "gram.y"
    {
				ereport(ERROR,
						(errcode(ERRCODE_FEATURE_NOT_SUPPORTED),
						 errmsg("MATCH PARTIAL not yet implemented")));
				(yyval.ival) = FKCONSTR_MATCH_PARTIAL;
			;}
    break;

  case 328:

/* Line 1455 of yacc.c  */
#line 2189 "gram.y"
    {
				(yyval.ival) = FKCONSTR_MATCH_UNSPECIFIED;
			;}
    break;

  case 329:

/* Line 1455 of yacc.c  */
#line 2193 "gram.y"
    {
				(yyval.ival) = FKCONSTR_MATCH_UNSPECIFIED;
			;}
    break;

  case 330:

/* Line 1455 of yacc.c  */
#line 2206 "gram.y"
    { (yyval.ival) = ((yyvsp[(1) - (1)].ival) << 8) | (FKCONSTR_ACTION_NOACTION & 0xFF); ;}
    break;

  case 331:

/* Line 1455 of yacc.c  */
#line 2208 "gram.y"
    { (yyval.ival) = (FKCONSTR_ACTION_NOACTION << 8) | ((yyvsp[(1) - (1)].ival) & 0xFF); ;}
    break;

  case 332:

/* Line 1455 of yacc.c  */
#line 2210 "gram.y"
    { (yyval.ival) = ((yyvsp[(1) - (2)].ival) << 8) | ((yyvsp[(2) - (2)].ival) & 0xFF); ;}
    break;

  case 333:

/* Line 1455 of yacc.c  */
#line 2212 "gram.y"
    { (yyval.ival) = ((yyvsp[(2) - (2)].ival) << 8) | ((yyvsp[(1) - (2)].ival) & 0xFF); ;}
    break;

  case 334:

/* Line 1455 of yacc.c  */
#line 2214 "gram.y"
    { (yyval.ival) = (FKCONSTR_ACTION_NOACTION << 8) | (FKCONSTR_ACTION_NOACTION & 0xFF); ;}
    break;

  case 335:

/* Line 1455 of yacc.c  */
#line 2217 "gram.y"
    { (yyval.ival) = (yyvsp[(3) - (3)].ival); ;}
    break;

  case 336:

/* Line 1455 of yacc.c  */
#line 2220 "gram.y"
    { (yyval.ival) = (yyvsp[(3) - (3)].ival); ;}
    break;

  case 337:

/* Line 1455 of yacc.c  */
#line 2224 "gram.y"
    { (yyval.ival) = FKCONSTR_ACTION_NOACTION; ;}
    break;

  case 338:

/* Line 1455 of yacc.c  */
#line 2225 "gram.y"
    { (yyval.ival) = FKCONSTR_ACTION_RESTRICT; ;}
    break;

  case 339:

/* Line 1455 of yacc.c  */
#line 2226 "gram.y"
    { (yyval.ival) = FKCONSTR_ACTION_CASCADE; ;}
    break;

  case 340:

/* Line 1455 of yacc.c  */
#line 2227 "gram.y"
    { (yyval.ival) = FKCONSTR_ACTION_SETNULL; ;}
    break;

  case 341:

/* Line 1455 of yacc.c  */
#line 2228 "gram.y"
    { (yyval.ival) = FKCONSTR_ACTION_SETDEFAULT; ;}
    break;

  case 342:

/* Line 1455 of yacc.c  */
#line 2231 "gram.y"
    { (yyval.list) = (yyvsp[(3) - (4)].list); ;}
    break;

  case 343:

/* Line 1455 of yacc.c  */
#line 2232 "gram.y"
    { (yyval.list) = NIL; ;}
    break;

  case 344:

/* Line 1455 of yacc.c  */
#line 2237 "gram.y"
    { (yyval.list) = (yyvsp[(2) - (2)].list); ;}
    break;

  case 345:

/* Line 1455 of yacc.c  */
#line 2238 "gram.y"
    { (yyval.list) = list_make1(defWithOids(true)); ;}
    break;

  case 346:

/* Line 1455 of yacc.c  */
#line 2239 "gram.y"
    { (yyval.list) = list_make1(defWithOids(false)); ;}
    break;

  case 347:

/* Line 1455 of yacc.c  */
#line 2240 "gram.y"
    { (yyval.list) = NIL; ;}
    break;

  case 348:

/* Line 1455 of yacc.c  */
#line 2243 "gram.y"
    { (yyval.oncommit) = ONCOMMIT_DROP; ;}
    break;

  case 349:

/* Line 1455 of yacc.c  */
#line 2244 "gram.y"
    { (yyval.oncommit) = ONCOMMIT_DELETE_ROWS; ;}
    break;

  case 350:

/* Line 1455 of yacc.c  */
#line 2245 "gram.y"
    { (yyval.oncommit) = ONCOMMIT_PRESERVE_ROWS; ;}
    break;

  case 351:

/* Line 1455 of yacc.c  */
#line 2246 "gram.y"
    { (yyval.oncommit) = ONCOMMIT_NOOP; ;}
    break;

  case 352:

/* Line 1455 of yacc.c  */
#line 2249 "gram.y"
    { (yyval.str) = (yyvsp[(2) - (2)].str); ;}
    break;

  case 353:

/* Line 1455 of yacc.c  */
#line 2250 "gram.y"
    { (yyval.str) = NULL; ;}
    break;

  case 354:

/* Line 1455 of yacc.c  */
#line 2253 "gram.y"
    { (yyval.str) = (yyvsp[(4) - (4)].str); ;}
    break;

  case 355:

/* Line 1455 of yacc.c  */
#line 2254 "gram.y"
    { (yyval.str) = NULL; ;}
    break;

  case 356:

/* Line 1455 of yacc.c  */
#line 2266 "gram.y"
    {
					/*
					 * When the SelectStmt is a set-operation tree, we must
					 * stuff the INTO information into the leftmost component
					 * Select, because that's where analyze.c will expect
					 * to find it.	Similarly, the output column names must
					 * be attached to that Select's target list.
					 */
					SelectStmt *n = findLeftmostSelect((SelectStmt *) (yyvsp[(10) - (10)].node));
					if (n->into != NULL)
						ereport(ERROR,
								(errcode(ERRCODE_SYNTAX_ERROR),
								 errmsg("CREATE TABLE AS may not specify INTO")));
					(yyvsp[(4) - (10)].range)->istemp = (yyvsp[(2) - (10)].boolean);
					n->into = (yyvsp[(4) - (10)].range);
					n->intoColNames = (yyvsp[(5) - (10)].list);
					n->intoOptions = (yyvsp[(6) - (10)].list);
					n->intoOnCommit = (yyvsp[(7) - (10)].oncommit);
					n->intoTableSpaceName = (yyvsp[(8) - (10)].str);
					(yyval.node) = (yyvsp[(10) - (10)].node);
				;}
    break;

  case 357:

/* Line 1455 of yacc.c  */
#line 2290 "gram.y"
    { (yyval.list) = (yyvsp[(2) - (3)].list); ;}
    break;

  case 358:

/* Line 1455 of yacc.c  */
#line 2291 "gram.y"
    { (yyval.list) = NIL; ;}
    break;

  case 359:

/* Line 1455 of yacc.c  */
#line 2295 "gram.y"
    { (yyval.list) = list_make1((yyvsp[(1) - (1)].node)); ;}
    break;

  case 360:

/* Line 1455 of yacc.c  */
#line 2296 "gram.y"
    { (yyval.list) = lappend((yyvsp[(1) - (3)].list), (yyvsp[(3) - (3)].node)); ;}
    break;

  case 361:

/* Line 1455 of yacc.c  */
#line 2301 "gram.y"
    {
					ColumnDef *n = makeNode(ColumnDef);
					n->colname = (yyvsp[(1) - (1)].str);
					n->typename = NULL;
					n->inhcount = 0;
					n->is_local = true;
					n->is_not_null = false;
					n->raw_default = NULL;
					n->cooked_default = NULL;
					n->constraints = NIL;
					(yyval.node) = (Node *)n;
				;}
    break;

  case 362:

/* Line 1455 of yacc.c  */
#line 2326 "gram.y"
    {
					CreateSeqStmt *n = makeNode(CreateSeqStmt);
					(yyvsp[(4) - (5)].range)->istemp = (yyvsp[(2) - (5)].boolean);
					n->sequence = (yyvsp[(4) - (5)].range);
					n->options = (yyvsp[(5) - (5)].list);
					(yyval.node) = (Node *)n;
				;}
    break;

  case 363:

/* Line 1455 of yacc.c  */
#line 2337 "gram.y"
    {
					AlterSeqStmt *n = makeNode(AlterSeqStmt);
					n->sequence = (yyvsp[(3) - (4)].range);
					n->options = (yyvsp[(4) - (4)].list);
					(yyval.node) = (Node *)n;
				;}
    break;

  case 364:

/* Line 1455 of yacc.c  */
#line 2345 "gram.y"
    { (yyval.list) = lappend((yyvsp[(1) - (2)].list), (yyvsp[(2) - (2)].defelt)); ;}
    break;

  case 365:

/* Line 1455 of yacc.c  */
#line 2346 "gram.y"
    { (yyval.list) = NIL; ;}
    break;

  case 366:

/* Line 1455 of yacc.c  */
#line 2350 "gram.y"
    {
					(yyval.defelt) = makeDefElem("cache", (Node *)(yyvsp[(2) - (2)].value));
				;}
    break;

  case 367:

/* Line 1455 of yacc.c  */
#line 2354 "gram.y"
    {
					(yyval.defelt) = makeDefElem("cycle", (Node *)makeInteger(TRUE));
				;}
    break;

  case 368:

/* Line 1455 of yacc.c  */
#line 2358 "gram.y"
    {
					(yyval.defelt) = makeDefElem("cycle", (Node *)makeInteger(FALSE));
				;}
    break;

  case 369:

/* Line 1455 of yacc.c  */
#line 2362 "gram.y"
    {
					(yyval.defelt) = makeDefElem("increment", (Node *)(yyvsp[(3) - (3)].value));
				;}
    break;

  case 370:

/* Line 1455 of yacc.c  */
#line 2366 "gram.y"
    {
					(yyval.defelt) = makeDefElem("maxvalue", (Node *)(yyvsp[(2) - (2)].value));
				;}
    break;

  case 371:

/* Line 1455 of yacc.c  */
#line 2370 "gram.y"
    {
					(yyval.defelt) = makeDefElem("minvalue", (Node *)(yyvsp[(2) - (2)].value));
				;}
    break;

  case 372:

/* Line 1455 of yacc.c  */
#line 2374 "gram.y"
    {
					(yyval.defelt) = makeDefElem("maxvalue", NULL);
				;}
    break;

  case 373:

/* Line 1455 of yacc.c  */
#line 2378 "gram.y"
    {
					(yyval.defelt) = makeDefElem("minvalue", NULL);
				;}
    break;

  case 374:

/* Line 1455 of yacc.c  */
#line 2382 "gram.y"
    {
					(yyval.defelt) = makeDefElem("owned_by", (Node *)(yyvsp[(3) - (3)].list));
				;}
    break;

  case 375:

/* Line 1455 of yacc.c  */
#line 2386 "gram.y"
    {
					(yyval.defelt) = makeDefElem("start", (Node *)(yyvsp[(3) - (3)].value));
				;}
    break;

  case 376:

/* Line 1455 of yacc.c  */
#line 2390 "gram.y"
    {
					(yyval.defelt) = makeDefElem("restart", (Node *)(yyvsp[(3) - (3)].value));
				;}
    break;

  case 377:

/* Line 1455 of yacc.c  */
#line 2395 "gram.y"
    {;}
    break;

  case 378:

/* Line 1455 of yacc.c  */
#line 2396 "gram.y"
    {;}
    break;

  case 379:

/* Line 1455 of yacc.c  */
#line 2400 "gram.y"
    { (yyval.value) = (yyvsp[(1) - (1)].value); ;}
    break;

  case 380:

/* Line 1455 of yacc.c  */
#line 2401 "gram.y"
    { (yyval.value) = (yyvsp[(1) - (1)].value); ;}
    break;

  case 381:

/* Line 1455 of yacc.c  */
#line 2404 "gram.y"
    { (yyval.value) = makeFloat((yyvsp[(1) - (1)].str)); ;}
    break;

  case 382:

/* Line 1455 of yacc.c  */
#line 2406 "gram.y"
    {
					(yyval.value) = makeFloat((yyvsp[(2) - (2)].str));
					doNegateFloat((yyval.value));
				;}
    break;

  case 383:

/* Line 1455 of yacc.c  */
#line 2412 "gram.y"
    { (yyval.value) = makeInteger((yyvsp[(1) - (1)].ival)); ;}
    break;

  case 384:

/* Line 1455 of yacc.c  */
#line 2425 "gram.y"
    {
				CreatePLangStmt *n = makeNode(CreatePLangStmt);
				n->plname = (yyvsp[(5) - (5)].str);
				/* parameters are all to be supplied by system */
				n->plhandler = NIL;
				n->plvalidator = NIL;
				n->pltrusted = false;
				(yyval.node) = (Node *)n;
			;}
    break;

  case 385:

/* Line 1455 of yacc.c  */
#line 2436 "gram.y"
    {
				CreatePLangStmt *n = makeNode(CreatePLangStmt);
				n->plname = (yyvsp[(5) - (9)].str);
				n->plhandler = (yyvsp[(7) - (9)].list);
				n->plvalidator = (yyvsp[(8) - (9)].list);
				n->pltrusted = (yyvsp[(2) - (9)].boolean);
				/* LANCOMPILER is now ignored entirely */
				(yyval.node) = (Node *)n;
			;}
    break;

  case 386:

/* Line 1455 of yacc.c  */
#line 2448 "gram.y"
    { (yyval.boolean) = TRUE; ;}
    break;

  case 387:

/* Line 1455 of yacc.c  */
#line 2449 "gram.y"
    { (yyval.boolean) = FALSE; ;}
    break;

  case 388:

/* Line 1455 of yacc.c  */
#line 2457 "gram.y"
    { (yyval.list) = list_make1(makeString((yyvsp[(1) - (1)].str))); ;}
    break;

  case 389:

/* Line 1455 of yacc.c  */
#line 2458 "gram.y"
    { (yyval.list) = lcons(makeString((yyvsp[(1) - (2)].str)), (yyvsp[(2) - (2)].list)); ;}
    break;

  case 390:

/* Line 1455 of yacc.c  */
#line 2462 "gram.y"
    { (yyval.list) = (yyvsp[(2) - (2)].list); ;}
    break;

  case 391:

/* Line 1455 of yacc.c  */
#line 2463 "gram.y"
    { (yyval.list) = NIL; ;}
    break;

  case 392:

/* Line 1455 of yacc.c  */
#line 2467 "gram.y"
    { (yyval.str) = (yyvsp[(2) - (2)].str); ;}
    break;

  case 393:

/* Line 1455 of yacc.c  */
#line 2468 "gram.y"
    { (yyval.str) = NULL; ;}
    break;

  case 394:

/* Line 1455 of yacc.c  */
#line 2473 "gram.y"
    {
					DropPLangStmt *n = makeNode(DropPLangStmt);
					n->plname = (yyvsp[(4) - (5)].str);
					n->behavior = (yyvsp[(5) - (5)].dbehavior);
					n->missing_ok = false;
					(yyval.node) = (Node *)n;
				;}
    break;

  case 395:

/* Line 1455 of yacc.c  */
#line 2481 "gram.y"
    {
					DropPLangStmt *n = makeNode(DropPLangStmt);
					n->plname = (yyvsp[(6) - (7)].str);
					n->behavior = (yyvsp[(7) - (7)].dbehavior);
					n->missing_ok = true;
					(yyval.node) = (Node *)n;
				;}
    break;

  case 396:

/* Line 1455 of yacc.c  */
#line 2491 "gram.y"
    {;}
    break;

  case 397:

/* Line 1455 of yacc.c  */
#line 2492 "gram.y"
    {;}
    break;

  case 398:

/* Line 1455 of yacc.c  */
#line 2503 "gram.y"
    {
					CreateTableSpaceStmt *n = makeNode(CreateTableSpaceStmt);
					n->tablespacename = (yyvsp[(3) - (6)].str);
					n->owner = (yyvsp[(4) - (6)].str);
					n->location = (yyvsp[(6) - (6)].str);
					(yyval.node) = (Node *) n;
				;}
    break;

  case 399:

/* Line 1455 of yacc.c  */
#line 2512 "gram.y"
    { (yyval.str) = (yyvsp[(2) - (2)].str); ;}
    break;

  case 400:

/* Line 1455 of yacc.c  */
#line 2513 "gram.y"
    { (yyval.str) = NULL; ;}
    break;

  case 401:

/* Line 1455 of yacc.c  */
#line 2527 "gram.y"
    {
					DropTableSpaceStmt *n = makeNode(DropTableSpaceStmt);
					n->tablespacename = (yyvsp[(3) - (3)].str);
					n->missing_ok = false;
					(yyval.node) = (Node *) n;
				;}
    break;

  case 402:

/* Line 1455 of yacc.c  */
#line 2534 "gram.y"
    {
					DropTableSpaceStmt *n = makeNode(DropTableSpaceStmt);
					n->tablespacename = (yyvsp[(5) - (5)].str);
					n->missing_ok = true;
					(yyval.node) = (Node *) n;
				;}
    break;

  case 403:

/* Line 1455 of yacc.c  */
#line 2554 "gram.y"
    {
					CreateTrigStmt *n = makeNode(CreateTrigStmt);
					n->trigname = (yyvsp[(3) - (14)].str);
					n->relation = (yyvsp[(7) - (14)].range);
					n->funcname = (yyvsp[(11) - (14)].list);
					n->args = (yyvsp[(13) - (14)].list);
					n->before = (yyvsp[(4) - (14)].boolean);
					n->row = (yyvsp[(8) - (14)].boolean);
					memcpy(n->actions, (yyvsp[(5) - (14)].str), 4);
					n->isconstraint  = FALSE;
					n->deferrable	 = FALSE;
					n->initdeferred  = FALSE;
					n->constrrel = NULL;
					(yyval.node) = (Node *)n;
				;}
    break;

  case 404:

/* Line 1455 of yacc.c  */
#line 2574 "gram.y"
    {
					CreateTrigStmt *n = makeNode(CreateTrigStmt);
					n->trigname = (yyvsp[(4) - (19)].str);
					n->relation = (yyvsp[(8) - (19)].range);
					n->funcname = (yyvsp[(16) - (19)].list);
					n->args = (yyvsp[(18) - (19)].list);
					n->before = FALSE;
					n->row = TRUE;
					memcpy(n->actions, (yyvsp[(6) - (19)].str), 4);
					n->isconstraint  = TRUE;
					n->deferrable = ((yyvsp[(10) - (19)].ival) & 1) != 0;
					n->initdeferred = ((yyvsp[(10) - (19)].ival) & 2) != 0;

					n->constrrel = (yyvsp[(9) - (19)].range);
					(yyval.node) = (Node *)n;
				;}
    break;

  case 405:

/* Line 1455 of yacc.c  */
#line 2593 "gram.y"
    { (yyval.boolean) = TRUE; ;}
    break;

  case 406:

/* Line 1455 of yacc.c  */
#line 2594 "gram.y"
    { (yyval.boolean) = FALSE; ;}
    break;

  case 407:

/* Line 1455 of yacc.c  */
#line 2599 "gram.y"
    {
					char *e = palloc(4);
					e[0] = (yyvsp[(1) - (1)].chr); e[1] = '\0';
					(yyval.str) = e;
				;}
    break;

  case 408:

/* Line 1455 of yacc.c  */
#line 2605 "gram.y"
    {
					char *e = palloc(4);
					e[0] = (yyvsp[(1) - (3)].chr); e[1] = (yyvsp[(3) - (3)].chr); e[2] = '\0';
					(yyval.str) = e;
				;}
    break;

  case 409:

/* Line 1455 of yacc.c  */
#line 2611 "gram.y"
    {
					char *e = palloc(4);
					e[0] = (yyvsp[(1) - (5)].chr); e[1] = (yyvsp[(3) - (5)].chr); e[2] = (yyvsp[(5) - (5)].chr); e[3] = '\0';
					(yyval.str) = e;
				;}
    break;

  case 410:

/* Line 1455 of yacc.c  */
#line 2619 "gram.y"
    { (yyval.chr) = 'i'; ;}
    break;

  case 411:

/* Line 1455 of yacc.c  */
#line 2620 "gram.y"
    { (yyval.chr) = 'd'; ;}
    break;

  case 412:

/* Line 1455 of yacc.c  */
#line 2621 "gram.y"
    { (yyval.chr) = 'u'; ;}
    break;

  case 413:

/* Line 1455 of yacc.c  */
#line 2626 "gram.y"
    {
					(yyval.boolean) = (yyvsp[(3) - (3)].boolean);
				;}
    break;

  case 414:

/* Line 1455 of yacc.c  */
#line 2630 "gram.y"
    {
					/*
					 * If ROW/STATEMENT not specified, default to
					 * STATEMENT, per SQL
					 */
					(yyval.boolean) = FALSE;
				;}
    break;

  case 415:

/* Line 1455 of yacc.c  */
#line 2640 "gram.y"
    {;}
    break;

  case 416:

/* Line 1455 of yacc.c  */
#line 2641 "gram.y"
    {;}
    break;

  case 417:

/* Line 1455 of yacc.c  */
#line 2645 "gram.y"
    { (yyval.boolean) = TRUE; ;}
    break;

  case 418:

/* Line 1455 of yacc.c  */
#line 2646 "gram.y"
    { (yyval.boolean) = FALSE; ;}
    break;

  case 419:

/* Line 1455 of yacc.c  */
#line 2650 "gram.y"
    { (yyval.list) = list_make1((yyvsp[(1) - (1)].value)); ;}
    break;

  case 420:

/* Line 1455 of yacc.c  */
#line 2651 "gram.y"
    { (yyval.list) = lappend((yyvsp[(1) - (3)].list), (yyvsp[(3) - (3)].value)); ;}
    break;

  case 421:

/* Line 1455 of yacc.c  */
#line 2652 "gram.y"
    { (yyval.list) = NIL; ;}
    break;

  case 422:

/* Line 1455 of yacc.c  */
#line 2657 "gram.y"
    {
					char buf[64];
					snprintf(buf, sizeof(buf), "%d", (yyvsp[(1) - (1)].ival));
					(yyval.value) = makeString(pstrdup(buf));
				;}
    break;

  case 423:

/* Line 1455 of yacc.c  */
#line 2662 "gram.y"
    { (yyval.value) = makeString((yyvsp[(1) - (1)].str)); ;}
    break;

  case 424:

/* Line 1455 of yacc.c  */
#line 2663 "gram.y"
    { (yyval.value) = makeString((yyvsp[(1) - (1)].str)); ;}
    break;

  case 425:

/* Line 1455 of yacc.c  */
#line 2664 "gram.y"
    { (yyval.value) = makeString((yyvsp[(1) - (1)].str)); ;}
    break;

  case 426:

/* Line 1455 of yacc.c  */
#line 2665 "gram.y"
    { (yyval.value) = makeString((yyvsp[(1) - (1)].str)); ;}
    break;

  case 427:

/* Line 1455 of yacc.c  */
#line 2666 "gram.y"
    { (yyval.value) = makeString((yyvsp[(1) - (1)].str)); ;}
    break;

  case 428:

/* Line 1455 of yacc.c  */
#line 2670 "gram.y"
    { (yyval.range) = (yyvsp[(2) - (2)].range); ;}
    break;

  case 429:

/* Line 1455 of yacc.c  */
#line 2671 "gram.y"
    { (yyval.range) = NULL; ;}
    break;

  case 430:

/* Line 1455 of yacc.c  */
#line 2676 "gram.y"
    { (yyval.ival) = (yyvsp[(1) - (1)].ival); ;}
    break;

  case 431:

/* Line 1455 of yacc.c  */
#line 2678 "gram.y"
    {
					if ((yyvsp[(1) - (2)].ival) == 0 && (yyvsp[(2) - (2)].ival) != 0)
						ereport(ERROR,
								(errcode(ERRCODE_SYNTAX_ERROR),
								 errmsg("constraint declared INITIALLY DEFERRED must be DEFERRABLE")));
					(yyval.ival) = (yyvsp[(1) - (2)].ival) | (yyvsp[(2) - (2)].ival);
				;}
    break;

  case 432:

/* Line 1455 of yacc.c  */
#line 2686 "gram.y"
    {
					if ((yyvsp[(1) - (1)].ival) != 0)
						(yyval.ival) = 3;
					else
						(yyval.ival) = 0;
				;}
    break;

  case 433:

/* Line 1455 of yacc.c  */
#line 2693 "gram.y"
    {
					if ((yyvsp[(2) - (2)].ival) == 0 && (yyvsp[(1) - (2)].ival) != 0)
						ereport(ERROR,
								(errcode(ERRCODE_SYNTAX_ERROR),
								 errmsg("constraint declared INITIALLY DEFERRED must be DEFERRABLE")));
					(yyval.ival) = (yyvsp[(1) - (2)].ival) | (yyvsp[(2) - (2)].ival);
				;}
    break;

  case 434:

/* Line 1455 of yacc.c  */
#line 2701 "gram.y"
    { (yyval.ival) = 0; ;}
    break;

  case 435:

/* Line 1455 of yacc.c  */
#line 2705 "gram.y"
    { (yyval.ival) = 0; ;}
    break;

  case 436:

/* Line 1455 of yacc.c  */
#line 2706 "gram.y"
    { (yyval.ival) = 1; ;}
    break;

  case 437:

/* Line 1455 of yacc.c  */
#line 2710 "gram.y"
    { (yyval.ival) = 0; ;}
    break;

  case 438:

/* Line 1455 of yacc.c  */
#line 2711 "gram.y"
    { (yyval.ival) = 2; ;}
    break;

  case 439:

/* Line 1455 of yacc.c  */
#line 2717 "gram.y"
    {
					DropPropertyStmt *n = makeNode(DropPropertyStmt);
					n->relation = (yyvsp[(5) - (6)].range);
					n->property = (yyvsp[(3) - (6)].str);
					n->behavior = (yyvsp[(6) - (6)].dbehavior);
					n->removeType = OBJECT_TRIGGER;
					n->missing_ok = false;
					(yyval.node) = (Node *) n;
				;}
    break;

  case 440:

/* Line 1455 of yacc.c  */
#line 2727 "gram.y"
    {
					DropPropertyStmt *n = makeNode(DropPropertyStmt);
					n->relation = (yyvsp[(7) - (8)].range);
					n->property = (yyvsp[(5) - (8)].str);
					n->behavior = (yyvsp[(8) - (8)].dbehavior);
					n->removeType = OBJECT_TRIGGER;
					n->missing_ok = true;
					(yyval.node) = (Node *) n;
				;}
    break;

  case 441:

/* Line 1455 of yacc.c  */
#line 2750 "gram.y"
    {
					CreateTrigStmt *n = makeNode(CreateTrigStmt);
					n->trigname = (yyvsp[(3) - (8)].str);
					n->args = list_make1((yyvsp[(6) - (8)].node));
					n->isconstraint  = TRUE;
					n->deferrable = ((yyvsp[(8) - (8)].ival) & 1) != 0;
					n->initdeferred = ((yyvsp[(8) - (8)].ival) & 2) != 0;

					ereport(ERROR,
							(errcode(ERRCODE_FEATURE_NOT_SUPPORTED),
							 errmsg("CREATE ASSERTION is not yet implemented")));

					(yyval.node) = (Node *)n;
				;}
    break;

  case 442:

/* Line 1455 of yacc.c  */
#line 2768 "gram.y"
    {
					DropPropertyStmt *n = makeNode(DropPropertyStmt);
					n->relation = NULL;
					n->property = (yyvsp[(3) - (4)].str);
					n->behavior = (yyvsp[(4) - (4)].dbehavior);
					n->removeType = OBJECT_TRIGGER; /* XXX */
					ereport(ERROR,
							(errcode(ERRCODE_FEATURE_NOT_SUPPORTED),
							 errmsg("DROP ASSERTION is not yet implemented")));
					(yyval.node) = (Node *) n;
				;}
    break;

  case 443:

/* Line 1455 of yacc.c  */
#line 2791 "gram.y"
    {
					DefineStmt *n = makeNode(DefineStmt);
					n->kind = OBJECT_AGGREGATE;
					n->oldstyle = false;
					n->defnames = (yyvsp[(3) - (5)].list);
					n->args = (yyvsp[(4) - (5)].list);
					n->definition = (yyvsp[(5) - (5)].list);
					(yyval.node) = (Node *)n;
				;}
    break;

  case 444:

/* Line 1455 of yacc.c  */
#line 2801 "gram.y"
    {
					/* old-style (pre-8.2) syntax for CREATE AGGREGATE */
					DefineStmt *n = makeNode(DefineStmt);
					n->kind = OBJECT_AGGREGATE;
					n->oldstyle = true;
					n->defnames = (yyvsp[(3) - (4)].list);
					n->args = NIL;
					n->definition = (yyvsp[(4) - (4)].list);
					(yyval.node) = (Node *)n;
				;}
    break;

  case 445:

/* Line 1455 of yacc.c  */
#line 2812 "gram.y"
    {
					DefineStmt *n = makeNode(DefineStmt);
					n->kind = OBJECT_OPERATOR;
					n->oldstyle = false;
					n->defnames = (yyvsp[(3) - (4)].list);
					n->args = NIL;
					n->definition = (yyvsp[(4) - (4)].list);
					(yyval.node) = (Node *)n;
				;}
    break;

  case 446:

/* Line 1455 of yacc.c  */
#line 2822 "gram.y"
    {
					DefineStmt *n = makeNode(DefineStmt);
					n->kind = OBJECT_TYPE;
					n->oldstyle = false;
					n->defnames = (yyvsp[(3) - (4)].list);
					n->args = NIL;
					n->definition = (yyvsp[(4) - (4)].list);
					(yyval.node) = (Node *)n;
				;}
    break;

  case 447:

/* Line 1455 of yacc.c  */
#line 2832 "gram.y"
    {
					/* Shell type (identified by lack of definition) */
					DefineStmt *n = makeNode(DefineStmt);
					n->kind = OBJECT_TYPE;
					n->oldstyle = false;
					n->defnames = (yyvsp[(3) - (3)].list);
					n->args = NIL;
					n->definition = NIL;
					(yyval.node) = (Node *)n;
				;}
    break;

  case 448:

/* Line 1455 of yacc.c  */
#line 2843 "gram.y"
    {
					CompositeTypeStmt *n = makeNode(CompositeTypeStmt);
					RangeVar *r = makeNode(RangeVar);

					/* can't use qualified_name, sigh */
					switch (list_length((yyvsp[(3) - (7)].list)))
					{
						case 1:
							r->catalogname = NULL;
							r->schemaname = NULL;
							r->relname = strVal(linitial((yyvsp[(3) - (7)].list)));
							break;
						case 2:
							r->catalogname = NULL;
							r->schemaname = strVal(linitial((yyvsp[(3) - (7)].list)));
							r->relname = strVal(lsecond((yyvsp[(3) - (7)].list)));
							break;
						case 3:
							r->catalogname = strVal(linitial((yyvsp[(3) - (7)].list)));
							r->schemaname = strVal(lsecond((yyvsp[(3) - (7)].list)));
							r->relname = strVal(lthird((yyvsp[(3) - (7)].list)));
							break;
						default:
							ereport(ERROR,
									(errcode(ERRCODE_SYNTAX_ERROR),
									 errmsg("improper qualified name (too many dotted names): %s",
											NameListToString((yyvsp[(3) - (7)].list)))));
							break;
					}
					n->typevar = r;
					n->coldeflist = (yyvsp[(6) - (7)].list);
					(yyval.node) = (Node *)n;
				;}
    break;

  case 449:

/* Line 1455 of yacc.c  */
#line 2878 "gram.y"
    { (yyval.list) = (yyvsp[(2) - (3)].list); ;}
    break;

  case 450:

/* Line 1455 of yacc.c  */
#line 2881 "gram.y"
    { (yyval.list) = list_make1((yyvsp[(1) - (1)].defelt)); ;}
    break;

  case 451:

/* Line 1455 of yacc.c  */
#line 2882 "gram.y"
    { (yyval.list) = lappend((yyvsp[(1) - (3)].list), (yyvsp[(3) - (3)].defelt)); ;}
    break;

  case 452:

/* Line 1455 of yacc.c  */
#line 2886 "gram.y"
    {
					(yyval.defelt) = makeDefElem((yyvsp[(1) - (3)].str), (Node *)(yyvsp[(3) - (3)].node));
				;}
    break;

  case 453:

/* Line 1455 of yacc.c  */
#line 2890 "gram.y"
    {
					(yyval.defelt) = makeDefElem((yyvsp[(1) - (1)].str), NULL);
				;}
    break;

  case 454:

/* Line 1455 of yacc.c  */
#line 2896 "gram.y"
    { (yyval.node) = (Node *)(yyvsp[(1) - (1)].typnam); ;}
    break;

  case 455:

/* Line 1455 of yacc.c  */
#line 2897 "gram.y"
    { (yyval.node) = (Node *)makeString(pstrdup((yyvsp[(1) - (1)].keyword))); ;}
    break;

  case 456:

/* Line 1455 of yacc.c  */
#line 2898 "gram.y"
    { (yyval.node) = (Node *)makeString(pstrdup((yyvsp[(1) - (1)].keyword))); ;}
    break;

  case 457:

/* Line 1455 of yacc.c  */
#line 2899 "gram.y"
    { (yyval.node) = (Node *)(yyvsp[(1) - (1)].list); ;}
    break;

  case 458:

/* Line 1455 of yacc.c  */
#line 2900 "gram.y"
    { (yyval.node) = (Node *)(yyvsp[(1) - (1)].value); ;}
    break;

  case 459:

/* Line 1455 of yacc.c  */
#line 2901 "gram.y"
    { (yyval.node) = (Node *)makeString((yyvsp[(1) - (1)].str)); ;}
    break;

  case 460:

/* Line 1455 of yacc.c  */
#line 2904 "gram.y"
    { (yyval.list) = (yyvsp[(2) - (3)].list); ;}
    break;

  case 461:

/* Line 1455 of yacc.c  */
#line 2905 "gram.y"
    { (yyval.list) = NIL; ;}
    break;

  case 462:

/* Line 1455 of yacc.c  */
#line 2909 "gram.y"
    { (yyval.list) = list_make1((yyvsp[(1) - (1)].typnam)); ;}
    break;

  case 463:

/* Line 1455 of yacc.c  */
#line 2910 "gram.y"
    { (yyval.list) = lappend((yyvsp[(1) - (3)].list), (yyvsp[(3) - (3)].typnam)); ;}
    break;

  case 464:

/* Line 1455 of yacc.c  */
#line 2913 "gram.y"
    { (yyval.list) = (yyvsp[(2) - (3)].list); ;}
    break;

  case 465:

/* Line 1455 of yacc.c  */
#line 2916 "gram.y"
    { (yyval.list) = list_make1((yyvsp[(1) - (1)].defelt)); ;}
    break;

  case 466:

/* Line 1455 of yacc.c  */
#line 2917 "gram.y"
    { (yyval.list) = lappend((yyvsp[(1) - (3)].list), (yyvsp[(3) - (3)].defelt)); ;}
    break;

  case 467:

/* Line 1455 of yacc.c  */
#line 2921 "gram.y"
    {
					(yyval.defelt) = makeDefElem((yyvsp[(1) - (3)].str), (Node *)(yyvsp[(3) - (3)].node));
				;}
    break;

  case 468:

/* Line 1455 of yacc.c  */
#line 2938 "gram.y"
    {
					CreateOpClassStmt *n = makeNode(CreateOpClassStmt);
					n->opclassname = (yyvsp[(4) - (12)].list);
					n->isDefault = (yyvsp[(5) - (12)].boolean);
					n->datatype = (yyvsp[(8) - (12)].typnam);
					n->amname = (yyvsp[(10) - (12)].str);
					n->items = (yyvsp[(12) - (12)].list);
					(yyval.node) = (Node *) n;
				;}
    break;

  case 469:

/* Line 1455 of yacc.c  */
#line 2950 "gram.y"
    { (yyval.list) = list_make1((yyvsp[(1) - (1)].node)); ;}
    break;

  case 470:

/* Line 1455 of yacc.c  */
#line 2951 "gram.y"
    { (yyval.list) = lappend((yyvsp[(1) - (3)].list), (yyvsp[(3) - (3)].node)); ;}
    break;

  case 471:

/* Line 1455 of yacc.c  */
#line 2956 "gram.y"
    {
					CreateOpClassItem *n = makeNode(CreateOpClassItem);
					n->itemtype = OPCLASS_ITEM_OPERATOR;
					n->name = (yyvsp[(3) - (4)].list);
					n->args = NIL;
					n->number = (yyvsp[(2) - (4)].ival);
					n->recheck = (yyvsp[(4) - (4)].boolean);
					(yyval.node) = (Node *) n;
				;}
    break;

  case 472:

/* Line 1455 of yacc.c  */
#line 2966 "gram.y"
    {
					CreateOpClassItem *n = makeNode(CreateOpClassItem);
					n->itemtype = OPCLASS_ITEM_OPERATOR;
					n->name = (yyvsp[(3) - (7)].list);
					n->args = (yyvsp[(5) - (7)].list);
					n->number = (yyvsp[(2) - (7)].ival);
					n->recheck = (yyvsp[(7) - (7)].boolean);
					(yyval.node) = (Node *) n;
				;}
    break;

  case 473:

/* Line 1455 of yacc.c  */
#line 2976 "gram.y"
    {
					CreateOpClassItem *n = makeNode(CreateOpClassItem);
					n->itemtype = OPCLASS_ITEM_FUNCTION;
					n->name = (yyvsp[(3) - (4)].list);
					n->args = extractArgTypes((yyvsp[(4) - (4)].list));
					n->number = (yyvsp[(2) - (4)].ival);
					(yyval.node) = (Node *) n;
				;}
    break;

  case 474:

/* Line 1455 of yacc.c  */
#line 2985 "gram.y"
    {
					CreateOpClassItem *n = makeNode(CreateOpClassItem);
					n->itemtype = OPCLASS_ITEM_STORAGETYPE;
					n->storedtype = (yyvsp[(2) - (2)].typnam);
					(yyval.node) = (Node *) n;
				;}
    break;

  case 475:

/* Line 1455 of yacc.c  */
#line 2993 "gram.y"
    { (yyval.boolean) = TRUE; ;}
    break;

  case 476:

/* Line 1455 of yacc.c  */
#line 2994 "gram.y"
    { (yyval.boolean) = FALSE; ;}
    break;

  case 477:

/* Line 1455 of yacc.c  */
#line 2997 "gram.y"
    { (yyval.boolean) = TRUE; ;}
    break;

  case 478:

/* Line 1455 of yacc.c  */
#line 2998 "gram.y"
    { (yyval.boolean) = FALSE; ;}
    break;

  case 479:

/* Line 1455 of yacc.c  */
#line 3004 "gram.y"
    {
					RemoveOpClassStmt *n = makeNode(RemoveOpClassStmt);
					n->opclassname = (yyvsp[(4) - (7)].list);
					n->amname = (yyvsp[(6) - (7)].str);
					n->behavior = (yyvsp[(7) - (7)].dbehavior);
					n->missing_ok = false;
					(yyval.node) = (Node *) n;
				;}
    break;

  case 480:

/* Line 1455 of yacc.c  */
#line 3013 "gram.y"
    {
					RemoveOpClassStmt *n = makeNode(RemoveOpClassStmt);
					n->opclassname = (yyvsp[(6) - (9)].list);
					n->amname = (yyvsp[(8) - (9)].str);
					n->behavior = (yyvsp[(9) - (9)].dbehavior);
					n->missing_ok = true;
					(yyval.node) = (Node *) n;
				;}
    break;

  case 481:

/* Line 1455 of yacc.c  */
#line 3033 "gram.y"
    {
					DropOwnedStmt *n = makeNode(DropOwnedStmt);
					n->roles = (yyvsp[(4) - (5)].list);
					n->behavior = (yyvsp[(5) - (5)].dbehavior);
					(yyval.node) = (Node *)n;
				;}
    break;

  case 482:

/* Line 1455 of yacc.c  */
#line 3043 "gram.y"
    {
					ReassignOwnedStmt *n = makeNode(ReassignOwnedStmt);
					n->roles = (yyvsp[(4) - (6)].list);
					n->newrole = (yyvsp[(6) - (6)].str);
					(yyval.node) = (Node *)n;
				;}
    break;

  case 483:

/* Line 1455 of yacc.c  */
#line 3061 "gram.y"
    {
					DropStmt *n = makeNode(DropStmt);
					n->removeType = (yyvsp[(2) - (6)].objtype);
					n->missing_ok = TRUE;
					n->objects = (yyvsp[(5) - (6)].list);
					n->behavior = (yyvsp[(6) - (6)].dbehavior);
					(yyval.node) = (Node *)n;
				;}
    break;

  case 484:

/* Line 1455 of yacc.c  */
#line 3070 "gram.y"
    {
					DropStmt *n = makeNode(DropStmt);
					n->removeType = (yyvsp[(2) - (4)].objtype);
					n->missing_ok = FALSE;
					n->objects = (yyvsp[(3) - (4)].list);
					n->behavior = (yyvsp[(4) - (4)].dbehavior);
					(yyval.node) = (Node *)n;
				;}
    break;

  case 485:

/* Line 1455 of yacc.c  */
#line 3081 "gram.y"
    { (yyval.objtype) = OBJECT_TABLE; ;}
    break;

  case 486:

/* Line 1455 of yacc.c  */
#line 3082 "gram.y"
    { (yyval.objtype) = OBJECT_SEQUENCE; ;}
    break;

  case 487:

/* Line 1455 of yacc.c  */
#line 3083 "gram.y"
    { (yyval.objtype) = OBJECT_VIEW; ;}
    break;

  case 488:

/* Line 1455 of yacc.c  */
#line 3084 "gram.y"
    { (yyval.objtype) = OBJECT_INDEX; ;}
    break;

  case 489:

/* Line 1455 of yacc.c  */
#line 3085 "gram.y"
    { (yyval.objtype) = OBJECT_TYPE; ;}
    break;

  case 490:

/* Line 1455 of yacc.c  */
#line 3086 "gram.y"
    { (yyval.objtype) = OBJECT_DOMAIN; ;}
    break;

  case 491:

/* Line 1455 of yacc.c  */
#line 3087 "gram.y"
    { (yyval.objtype) = OBJECT_CONVERSION; ;}
    break;

  case 492:

/* Line 1455 of yacc.c  */
#line 3088 "gram.y"
    { (yyval.objtype) = OBJECT_SCHEMA; ;}
    break;

  case 493:

/* Line 1455 of yacc.c  */
#line 3092 "gram.y"
    { (yyval.list) = list_make1((yyvsp[(1) - (1)].list)); ;}
    break;

  case 494:

/* Line 1455 of yacc.c  */
#line 3093 "gram.y"
    { (yyval.list) = lappend((yyvsp[(1) - (3)].list), (yyvsp[(3) - (3)].list)); ;}
    break;

  case 495:

/* Line 1455 of yacc.c  */
#line 3096 "gram.y"
    { (yyval.list) = list_make1(makeString((yyvsp[(1) - (1)].str))); ;}
    break;

  case 496:

/* Line 1455 of yacc.c  */
#line 3097 "gram.y"
    { (yyval.list) = lcons(makeString((yyvsp[(1) - (2)].str)), (yyvsp[(2) - (2)].list)); ;}
    break;

  case 497:

/* Line 1455 of yacc.c  */
#line 3101 "gram.y"
    { (yyval.list) = list_make1(makeString((yyvsp[(2) - (2)].str))); ;}
    break;

  case 498:

/* Line 1455 of yacc.c  */
#line 3103 "gram.y"
    { (yyval.list) = lappend((yyvsp[(1) - (3)].list), makeString((yyvsp[(3) - (3)].str))); ;}
    break;

  case 499:

/* Line 1455 of yacc.c  */
#line 3116 "gram.y"
    {
					TruncateStmt *n = makeNode(TruncateStmt);
					n->relations = (yyvsp[(3) - (4)].list);
					n->behavior = (yyvsp[(4) - (4)].dbehavior);
					(yyval.node) = (Node *)n;
				;}
    break;

  case 500:

/* Line 1455 of yacc.c  */
#line 3144 "gram.y"
    {
					CommentStmt *n = makeNode(CommentStmt);
					n->objtype = (yyvsp[(3) - (6)].objtype);
					n->objname = (yyvsp[(4) - (6)].list);
					n->objargs = NIL;
					n->comment = (yyvsp[(6) - (6)].str);
					(yyval.node) = (Node *) n;
				;}
    break;

  case 501:

/* Line 1455 of yacc.c  */
#line 3153 "gram.y"
    {
					CommentStmt *n = makeNode(CommentStmt);
					n->objtype = OBJECT_AGGREGATE;
					n->objname = (yyvsp[(4) - (7)].list);
					n->objargs = (yyvsp[(5) - (7)].list);
					n->comment = (yyvsp[(7) - (7)].str);
					(yyval.node) = (Node *) n;
				;}
    break;

  case 502:

/* Line 1455 of yacc.c  */
#line 3162 "gram.y"
    {
					CommentStmt *n = makeNode(CommentStmt);
					n->objtype = OBJECT_FUNCTION;
					n->objname = (yyvsp[(4) - (7)].list);
					n->objargs = extractArgTypes((yyvsp[(5) - (7)].list));
					n->comment = (yyvsp[(7) - (7)].str);
					(yyval.node) = (Node *) n;
				;}
    break;

  case 503:

/* Line 1455 of yacc.c  */
#line 3172 "gram.y"
    {
					CommentStmt *n = makeNode(CommentStmt);
					n->objtype = OBJECT_OPERATOR;
					n->objname = (yyvsp[(4) - (9)].list);
					n->objargs = (yyvsp[(6) - (9)].list);
					n->comment = (yyvsp[(9) - (9)].str);
					(yyval.node) = (Node *) n;
				;}
    break;

  case 504:

/* Line 1455 of yacc.c  */
#line 3181 "gram.y"
    {
					CommentStmt *n = makeNode(CommentStmt);
					n->objtype = OBJECT_CONSTRAINT;
					n->objname = lappend((yyvsp[(6) - (8)].list), makeString((yyvsp[(4) - (8)].str)));
					n->objargs = NIL;
					n->comment = (yyvsp[(8) - (8)].str);
					(yyval.node) = (Node *) n;
				;}
    break;

  case 505:

/* Line 1455 of yacc.c  */
#line 3190 "gram.y"
    {
					CommentStmt *n = makeNode(CommentStmt);
					n->objtype = OBJECT_RULE;
					n->objname = lappend((yyvsp[(6) - (8)].list), makeString((yyvsp[(4) - (8)].str)));
					n->objargs = NIL;
					n->comment = (yyvsp[(8) - (8)].str);
					(yyval.node) = (Node *) n;
				;}
    break;

  case 506:

/* Line 1455 of yacc.c  */
#line 3199 "gram.y"
    {
					/* Obsolete syntax supported for awhile for compatibility */
					CommentStmt *n = makeNode(CommentStmt);
					n->objtype = OBJECT_RULE;
					n->objname = list_make1(makeString((yyvsp[(4) - (6)].str)));
					n->objargs = NIL;
					n->comment = (yyvsp[(6) - (6)].str);
					(yyval.node) = (Node *) n;
				;}
    break;

  case 507:

/* Line 1455 of yacc.c  */
#line 3209 "gram.y"
    {
					CommentStmt *n = makeNode(CommentStmt);
					n->objtype = OBJECT_TRIGGER;
					n->objname = lappend((yyvsp[(6) - (8)].list), makeString((yyvsp[(4) - (8)].str)));
					n->objargs = NIL;
					n->comment = (yyvsp[(8) - (8)].str);
					(yyval.node) = (Node *) n;
				;}
    break;

  case 508:

/* Line 1455 of yacc.c  */
#line 3218 "gram.y"
    {
					CommentStmt *n = makeNode(CommentStmt);
					n->objtype = OBJECT_OPCLASS;
					n->objname = (yyvsp[(5) - (9)].list);
					n->objargs = list_make1(makeString((yyvsp[(7) - (9)].str)));
					n->comment = (yyvsp[(9) - (9)].str);
					(yyval.node) = (Node *) n;
				;}
    break;

  case 509:

/* Line 1455 of yacc.c  */
#line 3227 "gram.y"
    {
					CommentStmt *n = makeNode(CommentStmt);
					n->objtype = OBJECT_LARGEOBJECT;
					n->objname = list_make1((yyvsp[(5) - (7)].value));
					n->objargs = NIL;
					n->comment = (yyvsp[(7) - (7)].str);
					(yyval.node) = (Node *) n;
				;}
    break;

  case 510:

/* Line 1455 of yacc.c  */
#line 3236 "gram.y"
    {
					CommentStmt *n = makeNode(CommentStmt);
					n->objtype = OBJECT_CAST;
					n->objname = list_make1((yyvsp[(5) - (10)].typnam));
					n->objargs = list_make1((yyvsp[(7) - (10)].typnam));
					n->comment = (yyvsp[(10) - (10)].str);
					(yyval.node) = (Node *) n;
				;}
    break;

  case 511:

/* Line 1455 of yacc.c  */
#line 3245 "gram.y"
    {
					CommentStmt *n = makeNode(CommentStmt);
					n->objtype = OBJECT_LANGUAGE;
					n->objname = (yyvsp[(5) - (7)].list);
					n->objargs = NIL;
					n->comment = (yyvsp[(7) - (7)].str);
					(yyval.node) = (Node *) n;
				;}
    break;

  case 512:

/* Line 1455 of yacc.c  */
#line 3256 "gram.y"
    { (yyval.objtype) = OBJECT_COLUMN; ;}
    break;

  case 513:

/* Line 1455 of yacc.c  */
#line 3257 "gram.y"
    { (yyval.objtype) = OBJECT_DATABASE; ;}
    break;

  case 514:

/* Line 1455 of yacc.c  */
#line 3258 "gram.y"
    { (yyval.objtype) = OBJECT_SCHEMA; ;}
    break;

  case 515:

/* Line 1455 of yacc.c  */
#line 3259 "gram.y"
    { (yyval.objtype) = OBJECT_INDEX; ;}
    break;

  case 516:

/* Line 1455 of yacc.c  */
#line 3260 "gram.y"
    { (yyval.objtype) = OBJECT_SEQUENCE; ;}
    break;

  case 517:

/* Line 1455 of yacc.c  */
#line 3261 "gram.y"
    { (yyval.objtype) = OBJECT_TABLE; ;}
    break;

  case 518:

/* Line 1455 of yacc.c  */
#line 3262 "gram.y"
    { (yyval.objtype) = OBJECT_TYPE; ;}
    break;

  case 519:

/* Line 1455 of yacc.c  */
#line 3263 "gram.y"
    { (yyval.objtype) = OBJECT_TYPE; ;}
    break;

  case 520:

/* Line 1455 of yacc.c  */
#line 3264 "gram.y"
    { (yyval.objtype) = OBJECT_VIEW; ;}
    break;

  case 521:

/* Line 1455 of yacc.c  */
#line 3265 "gram.y"
    { (yyval.objtype) = OBJECT_CONVERSION; ;}
    break;

  case 522:

/* Line 1455 of yacc.c  */
#line 3266 "gram.y"
    { (yyval.objtype) = OBJECT_TABLESPACE; ;}
    break;

  case 523:

/* Line 1455 of yacc.c  */
#line 3267 "gram.y"
    { (yyval.objtype) = OBJECT_ROLE; ;}
    break;

  case 524:

/* Line 1455 of yacc.c  */
#line 3271 "gram.y"
    { (yyval.str) = (yyvsp[(1) - (1)].str); ;}
    break;

  case 525:

/* Line 1455 of yacc.c  */
#line 3272 "gram.y"
    { (yyval.str) = NULL; ;}
    break;

  case 526:

/* Line 1455 of yacc.c  */
#line 3283 "gram.y"
    {
					FetchStmt *n = (FetchStmt *) (yyvsp[(2) - (4)].node);
					n->portalname = (yyvsp[(4) - (4)].str);
					n->ismove = FALSE;
					(yyval.node) = (Node *)n;
				;}
    break;

  case 527:

/* Line 1455 of yacc.c  */
#line 3290 "gram.y"
    {
					FetchStmt *n = makeNode(FetchStmt);
					n->direction = FETCH_FORWARD;
					n->howMany = 1;
					n->portalname = (yyvsp[(2) - (2)].str);
					n->ismove = FALSE;
					(yyval.node) = (Node *)n;
				;}
    break;

  case 528:

/* Line 1455 of yacc.c  */
#line 3299 "gram.y"
    {
					FetchStmt *n = (FetchStmt *) (yyvsp[(2) - (4)].node);
					n->portalname = (yyvsp[(4) - (4)].str);
					n->ismove = TRUE;
					(yyval.node) = (Node *)n;
				;}
    break;

  case 529:

/* Line 1455 of yacc.c  */
#line 3306 "gram.y"
    {
					FetchStmt *n = makeNode(FetchStmt);
					n->direction = FETCH_FORWARD;
					n->howMany = 1;
					n->portalname = (yyvsp[(2) - (2)].str);
					n->ismove = TRUE;
					(yyval.node) = (Node *)n;
				;}
    break;

  case 530:

/* Line 1455 of yacc.c  */
#line 3318 "gram.y"
    {
					FetchStmt *n = makeNode(FetchStmt);
					n->direction = FETCH_FORWARD;
					n->howMany = 1;
					(yyval.node) = (Node *)n;
				;}
    break;

  case 531:

/* Line 1455 of yacc.c  */
#line 3325 "gram.y"
    {
					FetchStmt *n = makeNode(FetchStmt);
					n->direction = FETCH_FORWARD;
					n->howMany = 1;
					(yyval.node) = (Node *)n;
				;}
    break;

  case 532:

/* Line 1455 of yacc.c  */
#line 3332 "gram.y"
    {
					FetchStmt *n = makeNode(FetchStmt);
					n->direction = FETCH_BACKWARD;
					n->howMany = 1;
					(yyval.node) = (Node *)n;
				;}
    break;

  case 533:

/* Line 1455 of yacc.c  */
#line 3339 "gram.y"
    {
					FetchStmt *n = makeNode(FetchStmt);
					n->direction = FETCH_ABSOLUTE;
					n->howMany = 1;
					(yyval.node) = (Node *)n;
				;}
    break;

  case 534:

/* Line 1455 of yacc.c  */
#line 3346 "gram.y"
    {
					FetchStmt *n = makeNode(FetchStmt);
					n->direction = FETCH_ABSOLUTE;
					n->howMany = -1;
					(yyval.node) = (Node *)n;
				;}
    break;

  case 535:

/* Line 1455 of yacc.c  */
#line 3353 "gram.y"
    {
					FetchStmt *n = makeNode(FetchStmt);
					n->direction = FETCH_ABSOLUTE;
					n->howMany = (yyvsp[(2) - (2)].ival);
					(yyval.node) = (Node *)n;
				;}
    break;

  case 536:

/* Line 1455 of yacc.c  */
#line 3360 "gram.y"
    {
					FetchStmt *n = makeNode(FetchStmt);
					n->direction = FETCH_RELATIVE;
					n->howMany = (yyvsp[(2) - (2)].ival);
					(yyval.node) = (Node *)n;
				;}
    break;

  case 537:

/* Line 1455 of yacc.c  */
#line 3367 "gram.y"
    {
					FetchStmt *n = makeNode(FetchStmt);
					n->direction = FETCH_FORWARD;
					n->howMany = (yyvsp[(1) - (1)].ival);
					(yyval.node) = (Node *)n;
				;}
    break;

  case 538:

/* Line 1455 of yacc.c  */
#line 3374 "gram.y"
    {
					FetchStmt *n = makeNode(FetchStmt);
					n->direction = FETCH_FORWARD;
					n->howMany = FETCH_ALL;
					(yyval.node) = (Node *)n;
				;}
    break;

  case 539:

/* Line 1455 of yacc.c  */
#line 3381 "gram.y"
    {
					FetchStmt *n = makeNode(FetchStmt);
					n->direction = FETCH_FORWARD;
					n->howMany = 1;
					(yyval.node) = (Node *)n;
				;}
    break;

  case 540:

/* Line 1455 of yacc.c  */
#line 3388 "gram.y"
    {
					FetchStmt *n = makeNode(FetchStmt);
					n->direction = FETCH_FORWARD;
					n->howMany = (yyvsp[(2) - (2)].ival);
					(yyval.node) = (Node *)n;
				;}
    break;

  case 541:

/* Line 1455 of yacc.c  */
#line 3395 "gram.y"
    {
					FetchStmt *n = makeNode(FetchStmt);
					n->direction = FETCH_FORWARD;
					n->howMany = FETCH_ALL;
					(yyval.node) = (Node *)n;
				;}
    break;

  case 542:

/* Line 1455 of yacc.c  */
#line 3402 "gram.y"
    {
					FetchStmt *n = makeNode(FetchStmt);
					n->direction = FETCH_BACKWARD;
					n->howMany = 1;
					(yyval.node) = (Node *)n;
				;}
    break;

  case 543:

/* Line 1455 of yacc.c  */
#line 3409 "gram.y"
    {
					FetchStmt *n = makeNode(FetchStmt);
					n->direction = FETCH_BACKWARD;
					n->howMany = (yyvsp[(2) - (2)].ival);
					(yyval.node) = (Node *)n;
				;}
    break;

  case 544:

/* Line 1455 of yacc.c  */
#line 3416 "gram.y"
    {
					FetchStmt *n = makeNode(FetchStmt);
					n->direction = FETCH_BACKWARD;
					n->howMany = FETCH_ALL;
					(yyval.node) = (Node *)n;
				;}
    break;

  case 545:

/* Line 1455 of yacc.c  */
#line 3424 "gram.y"
    {;}
    break;

  case 546:

/* Line 1455 of yacc.c  */
#line 3425 "gram.y"
    {;}
    break;

  case 547:

/* Line 1455 of yacc.c  */
#line 3437 "gram.y"
    {
					GrantStmt *n = makeNode(GrantStmt);
					n->is_grant = true;
					n->privileges = (yyvsp[(2) - (7)].list);
					n->objtype = ((yyvsp[(4) - (7)].privtarget))->objtype;
					n->objects = ((yyvsp[(4) - (7)].privtarget))->objs;
					n->grantees = (yyvsp[(6) - (7)].list);
					n->grant_option = (yyvsp[(7) - (7)].boolean);
					(yyval.node) = (Node*)n;
				;}
    break;

  case 548:

/* Line 1455 of yacc.c  */
#line 3452 "gram.y"
    {
					GrantStmt *n = makeNode(GrantStmt);
					n->is_grant = false;
					n->grant_option = false;
					n->privileges = (yyvsp[(2) - (7)].list);
					n->objtype = ((yyvsp[(4) - (7)].privtarget))->objtype;
					n->objects = ((yyvsp[(4) - (7)].privtarget))->objs;
					n->grantees = (yyvsp[(6) - (7)].list);
					n->behavior = (yyvsp[(7) - (7)].dbehavior);
					(yyval.node) = (Node *)n;
				;}
    break;

  case 549:

/* Line 1455 of yacc.c  */
#line 3465 "gram.y"
    {
					GrantStmt *n = makeNode(GrantStmt);
					n->is_grant = false;
					n->grant_option = true;
					n->privileges = (yyvsp[(5) - (10)].list);
					n->objtype = ((yyvsp[(7) - (10)].privtarget))->objtype;
					n->objects = ((yyvsp[(7) - (10)].privtarget))->objs;
					n->grantees = (yyvsp[(9) - (10)].list);
					n->behavior = (yyvsp[(10) - (10)].dbehavior);
					(yyval.node) = (Node *)n;
				;}
    break;

  case 550:

/* Line 1455 of yacc.c  */
#line 3490 "gram.y"
    { (yyval.list) = (yyvsp[(1) - (1)].list); ;}
    break;

  case 551:

/* Line 1455 of yacc.c  */
#line 3492 "gram.y"
    { (yyval.list) = NIL; ;}
    break;

  case 552:

/* Line 1455 of yacc.c  */
#line 3494 "gram.y"
    { (yyval.list) = NIL; ;}
    break;

  case 553:

/* Line 1455 of yacc.c  */
#line 3498 "gram.y"
    { (yyval.list) = list_make1(makeString((yyvsp[(1) - (1)].str))); ;}
    break;

  case 554:

/* Line 1455 of yacc.c  */
#line 3500 "gram.y"
    { (yyval.list) = lappend((yyvsp[(1) - (3)].list), makeString((yyvsp[(3) - (3)].str))); ;}
    break;

  case 555:

/* Line 1455 of yacc.c  */
#line 3503 "gram.y"
    { (yyval.str) = pstrdup((yyvsp[(1) - (1)].keyword)); ;}
    break;

  case 556:

/* Line 1455 of yacc.c  */
#line 3504 "gram.y"
    { (yyval.str) = pstrdup((yyvsp[(1) - (1)].keyword)); ;}
    break;

  case 557:

/* Line 1455 of yacc.c  */
#line 3505 "gram.y"
    { (yyval.str) = pstrdup((yyvsp[(1) - (1)].keyword)); ;}
    break;

  case 558:

/* Line 1455 of yacc.c  */
#line 3506 "gram.y"
    { (yyval.str) = (yyvsp[(1) - (1)].str); ;}
    break;

  case 559:

/* Line 1455 of yacc.c  */
#line 3515 "gram.y"
    {
					PrivTarget *n = makeNode(PrivTarget);
					n->objtype = ACL_OBJECT_RELATION;
					n->objs = (yyvsp[(1) - (1)].list);
					(yyval.privtarget) = n;
				;}
    break;

  case 560:

/* Line 1455 of yacc.c  */
#line 3522 "gram.y"
    {
					PrivTarget *n = makeNode(PrivTarget);
					n->objtype = ACL_OBJECT_RELATION;
					n->objs = (yyvsp[(2) - (2)].list);
					(yyval.privtarget) = n;
				;}
    break;

  case 561:

/* Line 1455 of yacc.c  */
#line 3529 "gram.y"
    {
					PrivTarget *n = makeNode(PrivTarget);
					n->objtype = ACL_OBJECT_SEQUENCE;
					n->objs = (yyvsp[(2) - (2)].list);
					(yyval.privtarget) = n;
				;}
    break;

  case 562:

/* Line 1455 of yacc.c  */
#line 3536 "gram.y"
    {
					PrivTarget *n = makeNode(PrivTarget);
					n->objtype = ACL_OBJECT_FUNCTION;
					n->objs = (yyvsp[(2) - (2)].list);
					(yyval.privtarget) = n;
				;}
    break;

  case 563:

/* Line 1455 of yacc.c  */
#line 3543 "gram.y"
    {
					PrivTarget *n = makeNode(PrivTarget);
					n->objtype = ACL_OBJECT_DATABASE;
					n->objs = (yyvsp[(2) - (2)].list);
					(yyval.privtarget) = n;
				;}
    break;

  case 564:

/* Line 1455 of yacc.c  */
#line 3550 "gram.y"
    {
					PrivTarget *n = makeNode(PrivTarget);
					n->objtype = ACL_OBJECT_LANGUAGE;
					n->objs = (yyvsp[(2) - (2)].list);
					(yyval.privtarget) = n;
				;}
    break;

  case 565:

/* Line 1455 of yacc.c  */
#line 3557 "gram.y"
    {
					PrivTarget *n = makeNode(PrivTarget);
					n->objtype = ACL_OBJECT_NAMESPACE;
					n->objs = (yyvsp[(2) - (2)].list);
					(yyval.privtarget) = n;
				;}
    break;

  case 566:

/* Line 1455 of yacc.c  */
#line 3564 "gram.y"
    {
					PrivTarget *n = makeNode(PrivTarget);
					n->objtype = ACL_OBJECT_TABLESPACE;
					n->objs = (yyvsp[(2) - (2)].list);
					(yyval.privtarget) = n;
				;}
    break;

  case 567:

/* Line 1455 of yacc.c  */
#line 3574 "gram.y"
    { (yyval.list) = list_make1((yyvsp[(1) - (1)].node)); ;}
    break;

  case 568:

/* Line 1455 of yacc.c  */
#line 3575 "gram.y"
    { (yyval.list) = lappend((yyvsp[(1) - (3)].list), (yyvsp[(3) - (3)].node)); ;}
    break;

  case 569:

/* Line 1455 of yacc.c  */
#line 3579 "gram.y"
    {
					PrivGrantee *n = makeNode(PrivGrantee);
					/* This hack lets us avoid reserving PUBLIC as a keyword*/
					if (strcmp((yyvsp[(1) - (1)].str), "public") == 0)
						n->rolname = NULL;
					else
						n->rolname = (yyvsp[(1) - (1)].str);
					(yyval.node) = (Node *)n;
				;}
    break;

  case 570:

/* Line 1455 of yacc.c  */
#line 3589 "gram.y"
    {
					PrivGrantee *n = makeNode(PrivGrantee);
					/* Treat GROUP PUBLIC as a synonym for PUBLIC */
					if (strcmp((yyvsp[(2) - (2)].str), "public") == 0)
						n->rolname = NULL;
					else
						n->rolname = (yyvsp[(2) - (2)].str);
					(yyval.node) = (Node *)n;
				;}
    break;

  case 571:

/* Line 1455 of yacc.c  */
#line 3602 "gram.y"
    { (yyval.boolean) = TRUE; ;}
    break;

  case 572:

/* Line 1455 of yacc.c  */
#line 3603 "gram.y"
    { (yyval.boolean) = FALSE; ;}
    break;

  case 573:

/* Line 1455 of yacc.c  */
#line 3607 "gram.y"
    { (yyval.list) = list_make1((yyvsp[(1) - (1)].funwithargs)); ;}
    break;

  case 574:

/* Line 1455 of yacc.c  */
#line 3609 "gram.y"
    { (yyval.list) = lappend((yyvsp[(1) - (3)].list), (yyvsp[(3) - (3)].funwithargs)); ;}
    break;

  case 575:

/* Line 1455 of yacc.c  */
#line 3614 "gram.y"
    {
					FuncWithArgs *n = makeNode(FuncWithArgs);
					n->funcname = (yyvsp[(1) - (2)].list);
					n->funcargs = extractArgTypes((yyvsp[(2) - (2)].list));
					(yyval.funwithargs) = n;
				;}
    break;

  case 576:

/* Line 1455 of yacc.c  */
#line 3630 "gram.y"
    {
					GrantRoleStmt *n = makeNode(GrantRoleStmt);
					n->is_grant = true;
					n->granted_roles = (yyvsp[(2) - (6)].list);
					n->grantee_roles = (yyvsp[(4) - (6)].list);
					n->admin_opt = (yyvsp[(5) - (6)].boolean);
					n->grantor = (yyvsp[(6) - (6)].str);
					(yyval.node) = (Node*)n;
				;}
    break;

  case 577:

/* Line 1455 of yacc.c  */
#line 3643 "gram.y"
    {
					GrantRoleStmt *n = makeNode(GrantRoleStmt);
					n->is_grant = false;
					n->admin_opt = false;
					n->granted_roles = (yyvsp[(2) - (6)].list);
					n->grantee_roles = (yyvsp[(4) - (6)].list);
					n->behavior = (yyvsp[(6) - (6)].dbehavior);
					(yyval.node) = (Node*)n;
				;}
    break;

  case 578:

/* Line 1455 of yacc.c  */
#line 3653 "gram.y"
    {
					GrantRoleStmt *n = makeNode(GrantRoleStmt);
					n->is_grant = false;
					n->admin_opt = true;
					n->granted_roles = (yyvsp[(5) - (9)].list);
					n->grantee_roles = (yyvsp[(7) - (9)].list);
					n->behavior = (yyvsp[(9) - (9)].dbehavior);
					(yyval.node) = (Node*)n;
				;}
    break;

  case 579:

/* Line 1455 of yacc.c  */
#line 3664 "gram.y"
    { (yyval.boolean) = TRUE; ;}
    break;

  case 580:

/* Line 1455 of yacc.c  */
#line 3665 "gram.y"
    { (yyval.boolean) = FALSE; ;}
    break;

  case 581:

/* Line 1455 of yacc.c  */
#line 3668 "gram.y"
    { (yyval.str) = (yyvsp[(3) - (3)].str); ;}
    break;

  case 582:

/* Line 1455 of yacc.c  */
#line 3669 "gram.y"
    { (yyval.str) = NULL; ;}
    break;

  case 583:

/* Line 1455 of yacc.c  */
#line 3687 "gram.y"
    {
					IndexStmt *n = makeNode(IndexStmt);
					n->unique = (yyvsp[(2) - (13)].boolean);
					n->concurrent = false;
					n->idxname = (yyvsp[(4) - (13)].str);
					n->relation = (yyvsp[(6) - (13)].range);
					n->accessMethod = (yyvsp[(7) - (13)].str);
					n->indexParams = (yyvsp[(9) - (13)].list);
					n->options = (yyvsp[(11) - (13)].list);
					n->tableSpace = (yyvsp[(12) - (13)].str);
					n->whereClause = (yyvsp[(13) - (13)].node);
					(yyval.node) = (Node *)n;
				;}
    break;

  case 584:

/* Line 1455 of yacc.c  */
#line 3703 "gram.y"
    {
					IndexStmt *n = makeNode(IndexStmt);
					n->unique = (yyvsp[(2) - (14)].boolean);
					n->concurrent = true;
					n->idxname = (yyvsp[(5) - (14)].str);
					n->relation = (yyvsp[(7) - (14)].range);
					n->accessMethod = (yyvsp[(8) - (14)].str);
					n->indexParams = (yyvsp[(10) - (14)].list);
					n->options = (yyvsp[(12) - (14)].list);
					n->tableSpace = (yyvsp[(13) - (14)].str);
					n->whereClause = (yyvsp[(14) - (14)].node);
					(yyval.node) = (Node *)n;
				;}
    break;

  case 585:

/* Line 1455 of yacc.c  */
#line 3719 "gram.y"
    { (yyval.boolean) = TRUE; ;}
    break;

  case 586:

/* Line 1455 of yacc.c  */
#line 3720 "gram.y"
    { (yyval.boolean) = FALSE; ;}
    break;

  case 587:

/* Line 1455 of yacc.c  */
#line 3724 "gram.y"
    { (yyval.str) = (yyvsp[(2) - (2)].str); ;}
    break;

  case 588:

/* Line 1455 of yacc.c  */
#line 3725 "gram.y"
    { (yyval.str) = DEFAULT_INDEX_TYPE; ;}
    break;

  case 589:

/* Line 1455 of yacc.c  */
#line 3728 "gram.y"
    { (yyval.list) = list_make1((yyvsp[(1) - (1)].ielem)); ;}
    break;

  case 590:

/* Line 1455 of yacc.c  */
#line 3729 "gram.y"
    { (yyval.list) = lappend((yyvsp[(1) - (3)].list), (yyvsp[(3) - (3)].ielem)); ;}
    break;

  case 591:

/* Line 1455 of yacc.c  */
#line 3738 "gram.y"
    {
					(yyval.ielem) = makeNode(IndexElem);
					(yyval.ielem)->name = (yyvsp[(1) - (2)].str);
					(yyval.ielem)->expr = NULL;
					(yyval.ielem)->opclass = (yyvsp[(2) - (2)].list);
				;}
    break;

  case 592:

/* Line 1455 of yacc.c  */
#line 3745 "gram.y"
    {
					(yyval.ielem) = makeNode(IndexElem);
					(yyval.ielem)->name = NULL;
					(yyval.ielem)->expr = (yyvsp[(1) - (2)].node);
					(yyval.ielem)->opclass = (yyvsp[(2) - (2)].list);
				;}
    break;

  case 593:

/* Line 1455 of yacc.c  */
#line 3752 "gram.y"
    {
					(yyval.ielem) = makeNode(IndexElem);
					(yyval.ielem)->name = NULL;
					(yyval.ielem)->expr = (yyvsp[(2) - (4)].node);
					(yyval.ielem)->opclass = (yyvsp[(4) - (4)].list);
				;}
    break;

  case 594:

/* Line 1455 of yacc.c  */
#line 3760 "gram.y"
    { (yyval.list) = (yyvsp[(1) - (1)].list); ;}
    break;

  case 595:

/* Line 1455 of yacc.c  */
#line 3761 "gram.y"
    { (yyval.list) = (yyvsp[(2) - (2)].list); ;}
    break;

  case 596:

/* Line 1455 of yacc.c  */
#line 3762 "gram.y"
    { (yyval.list) = NIL; ;}
    break;

  case 597:

/* Line 1455 of yacc.c  */
#line 3779 "gram.y"
    {
					CreateFunctionStmt *n = makeNode(CreateFunctionStmt);
					n->replace = (yyvsp[(2) - (9)].boolean);
					n->funcname = (yyvsp[(4) - (9)].list);
					n->parameters = (yyvsp[(5) - (9)].list);
					n->returnType = (yyvsp[(7) - (9)].typnam);
					n->options = (yyvsp[(8) - (9)].list);
					n->withClause = (yyvsp[(9) - (9)].list);
					(yyval.node) = (Node *)n;
				;}
    break;

  case 598:

/* Line 1455 of yacc.c  */
#line 3791 "gram.y"
    {
					CreateFunctionStmt *n = makeNode(CreateFunctionStmt);
					n->replace = (yyvsp[(2) - (7)].boolean);
					n->funcname = (yyvsp[(4) - (7)].list);
					n->parameters = (yyvsp[(5) - (7)].list);
					n->returnType = NULL;
					n->options = (yyvsp[(6) - (7)].list);
					n->withClause = (yyvsp[(7) - (7)].list);
					(yyval.node) = (Node *)n;
				;}
    break;

  case 599:

/* Line 1455 of yacc.c  */
#line 3804 "gram.y"
    { (yyval.boolean) = TRUE; ;}
    break;

  case 600:

/* Line 1455 of yacc.c  */
#line 3805 "gram.y"
    { (yyval.boolean) = FALSE; ;}
    break;

  case 601:

/* Line 1455 of yacc.c  */
#line 3808 "gram.y"
    { (yyval.list) = (yyvsp[(2) - (3)].list); ;}
    break;

  case 602:

/* Line 1455 of yacc.c  */
#line 3809 "gram.y"
    { (yyval.list) = NIL; ;}
    break;

  case 603:

/* Line 1455 of yacc.c  */
#line 3813 "gram.y"
    { (yyval.list) = list_make1((yyvsp[(1) - (1)].fun_param)); ;}
    break;

  case 604:

/* Line 1455 of yacc.c  */
#line 3814 "gram.y"
    { (yyval.list) = lappend((yyvsp[(1) - (3)].list), (yyvsp[(3) - (3)].fun_param)); ;}
    break;

  case 605:

/* Line 1455 of yacc.c  */
#line 3829 "gram.y"
    {
					FunctionParameter *n = makeNode(FunctionParameter);
					n->name = (yyvsp[(2) - (3)].str);
					n->argType = (yyvsp[(3) - (3)].typnam);
					n->mode = (yyvsp[(1) - (3)].fun_param_mode);
					(yyval.fun_param) = n;
				;}
    break;

  case 606:

/* Line 1455 of yacc.c  */
#line 3837 "gram.y"
    {
					FunctionParameter *n = makeNode(FunctionParameter);
					n->name = (yyvsp[(1) - (3)].str);
					n->argType = (yyvsp[(3) - (3)].typnam);
					n->mode = (yyvsp[(2) - (3)].fun_param_mode);
					(yyval.fun_param) = n;
				;}
    break;

  case 607:

/* Line 1455 of yacc.c  */
#line 3845 "gram.y"
    {
					FunctionParameter *n = makeNode(FunctionParameter);
					n->name = (yyvsp[(1) - (2)].str);
					n->argType = (yyvsp[(2) - (2)].typnam);
					n->mode = FUNC_PARAM_IN;
					(yyval.fun_param) = n;
				;}
    break;

  case 608:

/* Line 1455 of yacc.c  */
#line 3853 "gram.y"
    {
					FunctionParameter *n = makeNode(FunctionParameter);
					n->name = NULL;
					n->argType = (yyvsp[(2) - (2)].typnam);
					n->mode = (yyvsp[(1) - (2)].fun_param_mode);
					(yyval.fun_param) = n;
				;}
    break;

  case 609:

/* Line 1455 of yacc.c  */
#line 3861 "gram.y"
    {
					FunctionParameter *n = makeNode(FunctionParameter);
					n->name = NULL;
					n->argType = (yyvsp[(1) - (1)].typnam);
					n->mode = FUNC_PARAM_IN;
					(yyval.fun_param) = n;
				;}
    break;

  case 610:

/* Line 1455 of yacc.c  */
#line 3871 "gram.y"
    { (yyval.fun_param_mode) = FUNC_PARAM_IN; ;}
    break;

  case 611:

/* Line 1455 of yacc.c  */
#line 3872 "gram.y"
    { (yyval.fun_param_mode) = FUNC_PARAM_OUT; ;}
    break;

  case 612:

/* Line 1455 of yacc.c  */
#line 3873 "gram.y"
    { (yyval.fun_param_mode) = FUNC_PARAM_INOUT; ;}
    break;

  case 613:

/* Line 1455 of yacc.c  */
#line 3874 "gram.y"
    { (yyval.fun_param_mode) = FUNC_PARAM_INOUT; ;}
    break;

  case 615:

/* Line 1455 of yacc.c  */
#line 3885 "gram.y"
    {
					/* We can catch over-specified results here if we want to,
					 * but for now better to silently swallow typmod, etc.
					 * - thomas 2000-03-22
					 */
					(yyval.typnam) = (yyvsp[(1) - (1)].typnam);
				;}
    break;

  case 616:

/* Line 1455 of yacc.c  */
#line 3898 "gram.y"
    { (yyval.typnam) = (yyvsp[(1) - (1)].typnam); ;}
    break;

  case 617:

/* Line 1455 of yacc.c  */
#line 3900 "gram.y"
    {
					(yyval.typnam) = makeNode(TypeName);
					(yyval.typnam)->names = lcons(makeString((yyvsp[(1) - (4)].str)), (yyvsp[(2) - (4)].list));
					(yyval.typnam)->pct_type = true;
					(yyval.typnam)->typmod = -1;
					(yyval.typnam)->location = (yylsp[(1) - (4)]);
				;}
    break;

  case 618:

/* Line 1455 of yacc.c  */
#line 3908 "gram.y"
    {
					(yyval.typnam) = makeNode(TypeName);
					(yyval.typnam)->names = lcons(makeString((yyvsp[(2) - (5)].str)), (yyvsp[(3) - (5)].list));
					(yyval.typnam)->pct_type = true;
					(yyval.typnam)->typmod = -1;
					(yyval.typnam)->setof = TRUE;
					(yyval.typnam)->location = (yylsp[(2) - (5)]);
				;}
    break;

  case 619:

/* Line 1455 of yacc.c  */
#line 3921 "gram.y"
    { (yyval.list) = list_make1((yyvsp[(1) - (1)].defelt)); ;}
    break;

  case 620:

/* Line 1455 of yacc.c  */
#line 3922 "gram.y"
    { (yyval.list) = lappend((yyvsp[(1) - (2)].list), (yyvsp[(2) - (2)].defelt)); ;}
    break;

  case 621:

/* Line 1455 of yacc.c  */
#line 3930 "gram.y"
    {
					(yyval.defelt) = makeDefElem("strict", (Node *)makeInteger(FALSE));
				;}
    break;

  case 622:

/* Line 1455 of yacc.c  */
#line 3934 "gram.y"
    {
					(yyval.defelt) = makeDefElem("strict", (Node *)makeInteger(TRUE));
				;}
    break;

  case 623:

/* Line 1455 of yacc.c  */
#line 3938 "gram.y"
    {
					(yyval.defelt) = makeDefElem("strict", (Node *)makeInteger(TRUE));
				;}
    break;

  case 624:

/* Line 1455 of yacc.c  */
#line 3942 "gram.y"
    {
					(yyval.defelt) = makeDefElem("volatility", (Node *)makeString("immutable"));
				;}
    break;

  case 625:

/* Line 1455 of yacc.c  */
#line 3946 "gram.y"
    {
					(yyval.defelt) = makeDefElem("volatility", (Node *)makeString("stable"));
				;}
    break;

  case 626:

/* Line 1455 of yacc.c  */
#line 3950 "gram.y"
    {
					(yyval.defelt) = makeDefElem("volatility", (Node *)makeString("volatile"));
				;}
    break;

  case 627:

/* Line 1455 of yacc.c  */
#line 3954 "gram.y"
    {
					(yyval.defelt) = makeDefElem("security", (Node *)makeInteger(TRUE));
				;}
    break;

  case 628:

/* Line 1455 of yacc.c  */
#line 3958 "gram.y"
    {
					(yyval.defelt) = makeDefElem("security", (Node *)makeInteger(FALSE));
				;}
    break;

  case 629:

/* Line 1455 of yacc.c  */
#line 3962 "gram.y"
    {
					(yyval.defelt) = makeDefElem("security", (Node *)makeInteger(TRUE));
				;}
    break;

  case 630:

/* Line 1455 of yacc.c  */
#line 3966 "gram.y"
    {
					(yyval.defelt) = makeDefElem("security", (Node *)makeInteger(FALSE));
				;}
    break;

  case 631:

/* Line 1455 of yacc.c  */
#line 3973 "gram.y"
    {
					(yyval.defelt) = makeDefElem("as", (Node *)(yyvsp[(2) - (2)].list));
				;}
    break;

  case 632:

/* Line 1455 of yacc.c  */
#line 3977 "gram.y"
    {
					(yyval.defelt) = makeDefElem("language", (Node *)makeString((yyvsp[(2) - (2)].str)));
				;}
    break;

  case 633:

/* Line 1455 of yacc.c  */
#line 3981 "gram.y"
    {
					(yyval.defelt) = (yyvsp[(1) - (1)].defelt);
				;}
    break;

  case 634:

/* Line 1455 of yacc.c  */
#line 3986 "gram.y"
    { (yyval.list) = list_make1(makeString((yyvsp[(1) - (1)].str))); ;}
    break;

  case 635:

/* Line 1455 of yacc.c  */
#line 3988 "gram.y"
    {
					(yyval.list) = list_make2(makeString((yyvsp[(1) - (3)].str)), makeString((yyvsp[(3) - (3)].str)));
				;}
    break;

  case 636:

/* Line 1455 of yacc.c  */
#line 3994 "gram.y"
    { (yyval.list) = (yyvsp[(2) - (2)].list); ;}
    break;

  case 637:

/* Line 1455 of yacc.c  */
#line 3995 "gram.y"
    { (yyval.list) = NIL; ;}
    break;

  case 638:

/* Line 1455 of yacc.c  */
#line 4008 "gram.y"
    {
					AlterFunctionStmt *n = makeNode(AlterFunctionStmt);
					n->func = (yyvsp[(3) - (5)].funwithargs);
					n->actions = (yyvsp[(4) - (5)].list);
					(yyval.node) = (Node *) n;
				;}
    break;

  case 639:

/* Line 1455 of yacc.c  */
#line 4018 "gram.y"
    { (yyval.list) = list_make1((yyvsp[(1) - (1)].defelt)); ;}
    break;

  case 640:

/* Line 1455 of yacc.c  */
#line 4019 "gram.y"
    { (yyval.list) = lappend((yyvsp[(1) - (2)].list), (yyvsp[(2) - (2)].defelt)); ;}
    break;

  case 643:

/* Line 1455 of yacc.c  */
#line 4041 "gram.y"
    {
					RemoveFuncStmt *n = makeNode(RemoveFuncStmt);
					n->kind = OBJECT_FUNCTION;
					n->name = (yyvsp[(3) - (5)].list);
					n->args = extractArgTypes((yyvsp[(4) - (5)].list));
					n->behavior = (yyvsp[(5) - (5)].dbehavior);
					n->missing_ok = false;
					(yyval.node) = (Node *)n;
				;}
    break;

  case 644:

/* Line 1455 of yacc.c  */
#line 4051 "gram.y"
    {
					RemoveFuncStmt *n = makeNode(RemoveFuncStmt);
					n->kind = OBJECT_FUNCTION;
					n->name = (yyvsp[(5) - (7)].list);
					n->args = extractArgTypes((yyvsp[(6) - (7)].list));
					n->behavior = (yyvsp[(7) - (7)].dbehavior);
					n->missing_ok = true;
					(yyval.node) = (Node *)n;
				;}
    break;

  case 645:

/* Line 1455 of yacc.c  */
#line 4064 "gram.y"
    {
					RemoveFuncStmt *n = makeNode(RemoveFuncStmt);
					n->kind = OBJECT_AGGREGATE;
					n->name = (yyvsp[(3) - (5)].list);
					n->args = (yyvsp[(4) - (5)].list);
					n->behavior = (yyvsp[(5) - (5)].dbehavior);
					n->missing_ok = false;
					(yyval.node) = (Node *)n;
				;}
    break;

  case 646:

/* Line 1455 of yacc.c  */
#line 4074 "gram.y"
    {
					RemoveFuncStmt *n = makeNode(RemoveFuncStmt);
					n->kind = OBJECT_AGGREGATE;
					n->name = (yyvsp[(5) - (7)].list);
					n->args = (yyvsp[(6) - (7)].list);
					n->behavior = (yyvsp[(7) - (7)].dbehavior);
					n->missing_ok = true;
					(yyval.node) = (Node *)n;
				;}
    break;

  case 647:

/* Line 1455 of yacc.c  */
#line 4087 "gram.y"
    {
					RemoveFuncStmt *n = makeNode(RemoveFuncStmt);
					n->kind = OBJECT_OPERATOR;
					n->name = (yyvsp[(3) - (7)].list);
					n->args = (yyvsp[(5) - (7)].list);
					n->behavior = (yyvsp[(7) - (7)].dbehavior);
					n->missing_ok = false;
					(yyval.node) = (Node *)n;
				;}
    break;

  case 648:

/* Line 1455 of yacc.c  */
#line 4097 "gram.y"
    {
					RemoveFuncStmt *n = makeNode(RemoveFuncStmt);
					n->kind = OBJECT_OPERATOR;
					n->name = (yyvsp[(5) - (9)].list);
					n->args = (yyvsp[(7) - (9)].list);
					n->behavior = (yyvsp[(9) - (9)].dbehavior);
					n->missing_ok = true;
					(yyval.node) = (Node *)n;
				;}
    break;

  case 649:

/* Line 1455 of yacc.c  */
#line 4110 "gram.y"
    {
				   ereport(ERROR,
						   (errcode(ERRCODE_SYNTAX_ERROR),
							errmsg("missing argument"),
							errhint("Use NONE to denote the missing argument of a unary operator.")));
				;}
    break;

  case 650:

/* Line 1455 of yacc.c  */
#line 4117 "gram.y"
    { (yyval.list) = list_make2((yyvsp[(1) - (3)].typnam), (yyvsp[(3) - (3)].typnam)); ;}
    break;

  case 651:

/* Line 1455 of yacc.c  */
#line 4119 "gram.y"
    { (yyval.list) = list_make2(NULL, (yyvsp[(3) - (3)].typnam)); ;}
    break;

  case 652:

/* Line 1455 of yacc.c  */
#line 4121 "gram.y"
    { (yyval.list) = list_make2((yyvsp[(1) - (3)].typnam), NULL); ;}
    break;

  case 653:

/* Line 1455 of yacc.c  */
#line 4126 "gram.y"
    { (yyval.list) = list_make1(makeString((yyvsp[(1) - (1)].str))); ;}
    break;

  case 654:

/* Line 1455 of yacc.c  */
#line 4128 "gram.y"
    { (yyval.list) = lcons(makeString((yyvsp[(1) - (3)].str)), (yyvsp[(3) - (3)].list)); ;}
    break;

  case 655:

/* Line 1455 of yacc.c  */
#line 4140 "gram.y"
    {
					CreateCastStmt *n = makeNode(CreateCastStmt);
					n->sourcetype = (yyvsp[(4) - (11)].typnam);
					n->targettype = (yyvsp[(6) - (11)].typnam);
					n->func = (yyvsp[(10) - (11)].funwithargs);
					n->context = (CoercionContext) (yyvsp[(11) - (11)].ival);
					(yyval.node) = (Node *)n;
				;}
    break;

  case 656:

/* Line 1455 of yacc.c  */
#line 4150 "gram.y"
    {
					CreateCastStmt *n = makeNode(CreateCastStmt);
					n->sourcetype = (yyvsp[(4) - (10)].typnam);
					n->targettype = (yyvsp[(6) - (10)].typnam);
					n->func = NULL;
					n->context = (CoercionContext) (yyvsp[(10) - (10)].ival);
					(yyval.node) = (Node *)n;
				;}
    break;

  case 657:

/* Line 1455 of yacc.c  */
#line 4160 "gram.y"
    { (yyval.ival) = COERCION_IMPLICIT; ;}
    break;

  case 658:

/* Line 1455 of yacc.c  */
#line 4161 "gram.y"
    { (yyval.ival) = COERCION_ASSIGNMENT; ;}
    break;

  case 659:

/* Line 1455 of yacc.c  */
#line 4162 "gram.y"
    { (yyval.ival) = COERCION_EXPLICIT; ;}
    break;

  case 660:

/* Line 1455 of yacc.c  */
#line 4167 "gram.y"
    {
					DropCastStmt *n = makeNode(DropCastStmt);
					n->sourcetype = (yyvsp[(5) - (9)].typnam);
					n->targettype = (yyvsp[(7) - (9)].typnam);
					n->behavior = (yyvsp[(9) - (9)].dbehavior);
					n->missing_ok = (yyvsp[(3) - (9)].boolean);
					(yyval.node) = (Node *)n;
				;}
    break;

  case 661:

/* Line 1455 of yacc.c  */
#line 4177 "gram.y"
    { (yyval.boolean) = true; ;}
    break;

  case 662:

/* Line 1455 of yacc.c  */
#line 4178 "gram.y"
    { (yyval.boolean) = false; ;}
    break;

  case 663:

/* Line 1455 of yacc.c  */
#line 4193 "gram.y"
    {
					ReindexStmt *n = makeNode(ReindexStmt);
					n->kind = (yyvsp[(2) - (4)].objtype);
					n->relation = (yyvsp[(3) - (4)].range);
					n->name = NULL;
					(yyval.node) = (Node *)n;
				;}
    break;

  case 664:

/* Line 1455 of yacc.c  */
#line 4201 "gram.y"
    {
					ReindexStmt *n = makeNode(ReindexStmt);
					n->kind = OBJECT_DATABASE;
					n->name = (yyvsp[(3) - (4)].str);
					n->relation = NULL;
					n->do_system = true;
					n->do_user = false;
					(yyval.node) = (Node *)n;
				;}
    break;

  case 665:

/* Line 1455 of yacc.c  */
#line 4211 "gram.y"
    {
					ReindexStmt *n = makeNode(ReindexStmt);
					n->kind = OBJECT_DATABASE;
					n->name = (yyvsp[(3) - (4)].str);
					n->relation = NULL;
					n->do_system = true;
					n->do_user = true;
					(yyval.node) = (Node *)n;
				;}
    break;

  case 666:

/* Line 1455 of yacc.c  */
#line 4223 "gram.y"
    { (yyval.objtype) = OBJECT_INDEX; ;}
    break;

  case 667:

/* Line 1455 of yacc.c  */
#line 4224 "gram.y"
    { (yyval.objtype) = OBJECT_TABLE; ;}
    break;

  case 668:

/* Line 1455 of yacc.c  */
#line 4227 "gram.y"
    {  (yyval.boolean) = TRUE; ;}
    break;

  case 669:

/* Line 1455 of yacc.c  */
#line 4228 "gram.y"
    {  (yyval.boolean) = FALSE; ;}
    break;

  case 670:

/* Line 1455 of yacc.c  */
#line 4239 "gram.y"
    {
					RenameStmt *n = makeNode(RenameStmt);
					n->renameType = OBJECT_AGGREGATE;
					n->object = (yyvsp[(3) - (7)].list);
					n->objarg = (yyvsp[(4) - (7)].list);
					n->newname = (yyvsp[(7) - (7)].str);
					(yyval.node) = (Node *)n;
				;}
    break;

  case 671:

/* Line 1455 of yacc.c  */
#line 4248 "gram.y"
    {
					RenameStmt *n = makeNode(RenameStmt);
					n->renameType = OBJECT_CONVERSION;
					n->object = (yyvsp[(3) - (6)].list);
					n->newname = (yyvsp[(6) - (6)].str);
					(yyval.node) = (Node *)n;
				;}
    break;

  case 672:

/* Line 1455 of yacc.c  */
#line 4256 "gram.y"
    {
					RenameStmt *n = makeNode(RenameStmt);
					n->renameType = OBJECT_DATABASE;
					n->subname = (yyvsp[(3) - (6)].str);
					n->newname = (yyvsp[(6) - (6)].str);
					(yyval.node) = (Node *)n;
				;}
    break;

  case 673:

/* Line 1455 of yacc.c  */
#line 4264 "gram.y"
    {
					RenameStmt *n = makeNode(RenameStmt);
					n->renameType = OBJECT_FUNCTION;
					n->object = (yyvsp[(3) - (7)].list);
					n->objarg = extractArgTypes((yyvsp[(4) - (7)].list));
					n->newname = (yyvsp[(7) - (7)].str);
					(yyval.node) = (Node *)n;
				;}
    break;

  case 674:

/* Line 1455 of yacc.c  */
#line 4273 "gram.y"
    {
					RenameStmt *n = makeNode(RenameStmt);
					n->renameType = OBJECT_ROLE;
					n->subname = (yyvsp[(3) - (6)].str);
					n->newname = (yyvsp[(6) - (6)].str);
					(yyval.node) = (Node *)n;
				;}
    break;

  case 675:

/* Line 1455 of yacc.c  */
#line 4281 "gram.y"
    {
					RenameStmt *n = makeNode(RenameStmt);
					n->renameType = OBJECT_LANGUAGE;
					n->subname = (yyvsp[(3) - (6)].str);
					n->newname = (yyvsp[(6) - (6)].str);
					(yyval.node) = (Node *)n;
				;}
    break;

  case 676:

/* Line 1455 of yacc.c  */
#line 4289 "gram.y"
    {
					RenameStmt *n = makeNode(RenameStmt);
					n->renameType = OBJECT_OPCLASS;
					n->object = (yyvsp[(4) - (9)].list);
					n->subname = (yyvsp[(6) - (9)].str);
					n->newname = (yyvsp[(9) - (9)].str);
					(yyval.node) = (Node *)n;
				;}
    break;

  case 677:

/* Line 1455 of yacc.c  */
#line 4298 "gram.y"
    {
					RenameStmt *n = makeNode(RenameStmt);
					n->renameType = OBJECT_SCHEMA;
					n->subname = (yyvsp[(3) - (6)].str);
					n->newname = (yyvsp[(6) - (6)].str);
					(yyval.node) = (Node *)n;
				;}
    break;

  case 678:

/* Line 1455 of yacc.c  */
#line 4306 "gram.y"
    {
					RenameStmt *n = makeNode(RenameStmt);
					n->renameType = OBJECT_TABLE;
					n->relation = (yyvsp[(3) - (6)].range);
					n->subname = NULL;
					n->newname = (yyvsp[(6) - (6)].str);
					(yyval.node) = (Node *)n;
				;}
    break;

  case 679:

/* Line 1455 of yacc.c  */
#line 4315 "gram.y"
    {
					RenameStmt *n = makeNode(RenameStmt);
					n->renameType = OBJECT_INDEX;
					n->relation = (yyvsp[(3) - (6)].range);
					n->subname = NULL;
					n->newname = (yyvsp[(6) - (6)].str);
					(yyval.node) = (Node *)n;
				;}
    break;

  case 680:

/* Line 1455 of yacc.c  */
#line 4324 "gram.y"
    {
					RenameStmt *n = makeNode(RenameStmt);
					n->renameType = OBJECT_COLUMN;
					n->relation = (yyvsp[(3) - (8)].range);
					n->subname = (yyvsp[(6) - (8)].str);
					n->newname = (yyvsp[(8) - (8)].str);
					(yyval.node) = (Node *)n;
				;}
    break;

  case 681:

/* Line 1455 of yacc.c  */
#line 4333 "gram.y"
    {
					RenameStmt *n = makeNode(RenameStmt);
					n->renameType = OBJECT_TRIGGER;
					n->relation = (yyvsp[(5) - (8)].range);
					n->subname = (yyvsp[(3) - (8)].str);
					n->newname = (yyvsp[(8) - (8)].str);
					(yyval.node) = (Node *)n;
				;}
    break;

  case 682:

/* Line 1455 of yacc.c  */
#line 4342 "gram.y"
    {
					RenameStmt *n = makeNode(RenameStmt);
					n->renameType = OBJECT_ROLE;
					n->subname = (yyvsp[(3) - (6)].str);
					n->newname = (yyvsp[(6) - (6)].str);
					(yyval.node) = (Node *)n;
				;}
    break;

  case 683:

/* Line 1455 of yacc.c  */
#line 4350 "gram.y"
    {
					RenameStmt *n = makeNode(RenameStmt);
					n->renameType = OBJECT_ROLE;
					n->subname = (yyvsp[(3) - (6)].str);
					n->newname = (yyvsp[(6) - (6)].str);
					(yyval.node) = (Node *)n;
				;}
    break;

  case 684:

/* Line 1455 of yacc.c  */
#line 4358 "gram.y"
    {
					RenameStmt *n = makeNode(RenameStmt);
					n->renameType = OBJECT_TABLESPACE;
					n->subname = (yyvsp[(3) - (6)].str);
					n->newname = (yyvsp[(6) - (6)].str);
					(yyval.node) = (Node *)n;
				;}
    break;

  case 685:

/* Line 1455 of yacc.c  */
#line 4367 "gram.y"
    { (yyval.ival) = COLUMN; ;}
    break;

  case 686:

/* Line 1455 of yacc.c  */
#line 4368 "gram.y"
    { (yyval.ival) = 0; ;}
    break;

  case 687:

/* Line 1455 of yacc.c  */
#line 4379 "gram.y"
    {
					AlterObjectSchemaStmt *n = makeNode(AlterObjectSchemaStmt);
					n->objectType = OBJECT_AGGREGATE;
					n->object = (yyvsp[(3) - (7)].list);
					n->objarg = (yyvsp[(4) - (7)].list);
					n->newschema = (yyvsp[(7) - (7)].str);
					(yyval.node) = (Node *)n;
				;}
    break;

  case 688:

/* Line 1455 of yacc.c  */
#line 4388 "gram.y"
    {
					AlterObjectSchemaStmt *n = makeNode(AlterObjectSchemaStmt);
					n->objectType = OBJECT_DOMAIN;
					n->object = (yyvsp[(3) - (6)].list);
					n->newschema = (yyvsp[(6) - (6)].str);
					(yyval.node) = (Node *)n;
				;}
    break;

  case 689:

/* Line 1455 of yacc.c  */
#line 4396 "gram.y"
    {
					AlterObjectSchemaStmt *n = makeNode(AlterObjectSchemaStmt);
					n->objectType = OBJECT_FUNCTION;
					n->object = (yyvsp[(3) - (7)].list);
					n->objarg = extractArgTypes((yyvsp[(4) - (7)].list));
					n->newschema = (yyvsp[(7) - (7)].str);
					(yyval.node) = (Node *)n;
				;}
    break;

  case 690:

/* Line 1455 of yacc.c  */
#line 4405 "gram.y"
    {
					AlterObjectSchemaStmt *n = makeNode(AlterObjectSchemaStmt);
					n->objectType = OBJECT_SEQUENCE;
					n->relation = (yyvsp[(3) - (6)].range);
					n->newschema = (yyvsp[(6) - (6)].str);
					(yyval.node) = (Node *)n;
				;}
    break;

  case 691:

/* Line 1455 of yacc.c  */
#line 4413 "gram.y"
    {
					AlterObjectSchemaStmt *n = makeNode(AlterObjectSchemaStmt);
					n->objectType = OBJECT_TABLE;
					n->relation = (yyvsp[(3) - (6)].range);
					n->newschema = (yyvsp[(6) - (6)].str);
					(yyval.node) = (Node *)n;
				;}
    break;

  case 692:

/* Line 1455 of yacc.c  */
#line 4421 "gram.y"
    {
					AlterObjectSchemaStmt *n = makeNode(AlterObjectSchemaStmt);
					n->objectType = OBJECT_TYPE;
					n->object = (yyvsp[(3) - (6)].list);
					n->newschema = (yyvsp[(6) - (6)].str);
					(yyval.node) = (Node *)n;
				;}
    break;

  case 693:

/* Line 1455 of yacc.c  */
#line 4437 "gram.y"
    {
					AlterOwnerStmt *n = makeNode(AlterOwnerStmt);
					n->objectType = OBJECT_AGGREGATE;
					n->object = (yyvsp[(3) - (7)].list);
					n->objarg = (yyvsp[(4) - (7)].list);
					n->newowner = (yyvsp[(7) - (7)].str);
					(yyval.node) = (Node *)n;
				;}
    break;

  case 694:

/* Line 1455 of yacc.c  */
#line 4446 "gram.y"
    {
					AlterOwnerStmt *n = makeNode(AlterOwnerStmt);
					n->objectType = OBJECT_CONVERSION;
					n->object = (yyvsp[(3) - (6)].list);
					n->newowner = (yyvsp[(6) - (6)].str);
					(yyval.node) = (Node *)n;
				;}
    break;

  case 695:

/* Line 1455 of yacc.c  */
#line 4454 "gram.y"
    {
					AlterOwnerStmt *n = makeNode(AlterOwnerStmt);
					n->objectType = OBJECT_DATABASE;
					n->object = list_make1((yyvsp[(3) - (6)].str));
					n->newowner = (yyvsp[(6) - (6)].str);
					(yyval.node) = (Node *)n;
				;}
    break;

  case 696:

/* Line 1455 of yacc.c  */
#line 4462 "gram.y"
    {
					AlterOwnerStmt *n = makeNode(AlterOwnerStmt);
					n->objectType = OBJECT_DOMAIN;
					n->object = (yyvsp[(3) - (6)].list);
					n->newowner = (yyvsp[(6) - (6)].str);
					(yyval.node) = (Node *)n;
				;}
    break;

  case 697:

/* Line 1455 of yacc.c  */
#line 4470 "gram.y"
    {
					AlterOwnerStmt *n = makeNode(AlterOwnerStmt);
					n->objectType = OBJECT_FUNCTION;
					n->object = (yyvsp[(3) - (7)].list);
					n->objarg = extractArgTypes((yyvsp[(4) - (7)].list));
					n->newowner = (yyvsp[(7) - (7)].str);
					(yyval.node) = (Node *)n;
				;}
    break;

  case 698:

/* Line 1455 of yacc.c  */
#line 4479 "gram.y"
    {
					AlterOwnerStmt *n = makeNode(AlterOwnerStmt);
					n->objectType = OBJECT_OPERATOR;
					n->object = (yyvsp[(3) - (9)].list);
					n->objarg = (yyvsp[(5) - (9)].list);
					n->newowner = (yyvsp[(9) - (9)].str);
					(yyval.node) = (Node *)n;
				;}
    break;

  case 699:

/* Line 1455 of yacc.c  */
#line 4488 "gram.y"
    {
					AlterOwnerStmt *n = makeNode(AlterOwnerStmt);
					n->objectType = OBJECT_OPCLASS;
					n->object = (yyvsp[(4) - (9)].list);
					n->addname = (yyvsp[(6) - (9)].str);
					n->newowner = (yyvsp[(9) - (9)].str);
					(yyval.node) = (Node *)n;
				;}
    break;

  case 700:

/* Line 1455 of yacc.c  */
#line 4497 "gram.y"
    {
					AlterOwnerStmt *n = makeNode(AlterOwnerStmt);
					n->objectType = OBJECT_SCHEMA;
					n->object = list_make1((yyvsp[(3) - (6)].str));
					n->newowner = (yyvsp[(6) - (6)].str);
					(yyval.node) = (Node *)n;
				;}
    break;

  case 701:

/* Line 1455 of yacc.c  */
#line 4505 "gram.y"
    {
					AlterOwnerStmt *n = makeNode(AlterOwnerStmt);
					n->objectType = OBJECT_TYPE;
					n->object = (yyvsp[(3) - (6)].list);
					n->newowner = (yyvsp[(6) - (6)].str);
					(yyval.node) = (Node *)n;
				;}
    break;

  case 702:

/* Line 1455 of yacc.c  */
#line 4513 "gram.y"
    {
					AlterOwnerStmt *n = makeNode(AlterOwnerStmt);
					n->objectType = OBJECT_TABLESPACE;
					n->object = list_make1((yyvsp[(3) - (6)].str));
					n->newowner = (yyvsp[(6) - (6)].str);
					(yyval.node) = (Node *)n;
				;}
    break;

  case 703:

/* Line 1455 of yacc.c  */
#line 4530 "gram.y"
    { QueryIsRule=TRUE; ;}
    break;

  case 704:

/* Line 1455 of yacc.c  */
#line 4533 "gram.y"
    {
					RuleStmt *n = makeNode(RuleStmt);
					n->replace = (yyvsp[(2) - (14)].boolean);
					n->relation = (yyvsp[(10) - (14)].range);
					n->rulename = (yyvsp[(4) - (14)].str);
					n->whereClause = (yyvsp[(11) - (14)].node);
					n->event = (yyvsp[(8) - (14)].ival);
					n->instead = (yyvsp[(13) - (14)].boolean);
					n->actions = (yyvsp[(14) - (14)].list);
					(yyval.node) = (Node *)n;
					QueryIsRule=FALSE;
				;}
    break;

  case 705:

/* Line 1455 of yacc.c  */
#line 4548 "gram.y"
    { (yyval.list) = NIL; ;}
    break;

  case 706:

/* Line 1455 of yacc.c  */
#line 4549 "gram.y"
    { (yyval.list) = list_make1((yyvsp[(1) - (1)].node)); ;}
    break;

  case 707:

/* Line 1455 of yacc.c  */
#line 4550 "gram.y"
    { (yyval.list) = (yyvsp[(2) - (3)].list); ;}
    break;

  case 708:

/* Line 1455 of yacc.c  */
#line 4556 "gram.y"
    { if ((yyvsp[(3) - (3)].node) != NULL)
					(yyval.list) = lappend((yyvsp[(1) - (3)].list), (yyvsp[(3) - (3)].node));
				  else
					(yyval.list) = (yyvsp[(1) - (3)].list);
				;}
    break;

  case 709:

/* Line 1455 of yacc.c  */
#line 4562 "gram.y"
    { if ((yyvsp[(1) - (1)].node) != NULL)
					(yyval.list) = list_make1((yyvsp[(1) - (1)].node));
				  else
					(yyval.list) = NIL;
				;}
    break;

  case 715:

/* Line 1455 of yacc.c  */
#line 4578 "gram.y"
    { (yyval.node) = (yyvsp[(1) - (1)].node); ;}
    break;

  case 716:

/* Line 1455 of yacc.c  */
#line 4579 "gram.y"
    { (yyval.node) = NULL; ;}
    break;

  case 717:

/* Line 1455 of yacc.c  */
#line 4582 "gram.y"
    { (yyval.ival) = CMD_SELECT; ;}
    break;

  case 718:

/* Line 1455 of yacc.c  */
#line 4583 "gram.y"
    { (yyval.ival) = CMD_UPDATE; ;}
    break;

  case 719:

/* Line 1455 of yacc.c  */
#line 4584 "gram.y"
    { (yyval.ival) = CMD_DELETE; ;}
    break;

  case 720:

/* Line 1455 of yacc.c  */
#line 4585 "gram.y"
    { (yyval.ival) = CMD_INSERT; ;}
    break;

  case 721:

/* Line 1455 of yacc.c  */
#line 4589 "gram.y"
    { (yyval.boolean) = TRUE; ;}
    break;

  case 722:

/* Line 1455 of yacc.c  */
#line 4590 "gram.y"
    { (yyval.boolean) = FALSE; ;}
    break;

  case 723:

/* Line 1455 of yacc.c  */
#line 4591 "gram.y"
    { (yyval.boolean) = FALSE; ;}
    break;

  case 724:

/* Line 1455 of yacc.c  */
#line 4597 "gram.y"
    {
					DropPropertyStmt *n = makeNode(DropPropertyStmt);
					n->relation = (yyvsp[(5) - (6)].range);
					n->property = (yyvsp[(3) - (6)].str);
					n->behavior = (yyvsp[(6) - (6)].dbehavior);
					n->removeType = OBJECT_RULE;
					n->missing_ok = false;
					(yyval.node) = (Node *) n;
				;}
    break;

  case 725:

/* Line 1455 of yacc.c  */
#line 4607 "gram.y"
    {
					DropPropertyStmt *n = makeNode(DropPropertyStmt);
					n->relation = (yyvsp[(7) - (8)].range);
					n->property = (yyvsp[(5) - (8)].str);
					n->behavior = (yyvsp[(8) - (8)].dbehavior);
					n->removeType = OBJECT_RULE;
					n->missing_ok = true;
					(yyval.node) = (Node *) n;
				;}
    break;

  case 726:

/* Line 1455 of yacc.c  */
#line 4628 "gram.y"
    {
					NotifyStmt *n = makeNode(NotifyStmt);
					n->relation = (yyvsp[(2) - (2)].range);
					(yyval.node) = (Node *)n;
				;}
    break;

  case 727:

/* Line 1455 of yacc.c  */
#line 4636 "gram.y"
    {
					ListenStmt *n = makeNode(ListenStmt);
					n->relation = (yyvsp[(2) - (2)].range);
					(yyval.node) = (Node *)n;
				;}
    break;

  case 728:

/* Line 1455 of yacc.c  */
#line 4645 "gram.y"
    {
					UnlistenStmt *n = makeNode(UnlistenStmt);
					n->relation = (yyvsp[(2) - (2)].range);
					(yyval.node) = (Node *)n;
				;}
    break;

  case 729:

/* Line 1455 of yacc.c  */
#line 4651 "gram.y"
    {
					UnlistenStmt *n = makeNode(UnlistenStmt);
					n->relation = makeNode(RangeVar);
					n->relation->relname = "*";
					n->relation->schemaname = NULL;
					(yyval.node) = (Node *)n;
				;}
    break;

  case 730:

/* Line 1455 of yacc.c  */
#line 4672 "gram.y"
    {
					TransactionStmt *n = makeNode(TransactionStmt);
					n->kind = TRANS_STMT_ROLLBACK;
					n->options = NIL;
					(yyval.node) = (Node *)n;
				;}
    break;

  case 731:

/* Line 1455 of yacc.c  */
#line 4679 "gram.y"
    {
					TransactionStmt *n = makeNode(TransactionStmt);
					n->kind = TRANS_STMT_BEGIN;
					n->options = (yyvsp[(3) - (3)].list);
					(yyval.node) = (Node *)n;
				;}
    break;

  case 732:

/* Line 1455 of yacc.c  */
#line 4686 "gram.y"
    {
					TransactionStmt *n = makeNode(TransactionStmt);
					n->kind = TRANS_STMT_START;
					n->options = (yyvsp[(3) - (3)].list);
					(yyval.node) = (Node *)n;
				;}
    break;

  case 733:

/* Line 1455 of yacc.c  */
#line 4693 "gram.y"
    {
					TransactionStmt *n = makeNode(TransactionStmt);
					n->kind = TRANS_STMT_COMMIT;
					n->options = NIL;
					(yyval.node) = (Node *)n;
				;}
    break;

  case 734:

/* Line 1455 of yacc.c  */
#line 4700 "gram.y"
    {
					TransactionStmt *n = makeNode(TransactionStmt);
					n->kind = TRANS_STMT_COMMIT;
					n->options = NIL;
					(yyval.node) = (Node *)n;
				;}
    break;

  case 735:

/* Line 1455 of yacc.c  */
#line 4707 "gram.y"
    {
					TransactionStmt *n = makeNode(TransactionStmt);
					n->kind = TRANS_STMT_ROLLBACK;
					n->options = NIL;
					(yyval.node) = (Node *)n;
				;}
    break;

  case 736:

/* Line 1455 of yacc.c  */
#line 4714 "gram.y"
    {
					TransactionStmt *n = makeNode(TransactionStmt);
					n->kind = TRANS_STMT_SAVEPOINT;
					n->options = list_make1(makeDefElem("savepoint_name",
														(Node *)makeString((yyvsp[(2) - (2)].str))));
					(yyval.node) = (Node *)n;
				;}
    break;

  case 737:

/* Line 1455 of yacc.c  */
#line 4722 "gram.y"
    {
					TransactionStmt *n = makeNode(TransactionStmt);
					n->kind = TRANS_STMT_RELEASE;
					n->options = list_make1(makeDefElem("savepoint_name",
														(Node *)makeString((yyvsp[(3) - (3)].str))));
					(yyval.node) = (Node *)n;
				;}
    break;

  case 738:

/* Line 1455 of yacc.c  */
#line 4730 "gram.y"
    {
					TransactionStmt *n = makeNode(TransactionStmt);
					n->kind = TRANS_STMT_RELEASE;
					n->options = list_make1(makeDefElem("savepoint_name",
														(Node *)makeString((yyvsp[(2) - (2)].str))));
					(yyval.node) = (Node *)n;
				;}
    break;

  case 739:

/* Line 1455 of yacc.c  */
#line 4738 "gram.y"
    {
					TransactionStmt *n = makeNode(TransactionStmt);
					n->kind = TRANS_STMT_ROLLBACK_TO;
					n->options = list_make1(makeDefElem("savepoint_name",
														(Node *)makeString((yyvsp[(5) - (5)].str))));
					(yyval.node) = (Node *)n;
				;}
    break;

  case 740:

/* Line 1455 of yacc.c  */
#line 4746 "gram.y"
    {
					TransactionStmt *n = makeNode(TransactionStmt);
					n->kind = TRANS_STMT_ROLLBACK_TO;
					n->options = list_make1(makeDefElem("savepoint_name",
														(Node *)makeString((yyvsp[(4) - (4)].str))));
					(yyval.node) = (Node *)n;
				;}
    break;

  case 741:

/* Line 1455 of yacc.c  */
#line 4754 "gram.y"
    {
					TransactionStmt *n = makeNode(TransactionStmt);
					n->kind = TRANS_STMT_PREPARE;
					n->gid = (yyvsp[(3) - (3)].str);
					(yyval.node) = (Node *)n;
				;}
    break;

  case 742:

/* Line 1455 of yacc.c  */
#line 4761 "gram.y"
    {
					TransactionStmt *n = makeNode(TransactionStmt);
					n->kind = TRANS_STMT_COMMIT_PREPARED;
					n->gid = (yyvsp[(3) - (3)].str);
					(yyval.node) = (Node *)n;
				;}
    break;

  case 743:

/* Line 1455 of yacc.c  */
#line 4768 "gram.y"
    {
					TransactionStmt *n = makeNode(TransactionStmt);
					n->kind = TRANS_STMT_ROLLBACK_PREPARED;
					n->gid = (yyvsp[(3) - (3)].str);
					(yyval.node) = (Node *)n;
				;}
    break;

  case 744:

/* Line 1455 of yacc.c  */
#line 4776 "gram.y"
    {;}
    break;

  case 745:

/* Line 1455 of yacc.c  */
#line 4777 "gram.y"
    {;}
    break;

  case 746:

/* Line 1455 of yacc.c  */
#line 4778 "gram.y"
    {;}
    break;

  case 747:

/* Line 1455 of yacc.c  */
#line 4783 "gram.y"
    { (yyval.defelt) = makeDefElem("transaction_isolation",
									   makeStringConst((yyvsp[(3) - (3)].str), NULL)); ;}
    break;

  case 748:

/* Line 1455 of yacc.c  */
#line 4786 "gram.y"
    { (yyval.defelt) = makeDefElem("transaction_read_only",
									   makeIntConst(TRUE)); ;}
    break;

  case 749:

/* Line 1455 of yacc.c  */
#line 4789 "gram.y"
    { (yyval.defelt) = makeDefElem("transaction_read_only",
									   makeIntConst(FALSE)); ;}
    break;

  case 750:

/* Line 1455 of yacc.c  */
#line 4796 "gram.y"
    { (yyval.list) = list_make1((yyvsp[(1) - (1)].defelt)); ;}
    break;

  case 751:

/* Line 1455 of yacc.c  */
#line 4798 "gram.y"
    { (yyval.list) = lappend((yyvsp[(1) - (3)].list), (yyvsp[(3) - (3)].defelt)); ;}
    break;

  case 752:

/* Line 1455 of yacc.c  */
#line 4800 "gram.y"
    { (yyval.list) = lappend((yyvsp[(1) - (2)].list), (yyvsp[(2) - (2)].defelt)); ;}
    break;

  case 754:

/* Line 1455 of yacc.c  */
#line 4806 "gram.y"
    { (yyval.list) = NIL; ;}
    break;

  case 755:

/* Line 1455 of yacc.c  */
#line 4820 "gram.y"
    {
					ViewStmt *n = makeNode(ViewStmt);
					n->replace = false;
					n->view = (yyvsp[(4) - (8)].range);
					n->view->istemp = (yyvsp[(2) - (8)].boolean);
					n->aliases = (yyvsp[(5) - (8)].list);
					n->query = (Query *) (yyvsp[(7) - (8)].node);
					(yyval.node) = (Node *) n;
				;}
    break;

  case 756:

/* Line 1455 of yacc.c  */
#line 4831 "gram.y"
    {
					ViewStmt *n = makeNode(ViewStmt);
					n->replace = true;
					n->view = (yyvsp[(6) - (10)].range);
					n->view->istemp = (yyvsp[(4) - (10)].boolean);
					n->aliases = (yyvsp[(7) - (10)].list);
					n->query = (Query *) (yyvsp[(9) - (10)].node);
					(yyval.node) = (Node *) n;
				;}
    break;

  case 757:

/* Line 1455 of yacc.c  */
#line 4848 "gram.y"
    {
					ereport(ERROR,
							(errcode(ERRCODE_FEATURE_NOT_SUPPORTED),
							 errmsg("WITH CHECK OPTION is not implemented")));
				;}
    break;

  case 758:

/* Line 1455 of yacc.c  */
#line 4854 "gram.y"
    {
					ereport(ERROR,
							(errcode(ERRCODE_FEATURE_NOT_SUPPORTED),
							 errmsg("WITH CHECK OPTION is not implemented")));
				;}
    break;

  case 759:

/* Line 1455 of yacc.c  */
#line 4860 "gram.y"
    {
					ereport(ERROR,
							(errcode(ERRCODE_FEATURE_NOT_SUPPORTED),
							 errmsg("WITH CHECK OPTION is not implemented")));
				;}
    break;

  case 760:

/* Line 1455 of yacc.c  */
#line 4865 "gram.y"
    { (yyval.list) = NIL; ;}
    break;

  case 761:

/* Line 1455 of yacc.c  */
#line 4876 "gram.y"
    {
					LoadStmt *n = makeNode(LoadStmt);
					n->filename = (yyvsp[(2) - (2)].str);
					(yyval.node) = (Node *)n;
				;}
    break;

  case 762:

/* Line 1455 of yacc.c  */
#line 4892 "gram.y"
    {
					CreatedbStmt *n = makeNode(CreatedbStmt);
					n->dbname = (yyvsp[(3) - (5)].str);
					n->options = (yyvsp[(5) - (5)].list);
					(yyval.node) = (Node *)n;
				;}
    break;

  case 763:

/* Line 1455 of yacc.c  */
#line 4901 "gram.y"
    { (yyval.list) = lappend((yyvsp[(1) - (2)].list), (yyvsp[(2) - (2)].defelt)); ;}
    break;

  case 764:

/* Line 1455 of yacc.c  */
#line 4902 "gram.y"
    { (yyval.list) = NIL; ;}
    break;

  case 765:

/* Line 1455 of yacc.c  */
#line 4907 "gram.y"
    {
					(yyval.defelt) = makeDefElem("tablespace", (Node *)makeString((yyvsp[(3) - (3)].str)));
				;}
    break;

  case 766:

/* Line 1455 of yacc.c  */
#line 4911 "gram.y"
    {
					(yyval.defelt) = makeDefElem("tablespace", NULL);
				;}
    break;

  case 767:

/* Line 1455 of yacc.c  */
#line 4915 "gram.y"
    {
					(yyval.defelt) = makeDefElem("location", (Node *)makeString((yyvsp[(3) - (3)].str)));
				;}
    break;

  case 768:

/* Line 1455 of yacc.c  */
#line 4919 "gram.y"
    {
					(yyval.defelt) = makeDefElem("location", NULL);
				;}
    break;

  case 769:

/* Line 1455 of yacc.c  */
#line 4923 "gram.y"
    {
					(yyval.defelt) = makeDefElem("template", (Node *)makeString((yyvsp[(3) - (3)].str)));
				;}
    break;

  case 770:

/* Line 1455 of yacc.c  */
#line 4927 "gram.y"
    {
					(yyval.defelt) = makeDefElem("template", NULL);
				;}
    break;

  case 771:

/* Line 1455 of yacc.c  */
#line 4931 "gram.y"
    {
					(yyval.defelt) = makeDefElem("encoding", (Node *)makeString((yyvsp[(3) - (3)].str)));
				;}
    break;

  case 772:

/* Line 1455 of yacc.c  */
#line 4935 "gram.y"
    {
					(yyval.defelt) = makeDefElem("encoding", (Node *)makeInteger((yyvsp[(3) - (3)].ival)));
				;}
    break;

  case 773:

/* Line 1455 of yacc.c  */
#line 4939 "gram.y"
    {
					(yyval.defelt) = makeDefElem("encoding", NULL);
				;}
    break;

  case 774:

/* Line 1455 of yacc.c  */
#line 4943 "gram.y"
    {
					(yyval.defelt) = makeDefElem("connectionlimit", (Node *)makeInteger((yyvsp[(4) - (4)].ival)));
				;}
    break;

  case 775:

/* Line 1455 of yacc.c  */
#line 4947 "gram.y"
    {
					(yyval.defelt) = makeDefElem("owner", (Node *)makeString((yyvsp[(3) - (3)].str)));
				;}
    break;

  case 776:

/* Line 1455 of yacc.c  */
#line 4951 "gram.y"
    {
					(yyval.defelt) = makeDefElem("owner", NULL);
				;}
    break;

  case 777:

/* Line 1455 of yacc.c  */
#line 4960 "gram.y"
    {;}
    break;

  case 778:

/* Line 1455 of yacc.c  */
#line 4961 "gram.y"
    {;}
    break;

  case 779:

/* Line 1455 of yacc.c  */
#line 4973 "gram.y"
    {
					AlterDatabaseStmt *n = makeNode(AlterDatabaseStmt);
					n->dbname = (yyvsp[(3) - (5)].str);
					n->options = (yyvsp[(5) - (5)].list);
					(yyval.node) = (Node *)n;
				 ;}
    break;

  case 780:

/* Line 1455 of yacc.c  */
#line 4983 "gram.y"
    {
					AlterDatabaseSetStmt *n = makeNode(AlterDatabaseSetStmt);
					n->dbname = (yyvsp[(3) - (5)].str);
					n->variable = (yyvsp[(5) - (5)].vsetstmt)->name;
					n->value = (yyvsp[(5) - (5)].vsetstmt)->args;
					(yyval.node) = (Node *)n;
				;}
    break;

  case 781:

/* Line 1455 of yacc.c  */
#line 4991 "gram.y"
    {
					AlterDatabaseSetStmt *n = makeNode(AlterDatabaseSetStmt);
					n->dbname = (yyvsp[(3) - (4)].str);
					n->variable = ((VariableResetStmt *)(yyvsp[(4) - (4)].node))->name;
					n->value = NIL;
					(yyval.node) = (Node *)n;
				;}
    break;

  case 782:

/* Line 1455 of yacc.c  */
#line 5002 "gram.y"
    { (yyval.list) = lappend((yyvsp[(1) - (2)].list), (yyvsp[(2) - (2)].defelt)); ;}
    break;

  case 783:

/* Line 1455 of yacc.c  */
#line 5003 "gram.y"
    { (yyval.list) = NIL; ;}
    break;

  case 784:

/* Line 1455 of yacc.c  */
#line 5008 "gram.y"
    {
					(yyval.defelt) = makeDefElem("connectionlimit", (Node *)makeInteger((yyvsp[(4) - (4)].ival)));
				;}
    break;

  case 785:

/* Line 1455 of yacc.c  */
#line 5022 "gram.y"
    {
					DropdbStmt *n = makeNode(DropdbStmt);
					n->dbname = (yyvsp[(3) - (3)].str);
					n->missing_ok = FALSE;
					(yyval.node) = (Node *)n;
				;}
    break;

  case 786:

/* Line 1455 of yacc.c  */
#line 5029 "gram.y"
    {
					DropdbStmt *n = makeNode(DropdbStmt);
					n->dbname = (yyvsp[(5) - (5)].str);
					n->missing_ok = TRUE;
					(yyval.node) = (Node *)n;
				;}
    break;

  case 787:

/* Line 1455 of yacc.c  */
#line 5046 "gram.y"
    {
					CreateDomainStmt *n = makeNode(CreateDomainStmt);
					n->domainname = (yyvsp[(3) - (6)].list);
					n->typename = (yyvsp[(5) - (6)].typnam);
					n->constraints = (yyvsp[(6) - (6)].list);
					(yyval.node) = (Node *)n;
				;}
    break;

  case 788:

/* Line 1455 of yacc.c  */
#line 5058 "gram.y"
    {
					AlterDomainStmt *n = makeNode(AlterDomainStmt);
					n->subtype = 'T';
					n->typename = (yyvsp[(3) - (4)].list);
					n->def = (yyvsp[(4) - (4)].node);
					(yyval.node) = (Node *)n;
				;}
    break;

  case 789:

/* Line 1455 of yacc.c  */
#line 5067 "gram.y"
    {
					AlterDomainStmt *n = makeNode(AlterDomainStmt);
					n->subtype = 'N';
					n->typename = (yyvsp[(3) - (6)].list);
					(yyval.node) = (Node *)n;
				;}
    break;

  case 790:

/* Line 1455 of yacc.c  */
#line 5075 "gram.y"
    {
					AlterDomainStmt *n = makeNode(AlterDomainStmt);
					n->subtype = 'O';
					n->typename = (yyvsp[(3) - (6)].list);
					(yyval.node) = (Node *)n;
				;}
    break;

  case 791:

/* Line 1455 of yacc.c  */
#line 5083 "gram.y"
    {
					AlterDomainStmt *n = makeNode(AlterDomainStmt);
					n->subtype = 'C';
					n->typename = (yyvsp[(3) - (5)].list);
					n->def = (yyvsp[(5) - (5)].node);
					(yyval.node) = (Node *)n;
				;}
    break;

  case 792:

/* Line 1455 of yacc.c  */
#line 5092 "gram.y"
    {
					AlterDomainStmt *n = makeNode(AlterDomainStmt);
					n->subtype = 'X';
					n->typename = (yyvsp[(3) - (7)].list);
					n->name = (yyvsp[(6) - (7)].str);
					n->behavior = (yyvsp[(7) - (7)].dbehavior);
					(yyval.node) = (Node *)n;
				;}
    break;

  case 793:

/* Line 1455 of yacc.c  */
#line 5102 "gram.y"
    {;}
    break;

  case 794:

/* Line 1455 of yacc.c  */
#line 5103 "gram.y"
    {;}
    break;

  case 795:

/* Line 1455 of yacc.c  */
#line 5119 "gram.y"
    {
			  CreateConversionStmt *n = makeNode(CreateConversionStmt);
			  n->conversion_name = (yyvsp[(4) - (10)].list);
			  n->for_encoding_name = (yyvsp[(6) - (10)].str);
			  n->to_encoding_name = (yyvsp[(8) - (10)].str);
			  n->func_name = (yyvsp[(10) - (10)].list);
			  n->def = (yyvsp[(2) - (10)].boolean);
			  (yyval.node) = (Node *)n;
			;}
    break;

  case 796:

/* Line 1455 of yacc.c  */
#line 5141 "gram.y"
    {
				   ClusterStmt *n = makeNode(ClusterStmt);
				   n->relation = (yyvsp[(4) - (4)].range);
				   n->indexname = (yyvsp[(2) - (4)].str);
				   (yyval.node) = (Node*)n;
				;}
    break;

  case 797:

/* Line 1455 of yacc.c  */
#line 5148 "gram.y"
    {
			       ClusterStmt *n = makeNode(ClusterStmt);
				   n->relation = (yyvsp[(2) - (2)].range);
				   n->indexname = NULL;
				   (yyval.node) = (Node*)n;
				;}
    break;

  case 798:

/* Line 1455 of yacc.c  */
#line 5155 "gram.y"
    {
				   ClusterStmt *n = makeNode(ClusterStmt);
				   n->relation = NULL;
				   n->indexname = NULL;
				   (yyval.node) = (Node*)n;
				;}
    break;

  case 799:

/* Line 1455 of yacc.c  */
#line 5172 "gram.y"
    {
					VacuumStmt *n = makeNode(VacuumStmt);
					n->vacuum = true;
					n->analyze = false;
					n->full = (yyvsp[(2) - (4)].boolean);
					n->freeze_min_age = (yyvsp[(3) - (4)].boolean) ? 0 : -1;
					n->verbose = (yyvsp[(4) - (4)].boolean);
					n->relation = NULL;
					n->va_cols = NIL;
					(yyval.node) = (Node *)n;
				;}
    break;

  case 800:

/* Line 1455 of yacc.c  */
#line 5184 "gram.y"
    {
					VacuumStmt *n = makeNode(VacuumStmt);
					n->vacuum = true;
					n->analyze = false;
					n->full = (yyvsp[(2) - (5)].boolean);
					n->freeze_min_age = (yyvsp[(3) - (5)].boolean) ? 0 : -1;
					n->verbose = (yyvsp[(4) - (5)].boolean);
					n->relation = (yyvsp[(5) - (5)].range);
					n->va_cols = NIL;
					(yyval.node) = (Node *)n;
				;}
    break;

  case 801:

/* Line 1455 of yacc.c  */
#line 5196 "gram.y"
    {
					VacuumStmt *n = (VacuumStmt *) (yyvsp[(5) - (5)].node);
					n->vacuum = true;
					n->full = (yyvsp[(2) - (5)].boolean);
					n->freeze_min_age = (yyvsp[(3) - (5)].boolean) ? 0 : -1;
					n->verbose |= (yyvsp[(4) - (5)].boolean);
					(yyval.node) = (Node *)n;
				;}
    break;

  case 802:

/* Line 1455 of yacc.c  */
#line 5208 "gram.y"
    {
					VacuumStmt *n = makeNode(VacuumStmt);
					n->vacuum = false;
					n->analyze = true;
					n->full = false;
					n->freeze_min_age = -1;
					n->verbose = (yyvsp[(2) - (2)].boolean);
					n->relation = NULL;
					n->va_cols = NIL;
					(yyval.node) = (Node *)n;
				;}
    break;

  case 803:

/* Line 1455 of yacc.c  */
#line 5220 "gram.y"
    {
					VacuumStmt *n = makeNode(VacuumStmt);
					n->vacuum = false;
					n->analyze = true;
					n->full = false;
					n->freeze_min_age = -1;
					n->verbose = (yyvsp[(2) - (4)].boolean);
					n->relation = (yyvsp[(3) - (4)].range);
					n->va_cols = (yyvsp[(4) - (4)].list);
					(yyval.node) = (Node *)n;
				;}
    break;

  case 804:

/* Line 1455 of yacc.c  */
#line 5234 "gram.y"
    {;}
    break;

  case 805:

/* Line 1455 of yacc.c  */
#line 5235 "gram.y"
    {;}
    break;

  case 806:

/* Line 1455 of yacc.c  */
#line 5239 "gram.y"
    { (yyval.boolean) = TRUE; ;}
    break;

  case 807:

/* Line 1455 of yacc.c  */
#line 5240 "gram.y"
    { (yyval.boolean) = FALSE; ;}
    break;

  case 808:

/* Line 1455 of yacc.c  */
#line 5243 "gram.y"
    { (yyval.boolean) = TRUE; ;}
    break;

  case 809:

/* Line 1455 of yacc.c  */
#line 5244 "gram.y"
    { (yyval.boolean) = FALSE; ;}
    break;

  case 810:

/* Line 1455 of yacc.c  */
#line 5247 "gram.y"
    { (yyval.boolean) = TRUE; ;}
    break;

  case 811:

/* Line 1455 of yacc.c  */
#line 5248 "gram.y"
    { (yyval.boolean) = FALSE; ;}
    break;

  case 812:

/* Line 1455 of yacc.c  */
#line 5252 "gram.y"
    { (yyval.list) = (yyvsp[(2) - (3)].list); ;}
    break;

  case 813:

/* Line 1455 of yacc.c  */
#line 5253 "gram.y"
    { (yyval.list) = NIL; ;}
    break;

  case 814:

/* Line 1455 of yacc.c  */
#line 5265 "gram.y"
    {
					ExplainStmt *n = makeNode(ExplainStmt);
					n->analyze = (yyvsp[(2) - (4)].boolean);
					n->verbose = (yyvsp[(3) - (4)].boolean);
					n->query = (Query*)(yyvsp[(4) - (4)].node);
					(yyval.node) = (Node *)n;
				;}
    break;

  case 821:

/* Line 1455 of yacc.c  */
#line 5284 "gram.y"
    { (yyval.boolean) = TRUE; ;}
    break;

  case 822:

/* Line 1455 of yacc.c  */
#line 5285 "gram.y"
    { (yyval.boolean) = FALSE; ;}
    break;

  case 823:

/* Line 1455 of yacc.c  */
#line 5296 "gram.y"
    {
					PrepareStmt *n = makeNode(PrepareStmt);
					n->name = (yyvsp[(2) - (5)].str);
					n->argtypes = (yyvsp[(3) - (5)].list);
					n->query = (Query *) (yyvsp[(5) - (5)].node);
					(yyval.node) = (Node *) n;
				;}
    break;

  case 824:

/* Line 1455 of yacc.c  */
#line 5305 "gram.y"
    { (yyval.list) = (yyvsp[(2) - (3)].list); ;}
    break;

  case 825:

/* Line 1455 of yacc.c  */
#line 5306 "gram.y"
    { (yyval.list) = NIL; ;}
    break;

  case 826:

/* Line 1455 of yacc.c  */
#line 5309 "gram.y"
    { (yyval.list) = list_make1((yyvsp[(1) - (1)].typnam)); ;}
    break;

  case 827:

/* Line 1455 of yacc.c  */
#line 5311 "gram.y"
    { (yyval.list) = lappend((yyvsp[(1) - (3)].list), (yyvsp[(3) - (3)].typnam)); ;}
    break;

  case 832:

/* Line 1455 of yacc.c  */
#line 5329 "gram.y"
    {
					ExecuteStmt *n = makeNode(ExecuteStmt);
					n->name = (yyvsp[(2) - (3)].str);
					n->params = (yyvsp[(3) - (3)].list);
					n->into = NULL;
					(yyval.node) = (Node *) n;
				;}
    break;

  case 833:

/* Line 1455 of yacc.c  */
#line 5339 "gram.y"
    {
					ExecuteStmt *n = makeNode(ExecuteStmt);
					n->name = (yyvsp[(11) - (12)].str);
					n->params = (yyvsp[(12) - (12)].list);
					(yyvsp[(4) - (12)].range)->istemp = (yyvsp[(2) - (12)].boolean);
					n->into = (yyvsp[(4) - (12)].range);
					n->intoOptions = (yyvsp[(6) - (12)].list);
					n->into_on_commit = (yyvsp[(7) - (12)].oncommit);
					n->into_tbl_space = (yyvsp[(8) - (12)].str);
					if ((yyvsp[(5) - (12)].list))
						ereport(ERROR,
								(errcode(ERRCODE_FEATURE_NOT_SUPPORTED),
								 errmsg("column name list not allowed in CREATE TABLE / AS EXECUTE")));
					/* ... because it's not implemented, but it could be */
					(yyval.node) = (Node *) n;
				;}
    break;

  case 834:

/* Line 1455 of yacc.c  */
#line 5357 "gram.y"
    { (yyval.list) = (yyvsp[(2) - (3)].list); ;}
    break;

  case 835:

/* Line 1455 of yacc.c  */
#line 5358 "gram.y"
    { (yyval.list) = NIL; ;}
    break;

  case 836:

/* Line 1455 of yacc.c  */
#line 5369 "gram.y"
    {
						DeallocateStmt *n = makeNode(DeallocateStmt);
						n->name = (yyvsp[(2) - (2)].str);
						(yyval.node) = (Node *) n;
					;}
    break;

  case 837:

/* Line 1455 of yacc.c  */
#line 5375 "gram.y"
    {
						DeallocateStmt *n = makeNode(DeallocateStmt);
						n->name = (yyvsp[(3) - (3)].str);
						(yyval.node) = (Node *) n;
					;}
    break;

  case 838:

/* Line 1455 of yacc.c  */
#line 5391 "gram.y"
    {
					(yyvsp[(4) - (5)].istmt)->relation = (yyvsp[(3) - (5)].range);
					(yyvsp[(4) - (5)].istmt)->returningList = (yyvsp[(5) - (5)].list);
					(yyval.node) = (Node *) (yyvsp[(4) - (5)].istmt);
				;}
    break;

  case 839:

/* Line 1455 of yacc.c  */
#line 5400 "gram.y"
    {
					(yyval.istmt) = makeNode(InsertStmt);
					(yyval.istmt)->cols = NIL;
					(yyval.istmt)->selectStmt = (yyvsp[(1) - (1)].node);
				;}
    break;

  case 840:

/* Line 1455 of yacc.c  */
#line 5406 "gram.y"
    {
					(yyval.istmt) = makeNode(InsertStmt);
					(yyval.istmt)->cols = (yyvsp[(2) - (4)].list);
					(yyval.istmt)->selectStmt = (yyvsp[(4) - (4)].node);
				;}
    break;

  case 841:

/* Line 1455 of yacc.c  */
#line 5412 "gram.y"
    {
					(yyval.istmt) = makeNode(InsertStmt);
					(yyval.istmt)->cols = NIL;
					(yyval.istmt)->selectStmt = NULL;
				;}
    break;

  case 842:

/* Line 1455 of yacc.c  */
#line 5421 "gram.y"
    { (yyval.list) = list_make1((yyvsp[(1) - (1)].target)); ;}
    break;

  case 843:

/* Line 1455 of yacc.c  */
#line 5423 "gram.y"
    { (yyval.list) = lappend((yyvsp[(1) - (3)].list), (yyvsp[(3) - (3)].target)); ;}
    break;

  case 844:

/* Line 1455 of yacc.c  */
#line 5428 "gram.y"
    {
					(yyval.target) = makeNode(ResTarget);
					(yyval.target)->name = (yyvsp[(1) - (2)].str);
					(yyval.target)->indirection = (yyvsp[(2) - (2)].list);
					(yyval.target)->val = NULL;
					(yyval.target)->location = (yylsp[(1) - (2)]);
				;}
    break;

  case 845:

/* Line 1455 of yacc.c  */
#line 5438 "gram.y"
    { (yyval.list) = (yyvsp[(2) - (2)].list); ;}
    break;

  case 846:

/* Line 1455 of yacc.c  */
#line 5439 "gram.y"
    { (yyval.list) = NIL; ;}
    break;

  case 847:

/* Line 1455 of yacc.c  */
#line 5452 "gram.y"
    {
					DeleteStmt *n = makeNode(DeleteStmt);
					n->relation = (yyvsp[(3) - (6)].range);
					n->usingClause = (yyvsp[(4) - (6)].list);
					n->whereClause = (yyvsp[(5) - (6)].node);
					n->returningList = (yyvsp[(6) - (6)].list);
					(yyval.node) = (Node *)n;
				;}
    break;

  case 848:

/* Line 1455 of yacc.c  */
#line 5463 "gram.y"
    { (yyval.list) = (yyvsp[(2) - (2)].list); ;}
    break;

  case 849:

/* Line 1455 of yacc.c  */
#line 5464 "gram.y"
    { (yyval.list) = NIL; ;}
    break;

  case 850:

/* Line 1455 of yacc.c  */
#line 5468 "gram.y"
    {
					LockStmt *n = makeNode(LockStmt);

					n->relations = (yyvsp[(3) - (5)].list);
					n->mode = (yyvsp[(4) - (5)].ival);
					n->nowait = (yyvsp[(5) - (5)].boolean);
					(yyval.node) = (Node *)n;
				;}
    break;

  case 851:

/* Line 1455 of yacc.c  */
#line 5478 "gram.y"
    { (yyval.ival) = (yyvsp[(2) - (3)].ival); ;}
    break;

  case 852:

/* Line 1455 of yacc.c  */
#line 5479 "gram.y"
    { (yyval.ival) = AccessExclusiveLock; ;}
    break;

  case 853:

/* Line 1455 of yacc.c  */
#line 5482 "gram.y"
    { (yyval.ival) = AccessShareLock; ;}
    break;

  case 854:

/* Line 1455 of yacc.c  */
#line 5483 "gram.y"
    { (yyval.ival) = RowShareLock; ;}
    break;

  case 855:

/* Line 1455 of yacc.c  */
#line 5484 "gram.y"
    { (yyval.ival) = RowExclusiveLock; ;}
    break;

  case 856:

/* Line 1455 of yacc.c  */
#line 5485 "gram.y"
    { (yyval.ival) = ShareUpdateExclusiveLock; ;}
    break;

  case 857:

/* Line 1455 of yacc.c  */
#line 5486 "gram.y"
    { (yyval.ival) = ShareLock; ;}
    break;

  case 858:

/* Line 1455 of yacc.c  */
#line 5487 "gram.y"
    { (yyval.ival) = ShareRowExclusiveLock; ;}
    break;

  case 859:

/* Line 1455 of yacc.c  */
#line 5488 "gram.y"
    { (yyval.ival) = ExclusiveLock; ;}
    break;

  case 860:

/* Line 1455 of yacc.c  */
#line 5489 "gram.y"
    { (yyval.ival) = AccessExclusiveLock; ;}
    break;

  case 861:

/* Line 1455 of yacc.c  */
#line 5492 "gram.y"
    { (yyval.boolean) = TRUE; ;}
    break;

  case 862:

/* Line 1455 of yacc.c  */
#line 5493 "gram.y"
    { (yyval.boolean) = FALSE; ;}
    break;

  case 863:

/* Line 1455 of yacc.c  */
#line 5509 "gram.y"
    {
					UpdateStmt *n = makeNode(UpdateStmt);
					n->relation = (yyvsp[(2) - (7)].range);
					n->targetList = (yyvsp[(4) - (7)].list);
					n->fromClause = (yyvsp[(5) - (7)].list);
					n->whereClause = (yyvsp[(6) - (7)].node);
					n->returningList = (yyvsp[(7) - (7)].list);
					(yyval.node) = (Node *)n;
				;}
    break;

  case 864:

/* Line 1455 of yacc.c  */
#line 5521 "gram.y"
    { (yyval.list) = (yyvsp[(1) - (1)].list); ;}
    break;

  case 865:

/* Line 1455 of yacc.c  */
#line 5522 "gram.y"
    { (yyval.list) = list_concat((yyvsp[(1) - (3)].list),(yyvsp[(3) - (3)].list)); ;}
    break;

  case 866:

/* Line 1455 of yacc.c  */
#line 5526 "gram.y"
    { (yyval.list) = list_make1((yyvsp[(1) - (1)].target)); ;}
    break;

  case 867:

/* Line 1455 of yacc.c  */
#line 5527 "gram.y"
    { (yyval.list) = (yyvsp[(1) - (1)].list); ;}
    break;

  case 868:

/* Line 1455 of yacc.c  */
#line 5532 "gram.y"
    {
					(yyval.target) = (yyvsp[(1) - (3)].target);
					(yyval.target)->val = (Node *) (yyvsp[(3) - (3)].node);
				;}
    break;

  case 869:

/* Line 1455 of yacc.c  */
#line 5540 "gram.y"
    {
					ListCell *col_cell;
					ListCell *val_cell;

					/*
					 * Break the ctext_row apart, merge individual expressions
					 * into the destination ResTargets.  XXX this approach
					 * cannot work for general row expressions as sources.
					 */
					if (list_length((yyvsp[(2) - (5)].list)) != list_length((yyvsp[(5) - (5)].list)))
						ereport(ERROR,
								(errcode(ERRCODE_SYNTAX_ERROR),
								 errmsg("number of columns does not match number of values")));
					forboth(col_cell, (yyvsp[(2) - (5)].list), val_cell, (yyvsp[(5) - (5)].list))
					{
						ResTarget *res_col = (ResTarget *) lfirst(col_cell);
						Node *res_val = (Node *) lfirst(val_cell);

						res_col->val = res_val;
					}
				    
					(yyval.list) = (yyvsp[(2) - (5)].list);
				;}
    break;

  case 870:

/* Line 1455 of yacc.c  */
#line 5567 "gram.y"
    {
					(yyval.target) = makeNode(ResTarget);
					(yyval.target)->name = (yyvsp[(1) - (2)].str);
					(yyval.target)->indirection = (yyvsp[(2) - (2)].list);
					(yyval.target)->val = NULL;	/* upper production sets this */
					(yyval.target)->location = (yylsp[(1) - (2)]);
				;}
    break;

  case 871:

/* Line 1455 of yacc.c  */
#line 5577 "gram.y"
    { (yyval.list) = list_make1((yyvsp[(1) - (1)].target)); ;}
    break;

  case 872:

/* Line 1455 of yacc.c  */
#line 5578 "gram.y"
    { (yyval.list) = lappend((yyvsp[(1) - (3)].list),(yyvsp[(3) - (3)].target)); ;}
    break;

  case 873:

/* Line 1455 of yacc.c  */
#line 5589 "gram.y"
    {
					DeclareCursorStmt *n = makeNode(DeclareCursorStmt);
					n->portalname = (yyvsp[(2) - (7)].str);
					n->options = (yyvsp[(3) - (7)].ival);
					n->query = (yyvsp[(7) - (7)].node);
					if ((yyvsp[(5) - (7)].boolean))
						n->options |= CURSOR_OPT_HOLD;
					(yyval.node) = (Node *)n;
				;}
    break;

  case 874:

/* Line 1455 of yacc.c  */
#line 5600 "gram.y"
    { (yyval.ival) = 0; ;}
    break;

  case 875:

/* Line 1455 of yacc.c  */
#line 5601 "gram.y"
    { (yyval.ival) = (yyvsp[(1) - (3)].ival) | CURSOR_OPT_NO_SCROLL; ;}
    break;

  case 876:

/* Line 1455 of yacc.c  */
#line 5602 "gram.y"
    { (yyval.ival) = (yyvsp[(1) - (2)].ival) | CURSOR_OPT_SCROLL; ;}
    break;

  case 877:

/* Line 1455 of yacc.c  */
#line 5603 "gram.y"
    { (yyval.ival) = (yyvsp[(1) - (2)].ival) | CURSOR_OPT_BINARY; ;}
    break;

  case 878:

/* Line 1455 of yacc.c  */
#line 5604 "gram.y"
    { (yyval.ival) = (yyvsp[(1) - (2)].ival) | CURSOR_OPT_INSENSITIVE; ;}
    break;

  case 879:

/* Line 1455 of yacc.c  */
#line 5607 "gram.y"
    { (yyval.boolean) = FALSE; ;}
    break;

  case 880:

/* Line 1455 of yacc.c  */
#line 5608 "gram.y"
    { (yyval.boolean) = TRUE; ;}
    break;

  case 881:

/* Line 1455 of yacc.c  */
#line 5609 "gram.y"
    { (yyval.boolean) = FALSE; ;}
    break;

  case 884:

/* Line 1455 of yacc.c  */
#line 5662 "gram.y"
    { (yyval.node) = (yyvsp[(2) - (3)].node); ;}
    break;

  case 885:

/* Line 1455 of yacc.c  */
#line 5663 "gram.y"
    { (yyval.node) = (yyvsp[(2) - (3)].node); ;}
    break;

  case 886:

/* Line 1455 of yacc.c  */
#line 5673 "gram.y"
    { (yyval.node) = (yyvsp[(1) - (1)].node); ;}
    break;

  case 887:

/* Line 1455 of yacc.c  */
#line 5675 "gram.y"
    {
					insertSelectOptions((SelectStmt *) (yyvsp[(1) - (2)].node), (yyvsp[(2) - (2)].list), NIL,
										NULL, NULL);
					(yyval.node) = (yyvsp[(1) - (2)].node);
				;}
    break;

  case 888:

/* Line 1455 of yacc.c  */
#line 5681 "gram.y"
    {
					insertSelectOptions((SelectStmt *) (yyvsp[(1) - (4)].node), (yyvsp[(2) - (4)].list), (yyvsp[(3) - (4)].list),
										list_nth((yyvsp[(4) - (4)].list), 0), list_nth((yyvsp[(4) - (4)].list), 1));
					(yyval.node) = (yyvsp[(1) - (4)].node);
				;}
    break;

  case 889:

/* Line 1455 of yacc.c  */
#line 5687 "gram.y"
    {
					insertSelectOptions((SelectStmt *) (yyvsp[(1) - (4)].node), (yyvsp[(2) - (4)].list), (yyvsp[(4) - (4)].list),
										list_nth((yyvsp[(3) - (4)].list), 0), list_nth((yyvsp[(3) - (4)].list), 1));
					(yyval.node) = (yyvsp[(1) - (4)].node);
				;}
    break;

  case 890:

/* Line 1455 of yacc.c  */
#line 5695 "gram.y"
    { (yyval.node) = (yyvsp[(1) - (1)].node); ;}
    break;

  case 891:

/* Line 1455 of yacc.c  */
#line 5696 "gram.y"
    { (yyval.node) = (yyvsp[(1) - (1)].node); ;}
    break;

  case 892:

/* Line 1455 of yacc.c  */
#line 5746 "gram.y"
    {
					SelectStmt *n = makeNode(SelectStmt);
					n->distinctClause = (yyvsp[(2) - (11)].list);
					n->targetList = (yyvsp[(3) - (11)].list);
					n->into = (yyvsp[(4) - (11)].range);
					n->intoColNames = NIL;
					n->fromClause = (yyvsp[(5) - (11)].list);
					n->whereClause = (yyvsp[(6) - (11)].node);
					n->groupClause = (yyvsp[(7) - (11)].list);

					n->aroundSelectStmt = (yyvsp[(8) - (11)].node);
					n->sgb_MaxGroupDiam = (yyvsp[(9) - (11)].ival);
					n->sgb_MaxElemSep = (yyvsp[(10) - (11)].ival);
					
					n->havingClause = (yyvsp[(11) - (11)].node);
					(yyval.node) = (Node *)n;
				;}
    break;

  case 893:

/* Line 1455 of yacc.c  */
#line 5765 "gram.y"
    { (yyval.node) = (yyvsp[(1) - (1)].node); ;}
    break;

  case 894:

/* Line 1455 of yacc.c  */
#line 5767 "gram.y"
    {
					(yyval.node) = makeSetOp(SETOP_UNION, (yyvsp[(3) - (4)].boolean), (yyvsp[(1) - (4)].node), (yyvsp[(4) - (4)].node));
				;}
    break;

  case 895:

/* Line 1455 of yacc.c  */
#line 5771 "gram.y"
    {
					(yyval.node) = makeSetOp(SETOP_INTERSECT, (yyvsp[(3) - (4)].boolean), (yyvsp[(1) - (4)].node), (yyvsp[(4) - (4)].node));
				;}
    break;

  case 896:

/* Line 1455 of yacc.c  */
#line 5775 "gram.y"
    {
					(yyval.node) = makeSetOp(SETOP_EXCEPT, (yyvsp[(3) - (4)].boolean), (yyvsp[(1) - (4)].node), (yyvsp[(4) - (4)].node));
				;}
    break;

  case 897:

/* Line 1455 of yacc.c  */
#line 5781 "gram.y"
    { (yyval.range) = (yyvsp[(2) - (2)].range); ;}
    break;

  case 898:

/* Line 1455 of yacc.c  */
#line 5782 "gram.y"
    { (yyval.range) = NULL; ;}
    break;

  case 899:

/* Line 1455 of yacc.c  */
#line 5791 "gram.y"
    {
					(yyval.range) = (yyvsp[(3) - (3)].range);
					(yyval.range)->istemp = true;
				;}
    break;

  case 900:

/* Line 1455 of yacc.c  */
#line 5796 "gram.y"
    {
					(yyval.range) = (yyvsp[(3) - (3)].range);
					(yyval.range)->istemp = true;
				;}
    break;

  case 901:

/* Line 1455 of yacc.c  */
#line 5801 "gram.y"
    {
					(yyval.range) = (yyvsp[(4) - (4)].range);
					(yyval.range)->istemp = true;
				;}
    break;

  case 902:

/* Line 1455 of yacc.c  */
#line 5806 "gram.y"
    {
					(yyval.range) = (yyvsp[(4) - (4)].range);
					(yyval.range)->istemp = true;
				;}
    break;

  case 903:

/* Line 1455 of yacc.c  */
#line 5811 "gram.y"
    {
					(yyval.range) = (yyvsp[(4) - (4)].range);
					(yyval.range)->istemp = true;
				;}
    break;

  case 904:

/* Line 1455 of yacc.c  */
#line 5816 "gram.y"
    {
					(yyval.range) = (yyvsp[(4) - (4)].range);
					(yyval.range)->istemp = true;
				;}
    break;

  case 905:

/* Line 1455 of yacc.c  */
#line 5821 "gram.y"
    {
					(yyval.range) = (yyvsp[(2) - (2)].range);
					(yyval.range)->istemp = false;
				;}
    break;

  case 906:

/* Line 1455 of yacc.c  */
#line 5826 "gram.y"
    {
					(yyval.range) = (yyvsp[(1) - (1)].range);
					(yyval.range)->istemp = false;
				;}
    break;

  case 907:

/* Line 1455 of yacc.c  */
#line 5832 "gram.y"
    {;}
    break;

  case 908:

/* Line 1455 of yacc.c  */
#line 5833 "gram.y"
    {;}
    break;

  case 909:

/* Line 1455 of yacc.c  */
#line 5836 "gram.y"
    { (yyval.boolean) = TRUE; ;}
    break;

  case 910:

/* Line 1455 of yacc.c  */
#line 5837 "gram.y"
    { (yyval.boolean) = FALSE; ;}
    break;

  case 911:

/* Line 1455 of yacc.c  */
#line 5838 "gram.y"
    { (yyval.boolean) = FALSE; ;}
    break;

  case 912:

/* Line 1455 of yacc.c  */
#line 5845 "gram.y"
    { (yyval.list) = list_make1(NIL); ;}
    break;

  case 913:

/* Line 1455 of yacc.c  */
#line 5846 "gram.y"
    { (yyval.list) = (yyvsp[(4) - (5)].list); ;}
    break;

  case 914:

/* Line 1455 of yacc.c  */
#line 5847 "gram.y"
    { (yyval.list) = NIL; ;}
    break;

  case 915:

/* Line 1455 of yacc.c  */
#line 5848 "gram.y"
    { (yyval.list) = NIL; ;}
    break;

  case 916:

/* Line 1455 of yacc.c  */
#line 5852 "gram.y"
    { (yyval.list) = (yyvsp[(1) - (1)].list);;}
    break;

  case 917:

/* Line 1455 of yacc.c  */
#line 5853 "gram.y"
    { (yyval.list) = NIL; ;}
    break;

  case 918:

/* Line 1455 of yacc.c  */
#line 5857 "gram.y"
    { (yyval.list) = (yyvsp[(3) - (3)].list); ;}
    break;

  case 919:

/* Line 1455 of yacc.c  */
#line 5861 "gram.y"
    { (yyval.list) = list_make1((yyvsp[(1) - (1)].sortby)); ;}
    break;

  case 920:

/* Line 1455 of yacc.c  */
#line 5862 "gram.y"
    { (yyval.list) = lappend((yyvsp[(1) - (3)].list), (yyvsp[(3) - (3)].sortby)); ;}
    break;

  case 921:

/* Line 1455 of yacc.c  */
#line 5866 "gram.y"
    {
					(yyval.sortby) = makeNode(SortBy);
					(yyval.sortby)->node = (yyvsp[(1) - (3)].node);
					(yyval.sortby)->sortby_kind = SORTBY_USING;
					(yyval.sortby)->useOp = (yyvsp[(3) - (3)].list);
				;}
    break;

  case 922:

/* Line 1455 of yacc.c  */
#line 5873 "gram.y"
    {
					(yyval.sortby) = makeNode(SortBy);
					(yyval.sortby)->node = (yyvsp[(1) - (2)].node);
					(yyval.sortby)->sortby_kind = SORTBY_ASC;
					(yyval.sortby)->useOp = NIL;
				;}
    break;

  case 923:

/* Line 1455 of yacc.c  */
#line 5880 "gram.y"
    {
					(yyval.sortby) = makeNode(SortBy);
					(yyval.sortby)->node = (yyvsp[(1) - (2)].node);
					(yyval.sortby)->sortby_kind = SORTBY_DESC;
					(yyval.sortby)->useOp = NIL;
				;}
    break;

  case 924:

/* Line 1455 of yacc.c  */
#line 5887 "gram.y"
    {
					(yyval.sortby) = makeNode(SortBy);
					(yyval.sortby)->node = (yyvsp[(1) - (1)].node);
					(yyval.sortby)->sortby_kind = SORTBY_ASC;	/* default */
					(yyval.sortby)->useOp = NIL;
				;}
    break;

  case 925:

/* Line 1455 of yacc.c  */
#line 5898 "gram.y"
    { (yyval.list) = list_make2((yyvsp[(4) - (4)].node), (yyvsp[(2) - (4)].node)); ;}
    break;

  case 926:

/* Line 1455 of yacc.c  */
#line 5900 "gram.y"
    { (yyval.list) = list_make2((yyvsp[(2) - (4)].node), (yyvsp[(4) - (4)].node)); ;}
    break;

  case 927:

/* Line 1455 of yacc.c  */
#line 5902 "gram.y"
    { (yyval.list) = list_make2(NULL, (yyvsp[(2) - (2)].node)); ;}
    break;

  case 928:

/* Line 1455 of yacc.c  */
#line 5904 "gram.y"
    { (yyval.list) = list_make2((yyvsp[(2) - (2)].node), NULL); ;}
    break;

  case 929:

/* Line 1455 of yacc.c  */
#line 5906 "gram.y"
    {
					/* Disabled because it was too confusing, bjm 2002-02-18 */
					ereport(ERROR,
							(errcode(ERRCODE_SYNTAX_ERROR),
							 errmsg("LIMIT #,# syntax is not supported"),
							 errhint("Use separate LIMIT and OFFSET clauses.")));
				;}
    break;

  case 930:

/* Line 1455 of yacc.c  */
#line 5916 "gram.y"
    { (yyval.list) = (yyvsp[(1) - (1)].list); ;}
    break;

  case 931:

/* Line 1455 of yacc.c  */
#line 5918 "gram.y"
    { (yyval.list) = list_make2(NULL,NULL); ;}
    break;

  case 932:

/* Line 1455 of yacc.c  */
#line 5922 "gram.y"
    { (yyval.node) = (yyvsp[(1) - (1)].node); ;}
    break;

  case 933:

/* Line 1455 of yacc.c  */
#line 5924 "gram.y"
    {
					/* LIMIT ALL is represented as a NULL constant */
					A_Const *n = makeNode(A_Const);
					n->val.type = T_Null;
					(yyval.node) = (Node *)n;
				;}
    break;

  case 934:

/* Line 1455 of yacc.c  */
#line 5933 "gram.y"
    { (yyval.node) = (yyvsp[(1) - (1)].node); ;}
    break;

  case 935:

/* Line 1455 of yacc.c  */
#line 5937 "gram.y"
    { (yyval.list) = (yyvsp[(3) - (3)].list); ;}
    break;

  case 936:

/* Line 1455 of yacc.c  */
#line 5938 "gram.y"
    { (yyval.list) = NIL; ;}
    break;

  case 937:

/* Line 1455 of yacc.c  */
#line 5943 "gram.y"
    { (yyval.node) = (yyvsp[(2) - (2)].node); ;}
    break;

  case 938:

/* Line 1455 of yacc.c  */
#line 5944 "gram.y"
    { (yyval.node) = (Node	   *)NIL; ;}
    break;

  case 939:

/* Line 1455 of yacc.c  */
#line 5949 "gram.y"
    { (yyval.ival) = (yyvsp[(2) - (2)].ival); ;}
    break;

  case 940:

/* Line 1455 of yacc.c  */
#line 5950 "gram.y"
    { (yyval.ival) = (int) -1; ;}
    break;

  case 941:

/* Line 1455 of yacc.c  */
#line 5955 "gram.y"
    { (yyval.ival) = (yyvsp[(2) - (2)].ival); ;}
    break;

  case 942:

/* Line 1455 of yacc.c  */
#line 5956 "gram.y"
    { (yyval.ival) = (int) -1; ;}
    break;

  case 943:

/* Line 1455 of yacc.c  */
#line 5961 "gram.y"
    { (yyval.node) = (yyvsp[(2) - (2)].node); ;}
    break;

  case 944:

/* Line 1455 of yacc.c  */
#line 5962 "gram.y"
    { (yyval.node) = NULL; ;}
    break;

  case 945:

/* Line 1455 of yacc.c  */
#line 5966 "gram.y"
    { (yyval.list) = (yyvsp[(1) - (1)].list); ;}
    break;

  case 946:

/* Line 1455 of yacc.c  */
#line 5967 "gram.y"
    { (yyval.list) = NIL; ;}
    break;

  case 947:

/* Line 1455 of yacc.c  */
#line 5971 "gram.y"
    { (yyval.list) = (yyvsp[(1) - (1)].list); ;}
    break;

  case 948:

/* Line 1455 of yacc.c  */
#line 5972 "gram.y"
    { (yyval.list) = NIL; ;}
    break;

  case 949:

/* Line 1455 of yacc.c  */
#line 5976 "gram.y"
    { (yyval.list) = list_make1((yyvsp[(1) - (1)].node)); ;}
    break;

  case 950:

/* Line 1455 of yacc.c  */
#line 5977 "gram.y"
    { (yyval.list) = lappend((yyvsp[(1) - (2)].list), (yyvsp[(2) - (2)].node)); ;}
    break;

  case 951:

/* Line 1455 of yacc.c  */
#line 5982 "gram.y"
    {
					LockingClause *n = makeNode(LockingClause);
					n->lockedRels = (yyvsp[(3) - (4)].list);
					n->forUpdate = TRUE;
					n->noWait = (yyvsp[(4) - (4)].boolean);
					(yyval.node) = (Node *) n;
				;}
    break;

  case 952:

/* Line 1455 of yacc.c  */
#line 5990 "gram.y"
    {
					LockingClause *n = makeNode(LockingClause);
					n->lockedRels = (yyvsp[(3) - (4)].list);
					n->forUpdate = FALSE;
					n->noWait = (yyvsp[(4) - (4)].boolean);
					(yyval.node) = (Node *) n;
				;}
    break;

  case 953:

/* Line 1455 of yacc.c  */
#line 6000 "gram.y"
    { (yyval.list) = (yyvsp[(2) - (2)].list); ;}
    break;

  case 954:

/* Line 1455 of yacc.c  */
#line 6001 "gram.y"
    { (yyval.list) = NIL; ;}
    break;

  case 955:

/* Line 1455 of yacc.c  */
#line 6007 "gram.y"
    {
					SelectStmt *n = makeNode(SelectStmt);
					n->valuesLists = list_make1((yyvsp[(2) - (2)].list));
					(yyval.node) = (Node *) n;
				;}
    break;

  case 956:

/* Line 1455 of yacc.c  */
#line 6013 "gram.y"
    {
					SelectStmt *n = (SelectStmt *) (yyvsp[(1) - (3)].node);
					n->valuesLists = lappend(n->valuesLists, (yyvsp[(3) - (3)].list));
					(yyval.node) = (Node *) n;
				;}
    break;

  case 957:

/* Line 1455 of yacc.c  */
#line 6030 "gram.y"
    { (yyval.list) = (yyvsp[(2) - (2)].list); ;}
    break;

  case 958:

/* Line 1455 of yacc.c  */
#line 6031 "gram.y"
    { (yyval.list) = NIL; ;}
    break;

  case 959:

/* Line 1455 of yacc.c  */
#line 6035 "gram.y"
    { (yyval.list) = list_make1((yyvsp[(1) - (1)].node)); ;}
    break;

  case 960:

/* Line 1455 of yacc.c  */
#line 6036 "gram.y"
    { (yyval.list) = lappend((yyvsp[(1) - (3)].list), (yyvsp[(3) - (3)].node)); ;}
    break;

  case 961:

/* Line 1455 of yacc.c  */
#line 6047 "gram.y"
    {
					(yyval.node) = (Node *) (yyvsp[(1) - (1)].range);
				;}
    break;

  case 962:

/* Line 1455 of yacc.c  */
#line 6051 "gram.y"
    {
					(yyvsp[(1) - (2)].range)->alias = (yyvsp[(2) - (2)].alias);
					(yyval.node) = (Node *) (yyvsp[(1) - (2)].range);
				;}
    break;

  case 963:

/* Line 1455 of yacc.c  */
#line 6056 "gram.y"
    {
					RangeFunction *n = makeNode(RangeFunction);
					n->funccallnode = (yyvsp[(1) - (1)].node);
					n->coldeflist = NIL;
					(yyval.node) = (Node *) n;
				;}
    break;

  case 964:

/* Line 1455 of yacc.c  */
#line 6063 "gram.y"
    {
					RangeFunction *n = makeNode(RangeFunction);
					n->funccallnode = (yyvsp[(1) - (2)].node);
					n->alias = (yyvsp[(2) - (2)].alias);
					n->coldeflist = NIL;
					(yyval.node) = (Node *) n;
				;}
    break;

  case 965:

/* Line 1455 of yacc.c  */
#line 6071 "gram.y"
    {
					RangeFunction *n = makeNode(RangeFunction);
					n->funccallnode = (yyvsp[(1) - (5)].node);
					n->coldeflist = (yyvsp[(4) - (5)].list);
					(yyval.node) = (Node *) n;
				;}
    break;

  case 966:

/* Line 1455 of yacc.c  */
#line 6078 "gram.y"
    {
					RangeFunction *n = makeNode(RangeFunction);
					Alias *a = makeNode(Alias);
					n->funccallnode = (yyvsp[(1) - (6)].node);
					a->aliasname = (yyvsp[(3) - (6)].str);
					n->alias = a;
					n->coldeflist = (yyvsp[(5) - (6)].list);
					(yyval.node) = (Node *) n;
				;}
    break;

  case 967:

/* Line 1455 of yacc.c  */
#line 6088 "gram.y"
    {
					RangeFunction *n = makeNode(RangeFunction);
					Alias *a = makeNode(Alias);
					n->funccallnode = (yyvsp[(1) - (5)].node);
					a->aliasname = (yyvsp[(2) - (5)].str);
					n->alias = a;
					n->coldeflist = (yyvsp[(4) - (5)].list);
					(yyval.node) = (Node *) n;
				;}
    break;

  case 968:

/* Line 1455 of yacc.c  */
#line 6098 "gram.y"
    {
					/*
					 * The SQL spec does not permit a subselect
					 * (<derived_table>) without an alias clause,
					 * so we don't either.  This avoids the problem
					 * of needing to invent a unique refname for it.
					 * That could be surmounted if there's sufficient
					 * popular demand, but for now let's just implement
					 * the spec and see if anyone complains.
					 * However, it does seem like a good idea to emit
					 * an error message that's better than "syntax error".
					 */
					if (IsA((yyvsp[(1) - (1)].node), SelectStmt) &&
						((SelectStmt *) (yyvsp[(1) - (1)].node))->valuesLists)
						ereport(ERROR,
								(errcode(ERRCODE_SYNTAX_ERROR),
								 errmsg("VALUES in FROM must have an alias"),
								 errhint("For example, FROM (VALUES ...) [AS] foo.")));
					else
						ereport(ERROR,
								(errcode(ERRCODE_SYNTAX_ERROR),
								 errmsg("subquery in FROM must have an alias"),
								 errhint("For example, FROM (SELECT ...) [AS] foo.")));
					(yyval.node) = NULL;
				;}
    break;

  case 969:

/* Line 1455 of yacc.c  */
#line 6124 "gram.y"
    {
					RangeSubselect *n = makeNode(RangeSubselect);
					n->subquery = (yyvsp[(1) - (2)].node);
					n->alias = (yyvsp[(2) - (2)].alias);
					(yyval.node) = (Node *) n;
				;}
    break;

  case 970:

/* Line 1455 of yacc.c  */
#line 6131 "gram.y"
    {
					(yyval.node) = (Node *) (yyvsp[(1) - (1)].jexpr);
				;}
    break;

  case 971:

/* Line 1455 of yacc.c  */
#line 6135 "gram.y"
    {
					(yyvsp[(2) - (4)].jexpr)->alias = (yyvsp[(4) - (4)].alias);
					(yyval.node) = (Node *) (yyvsp[(2) - (4)].jexpr);
				;}
    break;

  case 972:

/* Line 1455 of yacc.c  */
#line 6161 "gram.y"
    {
					(yyval.jexpr) = (yyvsp[(2) - (3)].jexpr);
				;}
    break;

  case 973:

/* Line 1455 of yacc.c  */
#line 6165 "gram.y"
    {
					/* CROSS JOIN is same as unqualified inner join */
					JoinExpr *n = makeNode(JoinExpr);
					n->jointype = JOIN_INNER;
					n->isNatural = FALSE;
					n->larg = (yyvsp[(1) - (4)].node);
					n->rarg = (yyvsp[(4) - (4)].node);
					n->using = NIL;
					n->quals = NULL;
					(yyval.jexpr) = n;
				;}
    break;

  case 974:

/* Line 1455 of yacc.c  */
#line 6177 "gram.y"
    {
					JoinExpr *n = makeNode(JoinExpr);
					n->jointype = (yyvsp[(2) - (5)].jtype);
					n->isNatural = FALSE;
					n->larg = (yyvsp[(1) - (5)].node);
					n->rarg = (yyvsp[(4) - (5)].node);
					if ((yyvsp[(5) - (5)].node) != NULL && IsA((yyvsp[(5) - (5)].node), List))
						n->using = (List *) (yyvsp[(5) - (5)].node); /* USING clause */
					else
						n->quals = (yyvsp[(5) - (5)].node); /* ON clause */
					(yyval.jexpr) = n;
				;}
    break;

  case 975:

/* Line 1455 of yacc.c  */
#line 6190 "gram.y"
    {
					/* letting join_type reduce to empty doesn't work */
					JoinExpr *n = makeNode(JoinExpr);
					n->jointype = JOIN_INNER;
					n->isNatural = FALSE;
					n->larg = (yyvsp[(1) - (4)].node);
					n->rarg = (yyvsp[(3) - (4)].node);
					if ((yyvsp[(4) - (4)].node) != NULL && IsA((yyvsp[(4) - (4)].node), List))
						n->using = (List *) (yyvsp[(4) - (4)].node); /* USING clause */
					else
						n->quals = (yyvsp[(4) - (4)].node); /* ON clause */
					(yyval.jexpr) = n;
				;}
    break;

  case 976:

/* Line 1455 of yacc.c  */
#line 6204 "gram.y"
    {
					JoinExpr *n = makeNode(JoinExpr);
					n->jointype = (yyvsp[(3) - (5)].jtype);
					n->isNatural = TRUE;
					n->larg = (yyvsp[(1) - (5)].node);
					n->rarg = (yyvsp[(5) - (5)].node);
					n->using = NIL; /* figure out which columns later... */
					n->quals = NULL; /* fill later */
					(yyval.jexpr) = n;
				;}
    break;

  case 977:

/* Line 1455 of yacc.c  */
#line 6215 "gram.y"
    {
					/* letting join_type reduce to empty doesn't work */
					JoinExpr *n = makeNode(JoinExpr);
					n->jointype = JOIN_INNER;
					n->isNatural = TRUE;
					n->larg = (yyvsp[(1) - (4)].node);
					n->rarg = (yyvsp[(4) - (4)].node);
					n->using = NIL; /* figure out which columns later... */
					n->quals = NULL; /* fill later */
					(yyval.jexpr) = n;
				;}
    break;

  case 978:

/* Line 1455 of yacc.c  */
#line 6230 "gram.y"
    {
					(yyval.alias) = makeNode(Alias);
					(yyval.alias)->aliasname = (yyvsp[(2) - (5)].str);
					(yyval.alias)->colnames = (yyvsp[(4) - (5)].list);
				;}
    break;

  case 979:

/* Line 1455 of yacc.c  */
#line 6236 "gram.y"
    {
					(yyval.alias) = makeNode(Alias);
					(yyval.alias)->aliasname = (yyvsp[(2) - (2)].str);
				;}
    break;

  case 980:

/* Line 1455 of yacc.c  */
#line 6241 "gram.y"
    {
					(yyval.alias) = makeNode(Alias);
					(yyval.alias)->aliasname = (yyvsp[(1) - (4)].str);
					(yyval.alias)->colnames = (yyvsp[(3) - (4)].list);
				;}
    break;

  case 981:

/* Line 1455 of yacc.c  */
#line 6247 "gram.y"
    {
					(yyval.alias) = makeNode(Alias);
					(yyval.alias)->aliasname = (yyvsp[(1) - (1)].str);
				;}
    break;

  case 982:

/* Line 1455 of yacc.c  */
#line 6253 "gram.y"
    { (yyval.jtype) = JOIN_FULL; ;}
    break;

  case 983:

/* Line 1455 of yacc.c  */
#line 6254 "gram.y"
    { (yyval.jtype) = JOIN_LEFT; ;}
    break;

  case 984:

/* Line 1455 of yacc.c  */
#line 6255 "gram.y"
    { (yyval.jtype) = JOIN_RIGHT; ;}
    break;

  case 985:

/* Line 1455 of yacc.c  */
#line 6256 "gram.y"
    { (yyval.jtype) = JOIN_INNER; ;}
    break;

  case 986:

/* Line 1455 of yacc.c  */
#line 6260 "gram.y"
    { (yyval.node) = NULL; ;}
    break;

  case 987:

/* Line 1455 of yacc.c  */
#line 6261 "gram.y"
    { (yyval.node) = NULL; ;}
    break;

  case 988:

/* Line 1455 of yacc.c  */
#line 6273 "gram.y"
    { (yyval.node) = (Node *) (yyvsp[(3) - (4)].list); ;}
    break;

  case 989:

/* Line 1455 of yacc.c  */
#line 6274 "gram.y"
    { (yyval.node) = (yyvsp[(2) - (2)].node); ;}
    break;

  case 990:

/* Line 1455 of yacc.c  */
#line 6280 "gram.y"
    {
					/* default inheritance */
					(yyval.range) = (yyvsp[(1) - (1)].range);
					(yyval.range)->inhOpt = INH_DEFAULT;
					(yyval.range)->alias = NULL;
				;}
    break;

  case 991:

/* Line 1455 of yacc.c  */
#line 6287 "gram.y"
    {
					/* inheritance query */
					(yyval.range) = (yyvsp[(1) - (2)].range);
					(yyval.range)->inhOpt = INH_YES;
					(yyval.range)->alias = NULL;
				;}
    break;

  case 992:

/* Line 1455 of yacc.c  */
#line 6294 "gram.y"
    {
					/* no inheritance */
					(yyval.range) = (yyvsp[(2) - (2)].range);
					(yyval.range)->inhOpt = INH_NO;
					(yyval.range)->alias = NULL;
				;}
    break;

  case 993:

/* Line 1455 of yacc.c  */
#line 6301 "gram.y"
    {
					/* no inheritance, SQL99-style syntax */
					(yyval.range) = (yyvsp[(3) - (4)].range);
					(yyval.range)->inhOpt = INH_NO;
					(yyval.range)->alias = NULL;
				;}
    break;

  case 994:

/* Line 1455 of yacc.c  */
#line 6320 "gram.y"
    {
					(yyval.range) = (yyvsp[(1) - (1)].range);
				;}
    break;

  case 995:

/* Line 1455 of yacc.c  */
#line 6324 "gram.y"
    {
					Alias *alias = makeNode(Alias);
					alias->aliasname = (yyvsp[(2) - (2)].str);
					(yyvsp[(1) - (2)].range)->alias = alias;
					(yyval.range) = (yyvsp[(1) - (2)].range);
				;}
    break;

  case 996:

/* Line 1455 of yacc.c  */
#line 6331 "gram.y"
    {
					Alias *alias = makeNode(Alias);
					alias->aliasname = (yyvsp[(3) - (3)].str);
					(yyvsp[(1) - (3)].range)->alias = alias;
					(yyval.range) = (yyvsp[(1) - (3)].range);
				;}
    break;

  case 997:

/* Line 1455 of yacc.c  */
#line 6340 "gram.y"
    { (yyval.node) = (yyvsp[(1) - (1)].node); ;}
    break;

  case 998:

/* Line 1455 of yacc.c  */
#line 6345 "gram.y"
    { (yyval.node) = (yyvsp[(2) - (2)].node); ;}
    break;

  case 999:

/* Line 1455 of yacc.c  */
#line 6347 "gram.y"
    { (yyval.node) = (yyvsp[(2) - (2)].node); ;}
    break;

  case 1000:

/* Line 1455 of yacc.c  */
#line 6349 "gram.y"
    { (yyval.node) = NULL; ;}
    break;

  case 1001:

/* Line 1455 of yacc.c  */
#line 6355 "gram.y"
    {
					(yyval.list) = list_make1((yyvsp[(1) - (1)].node));
				;}
    break;

  case 1002:

/* Line 1455 of yacc.c  */
#line 6359 "gram.y"
    {
					(yyval.list) = lappend((yyvsp[(1) - (3)].list), (yyvsp[(3) - (3)].node));
				;}
    break;

  case 1003:

/* Line 1455 of yacc.c  */
#line 6365 "gram.y"
    {
					ColumnDef *n = makeNode(ColumnDef);
					n->colname = (yyvsp[(1) - (2)].str);
					n->typename = (yyvsp[(2) - (2)].typnam);
					n->constraints = NIL;
					n->is_local = true;
					(yyval.node) = (Node *)n;
				;}
    break;

  case 1004:

/* Line 1455 of yacc.c  */
#line 6386 "gram.y"
    {
					(yyval.typnam) = (yyvsp[(1) - (2)].typnam);
					(yyval.typnam)->arrayBounds = (yyvsp[(2) - (2)].list);
				;}
    break;

  case 1005:

/* Line 1455 of yacc.c  */
#line 6391 "gram.y"
    {
					(yyval.typnam) = (yyvsp[(2) - (3)].typnam);
					(yyval.typnam)->arrayBounds = (yyvsp[(3) - (3)].list);
					(yyval.typnam)->setof = TRUE;
				;}
    break;

  case 1006:

/* Line 1455 of yacc.c  */
#line 6397 "gram.y"
    {
					/* SQL99's redundant syntax */
					(yyval.typnam) = (yyvsp[(1) - (5)].typnam);
					(yyval.typnam)->arrayBounds = list_make1(makeInteger((yyvsp[(4) - (5)].ival)));
				;}
    break;

  case 1007:

/* Line 1455 of yacc.c  */
#line 6403 "gram.y"
    {
					/* SQL99's redundant syntax */
					(yyval.typnam) = (yyvsp[(2) - (6)].typnam);
					(yyval.typnam)->arrayBounds = list_make1(makeInteger((yyvsp[(5) - (6)].ival)));
					(yyval.typnam)->setof = TRUE;
				;}
    break;

  case 1008:

/* Line 1455 of yacc.c  */
#line 6413 "gram.y"
    {  (yyval.list) = lappend((yyvsp[(1) - (3)].list), makeInteger(-1)); ;}
    break;

  case 1009:

/* Line 1455 of yacc.c  */
#line 6415 "gram.y"
    {  (yyval.list) = lappend((yyvsp[(1) - (4)].list), makeInteger((yyvsp[(3) - (4)].ival))); ;}
    break;

  case 1010:

/* Line 1455 of yacc.c  */
#line 6417 "gram.y"
    {  (yyval.list) = NIL; ;}
    break;

  case 1011:

/* Line 1455 of yacc.c  */
#line 6429 "gram.y"
    { (yyval.typnam) = (yyvsp[(1) - (1)].typnam); ;}
    break;

  case 1012:

/* Line 1455 of yacc.c  */
#line 6430 "gram.y"
    { (yyval.typnam) = (yyvsp[(1) - (1)].typnam); ;}
    break;

  case 1013:

/* Line 1455 of yacc.c  */
#line 6431 "gram.y"
    { (yyval.typnam) = (yyvsp[(1) - (1)].typnam); ;}
    break;

  case 1014:

/* Line 1455 of yacc.c  */
#line 6432 "gram.y"
    { (yyval.typnam) = (yyvsp[(1) - (1)].typnam); ;}
    break;

  case 1015:

/* Line 1455 of yacc.c  */
#line 6433 "gram.y"
    { (yyval.typnam) = (yyvsp[(1) - (1)].typnam); ;}
    break;

  case 1016:

/* Line 1455 of yacc.c  */
#line 6435 "gram.y"
    {
					(yyval.typnam) = (yyvsp[(1) - (2)].typnam);
					if ((yyvsp[(2) - (2)].ival) != INTERVAL_FULL_RANGE)
						(yyval.typnam)->typmod = INTERVAL_TYPMOD(INTERVAL_FULL_PRECISION, (yyvsp[(2) - (2)].ival));
				;}
    break;

  case 1017:

/* Line 1455 of yacc.c  */
#line 6441 "gram.y"
    {
					(yyval.typnam) = (yyvsp[(1) - (5)].typnam);
					if ((yyvsp[(3) - (5)].ival) < 0)
						ereport(ERROR,
								(errcode(ERRCODE_INVALID_PARAMETER_VALUE),
								 errmsg("INTERVAL(%d) precision must not be negative",
										(yyvsp[(3) - (5)].ival))));
					if ((yyvsp[(3) - (5)].ival) > MAX_INTERVAL_PRECISION)
					{
						ereport(WARNING,
								(errcode(ERRCODE_INVALID_PARAMETER_VALUE),
								 errmsg("INTERVAL(%d) precision reduced to maximum allowed, %d",
										(yyvsp[(3) - (5)].ival), MAX_INTERVAL_PRECISION)));
						(yyvsp[(3) - (5)].ival) = MAX_INTERVAL_PRECISION;
					}
					(yyval.typnam)->typmod = INTERVAL_TYPMOD((yyvsp[(3) - (5)].ival), (yyvsp[(5) - (5)].ival));
				;}
    break;

  case 1018:

/* Line 1455 of yacc.c  */
#line 6459 "gram.y"
    {
					(yyval.typnam) = makeNode(TypeName);
					(yyval.typnam)->names = lcons(makeString((yyvsp[(1) - (2)].str)), (yyvsp[(2) - (2)].list));
					(yyval.typnam)->typmod = -1;
					(yyval.typnam)->location = (yylsp[(1) - (2)]);
				;}
    break;

  case 1019:

/* Line 1455 of yacc.c  */
#line 6477 "gram.y"
    { (yyval.typnam) = (yyvsp[(1) - (1)].typnam); ;}
    break;

  case 1020:

/* Line 1455 of yacc.c  */
#line 6478 "gram.y"
    { (yyval.typnam) = (yyvsp[(1) - (1)].typnam); ;}
    break;

  case 1021:

/* Line 1455 of yacc.c  */
#line 6479 "gram.y"
    { (yyval.typnam) = (yyvsp[(1) - (1)].typnam); ;}
    break;

  case 1022:

/* Line 1455 of yacc.c  */
#line 6480 "gram.y"
    { (yyval.typnam) = (yyvsp[(1) - (1)].typnam); ;}
    break;

  case 1023:

/* Line 1455 of yacc.c  */
#line 6481 "gram.y"
    { (yyval.typnam) = (yyvsp[(1) - (1)].typnam); ;}
    break;

  case 1024:

/* Line 1455 of yacc.c  */
#line 6486 "gram.y"
    {
					(yyval.typnam) = makeTypeName((yyvsp[(1) - (1)].str));
					(yyval.typnam)->location = (yylsp[(1) - (1)]);
				;}
    break;

  case 1025:

/* Line 1455 of yacc.c  */
#line 6498 "gram.y"
    {
					(yyval.typnam) = SystemTypeName("int4");
				;}
    break;

  case 1026:

/* Line 1455 of yacc.c  */
#line 6502 "gram.y"
    {
					(yyval.typnam) = SystemTypeName("int4");
				;}
    break;

  case 1027:

/* Line 1455 of yacc.c  */
#line 6506 "gram.y"
    {
					(yyval.typnam) = SystemTypeName("int2");
				;}
    break;

  case 1028:

/* Line 1455 of yacc.c  */
#line 6510 "gram.y"
    {
					(yyval.typnam) = SystemTypeName("int8");
				;}
    break;

  case 1029:

/* Line 1455 of yacc.c  */
#line 6514 "gram.y"
    {
					(yyval.typnam) = SystemTypeName("float4");
				;}
    break;

  case 1030:

/* Line 1455 of yacc.c  */
#line 6518 "gram.y"
    {
					(yyval.typnam) = (yyvsp[(2) - (2)].typnam);
				;}
    break;

  case 1031:

/* Line 1455 of yacc.c  */
#line 6522 "gram.y"
    {
					(yyval.typnam) = SystemTypeName("float8");
				;}
    break;

  case 1032:

/* Line 1455 of yacc.c  */
#line 6526 "gram.y"
    {
					(yyval.typnam) = SystemTypeName("numeric");
					(yyval.typnam)->typmod = (yyvsp[(2) - (2)].ival);
				;}
    break;

  case 1033:

/* Line 1455 of yacc.c  */
#line 6531 "gram.y"
    {
					(yyval.typnam) = SystemTypeName("numeric");
					(yyval.typnam)->typmod = (yyvsp[(2) - (2)].ival);
				;}
    break;

  case 1034:

/* Line 1455 of yacc.c  */
#line 6536 "gram.y"
    {
					(yyval.typnam) = SystemTypeName("numeric");
					(yyval.typnam)->typmod = (yyvsp[(2) - (2)].ival);
				;}
    break;

  case 1035:

/* Line 1455 of yacc.c  */
#line 6541 "gram.y"
    {
					(yyval.typnam) = SystemTypeName("bool");
				;}
    break;

  case 1036:

/* Line 1455 of yacc.c  */
#line 6547 "gram.y"
    {
					if ((yyvsp[(2) - (3)].ival) < 1)
						ereport(ERROR,
								(errcode(ERRCODE_INVALID_PARAMETER_VALUE),
								 errmsg("precision for type float must be at least 1 bit")));
					else if ((yyvsp[(2) - (3)].ival) <= 24)
						(yyval.typnam) = SystemTypeName("float4");
					else if ((yyvsp[(2) - (3)].ival) <= 53)
						(yyval.typnam) = SystemTypeName("float8");
					else
						ereport(ERROR,
								(errcode(ERRCODE_INVALID_PARAMETER_VALUE),
								 errmsg("precision for type float must be less than 54 bits")));
				;}
    break;

  case 1037:

/* Line 1455 of yacc.c  */
#line 6562 "gram.y"
    {
					(yyval.typnam) = SystemTypeName("float8");
				;}
    break;

  case 1038:

/* Line 1455 of yacc.c  */
#line 6569 "gram.y"
    {
					if ((yyvsp[(2) - (5)].ival) < 1 || (yyvsp[(2) - (5)].ival) > NUMERIC_MAX_PRECISION)
						ereport(ERROR,
								(errcode(ERRCODE_INVALID_PARAMETER_VALUE),
								 errmsg("NUMERIC precision %d must be between 1 and %d",
										(yyvsp[(2) - (5)].ival), NUMERIC_MAX_PRECISION)));
					if ((yyvsp[(4) - (5)].ival) < 0 || (yyvsp[(4) - (5)].ival) > (yyvsp[(2) - (5)].ival))
						ereport(ERROR,
								(errcode(ERRCODE_INVALID_PARAMETER_VALUE),
								 errmsg("NUMERIC scale %d must be between 0 and precision %d",
										(yyvsp[(4) - (5)].ival), (yyvsp[(2) - (5)].ival))));

					(yyval.ival) = (((yyvsp[(2) - (5)].ival) << 16) | (yyvsp[(4) - (5)].ival)) + VARHDRSZ;
				;}
    break;

  case 1039:

/* Line 1455 of yacc.c  */
#line 6584 "gram.y"
    {
					if ((yyvsp[(2) - (3)].ival) < 1 || (yyvsp[(2) - (3)].ival) > NUMERIC_MAX_PRECISION)
						ereport(ERROR,
								(errcode(ERRCODE_INVALID_PARAMETER_VALUE),
								 errmsg("NUMERIC precision %d must be between 1 and %d",
										(yyvsp[(2) - (3)].ival), NUMERIC_MAX_PRECISION)));

					(yyval.ival) = ((yyvsp[(2) - (3)].ival) << 16) + VARHDRSZ;
				;}
    break;

  case 1040:

/* Line 1455 of yacc.c  */
#line 6594 "gram.y"
    {
					/* Insert "-1" meaning "no limit" */
					(yyval.ival) = -1;
				;}
    break;

  case 1041:

/* Line 1455 of yacc.c  */
#line 6602 "gram.y"
    {
					if ((yyvsp[(2) - (5)].ival) < 1 || (yyvsp[(2) - (5)].ival) > NUMERIC_MAX_PRECISION)
						ereport(ERROR,
								(errcode(ERRCODE_INVALID_PARAMETER_VALUE),
								 errmsg("DECIMAL precision %d must be between 1 and %d",
										(yyvsp[(2) - (5)].ival), NUMERIC_MAX_PRECISION)));
					if ((yyvsp[(4) - (5)].ival) < 0 || (yyvsp[(4) - (5)].ival) > (yyvsp[(2) - (5)].ival))
						ereport(ERROR,
								(errcode(ERRCODE_INVALID_PARAMETER_VALUE),
								 errmsg("DECIMAL scale %d must be between 0 and precision %d",
										(yyvsp[(4) - (5)].ival), (yyvsp[(2) - (5)].ival))));

					(yyval.ival) = (((yyvsp[(2) - (5)].ival) << 16) | (yyvsp[(4) - (5)].ival)) + VARHDRSZ;
				;}
    break;

  case 1042:

/* Line 1455 of yacc.c  */
#line 6617 "gram.y"
    {
					if ((yyvsp[(2) - (3)].ival) < 1 || (yyvsp[(2) - (3)].ival) > NUMERIC_MAX_PRECISION)
						ereport(ERROR,
								(errcode(ERRCODE_INVALID_PARAMETER_VALUE),
								 errmsg("DECIMAL precision %d must be between 1 and %d",
										(yyvsp[(2) - (3)].ival), NUMERIC_MAX_PRECISION)));

					(yyval.ival) = ((yyvsp[(2) - (3)].ival) << 16) + VARHDRSZ;
				;}
    break;

  case 1043:

/* Line 1455 of yacc.c  */
#line 6627 "gram.y"
    {
					/* Insert "-1" meaning "no limit" */
					(yyval.ival) = -1;
				;}
    break;

  case 1044:

/* Line 1455 of yacc.c  */
#line 6639 "gram.y"
    {
					(yyval.typnam) = (yyvsp[(1) - (1)].typnam);
				;}
    break;

  case 1045:

/* Line 1455 of yacc.c  */
#line 6643 "gram.y"
    {
					(yyval.typnam) = (yyvsp[(1) - (1)].typnam);
				;}
    break;

  case 1046:

/* Line 1455 of yacc.c  */
#line 6651 "gram.y"
    {
					(yyval.typnam) = (yyvsp[(1) - (1)].typnam);
				;}
    break;

  case 1047:

/* Line 1455 of yacc.c  */
#line 6655 "gram.y"
    {
					(yyval.typnam) = (yyvsp[(1) - (1)].typnam);
					(yyval.typnam)->typmod = -1;
				;}
    break;

  case 1048:

/* Line 1455 of yacc.c  */
#line 6663 "gram.y"
    {
					char *typname;

					typname = (yyvsp[(2) - (5)].boolean) ? "varbit" : "bit";
					(yyval.typnam) = SystemTypeName(typname);
					if ((yyvsp[(4) - (5)].ival) < 1)
						ereport(ERROR,
								(errcode(ERRCODE_INVALID_PARAMETER_VALUE),
								 errmsg("length for type %s must be at least 1",
										typname)));
					else if ((yyvsp[(4) - (5)].ival) > (MaxAttrSize * BITS_PER_BYTE))
						ereport(ERROR,
								(errcode(ERRCODE_INVALID_PARAMETER_VALUE),
								 errmsg("length for type %s cannot exceed %d",
										typname, MaxAttrSize * BITS_PER_BYTE)));
					(yyval.typnam)->typmod = (yyvsp[(4) - (5)].ival);
				;}
    break;

  case 1049:

/* Line 1455 of yacc.c  */
#line 6684 "gram.y"
    {
					/* bit defaults to bit(1), varbit to no limit */
					if ((yyvsp[(2) - (2)].boolean))
					{
						(yyval.typnam) = SystemTypeName("varbit");
						(yyval.typnam)->typmod = -1;
					}
					else
					{
						(yyval.typnam) = SystemTypeName("bit");
						(yyval.typnam)->typmod = 1;
					}
				;}
    break;

  case 1050:

/* Line 1455 of yacc.c  */
#line 6705 "gram.y"
    {
					(yyval.typnam) = (yyvsp[(1) - (1)].typnam);
				;}
    break;

  case 1051:

/* Line 1455 of yacc.c  */
#line 6709 "gram.y"
    {
					(yyval.typnam) = (yyvsp[(1) - (1)].typnam);
				;}
    break;

  case 1052:

/* Line 1455 of yacc.c  */
#line 6715 "gram.y"
    {
					(yyval.typnam) = (yyvsp[(1) - (1)].typnam);
				;}
    break;

  case 1053:

/* Line 1455 of yacc.c  */
#line 6719 "gram.y"
    {
					/* Length was not specified so allow to be unrestricted.
					 * This handles problems with fixed-length (bpchar) strings
					 * which in column definitions must default to a length
					 * of one, but should not be constrained if the length
					 * was not specified.
					 */
					(yyval.typnam) = (yyvsp[(1) - (1)].typnam);
					(yyval.typnam)->typmod = -1;
				;}
    break;

  case 1054:

/* Line 1455 of yacc.c  */
#line 6732 "gram.y"
    {
					if (((yyvsp[(5) - (5)].str) != NULL) && (strcmp((yyvsp[(5) - (5)].str), "sql_text") != 0))
					{
						char *type;

						type = palloc(strlen((yyvsp[(1) - (5)].str)) + 1 + strlen((yyvsp[(5) - (5)].str)) + 1);
						strcpy(type, (yyvsp[(1) - (5)].str));
						strcat(type, "_");
						strcat(type, (yyvsp[(5) - (5)].str));
						(yyvsp[(1) - (5)].str) = type;
					}

					(yyval.typnam) = SystemTypeName((yyvsp[(1) - (5)].str));

					if ((yyvsp[(3) - (5)].ival) < 1)
						ereport(ERROR,
								(errcode(ERRCODE_INVALID_PARAMETER_VALUE),
								 errmsg("length for type %s must be at least 1",
										(yyvsp[(1) - (5)].str))));
					else if ((yyvsp[(3) - (5)].ival) > MaxAttrSize)
						ereport(ERROR,
								(errcode(ERRCODE_INVALID_PARAMETER_VALUE),
								 errmsg("length for type %s cannot exceed %d",
										(yyvsp[(1) - (5)].str), MaxAttrSize)));

					/* we actually implement these like a varlen, so
					 * the first 4 bytes is the length. (the difference
					 * between these and "text" is that we blank-pad and
					 * truncate where necessary)
					 */
					(yyval.typnam)->typmod = VARHDRSZ + (yyvsp[(3) - (5)].ival);
				;}
    break;

  case 1055:

/* Line 1455 of yacc.c  */
#line 6767 "gram.y"
    {
					if (((yyvsp[(2) - (2)].str) != NULL) && (strcmp((yyvsp[(2) - (2)].str), "sql_text") != 0))
					{
						char *type;

						type = palloc(strlen((yyvsp[(1) - (2)].str)) + 1 + strlen((yyvsp[(2) - (2)].str)) + 1);
						strcpy(type, (yyvsp[(1) - (2)].str));
						strcat(type, "_");
						strcat(type, (yyvsp[(2) - (2)].str));
						(yyvsp[(1) - (2)].str) = type;
					}

					(yyval.typnam) = SystemTypeName((yyvsp[(1) - (2)].str));

					/* char defaults to char(1), varchar to no limit */
					if (strcmp((yyvsp[(1) - (2)].str), "bpchar") == 0)
						(yyval.typnam)->typmod = VARHDRSZ + 1;
					else
						(yyval.typnam)->typmod = -1;
				;}
    break;

  case 1056:

/* Line 1455 of yacc.c  */
#line 6790 "gram.y"
    { (yyval.str) = (yyvsp[(2) - (2)].boolean) ? "varchar": "bpchar"; ;}
    break;

  case 1057:

/* Line 1455 of yacc.c  */
#line 6792 "gram.y"
    { (yyval.str) = (yyvsp[(2) - (2)].boolean) ? "varchar": "bpchar"; ;}
    break;

  case 1058:

/* Line 1455 of yacc.c  */
#line 6794 "gram.y"
    { (yyval.str) = "varchar"; ;}
    break;

  case 1059:

/* Line 1455 of yacc.c  */
#line 6796 "gram.y"
    { (yyval.str) = (yyvsp[(3) - (3)].boolean) ? "varchar": "bpchar"; ;}
    break;

  case 1060:

/* Line 1455 of yacc.c  */
#line 6798 "gram.y"
    { (yyval.str) = (yyvsp[(3) - (3)].boolean) ? "varchar": "bpchar"; ;}
    break;

  case 1061:

/* Line 1455 of yacc.c  */
#line 6800 "gram.y"
    { (yyval.str) = (yyvsp[(2) - (2)].boolean) ? "varchar": "bpchar"; ;}
    break;

  case 1062:

/* Line 1455 of yacc.c  */
#line 6804 "gram.y"
    { (yyval.boolean) = TRUE; ;}
    break;

  case 1063:

/* Line 1455 of yacc.c  */
#line 6805 "gram.y"
    { (yyval.boolean) = FALSE; ;}
    break;

  case 1064:

/* Line 1455 of yacc.c  */
#line 6809 "gram.y"
    { (yyval.str) = (yyvsp[(3) - (3)].str); ;}
    break;

  case 1065:

/* Line 1455 of yacc.c  */
#line 6810 "gram.y"
    { (yyval.str) = NULL; ;}
    break;

  case 1066:

/* Line 1455 of yacc.c  */
#line 6815 "gram.y"
    {
					if ((yyvsp[(5) - (5)].boolean))
						(yyval.typnam) = SystemTypeName("timestamptz");
					else
						(yyval.typnam) = SystemTypeName("timestamp");
					/* XXX the timezone field seems to be unused
					 * - thomas 2001-09-06
					 */
					(yyval.typnam)->timezone = (yyvsp[(5) - (5)].boolean);
					if ((yyvsp[(3) - (5)].ival) < 0)
						ereport(ERROR,
								(errcode(ERRCODE_INVALID_PARAMETER_VALUE),
								 errmsg("TIMESTAMP(%d)%s precision must not be negative",
										(yyvsp[(3) - (5)].ival), ((yyvsp[(5) - (5)].boolean) ? " WITH TIME ZONE": ""))));
					if ((yyvsp[(3) - (5)].ival) > MAX_TIMESTAMP_PRECISION)
					{
						ereport(WARNING,
								(errcode(ERRCODE_INVALID_PARAMETER_VALUE),
								 errmsg("TIMESTAMP(%d)%s precision reduced to maximum allowed, %d",
										(yyvsp[(3) - (5)].ival), ((yyvsp[(5) - (5)].boolean) ? " WITH TIME ZONE": ""),
										MAX_TIMESTAMP_PRECISION)));
						(yyvsp[(3) - (5)].ival) = MAX_TIMESTAMP_PRECISION;
					}
					(yyval.typnam)->typmod = (yyvsp[(3) - (5)].ival);
				;}
    break;

  case 1067:

/* Line 1455 of yacc.c  */
#line 6841 "gram.y"
    {
					if ((yyvsp[(2) - (2)].boolean))
						(yyval.typnam) = SystemTypeName("timestamptz");
					else
						(yyval.typnam) = SystemTypeName("timestamp");
					/* XXX the timezone field seems to be unused
					 * - thomas 2001-09-06
					 */
					(yyval.typnam)->timezone = (yyvsp[(2) - (2)].boolean);
				;}
    break;

  case 1068:

/* Line 1455 of yacc.c  */
#line 6852 "gram.y"
    {
					if ((yyvsp[(5) - (5)].boolean))
						(yyval.typnam) = SystemTypeName("timetz");
					else
						(yyval.typnam) = SystemTypeName("time");
					if ((yyvsp[(3) - (5)].ival) < 0)
						ereport(ERROR,
								(errcode(ERRCODE_INVALID_PARAMETER_VALUE),
								 errmsg("TIME(%d)%s precision must not be negative",
										(yyvsp[(3) - (5)].ival), ((yyvsp[(5) - (5)].boolean) ? " WITH TIME ZONE": ""))));
					if ((yyvsp[(3) - (5)].ival) > MAX_TIME_PRECISION)
					{
						ereport(WARNING,
								(errcode(ERRCODE_INVALID_PARAMETER_VALUE),
								 errmsg("TIME(%d)%s precision reduced to maximum allowed, %d",
										(yyvsp[(3) - (5)].ival), ((yyvsp[(5) - (5)].boolean) ? " WITH TIME ZONE": ""),
										MAX_TIME_PRECISION)));
						(yyvsp[(3) - (5)].ival) = MAX_TIME_PRECISION;
					}
					(yyval.typnam)->typmod = (yyvsp[(3) - (5)].ival);
				;}
    break;

  case 1069:

/* Line 1455 of yacc.c  */
#line 6874 "gram.y"
    {
					if ((yyvsp[(2) - (2)].boolean))
						(yyval.typnam) = SystemTypeName("timetz");
					else
						(yyval.typnam) = SystemTypeName("time");
				;}
    break;

  case 1070:

/* Line 1455 of yacc.c  */
#line 6883 "gram.y"
    { (yyval.typnam) = SystemTypeName("interval"); ;}
    break;

  case 1071:

/* Line 1455 of yacc.c  */
#line 6887 "gram.y"
    { (yyval.boolean) = TRUE; ;}
    break;

  case 1072:

/* Line 1455 of yacc.c  */
#line 6888 "gram.y"
    { (yyval.boolean) = FALSE; ;}
    break;

  case 1073:

/* Line 1455 of yacc.c  */
#line 6889 "gram.y"
    { (yyval.boolean) = FALSE; ;}
    break;

  case 1074:

/* Line 1455 of yacc.c  */
#line 6893 "gram.y"
    { (yyval.ival) = INTERVAL_MASK(YEAR); ;}
    break;

  case 1075:

/* Line 1455 of yacc.c  */
#line 6894 "gram.y"
    { (yyval.ival) = INTERVAL_MASK(MONTH); ;}
    break;

  case 1076:

/* Line 1455 of yacc.c  */
#line 6895 "gram.y"
    { (yyval.ival) = INTERVAL_MASK(DAY); ;}
    break;

  case 1077:

/* Line 1455 of yacc.c  */
#line 6896 "gram.y"
    { (yyval.ival) = INTERVAL_MASK(HOUR); ;}
    break;

  case 1078:

/* Line 1455 of yacc.c  */
#line 6897 "gram.y"
    { (yyval.ival) = INTERVAL_MASK(MINUTE); ;}
    break;

  case 1079:

/* Line 1455 of yacc.c  */
#line 6898 "gram.y"
    { (yyval.ival) = INTERVAL_MASK(SECOND); ;}
    break;

  case 1080:

/* Line 1455 of yacc.c  */
#line 6900 "gram.y"
    { (yyval.ival) = INTERVAL_MASK(YEAR) | INTERVAL_MASK(MONTH); ;}
    break;

  case 1081:

/* Line 1455 of yacc.c  */
#line 6902 "gram.y"
    { (yyval.ival) = INTERVAL_MASK(DAY) | INTERVAL_MASK(HOUR); ;}
    break;

  case 1082:

/* Line 1455 of yacc.c  */
#line 6904 "gram.y"
    { (yyval.ival) = INTERVAL_MASK(DAY) | INTERVAL_MASK(HOUR)
						| INTERVAL_MASK(MINUTE); ;}
    break;

  case 1083:

/* Line 1455 of yacc.c  */
#line 6907 "gram.y"
    { (yyval.ival) = INTERVAL_MASK(DAY) | INTERVAL_MASK(HOUR)
						| INTERVAL_MASK(MINUTE) | INTERVAL_MASK(SECOND); ;}
    break;

  case 1084:

/* Line 1455 of yacc.c  */
#line 6910 "gram.y"
    { (yyval.ival) = INTERVAL_MASK(HOUR) | INTERVAL_MASK(MINUTE); ;}
    break;

  case 1085:

/* Line 1455 of yacc.c  */
#line 6912 "gram.y"
    { (yyval.ival) = INTERVAL_MASK(HOUR) | INTERVAL_MASK(MINUTE)
						| INTERVAL_MASK(SECOND); ;}
    break;

  case 1086:

/* Line 1455 of yacc.c  */
#line 6915 "gram.y"
    { (yyval.ival) = INTERVAL_MASK(MINUTE) | INTERVAL_MASK(SECOND); ;}
    break;

  case 1087:

/* Line 1455 of yacc.c  */
#line 6916 "gram.y"
    { (yyval.ival) = INTERVAL_FULL_RANGE; ;}
    break;

  case 1088:

/* Line 1455 of yacc.c  */
#line 6942 "gram.y"
    { (yyval.node) = (yyvsp[(1) - (1)].node); ;}
    break;

  case 1089:

/* Line 1455 of yacc.c  */
#line 6944 "gram.y"
    { (yyval.node) = makeTypeCast((yyvsp[(1) - (3)].node), (yyvsp[(3) - (3)].typnam)); ;}
    break;

  case 1090:

/* Line 1455 of yacc.c  */
#line 6946 "gram.y"
    {
					FuncCall *n = makeNode(FuncCall);
					n->funcname = SystemFuncName("timezone");
					n->args = list_make2((yyvsp[(5) - (5)].node), (yyvsp[(1) - (5)].node));
					n->agg_star = FALSE;
					n->agg_distinct = FALSE;
					n->location = (yylsp[(2) - (5)]);
					(yyval.node) = (Node *) n;
				;}
    break;

  case 1091:

/* Line 1455 of yacc.c  */
#line 6965 "gram.y"
    { (yyval.node) = (Node *) makeSimpleA_Expr(AEXPR_OP, "+", NULL, (yyvsp[(2) - (2)].node), (yylsp[(1) - (2)])); ;}
    break;

  case 1092:

/* Line 1455 of yacc.c  */
#line 6967 "gram.y"
    { (yyval.node) = doNegate((yyvsp[(2) - (2)].node), (yylsp[(1) - (2)])); ;}
    break;

  case 1093:

/* Line 1455 of yacc.c  */
#line 6969 "gram.y"
    { (yyval.node) = (Node *) makeSimpleA_Expr(AEXPR_OP, "+", (yyvsp[(1) - (3)].node), (yyvsp[(3) - (3)].node), (yylsp[(2) - (3)])); ;}
    break;

  case 1094:

/* Line 1455 of yacc.c  */
#line 6971 "gram.y"
    { (yyval.node) = (Node *) makeSimpleA_Expr(AEXPR_OP, "-", (yyvsp[(1) - (3)].node), (yyvsp[(3) - (3)].node), (yylsp[(2) - (3)])); ;}
    break;

  case 1095:

/* Line 1455 of yacc.c  */
#line 6973 "gram.y"
    { (yyval.node) = (Node *) makeSimpleA_Expr(AEXPR_OP, "*", (yyvsp[(1) - (3)].node), (yyvsp[(3) - (3)].node), (yylsp[(2) - (3)])); ;}
    break;

  case 1096:

/* Line 1455 of yacc.c  */
#line 6975 "gram.y"
    { (yyval.node) = (Node *) makeSimpleA_Expr(AEXPR_OP, "/", (yyvsp[(1) - (3)].node), (yyvsp[(3) - (3)].node), (yylsp[(2) - (3)])); ;}
    break;

  case 1097:

/* Line 1455 of yacc.c  */
#line 6977 "gram.y"
    { (yyval.node) = (Node *) makeSimpleA_Expr(AEXPR_OP, "%", (yyvsp[(1) - (3)].node), (yyvsp[(3) - (3)].node), (yylsp[(2) - (3)])); ;}
    break;

  case 1098:

/* Line 1455 of yacc.c  */
#line 6979 "gram.y"
    { (yyval.node) = (Node *) makeSimpleA_Expr(AEXPR_OP, "^", (yyvsp[(1) - (3)].node), (yyvsp[(3) - (3)].node), (yylsp[(2) - (3)])); ;}
    break;

  case 1099:

/* Line 1455 of yacc.c  */
#line 6981 "gram.y"
    { (yyval.node) = (Node *) makeSimpleA_Expr(AEXPR_OP, "<", (yyvsp[(1) - (3)].node), (yyvsp[(3) - (3)].node), (yylsp[(2) - (3)])); ;}
    break;

  case 1100:

/* Line 1455 of yacc.c  */
#line 6983 "gram.y"
    { (yyval.node) = (Node *) makeSimpleA_Expr(AEXPR_OP, ">", (yyvsp[(1) - (3)].node), (yyvsp[(3) - (3)].node), (yylsp[(2) - (3)])); ;}
    break;

  case 1101:

/* Line 1455 of yacc.c  */
#line 6985 "gram.y"
    { (yyval.node) = (Node *) makeSimpleA_Expr(AEXPR_OP, "=", (yyvsp[(1) - (3)].node), (yyvsp[(3) - (3)].node), (yylsp[(2) - (3)])); ;}
    break;

  case 1102:

/* Line 1455 of yacc.c  */
#line 6988 "gram.y"
    { (yyval.node) = (Node *) makeA_Expr(AEXPR_OP, (yyvsp[(2) - (3)].list), (yyvsp[(1) - (3)].node), (yyvsp[(3) - (3)].node), (yylsp[(2) - (3)])); ;}
    break;

  case 1103:

/* Line 1455 of yacc.c  */
#line 6990 "gram.y"
    { (yyval.node) = (Node *) makeA_Expr(AEXPR_OP, (yyvsp[(1) - (2)].list), NULL, (yyvsp[(2) - (2)].node), (yylsp[(1) - (2)])); ;}
    break;

  case 1104:

/* Line 1455 of yacc.c  */
#line 6992 "gram.y"
    { (yyval.node) = (Node *) makeA_Expr(AEXPR_OP, (yyvsp[(2) - (2)].list), (yyvsp[(1) - (2)].node), NULL, (yylsp[(2) - (2)])); ;}
    break;

  case 1105:

/* Line 1455 of yacc.c  */
#line 6995 "gram.y"
    { (yyval.node) = (Node *) makeA_Expr(AEXPR_AND, NIL, (yyvsp[(1) - (3)].node), (yyvsp[(3) - (3)].node), (yylsp[(2) - (3)])); ;}
    break;

  case 1106:

/* Line 1455 of yacc.c  */
#line 6997 "gram.y"
    { (yyval.node) = (Node *) makeA_Expr(AEXPR_OR, NIL, (yyvsp[(1) - (3)].node), (yyvsp[(3) - (3)].node), (yylsp[(2) - (3)])); ;}
    break;

  case 1107:

/* Line 1455 of yacc.c  */
#line 6999 "gram.y"
    { (yyval.node) = (Node *) makeA_Expr(AEXPR_NOT, NIL, NULL, (yyvsp[(2) - (2)].node), (yylsp[(1) - (2)])); ;}
    break;

  case 1108:

/* Line 1455 of yacc.c  */
#line 7002 "gram.y"
    { (yyval.node) = (Node *) makeSimpleA_Expr(AEXPR_OP, "~~", (yyvsp[(1) - (3)].node), (yyvsp[(3) - (3)].node), (yylsp[(2) - (3)])); ;}
    break;

  case 1109:

/* Line 1455 of yacc.c  */
#line 7004 "gram.y"
    {
					FuncCall *n = makeNode(FuncCall);
					n->funcname = SystemFuncName("like_escape");
					n->args = list_make2((yyvsp[(3) - (5)].node), (yyvsp[(5) - (5)].node));
					n->agg_star = FALSE;
					n->agg_distinct = FALSE;
					n->location = (yylsp[(4) - (5)]);
					(yyval.node) = (Node *) makeSimpleA_Expr(AEXPR_OP, "~~", (yyvsp[(1) - (5)].node), (Node *) n, (yylsp[(2) - (5)]));
				;}
    break;

  case 1110:

/* Line 1455 of yacc.c  */
#line 7014 "gram.y"
    { (yyval.node) = (Node *) makeSimpleA_Expr(AEXPR_OP, "!~~", (yyvsp[(1) - (4)].node), (yyvsp[(4) - (4)].node), (yylsp[(2) - (4)])); ;}
    break;

  case 1111:

/* Line 1455 of yacc.c  */
#line 7016 "gram.y"
    {
					FuncCall *n = makeNode(FuncCall);
					n->funcname = SystemFuncName("like_escape");
					n->args = list_make2((yyvsp[(4) - (6)].node), (yyvsp[(6) - (6)].node));
					n->agg_star = FALSE;
					n->agg_distinct = FALSE;
					n->location = (yylsp[(5) - (6)]);
					(yyval.node) = (Node *) makeSimpleA_Expr(AEXPR_OP, "!~~", (yyvsp[(1) - (6)].node), (Node *) n, (yylsp[(2) - (6)]));
				;}
    break;

  case 1112:

/* Line 1455 of yacc.c  */
#line 7026 "gram.y"
    { (yyval.node) = (Node *) makeSimpleA_Expr(AEXPR_OP, "~~*", (yyvsp[(1) - (3)].node), (yyvsp[(3) - (3)].node), (yylsp[(2) - (3)])); ;}
    break;

  case 1113:

/* Line 1455 of yacc.c  */
#line 7028 "gram.y"
    {
					FuncCall *n = makeNode(FuncCall);
					n->funcname = SystemFuncName("like_escape");
					n->args = list_make2((yyvsp[(3) - (5)].node), (yyvsp[(5) - (5)].node));
					n->agg_star = FALSE;
					n->agg_distinct = FALSE;
					n->location = (yylsp[(4) - (5)]);
					(yyval.node) = (Node *) makeSimpleA_Expr(AEXPR_OP, "~~*", (yyvsp[(1) - (5)].node), (Node *) n, (yylsp[(2) - (5)]));
				;}
    break;

  case 1114:

/* Line 1455 of yacc.c  */
#line 7038 "gram.y"
    { (yyval.node) = (Node *) makeSimpleA_Expr(AEXPR_OP, "!~~*", (yyvsp[(1) - (4)].node), (yyvsp[(4) - (4)].node), (yylsp[(2) - (4)])); ;}
    break;

  case 1115:

/* Line 1455 of yacc.c  */
#line 7040 "gram.y"
    {
					FuncCall *n = makeNode(FuncCall);
					n->funcname = SystemFuncName("like_escape");
					n->args = list_make2((yyvsp[(4) - (6)].node), (yyvsp[(6) - (6)].node));
					n->agg_star = FALSE;
					n->agg_distinct = FALSE;
					n->location = (yylsp[(5) - (6)]);
					(yyval.node) = (Node *) makeSimpleA_Expr(AEXPR_OP, "!~~*", (yyvsp[(1) - (6)].node), (Node *) n, (yylsp[(2) - (6)]));
				;}
    break;

  case 1116:

/* Line 1455 of yacc.c  */
#line 7051 "gram.y"
    {
					A_Const *c = makeNode(A_Const);
					FuncCall *n = makeNode(FuncCall);
					c->val.type = T_Null;
					n->funcname = SystemFuncName("similar_escape");
					n->args = list_make2((yyvsp[(4) - (4)].node), (Node *) c);
					n->agg_star = FALSE;
					n->agg_distinct = FALSE;
					n->location = (yylsp[(2) - (4)]);
					(yyval.node) = (Node *) makeSimpleA_Expr(AEXPR_OP, "~", (yyvsp[(1) - (4)].node), (Node *) n, (yylsp[(2) - (4)]));
				;}
    break;

  case 1117:

/* Line 1455 of yacc.c  */
#line 7063 "gram.y"
    {
					FuncCall *n = makeNode(FuncCall);
					n->funcname = SystemFuncName("similar_escape");
					n->args = list_make2((yyvsp[(4) - (6)].node), (yyvsp[(6) - (6)].node));
					n->agg_star = FALSE;
					n->agg_distinct = FALSE;
					n->location = (yylsp[(5) - (6)]);
					(yyval.node) = (Node *) makeSimpleA_Expr(AEXPR_OP, "~", (yyvsp[(1) - (6)].node), (Node *) n, (yylsp[(2) - (6)]));
				;}
    break;

  case 1118:

/* Line 1455 of yacc.c  */
#line 7073 "gram.y"
    {
					A_Const *c = makeNode(A_Const);
					FuncCall *n = makeNode(FuncCall);
					c->val.type = T_Null;
					n->funcname = SystemFuncName("similar_escape");
					n->args = list_make2((yyvsp[(5) - (5)].node), (Node *) c);
					n->agg_star = FALSE;
					n->agg_distinct = FALSE;
					n->location = (yylsp[(5) - (5)]);
					(yyval.node) = (Node *) makeSimpleA_Expr(AEXPR_OP, "!~", (yyvsp[(1) - (5)].node), (Node *) n, (yylsp[(2) - (5)]));
				;}
    break;

  case 1119:

/* Line 1455 of yacc.c  */
#line 7085 "gram.y"
    {
					FuncCall *n = makeNode(FuncCall);
					n->funcname = SystemFuncName("similar_escape");
					n->args = list_make2((yyvsp[(5) - (7)].node), (yyvsp[(7) - (7)].node));
					n->agg_star = FALSE;
					n->agg_distinct = FALSE;
					n->location = (yylsp[(6) - (7)]);
					(yyval.node) = (Node *) makeSimpleA_Expr(AEXPR_OP, "!~", (yyvsp[(1) - (7)].node), (Node *) n, (yylsp[(2) - (7)]));
				;}
    break;

  case 1120:

/* Line 1455 of yacc.c  */
#line 7105 "gram.y"
    {
					NullTest *n = makeNode(NullTest);
					n->arg = (Expr *) (yyvsp[(1) - (3)].node);
					n->nulltesttype = IS_NULL;
					(yyval.node) = (Node *)n;
				;}
    break;

  case 1121:

/* Line 1455 of yacc.c  */
#line 7112 "gram.y"
    {
					NullTest *n = makeNode(NullTest);
					n->arg = (Expr *) (yyvsp[(1) - (2)].node);
					n->nulltesttype = IS_NULL;
					(yyval.node) = (Node *)n;
				;}
    break;

  case 1122:

/* Line 1455 of yacc.c  */
#line 7119 "gram.y"
    {
					NullTest *n = makeNode(NullTest);
					n->arg = (Expr *) (yyvsp[(1) - (4)].node);
					n->nulltesttype = IS_NOT_NULL;
					(yyval.node) = (Node *)n;
				;}
    break;

  case 1123:

/* Line 1455 of yacc.c  */
#line 7126 "gram.y"
    {
					NullTest *n = makeNode(NullTest);
					n->arg = (Expr *) (yyvsp[(1) - (2)].node);
					n->nulltesttype = IS_NOT_NULL;
					(yyval.node) = (Node *)n;
				;}
    break;

  case 1124:

/* Line 1455 of yacc.c  */
#line 7133 "gram.y"
    {
					(yyval.node) = (Node *)makeOverlaps((yyvsp[(1) - (3)].list), (yyvsp[(3) - (3)].list), (yylsp[(2) - (3)]));
				;}
    break;

  case 1125:

/* Line 1455 of yacc.c  */
#line 7137 "gram.y"
    {
					BooleanTest *b = makeNode(BooleanTest);
					b->arg = (Expr *) (yyvsp[(1) - (3)].node);
					b->booltesttype = IS_TRUE;
					(yyval.node) = (Node *)b;
				;}
    break;

  case 1126:

/* Line 1455 of yacc.c  */
#line 7144 "gram.y"
    {
					BooleanTest *b = makeNode(BooleanTest);
					b->arg = (Expr *) (yyvsp[(1) - (4)].node);
					b->booltesttype = IS_NOT_TRUE;
					(yyval.node) = (Node *)b;
				;}
    break;

  case 1127:

/* Line 1455 of yacc.c  */
#line 7151 "gram.y"
    {
					BooleanTest *b = makeNode(BooleanTest);
					b->arg = (Expr *) (yyvsp[(1) - (3)].node);
					b->booltesttype = IS_FALSE;
					(yyval.node) = (Node *)b;
				;}
    break;

  case 1128:

/* Line 1455 of yacc.c  */
#line 7158 "gram.y"
    {
					BooleanTest *b = makeNode(BooleanTest);
					b->arg = (Expr *) (yyvsp[(1) - (4)].node);
					b->booltesttype = IS_NOT_FALSE;
					(yyval.node) = (Node *)b;
				;}
    break;

  case 1129:

/* Line 1455 of yacc.c  */
#line 7165 "gram.y"
    {
					BooleanTest *b = makeNode(BooleanTest);
					b->arg = (Expr *) (yyvsp[(1) - (3)].node);
					b->booltesttype = IS_UNKNOWN;
					(yyval.node) = (Node *)b;
				;}
    break;

  case 1130:

/* Line 1455 of yacc.c  */
#line 7172 "gram.y"
    {
					BooleanTest *b = makeNode(BooleanTest);
					b->arg = (Expr *) (yyvsp[(1) - (4)].node);
					b->booltesttype = IS_NOT_UNKNOWN;
					(yyval.node) = (Node *)b;
				;}
    break;

  case 1131:

/* Line 1455 of yacc.c  */
#line 7179 "gram.y"
    {
					(yyval.node) = (Node *) makeSimpleA_Expr(AEXPR_DISTINCT, "=", (yyvsp[(1) - (5)].node), (yyvsp[(5) - (5)].node), (yylsp[(2) - (5)]));
				;}
    break;

  case 1132:

/* Line 1455 of yacc.c  */
#line 7183 "gram.y"
    {
					(yyval.node) = (Node *) makeA_Expr(AEXPR_NOT, NIL, NULL,
									(Node *) makeSimpleA_Expr(AEXPR_DISTINCT,
															  "=", (yyvsp[(1) - (6)].node), (yyvsp[(6) - (6)].node), (yylsp[(2) - (6)])),
											 (yylsp[(2) - (6)]));

				;}
    break;

  case 1133:

/* Line 1455 of yacc.c  */
#line 7191 "gram.y"
    {
					(yyval.node) = (Node *) makeSimpleA_Expr(AEXPR_OF, "=", (yyvsp[(1) - (6)].node), (Node *) (yyvsp[(5) - (6)].list), (yylsp[(2) - (6)]));
				;}
    break;

  case 1134:

/* Line 1455 of yacc.c  */
#line 7195 "gram.y"
    {
					(yyval.node) = (Node *) makeSimpleA_Expr(AEXPR_OF, "<>", (yyvsp[(1) - (7)].node), (Node *) (yyvsp[(6) - (7)].list), (yylsp[(2) - (7)]));
				;}
    break;

  case 1135:

/* Line 1455 of yacc.c  */
#line 7199 "gram.y"
    {
					(yyval.node) = (Node *) makeA_Expr(AEXPR_AND, NIL,
						(Node *) makeSimpleA_Expr(AEXPR_OP, ">=", (yyvsp[(1) - (6)].node), (yyvsp[(4) - (6)].node), (yylsp[(2) - (6)])),
						(Node *) makeSimpleA_Expr(AEXPR_OP, "<=", (yyvsp[(1) - (6)].node), (yyvsp[(6) - (6)].node), (yylsp[(2) - (6)])),
											 (yylsp[(2) - (6)]));
				;}
    break;

  case 1136:

/* Line 1455 of yacc.c  */
#line 7206 "gram.y"
    {
					(yyval.node) = (Node *) makeA_Expr(AEXPR_OR, NIL,
						(Node *) makeSimpleA_Expr(AEXPR_OP, "<", (yyvsp[(1) - (7)].node), (yyvsp[(5) - (7)].node), (yylsp[(2) - (7)])),
						(Node *) makeSimpleA_Expr(AEXPR_OP, ">", (yyvsp[(1) - (7)].node), (yyvsp[(7) - (7)].node), (yylsp[(2) - (7)])),
											 (yylsp[(2) - (7)]));
				;}
    break;

  case 1137:

/* Line 1455 of yacc.c  */
#line 7213 "gram.y"
    {
					(yyval.node) = (Node *) makeA_Expr(AEXPR_OR, NIL,
						(Node *) makeA_Expr(AEXPR_AND, NIL,
						    (Node *) makeSimpleA_Expr(AEXPR_OP, ">=", (yyvsp[(1) - (6)].node), (yyvsp[(4) - (6)].node), (yylsp[(2) - (6)])),
						    (Node *) makeSimpleA_Expr(AEXPR_OP, "<=", (yyvsp[(1) - (6)].node), (yyvsp[(6) - (6)].node), (yylsp[(2) - (6)])),
											(yylsp[(2) - (6)])),
						(Node *) makeA_Expr(AEXPR_AND, NIL,
						    (Node *) makeSimpleA_Expr(AEXPR_OP, ">=", (yyvsp[(1) - (6)].node), (yyvsp[(6) - (6)].node), (yylsp[(2) - (6)])),
						    (Node *) makeSimpleA_Expr(AEXPR_OP, "<=", (yyvsp[(1) - (6)].node), (yyvsp[(4) - (6)].node), (yylsp[(2) - (6)])),
											(yylsp[(2) - (6)])),
											 (yylsp[(2) - (6)]));
				;}
    break;

  case 1138:

/* Line 1455 of yacc.c  */
#line 7226 "gram.y"
    {
					(yyval.node) = (Node *) makeA_Expr(AEXPR_AND, NIL,
						(Node *) makeA_Expr(AEXPR_OR, NIL,
						    (Node *) makeSimpleA_Expr(AEXPR_OP, "<", (yyvsp[(1) - (7)].node), (yyvsp[(5) - (7)].node), (yylsp[(2) - (7)])),
						    (Node *) makeSimpleA_Expr(AEXPR_OP, ">", (yyvsp[(1) - (7)].node), (yyvsp[(7) - (7)].node), (yylsp[(2) - (7)])),
											(yylsp[(2) - (7)])),
						(Node *) makeA_Expr(AEXPR_OR, NIL,
						    (Node *) makeSimpleA_Expr(AEXPR_OP, "<", (yyvsp[(1) - (7)].node), (yyvsp[(7) - (7)].node), (yylsp[(2) - (7)])),
						    (Node *) makeSimpleA_Expr(AEXPR_OP, ">", (yyvsp[(1) - (7)].node), (yyvsp[(5) - (7)].node), (yylsp[(2) - (7)])),
											(yylsp[(2) - (7)])),
											 (yylsp[(2) - (7)]));
				;}
    break;

  case 1139:

/* Line 1455 of yacc.c  */
#line 7239 "gram.y"
    {
					/* in_expr returns a SubLink or a list of a_exprs */
					if (IsA((yyvsp[(3) - (3)].node), SubLink))
					{
						/* generate foo = ANY (subquery) */
						SubLink *n = (SubLink *) (yyvsp[(3) - (3)].node);
						n->subLinkType = ANY_SUBLINK;
						n->testexpr = (yyvsp[(1) - (3)].node);
						n->operName = list_make1(makeString("="));
						(yyval.node) = (Node *)n;
					}
					else
					{
						/* generate scalar IN expression */
						(yyval.node) = (Node *) makeSimpleA_Expr(AEXPR_IN, "=", (yyvsp[(1) - (3)].node), (yyvsp[(3) - (3)].node), (yylsp[(2) - (3)]));
					}
				;}
    break;

  case 1140:

/* Line 1455 of yacc.c  */
#line 7257 "gram.y"
    {
					/* in_expr returns a SubLink or a list of a_exprs */
					if (IsA((yyvsp[(4) - (4)].node), SubLink))
					{
						/* generate NOT (foo = ANY (subquery)) */
						/* Make an = ANY node */
						SubLink *n = (SubLink *) (yyvsp[(4) - (4)].node);
						n->subLinkType = ANY_SUBLINK;
						n->testexpr = (yyvsp[(1) - (4)].node);
						n->operName = list_make1(makeString("="));
						/* Stick a NOT on top */
						(yyval.node) = (Node *) makeA_Expr(AEXPR_NOT, NIL, NULL, (Node *) n, (yylsp[(2) - (4)]));
					}
					else
					{
						/* generate scalar NOT IN expression */
						(yyval.node) = (Node *) makeSimpleA_Expr(AEXPR_IN, "<>", (yyvsp[(1) - (4)].node), (yyvsp[(4) - (4)].node), (yylsp[(2) - (4)]));
					}
				;}
    break;

  case 1141:

/* Line 1455 of yacc.c  */
#line 7277 "gram.y"
    {
					SubLink *n = makeNode(SubLink);
					n->subLinkType = (yyvsp[(3) - (4)].ival);
					n->testexpr = (yyvsp[(1) - (4)].node);
					n->operName = (yyvsp[(2) - (4)].list);
					n->subselect = (yyvsp[(4) - (4)].node);
					(yyval.node) = (Node *)n;
				;}
    break;

  case 1142:

/* Line 1455 of yacc.c  */
#line 7286 "gram.y"
    {
					if ((yyvsp[(3) - (6)].ival) == ANY_SUBLINK)
						(yyval.node) = (Node *) makeA_Expr(AEXPR_OP_ANY, (yyvsp[(2) - (6)].list), (yyvsp[(1) - (6)].node), (yyvsp[(5) - (6)].node), (yylsp[(2) - (6)]));
					else
						(yyval.node) = (Node *) makeA_Expr(AEXPR_OP_ALL, (yyvsp[(2) - (6)].list), (yyvsp[(1) - (6)].node), (yyvsp[(5) - (6)].node), (yylsp[(2) - (6)]));
				;}
    break;

  case 1143:

/* Line 1455 of yacc.c  */
#line 7293 "gram.y"
    {
					/* Not sure how to get rid of the parentheses
					 * but there are lots of shift/reduce errors without them.
					 *
					 * Should be able to implement this by plopping the entire
					 * select into a node, then transforming the target expressions
					 * from whatever they are into count(*), and testing the
					 * entire result equal to one.
					 * But, will probably implement a separate node in the executor.
					 */
					ereport(ERROR,
							(errcode(ERRCODE_FEATURE_NOT_SUPPORTED),
							 errmsg("UNIQUE predicate is not yet implemented")));
				;}
    break;

  case 1144:

/* Line 1455 of yacc.c  */
#line 7319 "gram.y"
    { (yyval.node) = (yyvsp[(1) - (1)].node); ;}
    break;

  case 1145:

/* Line 1455 of yacc.c  */
#line 7321 "gram.y"
    { (yyval.node) = makeTypeCast((yyvsp[(1) - (3)].node), (yyvsp[(3) - (3)].typnam)); ;}
    break;

  case 1146:

/* Line 1455 of yacc.c  */
#line 7323 "gram.y"
    { (yyval.node) = (Node *) makeSimpleA_Expr(AEXPR_OP, "+", NULL, (yyvsp[(2) - (2)].node), (yylsp[(1) - (2)])); ;}
    break;

  case 1147:

/* Line 1455 of yacc.c  */
#line 7325 "gram.y"
    { (yyval.node) = doNegate((yyvsp[(2) - (2)].node), (yylsp[(1) - (2)])); ;}
    break;

  case 1148:

/* Line 1455 of yacc.c  */
#line 7327 "gram.y"
    { (yyval.node) = (Node *) makeSimpleA_Expr(AEXPR_OP, "+", (yyvsp[(1) - (3)].node), (yyvsp[(3) - (3)].node), (yylsp[(2) - (3)])); ;}
    break;

  case 1149:

/* Line 1455 of yacc.c  */
#line 7329 "gram.y"
    { (yyval.node) = (Node *) makeSimpleA_Expr(AEXPR_OP, "-", (yyvsp[(1) - (3)].node), (yyvsp[(3) - (3)].node), (yylsp[(2) - (3)])); ;}
    break;

  case 1150:

/* Line 1455 of yacc.c  */
#line 7331 "gram.y"
    { (yyval.node) = (Node *) makeSimpleA_Expr(AEXPR_OP, "*", (yyvsp[(1) - (3)].node), (yyvsp[(3) - (3)].node), (yylsp[(2) - (3)])); ;}
    break;

  case 1151:

/* Line 1455 of yacc.c  */
#line 7333 "gram.y"
    { (yyval.node) = (Node *) makeSimpleA_Expr(AEXPR_OP, "/", (yyvsp[(1) - (3)].node), (yyvsp[(3) - (3)].node), (yylsp[(2) - (3)])); ;}
    break;

  case 1152:

/* Line 1455 of yacc.c  */
#line 7335 "gram.y"
    { (yyval.node) = (Node *) makeSimpleA_Expr(AEXPR_OP, "%", (yyvsp[(1) - (3)].node), (yyvsp[(3) - (3)].node), (yylsp[(2) - (3)])); ;}
    break;

  case 1153:

/* Line 1455 of yacc.c  */
#line 7337 "gram.y"
    { (yyval.node) = (Node *) makeSimpleA_Expr(AEXPR_OP, "^", (yyvsp[(1) - (3)].node), (yyvsp[(3) - (3)].node), (yylsp[(2) - (3)])); ;}
    break;

  case 1154:

/* Line 1455 of yacc.c  */
#line 7339 "gram.y"
    { (yyval.node) = (Node *) makeSimpleA_Expr(AEXPR_OP, "<", (yyvsp[(1) - (3)].node), (yyvsp[(3) - (3)].node), (yylsp[(2) - (3)])); ;}
    break;

  case 1155:

/* Line 1455 of yacc.c  */
#line 7341 "gram.y"
    { (yyval.node) = (Node *) makeSimpleA_Expr(AEXPR_OP, ">", (yyvsp[(1) - (3)].node), (yyvsp[(3) - (3)].node), (yylsp[(2) - (3)])); ;}
    break;

  case 1156:

/* Line 1455 of yacc.c  */
#line 7343 "gram.y"
    { (yyval.node) = (Node *) makeSimpleA_Expr(AEXPR_OP, "=", (yyvsp[(1) - (3)].node), (yyvsp[(3) - (3)].node), (yylsp[(2) - (3)])); ;}
    break;

  case 1157:

/* Line 1455 of yacc.c  */
#line 7345 "gram.y"
    { (yyval.node) = (Node *) makeA_Expr(AEXPR_OP, (yyvsp[(2) - (3)].list), (yyvsp[(1) - (3)].node), (yyvsp[(3) - (3)].node), (yylsp[(2) - (3)])); ;}
    break;

  case 1158:

/* Line 1455 of yacc.c  */
#line 7347 "gram.y"
    { (yyval.node) = (Node *) makeA_Expr(AEXPR_OP, (yyvsp[(1) - (2)].list), NULL, (yyvsp[(2) - (2)].node), (yylsp[(1) - (2)])); ;}
    break;

  case 1159:

/* Line 1455 of yacc.c  */
#line 7349 "gram.y"
    { (yyval.node) = (Node *) makeA_Expr(AEXPR_OP, (yyvsp[(2) - (2)].list), (yyvsp[(1) - (2)].node), NULL, (yylsp[(2) - (2)])); ;}
    break;

  case 1160:

/* Line 1455 of yacc.c  */
#line 7351 "gram.y"
    {
					(yyval.node) = (Node *) makeSimpleA_Expr(AEXPR_DISTINCT, "=", (yyvsp[(1) - (5)].node), (yyvsp[(5) - (5)].node), (yylsp[(2) - (5)]));
				;}
    break;

  case 1161:

/* Line 1455 of yacc.c  */
#line 7355 "gram.y"
    {
					(yyval.node) = (Node *) makeA_Expr(AEXPR_NOT, NIL,
						NULL, (Node *) makeSimpleA_Expr(AEXPR_DISTINCT, "=", (yyvsp[(1) - (6)].node), (yyvsp[(6) - (6)].node), (yylsp[(2) - (6)])), (yylsp[(2) - (6)]));
				;}
    break;

  case 1162:

/* Line 1455 of yacc.c  */
#line 7360 "gram.y"
    {
					(yyval.node) = (Node *) makeSimpleA_Expr(AEXPR_OF, "=", (yyvsp[(1) - (6)].node), (Node *) (yyvsp[(5) - (6)].list), (yylsp[(2) - (6)]));
				;}
    break;

  case 1163:

/* Line 1455 of yacc.c  */
#line 7364 "gram.y"
    {
					(yyval.node) = (Node *) makeSimpleA_Expr(AEXPR_OF, "<>", (yyvsp[(1) - (7)].node), (Node *) (yyvsp[(6) - (7)].list), (yylsp[(2) - (7)]));
				;}
    break;

  case 1164:

/* Line 1455 of yacc.c  */
#line 7377 "gram.y"
    { (yyval.node) = (yyvsp[(1) - (1)].node); ;}
    break;

  case 1165:

/* Line 1455 of yacc.c  */
#line 7378 "gram.y"
    { (yyval.node) = (yyvsp[(1) - (1)].node); ;}
    break;

  case 1166:

/* Line 1455 of yacc.c  */
#line 7380 "gram.y"
    {
					ParamRef *p = makeNode(ParamRef);
					p->number = (yyvsp[(1) - (2)].ival);
					if ((yyvsp[(2) - (2)].list))
					{
						A_Indirection *n = makeNode(A_Indirection);
						n->arg = (Node *) p;
						n->indirection = (yyvsp[(2) - (2)].list);
						(yyval.node) = (Node *) n;
					}
					else
						(yyval.node) = (Node *) p;
				;}
    break;

  case 1167:

/* Line 1455 of yacc.c  */
#line 7394 "gram.y"
    {
					if ((yyvsp[(4) - (4)].list))
					{
						A_Indirection *n = makeNode(A_Indirection);
						n->arg = (yyvsp[(2) - (4)].node);
						n->indirection = (yyvsp[(4) - (4)].list);
						(yyval.node) = (Node *)n;
					}
					else
						(yyval.node) = (yyvsp[(2) - (4)].node);
				;}
    break;

  case 1168:

/* Line 1455 of yacc.c  */
#line 7406 "gram.y"
    { (yyval.node) = (yyvsp[(1) - (1)].node); ;}
    break;

  case 1169:

/* Line 1455 of yacc.c  */
#line 7408 "gram.y"
    { (yyval.node) = (yyvsp[(1) - (1)].node); ;}
    break;

  case 1170:

/* Line 1455 of yacc.c  */
#line 7410 "gram.y"
    {
					SubLink *n = makeNode(SubLink);
					n->subLinkType = EXPR_SUBLINK;
					n->testexpr = NULL;
					n->operName = NIL;
					n->subselect = (yyvsp[(1) - (1)].node);
					(yyval.node) = (Node *)n;
				;}
    break;

  case 1171:

/* Line 1455 of yacc.c  */
#line 7419 "gram.y"
    {
					SubLink *n = makeNode(SubLink);
					n->subLinkType = EXISTS_SUBLINK;
					n->testexpr = NULL;
					n->operName = NIL;
					n->subselect = (yyvsp[(2) - (2)].node);
					(yyval.node) = (Node *)n;
				;}
    break;

  case 1172:

/* Line 1455 of yacc.c  */
#line 7428 "gram.y"
    {
					SubLink *n = makeNode(SubLink);
					n->subLinkType = ARRAY_SUBLINK;
					n->testexpr = NULL;
					n->operName = NIL;
					n->subselect = (yyvsp[(2) - (2)].node);
					(yyval.node) = (Node *)n;
				;}
    break;

  case 1173:

/* Line 1455 of yacc.c  */
#line 7437 "gram.y"
    {	(yyval.node) = (yyvsp[(2) - (2)].node);	;}
    break;

  case 1174:

/* Line 1455 of yacc.c  */
#line 7439 "gram.y"
    {
					RowExpr *r = makeNode(RowExpr);
					r->args = (yyvsp[(1) - (1)].list);
					r->row_typeid = InvalidOid;	/* not analyzed yet */
					(yyval.node) = (Node *)r;
				;}
    break;

  case 1175:

/* Line 1455 of yacc.c  */
#line 7456 "gram.y"
    {
					FuncCall *n = makeNode(FuncCall);
					n->funcname = (yyvsp[(1) - (3)].list);
					n->args = NIL;
					n->agg_star = FALSE;
					n->agg_distinct = FALSE;
					n->location = (yylsp[(1) - (3)]);
					(yyval.node) = (Node *)n;
				;}
    break;

  case 1176:

/* Line 1455 of yacc.c  */
#line 7466 "gram.y"
    {
					FuncCall *n = makeNode(FuncCall);
					n->funcname = (yyvsp[(1) - (4)].list);
					n->args = (yyvsp[(3) - (4)].list);
					n->agg_star = FALSE;
					n->agg_distinct = FALSE;
					n->location = (yylsp[(1) - (4)]);
					(yyval.node) = (Node *)n;
				;}
    break;

  case 1177:

/* Line 1455 of yacc.c  */
#line 7476 "gram.y"
    {
					FuncCall *n = makeNode(FuncCall);
					n->funcname = (yyvsp[(1) - (5)].list);
					n->args = (yyvsp[(4) - (5)].list);
					n->agg_star = FALSE;
					n->agg_distinct = FALSE;
					/* Ideally we'd mark the FuncCall node to indicate
					 * "must be an aggregate", but there's no provision
					 * for that in FuncCall at the moment.
					 */
					n->location = (yylsp[(1) - (5)]);
					(yyval.node) = (Node *)n;
				;}
    break;

  case 1178:

/* Line 1455 of yacc.c  */
#line 7490 "gram.y"
    {
					FuncCall *n = makeNode(FuncCall);
					n->funcname = (yyvsp[(1) - (5)].list);
					n->args = (yyvsp[(4) - (5)].list);
					n->agg_star = FALSE;
					n->agg_distinct = TRUE;
					n->location = (yylsp[(1) - (5)]);
					(yyval.node) = (Node *)n;
				;}
    break;

  case 1179:

/* Line 1455 of yacc.c  */
#line 7500 "gram.y"
    {
					/*
					 * We consider AGGREGATE(*) to invoke a parameterless
					 * aggregate.  This does the right thing for COUNT(*),
					 * and there are no other aggregates in SQL92 that accept
					 * '*' as parameter.
					 *
					 * The FuncCall node is also marked agg_star = true,
					 * so that later processing can detect what the argument
					 * really was.
					 */
					FuncCall *n = makeNode(FuncCall);
					n->funcname = (yyvsp[(1) - (4)].list);
					n->args = NIL;
					n->agg_star = TRUE;
					n->agg_distinct = FALSE;
					n->location = (yylsp[(1) - (4)]);
					(yyval.node) = (Node *)n;
				;}
    break;

  case 1180:

/* Line 1455 of yacc.c  */
#line 7520 "gram.y"
    {
					/*
					 * Translate as "'now'::text::date".
					 *
					 * We cannot use "'now'::date" because coerce_type() will
					 * immediately reduce that to a constant representing
					 * today's date.  We need to delay the conversion until
					 * runtime, else the wrong things will happen when
					 * CURRENT_DATE is used in a column default value or rule.
					 *
					 * This could be simplified if we had a way to generate
					 * an expression tree representing runtime application
					 * of type-input conversion functions.  (As of PG 7.3
					 * that is actually possible, but not clear that we want
					 * to rely on it.)
					 */
					A_Const *s = makeNode(A_Const);
					TypeName *d;

					s->val.type = T_String;
					s->val.val.str = "now";
					s->typename = SystemTypeName("text");

					d = SystemTypeName("date");

					(yyval.node) = (Node *)makeTypeCast((Node *)s, d);
				;}
    break;

  case 1181:

/* Line 1455 of yacc.c  */
#line 7548 "gram.y"
    {
					/*
					 * Translate as "'now'::text::timetz".
					 * See comments for CURRENT_DATE.
					 */
					A_Const *s = makeNode(A_Const);
					TypeName *d;

					s->val.type = T_String;
					s->val.val.str = "now";
					s->typename = SystemTypeName("text");

					d = SystemTypeName("timetz");

					(yyval.node) = (Node *)makeTypeCast((Node *)s, d);
				;}
    break;

  case 1182:

/* Line 1455 of yacc.c  */
#line 7565 "gram.y"
    {
					/*
					 * Translate as "'now'::text::timetz(n)".
					 * See comments for CURRENT_DATE.
					 */
					A_Const *s = makeNode(A_Const);
					TypeName *d;

					s->val.type = T_String;
					s->val.val.str = "now";
					s->typename = SystemTypeName("text");
					d = SystemTypeName("timetz");
					if ((yyvsp[(3) - (4)].ival) < 0)
						ereport(ERROR,
								(errcode(ERRCODE_INVALID_PARAMETER_VALUE),
								 errmsg("CURRENT_TIME(%d) precision must not be negative",
										(yyvsp[(3) - (4)].ival))));
					if ((yyvsp[(3) - (4)].ival) > MAX_TIME_PRECISION)
					{
						ereport(WARNING,
								(errcode(ERRCODE_INVALID_PARAMETER_VALUE),
								 errmsg("CURRENT_TIME(%d) precision reduced to maximum allowed, %d",
										(yyvsp[(3) - (4)].ival), MAX_TIME_PRECISION)));
						(yyvsp[(3) - (4)].ival) = MAX_TIME_PRECISION;
					}
					d->typmod = (yyvsp[(3) - (4)].ival);

					(yyval.node) = (Node *)makeTypeCast((Node *)s, d);
				;}
    break;

  case 1183:

/* Line 1455 of yacc.c  */
#line 7595 "gram.y"
    {
					/*
					 * Translate as "now()", since we have a function that
					 * does exactly what is needed.
					 */
					FuncCall *n = makeNode(FuncCall);
					n->funcname = SystemFuncName("now");
					n->args = NIL;
					n->agg_star = FALSE;
					n->agg_distinct = FALSE;
					n->location = (yylsp[(1) - (1)]);
					(yyval.node) = (Node *)n;
				;}
    break;

  case 1184:

/* Line 1455 of yacc.c  */
#line 7609 "gram.y"
    {
					/*
					 * Translate as "'now'::text::timestamptz(n)".
					 * See comments for CURRENT_DATE.
					 */
					A_Const *s = makeNode(A_Const);
					TypeName *d;

					s->val.type = T_String;
					s->val.val.str = "now";
					s->typename = SystemTypeName("text");

					d = SystemTypeName("timestamptz");
					if ((yyvsp[(3) - (4)].ival) < 0)
						ereport(ERROR,
								(errcode(ERRCODE_INVALID_PARAMETER_VALUE),
								 errmsg("CURRENT_TIMESTAMP(%d) precision must not be negative",
										(yyvsp[(3) - (4)].ival))));
					if ((yyvsp[(3) - (4)].ival) > MAX_TIMESTAMP_PRECISION)
					{
						ereport(WARNING,
								(errcode(ERRCODE_INVALID_PARAMETER_VALUE),
								 errmsg("CURRENT_TIMESTAMP(%d) precision reduced to maximum allowed, %d",
										(yyvsp[(3) - (4)].ival), MAX_TIMESTAMP_PRECISION)));
						(yyvsp[(3) - (4)].ival) = MAX_TIMESTAMP_PRECISION;
					}
					d->typmod = (yyvsp[(3) - (4)].ival);

					(yyval.node) = (Node *)makeTypeCast((Node *)s, d);
				;}
    break;

  case 1185:

/* Line 1455 of yacc.c  */
#line 7640 "gram.y"
    {
					/*
					 * Translate as "'now'::text::time".
					 * See comments for CURRENT_DATE.
					 */
					A_Const *s = makeNode(A_Const);
					TypeName *d;

					s->val.type = T_String;
					s->val.val.str = "now";
					s->typename = SystemTypeName("text");

					d = SystemTypeName("time");

					(yyval.node) = (Node *)makeTypeCast((Node *)s, d);
				;}
    break;

  case 1186:

/* Line 1455 of yacc.c  */
#line 7657 "gram.y"
    {
					/*
					 * Translate as "'now'::text::time(n)".
					 * See comments for CURRENT_DATE.
					 */
					A_Const *s = makeNode(A_Const);
					TypeName *d;

					s->val.type = T_String;
					s->val.val.str = "now";
					s->typename = SystemTypeName("text");
					d = SystemTypeName("time");
					if ((yyvsp[(3) - (4)].ival) < 0)
						ereport(ERROR,
								(errcode(ERRCODE_INVALID_PARAMETER_VALUE),
								 errmsg("LOCALTIME(%d) precision must not be negative",
										(yyvsp[(3) - (4)].ival))));
					if ((yyvsp[(3) - (4)].ival) > MAX_TIME_PRECISION)
					{
						ereport(WARNING,
								(errcode(ERRCODE_INVALID_PARAMETER_VALUE),
								 errmsg("LOCALTIME(%d) precision reduced to maximum allowed, %d",
										(yyvsp[(3) - (4)].ival), MAX_TIME_PRECISION)));
						(yyvsp[(3) - (4)].ival) = MAX_TIME_PRECISION;
					}
					d->typmod = (yyvsp[(3) - (4)].ival);

					(yyval.node) = (Node *)makeTypeCast((Node *)s, d);
				;}
    break;

  case 1187:

/* Line 1455 of yacc.c  */
#line 7687 "gram.y"
    {
					/*
					 * Translate as "'now'::text::timestamp".
					 * See comments for CURRENT_DATE.
					 */
					A_Const *s = makeNode(A_Const);
					TypeName *d;

					s->val.type = T_String;
					s->val.val.str = "now";
					s->typename = SystemTypeName("text");

					d = SystemTypeName("timestamp");

					(yyval.node) = (Node *)makeTypeCast((Node *)s, d);
				;}
    break;

  case 1188:

/* Line 1455 of yacc.c  */
#line 7704 "gram.y"
    {
					/*
					 * Translate as "'now'::text::timestamp(n)".
					 * See comments for CURRENT_DATE.
					 */
					A_Const *s = makeNode(A_Const);
					TypeName *d;

					s->val.type = T_String;
					s->val.val.str = "now";
					s->typename = SystemTypeName("text");

					d = SystemTypeName("timestamp");
					if ((yyvsp[(3) - (4)].ival) < 0)
						ereport(ERROR,
								(errcode(ERRCODE_INVALID_PARAMETER_VALUE),
								 errmsg("LOCALTIMESTAMP(%d) precision must not be negative",
										(yyvsp[(3) - (4)].ival))));
					if ((yyvsp[(3) - (4)].ival) > MAX_TIMESTAMP_PRECISION)
					{
						ereport(WARNING,
								(errcode(ERRCODE_INVALID_PARAMETER_VALUE),
								 errmsg("LOCALTIMESTAMP(%d) precision reduced to maximum allowed, %d",
										(yyvsp[(3) - (4)].ival), MAX_TIMESTAMP_PRECISION)));
						(yyvsp[(3) - (4)].ival) = MAX_TIMESTAMP_PRECISION;
					}
					d->typmod = (yyvsp[(3) - (4)].ival);

					(yyval.node) = (Node *)makeTypeCast((Node *)s, d);
				;}
    break;

  case 1189:

/* Line 1455 of yacc.c  */
#line 7735 "gram.y"
    {
					FuncCall *n = makeNode(FuncCall);
					n->funcname = SystemFuncName("current_user");
					n->args = NIL;
					n->agg_star = FALSE;
					n->agg_distinct = FALSE;
					n->location = (yylsp[(1) - (1)]);
					(yyval.node) = (Node *)n;
				;}
    break;

  case 1190:

/* Line 1455 of yacc.c  */
#line 7745 "gram.y"
    {
					FuncCall *n = makeNode(FuncCall);
					n->funcname = SystemFuncName("current_user");
					n->args = NIL;
					n->agg_star = FALSE;
					n->agg_distinct = FALSE;
					n->location = (yylsp[(1) - (1)]);
					(yyval.node) = (Node *)n;
				;}
    break;

  case 1191:

/* Line 1455 of yacc.c  */
#line 7755 "gram.y"
    {
					FuncCall *n = makeNode(FuncCall);
					n->funcname = SystemFuncName("session_user");
					n->args = NIL;
					n->agg_star = FALSE;
					n->agg_distinct = FALSE;
					n->location = (yylsp[(1) - (1)]);
					(yyval.node) = (Node *)n;
				;}
    break;

  case 1192:

/* Line 1455 of yacc.c  */
#line 7765 "gram.y"
    {
					FuncCall *n = makeNode(FuncCall);
					n->funcname = SystemFuncName("current_user");
					n->args = NIL;
					n->agg_star = FALSE;
					n->agg_distinct = FALSE;
					n->location = (yylsp[(1) - (1)]);
					(yyval.node) = (Node *)n;
				;}
    break;

  case 1193:

/* Line 1455 of yacc.c  */
#line 7775 "gram.y"
    { (yyval.node) = makeTypeCast((yyvsp[(3) - (6)].node), (yyvsp[(5) - (6)].typnam)); ;}
    break;

  case 1194:

/* Line 1455 of yacc.c  */
#line 7777 "gram.y"
    {
					FuncCall *n = makeNode(FuncCall);
					n->funcname = SystemFuncName("date_part");
					n->args = (yyvsp[(3) - (4)].list);
					n->agg_star = FALSE;
					n->agg_distinct = FALSE;
					n->location = (yylsp[(1) - (4)]);
					(yyval.node) = (Node *)n;
				;}
    break;

  case 1195:

/* Line 1455 of yacc.c  */
#line 7787 "gram.y"
    {
					/* overlay(A PLACING B FROM C FOR D) is converted to
					 * substring(A, 1, C-1) || B || substring(A, C+1, C+D)
					 * overlay(A PLACING B FROM C) is converted to
					 * substring(A, 1, C-1) || B || substring(A, C+1, C+char_length(B))
					 */
					FuncCall *n = makeNode(FuncCall);
					n->funcname = SystemFuncName("overlay");
					n->args = (yyvsp[(3) - (4)].list);
					n->agg_star = FALSE;
					n->agg_distinct = FALSE;
					n->location = (yylsp[(1) - (4)]);
					(yyval.node) = (Node *)n;
				;}
    break;

  case 1196:

/* Line 1455 of yacc.c  */
#line 7802 "gram.y"
    {
					/* position(A in B) is converted to position(B, A) */
					FuncCall *n = makeNode(FuncCall);
					n->funcname = SystemFuncName("position");
					n->args = (yyvsp[(3) - (4)].list);
					n->agg_star = FALSE;
					n->agg_distinct = FALSE;
					n->location = (yylsp[(1) - (4)]);
					(yyval.node) = (Node *)n;
				;}
    break;

  case 1197:

/* Line 1455 of yacc.c  */
#line 7813 "gram.y"
    {
					/* substring(A from B for C) is converted to
					 * substring(A, B, C) - thomas 2000-11-28
					 */
					FuncCall *n = makeNode(FuncCall);
					n->funcname = SystemFuncName("substring");
					n->args = (yyvsp[(3) - (4)].list);
					n->agg_star = FALSE;
					n->agg_distinct = FALSE;
					n->location = (yylsp[(1) - (4)]);
					(yyval.node) = (Node *)n;
				;}
    break;

  case 1198:

/* Line 1455 of yacc.c  */
#line 7826 "gram.y"
    {
					/* TREAT(expr AS target) converts expr of a particular type to target,
					 * which is defined to be a subtype of the original expression.
					 * In SQL99, this is intended for use with structured UDTs,
					 * but let's make this a generally useful form allowing stronger
					 * coercions than are handled by implicit casting.
					 */
					FuncCall *n = makeNode(FuncCall);
					/* Convert SystemTypeName() to SystemFuncName() even though
					 * at the moment they result in the same thing.
					 */
					n->funcname = SystemFuncName(((Value *)llast((yyvsp[(5) - (6)].typnam)->names))->val.str);
					n->args = list_make1((yyvsp[(3) - (6)].node));
					n->agg_star = FALSE;
					n->agg_distinct = FALSE;
					n->location = (yylsp[(1) - (6)]);
					(yyval.node) = (Node *)n;
				;}
    break;

  case 1199:

/* Line 1455 of yacc.c  */
#line 7845 "gram.y"
    {
					/* various trim expressions are defined in SQL92
					 * - thomas 1997-07-19
					 */
					FuncCall *n = makeNode(FuncCall);
					n->funcname = SystemFuncName("btrim");
					n->args = (yyvsp[(4) - (5)].list);
					n->agg_star = FALSE;
					n->agg_distinct = FALSE;
					n->location = (yylsp[(1) - (5)]);
					(yyval.node) = (Node *)n;
				;}
    break;

  case 1200:

/* Line 1455 of yacc.c  */
#line 7858 "gram.y"
    {
					FuncCall *n = makeNode(FuncCall);
					n->funcname = SystemFuncName("ltrim");
					n->args = (yyvsp[(4) - (5)].list);
					n->agg_star = FALSE;
					n->agg_distinct = FALSE;
					n->location = (yylsp[(1) - (5)]);
					(yyval.node) = (Node *)n;
				;}
    break;

  case 1201:

/* Line 1455 of yacc.c  */
#line 7868 "gram.y"
    {
					FuncCall *n = makeNode(FuncCall);
					n->funcname = SystemFuncName("rtrim");
					n->args = (yyvsp[(4) - (5)].list);
					n->agg_star = FALSE;
					n->agg_distinct = FALSE;
					n->location = (yylsp[(1) - (5)]);
					(yyval.node) = (Node *)n;
				;}
    break;

  case 1202:

/* Line 1455 of yacc.c  */
#line 7878 "gram.y"
    {
					FuncCall *n = makeNode(FuncCall);
					n->funcname = SystemFuncName("btrim");
					n->args = (yyvsp[(3) - (4)].list);
					n->agg_star = FALSE;
					n->agg_distinct = FALSE;
					n->location = (yylsp[(1) - (4)]);
					(yyval.node) = (Node *)n;
				;}
    break;

  case 1203:

/* Line 1455 of yacc.c  */
#line 7888 "gram.y"
    {
					FuncCall *n = makeNode(FuncCall);
					A_Const *c = makeNode(A_Const);

					c->val.type = T_String;
					c->val.val.str = NameListToQuotedString((yyvsp[(5) - (6)].list));

					n->funcname = SystemFuncName("convert_using");
					n->args = list_make2((yyvsp[(3) - (6)].node), c);
					n->agg_star = FALSE;
					n->agg_distinct = FALSE;
					n->location = (yylsp[(1) - (6)]);
					(yyval.node) = (Node *)n;
				;}
    break;

  case 1204:

/* Line 1455 of yacc.c  */
#line 7903 "gram.y"
    {
					FuncCall *n = makeNode(FuncCall);
					n->funcname = SystemFuncName("convert");
					n->args = (yyvsp[(3) - (4)].list);
					n->agg_star = FALSE;
					n->agg_distinct = FALSE;
					n->location = (yylsp[(1) - (4)]);
					(yyval.node) = (Node *)n;
				;}
    break;

  case 1205:

/* Line 1455 of yacc.c  */
#line 7913 "gram.y"
    {
					(yyval.node) = (Node *) makeSimpleA_Expr(AEXPR_NULLIF, "=", (yyvsp[(3) - (6)].node), (yyvsp[(5) - (6)].node), (yylsp[(1) - (6)]));
				;}
    break;

  case 1206:

/* Line 1455 of yacc.c  */
#line 7917 "gram.y"
    {
					CoalesceExpr *c = makeNode(CoalesceExpr);
					c->args = (yyvsp[(3) - (4)].list);
					(yyval.node) = (Node *)c;
				;}
    break;

  case 1207:

/* Line 1455 of yacc.c  */
#line 7923 "gram.y"
    {
					MinMaxExpr *v = makeNode(MinMaxExpr);
					v->args = (yyvsp[(3) - (4)].list);
					v->op = IS_GREATEST;
					(yyval.node) = (Node *)v;
				;}
    break;

  case 1208:

/* Line 1455 of yacc.c  */
#line 7930 "gram.y"
    {
					MinMaxExpr *v = makeNode(MinMaxExpr);
					v->args = (yyvsp[(3) - (4)].list);
					v->op = IS_LEAST;
					(yyval.node) = (Node *)v;
				;}
    break;

  case 1209:

/* Line 1455 of yacc.c  */
#line 7941 "gram.y"
    { (yyval.node) = (Node *) makeSJ_Expr(AEXPR_OP, "=", (yyvsp[(1) - (5)].node), (yyvsp[(5) - (5)].node), (yyvsp[(3) - (5)].str), 0); ;}
    break;

  case 1210:

/* Line 1455 of yacc.c  */
#line 7943 "gram.y"
    { (yyval.node) = (Node *) makeSJ_Expr(AEXPR_OP, "=", (yyvsp[(1) - (5)].node), (yyvsp[(3) - (5)].node), 0, (yyvsp[(5) - (5)].ival)); ;}
    break;

  case 1211:

/* Line 1455 of yacc.c  */
#line 7945 "gram.y"
    { (yyval.node) = (Node *) makeSJ_Expr(AEXPR_OP, "=", (yyvsp[(1) - (3)].node), (yyvsp[(3) - (3)].node), 0, 0); ;}
    break;

  case 1212:

/* Line 1455 of yacc.c  */
#line 7959 "gram.y"
    { (yyval.list) = (yyvsp[(3) - (4)].list); ;}
    break;

  case 1213:

/* Line 1455 of yacc.c  */
#line 7960 "gram.y"
    { (yyval.list) = NIL; ;}
    break;

  case 1214:

/* Line 1455 of yacc.c  */
#line 7961 "gram.y"
    { (yyval.list) = lappend((yyvsp[(2) - (5)].list), (yyvsp[(4) - (5)].node)); ;}
    break;

  case 1215:

/* Line 1455 of yacc.c  */
#line 7964 "gram.y"
    { (yyval.ival) = ANY_SUBLINK; ;}
    break;

  case 1216:

/* Line 1455 of yacc.c  */
#line 7965 "gram.y"
    { (yyval.ival) = ANY_SUBLINK; ;}
    break;

  case 1217:

/* Line 1455 of yacc.c  */
#line 7966 "gram.y"
    { (yyval.ival) = ALL_SUBLINK; ;}
    break;

  case 1218:

/* Line 1455 of yacc.c  */
#line 7969 "gram.y"
    { (yyval.str) = (yyvsp[(1) - (1)].str); ;}
    break;

  case 1219:

/* Line 1455 of yacc.c  */
#line 7970 "gram.y"
    { (yyval.str) = (yyvsp[(1) - (1)].str); ;}
    break;

  case 1220:

/* Line 1455 of yacc.c  */
#line 7973 "gram.y"
    { (yyval.str) = "+"; ;}
    break;

  case 1221:

/* Line 1455 of yacc.c  */
#line 7974 "gram.y"
    { (yyval.str) = "-"; ;}
    break;

  case 1222:

/* Line 1455 of yacc.c  */
#line 7975 "gram.y"
    { (yyval.str) = "*"; ;}
    break;

  case 1223:

/* Line 1455 of yacc.c  */
#line 7976 "gram.y"
    { (yyval.str) = "/"; ;}
    break;

  case 1224:

/* Line 1455 of yacc.c  */
#line 7977 "gram.y"
    { (yyval.str) = "%"; ;}
    break;

  case 1225:

/* Line 1455 of yacc.c  */
#line 7978 "gram.y"
    { (yyval.str) = "^"; ;}
    break;

  case 1226:

/* Line 1455 of yacc.c  */
#line 7979 "gram.y"
    { (yyval.str) = "<"; ;}
    break;

  case 1227:

/* Line 1455 of yacc.c  */
#line 7980 "gram.y"
    { (yyval.str) = ">"; ;}
    break;

  case 1228:

/* Line 1455 of yacc.c  */
#line 7981 "gram.y"
    { (yyval.str) = "="; ;}
    break;

  case 1229:

/* Line 1455 of yacc.c  */
#line 7985 "gram.y"
    { (yyval.list) = list_make1(makeString((yyvsp[(1) - (1)].str))); ;}
    break;

  case 1230:

/* Line 1455 of yacc.c  */
#line 7987 "gram.y"
    { (yyval.list) = (yyvsp[(3) - (4)].list); ;}
    break;

  case 1231:

/* Line 1455 of yacc.c  */
#line 7992 "gram.y"
    { (yyval.list) = list_make1(makeString((yyvsp[(1) - (1)].str))); ;}
    break;

  case 1232:

/* Line 1455 of yacc.c  */
#line 7994 "gram.y"
    { (yyval.list) = (yyvsp[(3) - (4)].list); ;}
    break;

  case 1233:

/* Line 1455 of yacc.c  */
#line 7999 "gram.y"
    { (yyval.list) = list_make1(makeString((yyvsp[(1) - (1)].str))); ;}
    break;

  case 1234:

/* Line 1455 of yacc.c  */
#line 8001 "gram.y"
    { (yyval.list) = (yyvsp[(3) - (4)].list); ;}
    break;

  case 1235:

/* Line 1455 of yacc.c  */
#line 8003 "gram.y"
    { (yyval.list) = list_make1(makeString("~~")); ;}
    break;

  case 1236:

/* Line 1455 of yacc.c  */
#line 8005 "gram.y"
    { (yyval.list) = list_make1(makeString("!~~")); ;}
    break;

  case 1237:

/* Line 1455 of yacc.c  */
#line 8007 "gram.y"
    { (yyval.list) = list_make1(makeString("~~*")); ;}
    break;

  case 1238:

/* Line 1455 of yacc.c  */
#line 8009 "gram.y"
    { (yyval.list) = list_make1(makeString("!~~*")); ;}
    break;

  case 1239:

/* Line 1455 of yacc.c  */
#line 8021 "gram.y"
    {
					(yyval.list) = list_make1((yyvsp[(1) - (1)].node));
				;}
    break;

  case 1240:

/* Line 1455 of yacc.c  */
#line 8025 "gram.y"
    {
					(yyval.list) = lappend((yyvsp[(1) - (3)].list), (yyvsp[(3) - (3)].node));
				;}
    break;

  case 1241:

/* Line 1455 of yacc.c  */
#line 8032 "gram.y"
    {
					A_Const *n = makeNode(A_Const);
					n->val.type = T_String;
					n->val.val.str = (yyvsp[(1) - (3)].str);
					(yyval.list) = list_make2((Node *) n, (yyvsp[(3) - (3)].node));
				;}
    break;

  case 1242:

/* Line 1455 of yacc.c  */
#line 8038 "gram.y"
    { (yyval.list) = NIL; ;}
    break;

  case 1243:

/* Line 1455 of yacc.c  */
#line 8042 "gram.y"
    {
					(yyval.list) = lappend((yyvsp[(1) - (3)].list), (yyvsp[(3) - (3)].typnam));
				;}
    break;

  case 1244:

/* Line 1455 of yacc.c  */
#line 8046 "gram.y"
    {
					(yyval.list) = list_make1((yyvsp[(1) - (1)].typnam));
				;}
    break;

  case 1245:

/* Line 1455 of yacc.c  */
#line 8052 "gram.y"
    {	(yyval.list) = list_make1((yyvsp[(1) - (1)].node));		;}
    break;

  case 1246:

/* Line 1455 of yacc.c  */
#line 8054 "gram.y"
    {	(yyval.list) = lappend((yyvsp[(1) - (3)].list), (yyvsp[(3) - (3)].node));	;}
    break;

  case 1247:

/* Line 1455 of yacc.c  */
#line 8058 "gram.y"
    {
					ArrayExpr *n = makeNode(ArrayExpr);
					n->elements = (yyvsp[(2) - (3)].list);
					(yyval.node) = (Node *)n;
				;}
    break;

  case 1248:

/* Line 1455 of yacc.c  */
#line 8064 "gram.y"
    {
					ArrayExpr *n = makeNode(ArrayExpr);
					n->elements = (yyvsp[(2) - (3)].list);
					(yyval.node) = (Node *)n;
				;}
    break;

  case 1249:

/* Line 1455 of yacc.c  */
#line 8076 "gram.y"
    { (yyval.str) = (yyvsp[(1) - (1)].str); ;}
    break;

  case 1250:

/* Line 1455 of yacc.c  */
#line 8077 "gram.y"
    { (yyval.str) = "year"; ;}
    break;

  case 1251:

/* Line 1455 of yacc.c  */
#line 8078 "gram.y"
    { (yyval.str) = "month"; ;}
    break;

  case 1252:

/* Line 1455 of yacc.c  */
#line 8079 "gram.y"
    { (yyval.str) = "day"; ;}
    break;

  case 1253:

/* Line 1455 of yacc.c  */
#line 8080 "gram.y"
    { (yyval.str) = "hour"; ;}
    break;

  case 1254:

/* Line 1455 of yacc.c  */
#line 8081 "gram.y"
    { (yyval.str) = "minute"; ;}
    break;

  case 1255:

/* Line 1455 of yacc.c  */
#line 8082 "gram.y"
    { (yyval.str) = "second"; ;}
    break;

  case 1256:

/* Line 1455 of yacc.c  */
#line 8083 "gram.y"
    { (yyval.str) = (yyvsp[(1) - (1)].str); ;}
    break;

  case 1257:

/* Line 1455 of yacc.c  */
#line 8093 "gram.y"
    {
					(yyval.list) = list_make4((yyvsp[(1) - (4)].node), (yyvsp[(2) - (4)].node), (yyvsp[(3) - (4)].node), (yyvsp[(4) - (4)].node));
				;}
    break;

  case 1258:

/* Line 1455 of yacc.c  */
#line 8097 "gram.y"
    {
					(yyval.list) = list_make3((yyvsp[(1) - (3)].node), (yyvsp[(2) - (3)].node), (yyvsp[(3) - (3)].node));
				;}
    break;

  case 1259:

/* Line 1455 of yacc.c  */
#line 8104 "gram.y"
    { (yyval.node) = (yyvsp[(2) - (2)].node); ;}
    break;

  case 1260:

/* Line 1455 of yacc.c  */
#line 8110 "gram.y"
    { (yyval.list) = list_make2((yyvsp[(3) - (3)].node), (yyvsp[(1) - (3)].node)); ;}
    break;

  case 1261:

/* Line 1455 of yacc.c  */
#line 8111 "gram.y"
    { (yyval.list) = NIL; ;}
    break;

  case 1262:

/* Line 1455 of yacc.c  */
#line 8128 "gram.y"
    {
					(yyval.list) = list_make3((yyvsp[(1) - (3)].node), (yyvsp[(2) - (3)].node), (yyvsp[(3) - (3)].node));
				;}
    break;

  case 1263:

/* Line 1455 of yacc.c  */
#line 8132 "gram.y"
    {
					/* not legal per SQL99, but might as well allow it */
					(yyval.list) = list_make3((yyvsp[(1) - (3)].node), (yyvsp[(3) - (3)].node), (yyvsp[(2) - (3)].node));
				;}
    break;

  case 1264:

/* Line 1455 of yacc.c  */
#line 8137 "gram.y"
    {
					(yyval.list) = list_make2((yyvsp[(1) - (2)].node), (yyvsp[(2) - (2)].node));
				;}
    break;

  case 1265:

/* Line 1455 of yacc.c  */
#line 8141 "gram.y"
    {
					/*
					 * Since there are no cases where this syntax allows
					 * a textual FOR value, we forcibly cast the argument
					 * to int4.  This is a kluge to avoid surprising results
					 * when the argument is, say, int8.  It'd be better if
					 * there were not an implicit cast from int8 to text ...
					 */
					A_Const *n = makeNode(A_Const);
					n->val.type = T_Integer;
					n->val.val.ival = 1;
					(yyval.list) = list_make3((yyvsp[(1) - (2)].node), (Node *) n,
									makeTypeCast((yyvsp[(2) - (2)].node), SystemTypeName("int4")));
				;}
    break;

  case 1266:

/* Line 1455 of yacc.c  */
#line 8156 "gram.y"
    {
					(yyval.list) = (yyvsp[(1) - (1)].list);
				;}
    break;

  case 1267:

/* Line 1455 of yacc.c  */
#line 8160 "gram.y"
    { (yyval.list) = NIL; ;}
    break;

  case 1268:

/* Line 1455 of yacc.c  */
#line 8164 "gram.y"
    { (yyval.node) = (yyvsp[(2) - (2)].node); ;}
    break;

  case 1269:

/* Line 1455 of yacc.c  */
#line 8167 "gram.y"
    { (yyval.node) = (yyvsp[(2) - (2)].node); ;}
    break;

  case 1270:

/* Line 1455 of yacc.c  */
#line 8170 "gram.y"
    { (yyval.list) = lappend((yyvsp[(3) - (3)].list), (yyvsp[(1) - (3)].node)); ;}
    break;

  case 1271:

/* Line 1455 of yacc.c  */
#line 8171 "gram.y"
    { (yyval.list) = (yyvsp[(2) - (2)].list); ;}
    break;

  case 1272:

/* Line 1455 of yacc.c  */
#line 8172 "gram.y"
    { (yyval.list) = (yyvsp[(1) - (1)].list); ;}
    break;

  case 1273:

/* Line 1455 of yacc.c  */
#line 8176 "gram.y"
    {
					SubLink *n = makeNode(SubLink);
					n->subselect = (yyvsp[(1) - (1)].node);
					/* other fields will be filled later */
					(yyval.node) = (Node *)n;
				;}
    break;

  case 1274:

/* Line 1455 of yacc.c  */
#line 8182 "gram.y"
    { (yyval.node) = (Node *)(yyvsp[(2) - (3)].list); ;}
    break;

  case 1275:

/* Line 1455 of yacc.c  */
#line 8193 "gram.y"
    {
					CaseExpr *c = makeNode(CaseExpr);
					c->casetype = InvalidOid; /* not analyzed yet */
					c->arg = (Expr *) (yyvsp[(2) - (5)].node);
					c->args = (yyvsp[(3) - (5)].list);
					c->defresult = (Expr *) (yyvsp[(4) - (5)].node);
					(yyval.node) = (Node *)c;
				;}
    break;

  case 1276:

/* Line 1455 of yacc.c  */
#line 8205 "gram.y"
    { (yyval.list) = list_make1((yyvsp[(1) - (1)].node)); ;}
    break;

  case 1277:

/* Line 1455 of yacc.c  */
#line 8206 "gram.y"
    { (yyval.list) = lappend((yyvsp[(1) - (2)].list), (yyvsp[(2) - (2)].node)); ;}
    break;

  case 1278:

/* Line 1455 of yacc.c  */
#line 8211 "gram.y"
    {
					CaseWhen *w = makeNode(CaseWhen);
					w->expr = (Expr *) (yyvsp[(2) - (4)].node);
					w->result = (Expr *) (yyvsp[(4) - (4)].node);
					(yyval.node) = (Node *)w;
				;}
    break;

  case 1279:

/* Line 1455 of yacc.c  */
#line 8220 "gram.y"
    { (yyval.node) = (yyvsp[(2) - (2)].node); ;}
    break;

  case 1280:

/* Line 1455 of yacc.c  */
#line 8221 "gram.y"
    { (yyval.node) = NULL; ;}
    break;

  case 1281:

/* Line 1455 of yacc.c  */
#line 8224 "gram.y"
    { (yyval.node) = (yyvsp[(1) - (1)].node); ;}
    break;

  case 1282:

/* Line 1455 of yacc.c  */
#line 8225 "gram.y"
    { (yyval.node) = NULL; ;}
    break;

  case 1283:

/* Line 1455 of yacc.c  */
#line 8234 "gram.y"
    {
					(yyval.node) = makeColumnRef((yyvsp[(1) - (1)].str), NIL, (yylsp[(1) - (1)]));
				;}
    break;

  case 1284:

/* Line 1455 of yacc.c  */
#line 8238 "gram.y"
    {
					(yyval.node) = makeColumnRef((yyvsp[(1) - (2)].str), (yyvsp[(2) - (2)].list), (yylsp[(1) - (2)]));
				;}
    break;

  case 1285:

/* Line 1455 of yacc.c  */
#line 8245 "gram.y"
    {
					(yyval.node) = (Node *) makeString((yyvsp[(2) - (2)].str));
				;}
    break;

  case 1286:

/* Line 1455 of yacc.c  */
#line 8249 "gram.y"
    {
					(yyval.node) = (Node *) makeString("*");
				;}
    break;

  case 1287:

/* Line 1455 of yacc.c  */
#line 8253 "gram.y"
    {
					A_Indices *ai = makeNode(A_Indices);
					ai->lidx = NULL;
					ai->uidx = (yyvsp[(2) - (3)].node);
					(yyval.node) = (Node *) ai;
				;}
    break;

  case 1288:

/* Line 1455 of yacc.c  */
#line 8260 "gram.y"
    {
					A_Indices *ai = makeNode(A_Indices);
					ai->lidx = (yyvsp[(2) - (5)].node);
					ai->uidx = (yyvsp[(4) - (5)].node);
					(yyval.node) = (Node *) ai;
				;}
    break;

  case 1289:

/* Line 1455 of yacc.c  */
#line 8269 "gram.y"
    { (yyval.list) = list_make1((yyvsp[(1) - (1)].node)); ;}
    break;

  case 1290:

/* Line 1455 of yacc.c  */
#line 8270 "gram.y"
    { (yyval.list) = lappend((yyvsp[(1) - (2)].list), (yyvsp[(2) - (2)].node)); ;}
    break;

  case 1291:

/* Line 1455 of yacc.c  */
#line 8274 "gram.y"
    { (yyval.list) = NIL; ;}
    break;

  case 1292:

/* Line 1455 of yacc.c  */
#line 8275 "gram.y"
    { (yyval.list) = lappend((yyvsp[(1) - (2)].list), (yyvsp[(2) - (2)].node)); ;}
    break;

  case 1295:

/* Line 1455 of yacc.c  */
#line 8290 "gram.y"
    { (yyval.node) = (Node *) (yyvsp[(1) - (1)].node); ;}
    break;

  case 1296:

/* Line 1455 of yacc.c  */
#line 8291 "gram.y"
    { (yyval.node) = (Node *) makeNode(SetToDefault); ;}
    break;

  case 1297:

/* Line 1455 of yacc.c  */
#line 8295 "gram.y"
    { (yyval.list) = list_make1((yyvsp[(1) - (1)].node)); ;}
    break;

  case 1298:

/* Line 1455 of yacc.c  */
#line 8296 "gram.y"
    { (yyval.list) = lappend((yyvsp[(1) - (3)].list), (yyvsp[(3) - (3)].node)); ;}
    break;

  case 1299:

/* Line 1455 of yacc.c  */
#line 8304 "gram.y"
    { (yyval.list) = (yyvsp[(2) - (3)].list); ;}
    break;

  case 1300:

/* Line 1455 of yacc.c  */
#line 8315 "gram.y"
    { (yyval.list) = list_make1((yyvsp[(1) - (1)].target)); ;}
    break;

  case 1301:

/* Line 1455 of yacc.c  */
#line 8316 "gram.y"
    { (yyval.list) = lappend((yyvsp[(1) - (3)].list), (yyvsp[(3) - (3)].target)); ;}
    break;

  case 1302:

/* Line 1455 of yacc.c  */
#line 8321 "gram.y"
    {
					(yyval.target) = makeNode(ResTarget);
					(yyval.target)->name = (yyvsp[(3) - (3)].str);
					(yyval.target)->indirection = NIL;
					(yyval.target)->val = (Node *)(yyvsp[(1) - (3)].node);
					(yyval.target)->location = (yylsp[(1) - (3)]);
				;}
    break;

  case 1303:

/* Line 1455 of yacc.c  */
#line 8329 "gram.y"
    {
					(yyval.target) = makeNode(ResTarget);
					(yyval.target)->name = NULL;
					(yyval.target)->indirection = NIL;
					(yyval.target)->val = (Node *)(yyvsp[(1) - (1)].node);
					(yyval.target)->location = (yylsp[(1) - (1)]);
				;}
    break;

  case 1304:

/* Line 1455 of yacc.c  */
#line 8337 "gram.y"
    {
					ColumnRef *n = makeNode(ColumnRef);
					n->fields = list_make1(makeString("*"));
					n->location = (yylsp[(1) - (1)]);

					(yyval.target) = makeNode(ResTarget);
					(yyval.target)->name = NULL;
					(yyval.target)->indirection = NIL;
					(yyval.target)->val = (Node *)n;
					(yyval.target)->location = (yylsp[(1) - (1)]);
				;}
    break;

  case 1305:

/* Line 1455 of yacc.c  */
#line 8358 "gram.y"
    { (yyval.str) = (yyvsp[(1) - (1)].str); ;}
    break;

  case 1306:

/* Line 1455 of yacc.c  */
#line 8359 "gram.y"
    { (yyval.str) = (yyvsp[(1) - (1)].str); ;}
    break;

  case 1307:

/* Line 1455 of yacc.c  */
#line 8363 "gram.y"
    { (yyval.list) = list_make1((yyvsp[(1) - (1)].range)); ;}
    break;

  case 1308:

/* Line 1455 of yacc.c  */
#line 8364 "gram.y"
    { (yyval.list) = lappend((yyvsp[(1) - (3)].list), (yyvsp[(3) - (3)].range)); ;}
    break;

  case 1309:

/* Line 1455 of yacc.c  */
#line 8376 "gram.y"
    {
					(yyval.range) = makeNode(RangeVar);
					(yyval.range)->catalogname = NULL;
					(yyval.range)->schemaname = NULL;
					(yyval.range)->relname = (yyvsp[(1) - (1)].str);
				;}
    break;

  case 1310:

/* Line 1455 of yacc.c  */
#line 8383 "gram.y"
    {
					check_qualified_name((yyvsp[(2) - (2)].list));
					(yyval.range) = makeNode(RangeVar);
					switch (list_length((yyvsp[(2) - (2)].list)))
					{
						case 1:
							(yyval.range)->catalogname = NULL;
							(yyval.range)->schemaname = (yyvsp[(1) - (2)].str);
							(yyval.range)->relname = strVal(linitial((yyvsp[(2) - (2)].list)));
							break;
						case 2:
							(yyval.range)->catalogname = (yyvsp[(1) - (2)].str);
							(yyval.range)->schemaname = strVal(linitial((yyvsp[(2) - (2)].list)));
							(yyval.range)->relname = strVal(lsecond((yyvsp[(2) - (2)].list)));
							break;
						default:
							ereport(ERROR,
									(errcode(ERRCODE_SYNTAX_ERROR),
									 errmsg("improper qualified name (too many dotted names): %s",
											NameListToString(lcons(makeString((yyvsp[(1) - (2)].str)), (yyvsp[(2) - (2)].list))))));
							break;
					}
				;}
    break;

  case 1311:

/* Line 1455 of yacc.c  */
#line 8409 "gram.y"
    { (yyval.list) = list_make1(makeString((yyvsp[(1) - (1)].str))); ;}
    break;

  case 1312:

/* Line 1455 of yacc.c  */
#line 8411 "gram.y"
    { (yyval.list) = lappend((yyvsp[(1) - (3)].list), makeString((yyvsp[(3) - (3)].str))); ;}
    break;

  case 1313:

/* Line 1455 of yacc.c  */
#line 8415 "gram.y"
    { (yyval.str) = (yyvsp[(1) - (1)].str); ;}
    break;

  case 1314:

/* Line 1455 of yacc.c  */
#line 8418 "gram.y"
    { (yyval.str) = (yyvsp[(1) - (1)].str); ;}
    break;

  case 1315:

/* Line 1455 of yacc.c  */
#line 8421 "gram.y"
    { (yyval.str) = (yyvsp[(1) - (1)].str); ;}
    break;

  case 1316:

/* Line 1455 of yacc.c  */
#line 8423 "gram.y"
    { (yyval.str) = (yyvsp[(1) - (1)].str); ;}
    break;

  case 1317:

/* Line 1455 of yacc.c  */
#line 8425 "gram.y"
    { (yyval.str) = (yyvsp[(1) - (1)].str); ;}
    break;

  case 1318:

/* Line 1455 of yacc.c  */
#line 8427 "gram.y"
    { (yyval.str) = (yyvsp[(1) - (1)].str); ;}
    break;

  case 1319:

/* Line 1455 of yacc.c  */
#line 8438 "gram.y"
    { (yyval.list) = list_make1(makeString((yyvsp[(1) - (1)].str))); ;}
    break;

  case 1320:

/* Line 1455 of yacc.c  */
#line 8440 "gram.y"
    { (yyval.list) = check_func_name(lcons(makeString((yyvsp[(1) - (2)].str)), (yyvsp[(2) - (2)].list))); ;}
    break;

  case 1321:

/* Line 1455 of yacc.c  */
#line 8448 "gram.y"
    {
					A_Const *n = makeNode(A_Const);
					n->val.type = T_Integer;
					n->val.val.ival = (yyvsp[(1) - (1)].ival);
					(yyval.node) = (Node *)n;
				;}
    break;

  case 1322:

/* Line 1455 of yacc.c  */
#line 8455 "gram.y"
    {
					A_Const *n = makeNode(A_Const);
					n->val.type = T_Float;
					n->val.val.str = (yyvsp[(1) - (1)].str);
					(yyval.node) = (Node *)n;
				;}
    break;

  case 1323:

/* Line 1455 of yacc.c  */
#line 8462 "gram.y"
    {
					A_Const *n = makeNode(A_Const);
					n->val.type = T_String;
					n->val.val.str = (yyvsp[(1) - (1)].str);
					(yyval.node) = (Node *)n;
				;}
    break;

  case 1324:

/* Line 1455 of yacc.c  */
#line 8469 "gram.y"
    {
					A_Const *n = makeNode(A_Const);
					n->val.type = T_BitString;
					n->val.val.str = (yyvsp[(1) - (1)].str);
					(yyval.node) = (Node *)n;
				;}
    break;

  case 1325:

/* Line 1455 of yacc.c  */
#line 8476 "gram.y"
    {
					/* This is a bit constant per SQL99:
					 * Without Feature F511, "BIT data type",
					 * a <general literal> shall not be a
					 * <bit string literal> or a <hex string literal>.
					 */
					A_Const *n = makeNode(A_Const);
					n->val.type = T_BitString;
					n->val.val.str = (yyvsp[(1) - (1)].str);
					(yyval.node) = (Node *)n;
				;}
    break;

  case 1326:

/* Line 1455 of yacc.c  */
#line 8488 "gram.y"
    {
					A_Const *n = makeNode(A_Const);
					n->typename = (yyvsp[(1) - (2)].typnam);
					n->val.type = T_String;
					n->val.val.str = (yyvsp[(2) - (2)].str);
					(yyval.node) = (Node *)n;
				;}
    break;

  case 1327:

/* Line 1455 of yacc.c  */
#line 8496 "gram.y"
    {
					A_Const *n = makeNode(A_Const);
					n->typename = (yyvsp[(1) - (3)].typnam);
					n->val.type = T_String;
					n->val.val.str = (yyvsp[(2) - (3)].str);
					/* precision is not specified, but fields may be... */
					if ((yyvsp[(3) - (3)].ival) != INTERVAL_FULL_RANGE)
						n->typename->typmod = INTERVAL_TYPMOD(INTERVAL_FULL_PRECISION, (yyvsp[(3) - (3)].ival));
					(yyval.node) = (Node *)n;
				;}
    break;

  case 1328:

/* Line 1455 of yacc.c  */
#line 8507 "gram.y"
    {
					A_Const *n = makeNode(A_Const);
					n->typename = (yyvsp[(1) - (6)].typnam);
					n->val.type = T_String;
					n->val.val.str = (yyvsp[(5) - (6)].str);
					/* precision specified, and fields may be... */
					if ((yyvsp[(3) - (6)].ival) < 0)
						ereport(ERROR,
								(errcode(ERRCODE_INVALID_PARAMETER_VALUE),
								 errmsg("INTERVAL(%d) precision must not be negative",
										(yyvsp[(3) - (6)].ival))));
					if ((yyvsp[(3) - (6)].ival) > MAX_INTERVAL_PRECISION)
					{
						ereport(WARNING,
								(errcode(ERRCODE_INVALID_PARAMETER_VALUE),
								 errmsg("INTERVAL(%d) precision reduced to maximum allowed, %d",
										(yyvsp[(3) - (6)].ival), MAX_INTERVAL_PRECISION)));
						(yyvsp[(3) - (6)].ival) = MAX_INTERVAL_PRECISION;
					}
					n->typename->typmod = INTERVAL_TYPMOD((yyvsp[(3) - (6)].ival), (yyvsp[(6) - (6)].ival));
					(yyval.node) = (Node *)n;
				;}
    break;

  case 1329:

/* Line 1455 of yacc.c  */
#line 8530 "gram.y"
    {
					(yyval.node) = (Node *)makeBoolAConst(TRUE);
				;}
    break;

  case 1330:

/* Line 1455 of yacc.c  */
#line 8534 "gram.y"
    {
					(yyval.node) = (Node *)makeBoolAConst(FALSE);
				;}
    break;

  case 1331:

/* Line 1455 of yacc.c  */
#line 8538 "gram.y"
    {
					A_Const *n = makeNode(A_Const);
					n->val.type = T_Null;
					(yyval.node) = (Node *)n;
				;}
    break;

  case 1332:

/* Line 1455 of yacc.c  */
#line 8545 "gram.y"
    { (yyval.ival) = (yyvsp[(1) - (1)].ival); ;}
    break;

  case 1333:

/* Line 1455 of yacc.c  */
#line 8546 "gram.y"
    { (yyval.str) = (yyvsp[(1) - (1)].str); ;}
    break;

  case 1334:

/* Line 1455 of yacc.c  */
#line 8547 "gram.y"
    { (yyval.str) = (yyvsp[(1) - (1)].str); ;}
    break;

  case 1335:

/* Line 1455 of yacc.c  */
#line 8549 "gram.y"
    { (yyval.ival) = (yyvsp[(1) - (1)].ival); ;}
    break;

  case 1336:

/* Line 1455 of yacc.c  */
#line 8550 "gram.y"
    { (yyval.ival) = - (yyvsp[(2) - (2)].ival); ;}
    break;

  case 1337:

/* Line 1455 of yacc.c  */
#line 8566 "gram.y"
    { (yyval.str) = (yyvsp[(1) - (1)].str); ;}
    break;

  case 1338:

/* Line 1455 of yacc.c  */
#line 8567 "gram.y"
    { (yyval.str) = pstrdup((yyvsp[(1) - (1)].keyword)); ;}
    break;

  case 1339:

/* Line 1455 of yacc.c  */
#line 8568 "gram.y"
    { (yyval.str) = pstrdup((yyvsp[(1) - (1)].keyword)); ;}
    break;

  case 1340:

/* Line 1455 of yacc.c  */
#line 8573 "gram.y"
    { (yyval.str) = (yyvsp[(1) - (1)].str); ;}
    break;

  case 1341:

/* Line 1455 of yacc.c  */
#line 8574 "gram.y"
    { (yyval.str) = pstrdup((yyvsp[(1) - (1)].keyword)); ;}
    break;

  case 1342:

/* Line 1455 of yacc.c  */
#line 8580 "gram.y"
    { (yyval.str) = (yyvsp[(1) - (1)].str); ;}
    break;

  case 1343:

/* Line 1455 of yacc.c  */
#line 8581 "gram.y"
    { (yyval.str) = pstrdup((yyvsp[(1) - (1)].keyword)); ;}
    break;

  case 1344:

/* Line 1455 of yacc.c  */
#line 8582 "gram.y"
    { (yyval.str) = pstrdup((yyvsp[(1) - (1)].keyword)); ;}
    break;

  case 1345:

/* Line 1455 of yacc.c  */
#line 8588 "gram.y"
    { (yyval.str) = (yyvsp[(1) - (1)].str); ;}
    break;

  case 1346:

/* Line 1455 of yacc.c  */
#line 8589 "gram.y"
    { (yyval.str) = pstrdup((yyvsp[(1) - (1)].keyword)); ;}
    break;

  case 1347:

/* Line 1455 of yacc.c  */
#line 8590 "gram.y"
    { (yyval.str) = pstrdup((yyvsp[(1) - (1)].keyword)); ;}
    break;

  case 1348:

/* Line 1455 of yacc.c  */
#line 8591 "gram.y"
    { (yyval.str) = pstrdup((yyvsp[(1) - (1)].keyword)); ;}
    break;

  case 1349:

/* Line 1455 of yacc.c  */
#line 8592 "gram.y"
    { (yyval.str) = pstrdup((yyvsp[(1) - (1)].keyword)); ;}
    break;

  case 1690:

/* Line 1455 of yacc.c  */
#line 8988 "gram.y"
    {
					if (QueryIsRule)
						(yyval.str) = "*OLD*";
					else
						ereport(ERROR,
								(errcode(ERRCODE_SYNTAX_ERROR),
								 errmsg("OLD used in query that is not in a rule")));
				;}
    break;

  case 1691:

/* Line 1455 of yacc.c  */
#line 8997 "gram.y"
    {
					if (QueryIsRule)
						(yyval.str) = "*NEW*";
					else
						ereport(ERROR,
								(errcode(ERRCODE_SYNTAX_ERROR),
								 errmsg("NEW used in query that is not in a rule")));
				;}
    break;



/* Line 1455 of yacc.c  */
#line 25096 "gram.tab.c"
      default: break;
    }
  YY_SYMBOL_PRINT ("-> $$ =", yyr1[yyn], &yyval, &yyloc);

  YYPOPSTACK (yylen);
  yylen = 0;
  YY_STACK_PRINT (yyss, yyssp);

  *++yyvsp = yyval;
  *++yylsp = yyloc;

  /* Now `shift' the result of the reduction.  Determine what state
     that goes to, based on the state we popped back to and the rule
     number reduced by.  */

  yyn = yyr1[yyn];

  yystate = yypgoto[yyn - YYNTOKENS] + *yyssp;
  if (0 <= yystate && yystate <= YYLAST && yycheck[yystate] == *yyssp)
    yystate = yytable[yystate];
  else
    yystate = yydefgoto[yyn - YYNTOKENS];

  goto yynewstate;


/*------------------------------------.
| yyerrlab -- here on detecting error |
`------------------------------------*/
yyerrlab:
  /* If not already recovering from an error, report this error.  */
  if (!yyerrstatus)
    {
      ++yynerrs;
#if ! YYERROR_VERBOSE
      yyerror (YY_("syntax error"));
#else
      {
	YYSIZE_T yysize = yysyntax_error (0, yystate, yychar);
	if (yymsg_alloc < yysize && yymsg_alloc < YYSTACK_ALLOC_MAXIMUM)
	  {
	    YYSIZE_T yyalloc = 2 * yysize;
	    if (! (yysize <= yyalloc && yyalloc <= YYSTACK_ALLOC_MAXIMUM))
	      yyalloc = YYSTACK_ALLOC_MAXIMUM;
	    if (yymsg != yymsgbuf)
	      YYSTACK_FREE (yymsg);
	    yymsg = (char *) YYSTACK_ALLOC (yyalloc);
	    if (yymsg)
	      yymsg_alloc = yyalloc;
	    else
	      {
		yymsg = yymsgbuf;
		yymsg_alloc = sizeof yymsgbuf;
	      }
	  }

	if (0 < yysize && yysize <= yymsg_alloc)
	  {
	    (void) yysyntax_error (yymsg, yystate, yychar);
	    yyerror (yymsg);
	  }
	else
	  {
	    yyerror (YY_("syntax error"));
	    if (yysize != 0)
	      goto yyexhaustedlab;
	  }
      }
#endif
    }

  yyerror_range[0] = yylloc;

  if (yyerrstatus == 3)
    {
      /* If just tried and failed to reuse lookahead token after an
	 error, discard it.  */

      if (yychar <= YYEOF)
	{
	  /* Return failure if at end of input.  */
	  if (yychar == YYEOF)
	    YYABORT;
	}
      else
	{
	  yydestruct ("Error: discarding",
		      yytoken, &yylval, &yylloc);
	  yychar = YYEMPTY;
	}
    }

  /* Else will try to reuse lookahead token after shifting the error
     token.  */
  goto yyerrlab1;


/*---------------------------------------------------.
| yyerrorlab -- error raised explicitly by YYERROR.  |
`---------------------------------------------------*/
yyerrorlab:

  /* Pacify compilers like GCC when the user code never invokes
     YYERROR and the label yyerrorlab therefore never appears in user
     code.  */
  if (/*CONSTCOND*/ 0)
     goto yyerrorlab;

  yyerror_range[0] = yylsp[1-yylen];
  /* Do not reclaim the symbols of the rule which action triggered
     this YYERROR.  */
  YYPOPSTACK (yylen);
  yylen = 0;
  YY_STACK_PRINT (yyss, yyssp);
  yystate = *yyssp;
  goto yyerrlab1;


/*-------------------------------------------------------------.
| yyerrlab1 -- common code for both syntax error and YYERROR.  |
`-------------------------------------------------------------*/
yyerrlab1:
  yyerrstatus = 3;	/* Each real token shifted decrements this.  */

  for (;;)
    {
      yyn = yypact[yystate];
      if (yyn != YYPACT_NINF)
	{
	  yyn += YYTERROR;
	  if (0 <= yyn && yyn <= YYLAST && yycheck[yyn] == YYTERROR)
	    {
	      yyn = yytable[yyn];
	      if (0 < yyn)
		break;
	    }
	}

      /* Pop the current state because it cannot handle the error token.  */
      if (yyssp == yyss)
	YYABORT;

      yyerror_range[0] = *yylsp;
      yydestruct ("Error: popping",
		  yystos[yystate], yyvsp, yylsp);
      YYPOPSTACK (1);
      yystate = *yyssp;
      YY_STACK_PRINT (yyss, yyssp);
    }

  *++yyvsp = yylval;

  yyerror_range[1] = yylloc;
  /* Using YYLLOC is tempting, but would change the location of
     the lookahead.  YYLOC is available though.  */
  YYLLOC_DEFAULT (yyloc, (yyerror_range - 1), 2);
  *++yylsp = yyloc;

  /* Shift the error token.  */
  YY_SYMBOL_PRINT ("Shifting", yystos[yyn], yyvsp, yylsp);

  yystate = yyn;
  goto yynewstate;


/*-------------------------------------.
| yyacceptlab -- YYACCEPT comes here.  |
`-------------------------------------*/
yyacceptlab:
  yyresult = 0;
  goto yyreturn;

/*-----------------------------------.
| yyabortlab -- YYABORT comes here.  |
`-----------------------------------*/
yyabortlab:
  yyresult = 1;
  goto yyreturn;

#if !defined(yyoverflow) || YYERROR_VERBOSE
/*-------------------------------------------------.
| yyexhaustedlab -- memory exhaustion comes here.  |
`-------------------------------------------------*/
yyexhaustedlab:
  yyerror (YY_("memory exhausted"));
  yyresult = 2;
  /* Fall through.  */
#endif

yyreturn:
  if (yychar != YYEMPTY)
     yydestruct ("Cleanup: discarding lookahead",
		 yytoken, &yylval, &yylloc);
  /* Do not reclaim the symbols of the rule which action triggered
     this YYABORT or YYACCEPT.  */
  YYPOPSTACK (yylen);
  YY_STACK_PRINT (yyss, yyssp);
  while (yyssp != yyss)
    {
      yydestruct ("Cleanup: popping",
		  yystos[*yyssp], yyvsp, yylsp);
      YYPOPSTACK (1);
    }
#ifndef yyoverflow
  if (yyss != yyssa)
    YYSTACK_FREE (yyss);
#endif
#if YYERROR_VERBOSE
  if (yymsg != yymsgbuf)
    YYSTACK_FREE (yymsg);
#endif
  /* Make sure YYID is used.  */
  return YYID (yyresult);
}



/* Line 1675 of yacc.c  */
#line 9007 "gram.y"


static Node *
makeColumnRef(char *relname, List *indirection, int location)
{
	/*
	 * Generate a ColumnRef node, with an A_Indirection node added if there
	 * is any subscripting in the specified indirection list.  However,
	 * any field selection at the start of the indirection list must be
	 * transposed into the "fields" part of the ColumnRef node.
	 */
	ColumnRef  *c = makeNode(ColumnRef);
	int		nfields = 0;
	ListCell *l;

	c->location = location;
	foreach(l, indirection)
	{
		if (IsA(lfirst(l), A_Indices))
		{
			A_Indirection *i = makeNode(A_Indirection);

			if (nfields == 0)
			{
				/* easy case - all indirection goes to A_Indirection */
				c->fields = list_make1(makeString(relname));
				i->indirection = indirection;
			}
			else
			{
				/* got to split the list in two */
				i->indirection = list_copy_tail(indirection, nfields);
				indirection = list_truncate(indirection, nfields);
				c->fields = lcons(makeString(relname), indirection);
			}
			i->arg = (Node *) c;
			return (Node *) i;
		}
		nfields++;
	}
	/* No subscripting, so all indirection gets added to field list */
	c->fields = lcons(makeString(relname), indirection);
	return (Node *) c;
}

static Node *
makeTypeCast(Node *arg, TypeName *typename)
{
	/*
	 * Simply generate a TypeCast node.
	 *
	 * Earlier we would determine whether an A_Const would
	 * be acceptable, however Domains require coerce_type()
	 * to process them -- applying constraints as required.
	 */
	TypeCast *n = makeNode(TypeCast);
	n->arg = arg;
	n->typename = typename;
	return (Node *) n;
}

static Node *
makeStringConst(char *str, TypeName *typename)
{
	A_Const *n = makeNode(A_Const);

	n->val.type = T_String;
	n->val.val.str = str;
	n->typename = typename;

	return (Node *)n;
}

static Node *
makeIntConst(int val)
{
	A_Const *n = makeNode(A_Const);
	n->val.type = T_Integer;
	n->val.val.ival = val;
	n->typename = SystemTypeName("int4");

	return (Node *)n;
}

static Node *
makeFloatConst(char *str)
{
	A_Const *n = makeNode(A_Const);

	n->val.type = T_Float;
	n->val.val.str = str;
	n->typename = SystemTypeName("float8");

	return (Node *)n;
}

static Node *
makeAConst(Value *v)
{
	Node *n;

	switch (v->type)
	{
		case T_Float:
			n = makeFloatConst(v->val.str);
			break;

		case T_Integer:
			n = makeIntConst(v->val.ival);
			break;

		case T_String:
		default:
			n = makeStringConst(v->val.str, NULL);
			break;
	}

	return n;
}

/* makeBoolAConst()
 * Create an A_Const node and initialize to a boolean constant.
 */
static A_Const *
makeBoolAConst(bool state)
{
	A_Const *n = makeNode(A_Const);
	n->val.type = T_String;
	n->val.val.str = (state? "t": "f");
	n->typename = SystemTypeName("bool");
	return n;
}

/* makeOverlaps()
 * Create and populate a FuncCall node to support the OVERLAPS operator.
 */
static FuncCall *
makeOverlaps(List *largs, List *rargs, int location)
{
	FuncCall *n = makeNode(FuncCall);

	n->funcname = SystemFuncName("overlaps");
	if (list_length(largs) == 1)
		largs = lappend(largs, largs);
	else if (list_length(largs) != 2)
		ereport(ERROR,
				(errcode(ERRCODE_SYNTAX_ERROR),
				 errmsg("wrong number of parameters on left side of OVERLAPS expression")));
	if (list_length(rargs) == 1)
		rargs = lappend(rargs, rargs);
	else if (list_length(rargs) != 2)
		ereport(ERROR,
				(errcode(ERRCODE_SYNTAX_ERROR),
				 errmsg("wrong number of parameters on right side of OVERLAPS expression")));
	n->args = list_concat(largs, rargs);
	n->agg_star = FALSE;
	n->agg_distinct = FALSE;
	n->location = location;
	return n;
}

/* check_qualified_name --- check the result of qualified_name production
 *
 * It's easiest to let the grammar production for qualified_name allow
 * subscripts and '*', which we then must reject here.
 */
static void
check_qualified_name(List *names)
{
	ListCell   *i;

	foreach(i, names)
	{
		if (!IsA(lfirst(i), String))
			yyerror("syntax error");
		else if (strcmp(strVal(lfirst(i)), "*") == 0)
			yyerror("syntax error");
	}
}

/* check_func_name --- check the result of func_name production
 *
 * It's easiest to let the grammar production for func_name allow subscripts
 * and '*', which we then must reject here.
 */
static List *
check_func_name(List *names)
{
	ListCell   *i;

	foreach(i, names)
	{
		if (!IsA(lfirst(i), String))
			yyerror("syntax error");
		else if (strcmp(strVal(lfirst(i)), "*") == 0)
			yyerror("syntax error");
	}
	return names;
}

/* extractArgTypes()
 * Given a list of FunctionParameter nodes, extract a list of just the
 * argument types (TypeNames) for input parameters only.  This is what
 * is needed to look up an existing function, which is what is wanted by
 * the productions that use this call.
 */
static List *
extractArgTypes(List *parameters)
{
	List	   *result = NIL;
	ListCell   *i;

	foreach(i, parameters)
	{
		FunctionParameter *p = (FunctionParameter *) lfirst(i);

		if (p->mode != FUNC_PARAM_OUT)			/* keep if IN or INOUT */
			result = lappend(result, p->argType);
	}
	return result;
}

/* findLeftmostSelect()
 * Find the leftmost component SelectStmt in a set-operation parsetree.
 */
static SelectStmt *
findLeftmostSelect(SelectStmt *node)
{
	while (node && node->op != SETOP_NONE)
		node = node->larg;
	Assert(node && IsA(node, SelectStmt) && node->larg == NULL);
	return node;
}

/* insertSelectOptions()
 * Insert ORDER BY, etc into an already-constructed SelectStmt.
 *
 * This routine is just to avoid duplicating code in SelectStmt productions.
 */
static void
insertSelectOptions(SelectStmt *stmt,
					List *sortClause, List *lockingClause,
					Node *limitOffset, Node *limitCount)
{
	/*
	 * Tests here are to reject constructs like
	 *	(SELECT foo ORDER BY bar) ORDER BY baz
	 */
	if (sortClause)
	{
		if (stmt->sortClause)
			ereport(ERROR,
					(errcode(ERRCODE_SYNTAX_ERROR),
					 errmsg("multiple ORDER BY clauses not allowed")));
		stmt->sortClause = sortClause;
	}
	/* We can handle multiple locking clauses, though */
	stmt->lockingClause = list_concat(stmt->lockingClause, lockingClause);
	if (limitOffset)
	{
		if (stmt->limitOffset)
			ereport(ERROR,
					(errcode(ERRCODE_SYNTAX_ERROR),
					 errmsg("multiple OFFSET clauses not allowed")));
		stmt->limitOffset = limitOffset;
	}
	if (limitCount)
	{
		if (stmt->limitCount)
			ereport(ERROR,
					(errcode(ERRCODE_SYNTAX_ERROR),
					 errmsg("multiple LIMIT clauses not allowed")));
		stmt->limitCount = limitCount;
	}
}

static Node *
makeSetOp(SetOperation op, bool all, Node *larg, Node *rarg)
{
	SelectStmt *n = makeNode(SelectStmt);

	n->op = op;
	n->all = all;
	n->larg = (SelectStmt *) larg;
	n->rarg = (SelectStmt *) rarg;
	return (Node *) n;
}

/* SystemFuncName()
 * Build a properly-qualified reference to a built-in function.
 */
List *
SystemFuncName(char *name)
{
	return list_make2(makeString("pg_catalog"), makeString(name));
}

/* SystemTypeName()
 * Build a properly-qualified reference to a built-in type.
 *
 * typmod is defaulted, but may be changed afterwards by caller.
 */
TypeName *
SystemTypeName(char *name)
{
	TypeName   *n = makeNode(TypeName);

	n->names = list_make2(makeString("pg_catalog"), makeString(name));
	n->typmod = -1;
	n->location = -1;
	return n;
}

/* parser_init()
 * Initialize to parse one query string
 */
void
parser_init(void)
{
	QueryIsRule = FALSE;
}

/* exprIsNullConstant()
 * Test whether an a_expr is a plain NULL constant or not.
 */
bool
exprIsNullConstant(Node *arg)
{
	if (arg && IsA(arg, A_Const))
	{
		A_Const *con = (A_Const *) arg;

		if (con->val.type == T_Null &&
			con->typename == NULL)
			return TRUE;
	}
	return FALSE;
}

/* doNegate()
 * Handle negation of a numeric constant.
 *
 * Formerly, we did this here because the optimizer couldn't cope with
 * indexquals that looked like "var = -4" --- it wants "var = const"
 * and a unary minus operator applied to a constant didn't qualify.
 * As of Postgres 7.0, that problem doesn't exist anymore because there
 * is a constant-subexpression simplifier in the optimizer.  However,
 * there's still a good reason for doing this here, which is that we can
 * postpone committing to a particular internal representation for simple
 * negative constants.	It's better to leave "-123.456" in string form
 * until we know what the desired type is.
 */
static Node *
doNegate(Node *n, int location)
{
	if (IsA(n, A_Const))
	{
		A_Const *con = (A_Const *)n;

		if (con->val.type == T_Integer)
		{
			con->val.val.ival = -con->val.val.ival;
			return n;
		}
		if (con->val.type == T_Float)
		{
			doNegateFloat(&con->val);
			return n;
		}
	}

	return (Node *) makeSimpleA_Expr(AEXPR_OP, "-", NULL, n, location);
}

static void
doNegateFloat(Value *v)
{
	char   *oldval = v->val.str;

	Assert(IsA(v, Float));
	if (*oldval == '+')
		oldval++;
	if (*oldval == '-')
		v->val.str = oldval+1;	/* just strip the '-' */
	else
	{
		char   *newval = (char *) palloc(strlen(oldval) + 2);

		*newval = '-';
		strcpy(newval+1, oldval);
		v->val.str = newval;
	}
}

/*
 * Must undefine base_yylex before including scan.c, since we want it
 * to create the function base_yylex not filtered_base_yylex.
 */
#undef base_yylex

#include "scan.c"

